`define FBIO_DDR_MODE
module fbio_fpga (
  input  wire        ref_clk,
  input  wire        io_clk,
  input  wire        SYSCLK,
  input  wire        mem_clk2x,
  // AXI slave port for B2A CPU access
  input  wire [8:0]   FBIO_SL_AWID,
  input  wire [31:0]  FBIO_SL_AWADDR,
  input  wire [3:0]   FBIO_SL_AWLEN,
  input  wire [2:0]   FBIO_SL_AWSIZE,
  input  wire [1:0]   FBIO_SL_AWBURST,
  input  wire [1:0]   FBIO_SL_AWLOCK,
  input  wire [3:0]   FBIO_SL_AWCACHE,
  input  wire [2:0]   FBIO_SL_AWPROT,
  input  wire         FBIO_SL_AWVALID,
  output wire         FBIO_SL_AWREADY,
  input  wire [8:0]   FBIO_SL_WID,
  input  wire [63:0]  FBIO_SL_WDATA,
  input  wire [7:0]   FBIO_SL_WSTRB,
  input  wire         FBIO_SL_WLAST,
  input  wire         FBIO_SL_WVALID,
  output wire         FBIO_SL_WREADY,

  output wire [8:0]   FBIO_SL_BID,
  output wire [1:0]   FBIO_SL_BRESP,
  output wire         FBIO_SL_BVALID,
  input  wire         FBIO_SL_BREADY,

  input  wire [8:0]   FBIO_SL_ARID,
  input  wire [31:0]  FBIO_SL_ARADDR,
  input  wire [3:0]   FBIO_SL_ARLEN,
  input  wire [2:0]   FBIO_SL_ARSIZE,
  input  wire [1:0]   FBIO_SL_ARBURST,
  input  wire [1:0]   FBIO_SL_ARLOCK,
  input  wire [3:0]   FBIO_SL_ARCACHE,
  input  wire [2:0]   FBIO_SL_ARPROT,
  input  wire         FBIO_SL_ARVALID,
  output wire         FBIO_SL_ARREADY,
  output wire [8:0]   FBIO_SL_RID,
  output wire [63:0]  FBIO_SL_RDATA,
  output wire [1:0]   FBIO_SL_RRESP,
  output wire         FBIO_SL_RLAST,
  output wire         FBIO_SL_RVALID,
  input  wire         FBIO_SL_RREADY,
  // AXI master1 interface
  output wire [7:0]   FBIO_MA_AWID,
  output wire [31:0]  FBIO_MA_AWADDR,
  output wire [3:0]   FBIO_MA_AWLEN,
  output wire [2:0]   FBIO_MA_AWSIZE,
  output wire [1:0]   FBIO_MA_AWBURST,
  output wire [1:0]   FBIO_MA_AWLOCK,
  output wire [3:0]   FBIO_MA_AWCACHE,
  output wire [2:0]   FBIO_MA_AWPROT,
  output wire         FBIO_MA_AWVALID,
  input  wire         FBIO_MA_AWREADY,
  output wire [7:0]   FBIO_MA_WID,
  output wire [63:0]  FBIO_MA_WDATA,
  output wire [7:0]   FBIO_MA_WSTRB,
  output wire         FBIO_MA_WLAST,
  output wire         FBIO_MA_WVALID,
  input  wire         FBIO_MA_WREADY,
  input  wire [7:0]   FBIO_MA_BID,
  input  wire [1:0]   FBIO_MA_BRESP,
  input  wire         FBIO_MA_BVALID,
  output wire         FBIO_MA_BREADY,
  output wire [7:0]   FBIO_MA_ARID,
  output wire [31:0]  FBIO_MA_ARADDR,
  output wire [3:0]   FBIO_MA_ARLEN,
  output wire [2:0]   FBIO_MA_ARSIZE,
  output wire [1:0]   FBIO_MA_ARBURST,
  output wire [1:0]   FBIO_MA_ARLOCK,
  output wire [3:0]   FBIO_MA_ARCACHE,
  output wire [2:0]   FBIO_MA_ARPROT,
  output wire         FBIO_MA_ARVALID,
  input  wire         FBIO_MA_ARREADY,
  input  wire [7:0]   FBIO_MA_RID,
  input  wire [63:0]  FBIO_MA_RDATA,
  input  wire [1:0]   FBIO_MA_RRESP,
  input  wire         FBIO_MA_RLAST,
  input  wire         FBIO_MA_RVALID,
  output wire         FBIO_MA_RREADY,

  // PAD signals for IO connections
  input  wire        F2P_CLK_I,
  output wire        F2P_CLK_O,
  output wire        F2P_CLK_OE,
  input  wire        P2F_CLK_I,
  output wire        P2F_CLK_O,
  output wire        P2F_CLK_OE,
  input  wire [35:0] FBIO_PAD_I,
  output wire [35:0] FBIO_PAD_O,
  output wire [35:0] FBIO_PAD_OE,
  input  wire        FBIO_PAD_RSTB
);

wire         FBIO_PAD_RSTB1;
wire         HW_CFG_SCAN_COMPRESSION_MODE;
wire         CTS_IGNORE;
wire         SFT_PAD_SCAN_CLK;
wire [15:0]  FBIO_RN_DATA_PROBE;
wire [3:0]   FBIO_RN_CLK_PROBE;
wire         FREE_FPGA_CLKFPGA27;
wire         CLKFPGA27_FPGA_RST_B;
wire         CLKFBIO_SRC;
wire         FREE_FIOCTL_CLKFTX;
wire         CLKFTX_FIOCTL_RST_B;
wire         FREE_FIOCTL_CLKFRX;
wire         CLKFRX_FIOCTL_RST_B;
wire         FREE_FIOCTL_CLK;
wire         MO_FIOCTL_RST_B;
wire         TEST_MODE;
wire         BIST_MODE;
wire         NVIC_RST_B;
wire         SCAN_ENABLE;
wire [12:0]  FBIO_BIST_FAIL;
wire [12:0]  FBIO_BIST_FINISH;
wire [21:0]  RB_FBIO_AWADDR;
wire [3:0]   RB_FBIO_AWLEN;
wire [2:0]   RB_FBIO_AWSIZE;
wire [1:0]   RB_FBIO_AWBURST;
wire [1:0]   RB_FBIO_AWLOCK;
wire [3:0]   RB_FBIO_AWCACHE;
wire [2:0]   RB_FBIO_AWPROT;
wire         RB_FBIO_AWVALID;
wire         FBIO_RB_AWREADY;
wire [31:0]  RB_FBIO_WDATA;
wire [3:0]   RB_FBIO_WSTRB;
wire         RB_FBIO_WLAST;
wire         RB_FBIO_WVALID;
wire         FBIO_RB_WREADY;
wire [1:0]   FBIO_RB_BRESP;
wire         FBIO_RB_BVALID;
wire         RB_FBIO_BREADY;
wire [21:0]  RB_FBIO_ARADDR;
wire [3:0]   RB_FBIO_ARLEN;
wire [2:0]   RB_FBIO_ARSIZE;
wire [1:0]   RB_FBIO_ARBURST;
wire [1:0]   RB_FBIO_ARLOCK;
wire [3:0]   RB_FBIO_ARCACHE;
wire [2:0]   RB_FBIO_ARPROT;
wire         RB_FBIO_ARVALID;
wire         FBIO_RB_ARREADY;
wire [31:0]  FBIO_RB_RDATA;
wire [1:0]   FBIO_RB_RRESP;
wire         FBIO_RB_RLAST;
wire         FBIO_RB_RVALID;
wire         RB_FBIO_RREADY;
wire [31:0]  FBIO0_MA_AWADDR;
wire [3:0]   FBIO0_MA_AWLEN;
wire [2:0]   FBIO0_MA_AWSIZE;
wire [1:0]   FBIO0_MA_AWBURST;
wire [1:0]   FBIO0_MA_AWLOCK;
wire [3:0]   FBIO0_MA_AWCACHE;
wire [2:0]   FBIO0_MA_AWPROT;
wire         FBIO0_MA_AWVALID;
wire         FBIO0_MA_AWREADY;
wire [127:0] FBIO0_MA_WDATA;
wire [15:0]  FBIO0_MA_WSTRB;
wire         FBIO0_MA_WLAST;
wire         FBIO0_MA_WVALID;
wire         FBIO0_MA_WREADY;
wire [1:0]   FBIO0_MA_BRESP;
wire         FBIO0_MA_BVALID;
wire         FBIO0_MA_BREADY;
wire [31:0]  FBIO0_MA_ARADDR;
wire [3:0]   FBIO0_MA_ARLEN;
wire [2:0]   FBIO0_MA_ARSIZE;
wire [1:0]   FBIO0_MA_ARBURST;
wire [1:0]   FBIO0_MA_ARLOCK;
wire [3:0]   FBIO0_MA_ARCACHE;
wire [2:0]   FBIO0_MA_ARPROT;
wire         FBIO0_MA_ARVALID;
wire         FBIO0_MA_ARREADY;
wire [127:0] FBIO0_MA_RDATA;
wire [1:0]   FBIO0_MA_RRESP;
wire         FBIO0_MA_RLAST;
wire         FBIO0_MA_RVALID;
wire         FBIO0_MA_RREADY;

wire ref_rstn, sysrstn;

f_aim_reset_sync u_rst_sync_0 (
  .RST_B            (FBIO_PAD_RSTB),
  .TEST_MODE        (1'b0),
  .RESAMPLE_CLK     (io_clk),
  .SRC_RST_B        (FBIO_PAD_RSTB),
  .RESAMPLE_RST_B   (CLKFTX_FIOCTL_RST_B)
);

f_aim_reset_sync u_rst_sync_1 (
  .RST_B            (FBIO_PAD_RSTB),
  .TEST_MODE        (1'b0),
  .RESAMPLE_CLK     (CLKFBIO_SRC),
  .SRC_RST_B        (FBIO_PAD_RSTB),
  .RESAMPLE_RST_B   (CLKFRX_FIOCTL_RST_B)
);

f_aim_reset_sync u_rst_sync_2 (
  .RST_B            (FBIO_PAD_RSTB),
  .TEST_MODE        (1'b0),
  .RESAMPLE_CLK     (ref_clk),
  .SRC_RST_B        (FBIO_PAD_RSTB),
  .RESAMPLE_RST_B   (ref_rstn)
);

f_aim_reset_sync u_rst_sync_3 (
  .RST_B            (FBIO_PAD_RSTB),
  .TEST_MODE        (1'b0),
  .RESAMPLE_CLK     (SYSCLK),
  .SRC_RST_B        (FBIO_PAD_RSTB),
  .RESAMPLE_RST_B   (sysrstn)
);

// clock and reset
assign SFT_PAD_SCAN_CLK     = ref_clk;
assign FREE_FPGA_CLKFPGA27  = ref_clk;
assign FREE_FIOCTL_CLKFTX   = io_clk;
assign FREE_FIOCTL_CLKFRX   = CLKFBIO_SRC;
assign FREE_FIOCTL_CLK      = SYSCLK;
assign MO_FIOCTL_RST_B      = sysrstn;
assign NVIC_RST_B           = sysrstn;
assign CLKFPGA27_FPGA_RST_B = ref_rstn;
// constant inputs
assign HW_CFG_SCAN_COMPRESSION_MODE = 1'b0;
assign CTS_IGNORE                   = 1'b0;
assign TEST_MODE                    = 1'b0;
assign BIST_MODE                    = 1'b0;
assign SCAN_ENABLE                  = 1'b0;
// RBUS (register configure)
assign RB_FBIO_AWADDR = 22'h0;
assign RB_FBIO_AWLEN = 4'h0;
assign RB_FBIO_AWSIZE = 3'h0;
assign RB_FBIO_AWBURST = 2'h0;
assign RB_FBIO_AWLOCK = 2'h0;
assign RB_FBIO_AWCACHE = 4'h0;
assign RB_FBIO_AWPROT = 3'h0;
assign RB_FBIO_AWVALID = 1'b0;
assign RB_FBIO_WDATA = 32'h0;
assign RB_FBIO_WSTRB = 4'h0;
assign RB_FBIO_WLAST = 1'b0;
assign RB_FBIO_WVALID = 1'b0;
assign RB_FBIO_BREADY = 1'b1;
assign RB_FBIO_ARADDR = 22'h0;
assign RB_FBIO_ARLEN = 4'h0;
assign RB_FBIO_ARSIZE = 3'h0;
assign RB_FBIO_ARBURST = 2'h0;
assign RB_FBIO_ARLOCK = 2'h0;
assign RB_FBIO_ARCACHE = 4'h0;
assign RB_FBIO_ARPROT = 3'h0;
assign RB_FBIO_ARVALID = 1'b0;
assign RB_FBIO_RREADY = 1'b1;
// DMA Mastre
assign FBIO0_MA_AWREADY = 1'b1;
assign FBIO0_MA_WREADY = 1'b1;
assign FBIO0_MA_BRESP   = 2'h0;
assign FBIO0_MA_BVALID  = 1'b0;
assign FBIO0_MA_ARREADY = 1'b1;
assign FBIO0_MA_RDATA   = 128'h0;
assign FBIO0_MA_RRESP   = 2'h0;
assign FBIO0_MA_RLAST   = 1'b0;
assign FBIO0_MA_RVALID  = 1'b0;

wire [3:0]   RB_FBIO_AWID  = 4'h0;
wire [3:0]   RB_FBIO_WID   = 4'h0;
wire [3:0]   RB_FBIO_ARID  = 4'h0;
wire [3:0]   FBIO0_MA_BID  = 4'h0;
wire [3:0]   FBIO0_MA_RID  = 4'h0;
wire [3:0]   FBIO_RB_BID;
wire [3:0]   FBIO_RB_RID;
wire [3:0]   FBIO0_MA_AWID;
wire [3:0]   FBIO0_MA_WID;
wire [3:0]   FBIO0_MA_ARID;

wire [37:0]  io_pad_oen;
wire [37:0]  io_pad_i;
wire [37:0]  io_pad_o;

assign FBIO_PAD_OE  = ~{io_pad_oen[37:20], io_pad_oen[17:0]};
assign FBIO_PAD_O   = {io_pad_o[37:20], io_pad_o[17:0]};
assign F2P_CLK_OE = ~io_pad_oen[18];
assign F2P_CLK_O  = io_pad_o[18];
assign P2F_CLK_OE = ~io_pad_oen[19];
assign P2F_CLK_O  = io_pad_o[19];
assign io_pad_i     = {FBIO_PAD_I[35:18], P2F_CLK_I, F2P_CLK_I, FBIO_PAD_I[17:0]};

f_fbio_top u_fbio_0 (
  // IO Pads
  .io_pad_i     (io_pad_i),
  .io_pad_oen   (io_pad_oen),
  .io_pad_o     (io_pad_o),
  .fpga_rstn    (FBIO_PAD_RSTB1),

  .achip_clk    (FREE_FPGA_CLKFPGA27),
  .achip_rst    (CLKFPGA27_FPGA_RST_B),
  .ioclk_src    (CLKFBIO_SRC),
  .com_mode     (HW_CFG_SCAN_COMPRESSION_MODE),
  .cts_ignore   (CTS_IGNORE),
  .scan_clk     (SFT_PAD_SCAN_CLK),

  // global signal from B-chip to A-chip
  .atest_en     (1'b0),
  .stest_mode   (1'b0),
  .stest_fail   (stest_fail),
  .stest_tfail  (stest_tfail),
  .stest_done   (stest_done),
  .bio_probe    (FBIO_RN_DATA_PROBE),
  .bio_probe1   (FBIO_RN_CLK_PROBE),

  .tx_clk       (FREE_FIOCTL_CLKFTX),
  .tx_rstn      (CLKFTX_FIOCTL_RST_B),
  .rx_clk       (FREE_FIOCTL_CLKFRX),
  .rx_rstn      (CLKFRX_FIOCTL_RST_B),
  .sysclk       (FREE_FIOCTL_CLK),
  .sysrstn      (MO_FIOCTL_RST_B),
  .adr_remap    (1'b0),

  .bist_rstn    (NVIC_RST_B),
  .bist_mode    (BIST_MODE),
  .test_mode    (TEST_MODE),
  .scan_enable  (SCAN_ENABLE),
  .bist_fail    (FBIO_BIST_FAIL),
  .bist_finish  (FBIO_BIST_FINISH),
  .mem_clk2x    (mem_clk2x),

  // AXI slave interface -->
  .axis0_awid        (RB_FBIO_AWID),
  .axis0_awaddr      ({10'h0, RB_FBIO_AWADDR}),
  .axis0_awlen       (RB_FBIO_AWLEN),
  .axis0_awsize      (RB_FBIO_AWSIZE),
  .axis0_awburst     (RB_FBIO_AWBURST),
  .axis0_awlock      (RB_FBIO_AWLOCK),
  .axis0_awcache     (RB_FBIO_AWCACHE),
  .axis0_awprot      (RB_FBIO_AWPROT),
  .axis0_awvalid     (RB_FBIO_AWVALID),
  .axis0_awready     (FBIO_RB_AWREADY),

  .axis0_wid         (RB_FBIO_WID),
  .axis0_wdata       (RB_FBIO_WDATA),
  .axis0_wstrb       (RB_FBIO_WSTRB),
  .axis0_wlast       (RB_FBIO_WLAST),
  .axis0_wvalid      (RB_FBIO_WVALID),
  .axis0_wready      (FBIO_RB_WREADY),

  .axis0_bid         (FBIO_RB_BID),
  .axis0_bresp       (FBIO_RB_BRESP),
  .axis0_bvalid      (FBIO_RB_BVALID),
  .axis0_bready      (RB_FBIO_BREADY),

  .axis0_arid        (RB_FBIO_ARID),
  .axis0_araddr      ({10'h0, RB_FBIO_ARADDR}),
  .axis0_arlen       (RB_FBIO_ARLEN),
  .axis0_arsize      (RB_FBIO_ARSIZE),
  .axis0_arburst     (RB_FBIO_ARBURST),
  .axis0_arlock      (RB_FBIO_ARLOCK),
  .axis0_arcache     (RB_FBIO_ARCACHE),
  .axis0_arprot      (RB_FBIO_ARPROT),
  .axis0_arvalid     (RB_FBIO_ARVALID),
  .axis0_arready     (FBIO_RB_ARREADY),

  .axis0_rid         (FBIO_RB_RID),
  .axis0_rdata       (FBIO_RB_RDATA),
  .axis0_rresp       (FBIO_RB_RRESP),
  .axis0_rlast       (FBIO_RB_RLAST),
  .axis0_rvalid      (FBIO_RB_RVALID),
  .axis0_rready      (RB_FBIO_RREADY),
  // AXI slave port for B2A CPU access
  .axis1_awid       (FBIO_SL_AWID),
  .axis1_awaddr     (FBIO_SL_AWADDR),
  .axis1_awlen      (FBIO_SL_AWLEN),
  .axis1_awsize     (FBIO_SL_AWSIZE),
  .axis1_awburst    (FBIO_SL_AWBURST),
  .axis1_awlock     (FBIO_SL_AWLOCK),
  .axis1_awcache    (FBIO_SL_AWCACHE),
  .axis1_awprot     (FBIO_SL_AWPROT),
  .axis1_awvalid    (FBIO_SL_AWVALID),
  .axis1_awready    (FBIO_SL_AWREADY),

  .axis1_wid        (FBIO_SL_WID),
  .axis1_wdata      (FBIO_SL_WDATA),
  .axis1_wstrb      (FBIO_SL_WSTRB),
  .axis1_wlast      (FBIO_SL_WLAST),
  .axis1_wvalid     (FBIO_SL_WVALID),
  .axis1_wready     (FBIO_SL_WREADY),

  .axis1_bid        (FBIO_SL_BID),
  .axis1_bresp      (FBIO_SL_BRESP),
  .axis1_bvalid     (FBIO_SL_BVALID),
  .axis1_bready     (FBIO_SL_BREADY),

  .axis1_arid       (FBIO_SL_ARID),
  .axis1_araddr     (FBIO_SL_ARADDR),
  .axis1_arlen      (FBIO_SL_ARLEN),
  .axis1_arsize     (FBIO_SL_ARSIZE),
  .axis1_arburst    (FBIO_SL_ARBURST),
  .axis1_arlock     (FBIO_SL_ARLOCK),
  .axis1_arcache    (FBIO_SL_ARCACHE),
  .axis1_arprot     (FBIO_SL_ARPROT),
  .axis1_arvalid    (FBIO_SL_ARVALID),
  .axis1_arready    (FBIO_SL_ARREADY),

  .axis1_rid        (FBIO_SL_RID),
  .axis1_rdata      (FBIO_SL_RDATA),
  .axis1_rresp      (FBIO_SL_RRESP),
  .axis1_rlast      (FBIO_SL_RLAST),
  .axis1_rvalid     (FBIO_SL_RVALID),
  .axis1_rready     (FBIO_SL_RREADY),
  // <-- AXI slave interface
  // AXI master0 interface -->
  .axim0_awid       (FBIO0_MA_AWID),
  .axim0_awaddr     (FBIO0_MA_AWADDR),
  .axim0_awlen      (FBIO0_MA_AWLEN),
  .axim0_awsize     (FBIO0_MA_AWSIZE),
  .axim0_awburst    (FBIO0_MA_AWBURST),
  .axim0_awlock     (FBIO0_MA_AWLOCK),
  .axim0_awcache    (FBIO0_MA_AWCACHE),
  .axim0_awprot     (FBIO0_MA_AWPROT),
  .axim0_awvalid    (FBIO0_MA_AWVALID),
  .axim0_awready    (FBIO0_MA_AWREADY),

  .axim0_wid        (FBIO0_MA_WID),
  .axim0_wdata      (FBIO0_MA_WDATA),
  .axim0_wstrb      (FBIO0_MA_WSTRB),
  .axim0_wlast      (FBIO0_MA_WLAST),
  .axim0_wvalid     (FBIO0_MA_WVALID),
  .axim0_wready     (FBIO0_MA_WREADY),

  .axim0_bid        (FBIO0_MA_BID),
  .axim0_bresp      (FBIO0_MA_BRESP),
  .axim0_bvalid     (FBIO0_MA_BVALID),
  .axim0_bready     (FBIO0_MA_BREADY),

  .axim0_arid       (FBIO0_MA_ARID),
  .axim0_araddr     (FBIO0_MA_ARADDR),
  .axim0_arlen      (FBIO0_MA_ARLEN),
  .axim0_arsize     (FBIO0_MA_ARSIZE),
  .axim0_arburst    (FBIO0_MA_ARBURST),
  .axim0_arlock     (FBIO0_MA_ARLOCK),
  .axim0_arcache    (FBIO0_MA_ARCACHE),
  .axim0_arprot     (FBIO0_MA_ARPROT),
  .axim0_arvalid    (FBIO0_MA_ARVALID),
  .axim0_arready    (FBIO0_MA_ARREADY),

  .axim0_rid        (FBIO0_MA_RID),
  .axim0_rdata      (FBIO0_MA_RDATA),
  .axim0_rresp      (FBIO0_MA_RRESP),
  .axim0_rlast      (FBIO0_MA_RLAST),
  .axim0_rvalid     (FBIO0_MA_RVALID),
  .axim0_rready     (FBIO0_MA_RREADY),
  // <-- AXI master0 interface
  // AXI master1 interface -->
  .axim1_awid       (FBIO_MA_AWID),
  .axim1_awaddr     (FBIO_MA_AWADDR),
  .axim1_awlen      (FBIO_MA_AWLEN),
  .axim1_awsize     (FBIO_MA_AWSIZE),
  .axim1_awburst    (FBIO_MA_AWBURST),
  .axim1_awlock     (FBIO_MA_AWLOCK),
  .axim1_awcache    (FBIO_MA_AWCACHE),
  .axim1_awprot     (FBIO_MA_AWPROT),
  .axim1_awvalid    (FBIO_MA_AWVALID),
  .axim1_awready    (FBIO_MA_AWREADY),

  .axim1_wid        (FBIO_MA_WID),
  .axim1_wdata      (FBIO_MA_WDATA),
  .axim1_wstrb      (FBIO_MA_WSTRB),
  .axim1_wlast      (FBIO_MA_WLAST),
  .axim1_wvalid     (FBIO_MA_WVALID),
  .axim1_wready     (FBIO_MA_WREADY),

  .axim1_bid        (FBIO_MA_BID),
  .axim1_bresp      (FBIO_MA_BRESP),
  .axim1_bvalid     (FBIO_MA_BVALID),
  .axim1_bready     (FBIO_MA_BREADY),

  .axim1_arid       (FBIO_MA_ARID),
  .axim1_araddr     (FBIO_MA_ARADDR),
  .axim1_arlen      (FBIO_MA_ARLEN),
  .axim1_arsize     (FBIO_MA_ARSIZE),
  .axim1_arburst    (FBIO_MA_ARBURST),
  .axim1_arlock     (FBIO_MA_ARLOCK),
  .axim1_arcache    (FBIO_MA_ARCACHE),
  .axim1_arprot     (FBIO_MA_ARPROT),
  .axim1_arvalid    (FBIO_MA_ARVALID),
  .axim1_arready    (FBIO_MA_ARREADY),

  .axim1_rid        (FBIO_MA_RID),
  .axim1_rdata      (FBIO_MA_RDATA),
  .axim1_rresp      (FBIO_MA_RRESP),
  .axim1_rlast      (FBIO_MA_RLAST),
  .axim1_rvalid     (FBIO_MA_RVALID),
  .axim1_rready     (FBIO_MA_RREADY)
  // <-- AXI master1 interface
);

endmodule
//==============================================================================
//
//    This confidential and proprietary hardware may be used only as
//  authorized by a licensing agreement from
//                    SunMedia Technology Co., LTD.
//
//  In the event of publication, the following notice is applicable:
//
//            COPYRIGHT 2017, SunMedia Technology Co., LTD.
//                        ALL RIGHTS RESERVED
//
//  The entire notice above must be reproduced on all authorized copies.
//
//==============================================================================
//
//  File        : f_bio_core.v
//  Author      : kun.zhang
//  Date        : 06/Dec/2017
//  Version     : 1.2
//  Abstract    : This module is the top block for BIO control functions
//
//  Modification History:
//  Date          By            Version         Change Description
//------------------------------------------------------------------------------
//  27/Feb/2017   kun.zhang      1.0            Original
//  07/Jun/2017   xh.du          1.1            Modify for W2R block
//  06/Dec/2017   kun.zhang      1.2            Add AXI slave1 interfce for B2A
//                                              CPU access and releated logics
//
//
//==============================================================================

























module f_bio_core (
  input  wire         tx_clk,   // TX domain clock
  input  wire         tx_rstn,  // TX domain reset
  input  wire         rx_clk,   // RX domain clock
  input  wire         rx_rstn,  // RX domain reset
  input  wire         sysclk,   // System domain clock
  input  wire         sysrstn,  // System domain reset
  input  wire         cdc_rstn, // CDC domain system reset
  input  wire         sft_rst,  // Soft reset
  input  wire         sft_set,  // Soft set
  output wire         sft_ack0, // Soft reset ack from cpu master mode
  output wire         sft_ack1, // Soft reset ack for DMA write
  output wire         sft_ack2, // Soft reset ack for DMA read
  output wire         sft_ack3, // Soft reset ack from CPU slave mode
  input  wire         adr_remap,    // Address remap enable
  input  wire [31:0]  st_reg_adr,   // Self-test register address

  input  wire         bist_rstn, // NVIC_RST_B
  input  wire         bist_mode,
  input  wire         test_mode,
  input  wire         scan_enable,
  output wire [12:0]  bist_fail,
  output wire [12:0]  bist_finish,
  input  wire         mem_clk2x,

  // AXI slave interface -->
  input  wire [3:0]   axis0_awid,
  input  wire [31:0]  axis0_awaddr,
  input  wire [3:0]   axis0_awlen,
  input  wire [2:0]   axis0_awsize,
  input  wire [1:0]   axis0_awburst,
  input  wire [1:0]   axis0_awlock,
  input  wire [3:0]   axis0_awcache,
  input  wire [2:0]   axis0_awprot,
  input  wire         axis0_awvalid,
  output wire         axis0_awready,

  input  wire [3:0]   axis0_wid,
  input  wire [31:0]  axis0_wdata,
  input  wire [3:0]   axis0_wstrb,
  input  wire         axis0_wlast,
  input  wire         axis0_wvalid,
  output wire         axis0_wready,

  output wire [3:0]   axis0_bid,
  output wire [1:0]   axis0_bresp,
  output wire         axis0_bvalid,
  input  wire         axis0_bready,

  input  wire [3:0]   axis0_arid,
  input  wire [31:0]  axis0_araddr,
  input  wire [3:0]   axis0_arlen,
  input  wire [2:0]   axis0_arsize,
  input  wire [1:0]   axis0_arburst,
  input  wire [1:0]   axis0_arlock,
  input  wire [3:0]   axis0_arcache,
  input  wire [2:0]   axis0_arprot,
  input  wire         axis0_arvalid,
  output wire         axis0_arready,

  output wire [3:0]   axis0_rid,
  output wire [31:0]  axis0_rdata,
  output wire [1:0]   axis0_rresp,
  output wire         axis0_rlast,
  output wire         axis0_rvalid,
  input  wire         axis0_rready,

  // AXI slave port for B2A CPU access
  input  wire [8:0]   axis1_awid,
  input  wire [31:0]  axis1_awaddr,
  input  wire [3:0]   axis1_awlen,
  input  wire [2:0]   axis1_awsize,
  input  wire [1:0]   axis1_awburst,
  input  wire [1:0]   axis1_awlock,
  input  wire [3:0]   axis1_awcache,
  input  wire [2:0]   axis1_awprot,
  input  wire         axis1_awvalid,
  output wire         axis1_awready,

  input  wire [8:0]   axis1_wid,
  input  wire [63:0]  axis1_wdata,
  input  wire [7:0]   axis1_wstrb,
  input  wire         axis1_wlast,
  input  wire         axis1_wvalid,
  output wire         axis1_wready,

  output wire [8:0]   axis1_bid,
  output wire [1:0]   axis1_bresp,
  output wire         axis1_bvalid,
  input  wire         axis1_bready,

  input  wire [8:0]   axis1_arid,
  input  wire [31:0]  axis1_araddr,
  input  wire [3:0]   axis1_arlen,
  input  wire [2:0]   axis1_arsize,
  input  wire [1:0]   axis1_arburst,
  input  wire [1:0]   axis1_arlock,
  input  wire [3:0]   axis1_arcache,
  input  wire [2:0]   axis1_arprot,
  input  wire         axis1_arvalid,
  output wire         axis1_arready,

  output wire [8:0]   axis1_rid,
  output wire [63:0]  axis1_rdata,
  output wire [1:0]   axis1_rresp,
  output wire         axis1_rlast,
  output wire         axis1_rvalid,
  input  wire         axis1_rready,
  // <-- AXI slave interface
  // AXI master0 interface -->
  // AXI Write Address phase signals
  output wire [3:0]   axim0_awid,
  output wire [31:0]  axim0_awaddr,
  output wire [3:0]   axim0_awlen,
  output wire [2:0]   axim0_awsize,
  output wire [1:0]   axim0_awburst,
  output wire [1:0]   axim0_awlock,
  output wire [3:0]   axim0_awcache,
  output wire [2:0]   axim0_awprot,
  output wire         axim0_awvalid,
  input  wire         axim0_awready,
  // AXI Write Data phase signals
  output wire [3:0]   axim0_wid,
  output wire [127:0] axim0_wdata,
  output wire [15:0]  axim0_wstrb,
  output wire         axim0_wlast,
  output wire         axim0_wvalid,
  input  wire         axim0_wready,
  // AXI Write Response phase signals
  input  wire [3:0]   axim0_bid,
  input  wire [1:0]   axim0_bresp,
  input  wire         axim0_bvalid,
  output wire         axim0_bready,

  // AXI Read Address phase signals
  output wire [3:0]   axim0_arid,
  output wire [31:0]  axim0_araddr,
  output wire [3:0]   axim0_arlen,
  output wire [2:0]   axim0_arsize,
  output wire [1:0]   axim0_arburst,
  output wire [1:0]   axim0_arlock,
  output wire [3:0]   axim0_arcache,
  output wire [2:0]   axim0_arprot,
  output wire         axim0_arvalid,
  input  wire         axim0_arready,
  // AXI Read Data phase signals
  input  wire [3:0]   axim0_rid,
  input  wire [127:0] axim0_rdata,
  input  wire [1:0]   axim0_rresp,
  input  wire         axim0_rlast,
  input  wire         axim0_rvalid,
  output wire         axim0_rready,
  // <-- AXI master0 interface
  // AXI master1 interface -->
  // AXI Write Address phase signals
  output wire [7:0]   axim1_awid,
  output wire [31:0]  axim1_awaddr,
  output wire [3:0]   axim1_awlen,
  output wire [2:0]   axim1_awsize,
  output wire [1:0]   axim1_awburst,
  output wire [1:0]   axim1_awlock,
  output wire [3:0]   axim1_awcache,
  output wire [2:0]   axim1_awprot,
  output wire         axim1_awvalid,
  input  wire         axim1_awready,
  // AXI Write Data phase signals
  output wire [7:0]   axim1_wid,
  output wire [63:0]  axim1_wdata,
  output wire [7:0]   axim1_wstrb,
  output wire         axim1_wlast,
  output wire         axim1_wvalid,
  input  wire         axim1_wready,
  // AXI Write Response phase signals
  input  wire [7:0]   axim1_bid,
  input  wire [1:0]   axim1_bresp,
  input  wire         axim1_bvalid,
  output wire         axim1_bready,

  // AXI Read Address phase signals
  output wire [7:0]   axim1_arid,
  output wire [31:0]  axim1_araddr,
  output wire [3:0]   axim1_arlen,
  output wire [2:0]   axim1_arsize,
  output wire [1:0]   axim1_arburst,
  output wire [1:0]   axim1_arlock,
  output wire [3:0]   axim1_arcache,
  output wire [2:0]   axim1_arprot,
  output wire         axim1_arvalid,
  input  wire         axim1_arready,
  // AXI Read Data phase signals
  input  wire [7:0]   axim1_rid,
  input  wire [63:0]  axim1_rdata,
  input  wire [1:0]   axim1_rresp,
  input  wire         axim1_rlast,
  input  wire         axim1_rvalid,
  output wire         axim1_rready,
  // <-- AXI master1 interface

















    input  wire         lvds_pop,       // LVDS TX pop data
    output wire [31:0]  lvds_rdata,     // LVDS TX read data
    output wire         lvds_empty,     // LVDS TX data empty
    input  wire         lvds_push,      // LVDS RX push data
    input  wire [31:0]  lvds_wdata,     // LVDS RX write data
    output wire         lvds_full,      // LVDS RX data full







    input  wire         ddfch_rreq,     // DDFCH read request
    output wire [31:0]  ddfch_rdata,    // DDFCH read data
    output wire         ddfch_rvalid,   // DDFCH read data valid


  input  wire         stest_trig,   // Self test trigger
  input  wire         stest_en,     // Self test enable
  input  wire         pulse_1us,    // 1us indicator
  output wire         stest_sreq,   // Self test software request
  output wire         stest_done,   // Self test done
  output wire         stest_fail,   // Self test fail
  output wire         stest_tfail,  // Self test timeout fail
  output wire         stest_run,    // Self test running for timer enable
  output wire [2:0]   stest_pst,    // Self test previous state
  output wire [7:0]   pb_sel,       // Probe select
  output wire [15:0]  axis_probe,   //
  output wire [15:0]  axim0_probe,  //
  output wire [31:0]  axim1_probe,  //
  output wire [15:0]  tx_probe,     //
  output wire [11:0]  rx_probe,     //
  output wire [9:0]   arb_probe,    //

  output wire [46:0]  sft_ds_en,    // PAD DS enable form register
  output wire [46:0]  sft_ie_en,    // PAD IE from register
  output wire         sft_pwd,      // Analog powerdown from register
  output wire [3:0]   rx_clki_dly,  // RX clock input delay select
  output wire         rx_clki_inv,  // RX clock input inverter select
  output wire         rx_clki_pol,  // RX clock input pol select
  output wire [3:0]   rx_clko_dly,  // RX clock output delay select
  output wire         rx_clko_inv,  // RX clock output inverter select
  output wire         rx_clko_pol,  // RX clock output pol select
  output wire [3:0]   tx_clki_dly,  // TX clock input delay select
  output wire         tx_clki_inv,  // TX clock input inverter select
  output wire         tx_clki_pol,  // TX clock input pol select
  output wire [3:0]   tx_clko_dly,  // TX clock output delay select
  output wire         tx_clko_inv,  // TX clock output inverter select
  output wire         tx_clko_pol,  // TX clock output pol select
  output wire         rx_ck_comp,   // RX clock compress mode enable
  output wire         rx_ck_cinv,   // RX clock inverter in compress mode
  output wire         tx_ck_comp,   // TX clock compress mode enable
  output wire         tx_ck_cinv,   // TX clock inverter in compress mode

  output wire         ddr_en,       // DDR mode enable from register
  output wire         en_16b,       // Enable 16bit data bus mode
  output wire [31:0]  tx_data,      // Transfer data to soft-pad, if SDR mode only bit 15:0 is valid
  output wire [1:0]   tx_vld,       // Transfer valid
  input  wire         tx_rdy,       // Transfer ready from rx domain
  input  wire [31:0]  rx_data,      // Receiver data from soft-pad, if SDR mode only bit 15:0 is valid
  input  wire [1:0]   rx_vld,       // Reciever valid
  output wire         rx_rdy        // Receiver ready to tx domain
);

wire         rx_rdy_rx;         // RX ready in RX clock domain
wire         rx_rdy_tx;         // RX ready in TX clock domain
wire         rx_afifo_wr;       // Receiver AFIFO write
wire [71:0]  rx_afifo_wdata;    // Receiver AFIFO write data
wire         rx_afifo_full;     // Reciever AFIFO full
wire         tx_rdy_tx;         // TX ready in TX clock domain
wire         tx_afifo_rd;       // Transmiter AFIFO read enable
wire [71:0]  tx_afifo_rdata;    // Transmiter AFIFO read data
wire         tx_afifo_empty;    // Transmiter AFIFO empty
wire         tx_ddr_en;         // DDR mode enable in TX domain
wire         rx_ddr_en;         // DDR mode enable in RX domain
wire         tx_en_16b;         // 16bit enable in TX domain
wire         rx_en_16b;         // 16bit enable in RX domain

wire         sys_afifo_wr;      // Sys AFIFO write
wire [71:0]  sys_afifo_wdata;   // Sys AFIFO write data
wire         sys_afifo_full;    // Sys AFIFO full
wire         sys_afifo_rd;      // Sys AFIFO read enable
wire [71:0]  sys_afifo_rdata;   // Sys AFIFO read data
wire         sys_afifo_empty;   // Sys AFIFO empty

wire        rx_cpum_req;    // Receiver to CPU request
wire [58:0] rx_cpum_info;   // Receiver to CPU request information
wire        cpum_rx_acp;    // CPU to receiver request accept
wire        cpum_wvld;      // CPU write data valid
wire [71:0] cpum_wdata;     // CPU write data
wire        cpum_wrdy;      // CPU write ready, has enough buffer for RX data.
wire        rx_cpus_req;      // CPU slave mode request for read data
wire [17:0] rx_cpus_info;     // CPU slave mode request information
wire        rx_cpus_rvld;     // CPU slave mode read data valid
wire [63:0] rx_cpus_rdata;    // CPU slave mode read data
wire        cpus_rx_rrdy;     // CPU slave mode red data ready
wire        rx_cpus_req1;     // CPU slave mode request for write response
wire [9:0]  rx_cpus_info1;    // CPU slave mode write response information
wire        cpus_rx_acp1;     // CPU slave accept write response request

wire        dma_wvld;  // DMA write data valid
wire [2:0]  dma_ch;    // DMA channel number
wire [63:0] dma_wdata; // DMA write data
wire        dma_wrdy;  // DMA write ready, has enough buffer for data

wire        cpum_tx_req;    // CPU to transmiter request
wire [18:0] cpum_tx_info;   // CPU to transmiter request information
wire        tx_cpum_ack;    // Transmiter to CPU request acknowlage
wire        tx_cpum_ren;    // CPU read data ren
wire [63:0] cpum_tx_data;   // CPU read data
wire [3:0]  cpum_tx_last;   // CPU last data in a burst
wire        cpum_tx_clast;  // CPU master mode tx command last

wire        cpus_tx_req;      // CPU slave mode transfer request, level
wire [66:0] cpus_tx_info;     // CPU slave mode transfer information
wire        tx_cpus_ack;      // CPU slave mode transfer acknowlage
wire        tx_cpus_ren;      // CPU slave mode data reand enable, low active
wire [63:0] cpus_tx_data;     // CPU slave mode data
wire [3:0]  cpus_tx_last;     // CPU slave mode last data in a burst
wire [131:0] cpus_tx_wbe;      // CPU slave mode write byte enable
wire        cpus_tx_clast;    // CPU slave mode read command last

wire        dma_req;   // DMA mode transfer request, pulse
wire [15:0] dma_info;  // DMA mode transfer information
wire        dma_ack;   // DMA mode transfer acknowlage
wire        dma_dvld;  // DMA mode data valid
wire [63:0] dma_data;  // DMA mode data
wire        dma_last;  // DMA mode last data in a burst
wire        dma_drdy;  // DMA mode data ready

wire        ch0_run;   // Channel0 runing states
wire        ch0_trig;  // Channel0 trigger
wire        ch0_dir;   // Channel0 Direction
wire [15:0] ch0_len;   // Channel0 DMA length
wire [31:0] ch0_addr;  // Channel0 start address
wire        ch0_stop;  // Channel0 Stop pulse
wire        ch1_run;   // Channel1 runing states
wire        ch1_trig;  // Channel1 trigger
wire        ch1_dir;   // Channel1 Direction
wire [15:0] ch1_len;   // Channel1 DMA length
wire [31:0] ch1_addr;  // Channel1 start address
wire        ch1_stop;  // Channel0 Stop pulse
wire        ch2_run;   // Channel2 runing states
wire        ch2_trig;  // Channel2 trigger
wire        ch2_dir;   // Channel2 Direction
wire [15:0] ch2_len;   // Channel2 DMA length
wire [31:0] ch2_addr;  // Channel2 start address
wire        ch2_stop;  // Channel0 Stop pulse
wire        ch3_run;   // Channel3 runing states
wire        ch3_trig;  // Channel3 trigger
wire        ch3_dir;   // Channel3 Direction
wire [15:0] ch3_len;   // Channel3 DMA length
wire [31:0] ch3_addr;  // Channel3 start address
wire        ch3_stop;  // Channel0 Stop pulse
wire        ch4_run;   // Channel4 runing states
wire        ch4_trig;  // Channel4 trigger
wire        ch4_dir;   // Channel4 Direction
wire [15:0] ch4_len;   // Channel4 DMA length
wire [31:0] ch4_addr;  // Channel4 start address
wire        ch4_stop;  // Channel0 Stop pulse
wire        ch5_run;   // Channel5 runing states
wire        ch5_trig;  // Channel5 trigger
wire        ch5_stop;  // Channel0 Stop pulse
wire        ch5_dir;   // Channel5 Direction
wire [15:0] ch5_len;   // Channel5 DMA length
wire [31:0] ch5_addr;  // Channel5 start address
wire [6:0]  cpum_wt;       // CPU master arbitration weight
wire [6:0]  cpus_wt;       // CPU slave arbitration weight
wire [6:0]  dma_wt;        // DMA arbitration weight
wire [7:0]  lp_mreq;       // Low priority maxmum request count
wire        arb_ctl_wr;    // Arbiter control register write
wire [6:0]  cpum_wtcnt;    // CPU master weight counter
wire [6:0]  cpus_wtcnt;    // CPU master weight counter
wire [6:0]  dma_wtcnt;     // CPU master weight counter


  wire [1:0] ch0_dst_sel; // Channle0 destination select
  wire [1:0] ch1_dst_sel; // Channle1 destination select
  wire [1:0] ch2_dst_sel; // Channle2 destination select
  wire [1:0] ch3_dst_sel; // Channle3 destination select
  wire [1:0] ch4_dst_sel; // Channle4 destination select
  wire [1:0] ch5_dst_sel; // Channle5 destination select
  wire       ch0_discnt;  // Channel0 disable length counter
  wire       ch1_discnt;  // Channel1 disable length counter
  wire       ch2_discnt;  // Channel2 disable length counter
  wire       ch3_discnt;  // Channel3 disable length counter
  wire       ch4_discnt;  // Channel4 disable length counter
  wire       ch5_discnt;  // Channel5 disable length counter
  wire       rx_stop_rx;   // DMA stop for RX in RX clock domain
  wire       rx_stop_sys;  // DMA stop for RX in system clock domain
  wire       rx_sack_rx;   // DMA stop ack for RX in RX clock domain
  wire       rx_sack_sys;  // DMA stop ack for RX in system clock domain
  wire       rx_req_rx;    // DMA RX request in RX clock domain
  wire       rx_req_sys;   // DMA RX request in system clock domain
  wire [2:0] rx_dch_rx;    // DMA RX request channel number in RX clock domain
  wire [2:0] rx_dch_sys;   // DMA RX request channel number in system clock domain
  wire       rx_ack_rx;    // DMA RX request acknowlage
  wire       tx_done_tx;   // DMA TX transfer done in TX clock domain
  wire       tx_done_sys;  // DMA TX transfer done in system clock domain
  wire [2:0] tx_dch_tx;    // DMA TX transfer done channel number
  wire [2:0] tx_dch_sys;   // DMA TX transfer done channel number
  wire       tx_dack_tx;   // DMA TX transfer done acknowlage
  wire [2:0] rx_sch;       // RX stop channel number
  wire [5:0] rx_sdone;      // DMA stop done for RX


wire [31:0] stest_reg;  // Self-test data register
wire        wr_sdata;   // Write self-test data
wire        ckchk_req;  // Self-test clock check request
wire        ckchk_ack;  // Self-test clock check acknowlage
wire        btchk_req;  // Request to send BT start
wire        btchk_ack;  // Btchk ack from RX packet
wire        stest_ack;  // Self-test ack from RX packet
wire        btchk_req1; // Request to send BT end
wire        btchk_ack1; // Btchk ack from RX packet
wire        btchk_dack; // Bus tunning data done
wire        btchk_req_sys;  // Bus tunning check request in system domain
//wire        btchk_ack_sys;  // Bus tunning check acknowlage in system domain
//wire        rx_fail_sys;    // RX fail in system domain
wire        btchk_done_rx;  // Bus tunning data done in RX domain
wire        btchk_done_tx;  // Bus tunning data done in TX domain
wire        rx_fail_tx;     // RX fail in TX domain
wire        rx_fail_io;     // RX fail in IO domain
wire        rx_fail;        // RX fail for system domain
wire        rx_bts_rx;      // RX Bus tunning start
wire        rx_bts_tx;      // RX Bus tunning start
wire        tx_bts_rx;      // TX Bus tunning start
wire        tx_bts_tx;      // TX Bus tunning start
wire        stest_req_sys;  // Selt-test start request in system domain
wire [31:0] boot_addr;      // Boot address remap
wire        btchk_done;
wire        btchk_fail;
wire [3:0]  cpus_arb_probe;


  // AXI Read Data phase signals
  wire [7:0]   axim1s_rid;
  wire [63:0]  axim1s_rdata;
  wire [1:0]   axim1s_rresp;
  wire         axim1s_rlast;
  wire         axim1s_rvalid;
  wire         axim1s_rready;


assign tx_probe[15:11] = {sys_afifo_wr, sys_afifo_full, tx_afifo_rd, tx_afifo_empty, 1'b0};
assign rx_probe[11:0]  = {sys_afifo_rd, sys_afifo_empty, rx_afifo_wr, rx_afifo_full,
                          dma_wvld, dma_ch, dma_wrdy, dma_dvld, dma_last, dma_drdy};
assign arb_probe[9:0]  = {cpus_arb_probe, dma_ack, dma_req, tx_cpum_ack, cpum_tx_req, tx_cpus_ack, cpus_tx_req};

f_bio_rx_ctrl u_rx_ctrl_0 (
  .rx_clk           (rx_clk),
  .rx_rstn          (rx_rstn),

  .bist_rstn        (bist_rstn),
  .bist_mode        (bist_mode),
  .test_mode        (test_mode),
  .scan_enable      (scan_enable),
  .bist_fail        (bist_fail[0]),
  .bist_finish      (bist_finish[0]),

  .rx_data          (rx_data),
  .rx_vld           (rx_vld),
  .ddr_en           (rx_ddr_en),
  .en_16b           (rx_en_16b),
  .rx_rdy           (rx_rdy_rx),
  .tx_rdy           (tx_rdy),


    .rx_req         (rx_req_rx),
    .rx_dch         (rx_dch_rx),
    .rx_ack         (rx_ack_rx),
    .rx_stop        (rx_stop_rx),
    .rx_sch         (rx_sch),
    .rx_sack        (rx_sack_rx),


  .rx_fail          (rx_fail_io),
  .rx_bt_s          (rx_bts_rx),
  .tx_bt_s          (tx_bts_rx),
  .btchk_done       (btchk_done_rx),

  .afifo_wr         (rx_afifo_wr),
  .afifo_wdata      (rx_afifo_wdata),
  .afifo_full       (rx_afifo_full)
);

f_bio_tx_ctrl u_tx_ctrl_0 (
  .tx_clk           (tx_clk),
  .tx_rstn          (tx_rstn),

  .tx_data          (tx_data),
  .tx_vld           (tx_vld),
  .tx_rdy           (tx_rdy_tx),
  .rx_rdy_tx        (rx_rdy_tx),
  .rx_rdy           (rx_rdy),
  .ddr_en           (tx_ddr_en),
  .en_16b           (tx_en_16b),
  .btchk_done       (btchk_done_tx),
  .rx_fail          (rx_fail_tx),
  .rx_bt_s          (rx_bts_tx),
  .tx_bt_s          (tx_bts_tx),


    .tx_done        (tx_done_tx),
    .tx_dch         (tx_dch_tx),
    .tx_dack        (tx_dack_tx),


  .tx_probe         (tx_probe[10:0]),

  .afifo_rd         (tx_afifo_rd),
  .afifo_rdata      (tx_afifo_rdata),
  .afifo_empty      (tx_afifo_empty)
);

f_bio_cdc u_cdc_0 (
  .tx_clk           (tx_clk),
  .tx_rstn          (tx_rstn),
  .rx_clk           (rx_clk),
  .rx_rstn          (rx_rstn),
  .sysclk           (sysclk),
  .sysrstn          (cdc_rstn),

  .bist_rstn        (bist_rstn),
  .bist_mode        (bist_mode),
  .test_mode        (test_mode),
  .scan_enable      (scan_enable),
  .bist_fail        (bist_fail[2:1]),
  .bist_finish      (bist_finish[2:1]),


    .rx_stop_rx     (rx_stop_rx),
    .rx_stop_sys    (rx_stop_sys),
    .rx_sack_rx     (rx_sack_rx),
    .rx_sack_sys    (rx_sack_sys),
    .rx_req_rx      (rx_req_rx),
    .rx_req_sys     (rx_req_sys),
    .rx_dch_rx      (rx_dch_rx),
    .rx_dch_sys     (rx_dch_sys),
    .rx_ack_rx      (rx_ack_rx),
    .tx_done_tx     (tx_done_tx),
    .tx_done_sys    (tx_done_sys),
    .tx_dch_tx      (tx_dch_tx),
    .tx_dch_sys     (tx_dch_sys),
    .tx_dack_tx     (tx_dack_tx),


  .tx_rdy           (tx_rdy),
  .tx_rdy_tx        (tx_rdy_tx),
  .rx_rdy_rx        (rx_rdy_rx),
  .rx_rdy           (rx_rdy_tx),

  .ddr_en_sys       (ddr_en),
  .en_16b_sys       (en_16b),
  .tx_ddr_en        (tx_ddr_en),
  .rx_ddr_en        (rx_ddr_en),
  .tx_en_16b        (tx_en_16b),
  .rx_en_16b        (rx_en_16b),

  .ckchk_req        (ckchk_req),
  .ckchk_ack        (ckchk_ack),
  //.btchk_ack_sys    (btchk_ack_sys),
  //.rx_fail_sys      (rx_fail_sys),
  .btchk_ack_io     (btchk_done_rx),
  .btchk_ack_tx     (btchk_done_tx),
  .rx_fail_io       (rx_fail_io),
  .rx_fail_tx       (rx_fail_tx),
  .rx_bts_rx        (rx_bts_rx),
  .rx_bts_tx        (rx_bts_tx),
  .tx_bts_rx        (tx_bts_rx),
  .tx_bts_tx        (tx_bts_tx),

  .rx_afifo_wr      (rx_afifo_wr),
  .rx_afifo_wdata   (rx_afifo_wdata),
  .rx_afifo_full    (rx_afifo_full),

  .tx_afifo_rd      (tx_afifo_rd),
  .tx_afifo_rdata   (tx_afifo_rdata),
  .tx_afifo_empty   (tx_afifo_empty),

  .sys_afifo_wr     (sys_afifo_wr),
  .sys_afifo_wdata  (sys_afifo_wdata),
  .sys_afifo_full   (sys_afifo_full),
  .sys_afifo_rd     (sys_afifo_rd),
  .sys_afifo_rdata  (sys_afifo_rdata),
  .sys_afifo_empty  (sys_afifo_empty)
);

f_bio_axis_reg u_axis_reg_0 (
  .sysclk       (sysclk),
  .sysrstn      (sysrstn),
  .sft_rst      (sft_rst),

  .axis_awid    (axis0_awid),
  .axis_awaddr  (axis0_awaddr),
  .axis_awlen   (axis0_awlen),
  .axis_awsize  (axis0_awsize),
  .axis_awburst (axis0_awburst),
  .axis_awlock  (axis0_awlock),
  .axis_awcache (axis0_awcache),
  .axis_awprot  (axis0_awprot),
  .axis_awvalid (axis0_awvalid),
  .axis_awready (axis0_awready),

  .axis_wid     (axis0_wid),
  .axis_wdata   (axis0_wdata),
  .axis_wstrb   (axis0_wstrb),
  .axis_wlast   (axis0_wlast),
  .axis_wvalid  (axis0_wvalid),
  .axis_wready  (axis0_wready),

  .axis_bid     (axis0_bid),
  .axis_bresp   (axis0_bresp),
  .axis_bvalid  (axis0_bvalid),
  .axis_bready  (axis0_bready),

  .axis_arid    (axis0_arid),
  .axis_araddr  (axis0_araddr),
  .axis_arlen   (axis0_arlen),
  .axis_arsize  (axis0_arsize),
  .axis_arburst (axis0_arburst),
  .axis_arlock  (axis0_arlock),
  .axis_arcache (axis0_arcache),
  .axis_arprot  (axis0_arprot),
  .axis_arvalid (axis0_arvalid),
  .axis_arready (axis0_arready),

  .axis_rid     (axis0_rid),
  .axis_rdata   (axis0_rdata),
  .axis_rresp   (axis0_rresp),
  .axis_rlast   (axis0_rlast),
  .axis_rvalid  (axis0_rvalid),
  .axis_rready  (axis0_rready),


    .ch0_dst_sel    (ch0_dst_sel),
    .ch1_dst_sel    (ch1_dst_sel),
    .ch2_dst_sel    (ch2_dst_sel),
    .ch3_dst_sel    (ch3_dst_sel),
    .ch4_dst_sel    (ch4_dst_sel),
    .ch5_dst_sel    (ch5_dst_sel),

    .ch0_discnt     (ch0_discnt),
    .ch1_discnt     (ch1_discnt),
    .ch2_discnt     (ch2_discnt),
    .ch3_discnt     (ch3_discnt),
    .ch4_discnt     (ch4_discnt),
    .ch5_discnt     (ch5_discnt),


  .stest_reg    (stest_reg),
  .wr_sdata     (wr_sdata),
  .btchk_sreq   (btchk_req_sys),
  .btchk_done   (btchk_done),
  .btchk_fail   (btchk_fail),
  .pb_sel       (pb_sel),
  .axis_probe   (axis_probe),
  .stest_sreq   (stest_sreq),
  .stest_tfail  (stest_tfail),
  .stest_fail   (stest_fail),
  .stest_done   (stest_done),
  .sft_ds_en    (sft_ds_en),
  .sft_ie_en    (sft_ie_en),
  .sft_pwd      (sft_pwd),
  .rx_clki_dly  (rx_clki_dly),
  .rx_clki_inv  (rx_clki_inv),
  .rx_clki_pol  (rx_clki_pol),
  .rx_clko_dly  (rx_clko_dly),
  .rx_clko_inv  (rx_clko_inv),
  .rx_clko_pol  (rx_clko_pol),
  .tx_clki_dly  (tx_clki_dly),
  .tx_clki_inv  (tx_clki_inv),
  .tx_clki_pol  (tx_clki_pol),
  .tx_clko_dly  (tx_clko_dly),
  .tx_clko_inv  (tx_clko_inv),
  .tx_clko_pol  (tx_clko_pol),
  .rx_ck_comp   (rx_ck_comp),
  .rx_ck_cinv   (rx_ck_cinv),
  .tx_ck_comp   (tx_ck_comp),
  .tx_ck_cinv   (tx_ck_cinv),
  .boot_addr    (boot_addr),

  .cpum_wt      (cpum_wt),
  .cpus_wt      (cpus_wt),
  .dma_wt       (dma_wt),
  .lp_mreq      (lp_mreq),
  .arb_ctl_wr   (arb_ctl_wr),
  //.cpum_wtcnt   (cpum_wtcnt),
  //.cpus_wtcnt   (cpus_wtcnt),
  //.dma_wtcnt    (dma_wtcnt),

  .ch0_run      (ch0_run),
  .ch0_trig     (ch0_trig),
  .ch0_dir      (ch0_dir),
  .ch0_len      (ch0_len),
  .ch0_addr     (ch0_addr),
  .ch0_stop     (ch0_stop),
  .ch1_run      (ch1_run),
  .ch1_trig     (ch1_trig),
  .ch1_dir      (ch1_dir),
  .ch1_len      (ch1_len),
  .ch1_addr     (ch1_addr),
  .ch1_stop     (ch1_stop),
  .ch2_run      (ch2_run),
  .ch2_trig     (ch2_trig),
  .ch2_dir      (ch2_dir),
  .ch2_len      (ch2_len),
  .ch2_addr     (ch2_addr),
  .ch2_stop     (ch2_stop),
  .ch3_run      (ch3_run),
  .ch3_trig     (ch3_trig),
  .ch3_dir      (ch3_dir),
  .ch3_len      (ch3_len),
  .ch3_addr     (ch3_addr),
  .ch3_stop     (ch3_stop),
  .ch4_run      (ch4_run),
  .ch4_trig     (ch4_trig),
  .ch4_dir      (ch4_dir),
  .ch4_len      (ch4_len),
  .ch4_addr     (ch4_addr),
  .ch4_stop     (ch4_stop),
  .ch5_run      (ch5_run),
  .ch5_trig     (ch5_trig),
  .ch5_stop     (ch5_stop),
  .ch5_dir      (ch5_dir),
  .ch5_len      (ch5_len),
  .ch5_addr     (ch5_addr),
  .en_16b       (en_16b),
  .ddr_en       (ddr_en)
);

f_bio_rx_pkt u_rx_pkt_0 (
  .sysclk       (sysclk),
  .sysrstn      (sysrstn),
  .sft_rst      (sft_rst),

  .cpum_req     (rx_cpum_req),
  .cpum_info    (rx_cpum_info),
  .cpum_acp     (cpum_rx_acp),
  .cpum_wvld    (cpum_wvld),
  .cpum_wdata   (cpum_wdata),
  .cpum_wrdy    (cpum_wrdy),

  .cpus_req     (rx_cpus_req),
  .cpus_info    (rx_cpus_info),
  .cpus_rvld    (rx_cpus_rvld),
  .cpus_rdata   (rx_cpus_rdata),
  .cpus_rrdy    (cpus_rx_rrdy),
  .cpus_req1    (rx_cpus_req1),
  .cpus_info1   (rx_cpus_info1),
  .cpus_acp1    (cpus_rx_acp1),

  .dma_wvld     (dma_wvld),
  .dma_ch       (dma_ch),
  .dma_wdata    (dma_wdata),
  .dma_wrdy     (dma_wrdy),


    .rx_req     (rx_req_sys),
    .rx_rch     (rx_dch_sys),
    .rx_sack    (rx_sack_sys),
    .rx_sch     (rx_sch),
    .rx_sdone   (rx_sdone),


  .stest_ack    (stest_ack),
  .btchk_ack    (btchk_ack),
  .btchk_dack   (btchk_dack),
  .btchk_ack1   (btchk_ack1),
  .rx_fail      (rx_fail),
  .stest_run    (stest_run),

  .afifo_rd     (sys_afifo_rd),
  .afifo_rdata  (sys_afifo_rdata),
  .afifo_empty  (sys_afifo_empty)
);

f_bio_tx_pkt u_tx_pkt_0 (
  .sysclk       (sysclk),
  .sysrstn      (sysrstn),
  .sft_rst      (sft_rst),

  .cpum_wt      (cpum_wt),
  .cpus_wt      (cpus_wt),
  .dma_wt       (dma_wt),
  .lp_mreq      (lp_mreq),
  .arb_ctl_wr   (arb_ctl_wr),
  //.cpum_wtcnt   (cpum_wtcnt),
  //.cpus_wtcnt   (cpus_wtcnt),
  //.dma_wtcnt    (dma_wtcnt),

  .cpum_req     (cpum_tx_req),
  .cpum_info    (cpum_tx_info),
  .cpum_ack     (tx_cpum_ack),
  .cpum_ren     (tx_cpum_ren),
  .cpum_data    (cpum_tx_data),
  .cpum_last    (cpum_tx_last),
  .cpum_clast   (cpum_tx_clast),
  .cpus_req     (cpus_tx_req),
  .cpus_info    (cpus_tx_info),
  .cpus_ack     (tx_cpus_ack),
  .cpus_ren     (tx_cpus_ren),
  .cpus_data    (cpus_tx_data),
  .cpus_last    (cpus_tx_last),
  .cpus_wbe     (cpus_tx_wbe),
  .cpus_clast   (cpus_tx_clast),

  .dma_req      (dma_req),
  .dma_info     (dma_info),
  .dma_ack      (dma_ack),
  .dma_dvld     (dma_dvld),
  .dma_data     (dma_data),
  .dma_last     (dma_last),
  .dma_drdy     (dma_drdy),

  .stest_req    (stest_req_sys),
  .btchk_req    (btchk_req),
  .btchk_req1   (btchk_req1),
  .stest_run    (stest_run),
  .rx_fail      (rx_fail),

  .afifo_wr     (sys_afifo_wr),
  .afifo_wdata  (sys_afifo_wdata),
  .afifo_full   (sys_afifo_full)
);

f_bio_cpum_ctrl u_cpum_ctrl_0 (
  .sysclk           (sysclk),
  .sysrstn          (sysrstn),
  .sft_rst          (sft_rst),
  .sft_ack0         (sft_ack0),
  .adr_remap        (adr_remap),
  .boot_addr        (boot_addr),

  .bist_rstn        (bist_rstn),
  .bist_mode        (bist_mode),
  .test_mode        (test_mode),
  .scan_enable      (scan_enable),
  .bist_fail        (bist_fail[4:3]),
  .bist_finish      (bist_finish[4:3]),
  .mem_clk2x        (mem_clk2x),

  .rx_cpu_req       (rx_cpum_req),
  .rx_cpu_info      (rx_cpum_info),
  .cpu_rx_acp       (cpum_rx_acp),
  .cpu_wvld         (cpum_wvld),
  .cpu_wdata        (cpum_wdata),
  .cpu_wrdy         (cpum_wrdy),

  .cpu_tx_req       (cpum_tx_req),
  .cpu_tx_info      (cpum_tx_info),
  .tx_cpu_ack       (tx_cpum_ack),
  .tx_cpu_ren       (tx_cpum_ren),
  .cpu_tdata        (cpum_tx_data),
  .cpu_tlast        (cpum_tx_last),
  .cpu_clast        (cpum_tx_clast),

  .axim_probe       (axim1_probe),

  // AXI Write Address phase signals
  .axim_awid        (axim1_awid),
  .axim_awaddr      (axim1_awaddr),
  .axim_awlen       (axim1_awlen),
  .axim_awsize      (axim1_awsize),
  .axim_awburst     (axim1_awburst),
  .axim_awlock      (axim1_awlock),
  .axim_awcache     (axim1_awcache),
  .axim_awprot      (axim1_awprot),
  .axim_awvalid     (axim1_awvalid),
  .axim_awready     (axim1_awready),
  // AXI Write Data phase signals
  .axim_wid         (axim1_wid),
  .axim_wdata       (axim1_wdata),
  .axim_wstrb       (axim1_wstrb),
  .axim_wlast       (axim1_wlast),
  .axim_wvalid      (axim1_wvalid),
  .axim_wready      (axim1_wready),
  // AXI Write Response phase signals
  .axim_bid         (axim1_bid),
  .axim_bresp       (axim1_bresp),
  .axim_bvalid      (axim1_bvalid),
  .axim_bready      (axim1_bready),

  // AXI Read Address phase signals
  .axim_arid        (axim1_arid),
  .axim_araddr      (axim1_araddr),
  .axim_arlen       (axim1_arlen),
  .axim_arsize      (axim1_arsize),
  .axim_arburst     (axim1_arburst),
  .axim_arlock      (axim1_arlock),
  .axim_arcache     (axim1_arcache),
  .axim_arprot      (axim1_arprot),
  .axim_arvalid     (axim1_arvalid),
  .axim_arready     (axim1_arready),
  // AXI Read Data phase signals

  .axim_rid         (axim1s_rid),
  .axim_rdata       (axim1s_rdata),
  .axim_rresp       (axim1s_rresp),
  .axim_rlast       (axim1s_rlast),
  .axim_rvalid      (axim1s_rvalid),
  .axim_rready      (axim1s_rready)








);


  wire [74:0] axim1_info;
  wire [74:0] axim1s_info;
  assign axim1_info[63:0]  = axim1_rdata;
  assign axim1_info[71:64] = axim1_rid;
  assign axim1_info[73:72] = axim1_rresp;
  assign axim1_info[74]    = axim1_rlast;
  assign axim1s_rdata = axim1s_info[63:0];
  assign axim1s_rid   = axim1s_info[71:64];
  assign axim1s_rresp = axim1s_info[73:72];
  assign axim1s_rlast = axim1s_info[74];
  f_bio_axi_rslice #(74) u_axim_rdata_0 (
    .clk       (sysclk),
    .rstn      (sysrstn),
    .valid_s   (axim1_rvalid),
    .data_s    (axim1_info),
    .ready_s   (axim1_rready),
    .valid_d   (axim1s_rvalid),
    .data_d    (axim1s_info),
    .ready_d   (axim1s_rready)
  );


f_bio_cpus_ctrl u_cpus_ctrl_0 (
  .sysclk           (sysclk),
  .sysrstn          (sysrstn),
  .sft_rst          (sft_rst),
  .sft_set          (sft_set),
  .sft_ack3         (sft_ack3),

  .bist_rstn        (bist_rstn),
  .bist_mode        (bist_mode),
  .test_mode        (test_mode),
  .scan_enable      (scan_enable),
  .bist_fail        (bist_fail[6:5]),
  .bist_finish      (bist_finish[6:5]),
  .mem_clk2x        (mem_clk2x),

  .stest_en         (1'b0),
  .stest_trig       (1'b0),

  .rx_cpu_req       (rx_cpus_req),
  .rx_cpu_info      (rx_cpus_info),
  .cpu_rvld         (rx_cpus_rvld),
  .cpu_rdata        (rx_cpus_rdata),
  .cpu_rrdy         (cpus_rx_rrdy),
  .rx_cpu_req1      (rx_cpus_req1),
  .rx_cpu_info1     (rx_cpus_info1),
  .cpu_rx_acp1      (cpus_rx_acp1),

  .cpu_tx_req       (cpus_tx_req),
  .cpu_tx_info      (cpus_tx_info),
  .tx_cpu_ack       (tx_cpus_ack),
  .tx_cpu_ren       (tx_cpus_ren),
  .cpu_data         (cpus_tx_data),
  .cpu_tlast        (cpus_tx_last),
  .cpu_wbe          (cpus_tx_wbe),
  .cpu_clast        (cpus_tx_clast),

  .arb_probe        (cpus_arb_probe),

  // AXI slave port
  .axis_awid        (axis1_awid),
  .axis_awaddr      (axis1_awaddr),
  .axis_awlen       (axis1_awlen),
  .axis_awsize      (axis1_awsize),
  .axis_awburst     (axis1_awburst),
  .axis_awlock      (axis1_awlock),
  .axis_awcache     (axis1_awcache),
  .axis_awprot      (axis1_awprot),
  .axis_awvalid     (axis1_awvalid),
  .axis_awready     (axis1_awready),

  .axis_wid         (axis1_wid),
  .axis_wdata       (axis1_wdata),
  .axis_wstrb       (axis1_wstrb),
  .axis_wlast       (axis1_wlast),
  .axis_wvalid      (axis1_wvalid),
  .axis_wready      (axis1_wready),

  .axis_bid         (axis1_bid),
  .axis_bresp       (axis1_bresp),
  .axis_bvalid      (axis1_bvalid),
  .axis_bready      (axis1_bready),

  .axis_arid        (axis1_arid),
  .axis_araddr      (axis1_araddr),
  .axis_arlen       (axis1_arlen),
  .axis_arsize      (axis1_arsize),
  .axis_arburst     (axis1_arburst),
  .axis_arlock      (axis1_arlock),
  .axis_arcache     (axis1_arcache),
  .axis_arprot      (axis1_arprot),
  .axis_arvalid     (axis1_arvalid),
  .axis_arready     (axis1_arready),

  .axis_rid         (axis1_rid),
  .axis_rdata       (axis1_rdata),
  .axis_rresp       (axis1_rresp),
  .axis_rlast       (axis1_rlast),
  .axis_rvalid      (axis1_rvalid),
  .axis_rready      (axis1_rready)
);

f_bio_dma_ctrl u_dma_ctrl_0 (
  .sysclk       (sysclk),
  .sysrstn      (sysrstn),
  .sft_rst      (sft_rst),
  .sft_ack1     (sft_ack1),
  .sft_ack2     (sft_ack2),

  .bist_rstn    (bist_rstn),
  .bist_mode    (bist_mode),
  .test_mode    (test_mode),
  .scan_enable  (scan_enable),
  .bist_fail    (bist_fail[12:7]),
  .bist_finish  (bist_finish[12:7]),

  .dma_wvld     (dma_wvld),
  .dma_ch       (dma_ch),
  .dma_wdata    (dma_wdata),
  .dma_wrdy     (dma_wrdy),

  .dma_req      (dma_req),
  .dma_info     (dma_info),
  .dma_ack      (dma_ack),
  .dma_dvld     (dma_dvld),
  .dma_data     (dma_data),
  .dma_last     (dma_last),
  .dma_drdy     (dma_drdy),

  .en_16b       (en_16b),
  .ch0_run      (ch0_run),
  .ch0_trig     (ch0_trig),
  .ch0_dir      (ch0_dir),
  .ch0_len      (ch0_len),
  .ch0_addr     (ch0_addr),
  .ch0_stop     (ch0_stop),
  .ch1_run      (ch1_run),
  .ch1_trig     (ch1_trig),
  .ch1_dir      (ch1_dir),
  .ch1_len      (ch1_len),
  .ch1_addr     (ch1_addr),
  .ch1_stop     (ch1_stop),
  .ch2_run      (ch2_run),
  .ch2_trig     (ch2_trig),
  .ch2_dir      (ch2_dir),
  .ch2_len      (ch2_len),
  .ch2_addr     (ch2_addr),
  .ch2_stop     (ch2_stop),
  .ch3_run      (ch3_run),
  .ch3_trig     (ch3_trig),
  .ch3_dir      (ch3_dir),
  .ch3_len      (ch3_len),
  .ch3_addr     (ch3_addr),
  .ch3_stop     (ch3_stop),
  .ch4_run      (ch4_run),
  .ch4_trig     (ch4_trig),
  .ch4_dir      (ch4_dir),
  .ch4_len      (ch4_len),
  .ch4_addr     (ch4_addr),
  .ch4_stop     (ch4_stop),
  .ch5_run      (ch5_run),
  .ch5_trig     (ch5_trig),
  .ch5_stop     (ch5_stop),
  .ch5_dir      (ch5_dir),
  .ch5_len      (ch5_len),
  .ch5_addr     (ch5_addr),


    .ch0_dst_sel    (ch0_dst_sel),
    .ch1_dst_sel    (ch1_dst_sel),
    .ch2_dst_sel    (ch2_dst_sel),
    .ch3_dst_sel    (ch3_dst_sel),
    .ch4_dst_sel    (ch4_dst_sel),
    .ch5_dst_sel    (ch5_dst_sel),

    .ch0_discnt     (ch0_discnt),
    .ch1_discnt     (ch1_discnt),
    .ch2_discnt     (ch2_discnt),
    .ch3_discnt     (ch3_discnt),
    .ch4_discnt     (ch4_discnt),
    .ch5_discnt     (ch5_discnt),

    .rx_sdone       (rx_sdone),
    .tx_done        (tx_done_sys),
    .tx_dch         (tx_dch_sys),
    .rx_stop_req    (rx_stop_sys),
    .rx_sch         (rx_sch),


















    .lvds_pop       (lvds_pop),
    .lvds_rdata     (lvds_rdata),
    .lvds_empty     (lvds_empty),
    .lvds_push      (lvds_push),
    .lvds_wdata     (lvds_wdata),
    .lvds_full      (lvds_full),







    .ddfch_rreq     (ddfch_rreq),
    .ddfch_rdata    (ddfch_rdata),
    .ddfch_rvalid   (ddfch_rvalid),


  .axim_probe   (axim0_probe),

  // AXI Write Address phase signals
  .axim_awid    (axim0_awid),
  .axim_awaddr  (axim0_awaddr),
  .axim_awlen   (axim0_awlen),
  .axim_awsize  (axim0_awsize),
  .axim_awburst (axim0_awburst),
  .axim_awlock  (axim0_awlock),
  .axim_awcache (axim0_awcache),
  .axim_awprot  (axim0_awprot),
  .axim_awvalid (axim0_awvalid),
  .axim_awready (axim0_awready),
  // AXI Write Data phase signals
  .axim_wid     (axim0_wid),
  .axim_wdata   (axim0_wdata),
  .axim_wstrb   (axim0_wstrb),
  .axim_wlast   (axim0_wlast),
  .axim_wvalid  (axim0_wvalid),
  .axim_wready  (axim0_wready),
  // AXI Write Response phase signals
  .axim_bid     (axim0_bid),
  .axim_bresp   (axim0_bresp),
  .axim_bvalid  (axim0_bvalid),
  .axim_bready  (axim0_bready),

  // AXI Read Address phase signals
  .axim_arid    (axim0_arid),
  .axim_araddr  (axim0_araddr),
  .axim_arlen   (axim0_arlen),
  .axim_arsize  (axim0_arsize),
  .axim_arburst (axim0_arburst),
  .axim_arlock  (axim0_arlock),
  .axim_arcache (axim0_arcache),
  .axim_arprot  (axim0_arprot),
  .axim_arvalid (axim0_arvalid),
  .axim_arready (axim0_arready),
  // AXI Read Data phase signals
  .axim_rid     (axim0_rid),
  .axim_rdata   (axim0_rdata),
  .axim_rresp   (axim0_rresp),
  .axim_rlast   (axim0_rlast),
  .axim_rvalid  (axim0_rvalid),
  .axim_rready  (axim0_rready)
);

f_bio_stest_ctrl u_stest_ctrl_0 (
  .sysclk           (sysclk),
  .sysrstn          (sysrstn),
  .sft_rst          (sft_rst),

  .stest_trig       (stest_trig),
  .pulse_1us        (pulse_1us),
  .stest_run        (stest_run),

  .ckchk_req        (ckchk_req),
  .ckchk_ack        (ckchk_ack),
  .stest_req        (stest_req_sys),
  .stest_ack        (stest_ack),
  .btchk_req        (btchk_req),
  .btchk_ack        (btchk_ack),
  .btchk_sreq       (btchk_req_sys),
  .btchk_dack       (btchk_dack),
  .btchk_req1       (btchk_req1),
  .btchk_ack1       (btchk_ack1),
  .rx_fail          (rx_fail),
  .btchk_done       (btchk_done),
  .btchk_fail       (btchk_fail),
  .stest_done       (stest_done),
  .stest_fail       (stest_fail),
  .stest_tfail      (stest_tfail),
  .stest_pst        (stest_pst)
);

endmodule
//==============================================================================
//
//    This confidential and proprietary hardware may be used only as
//  authorized by a licensing agreement from
//                    SunMedia Technology Co., LTD.
//
//  In the event of publication, the following notice is applicable:
//
//            COPYRIGHT 2017, SunMedia Technology Co., LTD.
//                        ALL RIGHTS RESERVED
//
//  The entire notice above must be reproduced on all authorized copies.
//
//==============================================================================
//
//  File        : f_bio_tx_pkt.v
//  Author      : kun.zhang
//  Date        : 22/Nov/2017
//  Version     : 1.1
//  Abstract    : This module is the TX packet block for BIO control. It takes
//                requests from CPU control and DMA control block and packed the
//                data into tramsfer format and wirte to AFIFO for CDC.
//
//  Modification History:
//  Date          By            Version         Change Description
//------------------------------------------------------------------------------
//  09/Feb/2017   kun.zhang      1.0            Original
//  22/Nov/2017   kun.zhang      1.1            Add CPU slave interface
//
//
//==============================================================================
// About *_info
// cpum_info
// [18]: 1'b1 -> write response, 1'b0 -> read data
//   for write response
//     [7:0]  : response id
//     [9:8]  : response type
//     [17:10]: reserved
//   for read data
//     [7:0]  : tx data length in bytes
//     [15:8] : read data id
//     [17:16]: read data response type
//------------------------------------------------------------------------------
// cpus_info
// [66]   : 1'b1 -> write request, 1'b0 -> read request
// [65:58]: for write data length (transfered to IO bus)
// [57:55]: awsize/arsize[2:0]
// [54:52]: awprot/arprot[2:0]
// [51:50]: awlock/arlock[1:0]
// [49:48]: awburst/arburst[1:0]
// [47:44]: awlen/arlen[3:0]
// [43:40]: awcache/arcache[3:0]
// [39:32]: awid/arid[7:0]. Only send 8bit id on IO bus
// [31:0] : awaddr/araddr[31:0]
//------------------------------------------------------------------------------
// dma_info
// [10:8]: DMA channel number
// [7:0] : DMA transfer length
//******************************************************************************



module f_bio_tx_pkt (
  input  wire        sysclk,    // clock
  input  wire        sysrstn,   // reset
  input  wire        sft_rst,   // Soft reset
//  input  wire        cpu_fsel,  // CPU first select. 1'b0: master first, 1'b1: slave first

  input  wire [6:0]  cpum_wt,       // CPU master arbitration weight
  input  wire [6:0]  cpus_wt,       // CPU slave arbitration weight
  input  wire [6:0]  dma_wt,        // DMA arbitration weight
  input  wire [7:0]  lp_mreq,       // Low priority maxmum request count
  input  wire        arb_ctl_wr,    // Arbiter control register write
  //output wire [6:0]  cpum_wtcnt,    // CPU master weight counter
  //output wire [6:0]  cpus_wtcnt,    // CPU master weight counter
  //output wire [6:0]  dma_wtcnt,     // CPU master weight counter

  input  wire        cpum_req,      // CPU master mode transfer request, level
  input  wire [18:0] cpum_info,     // CPU master mode transfer information
  output reg         cpum_ack,      // CPU master mode transfer acknowlage
  output reg         cpum_ren,      // CPU master mode data reand enable, low active
  input  wire [63:0] cpum_data,     // CPU master mode data
  input  wire [3:0]  cpum_last,     // CPU master mode last data in a burst
  input  wire        cpum_clast,    // CPU master mode read command last

  input  wire        cpus_req,      // CPU slave mode transfer request, level
  input  wire [66:0] cpus_info,     // CPU slave mode transfer information
  output reg         cpus_ack,      // CPU slave mode transfer acknowlage
  output reg         cpus_ren,      // CPU slave mode data reand enable, low active
  input  wire [63:0] cpus_data,     // CPU slave mode data
  input  wire [3:0]  cpus_last,     // CPU slave mode last data in a burst
  input  wire [131:0] cpus_wbe,      // CPU slave mode write byte enable
  input  wire        cpus_clast,    // CPU slave mode read command last

  input  wire        dma_req,   // DMA mode transfer request, pulse
  input  wire [15:0] dma_info,  // DMA mode transfer information
  output reg         dma_ack,   // DMA mode transfer acknowlage
  input  wire        dma_dvld,  // DMA mode data valid
  input  wire [63:0] dma_data,  // DMA mode data
  input  wire        dma_last,  // DMA mode last data in a burst
  output wire        dma_drdy,  // DMA mode data ready

  input  wire        stest_req,     // Self-test start request
  input  wire        btchk_req,     // Request to send BT start
  input  wire        btchk_req1,    // Request to send BT end
  input  wire        rx_fail,       // BT data rx fail
  input  wire        stest_run,     // Self-test running

  output reg         afifo_wr,      // AFIFO write enable
  output reg  [71:0] afifo_wdata,   // AFIFO write data
  input  wire        afifo_full     // AFIFO full
);

parameter M0_IDLE = 3'b000;   // Master0 idle
parameter M0_BUSY = 3'b100;   // Master0 busy
parameter M1_IDLE = 3'b001;   // Master1 idle
parameter M1_BUSY = 3'b101;   // Master1 busy
parameter M2_IDLE = 3'b010;   // Master2 idle
parameter M2_BUSY = 3'b110;   // Master2 busy
//******************************************************************************
reg  [2:0]  tx_arb_cs;      // TX arbiter current state
reg  [2:0]  tx_arb_ns;      // TX arbiter next state
wire        m0_hreq;        // Master0 high priority request
wire        m0_lreq;        // Master0 low priority request
wire        m1_hreq;        // Master0 high priority request
wire        m1_lreq;        // Master0 low priority request
wire        m2_hreq;        // Master0 high priority request
wire        m2_lreq;        // Master0 low priority request
reg  [7:0]  m0_wtcnt;       // Master0 weight counter
reg  [7:0]  m1_wtcnt;       // Master1 weight counter
reg  [7:0]  m2_wtcnt;       // Master2 weight counter
reg  [8:0]  lp_req_cnt;     // Low priority request counter
wire        reload_wtcnt;   // Status to reload all weight counters
wire        hp_req;         // High priority request

wire        push_cmd;       // Status to push request command to shift buffers
//reg         req_pend;       // Request pending
reg  [66:0] req_buf;        // Request buffer for pending information
reg  [7:0]  data_buf0;      // Data buffer0 for alignment
reg  [7:0]  data_buf1;      // Data buffer1 for alignment
reg  [7:0]  data_buf2;      // Data buffer2 for alignment
reg  [7:0]  data_buf3;      // Data buffer3 for alignment
reg  [7:0]  data_buf4;      // Data buffer4 for alignment
reg  [7:0]  data_buf5;      // Data buffer5 for alignment
reg  [7:0]  data_buf6;      // Data buffer6 for alignment
reg  [7:0]  data_buf7;      // Data buffer7 for alignment
reg  [7:0]  data_buf8;      // Data buffer8 for alignment
reg  [7:0]  data_buf9;      // Data buffer9 for alignment
reg  [7:0]  data_buf10;     // Data buffer10 for alignment
reg  [7:0]  data_buf11;     // Data buffer11 for alignment
reg  [7:0]  data_buf12;     // Data buffer12 for alignment
reg  [7:0]  data_buf13;     // Data buffer13 for alignment
reg  [7:0]  data_buf14;     // Data buffer14 for alignment
reg  [7:0]  data_buf15;     // Data buffer15 for alignment
wire        inc_bcnt8;      // Increase byte counter by 8
wire        inc_bcnt;       // Increase byte counter by blen
reg  [2:0]  bcnt_len;       // Byte counter increase length
reg  [5:0]  data_bcnt;      // Data byte counter for alignment
reg  [2:0]  cpu_dcnt0;      // CPU data counter for pre-read command
reg  [2:0]  cpu_dcnt1;      // CPU data counter for pre-read data
wire        inc_dcnt0;      // Status to increase cpu_dcnt0;
wire        dec_dcnt0;      // Status to decrease cpu_dcnt0;
wire        inc_dcnt1;      // Status to increase cpu_dcnt1;
wire        dec_dcnt1;      // Status to decrease cpu_dcnt1;
wire        wr_dbuf;        // Write data buffer enable
wire        rd_dbuf;        // Read data buffer enable
reg         dma_dbusy;      // DMA mode data transfer busy
reg         cpu_dbusy;      // CPU mode data transfer busy
reg         cpu_cbusy;      // CPU mode command bussy
reg  [1:0]  cpu_rd_d;       // CPU read request delayed for data valid
reg         cpu_rd_sel;     // CPU read select (master/slave)
reg  [67:0] cpu_dbuf0;      // CPU read data buffer0;
reg  [67:0] cpu_dbuf1;      // CPU read data buffer0;
reg  [67:0] cpu_dbuf2;      // CPU read data buffer0;
wire        drd_last;       // Data read last
reg         drd_last_r;     // Data read last latched

reg         cpus_wbe_st;    // CPU write WBE state
reg         cpus_wbe_pend;  // CPU write WBE pending
reg         cpus_wbe_2nd;   // CPU write WBE 2nd state
reg  [131:0] cpus_wbe_r;    // Latched CPU WBE
wire [131:0] cpus_wbe_w;    // Selected CPU WBE
reg  [63:0] dbuf_src;       // Data buffer source data (select from all CPU and DMA)
wire [63:0] wdata_s;        // write data source
wire        set_afifo_wr;   // Status to set the afifo_wr signal

reg         stest_rdy;      // Ready to transfer Test mode releated information
reg         btchk_req_r;    // Latched BT start request
reg         btchk_req_r1;   // Latched BT start request
//==============================================================================
assign m0_hreq = cpum_req&~stest_run&~cpum_ack&(|m0_wtcnt[6:0])&~sft_rst;
assign m0_lreq = cpum_req&~stest_run&~cpum_ack&~(|m0_wtcnt[6:0])&~sft_rst;
assign m1_hreq = cpus_req&~stest_run&~cpus_ack&(|m1_wtcnt[6:0])&~sft_rst;
assign m1_lreq = cpus_req&~stest_run&~cpus_ack&~(|m1_wtcnt[6:0])&~sft_rst;
assign m2_hreq = dma_req&~stest_run&~dma_ack&(|m2_wtcnt[6:0])&~sft_rst;
assign m2_lreq = dma_req&~stest_run&~dma_ack&~(|m2_wtcnt[6:0])&~sft_rst;

assign reload_wtcnt = arb_ctl_wr | ~(|lp_req_cnt[7:0])
                    | (~(|m0_wtcnt[6:0])&~(|m1_wtcnt[6:0])&~(|m2_wtcnt[6:0]));
assign hp_req       = m0_hreq | m1_hreq | m2_hreq;

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    m0_wtcnt <= #0.1 8'h0;
  else begin
    if (reload_wtcnt)
      m0_wtcnt <= #0.1 {1'b0, cpum_wt};
    else if (cpum_ack&(|m0_wtcnt[6:0]))
      m0_wtcnt <= #0.1 m0_wtcnt[6:0] - 1'b1;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    m1_wtcnt <= #0.1 8'h0;
  else begin
    if (reload_wtcnt)
      m1_wtcnt <= #0.1 {1'b0, cpus_wt};
    else if (cpus_ack&(|m1_wtcnt[6:0]))
      m1_wtcnt <= #0.1 m1_wtcnt[6:0] - 1'b1;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    m2_wtcnt <= #0.1 8'h0;
  else begin
    if (reload_wtcnt)
      m2_wtcnt <= #0.1 {1'b0, dma_wt};
    else if (dma_ack&(|m2_wtcnt[6:0]))
      m2_wtcnt <= #0.1 m2_wtcnt[6:0] - 1'b1;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    lp_req_cnt <= #0.1 9'h0;
  else begin
    if (reload_wtcnt)
      lp_req_cnt <= #0.1 {1'b0, lp_mreq};
    else if (((tx_arb_cs!=tx_arb_ns)|push_cmd)&tx_arb_ns[2]) begin
      if (hp_req)
        lp_req_cnt <= #0.1 {1'b0, lp_mreq};
      else
        lp_req_cnt <= #0.1 lp_req_cnt[7:0] - 1'b1;
    end
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    tx_arb_cs <= #0.1 M2_IDLE;
  else begin
    if (sft_rst)
      tx_arb_cs <= #0.1 M2_IDLE;
    else
      tx_arb_cs <= #0.1 tx_arb_ns;
  end
end

always @ (*) begin
  tx_arb_ns = tx_arb_cs;
  case (tx_arb_cs)
    M0_IDLE: begin
      if (m1_hreq)
        tx_arb_ns = M1_BUSY;
      else if (m2_hreq)
        tx_arb_ns = M2_BUSY;
      else if (m0_hreq)
        tx_arb_ns = M0_BUSY;
      else if (m1_lreq)
        tx_arb_ns = M1_BUSY;
      else if (m2_lreq)
        tx_arb_ns = M2_BUSY;
      else if (m0_lreq)
        tx_arb_ns = M0_BUSY;
    end
    M0_BUSY: begin
      if (push_cmd) begin
        if (m1_hreq)
          tx_arb_ns = M1_BUSY;
        else if (m2_hreq)
          tx_arb_ns = M2_BUSY;
        else if (m0_hreq)
          tx_arb_ns = M0_BUSY;
        else if (m1_lreq)
          tx_arb_ns = M1_BUSY;
        else if (m2_lreq)
          tx_arb_ns = M2_BUSY;
        else if (~m0_lreq)
          tx_arb_ns = M0_IDLE;
      end
    end
    M1_IDLE: begin
      if (m2_hreq)
        tx_arb_ns = M2_BUSY;
      else if (m0_hreq)
        tx_arb_ns = M0_BUSY;
      else if (m1_hreq)
        tx_arb_ns = M1_BUSY;
      else if (m2_lreq)
        tx_arb_ns = M2_BUSY;
      else if (m0_lreq)
        tx_arb_ns = M0_BUSY;
      else if (m1_lreq)
        tx_arb_ns = M1_BUSY;
    end
    M1_BUSY: begin
      if (push_cmd) begin
        if (m2_hreq)
          tx_arb_ns = M2_BUSY;
        else if (m0_hreq)
          tx_arb_ns = M0_BUSY;
        else if (m1_hreq)
          tx_arb_ns = M1_BUSY;
        else if (m2_lreq)
          tx_arb_ns = M2_BUSY;
        else if (m0_lreq)
          tx_arb_ns = M0_BUSY;
        else if (~m1_lreq)
          tx_arb_ns = M1_IDLE;
      end
    end
    M2_IDLE: begin
      if (m0_hreq)
        tx_arb_ns = M0_BUSY;
      else if (m1_hreq)
        tx_arb_ns = M1_BUSY;
      else if (m2_hreq)
        tx_arb_ns = M2_BUSY;
      else if (m0_lreq)
        tx_arb_ns = M0_BUSY;
      else if (m1_lreq)
        tx_arb_ns = M1_BUSY;
      else if (m2_lreq)
        tx_arb_ns = M2_BUSY;
    end
    M2_BUSY: begin
      if (push_cmd) begin
        if (m0_hreq)
          tx_arb_ns = M0_BUSY;
        else if (m1_hreq)
          tx_arb_ns = M1_BUSY;
        else if (m2_hreq)
          tx_arb_ns = M2_BUSY;
        else if (m0_lreq)
          tx_arb_ns = M0_BUSY;
        else if (m1_lreq)
          tx_arb_ns = M1_BUSY;
        else if (~m2_lreq)
          tx_arb_ns = M2_IDLE;
      end
    end
    default: tx_arb_ns = M2_IDLE;
  endcase
end
//==============================================================================
assign rd_dbuf = (~afifo_wr|~afifo_full)&(|data_bcnt[4:3]);
assign wr_dbuf = ~(|data_bcnt[4:3]) | (rd_dbuf&~data_bcnt[4]);
//assign push_cmd = ~dma_dbusy & ~cpu_dbusy & req_pend & wr_dbuf & ~data_bcnt[4];
assign push_cmd = (~dma_dbusy & ~cpu_dbusy & tx_arb_cs[2] & wr_dbuf & ~data_bcnt[4]|sft_rst);

//always @ (posedge sysclk or negedge sysrstn) begin
//  if (~sysrstn)
//    req_pend <= `DLY 1'b0;
//  else begin
//    if ((cpum_req&cpum_ack)|(cpus_req&cpus_ack)|(dma_req&dma_ack))
//      req_pend <= `DLY 1'b1;
//    else if (push_cmd)
//      req_pend <= `DLY 1'b0;
//  end
//end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    req_buf <= #0.1 67'h0;
  else begin
    if (((tx_arb_cs!=tx_arb_ns)|push_cmd)&tx_arb_ns[2]) begin
      case (tx_arb_ns[1:0])
        2'h0: begin
          req_buf[66:65] <= #0.1 2'b01;
          req_buf[64]    <= #0.1 cpum_info[18];
          req_buf[17:0]  <= #0.1 cpum_info[17:0];
        end
        2'h1: begin
          req_buf <= #0.1 cpus_info;
        end
        2'h2: begin
          req_buf[66:64] <= #0.1 3'b001;
          req_buf[15:0]  <= #0.1 dma_info[15:0];
        end
        default:;
      endcase
    end
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    cpus_wbe_st <= #0.1 1'b0;
  else begin
    if (push_cmd&req_buf[66]&~sft_rst)
      cpus_wbe_st <= #0.1 1'b1;
    else if ((cpus_wbe_st&wr_dbuf&(~cpus_wbe_w[131]|cpus_wbe_2nd))|sft_rst)
      cpus_wbe_st <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    cpus_wbe_2nd <= #0.1 1'b0;
  else begin
    if ((push_cmd&req_buf[66])|sft_rst)
      cpus_wbe_2nd <= #0.1 1'b0;
    else if (cpus_wbe_st&wr_dbuf&cpus_wbe_w[131])
      cpus_wbe_2nd <= #0.1 1'b1;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    cpus_wbe_pend <= #0.1 1'b0;
  else begin
    if (((cpus_wbe_st&~wr_dbuf&cpus_ack)|(cpus_wbe_st&cpus_ack&cpus_wbe_w[131]&~cpus_wbe_2nd))&~sft_rst)
      cpus_wbe_pend <= #0.1 1'b1;
    else if ((cpus_wbe_pend&wr_dbuf&(~cpus_wbe_w[131]|cpus_wbe_2nd))|sft_rst)
      cpus_wbe_pend <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    cpus_wbe_r <= #0.1 132'h0;
  else begin
    if ((cpus_wbe_st&~wr_dbuf&cpus_ack)|(cpus_wbe_st&cpus_ack&cpus_wbe_w[131]&~cpus_wbe_2nd))
      cpus_wbe_r <= #0.1 cpus_wbe;
  end
end

assign cpus_wbe_w = cpus_wbe_pend ? cpus_wbe_r : cpus_wbe;
always @ (*) begin  // 0~7 means 1~8 Byte
  if (cpus_wbe_st)
    bcnt_len = (cpus_wbe_w[131]&~cpus_wbe_2nd) ? 3'h7 : cpus_wbe_w[130:128];
    //bcnt_len = cpus_wbe_pend ? cpus_wbe_r[66:64] : cpus_wbe[66:64];
  else if ((cpu_dcnt1[1:0]==2'h1)&wr_dbuf&cpu_dbuf0[67])
    bcnt_len = cpu_dbuf0[66:64];
  else if (cpu_rd_d[1]&wr_dbuf&cpu_rd_sel&cpum_last[3])
    bcnt_len = cpum_last[2:0];
  else
    bcnt_len = cpus_last[2:0];
end

assign inc_bcnt  = ((cpu_dcnt1[1:0]==2'h1)&wr_dbuf&cpu_dbuf0[67]) | (cpus_wbe_st&wr_dbuf)
                 | ((cpu_dcnt1[1:0]==2'h0)&cpu_rd_d[1]&wr_dbuf&cpu_rd_sel&cpum_last[3])
                 | ((cpu_dcnt1[1:0]==2'h0)&cpu_rd_d[1]&wr_dbuf&~cpu_rd_sel&cpus_last[3]);
assign inc_bcnt8 = (dma_dbusy&dma_dvld&dma_drdy)
                 | ((cpu_dcnt1[1:0]==2'h1)&wr_dbuf&~cpus_wbe_st&~cpu_dbuf0[67]) | (cpu_dcnt1[1]&wr_dbuf&~cpus_wbe_st)
                 | ((cpu_dcnt1[1:0]==2'h0)&cpu_rd_d[1]&wr_dbuf&cpu_rd_sel&~cpum_last[3])
                 | ((cpu_dcnt1[1:0]==2'h0)&cpu_rd_d[1]&wr_dbuf&~cpus_wbe_st&~cpu_rd_sel&~cpus_last[3]);
always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    data_bcnt <= #0.1 6'h0;
  else begin
    if (sft_rst)
      data_bcnt <= #0.1 6'h0;
    else if (push_cmd) begin
      casez (req_buf[66:64])
        3'b1?? : data_bcnt <= #0.1 rd_dbuf ? (data_bcnt[4:0] + 4'h1) : (data_bcnt[4:0] + 4'h9);   // CPU slave write data
        3'b010 : data_bcnt <= #0.1 rd_dbuf ? (data_bcnt[4:0] - 4'h5) : (data_bcnt[4:0] + 2'h3);   // CPU master read data
        3'b011 : data_bcnt <= #0.1 rd_dbuf ? (data_bcnt[4:0] - 4'h6) : (data_bcnt[4:0] + 2'h2);   // CPU master write response
        3'b001 : data_bcnt <= #0.1 rd_dbuf ? (data_bcnt[4:0] - 4'h6) : (data_bcnt[4:0] + 2'h2);   // DMA mode packet
        default: begin
          if (~rd_dbuf)
            data_bcnt <= #0.1 data_bcnt[4:0] + 4'h8;   // 3'b000 CPU slave read command
        end
      endcase
    end else if (drd_last_r&~(|data_bcnt[4:3])&(~afifo_wr|~afifo_full))
      data_bcnt <= #0.1 4'h0;
    else begin
      case ({inc_bcnt8, inc_bcnt, rd_dbuf})
        3'b100 : data_bcnt <= #0.1 data_bcnt[4:0] + 4'h8;
        3'b010 : data_bcnt <= #0.1 data_bcnt[4:0] + (bcnt_len[2:0] + 1'b1);
        3'b001 : data_bcnt <= #0.1 data_bcnt[4:0] - 4'h8;
        3'b011 : data_bcnt <= #0.1 data_bcnt[4:0] + bcnt_len - 3'h7;    // bcnt_len is 0~7
        default:;   // no change
      endcase
    end
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    dma_dbusy <= #0.1 1'b0;
  else begin
    if (push_cmd&(req_buf[66:64]==3'b001)&~sft_rst)
      dma_dbusy <= #0.1 1'b1;
    else if ((dma_dvld&dma_drdy&dma_last)|sft_rst)
      dma_dbusy <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    cpu_dbusy <= #0.1 1'b0;
  else begin
    if (push_cmd&(req_buf[66]|(req_buf[66:64]==3'b010))&~sft_rst)
      cpu_dbusy <= #0.1 1'b1;
    else if ((inc_bcnt&~cpus_wbe_st)|sft_rst)
      cpu_dbusy <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    cpu_cbusy <= #0.1 1'b0;
  else begin
    if (push_cmd&(req_buf[66]|(req_buf[66:64]==3'b010))&~sft_rst)
      cpu_cbusy <= #0.1 1'b1;
    else if ((cpu_rd_sel&cpum_clast)|(~cpu_rd_sel&cpus_clast)|sft_rst)
      cpu_cbusy <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    cpu_rd_sel <= #0.1 1'b0;
  else begin
    if (push_cmd)
      cpu_rd_sel <= #0.1 ~req_buf[66];
  end
end

assign drd_last = (inc_bcnt&~cpus_wbe_st) | (dma_dbusy&dma_dvld&dma_drdy&dma_last)
                | (push_cmd & ~req_buf[66] & ~(req_buf[64]^req_buf[65]));
always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    drd_last_r <= #0.1 1'b0;
  else begin
    if (drd_last&~sft_rst)
      drd_last_r <= #0.1 1'b1;
    else if ((drd_last_r&(((~(|data_bcnt[4:3])|(data_bcnt[4:0]==4'h8))&(~afifo_wr|~afifo_full))|tx_arb_cs[2]))|sft_rst)
      drd_last_r <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    cpu_rd_d <= #0.1 2'h0;
  else
    if (sft_rst)
      cpu_rd_d <= #0.1 2'h0;
    else
      cpu_rd_d <= #0.1 {cpu_rd_d[0], ~(cpus_ren&cpum_ren)};
end

assign inc_dcnt0 = ~(cpum_ren & cpus_ren);
assign dec_dcnt0 = (inc_bcnt&~cpus_wbe_st) | (inc_bcnt8&~dma_dbusy);//wr_dbuf & ~cpus_wbe_st & (cpu_dcnt0[1:0]!=2'h0);
always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    cpu_dcnt0 <= #0.1 3'h0;
  else begin
    if (sft_rst)
      cpu_dcnt0 <= #0.1 3'h0;
    else begin
      case ({inc_dcnt0, dec_dcnt0})
        2'b01  : cpu_dcnt0 <= #0.1 cpu_dcnt0[1:0] - 1'b1;
        2'b10  : cpu_dcnt0 <= #0.1 cpu_dcnt0[1:0] + 1'b1;
        default: ;
      endcase
    end
  end
end

assign inc_dcnt1 = cpu_rd_d[1] & (~(wr_dbuf&~cpus_wbe_st)|(cpu_dcnt1[1:0]!=2'h0));
assign dec_dcnt1 = wr_dbuf & (cpu_dcnt1[1:0]!=2'h0) & ~cpus_wbe_st;
always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    cpu_dcnt1 <= #0.1 3'h0;
  else begin
    if (sft_rst)
      cpu_dcnt1 <= #0.1 3'h0;
    else begin
      case ({inc_dcnt1, dec_dcnt1})
        2'b01  : cpu_dcnt1 <= #0.1 cpu_dcnt1[1:0] - 1'b1;
        2'b10  : cpu_dcnt1 <= #0.1 cpu_dcnt1[1:0] + 1'b1;
        default: ;
      endcase
    end
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn) begin
    cpu_dbuf0 <= #0.1 68'h0;
    cpu_dbuf1 <= #0.1 68'h0;
    cpu_dbuf2 <= #0.1 68'h0;
  end else begin
    if (inc_dcnt1) begin
      case (cpu_dcnt1[1:0])
        2'h0: cpu_dbuf0 <= #0.1 cpu_rd_sel ? {cpum_last, cpum_data} : {cpus_last, cpus_data};
        2'h1: begin
          if (dec_dcnt1)
            cpu_dbuf0 <= #0.1 cpu_rd_sel ? {cpum_last, cpum_data} : {cpus_last, cpus_data};
          else
            cpu_dbuf1 <= #0.1 cpu_rd_sel ? {cpum_last, cpum_data} : {cpus_last, cpus_data};
        end
        2'h2: begin
          if (dec_dcnt1) begin
            cpu_dbuf0 <= #0.1 cpu_dbuf1;
            cpu_dbuf1 <= #0.1 cpu_rd_sel ? {cpum_last, cpum_data} : {cpus_last, cpus_data};
          end else
            cpu_dbuf2 <= #0.1 cpu_rd_sel ? {cpum_last, cpum_data} : {cpus_last, cpus_data};
        end
        default:;
      endcase
    end else if (dec_dcnt1) begin
      cpu_dbuf0 <= #0.1 cpu_dbuf1;
      cpu_dbuf1 <= #0.1 cpu_dbuf2;
    end
  end
end

always @ (*) begin
  if (cpus_wbe_st)
    dbuf_src = cpus_wbe_2nd ? cpus_wbe_w[127:64] : cpus_wbe_w[63:0];
  else if (cpu_dcnt1[1:0]!=2'h0)
    dbuf_src = cpu_dbuf0[63:0];
  else if (cpu_rd_d[1]&wr_dbuf&cpu_rd_sel)
    dbuf_src = cpum_data[63:0];
  else if (cpu_rd_d[1]&wr_dbuf)
    dbuf_src = cpus_data[63:0];
  else
    dbuf_src = dma_data[63:0];
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn) begin
    data_buf0  <= #0.1 8'h0;
    data_buf1  <= #0.1 8'h0;
    data_buf2  <= #0.1 8'h0;
    data_buf3  <= #0.1 8'h0;
    data_buf4  <= #0.1 8'h0;
    data_buf5  <= #0.1 8'h0;
    data_buf6  <= #0.1 8'h0;
    data_buf7  <= #0.1 8'h0;
    data_buf8  <= #0.1 8'h0;
    data_buf9  <= #0.1 8'h0;
    data_buf10 <= #0.1 8'h0;
    data_buf11 <= #0.1 8'h0;
    data_buf12 <= #0.1 8'h0;
    data_buf13 <= #0.1 8'h0;
    data_buf14 <= #0.1 8'h0;
    data_buf15 <= #0.1 8'h0;
  end else begin
    if (push_cmd) begin
      casez (req_buf[66:64])
        3'b1??: begin
          case (data_bcnt[2:0])
            3'h0: begin
              data_buf0 <= #0.1 {req_buf[43:40], 4'h6};
              data_buf1 <= #0.1 req_buf[65:58];
              data_buf2 <= #0.1 req_buf[51:44];
              data_buf3 <= #0.1 {1'b0, req_buf[57:55], 1'b0, req_buf[54:52]};
              data_buf4 <= #0.1 req_buf[7:0];
              data_buf5 <= #0.1 req_buf[15:8];
              data_buf6 <= #0.1 req_buf[23:16];
              data_buf7 <= #0.1 req_buf[31:24];
              data_buf8 <= #0.1 req_buf[39:32];
            end
            3'h1: begin
              if (data_bcnt[3]) begin
                data_buf0 <= #0.1 data_buf8;
              end
              data_buf1 <= #0.1 {req_buf[43:40], 4'h6};
              data_buf2 <= #0.1 req_buf[65:58];
              data_buf3 <= #0.1 req_buf[51:44];
              data_buf4 <= #0.1 {1'b0, req_buf[57:55], 1'b0, req_buf[54:52]};
              data_buf5 <= #0.1 req_buf[7:0];
              data_buf6 <= #0.1 req_buf[15:8];
              data_buf7 <= #0.1 req_buf[23:16];
              data_buf8 <= #0.1 req_buf[31:24];
              data_buf9 <= #0.1 req_buf[39:32];
            end
            3'h2: begin
              if (data_bcnt[3]) begin
                data_buf0  <= #0.1 data_buf8;
                data_buf1  <= #0.1 data_buf9;
              end
              data_buf2  <= #0.1 {req_buf[43:40], 4'h6};
              data_buf3  <= #0.1 req_buf[65:58];
              data_buf4  <= #0.1 req_buf[51:44];
              data_buf5  <= #0.1 {1'b0, req_buf[57:55], 1'b0, req_buf[54:52]};
              data_buf6  <= #0.1 req_buf[7:0];
              data_buf7  <= #0.1 req_buf[15:8];
              data_buf8  <= #0.1 req_buf[23:16];
              data_buf9  <= #0.1 req_buf[31:24];
              data_buf10 <= #0.1 req_buf[39:32];
            end
            3'h3: begin
              if (data_bcnt[3]) begin
                data_buf0  <= #0.1 data_buf8;
                data_buf1  <= #0.1 data_buf9;
                data_buf2  <= #0.1 data_buf10;
              end
              data_buf3  <= #0.1 {req_buf[43:40], 4'h6};
              data_buf4  <= #0.1 req_buf[65:58];
              data_buf5  <= #0.1 req_buf[51:44];
              data_buf6  <= #0.1 {1'b0, req_buf[57:55], 1'b0, req_buf[54:52]};
              data_buf7  <= #0.1 req_buf[7:0];
              data_buf8  <= #0.1 req_buf[15:8];
              data_buf9  <= #0.1 req_buf[23:16];
              data_buf10 <= #0.1 req_buf[31:24];
              data_buf11 <= #0.1 req_buf[39:32];
            end
            3'h4: begin
              if (data_bcnt[3]) begin
                data_buf0  <= #0.1 data_buf8;
                data_buf1  <= #0.1 data_buf9;
                data_buf2  <= #0.1 data_buf10;
                data_buf3  <= #0.1 data_buf11;
              end
              data_buf4  <= #0.1 {req_buf[43:40], 4'h6};
              data_buf5  <= #0.1 req_buf[65:58];
              data_buf6  <= #0.1 req_buf[51:44];
              data_buf7  <= #0.1 {1'b0, req_buf[57:55], 1'b0, req_buf[54:52]};
              data_buf8  <= #0.1 req_buf[7:0];
              data_buf9  <= #0.1 req_buf[15:8];
              data_buf10 <= #0.1 req_buf[23:16];
              data_buf11 <= #0.1 req_buf[31:24];
              data_buf12 <= #0.1 req_buf[39:32];
            end
            3'h5: begin
              if (data_bcnt[3]) begin
                data_buf0  <= #0.1 data_buf8;
                data_buf1  <= #0.1 data_buf9;
                data_buf2  <= #0.1 data_buf10;
                data_buf3  <= #0.1 data_buf11;
                data_buf4  <= #0.1 data_buf12;
              end
              data_buf5  <= #0.1 {req_buf[43:40], 4'h6};
              data_buf6  <= #0.1 req_buf[65:58];
              data_buf7  <= #0.1 req_buf[51:44];
              data_buf8  <= #0.1 {1'b0, req_buf[57:55], 1'b0, req_buf[54:52]};
              data_buf9  <= #0.1 req_buf[7:0];
              data_buf10 <= #0.1 req_buf[15:8];
              data_buf11 <= #0.1 req_buf[23:16];
              data_buf12 <= #0.1 req_buf[31:24];
              data_buf13 <= #0.1 req_buf[39:32];
            end
            3'h6: begin
              if (data_bcnt[3]) begin
                data_buf0  <= #0.1 data_buf8;
                data_buf1  <= #0.1 data_buf9;
                data_buf2  <= #0.1 data_buf10;
                data_buf3  <= #0.1 data_buf11;
                data_buf4  <= #0.1 data_buf12;
                data_buf5  <= #0.1 data_buf13;
              end
              data_buf6  <= #0.1 {req_buf[43:40], 4'h6};
              data_buf7  <= #0.1 req_buf[65:58];
              data_buf8  <= #0.1 req_buf[51:44];
              data_buf9  <= #0.1 {1'b0, req_buf[57:55], 1'b0, req_buf[54:52]};
              data_buf10 <= #0.1 req_buf[7:0];
              data_buf11 <= #0.1 req_buf[15:8];
              data_buf12 <= #0.1 req_buf[23:16];
              data_buf13 <= #0.1 req_buf[31:24];
              data_buf14 <= #0.1 req_buf[39:32];
            end
            default: begin
              if (data_bcnt[3]) begin
                data_buf0  <= #0.1 data_buf8;
                data_buf1  <= #0.1 data_buf9;
                data_buf2  <= #0.1 data_buf10;
                data_buf3  <= #0.1 data_buf11;
                data_buf4  <= #0.1 data_buf12;
                data_buf5  <= #0.1 data_buf13;
                data_buf6  <= #0.1 data_buf14;
              end
              data_buf7  <= #0.1 {req_buf[43:40], 4'h6};
              data_buf8  <= #0.1 req_buf[65:58];
              data_buf9  <= #0.1 req_buf[51:44];
              data_buf10 <= #0.1 {1'b0, req_buf[57:55], 1'b0, req_buf[54:52]};
              data_buf11 <= #0.1 req_buf[7:0];
              data_buf12 <= #0.1 req_buf[15:8];
              data_buf13 <= #0.1 req_buf[23:16];
              data_buf14 <= #0.1 req_buf[31:24];
              data_buf15 <= #0.1 req_buf[39:32];
            end
          endcase
        end
        3'b010: begin
          case (data_bcnt[2:0])
            3'h0: begin
              data_buf0 <= #0.1 {2'h0, req_buf[17:16], 4'h5};
              data_buf1 <= #0.1 req_buf[7:0];
              data_buf2 <= #0.1 req_buf[15:8];
            end
            3'h1: begin
              if (data_bcnt[3]) begin
                data_buf0 <= #0.1 data_buf8;
              end
              data_buf1 <= #0.1 {2'h0, req_buf[17:16], 4'h5};
              data_buf2 <= #0.1 req_buf[7:0];
              data_buf3 <= #0.1 req_buf[15:8];
            end
            3'h2: begin
              if (data_bcnt[3]) begin
                data_buf0 <= #0.1 data_buf8;
                data_buf1 <= #0.1 data_buf9;
              end
              data_buf2 <= #0.1 {2'h0, req_buf[17:16], 4'h5};
              data_buf3 <= #0.1 req_buf[7:0];
              data_buf4 <= #0.1 req_buf[15:8];
            end
            3'h3: begin
              if (data_bcnt[3]) begin
                data_buf0 <= #0.1 data_buf8;
                data_buf1 <= #0.1 data_buf9;
                data_buf2 <= #0.1 data_buf10;
              end
              data_buf3 <= #0.1 {2'h0, req_buf[17:16], 4'h5};
              data_buf4 <= #0.1 req_buf[7:0];
              data_buf5 <= #0.1 req_buf[15:8];
            end
            3'h4: begin
              if (data_bcnt[3]) begin
                data_buf0 <= #0.1 data_buf8;
                data_buf1 <= #0.1 data_buf9;
                data_buf2 <= #0.1 data_buf10;
                data_buf3 <= #0.1 data_buf11;
              end
              data_buf4 <= #0.1 {2'h0, req_buf[17:16], 4'h5};
              data_buf5 <= #0.1 req_buf[7:0];
              data_buf6 <= #0.1 req_buf[15:8];
            end
            3'h5: begin
              if (data_bcnt[3]) begin
                data_buf0 <= #0.1 data_buf8;
                data_buf1 <= #0.1 data_buf9;
                data_buf2 <= #0.1 data_buf10;
                data_buf3 <= #0.1 data_buf11;
                data_buf4 <= #0.1 data_buf12;
              end
              data_buf5 <= #0.1 {2'h0, req_buf[17:16], 4'h5};
              data_buf6 <= #0.1 req_buf[7:0];
              data_buf7 <= #0.1 req_buf[15:8];
            end
            3'h6: begin
              if (data_bcnt[3]) begin
                data_buf0 <= #0.1 data_buf8;
                data_buf1 <= #0.1 data_buf9;
                data_buf2 <= #0.1 data_buf10;
                data_buf3 <= #0.1 data_buf11;
                data_buf4 <= #0.1 data_buf12;
                data_buf5 <= #0.1 data_buf13;
              end
              data_buf6 <= #0.1 {2'h0, req_buf[17:16], 4'h5};
              data_buf7 <= #0.1 req_buf[7:0];
              data_buf8 <= #0.1 req_buf[15:8];
            end
            default: begin
              if (data_bcnt[3]) begin
                data_buf0 <= #0.1 data_buf8;
                data_buf1 <= #0.1 data_buf9;
                data_buf2 <= #0.1 data_buf10;
                data_buf3 <= #0.1 data_buf11;
                data_buf4 <= #0.1 data_buf12;
                data_buf5 <= #0.1 data_buf13;
                data_buf6 <= #0.1 data_buf14;
              end
              data_buf7 <= #0.1 {2'h0, req_buf[17:16], 4'h5};
              data_buf8 <= #0.1 req_buf[7:0];
              data_buf9 <= #0.1 req_buf[15:8];
            end
          endcase
        end
        3'b000: begin
          case (data_bcnt[2:0])
            3'h0: begin
              data_buf0 <= #0.1 {req_buf[43:40],4'h4};
              data_buf1 <= #0.1 req_buf[39:32];
              data_buf2 <= #0.1 req_buf[51:44];
              data_buf3 <= #0.1 {1'b0, req_buf[57:55], 1'b0, req_buf[54:52]};
              data_buf4 <= #0.1 req_buf[7:0];
              data_buf5 <= #0.1 req_buf[15:8];
              data_buf6 <= #0.1 req_buf[23:16];
              data_buf7 <= #0.1 req_buf[31:24];
            end
            3'h1: begin
              if (data_bcnt[3]) begin
                data_buf0 <= #0.1 data_buf8;
              end
              data_buf1 <= #0.1 {req_buf[43:40], 4'h4};
              data_buf2 <= #0.1 req_buf[39:32];
              data_buf3 <= #0.1 req_buf[51:44];
              data_buf4 <= #0.1 {1'b0, req_buf[57:55], 1'b0, req_buf[54:52]};
              data_buf5 <= #0.1 req_buf[7:0];
              data_buf6 <= #0.1 req_buf[15:8];
              data_buf7 <= #0.1 req_buf[23:16];
              data_buf8 <= #0.1 req_buf[31:24];
            end
            3'h2: begin
              if (data_bcnt[3]) begin
                data_buf0 <= #0.1 data_buf8;
                data_buf1 <= #0.1 data_buf9;
              end
              data_buf2 <= #0.1 {req_buf[43:40], 4'h4};
              data_buf3 <= #0.1 req_buf[39:32];
              data_buf4 <= #0.1 req_buf[51:44];
              data_buf5 <= #0.1 {1'b0, req_buf[57:55], 1'b0, req_buf[54:52]};
              data_buf6 <= #0.1 req_buf[7:0];
              data_buf7 <= #0.1 req_buf[15:8];
              data_buf8 <= #0.1 req_buf[23:16];
              data_buf9 <= #0.1 req_buf[31:24];
            end
            3'h3: begin
              if (data_bcnt[3]) begin
                data_buf0  <= #0.1 data_buf8;
                data_buf1  <= #0.1 data_buf9;
                data_buf2  <= #0.1 data_buf10;
              end
              data_buf3  <= #0.1 {req_buf[43:40], 4'h4};
              data_buf4  <= #0.1 req_buf[39:32];
              data_buf5  <= #0.1 req_buf[51:44];
              data_buf6  <= #0.1 {1'b0, req_buf[57:55], 1'b0, req_buf[54:52]};
              data_buf7  <= #0.1 req_buf[7:0];
              data_buf8  <= #0.1 req_buf[15:8];
              data_buf9  <= #0.1 req_buf[23:16];
              data_buf10 <= #0.1 req_buf[31:24];
            end
            3'h4: begin
              if (data_bcnt[3]) begin
                data_buf0  <= #0.1 data_buf8;
                data_buf1  <= #0.1 data_buf9;
                data_buf2  <= #0.1 data_buf10;
                data_buf3  <= #0.1 data_buf11;
              end
              data_buf4  <= #0.1 {req_buf[43:40], 4'h4};
              data_buf5  <= #0.1 req_buf[39:32];
              data_buf6  <= #0.1 req_buf[51:44];
              data_buf7  <= #0.1 {1'b0, req_buf[57:55], 1'b0, req_buf[54:52]};
              data_buf8  <= #0.1 req_buf[7:0];
              data_buf9  <= #0.1 req_buf[15:8];
              data_buf10 <= #0.1 req_buf[23:16];
              data_buf11 <= #0.1 req_buf[31:24];
            end
            3'h5: begin
              if (data_bcnt[3]) begin
                data_buf0  <= #0.1 data_buf8;
                data_buf1  <= #0.1 data_buf9;
                data_buf2  <= #0.1 data_buf10;
                data_buf3  <= #0.1 data_buf11;
                data_buf4  <= #0.1 data_buf12;
              end
              data_buf5  <= #0.1 {req_buf[43:40], 4'h4};
              data_buf6  <= #0.1 req_buf[39:32];
              data_buf7  <= #0.1 req_buf[51:44];
              data_buf8  <= #0.1 {1'b0, req_buf[57:55], 1'b0, req_buf[54:52]};
              data_buf9  <= #0.1 req_buf[7:0];
              data_buf10 <= #0.1 req_buf[15:8];
              data_buf11 <= #0.1 req_buf[23:16];
              data_buf12 <= #0.1 req_buf[31:24];
            end
            3'h6: begin
              if (data_bcnt[3]) begin
                data_buf0  <= #0.1 data_buf8;
                data_buf1  <= #0.1 data_buf9;
                data_buf2  <= #0.1 data_buf10;
                data_buf3  <= #0.1 data_buf11;
                data_buf4  <= #0.1 data_buf12;
                data_buf5  <= #0.1 data_buf13;
              end
              data_buf6  <= #0.1 {req_buf[43:40], 4'h4};
              data_buf7  <= #0.1 req_buf[39:32];
              data_buf8  <= #0.1 req_buf[51:44];
              data_buf9  <= #0.1 {1'b0, req_buf[57:55], 1'b0, req_buf[54:52]};
              data_buf10 <= #0.1 req_buf[7:0];
              data_buf11 <= #0.1 req_buf[15:8];
              data_buf12 <= #0.1 req_buf[23:16];
              data_buf13 <= #0.1 req_buf[31:24];
            end
            default: begin
              if (data_bcnt[3]) begin
                data_buf0  <= #0.1 data_buf8;
                data_buf1  <= #0.1 data_buf9;
                data_buf2  <= #0.1 data_buf10;
                data_buf3  <= #0.1 data_buf11;
                data_buf4  <= #0.1 data_buf12;
                data_buf5  <= #0.1 data_buf13;
                data_buf6  <= #0.1 data_buf14;
              end
              data_buf7  <= #0.1 {req_buf[43:40], 4'h4};
              data_buf8  <= #0.1 req_buf[39:32];
              data_buf9  <= #0.1 req_buf[51:44];
              data_buf10 <= #0.1 {1'b0, req_buf[57:55], 1'b0, req_buf[54:52]};
              data_buf11 <= #0.1 req_buf[7:0];
              data_buf12 <= #0.1 req_buf[15:8];
              data_buf13 <= #0.1 req_buf[23:16];
              data_buf14 <= #0.1 req_buf[31:24];
            end
          endcase
        end
        default: begin
          case (data_bcnt[2:0])
            3'h0: begin
              data_buf0 <= #0.1 {1'b0, req_buf[10:8], (req_buf[65] ? 4'h7 : 4'h1)};
              data_buf1 <= #0.1 req_buf[7:0];
            end
            3'h1: begin
              if (data_bcnt[3]) begin
                data_buf0 <= #0.1 data_buf8;
              end
              data_buf1 <= #0.1 {1'b0, req_buf[10:8], (req_buf[65] ? 4'h7 : 4'h1)};
              data_buf2 <= #0.1 req_buf[7:0];
            end
            3'h2: begin
              if (data_bcnt[3]) begin
                data_buf0 <= #0.1 data_buf8;
                data_buf1 <= #0.1 data_buf9;
              end
              data_buf2 <= #0.1 {1'b0, req_buf[10:8], (req_buf[65] ? 4'h7 : 4'h1)};
              data_buf3 <= #0.1 req_buf[7:0];
            end
            3'h3: begin
              if (data_bcnt[3]) begin
                data_buf0 <= #0.1 data_buf8;
                data_buf1 <= #0.1 data_buf9;
                data_buf2 <= #0.1 data_buf10;
              end
              data_buf3 <= #0.1 {1'b0, req_buf[10:8], (req_buf[65] ? 4'h7 : 4'h1)};
              data_buf4 <= #0.1 req_buf[7:0];
            end
            3'h4: begin
              if (data_bcnt[3]) begin
                data_buf0 <= #0.1 data_buf8;
                data_buf1 <= #0.1 data_buf9;
                data_buf2 <= #0.1 data_buf10;
                data_buf3 <= #0.1 data_buf11;
              end
              data_buf4 <= #0.1 {1'b0, req_buf[10:8], (req_buf[65] ? 4'h7 : 4'h1)};
              data_buf5 <= #0.1 req_buf[7:0];
            end
            3'h5: begin
              if (data_bcnt[3]) begin
                data_buf0 <= #0.1 data_buf8;
                data_buf1 <= #0.1 data_buf9;
                data_buf2 <= #0.1 data_buf10;
                data_buf3 <= #0.1 data_buf11;
                data_buf4 <= #0.1 data_buf12;
              end
              data_buf5 <= #0.1 {1'b0, req_buf[10:8], (req_buf[65] ? 4'h7 : 4'h1)};
              data_buf6 <= #0.1 req_buf[7:0];
            end
            3'h6: begin
              if (data_bcnt[3]) begin
                data_buf0 <= #0.1 data_buf8;
                data_buf1 <= #0.1 data_buf9;
                data_buf2 <= #0.1 data_buf10;
                data_buf3 <= #0.1 data_buf11;
                data_buf4 <= #0.1 data_buf12;
                data_buf5 <= #0.1 data_buf13;
              end
              data_buf6 <= #0.1 {1'b0, req_buf[10:8], (req_buf[65] ? 4'h7 : 4'h1)};
              data_buf7 <= #0.1 req_buf[7:0];
            end
            default: begin
              if (data_bcnt[3]) begin
                data_buf0 <= #0.1 data_buf8;
                data_buf1 <= #0.1 data_buf9;
                data_buf2 <= #0.1 data_buf10;
                data_buf3 <= #0.1 data_buf11;
                data_buf4 <= #0.1 data_buf12;
                data_buf5 <= #0.1 data_buf13;
                data_buf6 <= #0.1 data_buf14;
              end
              data_buf7 <= #0.1 {1'b0, req_buf[10:8], (req_buf[65] ? 4'h7 : 4'h1)};
              data_buf8 <= #0.1 req_buf[7:0];
            end
          endcase
        end
      endcase
    end else if (inc_bcnt8|inc_bcnt) begin
      case (data_bcnt[2:0])
        3'h0: begin
          data_buf0 <= #0.1 dbuf_src[7:0];
          data_buf1 <= #0.1 dbuf_src[15:8];
          data_buf2 <= #0.1 dbuf_src[23:16];
          data_buf3 <= #0.1 dbuf_src[31:24];
          data_buf4 <= #0.1 dbuf_src[39:32];
          data_buf5 <= #0.1 dbuf_src[47:40];
          data_buf6 <= #0.1 dbuf_src[55:48];
          data_buf7 <= #0.1 dbuf_src[63:56];
        end
        3'h1: begin
          if (rd_dbuf) begin
            data_buf0 <= #0.1 data_buf8;
          end
          data_buf1 <= #0.1 dbuf_src[7:0];
          data_buf2 <= #0.1 dbuf_src[15:8];
          data_buf3 <= #0.1 dbuf_src[23:16];
          data_buf4 <= #0.1 dbuf_src[31:24];
          data_buf5 <= #0.1 dbuf_src[39:32];
          data_buf6 <= #0.1 dbuf_src[47:40];
          data_buf7 <= #0.1 dbuf_src[55:48];
          data_buf8 <= #0.1 dbuf_src[63:56];
        end
        3'h2: begin
          if (rd_dbuf) begin
            data_buf0 <= #0.1 data_buf8;
            data_buf1 <= #0.1 data_buf9;
          end
          data_buf2 <= #0.1 dbuf_src[7:0];
          data_buf3 <= #0.1 dbuf_src[15:8];
          data_buf4 <= #0.1 dbuf_src[23:16];
          data_buf5 <= #0.1 dbuf_src[31:24];
          data_buf6 <= #0.1 dbuf_src[39:32];
          data_buf7 <= #0.1 dbuf_src[47:40];
          data_buf8 <= #0.1 dbuf_src[55:48];
          data_buf9 <= #0.1 dbuf_src[63:56];
        end
        3'h3: begin
          if (rd_dbuf) begin
            data_buf0  <= #0.1 data_buf8;
            data_buf1  <= #0.1 data_buf9;
            data_buf2  <= #0.1 data_buf10;
          end
          data_buf3  <= #0.1 dbuf_src[7:0];
          data_buf4  <= #0.1 dbuf_src[15:8];
          data_buf5  <= #0.1 dbuf_src[23:16];
          data_buf6  <= #0.1 dbuf_src[31:24];
          data_buf7  <= #0.1 dbuf_src[39:32];
          data_buf8  <= #0.1 dbuf_src[47:40];
          data_buf9  <= #0.1 dbuf_src[55:48];
          data_buf10 <= #0.1 dbuf_src[63:56];
        end
        3'h4: begin
          if (rd_dbuf) begin
            data_buf0  <= #0.1 data_buf8;
            data_buf1  <= #0.1 data_buf9;
            data_buf2  <= #0.1 data_buf10;
            data_buf3  <= #0.1 data_buf11;
          end
          data_buf4  <= #0.1 dbuf_src[7:0];
          data_buf5  <= #0.1 dbuf_src[15:8];
          data_buf6  <= #0.1 dbuf_src[23:16];
          data_buf7  <= #0.1 dbuf_src[31:24];
          data_buf8  <= #0.1 dbuf_src[39:32];
          data_buf9  <= #0.1 dbuf_src[47:40];
          data_buf10 <= #0.1 dbuf_src[55:48];
          data_buf11 <= #0.1 dbuf_src[63:56];
        end
        3'h5: begin
          if (rd_dbuf) begin
            data_buf0  <= #0.1 data_buf8;
            data_buf1  <= #0.1 data_buf9;
            data_buf2  <= #0.1 data_buf10;
            data_buf3  <= #0.1 data_buf11;
            data_buf4  <= #0.1 data_buf12;
          end
          data_buf5  <= #0.1 dbuf_src[7:0];
          data_buf6  <= #0.1 dbuf_src[15:8];
          data_buf7  <= #0.1 dbuf_src[23:16];
          data_buf8  <= #0.1 dbuf_src[31:24];
          data_buf9  <= #0.1 dbuf_src[39:32];
          data_buf10 <= #0.1 dbuf_src[47:40];
          data_buf11 <= #0.1 dbuf_src[55:48];
          data_buf12 <= #0.1 dbuf_src[63:56];
        end
        3'h6: begin
          if (rd_dbuf) begin
            data_buf0  <= #0.1 data_buf8;
            data_buf1  <= #0.1 data_buf9;
            data_buf2  <= #0.1 data_buf10;
            data_buf3  <= #0.1 data_buf11;
            data_buf4  <= #0.1 data_buf12;
            data_buf5  <= #0.1 data_buf13;
          end
          data_buf6  <= #0.1 dbuf_src[7:0];
          data_buf7  <= #0.1 dbuf_src[15:8];
          data_buf8  <= #0.1 dbuf_src[23:16];
          data_buf9  <= #0.1 dbuf_src[31:24];
          data_buf10 <= #0.1 dbuf_src[39:32];
          data_buf11 <= #0.1 dbuf_src[47:40];
          data_buf12 <= #0.1 dbuf_src[55:48];
          data_buf13 <= #0.1 dbuf_src[63:56];
        end
        default: begin
          if (rd_dbuf) begin
            data_buf0  <= #0.1 data_buf8;
            data_buf1  <= #0.1 data_buf9;
            data_buf2  <= #0.1 data_buf10;
            data_buf3  <= #0.1 data_buf11;
            data_buf4  <= #0.1 data_buf12;
            data_buf5  <= #0.1 data_buf13;
            data_buf6  <= #0.1 data_buf14;
          end
          data_buf7  <= #0.1 dbuf_src[7:0];
          data_buf8  <= #0.1 dbuf_src[15:8];
          data_buf9  <= #0.1 dbuf_src[23:16];
          data_buf10 <= #0.1 dbuf_src[31:24];
          data_buf11 <= #0.1 dbuf_src[39:32];
          data_buf12 <= #0.1 dbuf_src[47:40];
          data_buf13 <= #0.1 dbuf_src[55:48];
          data_buf14 <= #0.1 dbuf_src[63:56];
        end
      endcase
    end else if (rd_dbuf) begin
      data_buf0 <= #0.1 data_buf8;
      data_buf1 <= #0.1 data_buf9;
      data_buf2 <= #0.1 data_buf10;
      data_buf3 <= #0.1 data_buf11;
      data_buf4 <= #0.1 data_buf12;
      data_buf5 <= #0.1 data_buf13;
      data_buf6 <= #0.1 data_buf14;
      data_buf7 <= #0.1 data_buf15;
    end
  end
end

//******************************************************************************
assign dma_drdy = dma_dbusy&wr_dbuf;

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    cpum_ack <= #0.1 1'b0;
  else begin
    //if (cpum_req & (~req_pend|(req_pend&push_cmd)) & ((cpu_fsel&~cpus_req)|~cpu_fsel) & ~cpum_ack & ~(cpus_req&cpus_ack))
    if (((tx_arb_cs!=tx_arb_ns)|push_cmd)&(tx_arb_ns==M0_BUSY))
      cpum_ack <= #0.1 1'b1;
    else
      cpum_ack <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    cpum_ren <= #0.1 1'b1;
  else begin
    if ((~cpum_ren&(cpu_dcnt0[1:0]==2'h2)&~wr_dbuf)|cpum_clast|sft_rst)
      cpum_ren <= #0.1 1'b1;
    else if (((push_cmd&(req_buf[66:64]==3'b010))|(cpu_cbusy&cpu_rd_sel))
      & (~cpu_dcnt0[1]|(cpu_dcnt0[1]&wr_dbuf)))
      cpum_ren <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    cpus_ack <= #0.1 1'b0;
  else begin
    //if (cpus_req & (~req_pend|(req_pend&push_cmd)) & ((~cpu_fsel&~cpum_req)|cpu_fsel) & ~cpus_ack & ~(cpum_req&cpum_ack))
    if (((tx_arb_cs!=tx_arb_ns)|push_cmd)&(tx_arb_ns==M1_BUSY))
      cpus_ack <= #0.1 1'b1;
    else
      cpus_ack <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    cpus_ren <= #0.1 1'b1;
  else begin
    if ((~cpus_ren&(cpu_dcnt0[1:0]==2'h2)&~(wr_dbuf&~cpus_wbe_st))|cpus_clast|sft_rst)
      cpus_ren <= #0.1 1'b1;
    else if (((push_cmd&req_buf[66])|(cpu_cbusy&~cpu_rd_sel))
      & (~cpu_dcnt0[1]|(cpu_dcnt0[1]&wr_dbuf&~cpus_wbe_st)))
      cpus_ren <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    dma_ack <= #0.1 1'b0;
  else begin
    //if (dma_req & (~req_pend|(req_pend&push_cmd)) & ~cpus_req & ~cpum_req & ~dma_ack)
    if (((tx_arb_cs!=tx_arb_ns)|push_cmd)&(tx_arb_ns==M2_BUSY))
      dma_ack <= #0.1 1'b1;
    else
      dma_ack <= #0.1 1'b0;
  end
end

assign set_afifo_wr = rd_dbuf|(drd_last_r&(~(|data_bcnt[4:3]) | (data_bcnt[4:0]==4'h8))&~tx_arb_cs[2])
                    | (btchk_req_r&stest_rdy&(~afifo_wr|~afifo_full))|(btchk_req_r1&(~afifo_wr|~afifo_full))
                    | stest_req | btchk_req1;
always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    afifo_wr <= #0.1 1'b0;
  else begin
    if (set_afifo_wr&~sft_rst)
      afifo_wr <= #0.1 1'b1;
    else if ((afifo_wr&~afifo_full)|sft_rst)
      afifo_wr <= #0.1 1'b0;
  end
end

assign wdata_s = {data_buf7, data_buf6, data_buf5, data_buf4, data_buf3, data_buf2, data_buf1, data_buf0};
always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    afifo_wdata <= #0.1 72'h0;
  else begin
    if (btchk_req_r&stest_rdy&(~afifo_wr|~afifo_full))
      afifo_wdata <= #0.1 72'h0;
    else if (btchk_req_r1&(~afifo_wr|~afifo_full))
      afifo_wdata <= #0.1 {8'h3, 48'h0, 8'hF1, 8'h0E};
    else if (stest_req)
      afifo_wdata <= #0.1 {8'h3, 48'h0, 8'hF0, 8'h0F};
    else if (btchk_req1)
      afifo_wdata <= #0.1 rx_fail ? {8'h3, 48'h0, 8'hD1, 8'h2E} : {8'h3, 48'h0, 8'hE1, 8'h1E};
    else if (rd_dbuf|(drd_last_r&(data_bcnt[4:0]==4'h8)&(~afifo_wr|~afifo_full)))
      afifo_wdata <= #0.1 {8'hFF, wdata_s};
    else if (drd_last_r & ~(|data_bcnt[4:3]) & (~afifo_wr|~afifo_full)) begin
      case (data_bcnt[2:0])
        3'h7   : afifo_wdata <= #0.1 {8'h7F, 8'h0,  wdata_s[55:0]};
        3'h6   : afifo_wdata <= #0.1 {8'h3F, 16'h0, wdata_s[47:0]};
        3'h5   : afifo_wdata <= #0.1 {8'h1F, 24'h0, wdata_s[39:0]};
        3'h4   : afifo_wdata <= #0.1 {8'h0F, 32'h0, wdata_s[31:0]};
        3'h3   : afifo_wdata <= #0.1 {8'h07, 40'h0, wdata_s[23:0]};
        3'h2   : afifo_wdata <= #0.1 {8'h03, 48'h0, wdata_s[15:0]};
        3'h1   : afifo_wdata <= #0.1 {8'h01, 56'h0, wdata_s[7:0]};
        default:;
      endcase
    end
  end
end
//******************************************************************************

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    stest_rdy <= #0.1 1'b0;
  else begin
    if (stest_run&~cpu_dbusy&~dma_dbusy&(data_bcnt[4:0]==5'h0)&~tx_arb_cs[2])
      stest_rdy <= #0.1 1'b1;
    else if (stest_rdy&~stest_run)
      stest_rdy <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    btchk_req_r <= #0.1 1'b0;
  else begin
    if (btchk_req)
      btchk_req_r <= #0.1 1'b1;
    else if (btchk_req_r&stest_rdy&(~afifo_wr|~afifo_full))
      btchk_req_r <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    btchk_req_r1 <= #0.1 1'b0;
  else begin
    if (btchk_req_r&stest_rdy&(~afifo_wr|~afifo_full))
      btchk_req_r1 <= #0.1 1'b1;
    else if (btchk_req_r1&(~afifo_wr|~afifo_full))
      btchk_req_r1 <= #0.1 1'b0;
  end
end
endmodule
//==============================================================================
//
//    This confidential and proprietary hardware may be used only as
//  authorized by a licensing agreement from
//                    SunMedia Technology Co., LTD.
//
//  In the event of publication, the following notice is applicable:
//
//            COPYRIGHT 2017, SunMedia Technology Co., LTD.
//                        ALL RIGHTS RESERVED
//
//  The entire notice above must be reproduced on all authorized copies.
//
//==============================================================================
//
//  File        : f_bio_tx_ctrl.v
//  Author      : kun.zhang
//  Date        : 28/Nov/2017
//  Version     : 1.1
//  Abstract    : This module is the transmitter block for BIO control. It reads
//                data from AFIFO (CDC) and transmit it to soft-pad for
//                transfers. Including a 32x64 S1P memory to make sure that
//                valid is always high during a packet.
//
//  Modification History:
//  Date          By            Version         Change Description
//------------------------------------------------------------------------------
//  14/Feb/2017   kun.zhang      1.0            Original
//  28/Nov/2017   kun.zhang      1.1            Remove S1P memory, send tx data
//                                              ASAP.
//
//
//==============================================================================



module f_bio_tx_ctrl (
  input  wire        tx_clk,     // clock
  input  wire        tx_rstn,    // reset
  //input  wire [31:0] st_reg_adr, // Self-test register address

  output reg  [31:0] tx_data,   // Transfer data to soft-pad, if SDR mode only bit 15:0 is valid
  output reg  [1:0]  tx_vld,    // Transfer valid
  input  wire        tx_rdy,    // Transfer ready from rx domain
  input  wire        rx_rdy_tx, // RX ready in TX domain
  output reg         rx_rdy,    // RX ready to PAD
  input  wire        ddr_en,    // DDR mode enable, 1'b0: SDR mode, 1'b1: DDR mode
  input  wire        en_16b,    // 16bit mode enable, 1'b0: 8bit mode, 1'b1: 16bit mode
  input  wire        rx_bt_s,   // RX receives bus-tuning start indicator
  input  wire        rx_fail,   // RX bus tunning failed
  output reg         tx_bt_s,   // TX transmit bus-tuning start indicator
  input  wire        btchk_done,// Bus tunning check done


    output wire       tx_done,  // TX DMA Packet finished
    output wire [2:0] tx_dch,   // TX DMA packet finished channel number
    input  wire       tx_dack,  // TX DMA packet finished ack to send


  output wire [10:0] tx_probe,  //

  output reg         afifo_rd,      // AFIFO read enable
  input  wire [71:0] afifo_rdata,   // AFIFO read data
  input  wire        afifo_empty    // AFIFO empty
);

parameter BTCHK_D0 = 64'h00FF_9A9A_CCAA_CCA8;
parameter BTCHK_D1 = 64'h9A9A_FF00_CC55_CCA8;

reg         tx_vld_r;   // Transmit valid running
reg         tx_rdy_r;   // TX ready signal latched for transmit enable check
wire        tx_rdy_l;   // TX ready signal for transmit enable check
wire        clr_tvld;   // Status to clear tx_vld
wire        set_rdvld;  // Status to set rd_vld

reg  [6:0]  tx_cnt;     // Transmit counter in 16bits
reg  [3:0]  tx_cnt1;    // Transmit counter for data control
reg  [55:0] data_buf;   // Data buffer for transmit
reg  [6:0]  tvld_buf;   // Valid buffer for transmit
wire        data_1b;    // Data in 1Byte mode (8bit SDR mode)
wire        data_2b;    // Data in 2Byte mode (8bit DDR mode or 16bit SDR mode)
wire        data_4b;    // Data in 4byte mode (16bit DDR mode)


  reg  [1:0]  tx_dvld;      // TX done valid for queue
  reg  [5:0]  tx_dbuf;      // TX done buffer for queue
  reg  [3:0]  tx_vld_d;     // TX valid delayed for data check
  reg  [31:0] tx_data_d;    // TX data delayed for data check
  reg         pkt_start;    // Indicates the current delayed data including command information
  wire        pkt_start_w;  //
  wire        pkt_start_w1;
  reg         pkt_start_d;  // Indicates the current delayed data including the packet length information
  reg         pkt_rcmd;     // Indicates the current command is a read command packet
  reg         pkt_2byte;    // Indicates the current command is a 2byte packet in SDR 8bit mode
  wire        msb_cmd;      // Indicates the MSB of current data is command ID
  wire        set_pstart;   // Status to set pkt_start
  wire        pkt_end;      // Indicates the packetr is ended
  reg  [3:0]  cmd_loc;      // The command location in current data
  wire [3:0]  cmd_mux;      // The command ID after select
  wire [7:0]  len_mux;      // The packet length after select
  reg  [8:0]  pkt_cnt;      // Packet counter for start check
  wire [8:0]  pkt_cnt_n;    // Packet counter next for addition
  reg  [2:0]  pcnt_dnum;    // packet counter decrease number
  wire        pkt_lrdata;   // The read data packet is a long packet
  wire        lpkt_wrsp0;   // The next packet is a long packet after write response
  wire        lpkt_wrsp1;   // The next packet is a long packet after write response
  wire        nxt_dma0;     // The next packet is a DMA pacekt
  wire        nxt_dma1;     // The next packet is a DMA pacekt
  wire        clr_pkts32;   // Status to clear packet start for 32bit
  wire        clr_pkts16;   // Status to clear packet start for 16bit
  reg         dma_pkt;      // Indicates the current packet is a DMA request
  reg  [2:0]  dma_ch;       // The current DMA transfer packet
  wire [2:0]  ch_mux;       // Channel number after select
  wire        set_tdone;    // Status to set tx done queue


reg         set_btchk;      // Set bus tunning to running state
reg         tx_bts_r;       // TX Bus tunning start latched
reg         bts_1byte;      // The Bus tunnign start only 1Byte information
reg         rx_bts_r;       // RX bus tunning start latched
wire        set_rbts;       // Set RX Bus tunning start
reg         btchk_run;      // Bus tunning running
reg [63:0]  btchk_data0;    // Bus tunning data0 for data
reg [63:0]  btchk_data1;    // Bus tunning data1 for data
reg [63:0]  btchk_data2;    // Bus tunning data2 for vld and rdy

assign tx_probe = 11'h0;//{tx_busy, buschk_run, btchk_run, tx_vld_q};
//==============================================================================
assign data_1b = ~ddr_en & ~en_16b;
assign data_2b = ddr_en ^ en_16b;
assign data_4b = ddr_en & en_16b;
assign rd_vld  = afifo_rd & ~afifo_empty;

assign tx_rdy_l = tx_rdy_r | tx_rdy;

always @ (posedge tx_clk or negedge tx_rstn) begin
  if (~tx_rstn)
    tx_rdy_r <= #0.1 1'b0;
  else begin
    tx_rdy_r <= #0.1 tx_rdy;
  end
end

always @ (posedge tx_clk or negedge tx_rstn) begin
  if (~tx_rstn)
    tx_cnt <= #0.1 7'h0;
  else begin
    if (set_btchk)
      tx_cnt <= #0.1 7'h3F;
    else if (btchk_run)
      tx_cnt <= #0.1 tx_cnt[5:0] - 1'b1;
  end
end

always @ (posedge tx_clk or negedge tx_rstn) begin
  if (~tx_rstn)
    tx_cnt1 <= #0.1 4'h0;
  else begin
    if (rd_vld)
      tx_cnt1 <= #0.1 4'h0;
    else if (tx_vld_r&~btchk_run)
      tx_cnt1 <= #0.1 tx_cnt1[2:0] + 1'b1;
  end
end

assign clr_tvld = (data_4b&tx_cnt1[0]) | (data_2b&(tx_cnt1[1:0]==2'h3))
                | (data_1b&(tx_cnt1[2:0]==3'h7)) | (tx_vld==2'b00);
always @ (posedge tx_clk or negedge tx_rstn) begin
  if (~tx_rstn)
    tx_vld_r <= #0.1 1'b0;
  else begin
    if (rd_vld)
      tx_vld_r <= #0.1 1'b1;
    else if (clr_tvld&tx_vld_r)
      tx_vld_r <= #0.1 1'b0;
  end
end

always @ (posedge tx_clk or negedge tx_rstn) begin
  if (~tx_rstn)
    tx_vld <= #0.1 2'b00;
  else begin
    if (set_btchk)
      tx_vld <= #0.1 2'b11;
    else if (btchk_run)
      tx_vld <= #0.1 {btchk_data0[1], btchk_data0[0]};
    else begin
      case ({ddr_en, en_16b})
        2'b11: begin
          if (rd_vld)
            tx_vld <= #0.1 {afifo_rdata[66], afifo_rdata[64]};
          else if (tx_vld_r)
            tx_vld <= #0.1 tvld_buf[1:0];
        end
        2'b10: begin
          if (rd_vld)
            tx_vld <= #0.1 afifo_rdata[65:64];
          else if (tx_vld_r)
            tx_vld <= #0.1 tvld_buf[1:0];
        end
        2'b01: begin
          if (rd_vld)
            tx_vld <= #0.1 {1'b0, afifo_rdata[64]};
          else if (tx_vld_r)
            tx_vld <= #0.1 {1'b0, tvld_buf[0]};
        end
        default: begin  // 2'b00
          if (rd_vld)
            tx_vld <= #0.1 {1'b0, afifo_rdata[64]};
          else if (tx_vld_r)
            tx_vld <= #0.1 {1'b0, tvld_buf[0]};
        end
      endcase
    end
  end
end

always @ (posedge tx_clk or negedge tx_rstn) begin
  if (~tx_rstn)
    tvld_buf <= #0.1 7'h0;
  else begin
    if (data_4b) begin// &rd_vld)
      if (rd_vld)
        tvld_buf[1:0] <= #0.1 {afifo_rdata[70], afifo_rdata[68]};
      else if (tx_vld_r)
        tvld_buf[1:0] <= #0.1 2'h0;
    end
    else if (data_2b) begin
      if (rd_vld)
        tvld_buf[5:0] <= #0.1 afifo_rdata[71:66];
      else if (tx_vld_r)
        tvld_buf <= #0.1 {3'h0, tvld_buf[5:2]};
    end else begin
      if (rd_vld)
        tvld_buf[6:0] <= #0.1 afifo_rdata[71:65];
      else if (tx_vld_r)
        tvld_buf <= #0.1 {1'b0, tvld_buf[6:1]};
    end
  end
end

always @ (posedge tx_clk or negedge tx_rstn) begin
  if (~tx_rstn)
    tx_data <= #0.1 32'h0;
  else begin
    if (btchk_run)
      tx_data <= #0.1 {{8{btchk_data1[1], btchk_data0[1]}}, {8{btchk_data1[0], btchk_data0[0]}}};
    else begin
      case ({ddr_en, en_16b})
        2'b11: begin
          if (rd_vld)
            tx_data <= #0.1 afifo_rdata[31:0];
          else if (tx_vld_r)
            tx_data <= #0.1 data_buf[31:0];
        end
        2'b10: begin
          if (rd_vld)
            tx_data <= #0.1 {8'h0, afifo_rdata[15:8], 8'h0, afifo_rdata[7:0]};
          else if (tx_vld_r)
            tx_data <= #0.1 {8'h0, data_buf[15:8], 8'h0, data_buf[7:0]};
        end
        2'b01: begin
          if (rd_vld)
            tx_data <= #0.1 {16'h0, afifo_rdata[15:0]};
          else if (tx_vld_r)
            tx_data <= #0.1 {16'h0, data_buf[15:0]};
        end
        default: begin  // 2'b00
          if (rd_vld)
            tx_data <= #0.1 {24'h0, afifo_rdata[7:0]};
          else if (tx_vld_r)
            tx_data <= #0.1 {24'h0, data_buf[7:0]};
        end
      endcase
    end
  end
end

always @ (posedge tx_clk or negedge tx_rstn) begin
  if (~tx_rstn)
    data_buf <= #0.1 56'h0;
  else begin
    if (data_4b) begin
      data_buf[31:0] <= #0.1 afifo_rdata[63:32];
    end else if (data_2b) begin
      if (rd_vld)
        data_buf[47:0] <= #0.1 afifo_rdata[63:16];
      else if (tx_vld_r)
        data_buf <= #0.1 {16'h0, data_buf[55:16]};
    end else begin
      if (rd_vld)
        data_buf <= #0.1 afifo_rdata[63:8];
      else if (tx_vld_r)
        data_buf <= #0.1 {8'h0, data_buf[55:8]};
    end
  end
end

always @ (posedge tx_clk or negedge tx_rstn) begin
  if (~tx_rstn)
    rx_rdy <= #0.1 1'b0;
  else begin
    if (btchk_run)
      rx_rdy <= #0.1 btchk_data2[0];
    else
      rx_rdy <= #0.1 rx_rdy_tx;
  end
end
//******************************************************************************

always @ (posedge tx_clk or negedge tx_rstn) begin
  if (~tx_rstn)
    bts_1byte <= #0.1 1'b0;
  else begin
    if (pkt_start_w&tx_vld_d[0]&data_1b&(tx_data_d[7:0]==8'hE)&cmd_loc[0])
      bts_1byte <= #0.1 1'b1;
    else if (tx_vld_d[0]&bts_1byte)
      bts_1byte <= #0.1 1'b0;
  end
end

always @ (posedge tx_clk or negedge tx_rstn) begin
  if (~tx_rstn)
    tx_bt_s <= #0.1 1'b0;
  else begin
    if ((pkt_start_w&tx_vld_d[0]&~data_1b&(tx_data_d[7:0]==8'hE)&cmd_loc[0])|(tx_vld_d[0]&bts_1byte))
      tx_bt_s <= #0.1 1'b1;
    else
      tx_bt_s <= #0.1 1'b0;
  end
end

always @ (posedge tx_clk or negedge tx_rstn) begin
  if (~tx_rstn)
    tx_bts_r <= #0.1 1'b0;
  else begin
    if (tx_bt_s)
      tx_bts_r <= #0.1 1'b1;
    else if ((tx_bts_r&rx_bts_r)|btchk_done)
      tx_bts_r <= #0.1 1'b0;
  end
end

always @ (posedge tx_clk or negedge tx_rstn) begin
  if (~tx_rstn)
    rx_bts_r <= #0.1 1'b0;
  else begin
    if (rx_bt_s)
      rx_bts_r <= #0.1 1'b1;
    else if ((tx_bts_r&rx_bts_r)|btchk_done)
      rx_bts_r <= #0.1 1'b0;
  end
end

always @ (posedge tx_clk or negedge tx_rstn) begin
  if (~tx_rstn)
    set_btchk <= #0.1 1'b0;
  else begin
    if (tx_bts_r&rx_bts_r&~rx_fail)
      set_btchk <= #0.1 1'b1;
    else
      set_btchk <= #0.1 1'b0;
  end
end

always @ (posedge tx_clk or negedge tx_rstn) begin
  if (~tx_rstn)
    btchk_run <= #0.1 1'b0;
  else begin
    if (set_btchk)
      btchk_run <= #0.1 1'b1;
    else if (btchk_run&(tx_cnt[5:0]==6'h0))
      btchk_run <= #0.1 1'b0;
  end
end

always @ (posedge tx_clk or negedge tx_rstn) begin
  if (~tx_rstn)
    btchk_data0 <= #0.1 BTCHK_D0;
  else begin
    if (btchk_run&ddr_en)
      btchk_data0 <= #0.1 {btchk_data0[1:0], btchk_data0[63:2]};
    else if (btchk_run)
      btchk_data0 <= #0.1 {btchk_data0[0], btchk_data0[63:1]};
  end
end

always @ (posedge tx_clk or negedge tx_rstn) begin
  if (~tx_rstn)
    btchk_data1 <= #0.1 BTCHK_D1;
  else begin
    if (btchk_run&ddr_en)
      btchk_data1 <= #0.1 {btchk_data1[1:0], btchk_data1[63:2]};
    else if (btchk_run)
      btchk_data1 <= #0.1 {btchk_data1[0], btchk_data1[63:1]};
  end
end

always @ (posedge tx_clk or negedge tx_rstn) begin
  if (~tx_rstn)
    btchk_data2 <= #0.1 BTCHK_D0;
  else begin
    if (btchk_run)
      btchk_data2 <= #0.1 {btchk_data2[0], btchk_data2[63:1]};
  end
end

assign set_rdvld = (data_4b&~tx_cnt1[0]) | (data_2b&(tx_cnt1[1:0]==2'h2))
                 | (data_1b&(tx_cnt1[2:0])==3'h6);
always @ (posedge tx_clk or negedge tx_rstn) begin
  if (~tx_rstn)
    afifo_rd <= #0.1 1'b0;
  else begin
    if (((~afifo_rd&~tx_vld_r)|(set_rdvld&tx_vld_r))&tx_rdy_l)
      afifo_rd <= #0.1 1'b1;
    else if (rd_vld)
      afifo_rd <= #0.1 1'b0;
  end
end

//******************************************************************************

  assign tx_done = tx_dvld[0] & tx_dack;
  assign tx_dch  = tx_dbuf[2:0];
  assign cmd_mux = ({4{cmd_loc[0]}}&tx_data_d[3:0])   | ({4{cmd_loc[1]}}&tx_data_d[11:8])
                 | ({4{cmd_loc[2]}}&tx_data_d[19:16]) | ({4{cmd_loc[3]}}&tx_data_d[27:24]);
  assign ch_mux  = ({3{cmd_loc[0]}}&tx_data_d[6:4])   | ({3{cmd_loc[1]}}&tx_data_d[14:12])
                 | ({3{cmd_loc[2]}}&tx_data_d[22:20]) | ({3{cmd_loc[3]}}&tx_data_d[30:28]);
  assign len_mux = ({8{cmd_loc[0]}}&tx_data_d[15:8])  | ({8{cmd_loc[1]}}&tx_data_d[23:16])
                 | ({8{cmd_loc[2]}}&tx_data_d[31:24]);
  assign msb_cmd = (cmd_loc[3]&tx_vld_d[2]) | (cmd_loc[1]&tx_vld_d[1]&~tx_vld_d[2]) | ~tx_vld_d[1];

  always @ (posedge tx_clk or negedge tx_rstn) begin
    if (~tx_rstn) begin
      tx_vld_d  <= #0.1 4'h0;
      tx_data_d <= #0.1 32'h0;
    end else if (~btchk_run) begin
      case ({ddr_en, en_16b})
        2'b11: begin
          tx_vld_d  <= #0.1 {tx_vld[1], tx_vld[1], tx_vld[0], tx_vld[0]};
          tx_data_d <= #0.1 tx_data;
        end
        2'b10: begin
          tx_vld_d  <= #0.1 {2'b00, tx_vld[1:0]};
          tx_data_d <= #0.1 {16'h0, tx_data[23:16], tx_data[7:0]};
        end
        2'b01: begin
          tx_vld_d  <= #0.1 {2'b00, tx_vld[0], tx_vld[0]};
          tx_data_d <= #0.1 {16'h0, tx_data[15:0]};
        end
        default: begin
          tx_vld_d  <= #0.1 {3'h0, tx_vld[0]};
          tx_data_d <= #0.1 {24'h0, tx_data[7:0]};
        end
      endcase
    end
  end

  assign pkt_lrdata = (cmd_loc[0]&(|len_mux[7:3]))
                    | (cmd_loc[1]&((|len_mux[7:3])|(&len_mux[2:0]))) | cmd_loc[3]
                    | (cmd_loc[2]&((|len_mux[7:3])|(len_mux[2]&len_mux[1])));
  assign lpkt_wrsp0 = (tx_data_d[19:16]==4'h1)|(tx_data_d[19:16]==4'h5)|(tx_data_d[19:16]==4'h6);
  assign lpkt_wrsp1 = (tx_data_d[27:24]==4'h1)|(tx_data_d[27:24]==4'h6)|(tx_data_d[27:24]==4'h5);
  assign clr_pkts32 = (cmd_mux==4'h1)|(cmd_mux==4'h4)|(cmd_mux==4'h6)
                    | ((cmd_mux==4'h5)&pkt_lrdata)
                    | ((cmd_mux==4'h7)&cmd_loc[0]&lpkt_wrsp0&(tx_data_d[31:24]!=8'h4)&(tx_data_d[31:24]!=8'h5))
                    | ((cmd_mux==4'h7)&cmd_loc[0]&(tx_data_d[19:16]==4'h4))
                    | ((cmd_mux==4'h7)&cmd_loc[1]&((tx_data_d[27:24]==4'h4)|lpkt_wrsp1));
  assign clr_pkts16 = (cmd_mux==4'h1)|(cmd_mux==4'h4)|(cmd_mux==4'h6)|(cmd_mux==4'h5);
  assign set_pstart = (tx_vld_d[0]&(pkt_cnt[7:3]==5'h0) &
                      ((data_4b&pkt_cnt[2])
                      |(data_2b&~pkt_cnt[2]&pkt_cnt[1])
                      |(data_1b&~pkt_cnt[2]&~pkt_cnt[1]&pkt_cnt[0])))
                      |(pkt_start_d&~pkt_start&tx_vld_d[0]&data_4b&(~(|tx_data_d[7:4])&(tx_data_d[3]^(|tx_data_d[2:0]))))
                      |(pkt_start_d&~pkt_start&tx_vld_d[0]&data_4b&(tx_data_d[7:0]==8'h4))
                      |(pkt_start_d&tx_vld_d[0]&tx_vld_d[1]&(tx_data_d[7:0]==8'h4));
  assign pkt_start_w = pkt_start&(pkt_cnt[7:2]==6'h0)&((pkt_cnt[1]&tx_vld_d[2])|(~pkt_cnt[1]&pkt_cnt[0]&tx_vld_d[1])|(~pkt_cnt[1]&~pkt_cnt[0]));
  assign pkt_start_w1 = pkt_start_d&tx_vld_d[0]&tx_vld_d[2]&(tx_data_d[7:0]==8'h4);
  always @ (posedge tx_clk or negedge tx_rstn) begin
    if (~tx_rstn)
      pkt_start <= #0.1 1'b1;
    else begin
      if ((pkt_start_w|pkt_start_w1)&tx_vld_d[0]&((data_4b&clr_pkts32)|(data_2b&clr_pkts16)|data_1b))
        pkt_start <= #0.1 1'b0;
      else if (set_pstart|(pkt_2byte&tx_vld_d[0]))
        pkt_start <= #0.1 1'b1;
    end
  end

  always @ (posedge tx_clk or negedge tx_rstn) begin
    if (~tx_rstn)
      pkt_start_d <= #0.1 1'b0;
    else begin
      if ((pkt_start_w|pkt_start_w1)&tx_vld_d[0]&msb_cmd&((cmd_mux==4'h1)|(cmd_mux==4'h5)|(cmd_mux==4'h6)))
        pkt_start_d <= #0.1 1'b1;
      else if (pkt_start_w&tx_vld_d[0]&(cmd_mux==4'h7)&cmd_loc[1]&lpkt_wrsp1)
        pkt_start_d <= #0.1 1'b1;
      else if (pkt_start_d&tx_vld_d[0]&tx_vld_d[2]&(tx_data_d[7:0]==8'h4)&((cmd_mux==4'h1)|(cmd_mux==4'h5)|(cmd_mux==4'h6)))
        pkt_start_d <= #0.1 1'b1;
      else if (tx_vld_d[0]&pkt_start_d)
        pkt_start_d <= #0.1 1'b0;
    end
  end

  always @ (posedge tx_clk or negedge tx_rstn) begin
    if (~tx_rstn)
      pkt_rcmd <= #0.1 1'b0;
    else begin
      if (pkt_start_w&tx_vld_d[0]&((cmd_mux==4'h4)|((cmd_mux==4'h7)&cmd_loc[1]&(tx_data_d[27:24]==4'h4))))
        pkt_rcmd <= #0.1 1'b1;
      else if (tx_vld_d[0]&pkt_rcmd)
        pkt_rcmd <= #0.1 1'b0;
    end
  end

  always @ (posedge tx_clk or negedge tx_rstn) begin
    if (~tx_rstn)
      pkt_2byte <= #0.1 1'b0;
    else begin
      if (pkt_start_w&tx_vld_d[0]&data_1b&((cmd_mux==4'h7)|(cmd_mux==4'hE)|(cmd_mux==4'hF)))
        pkt_2byte <= #0.1 1'b1;
      else if (tx_vld_d[0]&pkt_2byte)
        pkt_2byte <= #0.1 1'b0;
    end
  end

  always @ (*) begin
    casez (tx_vld_d)
      4'b1???: pcnt_dnum = 3'h4;
      4'b001?: pcnt_dnum = 3'h2;
      4'b0001: pcnt_dnum = 3'h1;
      default: pcnt_dnum = 3'h0;
    endcase
  end

  assign pkt_cnt_n = pkt_cnt[7:0] + tx_data_d[7:0] - pcnt_dnum;
  always @ (posedge tx_clk or negedge tx_rstn) begin
    if (~tx_rstn)
      pkt_cnt <= #0.1 9'h0;
    else begin
      if ((pkt_start_w&tx_vld_d[0])|pkt_start_w1) begin
        case (cmd_mux)
          4'h0: pkt_cnt <= #0.1 9'h0;
          4'h1, 4'h5,  4'h6: begin
            if (~msb_cmd)
              pkt_cnt <= #0.1 pkt_cnt[7:0] + len_mux[7:0] - pcnt_dnum;
            else if (~pkt_start_w1)
              pkt_cnt <= #0.1 pkt_cnt[7:0] - pcnt_dnum;
          end
          4'h4: begin
            if (pkt_start_w1)
              pkt_cnt <= #0.1 pkt_cnt[7:0] + 8'h8;
            else
              pkt_cnt <= #0.1 pkt_cnt[7:0] + 8'h8 - pcnt_dnum;
          end
          4'h7: begin
            if (pkt_start_w1)
              pkt_cnt <= #0.1 pkt_cnt[7:0] + 2'h2;
            else if (cmd_loc[0]&lpkt_wrsp0&tx_vld_d[2])
              pkt_cnt <= #0.1 pkt_cnt[7:0] + tx_data_d[31:24] - 2'h2;
            else if ((cmd_loc[0]&(tx_data_d[19:16]==4'h4)&tx_vld_d[2])
                   | (cmd_loc[1]&(tx_data_d[27:24]==4'h4)&tx_vld_d[2]))
              pkt_cnt <= #0.1 pkt_cnt[7:0] + 3'h6;
            else if (cmd_loc[1]&(tx_data_d[27:24]==4'h0)&tx_vld_d[2])
              pkt_cnt <= #0.1 9'h0;
            else if (~((tx_data_d[19:16]==4'h7)&cmd_loc[0]) & ~((tx_data_d[27:24]==4'h7)&cmd_loc[1]) & ~data_1b)
              pkt_cnt <= #0.1 pkt_cnt[7:0] + 2'h2 - pcnt_dnum;
          end
          4'hE, 4'hF:
            pkt_cnt <= #0.1 9'h0;
          default:;
        endcase
      end else if (pkt_start_d&~pkt_start&tx_vld_d[0]) begin
        if ((tx_data_d[7:0]==8'h4)&(cmd_mux==4'h0)&tx_vld_d[2])
          pkt_cnt <= #0.1 9'h0;
        else
          pkt_cnt <= #0.1 pkt_cnt[7:0] + tx_data_d[7:0] - pcnt_dnum;
      end else if (tx_vld_d[0]&~pkt_2byte) begin
        pkt_cnt <= #0.1 pkt_cnt[7:0] - pcnt_dnum;
      end
    end
  end

always @ (posedge tx_clk or negedge tx_rstn) begin
  if (~tx_rstn)
    cmd_loc <= #0.1 4'b0001;
  else begin
    if ((pkt_start_w&tx_vld_d[0])|pkt_start_w1) begin
      case (cmd_mux)
        4'h0: cmd_loc <= #0.1 4'b0001;
        4'h1, 4'h5, 4'h6: begin
          if (data_4b) begin
            case (len_mux[1:0])
              2'h1   : cmd_loc <= #0.1 {cmd_loc[2:0], cmd_loc[3]};
              2'h2   : cmd_loc <= #0.1 {cmd_loc[1:0], cmd_loc[3:2]};
              2'h3   : cmd_loc <= #0.1 {cmd_loc[0], cmd_loc[3:1]};
              default:;
            endcase
          end else if (data_2b) begin
            if (len_mux[0])
              cmd_loc <= #0.1 {cmd_loc[3:2], cmd_loc[0], cmd_loc[1]};
          end
        end
        4'h7: begin
          if (tx_vld_d[2]&cmd_loc[0]) begin
            case (tx_data_d[19:16])
              4'h1, 4'h5, 4'h6: begin
                case (tx_data_d[25:24])
                  2'h0   : cmd_loc <= #0.1 {cmd_loc[1:0], cmd_loc[3:2]};
                  2'h1   : cmd_loc <= #0.1 {cmd_loc[0], cmd_loc[3:1]};
                  2'h3   : cmd_loc <= #0.1 {cmd_loc[2:0], cmd_loc[3]};
                  default:;
                endcase
              end
              4'h4: cmd_loc <= #0.1 {cmd_loc[1:0], cmd_loc[3:2]};
              default:;   // no change
            endcase
          end else if (tx_vld_d[2]) begin
            if (tx_data_d[27:24]==4'h0)
              cmd_loc <= #0.1 4'b0001;
            else if ((tx_data_d[27:24]!=4'h7)|cmd_loc[3]|cmd_loc[2])
              cmd_loc <= #0.1 {cmd_loc[1:0], cmd_loc[3:2]};
          end
        end
        default:;
      endcase
    end else if (pkt_start_d&~pkt_start&tx_vld_d[0]&~pkt_rcmd) begin
      if (data_4b) begin
        if (tx_data_d[7:0]==8'h4)
          cmd_loc <= #0.1 4'b0001;
        else begin
          case (tx_data_d[1:0])
            2'h1   : cmd_loc <= #0.1 {cmd_loc[2:0], cmd_loc[3]};
            2'h2   : cmd_loc <= #0.1 {cmd_loc[1:0], cmd_loc[3:2]};
            2'h3   : cmd_loc <= #0.1 {cmd_loc[0], cmd_loc[3:1]};
            default:;
          endcase
        end
      end else if (data_2b) begin
        if (tx_data_d[0])
          cmd_loc <= #0.1 {cmd_loc[3:2], cmd_loc[0], cmd_loc[1]};
      end
    end else if (data_4b&tx_vld_d[0]&(~tx_vld_d[2]|(tx_vld_d[2]&pkt_start_w&(cmd_mux==4'h7))))
      cmd_loc <= #0.1 {cmd_loc[1:0], cmd_loc[3:2]};
    else if (data_2b&tx_vld_d[0]&~tx_vld_d[1])
        cmd_loc <= #0.1 {cmd_loc[3:2], cmd_loc[0], cmd_loc[1]};
  end
end

assign pkt_end  = tx_vld_d[0]&(pkt_cnt[7:3]==5'h0)&
                ( (tx_vld_d[2]&(pkt_cnt[2]^(pkt_cnt[1]|pkt_cnt[0])))
                | (tx_vld_d[1]&~tx_vld_d[2]&~pkt_cnt[2]&(pkt_cnt[1]^pkt_cnt[0]))
                | (~tx_vld_d[1]&~pkt_cnt[2]&~pkt_cnt[1]&pkt_cnt[0]));
assign nxt_dma0 = (cmd_mux==4'h7)&cmd_loc[0]&(tx_data_d[19:16]==4'h1);
assign nxt_dma1 = (cmd_mux==4'h7)&cmd_loc[1]&(tx_data_d[27:24]==4'h1);
always @ (posedge tx_clk or negedge tx_rstn) begin
  if (~tx_rstn)
    dma_pkt <= #0.1 1'b0;
  else begin
    if ((pkt_start_w|pkt_start_w1)&tx_vld_d[0]&((cmd_mux==4'h1)|nxt_dma0|nxt_dma1))
      dma_pkt <= #0.1 1'b1;
    else if (pkt_end)
      dma_pkt <= #0.1 1'b0;
  end
end

always @ (posedge tx_clk or negedge tx_rstn) begin
  if (~tx_rstn)
    dma_ch <= #0.1 3'h0;
  else begin
    if ((pkt_start_w|pkt_start_w1)&tx_vld_d[0]&(cmd_mux==4'h1))
      dma_ch <= #0.1 ch_mux;
    else if (pkt_start_w&tx_vld_d[0]&nxt_dma0)
      dma_ch <= #0.1 tx_data_d[22:20];
    else if (pkt_start_w&tx_vld_d[0]&nxt_dma1)
      dma_ch <= #0.1 tx_data_d[30:28];
  end
end

assign set_tdone = dma_pkt & pkt_end;
always @ (posedge tx_clk or negedge tx_rstn) begin
  if (~tx_rstn)
    tx_dvld <= #0.1 2'h0;
  else begin
    case ({set_tdone, tx_done})
      2'b10  : tx_dvld <= #0.1 {tx_dvld[0], 1'b1};
      2'b01  : tx_dvld <= #0.1 {1'b0, tx_dvld[1]};
      default:;
    endcase
  end
end

always @ (posedge tx_clk or negedge tx_rstn) begin
  if (~tx_rstn)
    tx_dbuf <= #0.1 6'h0;
  else begin
    if (set_tdone) begin
      casez (tx_dvld)
        2'b00: tx_dbuf[2:0] <= #0.1 dma_ch;
        2'b01: begin
          if (tx_done)
            tx_dbuf[2:0] <= #0.1 dma_ch;
          else
            tx_dbuf[5:3] <= #0.1 dma_ch;
        end
        2'b1?: begin
          if (tx_done)
            tx_dbuf <= #0.1 {dma_ch, tx_dbuf[5:3]};
        end
        default:;
      endcase
    end else if (tx_done&tx_dvld[1])
      tx_dbuf[2:0] <= #0.1 tx_dbuf[5:3];
  end
end

endmodule
//==============================================================================
//
//    This confidential and proprietary hardware may be used only as
//  authorized by a licensing agreement from
//                    SunMedia Technology Co., LTD.
//
//  In the event of publication, the following notice is applicable:
//
//            COPYRIGHT 2017, SunMedia Technology Co., LTD.
//                        ALL RIGHTS RESERVED
//
//  The entire notice above must be reproduced on all authorized copies.
//
//==============================================================================
//
//  File        : f_bio_rx_pkt.v
//  Author      : kun.zhang
//  Date        : 05/Dec/2017
//  Version     : 1.2
//  Abstract    : This module is the RX packet block for BIO control. It read
//                the receiver information form AFIFO (CDC) and unpacket it to
//                CPU/DMA request
//
//  Modification History:
//  Date          By            Version         Change Description
//------------------------------------------------------------------------------
//  21/Feb/2017   kun.zhang      1.0            Original
//  07/Jun/2017   xh.du          1.1            Modify for W2R block
//  05/Dec/2017   kun.zhang      1.2            Add CPU slave mode support and
//                                              other releated logics
//
//
//==============================================================================
// About *_info
// cpum_info
// [58]   : 1'b1 -> Write Data, 1'b0: Read command
// [57:55]: awsize/arsize[2:0]
// [54:52]: awprot/arprot[2:0]
// [51:50]: awlock/arlock[1:0]
// [49:48]: awburst/arburst[1:0]
// [47:44]: awlen/arlen[3:0]
// [43:40]: awcache/arcache[3:0]
// [39:32]: awid/arid[7:0]. Only send 8bit id on IO bus
// [31:0] : awaddr/araddr[31:0]
// -----------------------------------------------------------------------------
// cpus_info: used for read data packet
// [17:16]: Read response
// [15:8]:  Read ID
// [7:0]:   Read length
// -----------------------------------------------------------------------------
// cpus_info1: used for write response packet
// [9:8]: Response type
// [7:0]:   Response ID
//******************************************************************************



module f_bio_rx_pkt (
  input  wire        sysclk,    // clock
  input  wire        sysrstn,   // reset
  input  wire        sft_rst,   // Soft reset

  output reg         cpum_req,   // CPU transfer request
  output reg  [58:0] cpum_info,  // CPU transfer information
  input  wire        cpum_acp,   // CPU transfer accept
  output wire        cpum_wvld,  // CPU write data valid
  output wire [71:0] cpum_wdata, // CPU write data
  input  wire        cpum_wrdy,  // CPU write ready, has enough buffer for data

  output reg         cpus_req,      // CPU slave mode request for read data
  output reg  [17:0] cpus_info,     // CPU slave mode request information
  output wire        cpus_rvld,     // CPU slave mode read data valid
  output wire [63:0] cpus_rdata,    // CPU slave mode read data
  input  wire        cpus_rrdy,     // CPU slave mode read data ready
  output reg         cpus_req1,     // CPU slave mode request for write response
  output reg  [9:0]  cpus_info1,    // CPU slave mode write response information
  input  wire        cpus_acp1,     // CPU slave accept write response request

  output wire        dma_wvld,  // DMA write data valid
  output reg  [2:0]  dma_ch,    // DMA channel number
  output wire [63:0] dma_wdata, // DMA write data
  input  wire        dma_wrdy,  // DMA write ready, has enough buffer for data


    input  wire       rx_req,   // RX request for stop counter
    input  wire [2:0] rx_rch,   // RX request channel number
    input  wire       rx_sack,  // RX stop ack from RX domain
    input  wire [2:0] rx_sch,   // RX stop channel number
    output reg  [5:0] rx_sdone, // DMA RX stop finished


  output reg         stest_ack,     // Receives Self-test start
  output reg         btchk_ack,     // Bus tunning acknowlage, receives BT start
  output reg         btchk_ack1,    // Bus tunning acknowlage, receives BT end
  output reg         btchk_dack,    // Bus tunning data acknowlage
  output reg         rx_fail,      // Bus tunning fail in the END packet
  input  wire        stest_run,     // Self-test running

  output wire        afifo_rd,      // AFIFO read enable
  input  wire [71:0] afifo_rdata,   // AFIFO read data
  input  wire        afifo_empty    // AFIFO empty
/*AUTOARG*/);
//******************************************************************************
reg  [71:0] data_buf;   // Data buffer for temp read
reg         rd_dvld;    // Temp Read data valid
reg  [4:0]  data_bcnt;  // Data byte counter for shift
reg  [7:0]  data_buf0;  // Data buffer0 for shift
reg  [7:0]  data_buf1;  // Data buffer1 for shift
reg  [7:0]  data_buf2;  // Data buffer2 for shift
reg  [7:0]  data_buf3;  // Data buffer3 for shift
reg  [7:0]  data_buf4;  // Data buffer4 for shift
reg  [7:0]  data_buf5;  // Data buffer5 for shift
reg  [7:0]  data_buf6;  // Data buffer6 for shift
reg  [7:0]  data_buf7;  // Data buffer7 for shift
reg  [7:0]  data_buf8;  // Data buffer8 for shift
reg  [7:0]  data_buf9;  // Data buffer9 for shift
reg  [7:0]  data_buf10; // Data buffer10 for shift
reg  [7:0]  data_buf11; // Data buffer11 for shift
reg  [7:0]  data_buf12; // Data buffer12 for shift
reg  [7:0]  data_buf13; // Data buffer13 for shift
reg  [7:0]  data_buf14; // Data buffer14 for shift
wire [3:0]  data_bcnt1; // Data byte counter for write data shift
wire        bcnt_dec8;  // Decrease bcnt by 8 for read
wire        sbuf_wen;   // Shift buffer write enable
wire        inc_bcnt;   // Status to increase byte counter
reg  [3:0]  inc_bnum;   // Byte counter increase number
wire        dec_bcnt;   // Status to decrease byte counter
wire        dec_bcnt0;  // Status0 to decrease byte counter (normal condition)
wire        dec_bcnt1;  // Status1 to decrease byte counter (no shift out)
reg  [3:0]  dec_bnum;   // Byte counter decrease number
wire [3:0]  last_bcnt;  // The byte counter for last transfer

reg         cmd_vld;    // The current read data includes command information
reg         cpum_wreq;  // The current request is cpu master write data
wire        data_pkt;   // The current is a data transfer packet
wire        last_trans; // The last data in a transfer
reg  [6:0]  cpum_dlen;  // CPU master data length in bytes
reg  [3:0]  wbe_len;    // CPU master write byte enable length in bytes
reg         wbe_l8b;    // The write byte enable is larger than 8Byte
reg         wbe_sel;    // The write byte enable select
reg  [8:0]  tran_cnt;   // Transfer counter for burst in words
wire        data_wdone; // Data write done for any transfers

reg  [127:0] wbe_tmp;    // CPU mode write byte-enable temp
reg         wbe_pend;   // wbe pending
wire        wbe_vld;    // wbe valid for latch
reg         cpum_dvld;  // CPU master data stage valid
reg         cpus_dvld;  // CPU slave data stage valid
reg         dma_dvld;   // DMA mode data stage valid

wire        dma_req;    // DMA transfer packet
wire        cpu_rcmd;   // CPU read command packet
wire        cpu_rdata;  // CPU read data packet
wire        cpu_wdata;  // CPU write data packet
wire        cpu_wresp;  // CPU wrire response packet
wire        pkt_empty;  // An empty packet (1Byte of dummy data)
wire        pkt_test;   // The packet is a testmode packet
wire        cpum_acp_w; // CPU master accept with valid
wire        cpus_acp1_w;    // CPU slave accept with valid
reg         btchk_dack_r;   // Data ack latched for waiting
reg         btchk_dack_i;   // Data ack before end receives
wire        rcv_tend;       // Receives tuning end


  reg  [5:0] rx_req_r;      // RX request for each channel
  reg  [8:0] rch_vld [5:0]; // RX channel valid queue
  reg  [5:0] rch_trans0;    // RX channel transfer queue0
  reg  [5:0] rch_trans1;    // RX channel transfer queue1;
  wire [5:0] rx_pop;        // Pop request from queue
  reg  [5:0] rx_stop;       // RX stop state

//==============================================================================
assign afifo_rd   = ~rd_dvld | (rd_dvld&sbuf_wen);
assign sbuf_wen   = ~data_bcnt[3] | (data_bcnt[3]&bcnt_dec8);
assign data_wdone = (cpum_wvld&cpum_wrdy) | (cpus_rvld&cpus_rrdy) | (dma_wvld&dma_wrdy);

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rd_dvld <= #0.1 1'b0;
  else begin
    if (afifo_rd&~afifo_empty&~sft_rst)
      rd_dvld <= #0.1 1'b1;
    else if ((rd_dvld&sbuf_wen)|sft_rst)
      rd_dvld <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    data_buf <= #0.1 72'h0;
  else begin
    if (afifo_rd & ~afifo_empty) begin
      case (afifo_rdata[71:64])
        8'h33, 8'hf3: begin
          data_buf[71:64] <= #0.1 {2'h0, afifo_rdata[71:70], 4'b1111};
          data_buf[47:0]  <= #0.1 {afifo_rdata[63:32], afifo_rdata[15:0]};
        end
        8'h05, 8'h0D, 8'h1D, 8'h3D, 8'h7D, 8'hFD: begin
          data_buf[71:64] <= #0.1 {1'b0, afifo_rdata[71:66], 1'b1};
          data_buf[55:0]  <= #0.1 {afifo_rdata[63:16], afifo_rdata[7:0]};
        end
        8'h15, 8'h35, 8'h75, 8'hF5: begin
          data_buf[71:64] <= #0.1 {2'b00, afifo_rdata[71:68], 2'b11};
          data_buf[47:0]  <= #0.1 {afifo_rdata[63:32], afifo_rdata[23:16], afifo_rdata[7:0]};
        end
        8'h55, 8'hD5: begin
          data_buf[71:64] <= #0.1 {3'b000, afifo_rdata[71:70], 3'b111};
          data_buf[39:0]  <= #0.1 {afifo_rdata[63:48], afifo_rdata[39:32], afifo_rdata[23:16], afifo_rdata[7:0]};
        end
        8'h5D, 8'hDD: begin
          data_buf[71:64] <= #0.1 {2'b00, afifo_rdata[71:70], 4'b1111};
          data_buf[47:0]  <= #0.1 {afifo_rdata[63:48], afifo_rdata[39:16], afifo_rdata[7:0]};
        end
        8'h5F, 8'hDF: begin
          data_buf[71:64] <= #0.1 {1'b0, afifo_rdata[71:70], 5'b1_1111};
          data_buf[55:0]  <= #0.1 {afifo_rdata[63:48], afifo_rdata[39:0]};
        end
        8'h17, 8'h37, 8'h77, 8'hF7: begin
          data_buf[71:64] <= #0.1 {1'b0, afifo_rdata[71:68], 3'b111};
          data_buf[55:0]  <= #0.1 {afifo_rdata[63:32], afifo_rdata[23:0]};
        end
        8'h57, 8'hD7: begin
          data_buf[71:64] <= #0.1 {2'b00, afifo_rdata[71:70], 4'b1111};
          data_buf[47:0]  <= #0.1 {afifo_rdata[63:48], afifo_rdata[39:32], afifo_rdata[23:0]};
        end
        default: data_buf <= #0.1 afifo_rdata;
      endcase
      //data_buf <= `DLY afifo_rdata;
    end
  end
end

always @ (*) begin
  case (data_buf[71:64])
    8'b0000_0001: inc_bnum = 4'h1;
    8'b0000_0011: inc_bnum = 4'h2;
    8'b0000_0111: inc_bnum = 4'h3;
    8'b0000_1111: inc_bnum = 4'h4;
    8'b0001_1111: inc_bnum = 4'h5;
    8'b0011_1111: inc_bnum = 4'h6;
    8'b0111_1111: inc_bnum = 4'h7;
    8'b1111_1111: inc_bnum = 4'h8;
    default     : inc_bnum = 4'h0;
  endcase
end

assign last_bcnt = tran_cnt[2:0] + 1'b1;
always @ (*) begin
  if (cmd_vld) begin
    case (data_buf0[3:0])
      4'h1:    dec_bnum = 4'h2;
      4'h4:    dec_bnum = 4'h8;
      4'h5:    dec_bnum = 4'h3;
      4'h6:    dec_bnum = 4'h1; // Write data will shift length first
      4'h7:    dec_bnum = 4'h2;
      4'hE:    dec_bnum = (|data_bcnt[3:1]) ? 4'h2 : 4'h1;
      4'hF:    dec_bnum = (|data_bcnt[3:1]) ? 4'h2 : 4'h1;
      default: dec_bnum = 4'h1; // Shift out 1Byte dummy data
    endcase
  end else if (cpum_wreq&data_bcnt[3]&cpum_acp_w)
    dec_bnum = 4'h8;
  else if (wbe_vld)
    dec_bnum = wbe_l8b ? 4'h8 : wbe_len;
  else if (cpum_dvld|cpus_dvld|dma_dvld) begin
    if (last_trans)
      dec_bnum = last_bcnt;
    else
      dec_bnum = 4'h8;
  end else
    dec_bnum = 4'h0;
end

assign inc_bcnt  = rd_dvld&sbuf_wen&(data_buf[71:64]!=8'h0);
assign bcnt_dec8 = (cmd_vld&cpu_rcmd&cpum_acp_w) | (cpum_wreq&data_bcnt[3]&cpum_acp_w)
                 | (((cpum_dvld&cpum_wrdy)|(cpus_dvld&cpus_rrdy)|(dma_dvld&dma_wrdy))&data_bcnt[3]&~(last_trans&~last_bcnt[3]));
assign dec_bcnt0 = (cmd_vld&(dma_req|(cpu_rcmd&cpum_acp_w)|cpu_rdata|(cpu_wresp&cpus_acp1_w)|pkt_empty|pkt_test))
                 | (cpum_wreq&data_bcnt[3]&cpum_acp_w) | wbe_vld
                 | (((cpum_dvld&cpum_wrdy)|(cpus_dvld&cpus_rrdy)|(dma_dvld&dma_wrdy))&(data_bcnt[3]|last_trans));
assign dec_bcnt1 = cmd_vld&cpu_wdata;
assign dec_bcnt  = dec_bcnt0 | dec_bcnt1;
always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    data_bcnt <= #0.1 5'h0;
  else begin
    if (sft_rst)
      data_bcnt <= #0.1 5'h0;
    else begin
      case ({inc_bcnt, dec_bcnt})
        2'b01  : data_bcnt <= #0.1 data_bcnt[3:0] - dec_bnum;
        2'b10  : data_bcnt <= #0.1 data_bcnt[3:0] + inc_bnum;
        2'b11  : data_bcnt <= #0.1 data_bcnt[3:0] + inc_bnum - dec_bnum;
        default:; //
      endcase
    end
  end
end

assign data_bcnt1 = cpum_wreq ? data_bcnt[3:0] : ({1'b0, data_bcnt[2:0]} - 1'b1);
always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn) begin
    data_buf0  <= #0.1 8'h0;
    data_buf1  <= #0.1 8'h0;
    data_buf2  <= #0.1 8'h0;
    data_buf3  <= #0.1 8'h0;
    data_buf4  <= #0.1 8'h0;
    data_buf5  <= #0.1 8'h0;
    data_buf6  <= #0.1 8'h0;
    data_buf7  <= #0.1 8'h0;
    data_buf8  <= #0.1 8'h0;
    data_buf9  <= #0.1 8'h0;
    data_buf10 <= #0.1 8'h0;
    data_buf11 <= #0.1 8'h0;
    data_buf12 <= #0.1 8'h0;
    data_buf13 <= #0.1 8'h0;
    data_buf14 <= #0.1 8'h0;
  end else begin
    if (inc_bcnt&(cpum_wreq|(cmd_vld&cpu_wdata))&~data_bcnt[3]) begin
      case (data_bcnt1[2:0])
        3'h0: begin // buf0: cmd(not shift out), length=buf[7:0], id=buf[63:56].
          data_buf1 <= #0.1 data_buf[63:56];
          data_buf2 <= #0.1 data_buf[15:8];
          data_buf3 <= #0.1 data_buf[23:16];
          data_buf4 <= #0.1 data_buf[31:24];
          data_buf5 <= #0.1 data_buf[39:32];
          data_buf6 <= #0.1 data_buf[47:40];
          data_buf7 <= #0.1 data_buf[55:48];
        end
        3'h1: begin // buf0: cmd, buf1: length (not shift out), id=buf[55:48].
          data_buf1 <= #0.1 data_buf[55:48];
          data_buf2 <= #0.1 data_buf[7:0];
          data_buf3 <= #0.1 data_buf[15:8];
          data_buf4 <= #0.1 data_buf[23:16];
          data_buf5 <= #0.1 data_buf[31:24];
          data_buf6 <= #0.1 data_buf[39:32];
          data_buf7 <= #0.1 data_buf[47:40];
          data_buf8 <= #0.1 data_buf[63:56];    // wbe lower byte
        end
        3'h2: begin // buf0: cmd, buf1: length (not shift out), id=buf[47:40].
          data_buf1 <= #0.1 data_buf[47:40];
          data_buf3 <= #0.1 data_buf[7:0];
          data_buf4 <= #0.1 data_buf[15:8];
          data_buf5 <= #0.1 data_buf[23:16];
          data_buf6 <= #0.1 data_buf[31:24];
          data_buf7 <= #0.1 data_buf[39:32];
          data_buf8 <= #0.1 data_buf[55:48];    // wbe lower byte
          data_buf9 <= #0.1 data_buf[63:56];
        end
        3'h3: begin // buf0: cmd, buf1: length (not shift out), id=buf[39:32].
          data_buf1  <= #0.1 data_buf[39:32];
          data_buf4  <= #0.1 data_buf[7:0];
          data_buf5  <= #0.1 data_buf[15:8];
          data_buf6  <= #0.1 data_buf[23:16];
          data_buf7  <= #0.1 data_buf[31:24];
          data_buf8  <= #0.1 data_buf[47:40];   // wbe lower byte
          data_buf9  <= #0.1 data_buf[55:48];
          data_buf10 <= #0.1 data_buf[63:56];
        end
        3'h4: begin // buf0: cmd, buf1: length (not shift out), id=buf[31:24].
          data_buf1  <= #0.1 data_buf[31:24];
          data_buf5  <= #0.1 data_buf[7:0];
          data_buf6  <= #0.1 data_buf[15:8];
          data_buf7  <= #0.1 data_buf[23:16];
          data_buf8  <= #0.1 data_buf[39:32];   // wbe lower byte
          data_buf9  <= #0.1 data_buf[47:40];
          data_buf10 <= #0.1 data_buf[55:48];
          data_buf11 <= #0.1 data_buf[63:56];
        end
        3'h5: begin // buf0: cmd, buf1: length (not shift out), id=buf[23:16].
          data_buf1  <= #0.1 data_buf[23:16];
          data_buf6  <= #0.1 data_buf[7:0];
          data_buf7  <= #0.1 data_buf[15:8];
          data_buf8  <= #0.1 data_buf[31:24];   // wbe lower byte
          data_buf9  <= #0.1 data_buf[39:32];
          data_buf10 <= #0.1 data_buf[47:40];
          data_buf11 <= #0.1 data_buf[55:48];
          data_buf12 <= #0.1 data_buf[63:56];
        end
        3'h6: begin // buf0: cmd, buf1: length (not shift out), id=buf[15:8].
          data_buf1  <= #0.1 data_buf[15:8];
          data_buf7  <= #0.1 data_buf[7:0];
          data_buf8  <= #0.1 data_buf[23:16];   // wbe lower byte
          data_buf9  <= #0.1 data_buf[31:24];
          data_buf10 <= #0.1 data_buf[39:32];
          data_buf11 <= #0.1 data_buf[47:40];
          data_buf12 <= #0.1 data_buf[55:48];
          data_buf13 <= #0.1 data_buf[63:56];
        end
        default: begin // buf0: cmd, buf1: length (not shift out), id=buf[7:0].
          if (cpum_wreq) begin
            data_buf1  <= #0.1 data_buf[7:0];
            data_buf8  <= #0.1 data_buf[15:8];    // wbe lower byte
            data_buf9  <= #0.1 data_buf[23:16];
            data_buf10 <= #0.1 data_buf[31:24];
            data_buf11 <= #0.1 data_buf[39:32];
            data_buf12 <= #0.1 data_buf[47:40];
            data_buf13 <= #0.1 data_buf[55:48];
            data_buf14 <= #0.1 data_buf[63:56];
          end
        end
      endcase
    end else if (inc_bcnt) begin
      case (data_bcnt[2:0])
        3'h0: begin
          data_buf0 <= #0.1 data_buf[7:0];
          data_buf1 <= #0.1 data_buf[15:8];
          data_buf2 <= #0.1 data_buf[23:16];
          data_buf3 <= #0.1 data_buf[31:24];
          data_buf4 <= #0.1 data_buf[39:32];
          data_buf5 <= #0.1 data_buf[47:40];
          data_buf6 <= #0.1 data_buf[55:48];
          data_buf7 <= #0.1 data_buf[63:56];
        end
        3'h1: begin
          if (dec_bcnt0&(dec_bnum[2:0]==3'h1)) begin
            data_buf0 <= #0.1 data_buf[7:0];
            data_buf1 <= #0.1 data_buf[15:8];
            data_buf2 <= #0.1 data_buf[23:16];
            data_buf3 <= #0.1 data_buf[31:24];
            data_buf4 <= #0.1 data_buf[39:32];
            data_buf5 <= #0.1 data_buf[47:40];
            data_buf6 <= #0.1 data_buf[55:48];
            data_buf7 <= #0.1 data_buf[63:56];
          end else begin
            if (bcnt_dec8) begin
              data_buf0 <= #0.1 data_buf8;
            end
            data_buf1 <= #0.1 data_buf[7:0];
            data_buf2 <= #0.1 data_buf[15:8];
            data_buf3 <= #0.1 data_buf[23:16];
            data_buf4 <= #0.1 data_buf[31:24];
            data_buf5 <= #0.1 data_buf[39:32];
            data_buf6 <= #0.1 data_buf[47:40];
            data_buf7 <= #0.1 data_buf[55:48];
            data_buf8 <= #0.1 data_buf[63:56];
          end
        end
        3'h2: begin
          if (dec_bcnt0&(dec_bnum[2:0]==3'h1)) begin
            data_buf0 <= #0.1 data_buf1;
            data_buf1 <= #0.1 data_buf[7:0];
            data_buf2 <= #0.1 data_buf[15:8];
            data_buf3 <= #0.1 data_buf[23:16];
            data_buf4 <= #0.1 data_buf[31:24];
            data_buf5 <= #0.1 data_buf[39:32];
            data_buf6 <= #0.1 data_buf[47:40];
            data_buf7 <= #0.1 data_buf[55:48];
            data_buf8 <= #0.1 data_buf[63:56];
          end else if (dec_bcnt0&(dec_bnum[2:0]==3'h2)) begin
            data_buf0 <= #0.1 data_buf[7:0];
            data_buf1 <= #0.1 data_buf[15:8];
            data_buf2 <= #0.1 data_buf[23:16];
            data_buf3 <= #0.1 data_buf[31:24];
            data_buf4 <= #0.1 data_buf[39:32];
            data_buf5 <= #0.1 data_buf[47:40];
            data_buf6 <= #0.1 data_buf[55:48];
            data_buf7 <= #0.1 data_buf[63:56];
          end else begin
            if (bcnt_dec8) begin
              data_buf0 <= #0.1 data_buf8;
              data_buf1 <= #0.1 data_buf9;
            end
            data_buf2 <= #0.1 data_buf[7:0];
            data_buf3 <= #0.1 data_buf[15:8];
            data_buf4 <= #0.1 data_buf[23:16];
            data_buf5 <= #0.1 data_buf[31:24];
            data_buf6 <= #0.1 data_buf[39:32];
            data_buf7 <= #0.1 data_buf[47:40];
            data_buf8 <= #0.1 data_buf[55:48];
            data_buf9 <= #0.1 data_buf[63:56];
          end
        end
        3'h3: begin
          if (~dec_bcnt0 | bcnt_dec8) begin
            if (bcnt_dec8) begin
              data_buf0 <= #0.1 data_buf8;
              data_buf1 <= #0.1 data_buf9;
              data_buf2 <= #0.1 data_buf10;
            end
            data_buf3  <= #0.1 data_buf[7:0];
            data_buf4  <= #0.1 data_buf[15:8];
            data_buf5  <= #0.1 data_buf[23:16];
            data_buf6  <= #0.1 data_buf[31:24];
            data_buf7  <= #0.1 data_buf[39:32];
            data_buf8  <= #0.1 data_buf[47:40];
            data_buf9  <= #0.1 data_buf[55:48];
            data_buf10 <= #0.1 data_buf[63:56];
          end else if (dec_bcnt0) begin
            case (dec_bnum[2:0])
              3'h1: begin
                data_buf0 <= #0.1 data_buf1;
                data_buf1 <= #0.1 data_buf2;
                data_buf2 <= #0.1 data_buf[7:0];
                data_buf3 <= #0.1 data_buf[15:8];
                data_buf4 <= #0.1 data_buf[23:16];
                data_buf5 <= #0.1 data_buf[31:24];
                data_buf6 <= #0.1 data_buf[39:32];
                data_buf7 <= #0.1 data_buf[47:40];
                data_buf8 <= #0.1 data_buf[55:48];
                data_buf9 <= #0.1 data_buf[63:56];
              end
              3'h2: begin
                data_buf0 <= #0.1 data_buf2;
                data_buf1 <= #0.1 data_buf[7:0];
                data_buf2 <= #0.1 data_buf[15:8];
                data_buf3 <= #0.1 data_buf[23:16];
                data_buf4 <= #0.1 data_buf[31:24];
                data_buf5 <= #0.1 data_buf[39:32];
                data_buf6 <= #0.1 data_buf[47:40];
                data_buf7 <= #0.1 data_buf[55:48];
                data_buf8 <= #0.1 data_buf[63:56];
              end
              3'h3: begin
                data_buf0 <= #0.1 data_buf[7:0];
                data_buf1 <= #0.1 data_buf[15:8];
                data_buf2 <= #0.1 data_buf[23:16];
                data_buf3 <= #0.1 data_buf[31:24];
                data_buf4 <= #0.1 data_buf[39:32];
                data_buf5 <= #0.1 data_buf[47:40];
                data_buf6 <= #0.1 data_buf[55:48];
                data_buf7 <= #0.1 data_buf[63:56];
              end
              default:; //
            endcase
          end
        end
        3'h4: begin
          if (~dec_bcnt0 | bcnt_dec8) begin
            if (bcnt_dec8) begin
              data_buf0 <= #0.1 data_buf8;
              data_buf1 <= #0.1 data_buf9;
              data_buf2 <= #0.1 data_buf10;
              data_buf3 <= #0.1 data_buf11;
            end
            data_buf4  <= #0.1 data_buf[7:0];
            data_buf5  <= #0.1 data_buf[15:8];
            data_buf6  <= #0.1 data_buf[23:16];
            data_buf7  <= #0.1 data_buf[31:24];
            data_buf8  <= #0.1 data_buf[39:32];
            data_buf9  <= #0.1 data_buf[47:40];
            data_buf10 <= #0.1 data_buf[55:48];
            data_buf11 <= #0.1 data_buf[63:56];
          end else if (dec_bcnt0) begin
            case (dec_bnum[2:0])
              3'h1: begin
                data_buf0  <= #0.1 data_buf1;
                data_buf1  <= #0.1 data_buf2;
                data_buf2  <= #0.1 data_buf3;
                data_buf3  <= #0.1 data_buf[7:0];
                data_buf4  <= #0.1 data_buf[15:8];
                data_buf5  <= #0.1 data_buf[23:16];
                data_buf6  <= #0.1 data_buf[31:24];
                data_buf7  <= #0.1 data_buf[39:32];
                data_buf8  <= #0.1 data_buf[47:40];
                data_buf9  <= #0.1 data_buf[55:48];
                data_buf10 <= #0.1 data_buf[63:56];
              end
              3'h2: begin
                data_buf0 <= #0.1 data_buf2;
                data_buf1 <= #0.1 data_buf3;
                data_buf2 <= #0.1 data_buf[7:0];
                data_buf3 <= #0.1 data_buf[15:8];
                data_buf4 <= #0.1 data_buf[23:16];
                data_buf5 <= #0.1 data_buf[31:24];
                data_buf6 <= #0.1 data_buf[39:32];
                data_buf7 <= #0.1 data_buf[47:40];
                data_buf8 <= #0.1 data_buf[55:48];
                data_buf9 <= #0.1 data_buf[63:56];
              end
              3'h3: begin
                data_buf0 <= #0.1 data_buf3;
                data_buf1 <= #0.1 data_buf[7:0];
                data_buf2 <= #0.1 data_buf[15:8];
                data_buf3 <= #0.1 data_buf[23:16];
                data_buf4 <= #0.1 data_buf[31:24];
                data_buf5 <= #0.1 data_buf[39:32];
                data_buf6 <= #0.1 data_buf[47:40];
                data_buf7 <= #0.1 data_buf[55:48];
                data_buf8 <= #0.1 data_buf[63:56];
              end
              3'h4: begin
                data_buf0 <= #0.1 data_buf[7:0];
                data_buf1 <= #0.1 data_buf[15:8];
                data_buf2 <= #0.1 data_buf[23:16];
                data_buf3 <= #0.1 data_buf[31:24];
                data_buf4 <= #0.1 data_buf[39:32];
                data_buf5 <= #0.1 data_buf[47:40];
                data_buf6 <= #0.1 data_buf[55:48];
                data_buf7 <= #0.1 data_buf[63:56];
              end
              default:; //
            endcase
          end
        end
        3'h5: begin
          if (~dec_bcnt0 | bcnt_dec8) begin
            if (bcnt_dec8) begin
              data_buf0 <= #0.1 data_buf8;
              data_buf1 <= #0.1 data_buf9;
              data_buf2 <= #0.1 data_buf10;
              data_buf3 <= #0.1 data_buf11;
              data_buf4 <= #0.1 data_buf12;
            end
            data_buf5  <= #0.1 data_buf[7:0];
            data_buf6  <= #0.1 data_buf[15:8];
            data_buf7  <= #0.1 data_buf[23:16];
            data_buf8  <= #0.1 data_buf[31:24];
            data_buf9  <= #0.1 data_buf[39:32];
            data_buf10 <= #0.1 data_buf[47:40];
            data_buf11 <= #0.1 data_buf[55:48];
            data_buf12 <= #0.1 data_buf[63:56];
          end else if (dec_bcnt0) begin
            case (dec_bnum[2:0])
              3'h1: begin
                data_buf0  <= #0.1 data_buf1;
                data_buf1  <= #0.1 data_buf2;
                data_buf2  <= #0.1 data_buf3;
                data_buf3  <= #0.1 data_buf4;
                data_buf4  <= #0.1 data_buf[7:0];
                data_buf5  <= #0.1 data_buf[15:8];
                data_buf6  <= #0.1 data_buf[23:16];
                data_buf7  <= #0.1 data_buf[31:24];
                data_buf8  <= #0.1 data_buf[39:32];
                data_buf9  <= #0.1 data_buf[47:40];
                data_buf10 <= #0.1 data_buf[55:48];
                data_buf11 <= #0.1 data_buf[63:56];
              end
              3'h2: begin
                data_buf0  <= #0.1 data_buf2;
                data_buf1  <= #0.1 data_buf3;
                data_buf2  <= #0.1 data_buf4;
                data_buf3  <= #0.1 data_buf[7:0];
                data_buf4  <= #0.1 data_buf[15:8];
                data_buf5  <= #0.1 data_buf[23:16];
                data_buf6  <= #0.1 data_buf[31:24];
                data_buf7  <= #0.1 data_buf[39:32];
                data_buf8  <= #0.1 data_buf[47:40];
                data_buf9  <= #0.1 data_buf[55:48];
                data_buf10 <= #0.1 data_buf[63:56];
              end
              3'h3: begin
                data_buf0 <= #0.1 data_buf3;
                data_buf1 <= #0.1 data_buf4;
                data_buf2 <= #0.1 data_buf[7:0];
                data_buf3 <= #0.1 data_buf[15:8];
                data_buf4 <= #0.1 data_buf[23:16];
                data_buf5 <= #0.1 data_buf[31:24];
                data_buf6 <= #0.1 data_buf[39:32];
                data_buf7 <= #0.1 data_buf[47:40];
                data_buf8 <= #0.1 data_buf[55:48];
                data_buf9 <= #0.1 data_buf[63:56];
              end
              3'h4: begin
                data_buf0 <= #0.1 data_buf4;
                data_buf1 <= #0.1 data_buf[7:0];
                data_buf2 <= #0.1 data_buf[15:8];
                data_buf3 <= #0.1 data_buf[23:16];
                data_buf4 <= #0.1 data_buf[31:24];
                data_buf5 <= #0.1 data_buf[39:32];
                data_buf6 <= #0.1 data_buf[47:40];
                data_buf7 <= #0.1 data_buf[55:48];
                data_buf8 <= #0.1 data_buf[63:56];
              end
              3'h5: begin
                data_buf0 <= #0.1 data_buf[7:0];
                data_buf1 <= #0.1 data_buf[15:8];
                data_buf2 <= #0.1 data_buf[23:16];
                data_buf3 <= #0.1 data_buf[31:24];
                data_buf4 <= #0.1 data_buf[39:32];
                data_buf5 <= #0.1 data_buf[47:40];
                data_buf6 <= #0.1 data_buf[55:48];
                data_buf7 <= #0.1 data_buf[63:56];
              end
              default:; //
            endcase
          end
        end
        3'h6: begin
          if (~dec_bcnt0 | bcnt_dec8) begin
            if (bcnt_dec8) begin
              data_buf0 <= #0.1 data_buf8;
              data_buf1 <= #0.1 data_buf9;
              data_buf2 <= #0.1 data_buf10;
              data_buf3 <= #0.1 data_buf11;
              data_buf4 <= #0.1 data_buf12;
              data_buf5 <= #0.1 data_buf13;
            end
            data_buf6  <= #0.1 data_buf[7:0];
            data_buf7  <= #0.1 data_buf[15:8];
            data_buf8  <= #0.1 data_buf[23:16];
            data_buf9  <= #0.1 data_buf[31:24];
            data_buf10 <= #0.1 data_buf[39:32];
            data_buf11 <= #0.1 data_buf[47:40];
            data_buf12 <= #0.1 data_buf[55:48];
            data_buf13 <= #0.1 data_buf[63:56];
          end else if (dec_bcnt0) begin
            case (dec_bnum[2:0])
              3'h1: begin
                data_buf0  <= #0.1 data_buf1;
                data_buf1  <= #0.1 data_buf2;
                data_buf2  <= #0.1 data_buf3;
                data_buf3  <= #0.1 data_buf4;
                data_buf4  <= #0.1 data_buf5;
                data_buf5  <= #0.1 data_buf[7:0];
                data_buf6  <= #0.1 data_buf[15:8];
                data_buf7  <= #0.1 data_buf[23:16];
                data_buf8  <= #0.1 data_buf[31:24];
                data_buf9  <= #0.1 data_buf[39:32];
                data_buf10 <= #0.1 data_buf[47:40];
                data_buf11 <= #0.1 data_buf[55:48];
                data_buf12 <= #0.1 data_buf[63:56];
              end
              3'h2: begin
                data_buf0  <= #0.1 data_buf2;
                data_buf1  <= #0.1 data_buf3;
                data_buf2  <= #0.1 data_buf4;
                data_buf3  <= #0.1 data_buf5;
                data_buf4  <= #0.1 data_buf[7:0];
                data_buf5  <= #0.1 data_buf[15:8];
                data_buf6  <= #0.1 data_buf[23:16];
                data_buf7  <= #0.1 data_buf[31:24];
                data_buf8  <= #0.1 data_buf[39:32];
                data_buf9  <= #0.1 data_buf[47:40];
                data_buf10 <= #0.1 data_buf[55:48];
                data_buf11 <= #0.1 data_buf[63:56];
              end
              3'h3: begin
                data_buf0  <= #0.1 data_buf3;
                data_buf1  <= #0.1 data_buf4;
                data_buf2  <= #0.1 data_buf5;
                data_buf3  <= #0.1 data_buf[7:0];
                data_buf4  <= #0.1 data_buf[15:8];
                data_buf5  <= #0.1 data_buf[23:16];
                data_buf6  <= #0.1 data_buf[31:24];
                data_buf7  <= #0.1 data_buf[39:32];
                data_buf8  <= #0.1 data_buf[47:40];
                data_buf9  <= #0.1 data_buf[55:48];
                data_buf10 <= #0.1 data_buf[63:56];
              end
              3'h4: begin
                data_buf0 <= #0.1 data_buf4;
                data_buf1 <= #0.1 data_buf5;
                data_buf2 <= #0.1 data_buf[7:0];
                data_buf3 <= #0.1 data_buf[15:8];
                data_buf4 <= #0.1 data_buf[23:16];
                data_buf5 <= #0.1 data_buf[31:24];
                data_buf6 <= #0.1 data_buf[39:32];
                data_buf7 <= #0.1 data_buf[47:40];
                data_buf8 <= #0.1 data_buf[55:48];
                data_buf9 <= #0.1 data_buf[63:56];
              end
              3'h5: begin
                data_buf0 <= #0.1 data_buf5;
                data_buf1 <= #0.1 data_buf[7:0];
                data_buf2 <= #0.1 data_buf[15:8];
                data_buf3 <= #0.1 data_buf[23:16];
                data_buf4 <= #0.1 data_buf[31:24];
                data_buf5 <= #0.1 data_buf[39:32];
                data_buf6 <= #0.1 data_buf[47:40];
                data_buf7 <= #0.1 data_buf[55:48];
                data_buf8 <= #0.1 data_buf[63:56];
              end
              3'h6: begin
                data_buf0 <= #0.1 data_buf[7:0];
                data_buf1 <= #0.1 data_buf[15:8];
                data_buf2 <= #0.1 data_buf[23:16];
                data_buf3 <= #0.1 data_buf[31:24];
                data_buf4 <= #0.1 data_buf[39:32];
                data_buf5 <= #0.1 data_buf[47:40];
                data_buf6 <= #0.1 data_buf[55:48];
                data_buf7 <= #0.1 data_buf[63:56];
              end
              default:; //
            endcase
          end
        end
        default: begin  // 3'h7
          if (~dec_bcnt0 | bcnt_dec8) begin
            if (bcnt_dec8) begin
              data_buf0 <= #0.1 data_buf8;
              data_buf1 <= #0.1 data_buf9;
              data_buf2 <= #0.1 data_buf10;
              data_buf3 <= #0.1 data_buf11;
              data_buf4 <= #0.1 data_buf12;
              data_buf5 <= #0.1 data_buf13;
              data_buf6 <= #0.1 data_buf14;
            end
            data_buf7  <= #0.1 data_buf[7:0];
            data_buf8  <= #0.1 data_buf[15:8];
            data_buf9  <= #0.1 data_buf[23:16];
            data_buf10 <= #0.1 data_buf[31:24];
            data_buf11 <= #0.1 data_buf[39:32];
            data_buf12 <= #0.1 data_buf[47:40];
            data_buf13 <= #0.1 data_buf[55:48];
            data_buf14 <= #0.1 data_buf[63:56];
          end else if (dec_bcnt0) begin
            case (dec_bnum[2:0])
              3'h1: begin
                data_buf0  <= #0.1 data_buf1;
                data_buf1  <= #0.1 data_buf2;
                data_buf2  <= #0.1 data_buf3;
                data_buf3  <= #0.1 data_buf4;
                data_buf4  <= #0.1 data_buf5;
                data_buf5  <= #0.1 data_buf6;
                data_buf6  <= #0.1 data_buf[7:0];
                data_buf7  <= #0.1 data_buf[15:8];
                data_buf8  <= #0.1 data_buf[23:16];
                data_buf9  <= #0.1 data_buf[31:24];
                data_buf10 <= #0.1 data_buf[39:32];
                data_buf11 <= #0.1 data_buf[47:40];
                data_buf12 <= #0.1 data_buf[55:48];
                data_buf13 <= #0.1 data_buf[63:56];
              end
              3'h2: begin
                data_buf0  <= #0.1 data_buf2;
                data_buf1  <= #0.1 data_buf3;
                data_buf2  <= #0.1 data_buf4;
                data_buf3  <= #0.1 data_buf5;
                data_buf4  <= #0.1 data_buf6;
                data_buf5  <= #0.1 data_buf[7:0];
                data_buf6  <= #0.1 data_buf[15:8];
                data_buf7  <= #0.1 data_buf[23:16];
                data_buf8  <= #0.1 data_buf[31:24];
                data_buf9  <= #0.1 data_buf[39:32];
                data_buf10 <= #0.1 data_buf[47:40];
                data_buf11 <= #0.1 data_buf[55:48];
                data_buf12 <= #0.1 data_buf[63:56];
              end
              3'h3: begin
                data_buf0  <= #0.1 data_buf3;
                data_buf1  <= #0.1 data_buf4;
                data_buf2  <= #0.1 data_buf5;
                data_buf3  <= #0.1 data_buf6;
                data_buf4  <= #0.1 data_buf[7:0];
                data_buf5  <= #0.1 data_buf[15:8];
                data_buf6  <= #0.1 data_buf[23:16];
                data_buf7  <= #0.1 data_buf[31:24];
                data_buf8  <= #0.1 data_buf[39:32];
                data_buf9  <= #0.1 data_buf[47:40];
                data_buf10 <= #0.1 data_buf[55:48];
                data_buf11 <= #0.1 data_buf[63:56];
              end
              3'h4: begin
                data_buf0  <= #0.1 data_buf4;
                data_buf1  <= #0.1 data_buf5;
                data_buf2  <= #0.1 data_buf6;
                data_buf3  <= #0.1 data_buf[7:0];
                data_buf4  <= #0.1 data_buf[15:8];
                data_buf5  <= #0.1 data_buf[23:16];
                data_buf6  <= #0.1 data_buf[31:24];
                data_buf7  <= #0.1 data_buf[39:32];
                data_buf8  <= #0.1 data_buf[47:40];
                data_buf9  <= #0.1 data_buf[55:48];
                data_buf10 <= #0.1 data_buf[63:56];
              end
              3'h5: begin
                data_buf0 <= #0.1 data_buf5;
                data_buf1 <= #0.1 data_buf6;
                data_buf2 <= #0.1 data_buf[7:0];
                data_buf3 <= #0.1 data_buf[15:8];
                data_buf4 <= #0.1 data_buf[23:16];
                data_buf5 <= #0.1 data_buf[31:24];
                data_buf6 <= #0.1 data_buf[39:32];
                data_buf7 <= #0.1 data_buf[47:40];
                data_buf8 <= #0.1 data_buf[55:48];
                data_buf9 <= #0.1 data_buf[63:56];
              end
              3'h6: begin
                data_buf0 <= #0.1 data_buf6;
                data_buf1 <= #0.1 data_buf[7:0];
                data_buf2 <= #0.1 data_buf[15:8];
                data_buf3 <= #0.1 data_buf[23:16];
                data_buf4 <= #0.1 data_buf[31:24];
                data_buf5 <= #0.1 data_buf[39:32];
                data_buf6 <= #0.1 data_buf[47:40];
                data_buf7 <= #0.1 data_buf[55:48];
                data_buf8 <= #0.1 data_buf[63:56];
              end
              3'h7: begin
                data_buf0 <= #0.1 data_buf[7:0];
                data_buf1 <= #0.1 data_buf[15:8];
                data_buf2 <= #0.1 data_buf[23:16];
                data_buf3 <= #0.1 data_buf[31:24];
                data_buf4 <= #0.1 data_buf[39:32];
                data_buf5 <= #0.1 data_buf[47:40];
                data_buf6 <= #0.1 data_buf[55:48];
                data_buf7 <= #0.1 data_buf[63:56];
              end
              default:; //
            endcase
          end
        end
      endcase
    end else if (dec_bcnt0) begin
      case (dec_bnum[2:0])
        3'h1: begin
          data_buf0  <= #0.1 data_buf1;
          data_buf1  <= #0.1 data_buf2;
          data_buf2  <= #0.1 data_buf3;
          data_buf3  <= #0.1 data_buf4;
          data_buf4  <= #0.1 data_buf5;
          data_buf5  <= #0.1 data_buf6;
          data_buf6  <= #0.1 data_buf7;
          data_buf7  <= #0.1 data_buf8;
          data_buf8  <= #0.1 data_buf9;
          data_buf9  <= #0.1 data_buf10;
          data_buf10 <= #0.1 data_buf11;
          data_buf11 <= #0.1 data_buf12;
          data_buf12 <= #0.1 data_buf13;
          data_buf13 <= #0.1 data_buf14;
        end
        3'h2: begin
          data_buf0  <= #0.1 data_buf2;
          data_buf1  <= #0.1 data_buf3;
          data_buf2  <= #0.1 data_buf4;
          data_buf3  <= #0.1 data_buf5;
          data_buf4  <= #0.1 data_buf6;
          data_buf5  <= #0.1 data_buf7;
          data_buf6  <= #0.1 data_buf8;
          data_buf7  <= #0.1 data_buf9;
          data_buf8  <= #0.1 data_buf10;
          data_buf9  <= #0.1 data_buf11;
          data_buf10 <= #0.1 data_buf12;
          data_buf11 <= #0.1 data_buf13;
          data_buf12 <= #0.1 data_buf14;
        end
        3'h3: begin
          data_buf0  <= #0.1 data_buf3;
          data_buf1  <= #0.1 data_buf4;
          data_buf2  <= #0.1 data_buf5;
          data_buf3  <= #0.1 data_buf6;
          data_buf4  <= #0.1 data_buf7;
          data_buf5  <= #0.1 data_buf8;
          data_buf6  <= #0.1 data_buf9;
          data_buf7  <= #0.1 data_buf10;
          data_buf8  <= #0.1 data_buf11;
          data_buf9  <= #0.1 data_buf12;
          data_buf10 <= #0.1 data_buf13;
          data_buf11 <= #0.1 data_buf14;
        end
        3'h4: begin
          data_buf0  <= #0.1 data_buf4;
          data_buf1  <= #0.1 data_buf5;
          data_buf2  <= #0.1 data_buf6;
          data_buf3  <= #0.1 data_buf7;
          data_buf4  <= #0.1 data_buf8;
          data_buf5  <= #0.1 data_buf9;
          data_buf6  <= #0.1 data_buf10;
          data_buf7  <= #0.1 data_buf11;
          data_buf8  <= #0.1 data_buf12;
          data_buf9  <= #0.1 data_buf13;
          data_buf10 <= #0.1 data_buf14;
        end
        3'h5: begin
          data_buf0  <= #0.1 data_buf5;
          data_buf1  <= #0.1 data_buf6;
          data_buf2  <= #0.1 data_buf7;
          data_buf3  <= #0.1 data_buf8;
          data_buf4  <= #0.1 data_buf9;
          data_buf5  <= #0.1 data_buf10;
          data_buf6  <= #0.1 data_buf11;
          data_buf7  <= #0.1 data_buf12;
          data_buf8  <= #0.1 data_buf13;
          data_buf9  <= #0.1 data_buf14;
        end
        3'h6: begin
          data_buf0  <= #0.1 data_buf6;
          data_buf1  <= #0.1 data_buf7;
          data_buf2  <= #0.1 data_buf8;
          data_buf3  <= #0.1 data_buf9;
          data_buf4  <= #0.1 data_buf10;
          data_buf5  <= #0.1 data_buf11;
          data_buf6  <= #0.1 data_buf12;
          data_buf7  <= #0.1 data_buf13;
          data_buf8  <= #0.1 data_buf14;
        end
        3'h7: begin
          data_buf0  <= #0.1 data_buf7;
          data_buf1  <= #0.1 data_buf8;
          data_buf2  <= #0.1 data_buf9;
          data_buf3  <= #0.1 data_buf10;
          data_buf4  <= #0.1 data_buf11;
          data_buf5  <= #0.1 data_buf12;
          data_buf6  <= #0.1 data_buf13;
          data_buf7  <= #0.1 data_buf14;
        end
        default: begin  // 3'h0 for 4'h8.
          data_buf0  <= #0.1 data_buf8;
          data_buf1  <= #0.1 data_buf9;
          data_buf2  <= #0.1 data_buf10;
          data_buf3  <= #0.1 data_buf11;
          data_buf4  <= #0.1 data_buf12;
          data_buf5  <= #0.1 data_buf13;
          data_buf6  <= #0.1 data_buf14;
        end
      endcase
    end else if (dec_bcnt1&data_bcnt[3]) begin
      case (data_bcnt[2:0])
        3'h1: begin
          data_buf1 <= #0.1 data_buf8;
        end
        3'h2: begin
          data_buf1 <= #0.1 data_buf8;
          data_buf8 <= #0.1 data_buf9;
        end
        3'h3: begin
          data_buf1 <= #0.1 data_buf8;
          data_buf8 <= #0.1 data_buf9;
          data_buf9 <= #0.1 data_buf10;
        end
        3'h4: begin
          data_buf1  <= #0.1 data_buf8;
          data_buf8  <= #0.1 data_buf9;
          data_buf9  <= #0.1 data_buf10;
          data_buf10 <= #0.1 data_buf11;
        end
        3'h5: begin
          data_buf1  <= #0.1 data_buf8;
          data_buf8  <= #0.1 data_buf9;
          data_buf9  <= #0.1 data_buf10;
          data_buf10 <= #0.1 data_buf11;
          data_buf11 <= #0.1 data_buf12;
        end
        3'h6: begin
          data_buf1  <= #0.1 data_buf8;
          data_buf8  <= #0.1 data_buf9;
          data_buf9  <= #0.1 data_buf10;
          data_buf10 <= #0.1 data_buf11;
          data_buf11 <= #0.1 data_buf12;
          data_buf12 <= #0.1 data_buf13;
        end
        3'h7: begin
          data_buf1  <= #0.1 data_buf8;
          data_buf8  <= #0.1 data_buf9;
          data_buf9  <= #0.1 data_buf10;
          data_buf10 <= #0.1 data_buf11;
          data_buf11 <= #0.1 data_buf12;
          data_buf12 <= #0.1 data_buf13;
          data_buf13 <= #0.1 data_buf14;
        end
        default:;   // 3'h0
      endcase
    end
  end
end

assign data_pkt   = dma_req | cpu_rdata | cpu_wdata;
assign last_trans = ~(|tran_cnt[7:3]) & (data_bcnt[3:0] > tran_cnt[2:0]);
always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    cmd_vld <= #0.1 1'b1;
  else begin
    if (cmd_vld&data_pkt&~sft_rst)
      cmd_vld <= #0.1 1'b0;
    else if ((last_trans&((cpum_dvld&cpum_wrdy)|(cpus_dvld&cpus_rrdy)|(dma_dvld&dma_wrdy)))|sft_rst)
      cmd_vld <= #0.1 1'b1;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    cpum_wreq <= #0.1 1'b0;
  else begin
    if (cmd_vld & cpu_wdata & ~sft_rst)
      cpum_wreq <= #0.1 1'b1;
    else if ((cpum_wreq & data_bcnt[3] & cpum_acp_w)|sft_rst)
      cpum_wreq <= #0.1 1'b0;
  end
end

always @ (*) begin
  case (data_buf3[6:4])
    3'b000 : cpum_dlen = {3'h0, data_buf2[3:0]};         // 8bit
    3'b001 : cpum_dlen = {2'h0, data_buf2[3:0], 1'b1};   // 16bit
    3'b010 : cpum_dlen = {1'b0, data_buf2[3:0], 2'b11};  // 32bit
    3'b011 : cpum_dlen = {data_buf2[3:0], 3'b111};       // 64bit
    default: cpum_dlen = {data_buf2[2:0], 4'b1111};      // 128bit
  endcase
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wbe_len <= #0.1 4'h0;
  else begin
    if (cpum_wreq & data_bcnt[3] & cpum_acp_w)
      wbe_len <= #0.1 cpum_dlen[5:3] + 1'b1;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wbe_l8b <= #0.1 1'b0;
  else begin
    if (cpum_wreq & data_bcnt[3] & cpum_acp_w)
      wbe_l8b <= #0.1 cpum_dlen[6];
    else if (data_bcnt[3])
      wbe_l8b <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wbe_sel <= #0.1 1'b0;
  else begin
    if (wbe_vld&wbe_l8b&~sft_rst)
      wbe_sel <= #0.1 1'b1;
    else if (wbe_vld|sft_rst)
      wbe_sel <= #0.1 1'b0;
  end
end

assign wbe_vld = wbe_pend & (((data_bcnt[3:0] >= wbe_len[3:0])&~wbe_l8b)|(data_bcnt[3]&wbe_l8b));
always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wbe_pend <= #0.1 1'b0;
  else begin
    if (cpum_wreq&data_bcnt[3]&cpum_acp_w&~sft_rst)
      wbe_pend <= #0.1 1'b1;
    else if ((wbe_vld&~wbe_l8b)|sft_rst)
      wbe_pend <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    cpum_dvld <= #0.1 1'b0;
  else begin
    if (wbe_vld&~wbe_l8b&~sft_rst)
      cpum_dvld <= #0.1 1'b1;
    else if ((last_trans&cpum_dvld&cpum_wrdy)|sft_rst)
      cpum_dvld <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    cpus_dvld <= #0.1 1'b0;
  else begin
    if (cmd_vld&cpu_rdata&~sft_rst)
      cpus_dvld <= #0.1 1'b1;
    else if ((last_trans&cpus_dvld&cpus_rrdy)|sft_rst)
      cpus_dvld <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    dma_dvld <= #0.1 1'b0;
  else begin
    if (cmd_vld&dma_req&~sft_rst)
      dma_dvld <= #0.1 1'b1;
    else if ((last_trans&dma_dvld&dma_wrdy)|sft_rst)
      dma_dvld <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    tran_cnt <= #0.1 9'h0;
  else begin
    if (sft_rst)
      tran_cnt <= #0.1 9'h0;
    else if (cpum_wreq&data_bcnt[3]&cpum_acp_w)
      tran_cnt <= #0.1 {2'h0, cpum_dlen};
    else if (cmd_vld&cpu_rdata)
      tran_cnt <= #0.1 data_buf1[7:0] - 3'h4;
    else if (cmd_vld&dma_req)
      tran_cnt <= #0.1 data_buf1[7:0] - 2'h3;
    else if (data_wdone) begin
      if (last_trans)
        tran_cnt <= #0.1 9'h0;
      else
        tran_cnt <= #0.1 tran_cnt[7:0] - 4'h8;
    end
  end
end
//******************************************************************************
assign cpum_acp_w  = ~cpum_req | (cpum_req&cpum_acp);
assign cpus_acp1_w = ~cpus_req1 | (cpus_req1&cpus_acp1);

assign cpum_wvld  = (data_bcnt[3]|last_trans) & cpum_dvld;
assign cpus_rvld  = (data_bcnt[3]|last_trans) & cpus_dvld;
assign dma_wvld   = (data_bcnt[3]|last_trans) & dma_dvld;

assign cpum_wdata = {wbe_tmp[7:0], data_buf7, data_buf6, data_buf5, data_buf4, data_buf3, data_buf2, data_buf1, data_buf0};
assign cpus_rdata = {data_buf7, data_buf6, data_buf5, data_buf4, data_buf3, data_buf2, data_buf1, data_buf0};
assign dma_wdata  = {data_buf7, data_buf6, data_buf5, data_buf4, data_buf3, data_buf2, data_buf1, data_buf0};

assign dma_req   = (data_buf0[3:0]==4'h1)&(|data_bcnt[3:1]);
assign cpu_rcmd  = (data_buf0[3:0]==4'h4)&data_bcnt[3];
assign cpu_rdata = (data_buf0[3:0]==4'h5)&(|data_bcnt[3:2]);
assign cpu_wdata = (data_buf0[3:0]==4'h6)&(|data_bcnt[3:0]);
assign cpu_wresp = (data_buf0[3:0]==4'h7)&(|data_bcnt[3:1]);
assign pkt_test  = ((data_buf0[3:0]==4'hE)&(|data_bcnt[3:1]))
                 | ((data_buf0[3:0]==4'hF)&(|data_bcnt[3:1]));
assign pkt_empty = (data_buf0[3:0]!=4'h1)&(data_buf0[3:0]!=4'h4)&(data_buf0[3:0]!=4'h5)&(data_buf0[3:0]!=4'h6) &
                   (data_buf0[3:0]!=4'h7)&(|data_bcnt[3:0]);

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    cpum_req <= #0.1 1'b0;
  else begin
    if (((cmd_vld&cpu_rcmd)|(cpum_wreq&data_bcnt[3]))&cpum_acp_w&~sft_rst)
      cpum_req <= #0.1 1'b1;
    else if (cpum_acp|sft_rst)
      cpum_req <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    cpum_info <= #0.1 59'h0;
  else begin
    if (cmd_vld&cpu_rcmd&cpum_acp_w)
      cpum_info <= #0.1 {1'b0, data_buf3[6:4], data_buf3[2:0], data_buf2, data_buf0[7:4], data_buf1, data_buf7, data_buf6, data_buf5, data_buf4};
    else if (cpum_wreq&data_bcnt[3]&cpum_acp_w)
      cpum_info <= #0.1 {1'b1, data_buf3[6:4], data_buf3[2:0], data_buf2, data_buf0[7:4], data_buf1, data_buf7, data_buf6, data_buf5, data_buf4};
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    cpus_req <= #0.1 1'b0;
  else begin
    if ((cmd_vld&cpu_rdata)&~sft_rst)
      cpus_req <= #0.1 1'b1;
    else if (cpus_req|sft_rst)
      cpus_req <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    cpus_info <= #0.1 18'h0;
  else begin
    if (cmd_vld&cpu_rdata)
      cpus_info <= #0.1 {data_buf0[5:4], data_buf2, data_buf1};
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    cpus_req1 <= #0.1 1'b0;
  else begin
    if ((cmd_vld&cpu_wresp&cpus_acp1_w)&~sft_rst)
      cpus_req1 <= #0.1 1'b1;
    else if (cpus_acp1|sft_rst)
      cpus_req1 <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    cpus_info1 <= #0.1 10'h0;
  else begin
    if (cmd_vld&cpu_wresp&cpus_acp1_w)
      cpus_info1 <= #0.1 {data_buf0[5:4], data_buf1};
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wbe_tmp <= #0.1 128'h0;
  else begin
    if (wbe_vld&wbe_sel)
      wbe_tmp[127:64] <= #0.1 {data_buf7, data_buf6, data_buf5, data_buf4, data_buf3, data_buf2, data_buf1, data_buf0};
    else if (wbe_vld)
      wbe_tmp[63:0] <= #0.1 {data_buf7, data_buf6, data_buf5, data_buf4, data_buf3, data_buf2, data_buf1, data_buf0};
    else if (cpum_wvld&cpum_wrdy)
      wbe_tmp <= #0.1 {8'h0, wbe_tmp[127:8]};
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    dma_ch <= #0.1 3'h0;
  else begin
    if (cmd_vld&dma_req)
      dma_ch <= #0.1 data_buf0[6:4];
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    stest_ack <= #0.1 1'b0;
  else begin
    if (cmd_vld&(|data_bcnt[3:1])&(data_buf0[7:0]==8'hF)&(data_buf1==8'hF0))
      stest_ack <= #0.1 1'b1;
    else
      stest_ack <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    btchk_ack <= #0.1 1'b0;
  else begin
    if (cmd_vld&(|data_bcnt[3:1])&(data_buf0[7:0]==8'hE)&(data_buf1==8'hF1))
      btchk_ack <= #0.1 1'b1;
    else
      btchk_ack <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    btchk_dack_r <= #0.1 1'b0;
  else begin
    if (rd_dvld&sbuf_wen&(data_buf[71:64]==8'h0))
      btchk_dack_r <= #0.1 1'b1;
    else if (btchk_dack_r&((data_bcnt[3:0]==4'h0)|rcv_tend))
      btchk_dack_r <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    btchk_dack <= #0.1 1'b0;
  else begin
    //if (rd_dvld&sbuf_wen&(data_buf[71:64]==8'h0))
    if (btchk_dack_r&((data_bcnt[3:0]==4'h0)|rcv_tend))
      btchk_dack <= #0.1 1'b1;
    else
      btchk_dack <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    btchk_dack_i <= #0.1 1'b0;
  else begin
    if (btchk_dack_r&rcv_tend)
      btchk_dack_i <= #0.1 1'b1;
    else
      btchk_dack_i <= #0.1 1'b0;
  end
end

assign rcv_tend = (cmd_vld&(|data_bcnt[3:1])&(data_buf0[7:0]==8'h1E)&(data_buf1==8'hE1))
                | (cmd_vld&(|data_bcnt[3:1])&(data_buf0[7:0]==8'h2E)&(data_buf1==8'hD1));
always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    btchk_ack1 <= #0.1 1'b0;
  else begin
    if ((rcv_tend&~btchk_dack_r)|btchk_dack_i)
      btchk_ack1 <= #0.1 1'b1;
    else
      btchk_ack1 <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rx_fail <= #0.1 1'b0;
  else begin
    //if (btchk_ack|stest_ack)
    //  rx_fail <= `DLY 1'b0;
    if ((cmd_vld&(|data_bcnt[3:1])&(data_buf0[7:0]==8'h2E)&(data_buf1==8'hD1)) |
             (rd_dvld&sbuf_wen&(data_buf[71:64]==8'h0)&data_buf[0]))
      rx_fail <= #0.1 1'b1;
    else if (~btchk_dack_r)
      rx_fail <= #0.1 1'b0;
  end
end
//******************************************************************************


  always @ (posedge sysclk or negedge sysrstn) begin
    if (~sysrstn)
      rx_req_r <= #0.1 6'h0;
    else begin
      if (rx_req) begin
        case (rx_rch)
          3'h0   : rx_req_r <= #0.1 6'b00_0001;
          3'h1   : rx_req_r <= #0.1 6'b00_0010;
          3'h2   : rx_req_r <= #0.1 6'b00_0100;
          3'h3   : rx_req_r <= #0.1 6'b00_1000;
          3'h4   : rx_req_r <= #0.1 6'b01_0000;
          3'h5   : rx_req_r <= #0.1 6'b10_0000;
          default: rx_req_r <= #0.1 6'h0;
        endcase
      end else
        rx_req_r <= #0.1 6'h0;
    end
  end

  genvar ch;
  generate
    for (ch=0; ch<6; ch=ch+1) begin: RSTOP

      always @ (posedge sysclk or negedge sysrstn) begin
        if (~sysrstn)
          rx_stop[ch] <= #0.1 1'b0;
        else begin
          if (rx_sack&(rx_sch==ch)&~sft_rst)
            rx_stop[ch] <= #0.1 1'b1;
          else if (rx_sdone[ch]|sft_rst)
            rx_stop[ch] <= #0.1 1'b0;
        end
      end

      assign rx_pop[ch] = cmd_vld&dma_req&(data_buf0[6:4]==ch);

      wire [8:0] rch_vld_0 = rch_vld[0];
      wire [8:0] rch_vld_1 = rch_vld[1];
      wire [8:0] rch_vld_2 = rch_vld[2];
      wire [8:0] rch_vld_3 = rch_vld[3];
      wire [8:0] rch_vld_4 = rch_vld[4];
      wire [8:0] rch_vld_5 = rch_vld[5];

      always @ (posedge sysclk or negedge sysrstn) begin
        if (~sysrstn)
          rch_vld[ch] <= #0.1 9'h0;
        else begin
          if (sft_rst)
            rch_vld[ch] <= #0.1 9'h0;   // novas s-23028
          else begin
            case ({rx_req_r[ch], rx_pop[ch]})
              2'b10  : rch_vld[ch] <= #0.1 {rch_vld[ch][7:0], 1'b1};  // novas s-23028
              2'b01  : rch_vld[ch] <= #0.1 {1'b0, rch_vld[ch][8:1]};  // novas s-23028
              default:;   // no change
            endcase
          end
        end
      end

      always @ (posedge sysclk or negedge sysrstn) begin
        if (~sysrstn)
          {rch_trans1[ch], rch_trans0[ch]} <= #0.1 2'h0;
        else begin
          if (sft_rst)
            {rch_trans1[ch], rch_trans0[ch]} <= #0.1 2'h0;
          else begin
            case ({rx_pop[ch], (dma_wvld&dma_wrdy&last_trans&(dma_ch==ch))})
              2'b10  : {rch_trans1[ch], rch_trans0[ch]} <= #0.1 {rch_trans0[ch], 1'b1};
              2'b01  : {rch_trans1[ch], rch_trans0[ch]} <= #0.1 {1'b0, rch_trans1[ch]};
              default:; // no change
            endcase
          end
        end
      end

      always @ (posedge sysclk or negedge sysrstn) begin
        if (~sysrstn)
          rx_sdone[ch] <= #0.1 1'b0;
        else begin
          if (rx_stop[ch]&~rch_trans0[ch]&~rch_trans1[ch]&(rch_vld[ch]==9'h0))
            rx_sdone[ch] <= #0.1 1'b1;
          else
            rx_sdone[ch] <= #0.1 1'b0;
        end
      end
    end
  endgenerate

endmodule
//==============================================================================
//
//    This confidential and proprietary hardware may be used only as
//  authorized by a licensing agreement from
//                    SunMedia Technology Co., LTD.
//
//  In the event of publication, the following notice is applicable:
//
//            COPYRIGHT 2017, SunMedia Technology Co., LTD.
//                        ALL RIGHTS RESERVED
//
//  The entire notice above must be reproduced on all authorized copies.
//
//==============================================================================
//
//  File        : f_bio_rx_ctrl.v
//  Author      : kun.zhang
//  Date        : 05/Dec/2017
//  Version     : 1.1
//  Abstract    : This module is the receiver block for BIO control. It receives
//                data from soft-pad and transfer the data to AFIFO (CDC).
//                Including a 64x72 S1P memory for data storage in case AFIFO is
//                full. The ready signal will be low if the memory can't store
//                a next maximum length packet.
//
//  Modification History:
//  Date          By            Version         Change Description
//------------------------------------------------------------------------------
//  16/Feb/2017   kun.zhang      1.0            Original
//  05/Dec/2017   kun.zhang      1.1            modify for 2bit rx_vld and other
//                                              releated logics
//
//
//==============================================================================



module f_bio_rx_ctrl (
  input  wire        rx_clk,    // clock
  input  wire        rx_rstn,   // reset

  input  wire        bist_rstn, // NVIC_RST_B
  input  wire        bist_mode,
  input  wire        test_mode,
  input  wire        scan_enable,
  output wire        bist_fail,
  output wire        bist_finish,

  input  wire [31:0] rx_data,   // Receiver data from soft-pad, if SDR mode only bit 15:0 is valid
  input  wire [1:0]  rx_vld,    // Reciever valid
  input  wire        ddr_en,    // DDR mode enable, 1'b0: SDR mode, 1'b1: DDR mode
  input  wire        en_16b,    // 16bit mode enable, 1'b0: 8bit mode, 1'b1: 16bit mode
  output reg         rx_rdy,    // Receiver ready to tx domain
  input  wire        tx_rdy,    // TX ready used for tunning data


    output wire       rx_req,   // RX packet request for stop counter
    output wire [2:0] rx_dch,   // RX DMA request channel number
    input  wire       rx_ack,   // RX DMA request acknowlage
    input  wire       rx_stop,  // RX Stop request from system domain
    input  wire [2:0] rx_sch,   // RX Stop request channel number
    output reg        rx_sack,  // RX Stop ack to system domain. // NO pending request in request queue


  output reg         rx_fail,       // Self-test RX fail
  output reg         rx_bt_s,       // RX receives bus-tuning start indicator
  input  wire        tx_bt_s,       // TX transmit bus-tuning start indicator
  output reg         btchk_done,    // Bus tunning check done

  output reg         afifo_wr,      // AFIFO write enable
  output reg [71:0]  afifo_wdata,   // AFIFO write data
  input  wire        afifo_full     // AFIFO full
);

//==============================================================================
parameter BTCHK_D0 = 64'h00FF_9A9A_CCAA_CCA8;
parameter BTCHK_D1 = 64'h9A9A_FF00_CC55_CCA8;

wire        data_1b;    // Data in 1Byte mode (8bit SDR mode)
wire        data_2b;    // Data in 2Byte mode (8bit DDR mode or 16bit SDR mode)
wire        data_4b;    // Data in 4Byte mode (16bit DDR mode)
reg  [3:0]  rx_cnt1;    // Receiver counter for data control
reg         rx_vld0_d;  // Delayed rx_vld[0] for edge check
reg  [55:0] data_buf;   // Data buffer for receiver
reg  [7:0]  rx_vld_r;   // RX Byte valid
reg  [6:0]  rvld_buf;   // RX byte valid buffer
reg         rx_dvld;    // RX data valid
reg  [63:0] rx_data_r;  // RX data
wire        rx_end_d;   // RX packet end, assert when receives a falling edge of rx_vld and the received data is not 64bit
reg         pkt1_start;  // Packet start indicator
reg         pkt_b2b;    // Back to Back packet with 1T IPG
wire [15:0] rdata_hw_s; // RX data half-word select
wire [1:0]  rvld_hw_s;  // RX valid half-word select

reg         mem_acc_en; // SRAM access enable, 1'b0: data write to AFIFO, 1'b1: data write to SRAM
wire        mem_wr;     // Memory write valid
wire        mem_rd;     // memory read valid

reg         mem_empty;  // Data memory empty
reg  [7:0]  mem_dcnt;   // SRAM data counter
reg  [7:0]  mem_wptr;   // SRAM write pointer
reg  [7:0]  mem_rptr;   // SRAM read pointer
wire        sram_empty; // SRAM empty
wire        sram_wr;    // SRAM write enable
wire        sram_rd;    // SRAM read enable

wire        wr_pre;     // Memory pre-write
wire        wr_pre0;
wire        wr_pre1;
wire        wr_pre2;
wire        wr_pre3;
reg  [2:0]  data_cnt2;  // Data counter for temp buffer entry number
reg  [2:0]  dcnt2_tmp0; // data_cnt2 temp
reg  [2:0]  dcnt2_tmp1; // data_cnt2 temp
reg  [2:0]  dcnt2_tmp2; // data_cnt2 temp
reg  [71:0] data_tmp0;  // Data temp0 for memory pre-read
reg  [71:0] data_tmp1;  // Data temp1 for memory pre-read
reg  [71:0] data_tmp2;  // Data temp2 for memory pre-read
reg  [71:0] data_tmp3;  // Data temp3 for memory pre-read

reg  [2:0]  mem_rd_d;   // Memory delayed for data latch

reg         mem_cen;    // SRAM chip enable
reg         mem_wen;    // SRAM write enable
reg  [71:0] mem_wdata;  // SRAM write data
reg  [5:0]  mem_addr;   // SRAM access address
wire [71:0] mem_rdata;  // SRAM read data, SQ
wire [71:0] mem_dummy;  // SRAM read data, Q

reg         bts_1byte;      // The Bus tunnign start only 1Byte information
reg         tx_bts_r;       // TX Bus tunning start latched
reg         rx_bts_r;       // RX bus tunning start latched
reg         rx_bts_fail;    // RX bus tunning start failed
wire        set_bts_fail;   // Status to set bts fail
wire        ivld_cmd;       // Indicates the current is invalid commanmd
reg         bts_end;        // Bus tunning end
wire        set_btchk;      // Set bus tunning
reg         btchk_fail;     // Bus tunning check fail
reg         btchk_run;      // Bus tunning running
reg  [7:0]  btchk_cnt;      // Bus tunning counter
wire        set_rx_fail;    // Statue to set rx_fail
reg  [63:0] btchk_data0;    // Bus tunning data0
reg  [63:0] btchk_data1;    // Bus tunning data1
reg  [63:0] btchk_data2;    // Bus tunning data2 for valid and ready

  reg  [4:0]  rx_rvld;      // RX done valid for queue
  reg  [14:0] rx_rbuf;      // RX done buffer for queue
  reg  [3:0]  rx_vld_d;     // RX valid delayed for data check
  reg  [31:0] rx_data_d;    // RX data delayed for data check
  reg         pkt_start;    // Indicates the current delayed data including command information
  wire        pkt_start_w;  //
  wire        pkt_start_w1; //
  reg         pkt_start_d;  // Indicates the current delayed data including the packet length information
  reg         pkt_rcmd;     // Indicates the current command is a read command packet
  reg         pkt_2byte;    // Indicates the current command is a 2byte packet in SDR 8bit mode
  wire        msb_cmd;      // Indicates the MSB of current data is command ID
  wire        set_pstart;   // Status to set pkt_start
  reg  [3:0]  cmd_loc;      // The command location in current data
  wire [3:0]  cmd_mux;      // The command ID after select
  wire [7:0]  len_mux;      // The packet length after select
  reg  [8:0]  pkt_cnt;      // Packet counter for start check
  wire [8:0]  pkt_cnt_n;    // Packet counter next for addition
  reg  [2:0]  pcnt_dnum;    // packet counter decrease number
  wire        pkt_lrdata;   // The read data packet is a long packet
  wire        lpkt_wrsp0;   // The next packet is a long packet after write response
  wire        lpkt_wrsp1;   // The next packet is a long packet after write response
  wire        nxt_dma0;     // The next packet is a DMA pacekt
  wire        nxt_dma1;     // The next packet is a DMA pacekt
  wire        clr_pkts32;   // Status to clear packet start for 32bit
  wire        clr_pkts16;   // Status to clear packet start for 16bit
  wire [2:0]  ch_mux;       // Channel number after select
  wire [2:0]  ch_mux1;      // Channel number mux for queue source
  wire        set_rdone;    // Status to set rx done queue
  reg         rx_stop_r;    // RX stop latched
  reg  [2:0]  rx_sch_r;     // RX stop channel number latched
  wire        rx_pend;      // RX request pending

//==============================================================================
assign data_1b = ~ddr_en & ~en_16b;
assign data_2b = ddr_en ^ en_16b;
assign data_4b = ddr_en & en_16b;

assign rdata_hw_s = ddr_en ? {rx_data[23:16], rx_data[7:0]} : rx_data[15:0];
assign rvld_hw_s  = ddr_en ? rx_vld : {rx_vld[0], rx_vld[0]};

assign rx_end_d = ~rx_vld[0] & rx_vld0_d & (data_4b ? rx_cnt1[0] : data_2b ? (rx_cnt1[1:0]!=2'h0) : (rx_cnt1[2:0]!=3'h0));

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn) begin
    rx_vld0_d  <= #0.1 1'b0;
  end else begin
    rx_vld0_d  <= #0.1 rx_vld[0];
  end
end

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    pkt1_start <= #0.1 1'b0;
  else begin
    if (rx_vld[0] & ~rx_vld0_d)
      pkt1_start <= #0.1 1'b0;
    else if (rx_dvld)
      pkt1_start <= #0.1 1'b0;
  end
end

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    pkt_b2b <= #0.1 1'b0;
  else begin
    if (rx_vld[0] & ~rx_vld0_d)
      pkt_b2b <= #0.1 data_4b ? rx_cnt1[0] : data_2b ? (rx_cnt1[1:0]!=2'h0) : (rx_cnt1[2:0]!=3'h0);
    else if (rx_dvld)
      pkt_b2b <= #0.1 1'b0;
  end
end

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    rx_cnt1 <= #0.1 4'h0;
  else begin
    if (rx_end_d&~rx_vld[0])
      rx_cnt1 <= #0.1 4'h0;
    else if (rx_vld[0])
      rx_cnt1 <= #0.1 rx_cnt1[2:0] + 1'b1;
  end
end

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    rx_dvld <= #0.1 1'b0;
  else begin
    if (~(btchk_run|bts_end|rx_bts_fail|rx_bts_r)&((rx_vld[0]&(data_4b ? rx_cnt1[0] : data_2b ? (rx_cnt1[1:0]==2'h3) : (rx_cnt1[2:0]==3'h7)))|(rx_end_d&~rx_vld[0])))
      rx_dvld <= #0.1 1'b1;
    else if (btchk_done)
      rx_dvld <= #0.1 1'b1;
    else
      rx_dvld <= #0.1 1'b0;
  end
end

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    rx_data_r <= #0.1 64'h0;
  else begin
    if (btchk_done)
      rx_data_r <= #0.1 {63'h0, (rx_fail|btchk_fail)};
    else if (data_4b) begin
      if (rx_vld[0]&rx_cnt1[0])
        rx_data_r <= #0.1 {rx_data[31:0], data_buf[31:0]};
      else if (~rx_vld[0] & rx_end_d)
        rx_data_r <= #0.1 {32'h0, data_buf[31:0]};
    end else if (data_2b) begin
      if (rx_vld[0]&(rx_cnt1[1:0]==2'h3))
        rx_data_r <= #0.1 {rdata_hw_s, data_buf[47:0]};
      else if (~rx_vld[0] & rx_end_d) begin
        case (rx_cnt1[1:0])
          2'h3   : rx_data_r <= #0.1 {16'h0, data_buf[47:0]};
          2'h2   : rx_data_r <= #0.1 {32'h0, data_buf[31:0]};
          2'h1   : rx_data_r <= #0.1 {48'h0, data_buf[15:0]};
          default:;
        endcase
      end
    end else begin
      if (rx_vld[0]&(rx_cnt1[2:0]==3'h7))
        rx_data_r <= #0.1 {rx_data[7:0], data_buf[55:0]};
      else if (~rx_vld[0] & rx_end_d) begin
        case (rx_cnt1[2:0])
          3'h7   : rx_data_r <= #0.1 {8'h0,  data_buf[55:0]};
          3'h6   : rx_data_r <= #0.1 {16'h0, data_buf[47:0]};
          3'h5   : rx_data_r <= #0.1 {24'h0, data_buf[39:0]};
          3'h4   : rx_data_r <= #0.1 {32'h0, data_buf[31:0]};
          3'h3   : rx_data_r <= #0.1 {40'h0, data_buf[23:0]};
          3'h2   : rx_data_r <= #0.1 {48'h0, data_buf[15:0]};
          3'h1   : rx_data_r <= #0.1 {56'h0, data_buf[7:0]};
          default:;
        endcase
      end
    end
  end
end

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    data_buf <= #0.1 56'h0;
  else begin
    if (data_4b) begin
      if (rx_vld[0]&~rx_cnt1[0])
        data_buf[31:0] <= #0.1 rx_data;
    end else if (data_2b) begin
      if (rx_vld[0]&(rx_cnt1[1:0]==2'h0))
        data_buf[15:0] <= #0.1 rdata_hw_s;
      else if (rx_vld[0]&(rx_cnt1[1:0]==2'h1))
        data_buf[31:16] <= #0.1 rdata_hw_s;
      else if (rx_vld[0]&(rx_cnt1[1:0]==2'h2))
        data_buf[47:32] <= #0.1 rdata_hw_s;
    end else if (rx_vld[0]) begin
      case (rx_cnt1[2:0])
        3'h0   : data_buf[7:0]   <= #0.1 rx_data[7:0];
        3'h1   : data_buf[15:8]  <= #0.1 rx_data[7:0];
        3'h2   : data_buf[23:16] <= #0.1 rx_data[7:0];
        3'h3   : data_buf[31:24] <= #0.1 rx_data[7:0];
        3'h4   : data_buf[39:32] <= #0.1 rx_data[7:0];
        3'h5   : data_buf[47:40] <= #0.1 rx_data[7:0];
        3'h6   : data_buf[55:48] <= #0.1 rx_data[7:0];
        default:;   // no change
      endcase
    end
  end
end

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    rx_vld_r <= #0.1 8'h0;
  else begin
    if (btchk_done)
      rx_vld_r <= #0.1 8'h0;
    else if (data_4b) begin
      if (rx_vld[0]&rx_cnt1[0])
        rx_vld_r <= #0.1 {rx_vld[1], rx_vld[1], rx_vld[0], rx_vld[0], rvld_buf[3:0]};
      else if (~rx_vld[0]&rx_end_d)
        rx_vld_r <= #0.1 {4'h0, rvld_buf[3:0]};
    end else if (data_2b) begin
      if (rx_vld[0]&(rx_cnt1[1:0]==2'h3))
        rx_vld_r <= #0.1 {rvld_hw_s, rvld_buf[5:0]};
      else if (~rx_vld[0]&rx_end_d)
        rx_vld_r <= #0.1 {2'h0, rvld_buf[5:0]};
    end else begin
      if (rx_vld[0]&(rx_cnt1[2:0]==3'h7))
        rx_vld_r <= #0.1 {rx_vld[0], rvld_buf[6:0]};
      else if (~rx_vld[0]&rx_end_d)
        rx_vld_r <= #0.1 {1'b0, rvld_buf[6:0]};
    end
  end
end

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    rvld_buf <= #0.1 7'h0;
  else begin
    if (data_4b) begin
      if (rx_vld[0]&~rx_cnt1[0])
        rvld_buf[3:0] <= #0.1 {rx_vld[1], rx_vld[1], rx_vld[0], rx_vld[0]};
    end else if (data_2b) begin
      if (rx_vld[0]&(rx_cnt1[1:0]==2'h0))
        rvld_buf <= #0.1 {5'h0, rvld_hw_s};
      else if (rx_vld[0]&(rx_cnt1[1:0]==2'h1))
        rvld_buf[3:2] <= #0.1 rvld_hw_s;
      else if (rx_vld[0]&(rx_cnt1[1:0]==2'h2))
        rvld_buf[5:4] <= #0.1 rvld_hw_s;
    end else if (rx_vld[0]) begin
      case (rx_cnt1[2:0])
        3'h0   : rvld_buf    <= #0.1 7'h1;
        3'h1   : rvld_buf[1] <= #0.1 1'b1;
        3'h2   : rvld_buf[2] <= #0.1 1'b1;
        3'h3   : rvld_buf[3] <= #0.1 1'b1;
        3'h4   : rvld_buf[4] <= #0.1 1'b1;
        3'h5   : rvld_buf[5] <= #0.1 1'b1;
        3'h6   : rvld_buf[6] <= #0.1 1'b1;
        default:;
      endcase
    end
  end
end
//******************************************************************************

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    bts_1byte <= #0.1 1'b0;
  else begin
    if (pkt_start_w&rx_vld_d[0]&data_1b&(rx_data_d[7:0]==8'hE)&cmd_loc[0])
      bts_1byte <= #0.1 1'b1;
    else if (rx_vld_d[0]&bts_1byte)
      bts_1byte <= #0.1 1'b0;
  end
end

assign set_rbts = (pkt_start_w&rx_vld_d[0]&~data_1b&(rx_data_d[15:0]=={8'hF1, 8'hE})&cmd_loc[0])
                | (rx_vld_d[0]&bts_1byte&(rx_data_d[7:0]==8'hF1));
always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    rx_bt_s <= #0.1 1'b0;
  else begin
    if (set_rbts)
      rx_bt_s <= #0.1 1'b1;
    else
      rx_bt_s <= #0.1 1'b0;
  end
end

assign ivld_cmd     = (cmd_mux!=4'h1) & (cmd_mux!=4'h4) & (cmd_mux!=4'h5) & (cmd_mux!=4'h6) & (cmd_mux!=4'h7);
assign set_bts_fail = (pkt_start_w&rx_vld_d[0]&~data_1b&(rx_data_d[15:0]!={8'hF1, 8'hE})&cmd_loc[0]&ivld_cmd)
                    | (pkt_start_w&rx_vld_d[0]&ivld_cmd&(cmd_mux!=4'hE)&(cmd_mux!=4'h0))
                    | (rx_vld_d[0]&bts_1byte&(rx_data_d[7:0]!=8'hF1));
always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    rx_bts_fail <= #0.1 1'b0;
  else begin
    if (tx_bts_r&set_bts_fail)
      rx_bts_fail <= #0.1 1'b1;
    else if (rx_bt_s|bts_end|(btchk_cnt[6:0]==7'h7F))
      rx_bts_fail <= #0.1 1'b0;
  end
end

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    rx_bts_r <= #0.1 1'b0;
  else begin
    if (rx_bt_s)
      rx_bts_r <= #0.1 1'b1;
    else if ((tx_bts_r&rx_bts_r)|(btchk_cnt[6:0]==7'h7F))
      rx_bts_r <= #0.1 1'b0;
  end
end

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    tx_bts_r <= #0.1 1'b0;
  else begin
    if (tx_bt_s)
      tx_bts_r <= #0.1 1'b1;
    else if ((tx_bts_r&rx_bts_r)|(btchk_cnt[6:0]==7'h7F))
      tx_bts_r <= #0.1 1'b0;
  end
end

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    bts_end <= #0.1 1'b0;
  else begin
    if (tx_bts_r&rx_bts_r)
      bts_end <= #0.1 1'b1;
    else if (set_btchk|(btchk_cnt[6:0]==7'h7F))
      bts_end <= #0.1 1'b0;
  end
end

assign set_btchk = bts_end & (ddr_en ? (rx_vld[1:0]==2'b11) : rx_vld[0]);
always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    btchk_run <= #0.1 1'b0;
  else begin
    if (set_btchk)
      btchk_run <= #0.1 1'b1;
    else if (btchk_run&(btchk_cnt[6:0]==7'h3F))
      btchk_run <= #0.1 1'b0;
  end
end

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    btchk_cnt <= #0.1 8'h0;
  else begin
    if (set_btchk|(tx_bt_s&~rx_bts_r)|(tx_bts_r&rx_bts_r)|(tx_bts_r&set_bts_fail))
      btchk_cnt <= #0.1 8'h0;
    else if (btchk_run|(tx_bts_r&~rx_bts_r)|bts_end|rx_bts_fail)
      btchk_cnt <= #0.1 btchk_cnt[6:0] + 1'b1;
  end
end

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    btchk_done <= #0.1 1'b0;
  else begin
    if ((btchk_run&(btchk_cnt[6:0]==7'h3F))|(((tx_bts_r&~rx_bts_r)|(bts_end&~rx_vld[0])|rx_bts_fail)&(btchk_cnt[6:0]==7'h7F)))
      btchk_done <= #0.1 1'b1;
    else
      btchk_done <= #0.1 1'b0;
  end
end

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    btchk_fail <= #0.1 1'b0;
  else begin
    if ((btchk_run&((rx_vld[0]!=btchk_data0[0])|(tx_rdy!=btchk_data2[0])))
      | (btchk_run&ddr_en&(rx_vld[1]!=btchk_data0[1]))
      | (btchk_run&(rx_data[7:0]!={4{btchk_data1[0], btchk_data0[0]}}))
      | (btchk_run&en_16b&(rx_data[15:8]!={4{btchk_data1[0], btchk_data0[0]}}))
      | (btchk_run&ddr_en&(rx_data[23:16]!={4{btchk_data1[1], btchk_data0[1]}}))
      | (btchk_run&data_4b&(rx_data[31:24]!={4{btchk_data1[1], btchk_data0[1]}})) )
      btchk_fail <= #0.1 1'b1;
    else
      btchk_fail <= #0.1 1'b0;
  end
end

assign set_rx_fail = (((tx_bts_r&~rx_bts_r)|(bts_end&~rx_vld[0])|rx_bts_fail)&(btchk_cnt[6:0]==7'h7F)) | btchk_fail;

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    rx_fail <= #0.1 1'b0;
  else begin
    if (tx_bt_s|rx_bt_s)
      rx_fail <= #0.1 1'b0;
    else if (set_rx_fail)
      rx_fail <= #0.1 1'b1;
  end
end

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    btchk_data0 <= #0.1 BTCHK_D0;
  else begin
    if (btchk_run&ddr_en)
      btchk_data0 <= #0.1 {btchk_data0[1:0], btchk_data0[63:2]};
    else if (btchk_run)
      btchk_data0 <= #0.1 {btchk_data0[0], btchk_data0[63:1]};
  end
end

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    btchk_data1 <= #0.1 BTCHK_D1;
  else begin
    if (btchk_run&ddr_en)
      btchk_data1 <= #0.1 {btchk_data1[1:0], btchk_data1[63:2]};
    else if (btchk_run)
      btchk_data1 <= #0.1 {btchk_data1[0], btchk_data1[63:1]};
  end
end

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    btchk_data2 <= #0.1 BTCHK_D0;
  else begin
    if (btchk_run)
      btchk_data2 <= #0.1 {btchk_data2[0], btchk_data2[63:1]};
  end
end
//******************************************************************************
assign mem_rd = ~mem_empty & ~afifo_full & ~mem_wr;
assign mem_wr = mem_acc_en & rx_dvld;

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    mem_empty <= #0.1 1'b1;
  else begin
    if (mem_empty&mem_wr)
      mem_empty <= #0.1 1'b0;
    else if (mem_rd&(mem_dcnt[6:0]==7'h1))
      mem_empty <= #0.1 1'b1;
  end
end

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    mem_acc_en <= #0.1 1'b0;
  else begin
    if (afifo_wr & afifo_full)
      mem_acc_en <= #0.1 1'b1;
    else if (mem_empty&~mem_wr)
      mem_acc_en <= #0.1 1'b0;
  end
end

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    mem_dcnt <= #0.1 8'h0;
  else begin
    if (mem_wr)
      mem_dcnt <= #0.1 mem_dcnt[6:0] + 1'b1;
    else if (mem_rd&(mem_dcnt[6:0]!=7'h0))
      mem_dcnt <= #0.1 mem_dcnt[6:0] - 1'b1;
  end
end

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    rx_rdy <= #0.1 1'b1;
  else begin
    if (mem_wr&(mem_dcnt[6:0]==7'd44))
      rx_rdy <= #0.1 1'b0;
    else if (mem_rd&(mem_dcnt[6:0]==7'd40))
      rx_rdy <= #0.1 1'b1;
  end
end

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    afifo_wr <= #0.1 1'b0;
  else begin
    if ((~mem_acc_en&rx_dvld)|(mem_acc_en&mem_rd))
      afifo_wr <= #0.1 1'b1;
    else if (~afifo_full)
      afifo_wr <= #0.1 1'b0;
  end
end

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    afifo_wdata <= #0.1 72'h0;
  else begin
    if (~mem_acc_en&rx_dvld)
      afifo_wdata <= #0.1 {rx_vld_r, rx_data_r};
    else if (mem_acc_en&mem_rd)
      afifo_wdata <= #0.1 data_tmp0;
  end
end

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn) begin
    data_cnt2  <= #0.1 3'h0;
    dcnt2_tmp2 <= #0.1 3'h0;
    dcnt2_tmp1 <= #0.1 3'h0;
  end else begin
    if (mem_rd&~mem_rd_d[2]) begin
      if (dcnt2_tmp2[1:0]!=2'h0)
        data_cnt2 <= #0.1 dcnt2_tmp2[1:0] - 1'b1;

      if (dcnt2_tmp1[1:0]!=2'h0)
        dcnt2_tmp2 <= #0.1 dcnt2_tmp1[1:0] - 1'b1;

      if (dcnt2_tmp0[1:0]!=2'h0)
        dcnt2_tmp1 <= #0.1 dcnt2_tmp0[1:0] - 1'b1;
    end else if (mem_rd_d[2]&~mem_rd) begin
      data_cnt2  <= #0.1 dcnt2_tmp2[1:0] + 1'b1;
      dcnt2_tmp2 <= #0.1 dcnt2_tmp1[1:0] + 1'b1;
      dcnt2_tmp1 <= #0.1 dcnt2_tmp0[1:0] + 1'b1;
    end else begin
      data_cnt2  <= #0.1 {1'b0, dcnt2_tmp2[1:0]};
      dcnt2_tmp2 <= #0.1 {1'b0, dcnt2_tmp1[1:0]};
      dcnt2_tmp1 <= #0.1 {1'b0, dcnt2_tmp0[1:0]};
    end
  end
end

assign wr_pre0 = mem_wr & (mem_dcnt[6:0]==6'h0);
assign wr_pre1 = mem_wr & (mem_dcnt[6:0]==6'h1);
assign wr_pre2 = mem_wr & (mem_dcnt[6:0]==6'h2);
assign wr_pre3 = mem_wr & (mem_dcnt[6:0]==6'h3);
assign wr_pre  = wr_pre1 | wr_pre2 | wr_pre3;
always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    dcnt2_tmp0 <= #0.1 3'h0;
  else begin
    case ({mem_rd_d[2], wr_pre, mem_rd})
      3'b001 : if (dcnt2_tmp0[1:0]!=2'h0) dcnt2_tmp0 <= #0.1 dcnt2_tmp0[1:0] - 1'b1;
      3'b010 : if (dcnt2_tmp0[1:0]!=2'h3) dcnt2_tmp0 <= #0.1 dcnt2_tmp0[1:0] + 1'b1;
      3'b100 : if (dcnt2_tmp0[1:0]!=2'h3) dcnt2_tmp0 <= #0.1 dcnt2_tmp0[1:0] + 1'b1;
      3'b110 : if (dcnt2_tmp0[1:0]!=2'h3) dcnt2_tmp0 <= #0.1 dcnt2_tmp0[1:0] + 2'h2;
      default:; // no change
    endcase
  end
end

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    data_tmp0 <= #0.1 72'h0;
  else begin
    if (wr_pre0)
      data_tmp0 <= #0.1 {rx_vld_r, rx_data_r};
    else if (mem_rd_d[2] & mem_rd & (data_cnt2[1:0]==2'h0))
      data_tmp0 <= #0.1 mem_rdata;
    else if (mem_rd)
      data_tmp0 <= #0.1 data_tmp1;
  end
end

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    data_tmp1 <= #0.1 72'h0;
  else begin
    if (wr_pre1)
      data_tmp1 <= #0.1 {rx_vld_r, rx_data_r};
    else if (mem_rd_d[2] & ((~mem_rd&(data_cnt2[1:0]==2'h0))|(mem_rd&(data_cnt2[1:0]==2'h1))))
      data_tmp1 <= #0.1 mem_rdata;
    else if (mem_rd)
      data_tmp1 <= #0.1 data_tmp2;
  end
end

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    data_tmp2 <= #0.1 72'h0;
  else begin
    if (wr_pre2)
      data_tmp2 <= #0.1 {rx_vld_r, rx_data_r};
    else if (mem_rd_d[2] & ((~mem_rd&(data_cnt2[1:0]==2'h1))|(mem_rd&(data_cnt2[1:0]==2'h2))))
      data_tmp2 <= #0.1 mem_rdata;
    else if (mem_rd)
      data_tmp2 <= #0.1 data_tmp3;
  end
end

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    data_tmp3 <= #0.1 72'h0;
  else begin
    if (wr_pre3)
      data_tmp3 <= #0.1 {rx_vld_r, rx_data_r};
    else if (mem_rd_d[2] & ((~mem_rd&(data_cnt2[1:0]==2'h2))|(mem_rd&(data_cnt2[1:0]==2'h3))))
      data_tmp3 <= #0.1 mem_rdata;
  end
end

//==============================================================================
// SRAM control and instance
assign sram_rd    = mem_rd & ~sram_empty;
assign sram_wr    = mem_wr & (|mem_dcnt[6:2]);
assign sram_empty = (mem_rptr[6:0]==mem_wptr[6:0]);

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    mem_rd_d <= #0.1 3'h0;
  else begin
    mem_rd_d <= #0.1 {mem_rd_d[1:0], sram_rd};
  end
end

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    mem_cen <= #0.1 1'b1;
  else begin
    if (sram_wr|sram_rd)
      mem_cen <= #0.1 1'b0;
    else
      mem_cen <= #0.1 1'b1;
  end
end

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    mem_wen <= #0.1 1'b1;
  else begin
    if (sram_wr)
      mem_wen <= #0.1 1'b0;
    else
      mem_wen <= #0.1 1'b1;
  end
end

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    mem_wdata <= #0.1 72'h0;
  else begin
    if (sram_wr)
      mem_wdata <= #0.1 {rx_vld_r, rx_data_r};
  end
end

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    mem_wptr <= #0.1 8'h0;
  else begin
    if (sram_wr)
      mem_wptr <= #0.1 mem_wptr[6:0] + 1'b1;
  end
end

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    mem_rptr <= #0.1 8'h0;
  else begin
    if (sram_rd)
      mem_rptr <= #0.1 mem_rptr[6:0] + 1'b1;
  end
end

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    mem_addr <= #0.1 6'h0;
  else begin
    if (sram_wr)
      mem_addr <= #0.1 mem_wptr[5:0];
    else if (sram_rd)
      mem_addr <= #0.1 mem_rptr[5:0];
  end
end

sim_Bisted_S1P64X72 u_rx_fifo_0 (
  .Q           (mem_dummy),
  .SQ          (mem_rdata),
  .BistFail    (bist_fail),
  .BistFinish  (bist_finish),

  .CLK         (rx_clk),
  .CEN         (mem_cen),
  .WEN         (mem_wen),
  .A           (mem_addr),
  .D           (mem_wdata),
  .RESET_B     (rx_rstn),
  .NVIC_RST_B  (bist_rstn),
  .SCAN_ENABLE (scan_enable),
  .BistMode    (bist_mode),
  .TEST_MODE   (test_mode)
);
//******************************************************************************

  assign rx_req = rx_rvld[0] & rx_ack;
  assign rx_dch = rx_rbuf[2:0];
  assign cmd_mux = ({4{cmd_loc[0]}}&rx_data_d[3:0])   | ({4{cmd_loc[1]}}&rx_data_d[11:8])
                 | ({4{cmd_loc[2]}}&rx_data_d[19:16]) | ({4{cmd_loc[3]}}&rx_data_d[27:24]);
  assign ch_mux  = ({3{cmd_loc[0]}}&rx_data_d[6:4])   | ({3{cmd_loc[1]}}&rx_data_d[14:12])
                 | ({3{cmd_loc[2]}}&rx_data_d[22:20]) | ({3{cmd_loc[3]}}&rx_data_d[30:28]);
  assign len_mux = ({8{cmd_loc[0]}}&rx_data_d[15:8])  | ({8{cmd_loc[1]}}&rx_data_d[23:16])
                 | ({8{cmd_loc[2]}}&rx_data_d[31:24]);
  assign msb_cmd = (cmd_loc[3]&rx_vld_d[2]) | (cmd_loc[1]&rx_vld_d[1]&~rx_vld_d[2]) | ~rx_vld_d[1];

  always @ (posedge rx_clk or negedge rx_rstn) begin
    if (~rx_rstn) begin
      rx_vld_d  <= #0.1 4'h0;
      rx_data_d <= #0.1 32'h0;
    end else if (~(btchk_run|bts_end|rx_bts_fail)) begin
      case ({ddr_en, en_16b})
        2'b11: begin
          rx_vld_d  <= #0.1 {rx_vld[1], rx_vld[1], rx_vld[0], rx_vld[0]};
          rx_data_d <= #0.1 {({16{rx_vld[1]}}&rx_data[31:16]), rx_data[15:0]};
        end
        2'b10: begin
          rx_vld_d  <= #0.1 {2'b00, rx_vld[1:0]};
          rx_data_d <= #0.1 {16'h0, ({8{rx_vld[1]}}&rx_data[23:16]), rx_data[7:0]};
        end
        2'b01: begin
          rx_vld_d  <= #0.1 {2'b00, rx_vld[0], rx_vld[0]};
          rx_data_d <= #0.1 {16'h0, rx_data[15:0]};
        end
        default: begin
          rx_vld_d  <= #0.1 {3'h0, rx_vld[0]};
          rx_data_d <= #0.1 {24'h0, rx_data[7:0]};
        end
      endcase
    end
  end

  assign pkt_lrdata = (cmd_loc[0]&(|len_mux[7:3])&rx_vld_d[2]) | cmd_loc[3] | (cmd_loc[1]&~rx_vld_d[2]&(cmd_mux!=8'h4))
                    | (cmd_loc[1]&((|len_mux[7:3])|(&(len_mux[2:0]))&rx_vld_d[2]))
                    | (cmd_loc[0]&((|len_mux[7:3])|(len_mux[2]&len_mux[1]))&~rx_vld_d[2])
                    | (cmd_loc[2]&((|len_mux[7:3])|(len_mux[2]&len_mux[1]))&rx_vld_d[2]);
  assign lpkt_wrsp0 = (rx_data_d[19:16]==4'h1)|(rx_data_d[19:16]==4'h6)|(rx_data_d[19:16]==4'h5);
  assign lpkt_wrsp1 = (rx_data_d[27:24]==4'h1)|(rx_data_d[27:24]==4'h6)|(rx_data_d[27:24]==4'h5);
  assign clr_pkts32 = (cmd_mux==4'h1)|(cmd_mux==4'h4)|(cmd_mux==4'h6)
                    | ((cmd_mux==4'h5)&pkt_lrdata)
                    | ((cmd_mux==4'h7)&cmd_loc[0]&lpkt_wrsp0&(rx_data_d[31:24]!=8'h4)&(rx_data_d[31:24]!=8'h5))
                    | ((cmd_mux==4'h7)&cmd_loc[0]&(rx_data_d[19:16]==4'h4))
                    | ((cmd_mux==4'h7)&cmd_loc[1]&((rx_data_d[27:24]==4'h4)|lpkt_wrsp1));
  assign clr_pkts16 = (cmd_mux==4'h1)|(cmd_mux==4'h4)|(cmd_mux==4'h6)|(cmd_mux==4'h5);
  assign set_pstart = (rx_vld_d[0]&(pkt_cnt[7:3]==5'h0) &
                      ((data_4b&pkt_cnt[2])
                      |(data_2b&~pkt_cnt[2]&pkt_cnt[1])
                      |(data_1b&~pkt_cnt[2]&~pkt_cnt[1]&pkt_cnt[0])))
                      |(pkt_start_d&~pkt_start&rx_vld_d[0]&data_4b&(~(|rx_data_d[7:4])&(rx_data_d[3]^(|rx_data_d[2:0]))))
                      |(pkt_start_d&~pkt_start&rx_vld_d[0]&data_2b&(rx_data_d[7:0]==8'h4))
                      |(pkt_start_d&rx_vld_d[0]&rx_vld_d[1]&(rx_data_d[7:0]==8'h4));
  assign pkt_start_w = pkt_start&(pkt_cnt[7:2]==6'h0)&((pkt_cnt[1]&rx_vld_d[2])|(~pkt_cnt[1]&pkt_cnt[0]&rx_vld_d[1])|(~pkt_cnt[1]&~pkt_cnt[0]));
  assign pkt_start_w1 = pkt_start_d&rx_vld_d[0]&rx_vld_d[2]&(rx_data_d[7:0]==8'h4);
  always @ (posedge rx_clk or negedge rx_rstn) begin
    if (~rx_rstn)
      pkt_start <= #0.1 1'b1;
    else begin
      if ((pkt_start_w|pkt_start_w1)&rx_vld_d[0]&((data_4b&clr_pkts32)|(data_2b&clr_pkts16)|data_1b))
        pkt_start <= #0.1 1'b0;
      else if (set_pstart|(pkt_2byte&rx_vld_d[0]))
        pkt_start <= #0.1 1'b1;
    end
  end

  always @ (posedge rx_clk or negedge rx_rstn) begin
    if (~rx_rstn)
      pkt_start_d <= #0.1 1'b0;
    else begin
      if ((pkt_start_w|pkt_start_w1)&rx_vld_d[0]&msb_cmd&((cmd_mux==4'h1)|(cmd_mux==4'h5)|(cmd_mux==4'h6)))
        pkt_start_d <= #0.1 1'b1;
      else if (pkt_start_w&rx_vld_d[0]&(cmd_mux==4'h7)&cmd_loc[1]&lpkt_wrsp1)
        pkt_start_d <= #0.1 1'b1;
      else if (pkt_start_d&rx_vld_d[0]&rx_vld_d[2]&(rx_data_d[7:0]==8'h4)&((cmd_mux==4'h1)|(cmd_mux==4'h5)|(cmd_mux==4'h6)))
        pkt_start_d <= #0.1 1'b1;
      else if (rx_vld_d[0]&pkt_start_d)
        pkt_start_d <= #0.1 1'b0;
    end
  end

  always @ (posedge rx_clk or negedge rx_rstn) begin
    if (~rx_rstn)
      pkt_rcmd <= #0.1 1'b0;
    else begin
      if (pkt_start_w&rx_vld_d[0]&((cmd_mux==4'h4)|((cmd_mux==4'h7)&cmd_loc[1]&(rx_data_d[27:24]==4'h4))))
        pkt_rcmd <= #0.1 1'b1;
      else if (rx_vld_d[0]&pkt_rcmd)
        pkt_rcmd <= #0.1 1'b0;
    end
  end

  always @ (posedge rx_clk or negedge rx_rstn) begin
    if (~rx_rstn)
      pkt_2byte <= #0.1 1'b0;
    else begin
      if (pkt_start_w&rx_vld_d[0]&data_1b&((cmd_mux==4'h7)|(cmd_mux==4'hE)|(cmd_mux==4'hF)))
        pkt_2byte <= #0.1 1'b1;
      else if (rx_vld_d[0]&pkt_2byte)
        pkt_2byte <= #0.1 1'b0;
    end
  end

  always @ (*) begin
    casez (rx_vld_d)
      4'b1???: pcnt_dnum = 3'h4;
      4'b001?: pcnt_dnum = 3'h2;
      4'b0001: pcnt_dnum = 3'h1;
      default: pcnt_dnum = 3'h0;
    endcase
  end

  assign pkt_cnt_n = pkt_cnt[7:0] + rx_data_d[7:0] - pcnt_dnum;
  always @ (posedge rx_clk or negedge rx_rstn) begin
    if (~rx_rstn)
      pkt_cnt <= #0.1 9'h0;
    else begin
      if ((pkt_start_w&rx_vld_d[0])|pkt_start_w1) begin
        case (cmd_mux)
          4'h0: pkt_cnt <= #0.1 9'h0;
          4'h1, 4'h5, 4'h6: begin
            if (~msb_cmd)
              pkt_cnt <= #0.1 pkt_cnt[7:0] + len_mux[7:0] - pcnt_dnum;
            else if (~pkt_start_w1)
              pkt_cnt <= #0.1 pkt_cnt[7:0] - pcnt_dnum;
          end
          4'h4: begin
            if (pkt_start_w1)
              pkt_cnt <= #0.1 pkt_cnt[7:0] + 8'h8;
            else
              pkt_cnt <= #0.1 pkt_cnt[7:0] + 8'h8 - pcnt_dnum;
          end
          4'h7: begin
            if (pkt_start_w1)
              pkt_cnt <= #0.1 pkt_cnt[7:0] + 2'h2;
            else if (cmd_loc[0]&lpkt_wrsp0&rx_vld_d[2])
              pkt_cnt <= #0.1 pkt_cnt[7:0] + rx_data_d[31:24] - 2'h2;
            else if ((cmd_loc[0]&(rx_data_d[19:16]==4'h4)&rx_vld_d[2])
                   | (cmd_loc[1]&(rx_data_d[27:24]==4'h4)&rx_vld_d[2]))
              pkt_cnt <= #0.1 pkt_cnt[7:0] + 3'h6;
            else if (cmd_loc[1]&(rx_data_d[27:24]==4'h0)&rx_vld_d[2])
              pkt_cnt <= #0.1 9'h0;
            else if (~((rx_data_d[19:16]==4'h7)&cmd_loc[0]) & ~((rx_data_d[27:24]==4'h7)&cmd_loc[1]) & ~data_1b)
              pkt_cnt <= #0.1 pkt_cnt[7:0] + 2'h2 - pcnt_dnum;
          end
          4'hE, 4'hF:
            pkt_cnt <= #0.1 9'h0;
          default:;
        endcase
      end else if (pkt_start_d&~pkt_start&rx_vld_d[0]) begin
        if ((rx_data_d[7:0]==8'h4)&(cmd_mux==4'h0)&rx_vld_d[2])
          pkt_cnt <= #0.1 9'h0;
        else
          pkt_cnt <= #0.1 pkt_cnt[7:0] + rx_data_d[7:0] - pcnt_dnum;
      end else if (rx_vld_d[0]&~pkt_2byte) begin
        pkt_cnt <= #0.1 pkt_cnt[7:0] - pcnt_dnum;
      end
    end
  end

  always @ (posedge rx_clk or negedge rx_rstn) begin
    if (~rx_rstn)
      cmd_loc <= #0.1 4'b0001;
    else begin
      if ((pkt_start_w&rx_vld_d[0])|pkt_start_w1) begin
        case (cmd_mux)
          4'h0: cmd_loc <= #0.1 4'b0001;
          4'h4: begin
            if (data_4b&~rx_vld_d[2])
              cmd_loc <= #0.1 {cmd_loc[1:0], cmd_loc[3:2]};
            else if (data_2b&~rx_vld_d[1])
              cmd_loc <= #0.1 {cmd_loc[3:2], cmd_loc[0], cmd_loc[1]};
          end
          4'h1, 4'h5, 4'h6: begin
            if (data_4b&rx_vld_d[2]) begin
              case (len_mux[1:0])
                2'h1   : cmd_loc <= #0.1 {cmd_loc[2:0], cmd_loc[3]};
                2'h2   : cmd_loc <= #0.1 {cmd_loc[1:0], cmd_loc[3:2]};
                2'h3   : cmd_loc <= #0.1 {cmd_loc[0], cmd_loc[3:1]};
                default:;
              endcase
            end else if (data_4b) begin
              case (len_mux[1:0])
                2'h0   : cmd_loc <= #0.1 {cmd_loc[1:0], cmd_loc[3:2]};
                2'h1   : cmd_loc <= #0.1 {cmd_loc[0], cmd_loc[3:1]};
                2'h3   : cmd_loc <= #0.1 {cmd_loc[2:0], cmd_loc[3]};
                default:;
              endcase
            end else if (data_2b) begin
              if (len_mux[0]|~rx_vld_d[1])
                cmd_loc <= #0.1 {cmd_loc[3:2], cmd_loc[0], cmd_loc[1]};
            end
          end
          4'h7: begin
            if (rx_vld_d[2]&cmd_loc[0]) begin
              case (rx_data_d[19:16])
                4'h1, 4'h5, 4'h6: begin
                  case (rx_data_d[25:24])
                    2'h0   : cmd_loc <= #0.1 {cmd_loc[1:0], cmd_loc[3:2]};
                    2'h1   : cmd_loc <= #0.1 {cmd_loc[0], cmd_loc[3:1]};
                    2'h3   : cmd_loc <= #0.1 {cmd_loc[2:0], cmd_loc[3]};
                    default:;
                  endcase
                end
                4'h4: cmd_loc <= #0.1 {cmd_loc[1:0], cmd_loc[3:2]};
                default:;   // no change
              endcase
            end else if (rx_vld_d[2]) begin
              if (rx_data_d[27:24]==4'h0)
                cmd_loc <= #0.1 4'b0001;
              else if ((rx_data_d[27:24]!=4'h7)|cmd_loc[3]|cmd_loc[2])
                cmd_loc <= #0.1 {cmd_loc[1:0], cmd_loc[3:2]};
            end else if (~rx_vld_d[1]&data_2b)
              cmd_loc <= #0.1 4'b0010;
          end
          default:;
        endcase
      end else if (pkt_start_d&~pkt_start&rx_vld_d[0]) begin
        if (data_4b&rx_vld_d[2]) begin
          if (rx_data_d[7:0]==8'h4)
            cmd_loc <= #0.1 4'b0001;
          else begin
            case (rx_data_d[1:0])
              2'h1   : cmd_loc <= #0.1 {cmd_loc[2:0], cmd_loc[3]};
              2'h2   : cmd_loc <= #0.1 {cmd_loc[1:0], cmd_loc[3:2]};
              2'h3   : cmd_loc <= #0.1 {cmd_loc[0], cmd_loc[3:1]};
              default:;
            endcase
          end
        end else if (data_4b) begin
          case (rx_data_d[1:0])
            2'h0   : cmd_loc <= #0.1 {cmd_loc[1:0], cmd_loc[3:2]};
            2'h1   : cmd_loc <= #0.1 {cmd_loc[0], cmd_loc[3:1]};
            2'h3   : cmd_loc <= #0.1 {cmd_loc[2:0], cmd_loc[3]};
            default:;
          endcase
        end else if (data_2b) begin
          if (rx_data_d[0]^(~rx_vld_d[1]))
            cmd_loc <= #0.1 {cmd_loc[3:2], cmd_loc[0], cmd_loc[1]};
        end
      end else if (data_4b&rx_vld_d[0]&(~rx_vld_d[2]|(rx_vld_d[2]&pkt_start_w&(cmd_mux==4'h7))))
        cmd_loc <= #0.1 {cmd_loc[1:0], cmd_loc[3:2]};
      else if (data_2b&rx_vld_d[0]&~rx_vld_d[1])
        cmd_loc <= #0.1 {cmd_loc[3:2], cmd_loc[0], cmd_loc[1]};
    end
  end

assign nxt_dma0  = (cmd_mux==4'h7)&cmd_loc[0]&(rx_data_d[19:16]==4'h1);
assign nxt_dma1  = (cmd_mux==4'h7)&cmd_loc[1]&(rx_data_d[27:24]==4'h1);
assign set_rdone = (pkt_start_w|pkt_start_w1)&rx_vld_d[0]&((cmd_mux==4'h1)|nxt_dma0|nxt_dma1);
assign ch_mux1   = nxt_dma0 ? rx_data_d[22:20] : (nxt_dma1 ? rx_data_d[30:28] : ch_mux);

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    rx_rvld <= #0.1 2'h0;
  else begin
    case ({set_rdone, rx_req})
      2'b10  : rx_rvld <= #0.1 {rx_rvld[3:0], 1'b1};
      2'b01  : rx_rvld <= #0.1 {1'b0, rx_rvld[4:1]};
      default:;
    endcase
  end
end

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    rx_rbuf <= #0.1 15'h0;
  else begin
    if (set_rdone) begin
      casez (rx_rvld)
        5'b00000: rx_rbuf[2:0] <= #0.1 ch_mux1;
        5'b00001: begin
          if (rx_req)
            rx_rbuf[2:0] <= #0.1 ch_mux1;
          else
            rx_rbuf[5:3] <= #0.1 ch_mux1;
        end
        5'b0001?: begin
          if (rx_req)
            rx_rbuf[5:0] <= #0.1 {ch_mux1, rx_rbuf[5:3]};
          else
            rx_rbuf[8:6] <= #0.1 ch_mux1;
        end
        5'b001??: begin
          if (rx_req)
            rx_rbuf[8:0] <= #0.1 {ch_mux1, rx_rbuf[8:3]};
          else
            rx_rbuf[11:9] <= #0.1 ch_mux1;
        end
        5'b01???: begin
          if (rx_req)
            rx_rbuf[11:0] <= #0.1 {ch_mux1, rx_rbuf[11:3]};
          else
            rx_rbuf[14:12] <= #0.1 ch_mux1;
        end
        5'b1????: begin
          if (rx_req)
            rx_rbuf <= #0.1 {ch_mux1, rx_rbuf[14:3]};
        end
        default:;
      endcase
    end else if (rx_req)
      rx_rbuf[11:0] <= #0.1 rx_rbuf[14:3];
  end
end

assign rx_pend = (rx_rvld[0]&(rx_sch_r==rx_rbuf[2:0])) | (rx_rvld[1]&(rx_sch_r==rx_rbuf[5:3]))
               | (rx_rvld[2]&(rx_sch_r==rx_rbuf[8:6])) | (rx_rvld[3]&(rx_sch_r==rx_rbuf[11:9]))
               | (rx_rvld[4]&(rx_sch_r==rx_rbuf[14:12]));
always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    rx_stop_r <= #0.1 1'b0;
  else begin
    if (rx_stop)
      rx_stop_r <= #0.1 1'b1;
    else if (~rx_pend&rx_stop_r)
      rx_stop_r <= #0.1 1'b0;
  end
end

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    rx_sch_r <= #0.1 3'h0;
  else begin
    if (rx_stop)
      rx_sch_r <= #0.1 rx_sch;
  end
end

always @ (posedge rx_clk or negedge rx_rstn) begin
  if (~rx_rstn)
    rx_sack <= #0.1 1'b0;
  else begin
    if (~rx_pend&rx_stop_r)
      rx_sack <= #0.1 1'b1;
    else
      rx_sack <= #0.1 1'b0;
  end
end

endmodule
//==============================================================================
//
//    This confidential and proprietary hardware may be used only as
//  authorized by a licensing agreement from
//                    SunMedia Technology Co., LTD.
//
//  In the event of publication, the following notice is applicable:
//
//            COPYRIGHT 2017, SunMedia Technology Co., LTD.
//                        ALL RIGHTS RESERVED
//
//  The entire notice above must be reproduced on all authorized copies.
//
//==============================================================================
//
//  File        : f_bio_cdc.v
//  Author      : kun.zhang
//  Date        : 06/Dec/2017
//  Version     : 1.1
//  Abstract    : The Clock Domain Cross control block
//
//  Modification History:
//  Date          By            Version         Change Description
//------------------------------------------------------------------------------
//  21/Feb/2017   kun.zhang      1.0            Original
//  06/Dec/2017   kun.zhang      1.1            Change AFIFO to 72bit
//
//
//==============================================================================
module f_bio_cdc (
  input  wire        tx_clk,   // TX domain clock
  input  wire        tx_rstn,  // TX domain reset
  input  wire        rx_clk,   // RX domain clock
  input  wire        rx_rstn,  // RX domain reset
  input  wire        sysclk,   // System domain clock
  input  wire        sysrstn,  // System domain reset

  input  wire        bist_rstn, // NVIC_RST_B
  input  wire        bist_mode,
  input  wire        test_mode,
  input  wire        scan_enable,
  output wire [1:0]  bist_fail,
  output wire [1:0]  bist_finish,


    output wire       rx_stop_rx,   // DMA stop for RX in RX clock domain
    input  wire       rx_stop_sys,  // DMA stop for RX in system clock domain
    input  wire       rx_sack_rx,  // DMA stop done for RX in RX clock domain
    output wire       rx_sack_sys, // DMA stop done for RX in system clock domain

    input  wire       rx_req_rx,    // DMA RX request in RX clock domain
    output wire       rx_req_sys,   // DMA RX request in system clock domain
    input  wire [2:0] rx_dch_rx,    // DMA RX request channel number in RX clock domain
    output wire [2:0] rx_dch_sys,   // DMA RX request channel number in system clock domain
    output wire       rx_ack_rx,    // DMA RX request acknowlage

    input  wire       tx_done_tx,   // DMA TX transfer done in TX clock domain
    output wire       tx_done_sys,  // DMA TX transfer done in system clock domain
    input  wire [2:0] tx_dch_tx,    // DMA TX transfer done channel number
    output wire [2:0] tx_dch_sys,   // DMA TX transfer done channel number
    output wire       tx_dack_tx,   // DMA TX transfer done acknowlage


  input  wire        tx_rdy,    // Transmit ready in RX clock domain
  output wire        tx_rdy_tx, // Transmit ready in TX clock domain
  input  wire        rx_rdy_rx, // Receiver ready in RX clock domain
  output wire        rx_rdy,    // Receiver ready in TX clock domain

  input  wire        ddr_en_sys,    // DDR mode enable in system clock domain
  output wire        tx_ddr_en,     // DDR mode enable in TX clock domain
  output wire        rx_ddr_en,     // DDR mode enable in RX clock domain
  input  wire        en_16b_sys,    // 16bit mode enable in system clock domain
  output wire        tx_en_16b,     // 16bit mode enable in TX clock domain
  output wire        rx_en_16b,     // 16bit mode enable in RX clock domain

  input  wire        ckchk_req,  // Self-test clock check request
  output wire        ckchk_ack,  // Self-test clock check acknowlage
//  output wire        btchk_ack_sys,  // Bus tunning check acknowlage in system domain
//  output wire        rx_fail_sys,    // RX fail in system domain
  input  wire        btchk_ack_io,   // Bus tunning check acknowlage in IO domain
  output wire        btchk_ack_tx,   // Bus tunning check acknowlage in TX domain
  input  wire        rx_fail_io,     // RX fail in IO domain
  output wire        rx_fail_tx,     // RX fail in TX domain
  input  wire        rx_bts_rx,      // RX Bus tunning start
  output wire        rx_bts_tx,      // RX Bus tunning start
  output wire        tx_bts_rx,      // TX Bus tunning start
  input  wire        tx_bts_tx,      // TX Bus tunning start

  input  wire        rx_afifo_wr,       // Receiver AFIFO write
  input  wire [71:0] rx_afifo_wdata,    // Receiver AFIFO write data
  output wire        rx_afifo_full,     // Reciever AFIFO full

  input  wire        tx_afifo_rd,       // Transmiter AFIFO read enable
  output wire [71:0] tx_afifo_rdata,    // Transmiter AFIFO read data
  output wire        tx_afifo_empty,    // Transmiter AFIFO empty

  input  wire        sys_afifo_wr,      // System AFIFO write
  input  wire [71:0] sys_afifo_wdata,   // System AFIFO write data
  output wire        sys_afifo_full,    // System AFIFO full
  input  wire        sys_afifo_rd,      // System AFIFO read enable
  output wire [71:0] sys_afifo_rdata,   // System AFIFO read data
  output wire        sys_afifo_empty    // System AFIFO empty
);

wire    ckchk_req_tx;
wire    ckchk_ack_rx;

f_aim_rego_sync u_tx_rdy_sync_0 (
  .inp        (tx_rdy),
  .outp       (tx_rdy_tx),
  .clk        (tx_clk),
  .rstb       (tx_rstn)
);

f_aim_rego_sync u_rx_rdy_sync_0 (
  .inp        (rx_rdy_rx),
  .outp       (rx_rdy),
  .clk        (tx_clk),
  .rstb       (tx_rstn)
);

f_aim_rego_sync u_ddr_en_sync_0 (
  .inp        (ddr_en_sys),
  .outp       (tx_ddr_en),
  .clk        (tx_clk),
  .rstb       (tx_rstn)
);

f_aim_rego_sync u_ddr_en_sync_1 (
  .inp        (ddr_en_sys),
  .outp       (rx_ddr_en),
  .clk        (rx_clk),
  .rstb       (rx_rstn)
);

f_aim_rego_sync u_16b_en_sync_0 (
  .inp        (en_16b_sys),
  .outp       (tx_en_16b),
  .clk        (tx_clk),
  .rstb       (tx_rstn)
);

f_aim_rego_sync u_16b_en_sync_1 (
  .inp        (en_16b_sys),
  .outp       (rx_en_16b),
  .clk        (rx_clk),
  .rstb       (rx_rstn)
);


  f_aim_pulse_sync u_rx_stop_sync_0 (
    .inp          (rx_stop_sys),
    .outp         (rx_stop_rx),
    .clks         (sysclk),
    .clkd         (rx_clk),
    .rstb_clks    (sysrstn),
    .rstb_clkd    (rx_rstn)
  );

  f_aim_pulse_sync u_rx_sack_sync_0 (
    .inp          (rx_sack_rx),
    .outp         (rx_sack_sys),
    .clks         (rx_clk),
    .clkd         (sysclk),
    .rstb_clks    (rx_rstn),
    .rstb_clkd    (sysrstn)
  );

  f_aim_data_rdy_sync #(3) u_rx_req_sync_0 (
    .ready_s        (rx_ack_rx),
    .indata_s       (rx_dch_rx),
    .send_s         (rx_req_rx),
    .clks           (rx_clk),
    .rstb_clks      (rx_rstn),
    .data_d         (rx_dch_sys),
    .data_avail_d   (rx_req_sys),
    .clkd           (sysclk),
    .rstb_clkd      (sysrstn)
  );

  f_aim_data_rdy_sync #(3) u_tx_done_sync_0 (
    .ready_s        (tx_dack_tx),
    .indata_s       (tx_dch_tx),
    .send_s         (tx_done_tx),
    .clks           (tx_clk),
    .rstb_clks      (tx_rstn),
    .data_d         (tx_dch_sys),
    .data_avail_d   (tx_done_sys),
    .clkd           (sysclk),
    .rstb_clkd      (sysrstn)
  );


f_aim_pulse_sync u_ckchk_sync_0 (
  .inp          (ckchk_req),
  .outp         (ckchk_req_tx),
  .clks         (sysclk),
  .clkd         (tx_clk),
  .rstb_clks    (sysrstn),
  .rstb_clkd    (tx_rstn)
);

f_aim_pulse_sync u_ckchk_sync_1 (
  .inp          (ckchk_req_tx),
  .outp         (ckchk_ack_rx),
  .clks         (tx_clk),
  .clkd         (rx_clk),
  .rstb_clks    (tx_rstn),
  .rstb_clkd    (rx_rstn)
);

f_aim_pulse_sync u_ckchk_sync_2 (
  .inp          (ckchk_ack_rx),
  .outp         (ckchk_ack),
  .clks         (rx_clk),
  .clkd         (sysclk),
  .rstb_clks    (rx_rstn),
  .rstb_clkd    (sysrstn)
);

//f_aim_pulse_sync u_btchk_sync_1 (
//  .inp          (btchk_ack_io),
//  .outp         (btchk_ack_sys),
//  .clks         (rx_clk),
//  .clkd         (sysclk),
//  .rstb_clks    (rx_rstn),
//  .rstb_clkd    (sysrstn)
//);

f_aim_pulse_sync u_btchk_sync_2 (
  .inp          (btchk_ack_io),
  .outp         (btchk_ack_tx),
  .clks         (rx_clk),
  .clkd         (tx_clk),
  .rstb_clks    (rx_rstn),
  .rstb_clkd    (tx_rstn)
);

f_aim_pulse_sync u_rx_bts_sync_0 (
  .inp          (rx_bts_rx),
  .outp         (rx_bts_tx),
  .clks         (rx_clk),
  .clkd         (tx_clk),
  .rstb_clks    (rx_rstn),
  .rstb_clkd    (tx_rstn)
);

f_aim_pulse_sync u_tx_bts_sync_0 (
  .inp          (tx_bts_tx),
  .outp         (tx_bts_rx),
  .clks         (tx_clk),
  .clkd         (rx_clk),
  .rstb_clks    (tx_rstn),
  .rstb_clkd    (rx_rstn)
);

//f_aim_rego_sync u_rx_fail_sync_0 (
//  .inp        (rx_fail_io),
//  .outp       (rx_fail_sys),
//  .clk        (sysclk),
//  .rstb       (sysrstn)
//);

f_aim_rego_sync u_rx_fail_sync_1 (
  .inp        (rx_fail_io),
  .outp       (rx_fail_tx),
  .clk        (tx_clk),
  .rstb       (tx_rstn)
);

sim_ASYNC_FIFO8X72_LATCH I_async_fifo_sys2tx_0 (
  .bist_finish      (bist_finish[0]),
  .bist_fail        (bist_fail[0]),
  .test_mode        (test_mode),
  .bist_mode        (bist_mode),
  .SCAN_ENABLE      (scan_enable),
  .rdata            (tx_afifo_rdata),
  .wfull            (sys_afifo_full),
  .rempty           (tx_afifo_empty),
  .wdata            (sys_afifo_wdata),
  .winc             (sys_afifo_wr),
  .wclk             (sysclk),
  .wrst_n           (sysrstn),
  .rinc             (tx_afifo_rd),
  .rclk             (tx_clk),
  .rrst_n           (tx_rstn),
  .NVIC_RST_B       (bist_rstn),
  .asfifo_lp_dis    (1'b1)
);

sim_ASYNC_FIFO8X72_LATCH I_async_fifo_rx2sys_0 (
  .bist_finish      (bist_finish[1]),
  .bist_fail        (bist_fail[1]),
  .test_mode        (test_mode),
  .bist_mode        (bist_mode),
  .SCAN_ENABLE      (scan_enable),
  .rdata            (sys_afifo_rdata),
  .wfull            (rx_afifo_full),
  .rempty           (sys_afifo_empty),
  .wdata            (rx_afifo_wdata),
  .winc             (rx_afifo_wr),
  .wclk             (rx_clk),
  .wrst_n           (rx_rstn),
  .rinc             (sys_afifo_rd),
  .rclk             (sysclk),
  .rrst_n           (sysrstn),
  .NVIC_RST_B       (bist_rstn),
  .asfifo_lp_dis    (1'b1)
);
endmodule
//==============================================================================
//
//    This confidential and proprietary hardware may be used only as
//  authorized by a licensing agreement from
//                    SunMedia Technology Co., LTD.
//
//  In the event of publication, the following notice is applicable:
//
//            COPYRIGHT 2017, SunMedia Technology Co., LTD.
//                        ALL RIGHTS RESERVED
//
//  The entire notice above must be reproduced on all authorized copies.
//
//==============================================================================
//
//  File        : f_bio_axis_reg.v
//  Author      : kun.zhang
//  Date        : 22/Feb/2017
//  Version     : 1.0
//  Abstract    : This module is the AXI slave port control block. Including all
//                control registers read/write logics
//
//  Modification History:
//  Date          By            Version         Change Description
//------------------------------------------------------------------------------
//  22/Feb/2017   kun.zhang      1.0            Original
//
//
//==============================================================================



module f_bio_axis_reg (
  input  wire        sysclk,    // clock
  input  wire        sysrstn,   // reset
  input  wire        sft_rst,

  input  wire [3:0]  axis_awid,
  input  wire [31:0] axis_awaddr,
  input  wire [3:0]  axis_awlen,
  input  wire [2:0]  axis_awsize,
  input  wire [1:0]  axis_awburst,
  input  wire [1:0]  axis_awlock,
  input  wire [3:0]  axis_awcache,
  input  wire [2:0]  axis_awprot,
  input  wire        axis_awvalid,
  output wire        axis_awready,

  input  wire [3:0]  axis_wid,
  input  wire [31:0] axis_wdata,
  input  wire [3:0]  axis_wstrb,
  input  wire        axis_wlast,
  input  wire        axis_wvalid,
  output wire        axis_wready,

  output wire [3:0]  axis_bid,
  output wire [1:0]  axis_bresp,
  output wire        axis_bvalid,
  input  wire        axis_bready,

  input  wire [3:0]  axis_arid,
  input  wire [31:0] axis_araddr,
  input  wire [3:0]  axis_arlen,
  input  wire [2:0]  axis_arsize,
  input  wire [1:0]  axis_arburst,
  input  wire [1:0]  axis_arlock,
  input  wire [3:0]  axis_arcache,
  input  wire [2:0]  axis_arprot,
  input  wire        axis_arvalid,
  output wire        axis_arready,

  output wire [3:0]  axis_rid,
  output wire [31:0] axis_rdata,
  output wire [1:0]  axis_rresp,
  output wire        axis_rlast,
  output wire        axis_rvalid,
  input  wire        axis_rready,


    output wire [1:0] ch0_dst_sel,   // Channel0 destination select
    output wire [1:0] ch1_dst_sel,   // Channel1 destination select
    output wire [1:0] ch2_dst_sel,   // Channel2 destination select
    output wire [1:0] ch3_dst_sel,   // Channel3 destination select
    output wire [1:0] ch4_dst_sel,   // Channel4 destination select
    output wire [1:0] ch5_dst_sel,   // Channel5 destination select

    output wire       ch0_discnt,     // Channel0 disable length counter
    output wire       ch1_discnt,     // Channel1 disable length counter
    output wire       ch2_discnt,     // Channel2 disable length counter
    output wire       ch3_discnt,     // Channel3 disable length counter
    output wire       ch4_discnt,     // Channel4 disable length counter
    output wire       ch5_discnt,     // Channel5 disable length counter

  output wire [15:0] axis_probe,

  output wire [31:0] stest_reg,     // Self-test data register
  output wire        wr_sdata,      // Write self-test data register
  output wire        btchk_sreq,    // Bus tunning check soft request
  input  wire        btchk_done,    // Bus tunning done
  input  wire        btchk_fail,    // Bus tunning check fail
  output wire [7:0]  pb_sel,        // Probe out select
  output wire        stest_sreq,    // Self-test request
  input  wire        stest_done,    // Self-test done
  input  wire        stest_tfail,   // Self-test Timeout fail
  input  wire        stest_fail,    // Self-test fail
  output wire [46:0] sft_ds_en,    // PAD DS enable form register
  output wire [46:0] sft_ie_en,    // PAD IE from register
  output wire        sft_pwd,      // Analog powerdown from register
  output wire [3:0]  rx_clki_dly,  // RX clock input delay select
  output wire        rx_clki_inv,  // RX clock input inverter select
  output wire        rx_clki_pol,  // RX clock input pol select
  output wire [3:0]  rx_clko_dly,  // RX clock output delay select
  output wire        rx_clko_inv,  // RX clock output inverter select
  output wire        rx_clko_pol,  // RX clock output pol select
  output wire [3:0]  tx_clki_dly,  // TX clock input delay select
  output wire        tx_clki_inv,  // TX clock input inverter select
  output wire        tx_clki_pol,  // TX clock input pol select
  output wire [3:0]  tx_clko_dly,  // TX clock output delay select
  output wire        tx_clko_inv,  // TX clock output inverter select
  output wire        tx_clko_pol,  // TX clock output pol select
  output wire        rx_ck_comp,   // RX clock compress mode enable
  output wire        rx_ck_cinv,   // RX clock inverter in compress mode
  output wire        tx_ck_comp,   // TX clock compress mode enable
  output wire        tx_ck_cinv,   // TX clock inverter in compress mode
  output wire [31:0] boot_addr,    // Boot address remap

  output wire [6:0]  cpum_wt,       // CPU master arbitration weight
  output wire [6:0]  cpus_wt,       // CPU slave arbitration weight
  output wire [6:0]  dma_wt,        // DMA arbitration weight
  output wire [7:0]  lp_mreq,       // Low priority maxmum request count
  output wire        arb_ctl_wr,    // Arbiter control register write
  //input  wire [6:0]  cpum_wtcnt,    // CPU master weight counter
  //input  wire [6:0]  cpus_wtcnt,    // CPU master weight counter
  //input  wire [6:0]  dma_wtcnt,     // CPU master weight counter

  output wire        ddr_en,    // Enable DDR mode, default 1'b0;
  output wire        en_16b,    // Enable 16bit bus mode, default 1'b1;
  input  wire        ch0_run,   // Channel0 runing states
  output wire        ch0_trig,  // Channel0 trigger
  output wire        ch0_dir,   // Channel0 Direction
  output wire [15:0] ch0_len,   // Channel0 DMA length
  output wire [31:0] ch0_addr,  // Channel0 start address
  output wire        ch0_stop,  // Channel0 Stop pulse
  input  wire        ch1_run,   // Channel1 runing states
  output wire        ch1_trig,  // Channel1 trigger
  output wire        ch1_dir,   // Channel1 Direction
  output wire [15:0] ch1_len,   // Channel1 DMA length
  output wire [31:0] ch1_addr,  // Channel1 start address
  output wire        ch1_stop,  // Channel0 Stop pulse
  input  wire        ch2_run,   // Channel2 runing states
  output wire        ch2_trig,  // Channel2 trigger
  output wire        ch2_dir,   // Channel2 Direction
  output wire [15:0] ch2_len,   // Channel2 DMA length
  output wire [31:0] ch2_addr,  // Channel2 start address
  output wire        ch2_stop,  // Channel0 Stop pulse
  input  wire        ch3_run,   // Channel3 runing states
  output wire        ch3_trig,  // Channel3 trigger
  output wire        ch3_dir,   // Channel3 Direction
  output wire [15:0] ch3_len,   // Channel3 DMA length
  output wire [31:0] ch3_addr,  // Channel3 start address
  output wire        ch3_stop,  // Channel0 Stop pulse
  input  wire        ch4_run,   // Channel4 runing states
  output wire        ch4_trig,  // Channel4 trigger
  output wire        ch4_dir,   // Channel4 Direction
  output wire [15:0] ch4_len,   // Channel4 DMA length
  output wire [31:0] ch4_addr,  // Channel4 start address
  output wire        ch4_stop,  // Channel0 Stop pulse
  input  wire        ch5_run,   // Channel5 runing states
  output wire        ch5_trig,  // Channel5 trigger
  output wire        ch5_stop,  // Channel0 Stop pulse
  output wire        ch5_dir,   // Channel5 Direction
  output wire [15:0] ch5_len,   // Channel5 DMA length
  output wire [31:0] ch5_addr   // Channel5 start address
);
`ifdef FBIO_DDR_MODE
  assign ddr_en = 1'h1;
`else
  assign ddr_en = 1'h0;
`endif
assign en_16b = 1'h1;

assign axis_awready = 1'h0;
assign axis_wready = 1'h0;
assign axis_bid = 4'h0;
assign axis_bresp = 2'h0;
assign axis_bvalid = 1'h0;
assign axis_arready = 1'h0;
assign axis_rid = 4'h0;
assign axis_rdata = 32'h0;
assign axis_rresp = 2'h0;
assign axis_rlast = 1'h0;
assign axis_rvalid = 1'h0;
assign ch0_dst_sel = 2'h0;
assign ch1_dst_sel = 2'h0;
assign ch2_dst_sel = 2'h0;
assign ch3_dst_sel = 2'h0;
assign ch4_dst_sel = 2'h0;
assign ch5_dst_sel = 2'h0;
assign ch0_discnt = 1'h0;
assign ch1_discnt = 1'h0;
assign ch2_discnt = 1'h0;
assign ch3_discnt = 1'h0;
assign ch4_discnt = 1'h0;
assign ch5_discnt = 1'h0;
assign axis_probe = 1'h0;
assign stest_reg = 32'h0;
assign wr_sdata = 1'h0;
assign btchk_sreq = 1'h0;
assign pb_sel = 8'h0;
assign stest_sreq = 1'h0;
assign sft_ds_en = 47'h0;
assign sft_ie_en = 47'h0;
assign sft_pwd = 1'h0;
assign rx_clki_dly = 4'h0;
assign rx_clki_inv = 1'h0;
assign rx_clki_pol = 1'h0;
assign rx_clko_dly = 4'h0;
assign rx_clko_inv = 1'h0;
assign rx_clko_pol = 1'h0;
assign tx_clki_dly = 4'h0;
assign tx_clki_inv = 1'h0;
assign tx_clki_pol = 1'h0;
assign tx_clko_dly = 4'h0;
assign tx_clko_inv = 1'h0;
assign tx_clko_pol = 1'h0;
assign rx_ck_comp = 1'h0;
assign rx_ck_cinv = 1'h0;
assign tx_ck_comp = 1'h0;
assign tx_ck_cinv = 1'h0;
assign boot_addr = 32'h0;
assign cpum_wt = 7'h0;
assign cpus_wt = 7'h0;
assign dma_wt = 7'h0;
assign lp_mreq = 8'h0;
assign arb_ctl_wr = 1'h0;
assign ch0_trig = 1'h0;
assign ch0_dir = 1'h0;
assign ch0_len = 16'h0;
assign ch0_addr = 32'h0;
assign ch0_stop = 1'h0;
assign ch1_trig = 1'h0;
assign ch1_dir = 1'h0;
assign ch1_len = 16'h0;
assign ch1_addr = 32'h0;
assign ch1_stop = 1'h0;
assign ch2_trig = 1'h0;
assign ch2_dir = 1'h0;
assign ch2_len = 16'h0;
assign ch2_addr = 32'h0;
assign ch2_stop = 1'h0;
assign ch3_trig = 1'h0;
assign ch3_dir = 1'h0;
assign ch3_len = 16'h0;
assign ch3_addr = 32'h0;
assign ch3_stop = 1'h0;
assign ch4_trig = 1'h0;
assign ch4_dir = 1'h0;
assign ch4_len = 16'h0;
assign ch4_addr = 32'h0;
assign ch4_stop = 1'h0;
assign ch5_trig = 1'h0;
assign ch5_stop = 1'h0;
assign ch5_dir = 1'h0;
assign ch5_len = 16'h0;
assign ch5_addr = 32'h0;
endmodule
//==============================================================================
//
//    This confidential and proprietary hardware may be used only as
//  authorized by a licensing agreement from
//                    SunMedia Technology Co., LTD.
//
//  In the event of publication, the following notice is applicable:
//
//            COPYRIGHT 2017, SunMedia Technology Co., LTD.
//                        ALL RIGHTS RESERVED
//
//  The entire notice above must be reproduced on all authorized copies.
//
//==============================================================================
//
//  File        : f_bio_cpum_ctrl.v
//  Author      : kun.zhang
//  Date        : 21/Nov/2017
//  Version     : 1.2
//  Abstract    : This is the CPU mode control block for BIO control. It
//                generates AXI request from received command information and
//                transfers write data to AXI and read data to TX packeger.
//                including a 32x72 S2P memory for write data and a 32x64 S2P
//                memory for read data. This module is for Achip to Bchip CPU
//                access.
//
//  Modification History:
//  Date          By            Version         Change Description
//------------------------------------------------------------------------------
//  24/Feb/2017   kun.zhang      1.0            Original
//  07/Jun/2017   xh.du          1.1            Modify for W2R block
//  21/Nov/2017   kun.zhang      1.2            Change AXI to 64bit, change
//                memory to S2P, add Read interleave and write response support,
//                modify tx_pkt interface.
//
//
//==============================================================================



module f_bio_cpum_ctrl (
  input  wire        sysclk,    // clock
  input  wire        sysrstn,   // reset
  input  wire        sft_rst,   // Soft reset
  output reg         sft_ack0,  // Soft reset ack from cpu master mode
  input  wire        adr_remap, // address remap enable
  input  wire [31:0] boot_addr, // Boot register address

  input  wire        bist_rstn, // NVIC_RST_B
  input  wire        bist_mode,
  input  wire        test_mode,
  input  wire        scan_enable,
  output wire [1:0]  bist_fail,
  output wire [1:0]  bist_finish,
  input  wire        mem_clk2x,

  input  wire        rx_cpu_req,    // Receiver to CPU request
  input  wire [58:0] rx_cpu_info,   // Receiver to CPU request information
  output wire        cpu_rx_acp,    // CPU to receiver request accept
  input  wire        cpu_wvld,      // CPU write data valid
  input  wire [71:0] cpu_wdata,     // CPU write data
  output wire        cpu_wrdy,      // CPU write ready, has enough buffer for RX data.

  output reg         cpu_tx_req,    // CPU to transmiter request
  output reg  [18:0] cpu_tx_info,   // CPU to transmiter request information
  input  wire        tx_cpu_ack,    // Transmiter to CPU request acknowlage
  input  wire        tx_cpu_ren,    // Transmiter to CPU read enable, low active
  output wire [63:0] cpu_tdata,     // CPU read data
  output reg  [3:0]  cpu_tlast,     // CPU read last and byte number
  output wire        cpu_clast,     // CPU read command last

  output wire [31:0] axim_probe,    //

  // AXI Write Address phase signals
  output reg  [7:0]  axim_awid,
  output reg  [31:0] axim_awaddr,
  output reg  [3:0]  axim_awlen,
  output reg  [2:0]  axim_awsize,
  output reg  [1:0]  axim_awburst,
  output reg  [1:0]  axim_awlock,
  output reg  [3:0]  axim_awcache,
  output reg  [2:0]  axim_awprot,
  output reg         axim_awvalid,
  input  wire        axim_awready,
  // AXI Write Data phase signals
  output wire [7:0]  axim_wid,
  output wire [63:0] axim_wdata,
  output wire [7:0]  axim_wstrb,
  output reg         axim_wlast,
  output reg         axim_wvalid,
  input  wire        axim_wready,
  // AXI Write Response phase signals
  input  wire [7:0]  axim_bid,
  input  wire [1:0]  axim_bresp,
  input  wire        axim_bvalid,
  output wire        axim_bready,

  // AXI Read Address phase signals
  output reg  [7:0]  axim_arid,
  output reg  [31:0] axim_araddr,
  output reg  [3:0]  axim_arlen,
  output reg  [2:0]  axim_arsize,
  output reg  [1:0]  axim_arburst,
  output reg  [1:0]  axim_arlock,
  output reg  [3:0]  axim_arcache,
  output reg  [2:0]  axim_arprot,
  output reg         axim_arvalid,
  input  wire        axim_arready,
  // AXI Read Data phase signals
  input  wire [7:0]  axim_rid,
  input  wire [63:0] axim_rdata,
  input  wire [1:0]  axim_rresp,
  input  wire        axim_rlast,
  input  wire        axim_rvalid,
  output reg         axim_rready
);

reg         trans_abort;
wire        abort_done;
reg         wr_abort;
reg         wr_abort_r;
wire        wabort_done;

wire        set_wcmd;   // Set a new write command, push
wire        pop_wcmd;   // Pop a new write command from queue
reg  [3:0]  wcmd_vld;   // Write command valid for queue
reg  [57:0] wcmd_q0;    // Write command queue entry0
reg  [57:0] wcmd_q1;    // Write command queue entry1
reg  [57:0] wcmd_q2;    // Write command queue entry2
reg  [57:0] wcmd_q3;    // Write command queue entry3

reg         wrd_rd_en;  // Write read memory enable
reg  [3:0]  wlen_n;     // write length calculated
reg  [1:0]  wsize_n;    // write size remaped for write data check
wire        pop_wdq;    // Pop a new write data burst form the queue
reg  [7:0]  wdq_vld;    // Write data queue valid
reg  [16:0] wdata_q0;   // Write data queue entry0
reg  [16:0] wdata_q1;   // Write data queue entry1
reg  [16:0] wdata_q2;   // Write data queue entry2
reg  [16:0] wdata_q3;   // Write data queue entry3
reg  [16:0] wdata_q4;   // Write data queue entry4
reg  [16:0] wdata_q5;   // Write data queue entry5
reg  [16:0] wdata_q6;   // Write data queue entry6
reg  [16:0] wdata_q7;   // Write data queue entry7
reg  [31:0] wid_queue;  // Write data id queue
reg  [3:0]  wid_qvld;   // Write data id queue valid
wire        wr_last;    // Write last of AXI
reg  [7:0]  wdq1_vld;   // Write data queue valid for pipe-line control
reg  [1:0]  wsize_d;    // Write data size for length calculation
reg  [1:0]  wsize_d1;   // Write data size for data select
reg  [2:0]  wadr_sel;   // Write address for data select

wire        push_wrq;   // Push new information to write response queue
wire        pop_wrq;    // Pop information from write response queue
reg  [7:0]  wrq_vld;    // Write response queue valid
reg  [9:0]  wrq_buf0;   // Write response queue entry0
reg  [9:0]  wrq_buf1;   // Write response queue entry1
reg  [9:0]  wrq_buf2;   // Write response queue entry2
reg  [9:0]  wrq_buf3;   // Write response queue entry3
reg  [9:0]  wrq_buf4;   // Write response queue entry4
reg  [9:0]  wrq_buf5;   // Write response queue entry5
reg  [9:0]  wrq_buf6;   // Write response queue entry6
reg  [9:0]  wrq_buf7;   // Write response queue entry7

wire        set_rcmd;   // Set a new read command, push
wire        pop_rcmd;   // Pop a new read command from queue
reg  [3:0]  rcmd_vld;   // Read command valid for queue
reg  [57:0] rcmd_q0;    // Read command queue entry0
reg  [57:0] rcmd_q1;    // Read command queue entry1
reg  [57:0] rcmd_q2;    // Read command queue entry2
reg  [57:0] rcmd_q3;    // Read command queue entry3
wire        push_rtq;   // Push a new transfer to read transfer queue
wire        pop_rtq;    // Pop a new read transfer information from queue
reg  [7:0]  rd_tqvld;    // Read transfer queue valid
reg  [15:0] rd_tqbuf0;     // Read transfer queue entry0;
reg  [15:0] rd_tqbuf1;     // Read transfer queue entry1;
reg  [15:0] rd_tqbuf2;     // Read transfer queue entry2;
reg  [15:0] rd_tqbuf3;     // Read transfer queue entry3;
reg  [15:0] rd_tqbuf4;     // Read transfer queue entry4;
reg  [15:0] rd_tqbuf5;     // Read transfer queue entry5;
reg  [15:0] rd_tqbuf6;     // Read transfer queue entry6;
reg  [15:0] rd_tqbuf7;     // Read transfer queue entry7;


wire        push_rdq;   // Push new transfer to read data quque
wire [19:0] rdq_info;   // Read data queue information
wire        pop_rdq;    // Pop new transfer from read data queue
reg  [7:0]  rdq_vld;    // Read data queue valid
reg  [19:0] rdata_q0;   // Read data queue entry0
reg  [19:0] rdata_q1;   // Read data queue entry1
reg  [19:0] rdata_q2;   // Read data queue entry2
reg  [19:0] rdata_q3;   // Read data queue entry3
reg  [19:0] rdata_q4;   // Read data queue entry4
reg  [19:0] rdata_q5;   // Read data queue entry5
reg  [19:0] rdata_q6;   // Read data queue entry6
reg  [19:0] rdata_q7;   // Read data queue entry7

wire [7:0]  tx_dlen;    // TX data length
wire        pop_txdq;   // Pop information from TX data queue
reg  [2:0]  txdq_vld;   // TX data queue valid
reg  [29:0] txdq_buf;   // TX data queue entry
reg  [3:0]  tx_dlast;   // TX data last, {tx_last, tx_bcnt};
reg         load_adr;   // Load memory address

wire        wmem_wr;    // Write data memory write
wire        wmem_rd;    // Write data memory read
wire        wmem_full;  // Write data memory full
wire        wmem_empty; // Write data memory empty
wire        wpre_wr0;   // Write memory pre-write0
wire        wpre_wr1;   // Write memory pre-write1
wire        wpre_wr2;   // Write memory pre-write2
wire        wpre_wr3;   // Write memory pre-write3
wire        wpre_wr4;   // Write memory pre-write4
wire        wpre_wr;    // Write memory pre-write
reg  [7:0]  wmem_dcnt0; // Write memory data counter0 for pre-read
reg  [2:0]  wmem_dcnt1; // Write memory data counter1 for pre-read
reg  [2:0]  wmem_dcnt10;// Write memory data counter1 temp0 for pre-read
reg  [2:0]  wmem_dcnt11;// Write memory data counter1 temp1 for pre-read
reg  [2:0]  wmem_dcnt12;// Write memory data counter1 temp2 for pre-read
wire        wsram_wr;   // Write SRAM write
wire        wsram_rd;   // Write SRAM read
reg  [7:0]  wsram_wptr;  // Write SRAM write pointer
reg  [7:0]  wsram_rptr;  // Write SRAM read pointer
wire        wsram_empty; // Write SRAM empty
reg  [71:0] wdata_tmp0; // Write data temp for pre-read
reg  [71:0] wdata_tmp1; // Write data temp for pre-read
reg  [71:0] wdata_tmp2; // Write data temp for pre-read
reg  [71:0] wdata_tmp3; // Write data temp for pre-read
reg  [3:0]  wr_dcnt0;   // Write data counter for axi data shift
reg  [71:0] wdata_buf0; // Write data buffer for shift
reg  [7:0]  wdata_vld;  // Write data valid for axi narrow bus mask
wire [63:0] wdata_vld1; // Write data valid for axi narrow bus mask
reg  [4:0]  wrd_len;    // Write data length
reg  [4:0]  wlen_cnt;   // Write data length counter
reg  [2:0]  wmem_rd_d;  // Write SRAM read delayed for data latch

reg         wmem_cen;   // Write SRAM chip enable
reg  [5:0]  wmem_raddr; // Write SRAM read address
reg         wmem_wen;   // Write SRAM write enable
reg  [5:0]  wmem_waddr; // Write SRAM write address
reg  [71:0] wmem_wdata; // Write SRAM write data
wire [71:0] wmem_rdata; // Write SRAM read data, SQ
wire [71:0] wmem_temp;  // Write SRAM read temp, Q

reg  [63:0] rdata_buf0; // Read data buffer for queue0
reg  [63:0] rdata_buf1; // Read data buffer for queue1
reg  [63:0] rdata_buf2; // Read data buffer for queue2
reg  [63:0] rdata_buf3; // Read data buffer for queue3
reg  [63:0] rdata_buf4; // Read data buffer for queue4
reg  [63:0] rdata_buf5; // Read data buffer for queue5
reg  [63:0] rdata_buf6; // Read data buffer for queue6
reg  [63:0] rdata_buf7; // Read data buffer for queue7
reg  [7:0]  rdata_cnt0; // Read data byte counter for queue0
reg  [7:0]  rdata_cnt1; // Read data byte counter for queue1
reg  [7:0]  rdata_cnt2; // Read data byte counter for queue2
reg  [7:0]  rdata_cnt3; // Read data byte counter for queue3
reg  [7:0]  rdata_cnt4; // Read data byte counter for queue4
reg  [7:0]  rdata_cnt5; // Read data byte counter for queue5
reg  [7:0]  rdata_cnt6; // Read data byte counter for queue6
reg  [7:0]  rdata_cnt7; // Read data byte counter for queue7
reg  [9:0]  rdata_len;  // Read data length in byte. 0 for 1 byte
reg  [7:0]  rmem_busy;  // Read data memory busy

wire        rmem_wr;    // Read memory write
wire        rmem_wr0;   // Read memory write for queue0;
wire        rmem_wr1;   // Read memory write for queue1;
wire        rmem_wr2;   // Read memory write for queue2;
wire        rmem_wr3;   // Read memory write for queue3;
wire        rmem_wr4;   // Read memory write for queue4;
wire        rmem_wr5;   // Read memory write for queue5;
wire        rmem_wr6;   // Read memory write for queue6;
wire        rmem_wr7;   // Read memory write for queue7;
reg  [7:0]  rmem_wsel;  // Read memory write select
reg  [7:0]  rdata_sel;  // Read data select for buffer shift

wire        rmem_cen;   // Read SRAM chip enable
reg  [7:0]  rmem_raddr; // Read SRAM read address
reg         rmem_wen;   // Read SRAM write enable
reg  [6:0]  rmem_waddr; // Read SRAM write address
wire [63:0] rmem_wdata; // Read SRAM write data
wire [63:0] rmem_rdata; // Read SRAM read data, SQ
wire [63:0] rmem_temp;  // Read SRAM read temp, Q

reg         temp0;      // Temp reg for addition
assign axim_probe = {1'b0, 1'b0, 1'b0, tx_cpu_ack, 2'h0,  cpu_wvld, cpu_wrdy,
                     axim_awvalid, axim_awready, axim_wvalid, axim_wready, axim_arvalid,
                     axim_arready, axim_rvalid, axim_rready, wcmd_vld[3:0], rcmd_vld[3:0],
                     wdq_vld[3:0], rdq_vld[3:0]};

//==============================================================================
assign cpu_rx_acp = rx_cpu_info[58] ? ~wcmd_vld[3] : ~rcmd_vld[3];
assign set_rcmd   = rx_cpu_req & ~rcmd_vld[3] & ~rx_cpu_info[58];
assign pop_rcmd   = rcmd_vld[0] & ~axim_arvalid & ~rd_tqvld[6] & ~sft_rst;
assign set_wcmd   = rx_cpu_req & ~wcmd_vld[3] & rx_cpu_info[58];
assign pop_wcmd   = wcmd_vld[0] & ~axim_awvalid & ~wdq1_vld[7] & ~sft_rst;
assign pop_wdq    = wdq_vld[0]&~wrd_rd_en&(~axim_wvalid|(axim_wvalid&axim_wready&axim_wlast));
assign push_rtq   = axim_arvalid&axim_arready;
assign pop_rtq    = axim_rvalid&axim_rready&axim_rlast;
assign abort_done = (rd_tqvld[3:0]==4'h0) & ~axim_arvalid & wabort_done;

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    trans_abort <= #0.1 1'b0;
  else begin
    if (sft_rst)
      trans_abort <= #0.1 1'b1;
    else if (abort_done)
      trans_abort <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    sft_ack0 <= #0.1 1'b0;
  else begin
    if (trans_abort&abort_done)
      sft_ack0 <= #0.1 1'b1;
    else
      sft_ack0 <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rcmd_vld <= #0.1 4'h0;
  else begin
    if (sft_rst)
      rcmd_vld <= #0.1 4'h0;
    else begin
      case ({set_rcmd, pop_rcmd})
        2'b01: rcmd_vld <= #0.1 {1'b0, rcmd_vld[3:1]};
        2'b10: rcmd_vld <= #0.1 {rcmd_vld[2:0], 1'b1};
        default:;// no change
      endcase
    end
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn) begin
    rcmd_q0 <= #0.1 58'h0;
    rcmd_q1 <= #0.1 58'h0;
    rcmd_q2 <= #0.1 58'h0;
    rcmd_q3 <= #0.1 58'h0;
  end else begin
    if (set_rcmd) begin
      casez (rcmd_vld)
        4'b0000: rcmd_q0 <= #0.1 rx_cpu_info[57:0];
        4'b0001: begin
          if (pop_rcmd)
            rcmd_q0 <= #0.1 rx_cpu_info[57:0];
          else
            rcmd_q1 <= #0.1 rx_cpu_info[57:0];
        end
        4'b001?: begin
          if (pop_rcmd) begin
            rcmd_q0 <= #0.1 rcmd_q1;
            rcmd_q1 <= #0.1 rx_cpu_info[57:0];
          end else
            rcmd_q2 <= #0.1 rx_cpu_info[57:0];
        end
        4'b01??: begin
          if (pop_rcmd) begin
            rcmd_q0 <= #0.1 rcmd_q1;
            rcmd_q1 <= #0.1 rcmd_q2;
            rcmd_q2 <= #0.1 rx_cpu_info[57:0];
          end else
            rcmd_q3 <= #0.1 rx_cpu_info[57:0];
        end
        4'b1???: begin
          if (pop_rcmd) begin
            rcmd_q0 <= #0.1 rcmd_q1;
            rcmd_q1 <= #0.1 rcmd_q2;
            rcmd_q2 <= #0.1 rcmd_q3;
            rcmd_q3 <= #0.1 rx_cpu_info[57:0];
          end
        end
        default:;   // no change
      endcase
    end else if (pop_rcmd) begin
      rcmd_q0 <= #0.1 rcmd_q1;
      rcmd_q1 <= #0.1 rcmd_q2;
      rcmd_q2 <= #0.1 rcmd_q3;
    end
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rd_tqvld <= #0.1 4'h0;
  else begin
    case ({push_rtq, pop_rtq})
      2'b01: rd_tqvld <= #0.1 {1'b0, rd_tqvld[7:1]};
      2'b10: rd_tqvld <= #0.1 {rd_tqvld[6:0], 1'b1};
      default:;
    endcase
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn) begin
    rd_tqbuf0 <= #0.1 {3'h0, 13'h0};
    rd_tqbuf1 <= #0.1 {3'h1, 13'h0};
    rd_tqbuf2 <= #0.1 {3'h2, 13'h0};
    rd_tqbuf3 <= #0.1 {3'h3, 13'h0};
    rd_tqbuf4 <= #0.1 {3'h4, 13'h0};
    rd_tqbuf5 <= #0.1 {3'h5, 13'h0};
    rd_tqbuf6 <= #0.1 {3'h6, 13'h0};
    rd_tqbuf7 <= #0.1 {3'h7, 13'h0};
  end else begin
    if (push_rtq) begin
      casez (rd_tqvld)
        8'b0000_0000: rd_tqbuf0[12:0] <= #0.1 {axim_araddr[2:0], axim_arsize[1:0], axim_arid};
        8'b0000_0001: begin
          if (pop_rtq) begin
            rd_tqbuf0 <= #0.1 {rd_tqbuf1[15:13], axim_araddr[2:0], axim_arsize[1:0], axim_arid};
            rd_tqbuf1[15:13] <= #0.1 rd_tqbuf2[15:13];
            rd_tqbuf2[15:13] <= #0.1 rd_tqbuf3[15:13];
            rd_tqbuf3[15:13] <= #0.1 rd_tqbuf4[15:13];
            rd_tqbuf4[15:13] <= #0.1 rd_tqbuf5[15:13];
            rd_tqbuf5[15:13] <= #0.1 rd_tqbuf6[15:13];
            rd_tqbuf6[15:13] <= #0.1 rd_tqbuf7[15:13];
            rd_tqbuf7[15:13] <= #0.1 rd_tqbuf0[15:13];
          end else
            rd_tqbuf1[12:0] <= #0.1 {axim_araddr[2:0], axim_arsize[1:0], axim_arid};
        end
        8'b0000_001?: begin
          if (pop_rtq&(rd_tqbuf0[7:0]==axim_rid)) begin
            rd_tqbuf0 <= #0.1 rd_tqbuf1;
            rd_tqbuf1 <= #0.1 {rd_tqbuf2[15:13], axim_araddr[2:0], axim_arsize[1:0], axim_arid};
            rd_tqbuf2[15:13] <= #0.1 rd_tqbuf3[15:13];
            rd_tqbuf3[15:13] <= #0.1 rd_tqbuf4[15:13];
            rd_tqbuf4[15:13] <= #0.1 rd_tqbuf5[15:13];
            rd_tqbuf5[15:13] <= #0.1 rd_tqbuf6[15:13];
            rd_tqbuf6[15:13] <= #0.1 rd_tqbuf7[15:13];
            rd_tqbuf7[15:13] <= #0.1 rd_tqbuf0[15:13];
          end else if (pop_rtq) begin
            rd_tqbuf1 <= #0.1 {rd_tqbuf2[15:13], axim_araddr[2:0], axim_arsize[1:0], axim_arid};
            rd_tqbuf2[15:13] <= #0.1 rd_tqbuf3[15:13];
            rd_tqbuf3[15:13] <= #0.1 rd_tqbuf4[15:13];
            rd_tqbuf4[15:13] <= #0.1 rd_tqbuf5[15:13];
            rd_tqbuf5[15:13] <= #0.1 rd_tqbuf6[15:13];
            rd_tqbuf6[15:13] <= #0.1 rd_tqbuf7[15:13];
            rd_tqbuf7[15:13] <= #0.1 rd_tqbuf1[15:13];
          end else
            rd_tqbuf2[12:0] <= #0.1 {axim_araddr[2:0], axim_arsize[1:0], axim_arid};
        end
        8'b0000_01??: begin
          if (pop_rtq&(rd_tqbuf0[7:0]==axim_rid)) begin
            rd_tqbuf0 <= #0.1 rd_tqbuf1;
            rd_tqbuf1 <= #0.1 rd_tqbuf2;
            rd_tqbuf2 <= #0.1 {rd_tqbuf3[15:13], axim_araddr[2:0], axim_arsize[1:0], axim_arid};
            rd_tqbuf3[15:13] <= #0.1 rd_tqbuf4[15:13];
            rd_tqbuf4[15:13] <= #0.1 rd_tqbuf5[15:13];
            rd_tqbuf5[15:13] <= #0.1 rd_tqbuf6[15:13];
            rd_tqbuf6[15:13] <= #0.1 rd_tqbuf7[15:13];
            rd_tqbuf7[15:13] <= #0.1 rd_tqbuf0[15:13];
          end else if (pop_rtq&(rd_tqbuf1[7:0]==axim_rid)) begin
            rd_tqbuf1 <= #0.1 rd_tqbuf2;
            rd_tqbuf2 <= #0.1 {rd_tqbuf3[15:13], axim_araddr[2:0], axim_arsize[1:0], axim_arid};
            rd_tqbuf3[15:13] <= #0.1 rd_tqbuf4[15:13];
            rd_tqbuf4[15:13] <= #0.1 rd_tqbuf5[15:13];
            rd_tqbuf5[15:13] <= #0.1 rd_tqbuf6[15:13];
            rd_tqbuf6[15:13] <= #0.1 rd_tqbuf7[15:13];
            rd_tqbuf7[15:13] <= #0.1 rd_tqbuf1[15:13];
          end else if (pop_rtq) begin
            rd_tqbuf2 <= #0.1 {rd_tqbuf3[15:13], axim_araddr[2:0], axim_arsize[1:0], axim_arid};
            rd_tqbuf3[15:13] <= #0.1 rd_tqbuf4[15:13];
            rd_tqbuf4[15:13] <= #0.1 rd_tqbuf5[15:13];
            rd_tqbuf5[15:13] <= #0.1 rd_tqbuf6[15:13];
            rd_tqbuf6[15:13] <= #0.1 rd_tqbuf7[15:13];
            rd_tqbuf7[15:13] <= #0.1 rd_tqbuf2[15:13];
          end else
            rd_tqbuf3[12:0] <= #0.1 {axim_araddr[2:0], axim_arsize[1:0], axim_arid};
        end
        8'b0000_1???: begin
          if (pop_rtq&(rd_tqbuf0[7:0]==axim_rid)) begin
            rd_tqbuf0 <= #0.1 rd_tqbuf1;
            rd_tqbuf1 <= #0.1 rd_tqbuf2;
            rd_tqbuf2 <= #0.1 rd_tqbuf3;
            rd_tqbuf3 <= #0.1 {rd_tqbuf4[15:13], axim_araddr[2:0], axim_arsize[1:0], axim_arid};
            rd_tqbuf4[15:13] <= #0.1 rd_tqbuf5[15:13];
            rd_tqbuf5[15:13] <= #0.1 rd_tqbuf6[15:13];
            rd_tqbuf6[15:13] <= #0.1 rd_tqbuf7[15:13];
            rd_tqbuf7[15:13] <= #0.1 rd_tqbuf0[15:13];
          end else if (pop_rtq&(rd_tqbuf1[7:0]==axim_rid)) begin
            rd_tqbuf1 <= #0.1 rd_tqbuf2;
            rd_tqbuf2 <= #0.1 rd_tqbuf3;
            rd_tqbuf3 <= #0.1 {rd_tqbuf4[15:13], axim_araddr[2:0], axim_arsize[1:0], axim_arid};
            rd_tqbuf4[15:13] <= #0.1 rd_tqbuf5[15:13];
            rd_tqbuf5[15:13] <= #0.1 rd_tqbuf6[15:13];
            rd_tqbuf6[15:13] <= #0.1 rd_tqbuf7[15:13];
            rd_tqbuf7[15:13] <= #0.1 rd_tqbuf1[15:13];
          end else if (pop_rtq&(rd_tqbuf2[7:0]==axim_rid)) begin
            rd_tqbuf2 <= #0.1 rd_tqbuf3;
            rd_tqbuf3 <= #0.1 {rd_tqbuf4[15:13], axim_araddr[2:0], axim_arsize[1:0], axim_arid};
            rd_tqbuf4[15:13] <= #0.1 rd_tqbuf5[15:13];
            rd_tqbuf5[15:13] <= #0.1 rd_tqbuf6[15:13];
            rd_tqbuf6[15:13] <= #0.1 rd_tqbuf7[15:13];
            rd_tqbuf7[15:13] <= #0.1 rd_tqbuf2[15:13];
          end else if (pop_rtq) begin
            rd_tqbuf3 <= #0.1 {rd_tqbuf4[15:13], axim_araddr[2:0], axim_arsize[1:0], axim_arid};
            rd_tqbuf4[15:13] <= #0.1 rd_tqbuf5[15:13];
            rd_tqbuf5[15:13] <= #0.1 rd_tqbuf6[15:13];
            rd_tqbuf6[15:13] <= #0.1 rd_tqbuf7[15:13];
            rd_tqbuf7[15:13] <= #0.1 rd_tqbuf3[15:13];
          end else
            rd_tqbuf4[12:0] <= #0.1 {axim_araddr[2:0], axim_arsize[1:0], axim_arid};
        end
        8'b0001_????: begin
          if (pop_rtq&(rd_tqbuf0[7:0]==axim_rid)) begin
            rd_tqbuf0 <= #0.1 rd_tqbuf1;
            rd_tqbuf1 <= #0.1 rd_tqbuf2;
            rd_tqbuf2 <= #0.1 rd_tqbuf3;
            rd_tqbuf3 <= #0.1 rd_tqbuf4;
            rd_tqbuf4 <= #0.1 {rd_tqbuf5[15:13], axim_araddr[2:0], axim_arsize[1:0], axim_arid};
            rd_tqbuf5[15:13] <= #0.1 rd_tqbuf6[15:13];
            rd_tqbuf6[15:13] <= #0.1 rd_tqbuf7[15:13];
            rd_tqbuf7[15:13] <= #0.1 rd_tqbuf0[15:13];
          end else if (pop_rtq&(rd_tqbuf1[7:0]==axim_rid)) begin
            rd_tqbuf1 <= #0.1 rd_tqbuf2;
            rd_tqbuf2 <= #0.1 rd_tqbuf3;
            rd_tqbuf3 <= #0.1 rd_tqbuf4;
            rd_tqbuf4 <= #0.1 {rd_tqbuf5[15:13], axim_araddr[2:0], axim_arsize[1:0], axim_arid};
            rd_tqbuf5[15:13] <= #0.1 rd_tqbuf6[15:13];
            rd_tqbuf6[15:13] <= #0.1 rd_tqbuf7[15:13];
            rd_tqbuf7[15:13] <= #0.1 rd_tqbuf1[15:13];
          end else if (pop_rtq&(rd_tqbuf2[7:0]==axim_rid)) begin
            rd_tqbuf2 <= #0.1 rd_tqbuf3;
            rd_tqbuf3 <= #0.1 rd_tqbuf4;
            rd_tqbuf4 <= #0.1 {rd_tqbuf5[15:13], axim_araddr[2:0], axim_arsize[1:0], axim_arid};
            rd_tqbuf5[15:13] <= #0.1 rd_tqbuf6[15:13];
            rd_tqbuf6[15:13] <= #0.1 rd_tqbuf7[15:13];
            rd_tqbuf7[15:13] <= #0.1 rd_tqbuf2[15:13];
          end else if (pop_rtq&(rd_tqbuf3[7:0]==axim_rid)) begin
            rd_tqbuf3 <= #0.1 rd_tqbuf4;
            rd_tqbuf4 <= #0.1 {rd_tqbuf5[15:13], axim_araddr[2:0], axim_arsize[1:0], axim_arid};
            rd_tqbuf5[15:13] <= #0.1 rd_tqbuf6[15:13];
            rd_tqbuf6[15:13] <= #0.1 rd_tqbuf7[15:13];
            rd_tqbuf7[15:13] <= #0.1 rd_tqbuf3[15:13];
          end else if (pop_rtq) begin
            rd_tqbuf4 <= #0.1 {rd_tqbuf5[15:13], axim_araddr[2:0], axim_arsize[1:0], axim_arid};
            rd_tqbuf5[15:13] <= #0.1 rd_tqbuf6[15:13];
            rd_tqbuf6[15:13] <= #0.1 rd_tqbuf7[15:13];
            rd_tqbuf7[15:13] <= #0.1 rd_tqbuf4[15:13];
          end else
            rd_tqbuf5[12:0] <= #0.1 {axim_araddr[2:0], axim_arsize[1:0], axim_arid};
        end
        8'b001?_????: begin
          if (pop_rtq&(rd_tqbuf0[7:0]==axim_rid)) begin
            rd_tqbuf0 <= #0.1 rd_tqbuf1;
            rd_tqbuf1 <= #0.1 rd_tqbuf2;
            rd_tqbuf2 <= #0.1 rd_tqbuf3;
            rd_tqbuf3 <= #0.1 rd_tqbuf4;
            rd_tqbuf4 <= #0.1 rd_tqbuf5;
            rd_tqbuf5 <= #0.1 {rd_tqbuf6[15:13], axim_araddr[2:0], axim_arsize[1:0], axim_arid};
            rd_tqbuf6[15:13] <= #0.1 rd_tqbuf7[15:13];
            rd_tqbuf7[15:13] <= #0.1 rd_tqbuf0[15:13];
          end else if (pop_rtq&(rd_tqbuf1[7:0]==axim_rid)) begin
            rd_tqbuf1 <= #0.1 rd_tqbuf2;
            rd_tqbuf2 <= #0.1 rd_tqbuf3;
            rd_tqbuf3 <= #0.1 rd_tqbuf4;
            rd_tqbuf4 <= #0.1 rd_tqbuf5;
            rd_tqbuf5 <= #0.1 {rd_tqbuf6[15:13], axim_araddr[2:0], axim_arsize[1:0], axim_arid};
            rd_tqbuf6[15:13] <= #0.1 rd_tqbuf7[15:13];
            rd_tqbuf7[15:13] <= #0.1 rd_tqbuf1[15:13];
          end else if (pop_rtq&(rd_tqbuf2[7:0]==axim_rid)) begin
            rd_tqbuf2 <= #0.1 rd_tqbuf3;
            rd_tqbuf3 <= #0.1 rd_tqbuf4;
            rd_tqbuf4 <= #0.1 rd_tqbuf5;
            rd_tqbuf5 <= #0.1 {rd_tqbuf6[15:13], axim_araddr[2:0], axim_arsize[1:0], axim_arid};
            rd_tqbuf6[15:13] <= #0.1 rd_tqbuf7[15:13];
            rd_tqbuf7[15:13] <= #0.1 rd_tqbuf2[15:13];
          end else if (pop_rtq&(rd_tqbuf3[7:0]==axim_rid)) begin
            rd_tqbuf3 <= #0.1 rd_tqbuf4;
            rd_tqbuf4 <= #0.1 rd_tqbuf5;
            rd_tqbuf5 <= #0.1 {rd_tqbuf6[15:13], axim_araddr[2:0], axim_arsize[1:0], axim_arid};
            rd_tqbuf6[15:13] <= #0.1 rd_tqbuf7[15:13];
            rd_tqbuf7[15:13] <= #0.1 rd_tqbuf3[15:13];
          end else if (pop_rtq&(rd_tqbuf4[7:0]==axim_rid)) begin
            rd_tqbuf4 <= #0.1 rd_tqbuf5;
            rd_tqbuf5 <= #0.1 {rd_tqbuf6[15:13], axim_araddr[2:0], axim_arsize[1:0], axim_arid};
            rd_tqbuf6[15:13] <= #0.1 rd_tqbuf7[15:13];
            rd_tqbuf7[15:13] <= #0.1 rd_tqbuf4[15:13];
          end else if (pop_rtq) begin
            rd_tqbuf5 <= #0.1 {rd_tqbuf6[15:13], axim_araddr[2:0], axim_arsize[1:0], axim_arid};
            rd_tqbuf6[15:13] <= #0.1 rd_tqbuf7[15:13];
            rd_tqbuf7[15:13] <= #0.1 rd_tqbuf5[15:13];
          end else
            rd_tqbuf6[12:0] <= #0.1 {axim_araddr[2:0], axim_arsize[1:0], axim_arid};
        end
        8'b01??_????: begin
          if (pop_rtq&(rd_tqbuf0[7:0]==axim_rid)) begin
            rd_tqbuf0 <= #0.1 rd_tqbuf1;
            rd_tqbuf1 <= #0.1 rd_tqbuf2;
            rd_tqbuf2 <= #0.1 rd_tqbuf3;
            rd_tqbuf3 <= #0.1 rd_tqbuf4;
            rd_tqbuf4 <= #0.1 rd_tqbuf5;
            rd_tqbuf5 <= #0.1 rd_tqbuf6;
            rd_tqbuf6 <= #0.1 {rd_tqbuf7[15:13], axim_araddr[2:0], axim_arsize[1:0], axim_arid};
            rd_tqbuf7[15:13] <= #0.1 rd_tqbuf0[15:13];
          end else if (pop_rtq&(rd_tqbuf1[7:0]==axim_rid)) begin
            rd_tqbuf1 <= #0.1 rd_tqbuf2;
            rd_tqbuf2 <= #0.1 rd_tqbuf3;
            rd_tqbuf3 <= #0.1 rd_tqbuf4;
            rd_tqbuf4 <= #0.1 rd_tqbuf5;
            rd_tqbuf5 <= #0.1 rd_tqbuf6;
            rd_tqbuf6 <= #0.1 {rd_tqbuf7[15:13], axim_araddr[2:0], axim_arsize[1:0], axim_arid};
            rd_tqbuf7[15:13] <= #0.1 rd_tqbuf1[15:13];
          end else if (pop_rtq&(rd_tqbuf2[7:0]==axim_rid)) begin
            rd_tqbuf2 <= #0.1 rd_tqbuf3;
            rd_tqbuf3 <= #0.1 rd_tqbuf4;
            rd_tqbuf4 <= #0.1 rd_tqbuf5;
            rd_tqbuf5 <= #0.1 rd_tqbuf6;
            rd_tqbuf6 <= #0.1 {rd_tqbuf7[15:13], axim_araddr[2:0], axim_arsize[1:0], axim_arid};
            rd_tqbuf7[15:13] <= #0.1 rd_tqbuf2[15:13];
          end else if (pop_rtq&(rd_tqbuf3[7:0]==axim_rid)) begin
            rd_tqbuf3 <= #0.1 rd_tqbuf4;
            rd_tqbuf4 <= #0.1 rd_tqbuf5;
            rd_tqbuf5 <= #0.1 rd_tqbuf6;
            rd_tqbuf6 <= #0.1 {rd_tqbuf7[15:13], axim_araddr[2:0], axim_arsize[1:0], axim_arid};
            rd_tqbuf7[15:13] <= #0.1 rd_tqbuf3[15:13];
          end else if (pop_rtq&(rd_tqbuf4[7:0]==axim_rid)) begin
            rd_tqbuf4 <= #0.1 rd_tqbuf5;
            rd_tqbuf5 <= #0.1 rd_tqbuf6;
            rd_tqbuf6 <= #0.1 {rd_tqbuf7[15:13], axim_araddr[2:0], axim_arsize[1:0], axim_arid};
            rd_tqbuf7[15:13] <= #0.1 rd_tqbuf4[15:13];
          end else if (pop_rtq&(rd_tqbuf5[7:0]==axim_rid)) begin
            rd_tqbuf5 <= #0.1 rd_tqbuf6;
            rd_tqbuf6 <= #0.1 {rd_tqbuf7[15:13], axim_araddr[2:0], axim_arsize[1:0], axim_arid};
            rd_tqbuf7[15:13] <= #0.1 rd_tqbuf5[15:13];
          end else if (pop_rtq) begin
            rd_tqbuf6 <= #0.1 {rd_tqbuf6[15:13], axim_araddr[2:0], axim_arsize[1:0], axim_arid};
            rd_tqbuf7[15:13] <= #0.1 rd_tqbuf6[15:13];
          end else
            rd_tqbuf7[12:0] <= #0.1 {axim_araddr[2:0], axim_arsize[1:0], axim_arid};
        end
        8'b1???_????: begin
          if (pop_rtq&(rd_tqbuf0[7:0]==axim_rid)) begin
            rd_tqbuf0 <= #0.1 rd_tqbuf1;
            rd_tqbuf1 <= #0.1 rd_tqbuf2;
            rd_tqbuf2 <= #0.1 rd_tqbuf3;
            rd_tqbuf3 <= #0.1 rd_tqbuf4;
            rd_tqbuf4 <= #0.1 rd_tqbuf5;
            rd_tqbuf5 <= #0.1 rd_tqbuf6;
            rd_tqbuf6 <= #0.1 rd_tqbuf7;
            rd_tqbuf7 <= #0.1 {rd_tqbuf0[15:13], axim_araddr[2:0], axim_arsize[1:0], axim_arid};
          end else if (pop_rtq&(rd_tqbuf1[7:0]==axim_rid)) begin
            rd_tqbuf1 <= #0.1 rd_tqbuf2;
            rd_tqbuf2 <= #0.1 rd_tqbuf3;
            rd_tqbuf3 <= #0.1 rd_tqbuf4;
            rd_tqbuf4 <= #0.1 rd_tqbuf5;
            rd_tqbuf5 <= #0.1 rd_tqbuf6;
            rd_tqbuf6 <= #0.1 rd_tqbuf7;
            rd_tqbuf7 <= #0.1 {rd_tqbuf1[15:13], axim_araddr[2:0], axim_arsize[1:0], axim_arid};
          end else if (pop_rtq&(rd_tqbuf2[7:0]==axim_rid)) begin
            rd_tqbuf2 <= #0.1 rd_tqbuf3;
            rd_tqbuf3 <= #0.1 rd_tqbuf4;
            rd_tqbuf4 <= #0.1 rd_tqbuf5;
            rd_tqbuf5 <= #0.1 rd_tqbuf6;
            rd_tqbuf6 <= #0.1 rd_tqbuf7;
            rd_tqbuf7 <= #0.1 {rd_tqbuf2[15:13], axim_araddr[2:0], axim_arsize[1:0], axim_arid};
          end else if (pop_rtq&(rd_tqbuf3[7:0]==axim_rid)) begin
            rd_tqbuf3 <= #0.1 rd_tqbuf4;
            rd_tqbuf4 <= #0.1 rd_tqbuf5;
            rd_tqbuf5 <= #0.1 rd_tqbuf6;
            rd_tqbuf6 <= #0.1 rd_tqbuf7;
            rd_tqbuf7 <= #0.1 {rd_tqbuf3[15:13], axim_araddr[2:0], axim_arsize[1:0], axim_arid};
            rd_tqbuf7[15:13] <= #0.1 rd_tqbuf3[15:13];
          end else if (pop_rtq&(rd_tqbuf4[7:0]==axim_rid)) begin
            rd_tqbuf4 <= #0.1 rd_tqbuf5;
            rd_tqbuf5 <= #0.1 rd_tqbuf6;
            rd_tqbuf6 <= #0.1 rd_tqbuf7;
            rd_tqbuf7 <= #0.1 {rd_tqbuf4[15:13], axim_araddr[2:0], axim_arsize[1:0], axim_arid};
          end else if (pop_rtq&(rd_tqbuf5[7:0]==axim_rid)) begin
            rd_tqbuf5 <= #0.1 rd_tqbuf6;
            rd_tqbuf6 <= #0.1 rd_tqbuf7;
            rd_tqbuf7 <= #0.1 {rd_tqbuf5[15:13], axim_araddr[2:0], axim_arsize[1:0], axim_arid};
          end else if (pop_rtq&(rd_tqbuf6[7:0]==axim_rid)) begin
            rd_tqbuf6 <= #0.1 rd_tqbuf7;
            rd_tqbuf7 <= #0.1 {rd_tqbuf6[15:13], axim_araddr[2:0], axim_arsize[1:0], axim_arid};
          end else if (pop_rtq) begin
            rd_tqbuf7 <= #0.1 {rd_tqbuf7[15:13], axim_araddr[2:0], axim_arsize[1:0], axim_arid};
          end else
            rd_tqbuf7[12:0] <= #0.1 {axim_araddr[2:0], axim_arsize[1:0], axim_arid};
        end
        default:;   // no change
      endcase
    end else if (pop_rtq) begin
      if (rd_tqvld[0]&(rd_tqbuf0[7:0]==axim_rid)) begin
        rd_tqbuf0 <= #0.1 rd_tqbuf1;
        rd_tqbuf1 <= #0.1 rd_tqbuf2;
        rd_tqbuf2 <= #0.1 rd_tqbuf3;
        rd_tqbuf3 <= #0.1 rd_tqbuf4;
        rd_tqbuf4 <= #0.1 rd_tqbuf5;
        rd_tqbuf5 <= #0.1 rd_tqbuf6;
        rd_tqbuf6 <= #0.1 rd_tqbuf7;
        rd_tqbuf7[15:13] <= #0.1 rd_tqbuf0[15:13];
      end else if (rd_tqvld[1]&(rd_tqbuf1[7:0]==axim_rid)) begin
        rd_tqbuf1 <= #0.1 rd_tqbuf2;
        rd_tqbuf2 <= #0.1 rd_tqbuf3;
        rd_tqbuf3 <= #0.1 rd_tqbuf4;
        rd_tqbuf4 <= #0.1 rd_tqbuf5;
        rd_tqbuf5 <= #0.1 rd_tqbuf6;
        rd_tqbuf6 <= #0.1 rd_tqbuf7;
        rd_tqbuf7[15:13] <= #0.1 rd_tqbuf1[15:13];
      end else if (rd_tqvld[2]&(rd_tqbuf2[7:0]==axim_rid)) begin
        rd_tqbuf2 <= #0.1 rd_tqbuf3;
        rd_tqbuf3 <= #0.1 rd_tqbuf4;
        rd_tqbuf4 <= #0.1 rd_tqbuf5;
        rd_tqbuf5 <= #0.1 rd_tqbuf6;
        rd_tqbuf6 <= #0.1 rd_tqbuf7;
        rd_tqbuf7[15:13] <= #0.1 rd_tqbuf2[15:13];
      end else if (rd_tqvld[3]&(rd_tqbuf3[7:0]==axim_rid)) begin
        rd_tqbuf3 <= #0.1 rd_tqbuf4;
        rd_tqbuf4 <= #0.1 rd_tqbuf5;
        rd_tqbuf5 <= #0.1 rd_tqbuf6;
        rd_tqbuf6 <= #0.1 rd_tqbuf7;
        rd_tqbuf7[15:13] <= #0.1 rd_tqbuf3[15:13];
      end else if (rd_tqvld[4]&(rd_tqbuf4[7:0]==axim_rid)) begin
        rd_tqbuf4 <= #0.1 rd_tqbuf5;
        rd_tqbuf5 <= #0.1 rd_tqbuf6;
        rd_tqbuf6 <= #0.1 rd_tqbuf7;
        rd_tqbuf7[15:13] <= #0.1 rd_tqbuf4[15:13];
      end else if (rd_tqvld[5]&(rd_tqbuf5[7:0]==axim_rid)) begin
        rd_tqbuf5 <= #0.1 rd_tqbuf6;
        rd_tqbuf6 <= #0.1 rd_tqbuf7;
        rd_tqbuf7[15:13] <= #0.1 rd_tqbuf5[15:13];
      end else if (rd_tqvld[6]&(rd_tqbuf6[7:0]==axim_rid)) begin
        rd_tqbuf6 <= #0.1 rd_tqbuf7;
        rd_tqbuf7[15:13] <= #0.1 rd_tqbuf6[15:13];
      end
    end
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wcmd_vld <= #0.1 4'h0;
  else begin
    if (sft_rst)
      wcmd_vld <= #0.1 4'h0;
    else begin
      case ({set_wcmd, pop_wcmd})
        2'b01: wcmd_vld <= #0.1 {1'b0, wcmd_vld[3:1]};
        2'b10: wcmd_vld <= #0.1 {wcmd_vld[2:0], 1'b1};
        default:;// no change
      endcase
    end
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn) begin
    wcmd_q0 <= #0.1 52'h0;
    wcmd_q1 <= #0.1 52'h0;
    wcmd_q2 <= #0.1 52'h0;
    wcmd_q3 <= #0.1 52'h0;
  end else begin
    if (set_wcmd) begin
      casez (wcmd_vld)
        4'b0000: wcmd_q0 <= #0.1 rx_cpu_info[57:0];
        4'b0001: begin
          if (pop_wcmd)
            wcmd_q0 <= #0.1 rx_cpu_info[57:0];
          else
            wcmd_q1 <= #0.1 rx_cpu_info[57:0];
        end
        4'b001?: begin
          if (pop_wcmd) begin
            wcmd_q0 <= #0.1 wcmd_q1;
            wcmd_q1 <= #0.1 rx_cpu_info[57:0];
          end else
            wcmd_q2 <= #0.1 rx_cpu_info[57:0];
        end
        4'b01??: begin
          if (pop_wcmd) begin
            wcmd_q0 <= #0.1 wcmd_q1;
            wcmd_q1 <= #0.1 wcmd_q2;
            wcmd_q2 <= #0.1 rx_cpu_info[57:0];
          end else
            wcmd_q3 <= #0.1 rx_cpu_info[57:0];
        end
        4'b1???: begin
          if (pop_wcmd) begin
            wcmd_q0 <= #0.1 wcmd_q1;
            wcmd_q1 <= #0.1 wcmd_q2;
            wcmd_q2 <= #0.1 wcmd_q3;
            wcmd_q3 <= #0.1 rx_cpu_info[57:0];
          end
        end
        default:;   // No change
      endcase
    end else if (pop_wcmd) begin
      wcmd_q0 <= #0.1 wcmd_q1;
      wcmd_q1 <= #0.1 wcmd_q2;
      wcmd_q2 <= #0.1 wcmd_q3;
    end
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wdq_vld <= #0.1 8'h0;
  else begin
    case ({pop_wcmd, pop_wdq})
      2'b01  : wdq_vld <= #0.1 {1'b0, wdq_vld[7:1]};
      2'b10  : wdq_vld <= #0.1 {wdq_vld[6:0], 1'b1};
      default:; // no change
    endcase
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn) begin
    wdata_q0 <= #0.1 17'h0;
    wdata_q1 <= #0.1 17'h0;
    wdata_q2 <= #0.1 17'h0;
    wdata_q3 <= #0.1 17'h0;
    wdata_q4 <= #0.1 17'h0;
    wdata_q5 <= #0.1 17'h0;
    wdata_q6 <= #0.1 17'h0;
    wdata_q7 <= #0.1 17'h0;
  end else begin
    if (pop_wcmd) begin
      casez (wdq_vld)
        8'b0000_0000: wdata_q0 <= #0.1 {wcmd_q0[2:0], wsize_n, wcmd_q0[39:32], wlen_n};
        8'b0000_0001: begin
          if (pop_wdq)
            wdata_q0 <= #0.1 {wcmd_q0[2:0], wsize_n, wcmd_q0[39:32], wlen_n};
          else
            wdata_q1 <= #0.1 {wcmd_q0[2:0], wsize_n, wcmd_q0[39:32], wlen_n};
        end
        8'b0000_001?: begin
          if (pop_wdq) begin
            wdata_q0 <= #0.1 wdata_q1;
            wdata_q1 <= #0.1 {wcmd_q0[2:0], wsize_n, wcmd_q0[39:32], wlen_n};
          end else
            wdata_q2 <= #0.1 {wcmd_q0[2:0], wsize_n, wcmd_q0[39:32], wlen_n};
        end
        8'b0000_01??: begin
          if (pop_wdq) begin
            wdata_q0 <= #0.1 wdata_q1;
            wdata_q1 <= #0.1 wdata_q2;
            wdata_q2 <= #0.1 {wcmd_q0[2:0], wsize_n, wcmd_q0[39:32], wlen_n};
          end else
            wdata_q3 <= #0.1 {wcmd_q0[2:0], wsize_n, wcmd_q0[39:32], wlen_n};
        end
        8'b0000_1???: begin
          if (pop_wdq) begin
            wdata_q0 <= #0.1 wdata_q1;
            wdata_q1 <= #0.1 wdata_q2;
            wdata_q2 <= #0.1 wdata_q3;
            wdata_q3 <= #0.1 {wcmd_q0[2:0], wsize_n, wcmd_q0[39:32], wlen_n};
          end else
            wdata_q4 <= #0.1 {wcmd_q0[2:0], wsize_n, wcmd_q0[39:32], wlen_n};
        end
        8'b0001_????: begin
          if (pop_wdq) begin
            wdata_q0 <= #0.1 wdata_q1;
            wdata_q1 <= #0.1 wdata_q2;
            wdata_q2 <= #0.1 wdata_q3;
            wdata_q3 <= #0.1 wdata_q4;
            wdata_q4 <= #0.1 {wcmd_q0[2:0], wsize_n, wcmd_q0[39:32], wlen_n};
          end else
            wdata_q5 <= #0.1 {wcmd_q0[2:0], wsize_n, wcmd_q0[39:32], wlen_n};
        end
        8'b001?_????: begin
          if (pop_wdq) begin
            wdata_q0 <= #0.1 wdata_q1;
            wdata_q1 <= #0.1 wdata_q2;
            wdata_q2 <= #0.1 wdata_q3;
            wdata_q3 <= #0.1 wdata_q4;
            wdata_q4 <= #0.1 wdata_q5;
            wdata_q5 <= #0.1 {wcmd_q0[2:0], wsize_n, wcmd_q0[39:32], wlen_n};
          end else
            wdata_q6 <= #0.1 {wcmd_q0[2:0], wsize_n, wcmd_q0[39:32], wlen_n};
        end
        8'b01??_????: begin
          if (pop_wdq) begin
            wdata_q0 <= #0.1 wdata_q1;
            wdata_q1 <= #0.1 wdata_q2;
            wdata_q2 <= #0.1 wdata_q3;
            wdata_q3 <= #0.1 wdata_q4;
            wdata_q4 <= #0.1 wdata_q5;
            wdata_q5 <= #0.1 wdata_q6;
            wdata_q6 <= #0.1 {wcmd_q0[2:0], wsize_n, wcmd_q0[39:32], wlen_n};
          end else
            wdata_q7 <= #0.1 {wcmd_q0[2:0], wsize_n, wcmd_q0[39:32], wlen_n};
        end
        8'b1???_????: begin
          if (pop_wdq) begin
            wdata_q0 <= #0.1 wdata_q1;
            wdata_q1 <= #0.1 wdata_q2;
            wdata_q2 <= #0.1 wdata_q3;
            wdata_q3 <= #0.1 wdata_q4;
            wdata_q4 <= #0.1 wdata_q5;
            wdata_q5 <= #0.1 wdata_q6;
            wdata_q6 <= #0.1 wdata_q7;
            wdata_q7 <= #0.1 {wcmd_q0[2:0], wsize_n, wcmd_q0[39:32], wlen_n};
          end// else
          //  wdata_q7 <= `DLY {wcmd_q0[2:0], wsize_n, wcmd_q0[39:32], wlen_n};
        end
        default:;   // No change
      endcase
    end else if (pop_wdq) begin
      wdata_q0 <= #0.1 wdata_q1;
      wdata_q1 <= #0.1 wdata_q2;
      wdata_q2 <= #0.1 wdata_q3;
      wdata_q3 <= #0.1 wdata_q4;
      wdata_q4 <= #0.1 wdata_q5;
      wdata_q5 <= #0.1 wdata_q6;
      wdata_q6 <= #0.1 wdata_q7;
    end
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wsize_d <= #0.1 2'b00;
  else begin
    if (pop_wdq)
      wsize_d <= #0.1 wdata_q0[13:12];
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wsize_d1 <= #0.1 2'b00;
  else begin
    if (wmem_rd)
      wsize_d1 <= #0.1 wsize_d;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wadr_sel <= #0.1 3'h0;
  else begin
    if (pop_wdq)
      wadr_sel <= #0.1 wdata_q0[16:14];
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wdq1_vld <= #0.1 8'h0;
  else begin
    case ({(axim_awvalid&axim_awready), axim_bvalid})
      2'b01  : wdq1_vld <= #0.1 {1'b0, wdq1_vld[7:1]};
      2'b10  : wdq1_vld <= #0.1 {wdq1_vld[6:0], 1'b1};
      default:; // No change
    endcase
  end
end
//******************************************************************************
assign wmem_empty  = (wmem_dcnt0[6:0]==6'h0);
assign wmem_full   = (wsram_wptr[6]^wsram_rptr[6]) & (wsram_wptr[5:0]==wsram_rptr[5:0]);
assign wsram_empty = (wsram_wptr[6:0]==wsram_rptr[6:0]);
assign cpu_wrdy    = ~wmem_full & ~(wcmd_vld[3]&~pop_wcmd);
assign wmem_wr     = cpu_wvld&cpu_wrdy;
assign wmem_rd     = ~(|wr_dcnt0[2:0]) & (~wmem_empty|trans_abort)
                   & wrd_rd_en & ~(axim_wvalid&~axim_wready);
assign wsram_wr = wmem_wr & (|wmem_dcnt0[6:2]) & ~((wmem_dcnt0[6:0]==7'h4)&wmem_rd) & ~wmem_full;
assign wsram_rd = wmem_rd & ~wsram_empty;

assign wpre_wr0 = wmem_wr & (wmem_dcnt0[6:0]==6'h0);
assign wpre_wr1 = wmem_wr & (wmem_dcnt0[6:0]==6'h1);
assign wpre_wr2 = wmem_wr & (wmem_dcnt0[6:0]==6'h2);
assign wpre_wr3 = wmem_wr & (wmem_dcnt0[6:0]==6'h3);
assign wpre_wr4 = wmem_wr & (wmem_dcnt0[6:0]==6'h4);

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wr_dcnt0 <= #0.1 4'h0;
  else begin
    if (wr_abort&wabort_done)
      wr_dcnt0 <= #0.1 4'h0;
    else if (wmem_rd) begin
      case (wsize_d)
        2'b00  : wr_dcnt0 <= #0.1 4'h7;
        2'b01  : wr_dcnt0 <= #0.1 4'h3;
        2'b10  : wr_dcnt0 <= #0.1 4'h1;
        default: wr_dcnt0 <= #0.1 4'h0;
      endcase
    end else if (axim_wvalid&axim_wready&axim_wlast)
      wr_dcnt0 <= #0.1 4'h0;
    else if (axim_wvalid&axim_wready&(wr_dcnt0[2:0]!=3'h0))
      wr_dcnt0 <= #0.1 wr_dcnt0[2:0] - 1'b1;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wmem_dcnt0 <= #0.1 8'h0;
  else begin
    if (sft_rst|trans_abort)
      wmem_dcnt0 <= #0.1 8'h0;
    else begin
      case ({wmem_wr, wmem_rd})
        2'b01  : wmem_dcnt0 <= #0.1 wmem_dcnt0[6:0] - 1'b1;
        2'b10  : wmem_dcnt0 <= #0.1 wmem_dcnt0[6:0] + 1'b1;
        default:;   //
      endcase
    end
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wsram_wptr <= #0.1 8'h0;
  else begin
    if (sft_rst|trans_abort)
      wsram_wptr <= #0.1 8'h0;
    else if (wsram_wr)
      wsram_wptr <= #0.1 wsram_wptr[6:0] + 1'b1;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wsram_rptr <= #0.1 8'h0;
  else begin
    if (sft_rst|trans_abort)
      wsram_rptr <= #0.1 8'h0;
    else if (wsram_rd)
      wsram_rptr <= #0.1 wsram_rptr[6:0] + 1'b1;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn) begin
    wmem_dcnt1  <= #0.1 3'h0;
    wmem_dcnt12 <= #0.1 3'h0;
    wmem_dcnt11 <= #0.1 3'h0;
  end else begin
    if (sft_rst|trans_abort) begin
      wmem_dcnt1  <= #0.1 3'h0;
      wmem_dcnt12 <= #0.1 3'h0;
      wmem_dcnt11 <= #0.1 3'h0;
    end else if (wmem_rd&~wmem_rd_d[2]) begin
      if (wmem_dcnt12[1:0]!=2'h0)
        wmem_dcnt1 <= #0.1 wmem_dcnt12[1:0] - 1'b1;

      if (wmem_dcnt11[1:0]!=2'h0)
        wmem_dcnt12 <= #0.1 wmem_dcnt11[1:0] - 1'b1;

      if (wmem_dcnt10[1:0]!=2'h0)
        wmem_dcnt11 <= #0.1 wmem_dcnt10[1:0] - 1'b1;
    end else if (wmem_rd_d[2]&~wmem_rd) begin
      wmem_dcnt1  <= #0.1 wmem_dcnt12[1:0] + 1'b1;
      wmem_dcnt12 <= #0.1 wmem_dcnt11[1:0] + 1'b1;
      wmem_dcnt11 <= #0.1 wmem_dcnt10[1:0] + 1'b1;
    end else begin
      wmem_dcnt1  <= #0.1 {1'b0, wmem_dcnt12[1:0]};
      wmem_dcnt12 <= #0.1 {1'b0, wmem_dcnt11[1:0]};
      wmem_dcnt11 <= #0.1 {1'b0, wmem_dcnt10[1:0]};
    end
  end
end

assign wpre_wr = wpre_wr1|wpre_wr2|wpre_wr3|(wpre_wr4&wmem_rd);
always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wmem_dcnt10 <= #0.1 3'h0;
  else begin
    if (sft_rst|trans_abort)
      wmem_dcnt10 <= #0.1 3'h0;
    else begin
      case ({wmem_rd_d[2], wpre_wr, wmem_rd})
        3'b001: if (wmem_dcnt10[1:0]!=2'h0) wmem_dcnt10 <= #0.1 wmem_dcnt10[1:0] - 1'b1;
        3'b010: if (wmem_dcnt10[1:0]!=2'h3) wmem_dcnt10 <= #0.1 wmem_dcnt10[1:0] + 1'b1;
        3'b100: if (wmem_dcnt10[1:0]!=2'h3) wmem_dcnt10 <= #0.1 wmem_dcnt10[1:0] + 1'b1;
        3'b110: if (wmem_dcnt10[1:0]!=2'h3) wmem_dcnt10 <= #0.1 wmem_dcnt10[1:0] + 2'h2;
        3'b111: if (wmem_dcnt10[1:0]!=2'h3) wmem_dcnt10 <= #0.1 wmem_dcnt10[1:0] + 1'b1;
        default:; // no change
      endcase
    end
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wdata_tmp0 <= #0.1 72'h0;
  else begin
    if (wpre_wr0|(wpre_wr1&wmem_rd))
      wdata_tmp0 <= #0.1 cpu_wdata;
    else if (wmem_rd_d[2] & wmem_rd & (wmem_dcnt1[1:0]==2'h0))
      wdata_tmp0 <= #0.1 wmem_rdata;
    else if (wmem_rd)
      wdata_tmp0 <= #0.1 wdata_tmp1;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wdata_tmp1 <= #0.1 72'h0;
  else begin
    if (wpre_wr1|(wpre_wr2&wmem_rd))
      wdata_tmp1 <= #0.1 cpu_wdata;
    else if (wmem_rd_d[2] & ((wmem_rd&(wmem_dcnt1[1:0]==2'h1))|(~wmem_rd&(wmem_dcnt1[1:0]==2'h0))))
      wdata_tmp1 <= #0.1 wmem_rdata;
    else if (wmem_rd)
      wdata_tmp1 <= #0.1 wdata_tmp2;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wdata_tmp2 <= #0.1 72'h0;
  else begin
    if (wpre_wr2|(wpre_wr3&wmem_rd))
      wdata_tmp2 <= #0.1 cpu_wdata;
    else if (wmem_rd_d[2] & ((wmem_rd&(wmem_dcnt1[1:0]==2'h2))|(~wmem_rd&(wmem_dcnt1[1:0]==2'h1))))
      wdata_tmp2 <= #0.1 wmem_rdata;
    else if (wmem_rd)
      wdata_tmp2 <= #0.1 wdata_tmp3;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wdata_tmp3 <= #0.1 72'h0;
  else begin
    if (wpre_wr3|(wpre_wr4&wmem_rd))
      wdata_tmp3 <= #0.1 cpu_wdata;
    else if (wmem_rd_d[2] & ((wmem_rd&(wmem_dcnt1[1:0]==2'h3))|(~wmem_rd&(wmem_dcnt1[1:0]==2'h2))))
      wdata_tmp3 <= #0.1 wmem_rdata;
  end
end
//******************************************************************************
assign push_rdq  = axim_rvalid & axim_rready & axim_rlast & ~(trans_abort|sft_rst);
assign pop_rdq   = rdq_vld[0] & ~(cpu_tx_req&~tx_cpu_ack) & ~wrq_vld[0];
assign rdq_info  = {axim_rresp, axim_rid, rdata_len};
assign cpu_tdata = rmem_rdata;
assign cpu_clast = pop_txdq;

assign rmem_wr  = (axim_rvalid&axim_rready&(axim_rlast|rmem_wr0|rmem_wr1|rmem_wr2|rmem_wr3|rmem_wr4|rmem_wr5|rmem_wr6|rmem_wr7));
assign rmem_wr0 = (axim_rid==rd_tqbuf0[7:0]) & ((rd_tqbuf0[9:8]==2'b11)
                | ((rd_tqbuf0[9:8]==2'b10)&rdata_cnt0[2])
                | ((rd_tqbuf0[9:8]==2'b01)&(rdata_cnt0[2:1]==2'b11))
                | ((rd_tqbuf0[9:8]==2'b00)&(rdata_cnt0[2:0]==3'b111)) );
assign rmem_wr1 = (axim_rid==rd_tqbuf1[7:0]) & (rd_tqbuf1[7:0]!=rd_tqbuf0[7:0]) & ((rd_tqbuf1[9:8]==2'b11)
                | ((rd_tqbuf1[9:8]==2'b10)&rdata_cnt1[2])
                | ((rd_tqbuf1[9:8]==2'b01)&(rdata_cnt1[2:1]==2'b11))
                | ((rd_tqbuf1[9:8]==2'b00)&(rdata_cnt1[2:0]==3'b111)) );
assign rmem_wr2 = (axim_rid==rd_tqbuf2[7:0]) & (rd_tqbuf2[7:0]!=rd_tqbuf1[7:0]) & (rd_tqbuf2[7:0]!=rd_tqbuf0[7:0])
                & ((rd_tqbuf2[9:8]==2'b11)
                | ((rd_tqbuf2[9:8]==2'b10)&rdata_cnt2[2])
                | ((rd_tqbuf2[9:8]==2'b01)&(rdata_cnt2[2:1]==2'b11))
                | ((rd_tqbuf2[9:8]==2'b00)&(rdata_cnt2[2:0]==3'b111)) );
assign rmem_wr3 = (axim_rid==rd_tqbuf3[7:0]) & (rd_tqbuf3[7:0]!=rd_tqbuf2[7:0]) & (rd_tqbuf3[7:0]!=rd_tqbuf1[7:0])
                & (rd_tqbuf3[7:0]!=rd_tqbuf0[7:0]) & ((rd_tqbuf3[9:8]==2'b11)
                | ((rd_tqbuf3[9:8]==2'b10)&rdata_cnt3[2])
                | ((rd_tqbuf3[9:8]==2'b01)&(rdata_cnt3[2:1]==2'b11))
                | ((rd_tqbuf3[9:8]==2'b00)&(rdata_cnt3[2:0]==3'b111)) );
assign rmem_wr4 = (axim_rid==rd_tqbuf4[7:0]) & (rd_tqbuf4[7:0]!=rd_tqbuf3[7:0]) & (rd_tqbuf4[7:0]!=rd_tqbuf2[7:0])
                & (rd_tqbuf4[7:0]!=rd_tqbuf1[7:0]) & (rd_tqbuf4[7:0]!=rd_tqbuf0[7:0]) & ((rd_tqbuf4[9:8]==2'b11)
                | ((rd_tqbuf4[9:8]==2'b10)&rdata_cnt4[2])
                | ((rd_tqbuf4[9:8]==2'b01)&(rdata_cnt4[2:1]==2'b11))
                | ((rd_tqbuf4[9:8]==2'b00)&(rdata_cnt4[2:0]==3'b111)) );
assign rmem_wr5 = (axim_rid==rd_tqbuf5[7:0]) & (rd_tqbuf5[7:0]!=rd_tqbuf3[7:0]) & (rd_tqbuf5[7:0]!=rd_tqbuf2[7:0])
                & (rd_tqbuf5[7:0]!=rd_tqbuf1[7:0]) & (rd_tqbuf5[7:0]!=rd_tqbuf0[7:0]) & (rd_tqbuf5[7:0]!=rd_tqbuf4[7:0])
                & ((rd_tqbuf5[9:8]==2'b11)
                | ((rd_tqbuf5[9:8]==2'b10)&rdata_cnt5[2])
                | ((rd_tqbuf5[9:8]==2'b01)&(rdata_cnt5[2:1]==2'b11))
                | ((rd_tqbuf5[9:8]==2'b00)&(rdata_cnt5[2:0]==3'b111)) );
assign rmem_wr6 = (axim_rid==rd_tqbuf6[7:0]) & (rd_tqbuf6[7:0]!=rd_tqbuf3[7:0]) & (rd_tqbuf6[7:0]!=rd_tqbuf2[7:0])
                & (rd_tqbuf6[7:0]!=rd_tqbuf1[7:0]) & (rd_tqbuf6[7:0]!=rd_tqbuf0[7:0]) & (rd_tqbuf6[7:0]!=rd_tqbuf4[7:0])
                & (rd_tqbuf6[7:0]!=rd_tqbuf5[7:0]) & ((rd_tqbuf6[9:8]==2'b11)
                | ((rd_tqbuf6[9:8]==2'b10)&rdata_cnt6[2])
                | ((rd_tqbuf6[9:8]==2'b01)&(rdata_cnt6[2:1]==2'b11))
                | ((rd_tqbuf6[9:8]==2'b00)&(rdata_cnt6[2:0]==3'b111)) );
assign rmem_wr7 = (axim_rid==rd_tqbuf7[7:0]) & (rd_tqbuf7[7:0]!=rd_tqbuf3[7:0]) & (rd_tqbuf7[7:0]!=rd_tqbuf2[7:0])
                & (rd_tqbuf7[7:0]!=rd_tqbuf1[7:0]) & (rd_tqbuf7[7:0]!=rd_tqbuf0[7:0]) & (rd_tqbuf7[7:0]!=rd_tqbuf4[7:0])
                & (rd_tqbuf7[7:0]!=rd_tqbuf5[7:0]) & (rd_tqbuf7[7:0]!=rd_tqbuf6[7:0]) & ((rd_tqbuf7[9:8]==2'b11)
                | ((rd_tqbuf7[9:8]==2'b10)&rdata_cnt7[2])
                | ((rd_tqbuf7[9:8]==2'b01)&(rdata_cnt7[2:1]==2'b11))
                | ((rd_tqbuf7[9:8]==2'b00)&(rdata_cnt7[2:0]==3'b111)) );

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rmem_wsel <= #0.1 8'h0;
  else begin
    if (axim_rvalid&axim_rready) begin
      if ((axim_rlast&(axim_rid==rd_tqbuf0[7:0])) | rmem_wr0)
        rmem_wsel <= #0.1 8'b0000_0001;
      else if ((axim_rlast&(axim_rid==rd_tqbuf1[7:0])) | rmem_wr1)
        rmem_wsel <= #0.1 8'b0000_0010;
      else if ((axim_rlast&(axim_rid==rd_tqbuf2[7:0])) | rmem_wr2)
        rmem_wsel <= #0.1 8'b0000_0100;
      else if ((axim_rlast&(axim_rid==rd_tqbuf3[7:0])) | rmem_wr3)
        rmem_wsel <= #0.1 8'b0000_1000;
      else if ((axim_rlast&(axim_rid==rd_tqbuf4[7:0])) | rmem_wr4)
        rmem_wsel <= #0.1 8'b0001_0000;
      else if ((axim_rlast&(axim_rid==rd_tqbuf5[7:0])) | rmem_wr5)
        rmem_wsel <= #0.1 8'b0010_0000;
      else if ((axim_rlast&(axim_rid==rd_tqbuf6[7:0])) | rmem_wr6)
        rmem_wsel <= #0.1 8'b0100_0000;
      else if ((axim_rlast&(axim_rid==rd_tqbuf7[7:0])) | rmem_wr7)
        rmem_wsel <= #0.1 8'b1000_0000;
      else
        rmem_wsel <= #0.1 4'b0000;
    end
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rdata_sel <= #0.1 8'h0;
  else begin
    if (axim_rvalid&axim_rready) begin
      if (axim_rlast&(axim_rid==rd_tqbuf0[7:0])&rd_tqvld[0])
        rdata_sel <= #0.1 8'b0000_0001;
      else if (axim_rlast&(axim_rid==rd_tqbuf1[7:0])&rd_tqvld[1])
        rdata_sel <= #0.1 8'b0000_0010;
      else if (axim_rlast&(axim_rid==rd_tqbuf2[7:0])&rd_tqvld[2])
        rdata_sel <= #0.1 8'b0000_0100;
      else if (axim_rlast&(axim_rid==rd_tqbuf3[7:0])&rd_tqvld[3])
        rdata_sel <= #0.1 8'b0000_1000;
      else if (axim_rlast&(axim_rid==rd_tqbuf4[7:0])&rd_tqvld[4])
        rdata_sel <= #0.1 8'b0001_0000;
      else if (axim_rlast&(axim_rid==rd_tqbuf5[7:0])&rd_tqvld[5])
        rdata_sel <= #0.1 8'b0010_0000;
      else if (axim_rlast&(axim_rid==rd_tqbuf6[7:0])&rd_tqvld[6])
        rdata_sel <= #0.1 8'b0100_0000;
      else if (axim_rlast&(axim_rid==rd_tqbuf7[7:0])&rd_tqvld[7])
        rdata_sel <= #0.1 8'b1000_0000;
      else
        rdata_sel <= #0.1 8'b0000_0000;
    end else
      rdata_sel <= #0.1 8'b0000_0000;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rdq_vld <= #0.1 8'h0;
  else begin
    if (sft_rst)
      rdq_vld <= #0.1 8'h0;
    else begin
      case ({push_rdq, pop_rdq})
        2'b01: rdq_vld <= #0.1 {1'b0, rdq_vld[7:1]};
        2'b10: rdq_vld <= #0.1 {rdq_vld[6:0], 1'b1};
        default:; // no change
      endcase
    end
  end
end

always @ (*) begin
  if (axim_rid==rd_tqbuf0[7:0]) begin
    case (rd_tqbuf0[9:8])
      2'b00  : rdata_len = {rd_tqbuf0[15:13], rdata_cnt0[6:0]};
      2'b01  : rdata_len = {rd_tqbuf0[15:13], rdata_cnt0[6:1], 1'b1};
      2'b10  : rdata_len = {rd_tqbuf0[15:13], rdata_cnt0[6:2], 2'b11};
      default: rdata_len = {rd_tqbuf0[15:13], rdata_cnt0[6:3], 3'b111};
    endcase
  end else if (axim_rid==rd_tqbuf1[7:0]) begin
    case (rd_tqbuf1[9:8])
      2'b00  : rdata_len = {rd_tqbuf1[15:13], rdata_cnt1[6:0]};
      2'b01  : rdata_len = {rd_tqbuf1[15:13], rdata_cnt1[6:1], 1'b1};
      2'b10  : rdata_len = {rd_tqbuf1[15:13], rdata_cnt1[6:2], 2'b11};
      default: rdata_len = {rd_tqbuf1[15:13], rdata_cnt1[6:3], 3'b111};
    endcase
  end else if (axim_rid==rd_tqbuf2[7:0]) begin
    case (rd_tqbuf2[9:8])
      2'b00  : rdata_len = {rd_tqbuf2[15:13], rdata_cnt2[6:0]};
      2'b01  : rdata_len = {rd_tqbuf2[15:13], rdata_cnt2[6:1], 1'b1};
      2'b10  : rdata_len = {rd_tqbuf2[15:13], rdata_cnt2[6:2], 2'b11};
      default: rdata_len = {rd_tqbuf2[15:13], rdata_cnt2[6:3], 3'b111};
    endcase
  end else if (axim_rid==rd_tqbuf3[7:0]) begin
    case (rd_tqbuf3[9:8])
      2'b00  : rdata_len = {rd_tqbuf3[15:13], rdata_cnt3[6:0]};
      2'b01  : rdata_len = {rd_tqbuf3[15:13], rdata_cnt3[6:1], 1'b1};
      2'b10  : rdata_len = {rd_tqbuf3[15:13], rdata_cnt3[6:2], 2'b11};
      default: rdata_len = {rd_tqbuf3[15:13], rdata_cnt3[6:3], 3'b111};
    endcase
  end else if (axim_rid==rd_tqbuf4[7:0]) begin
    case (rd_tqbuf4[9:8])
      2'b00  : rdata_len = {rd_tqbuf4[15:13], rdata_cnt4[6:0]};
      2'b01  : rdata_len = {rd_tqbuf4[15:13], rdata_cnt4[6:1], 1'b1};
      2'b10  : rdata_len = {rd_tqbuf4[15:13], rdata_cnt4[6:2], 2'b11};
      default: rdata_len = {rd_tqbuf4[15:13], rdata_cnt4[6:3], 3'b111};
    endcase
  end else if (axim_rid==rd_tqbuf5[7:0]) begin
    case (rd_tqbuf5[9:8])
      2'b00  : rdata_len = {rd_tqbuf5[15:13], rdata_cnt5[6:0]};
      2'b01  : rdata_len = {rd_tqbuf5[15:13], rdata_cnt5[6:1], 1'b1};
      2'b10  : rdata_len = {rd_tqbuf5[15:13], rdata_cnt5[6:2], 2'b11};
      default: rdata_len = {rd_tqbuf5[15:13], rdata_cnt5[6:3], 3'b111};
    endcase
  end else if (axim_rid==rd_tqbuf6[7:0]) begin
    case (rd_tqbuf6[9:8])
      2'b00  : rdata_len = {rd_tqbuf6[15:13], rdata_cnt6[6:0]};
      2'b01  : rdata_len = {rd_tqbuf6[15:13], rdata_cnt6[6:1], 1'b1};
      2'b10  : rdata_len = {rd_tqbuf6[15:13], rdata_cnt6[6:2], 2'b11};
      default: rdata_len = {rd_tqbuf6[15:13], rdata_cnt6[6:3], 3'b111};
    endcase
  end else begin
    case (rd_tqbuf7[9:8])
      2'b00  : rdata_len = {rd_tqbuf7[15:13], rdata_cnt7[6:0]};
      2'b01  : rdata_len = {rd_tqbuf7[15:13], rdata_cnt7[6:1], 1'b1};
      2'b10  : rdata_len = {rd_tqbuf7[15:13], rdata_cnt7[6:2], 2'b11};
      default: rdata_len = {rd_tqbuf7[15:13], rdata_cnt7[6:3], 3'b111};
    endcase
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn) begin
    rdata_q0 <= #0.1 20'h0;
    rdata_q1 <= #0.1 20'h0;
    rdata_q2 <= #0.1 20'h0;
    rdata_q3 <= #0.1 20'h0;
    rdata_q4 <= #0.1 20'h0;
    rdata_q5 <= #0.1 20'h0;
    rdata_q6 <= #0.1 20'h0;
    rdata_q7 <= #0.1 20'h0;
  end else begin
    if (push_rdq) begin
      casez (rdq_vld)
        8'b0000_0000: rdata_q0 <= #0.1 rdq_info;
        8'b0000_0001: begin
          if (pop_rdq)
            rdata_q0 <= #0.1 rdq_info;
          else
            rdata_q1 <= #0.1 rdq_info;
        end
        8'b0000_001?: begin
          if (pop_rdq) begin
            rdata_q0 <= #0.1 rdata_q1;
            rdata_q1 <= #0.1 rdq_info;
          end else
            rdata_q2 <= #0.1 rdq_info;
        end
        8'b0000_01??: begin
          if (pop_rdq) begin
            rdata_q0 <= #0.1 rdata_q1;
            rdata_q1 <= #0.1 rdata_q2;
            rdata_q2 <= #0.1 rdq_info;
          end else
            rdata_q3 <= #0.1 rdq_info;
        end
        8'b0000_1???: begin
          if (pop_rdq) begin
            rdata_q0 <= #0.1 rdata_q1;
            rdata_q1 <= #0.1 rdata_q2;
            rdata_q2 <= #0.1 rdata_q3;
            rdata_q3 <= #0.1 rdq_info;
          end else
            rdata_q4 <= #0.1 rdq_info;
        end
        8'b0001_????: begin
          if (pop_rdq) begin
            rdata_q0 <= #0.1 rdata_q1;
            rdata_q1 <= #0.1 rdata_q2;
            rdata_q2 <= #0.1 rdata_q3;
            rdata_q3 <= #0.1 rdata_q4;
            rdata_q4 <= #0.1 rdq_info;
          end else
            rdata_q5 <= #0.1 rdq_info;
        end
        8'b001?_????: begin
          if (pop_rdq) begin
            rdata_q0 <= #0.1 rdata_q1;
            rdata_q1 <= #0.1 rdata_q2;
            rdata_q2 <= #0.1 rdata_q3;
            rdata_q3 <= #0.1 rdata_q4;
            rdata_q4 <= #0.1 rdata_q5;
            rdata_q5 <= #0.1 rdq_info;
          end else
            rdata_q6 <= #0.1 rdq_info;
        end
        8'b01??_????: begin
          if (pop_rdq) begin
            rdata_q0 <= #0.1 rdata_q1;
            rdata_q1 <= #0.1 rdata_q2;
            rdata_q2 <= #0.1 rdata_q3;
            rdata_q3 <= #0.1 rdata_q4;
            rdata_q4 <= #0.1 rdata_q5;
            rdata_q5 <= #0.1 rdata_q6;
            rdata_q6 <= #0.1 rdq_info;
          end else
            rdata_q7 <= #0.1 rdq_info;
        end
        8'b1???_????: begin
          if (pop_rdq) begin
            rdata_q0 <= #0.1 rdata_q1;
            rdata_q1 <= #0.1 rdata_q2;
            rdata_q2 <= #0.1 rdata_q3;
            rdata_q3 <= #0.1 rdata_q4;
            rdata_q4 <= #0.1 rdata_q5;
            rdata_q5 <= #0.1 rdata_q6;
            rdata_q6 <= #0.1 rdata_q7;
            rdata_q7 <= #0.1 rdq_info;
          end// else
            //rdata_q7 <= `DLY rdq_info;
        end
        default:;   // No change
      endcase
    end else if (pop_rdq) begin
      rdata_q0 <= #0.1 rdata_q1;
      rdata_q1 <= #0.1 rdata_q2;
      rdata_q2 <= #0.1 rdata_q3;
      rdata_q3 <= #0.1 rdata_q4;
      rdata_q4 <= #0.1 rdata_q5;
      rdata_q5 <= #0.1 rdata_q6;
      rdata_q6 <= #0.1 rdata_q7;
    end
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    cpu_tx_req <= #0.1 1'b0;
  else begin
    if ((pop_rdq|pop_wrq)&~(trans_abort|sft_rst))
      cpu_tx_req <= #0.1 1'b1;
    else if (tx_cpu_ack|sft_rst)
      cpu_tx_req <= #0.1 1'b0;
  end
end

assign tx_dlen = rdata_q0[6:0] + 3'h4;  // 3 for packet command, 1 for length information
always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    cpu_tx_info <= #0.1 18'h0;
  else begin
    if (pop_wrq)
      cpu_tx_info <= #0.1 {1'b1, 8'h0, wrq_buf0};
    else if (pop_rdq)
      cpu_tx_info <= #0.1 {1'b0, rdata_q0[19:10], tx_dlen};
  end
end

assign pop_txdq = ~tx_cpu_ren & (txdq_buf[6:3]==4'h0) & txdq_vld[0];
always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    txdq_vld <= #0.1 3'h0;
  else begin
    if (sft_ack0)
      txdq_vld <= #0.1 3'h0;
    else begin
      case ({pop_rdq, pop_txdq})
        2'b01  : txdq_vld <= #0.1 {1'b0, txdq_vld[2:1]};
        2'b10  : txdq_vld <= #0.1 {txdq_vld[1:0], 1'b1};
        default:; //
      endcase
    end
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    {temp0, txdq_buf} <= #0.1 31'h0;
  else begin
    if (pop_rdq) begin
      casez (txdq_vld)
        3'b000: txdq_buf[9:0] <= #0.1 rdata_q0[9:0];
        3'b001: begin
          if (pop_txdq)
            txdq_buf[9:0] <= #0.1 rdata_q0[9:0];
          else if (~tx_cpu_ren) begin
            {temp0, txdq_buf[6:3]} <= #0.1 txdq_buf[6:3] - 1'b1;
            txdq_buf[19:10] <= #0.1 rdata_q0[9:0];
          end else
            txdq_buf[19:10] <= #0.1 rdata_q0[9:0];
        end
        3'b01?: begin
          if (pop_txdq)
            txdq_buf[19:0] <= #0.1 {rdata_q0[9:0], txdq_buf[19:10]};
          else if (~tx_cpu_ren) begin
            {temp0, txdq_buf[6:3]} <= #0.1 txdq_buf[6:3] - 1'b1;
            txdq_buf[29:20] <= #0.1 rdata_q0[9:0];
          end else
            txdq_buf[29:20] <= #0.1 rdata_q0[9:0];
        end
        3'b1??: begin
          if (pop_txdq)
            txdq_buf <= #0.1 {rdata_q0[9:0], txdq_buf[29:10]};
        end
        default:;   //
      endcase
    end else if (pop_txdq)
      txdq_buf[19:0] <= #0.1 txdq_buf[29:10];
    else if (~tx_cpu_ren) begin
      {temp0, txdq_buf[6:3]} <= #0.1 txdq_buf[6:3] - 1'b1;
    end
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    tx_dlast <= #0.1 4'h0;
  else begin
    if (pop_txdq)
      tx_dlast <= #0.1 {1'b1, txdq_buf[2:0]};
    else
      tx_dlast[3] <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    cpu_tlast <= #0.1 4'h0;
  else begin
    cpu_tlast <= #0.1 tx_dlast;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    load_adr <= #0.1 1'b0;
  else begin
    if (pop_rdq & (~txdq_vld[0]|pop_txdq))
      load_adr <= #0.1 1'b1;
    else
      load_adr <= #0.1 1'b0;
  end
end
//******************************************************************************
assign axim_bready = 1'b1;
//assign axim_rready = 1'b1;
assign wabort_done = ~wdq1_vld[0] & ~wrq_vld[0] & ~axim_awvalid;
assign axim_wdata  = (wdata_buf0[63:0] & wdata_vld1[63:0]);
assign axim_wstrb  = wr_abort_r ? 8'h0 : (wdata_buf0[71:64] & wdata_vld[7:0]);

assign wdata_vld1[7:0]   = {8{wdata_vld[0]}};
assign wdata_vld1[15:8]  = {8{wdata_vld[1]}};
assign wdata_vld1[23:16] = {8{wdata_vld[2]}};
assign wdata_vld1[31:24] = {8{wdata_vld[3]}};
assign wdata_vld1[39:32] = {8{wdata_vld[4]}};
assign wdata_vld1[47:40] = {8{wdata_vld[5]}};
assign wdata_vld1[55:48] = {8{wdata_vld[6]}};
assign wdata_vld1[63:56] = {8{wdata_vld[7]}};

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wr_abort <= #0.1 1'b0;
  else begin
    if (sft_rst)
      wr_abort <= #0.1 1'b1;
    else if (wabort_done)
      wr_abort <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wr_abort_r <= #0.1 1'b0;
  else begin
    if (wabort_done)
      wr_abort_r <= #0.1 1'b0;
    else if ((sft_rst|wr_abort)&(~axim_wvalid|(axim_wvalid&axim_wready)))
      wr_abort_r <= #0.1 1'b1;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wrd_rd_en <= #0.1 1'b0;
  else begin
    if (pop_wdq)
      wrd_rd_en <= #0.1 1'b1;
    else if (wmem_rd&(wrd_len[3:0]==4'h1))
      wrd_rd_en <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    axim_arvalid <= #0.1 1'b0;
  else begin
    if (pop_rcmd)
      axim_arvalid <= #0.1 1'b1;
    else if (axim_arready)
      axim_arvalid <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn) begin
    axim_arid    <= #0.1 6'h0;
    axim_araddr  <= #0.1 32'h0;
    axim_arlen   <= #0.1 4'h0;
    axim_arsize  <= #0.1 3'h0;
    axim_arburst <= #0.1 2'h0;
    axim_arlock  <= #0.1 2'h0;
    axim_arcache <= #0.1 4'h0;
    axim_arprot  <= #0.1 3'h0;
  end else begin
    if (pop_rcmd) begin
      axim_arid    <= #0.1 rcmd_q0[39:32];
      axim_arburst <= #0.1 rcmd_q0[49:48];// ? 2'b10 : 2'b01;
      axim_arlock  <= #0.1 rcmd_q0[51:50];
      axim_arcache <= #0.1 rcmd_q0[43:40];
      axim_arprot  <= #0.1 rcmd_q0[54:52];

      if (adr_remap) begin
        if (rcmd_q0[31:12]==20'hFFFF0)
          axim_araddr[31:4] <= #0.1 {boot_addr[31:12], rcmd_q0[11:4]};
        //else if (rcmd_q0[31:20]==12'h9E0)
        //  axim_araddr[31:4] <= `DLY {12'h9E8, rcmd_q0[19:4]};
        else
          axim_araddr[31:4] <= #0.1 rcmd_q0[31:4];
      end else
        axim_araddr[31:4] <= #0.1 rcmd_q0[31:4];

      if (rcmd_q0[57:55]==3'b100)
        axim_araddr[3:0] <= #0.1 {1'b0, rcmd_q0[2:0]};
      else
        axim_araddr[3:0] <= #0.1 rcmd_q0[3:0];

      if (rcmd_q0[57:55]==3'b100)
        axim_arlen <= #0.1 {rcmd_q0[46:44], 1'b1};
      else
        axim_arlen <= #0.1 rcmd_q0[47:44];

      if (rcmd_q0[57:55]==3'b100)
        axim_arsize <= #0.1 3'b011;
      else
        axim_arsize <= #0.1 rcmd_q0[57:55];
    end
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    axim_awvalid <= #0.1 1'b0;
  else begin
    if (pop_wcmd)
      axim_awvalid <= #0.1 1'b1;
    else if (axim_awready)
      axim_awvalid <= #0.1 1'b0;
  end
end

always @ (*) begin
  if (wcmd_q0[57:55]==3'b100)
    wlen_n = {wcmd_q0[46:44], 1'b1};
  else
    wlen_n = wcmd_q0[47:44];
end

always @ (*) begin
  if (wcmd_q0[57:55]==3'b100)
    wsize_n = 2'b11;
  else
    wsize_n = wcmd_q0[56:55];
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn) begin
    axim_awid    <= #0.1 6'h0;
    axim_awaddr  <= #0.1 32'h0;
    axim_awlen   <= #0.1 4'h0;
    axim_awsize  <= #0.1 3'h0;
    axim_awburst <= #0.1 2'h0;
    axim_awlock  <= #0.1 2'h0;
    axim_awcache <= #0.1 4'h0;
    axim_awprot  <= #0.1 3'h0;
  end else begin
    if (pop_wcmd) begin
      axim_awid    <= #0.1 wcmd_q0[39:32];
      axim_awburst <= #0.1 wcmd_q0[49:48];// ? 2'b10 : 2'b01;
      axim_awlock  <= #0.1 wcmd_q0[51:50];
      axim_awcache <= #0.1 wcmd_q0[43:40];
      axim_awprot  <= #0.1 wcmd_q0[54:52];
      axim_awlen   <= #0.1 wlen_n;
      axim_awsize  <= #0.1 {1'b0, wsize_n};

      if (adr_remap) begin
        //if (wcmd_q0[31:16]==16'hFFFF)
        //  axim_awaddr[31:4] <= `DLY {16'h9F00, wcmd_q0[15:4]};
        //else if (wcmd_q0[31:20]==12'h9E0)
        //  axim_awaddr[31:4] <= `DLY {12'h9E8, wcmd_q0[19:4]};
        //else
          axim_awaddr[31:4] <= #0.1 wcmd_q0[31:4];
      end else
        axim_awaddr[31:4] <= #0.1 wcmd_q0[31:4];
      if (wcmd_q0[57:55]==3'b100)
        axim_awaddr[3:0]  <= #0.1 {1'b0, wcmd_q0[2:0]};
      else
        axim_awaddr[3:0]  <= #0.1 wcmd_q0[3:0];
    end
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    axim_wvalid <= #0.1 1'b0;
  else begin
    if (wmem_rd)
      axim_wvalid <= #0.1 1'b1;
    else if (axim_wvalid&axim_wready&(axim_wlast|(wr_dcnt0[2:0]==3'h0)))
      axim_wvalid <= #0.1 1'b0;
  end
end

assign axim_wid = wid_queue[7:0];
assign wr_last  = axim_wvalid&axim_wready&axim_wlast;
always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wid_qvld <= #0.1 4'h0;
  else begin
    case ({pop_wdq, wr_last})
      2'b01  : wid_qvld <= #0.1 {1'b0, wid_qvld[3:1]};
      2'b10  : wid_qvld <= #0.1 {wid_qvld[2:0], 1'b1};
      default:;
    endcase
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wid_queue <= #0.1 32'h0;
  else begin
    if (pop_wdq) begin
      casez (wid_qvld)
        4'b0000: wid_queue[7:0] <= #0.1 wdata_q0[11:4];
        4'b0001: wid_queue <= #0.1 wr_last ? {wid_queue[31:8], wdata_q0[11:4]} : {wid_queue[31:16], wdata_q0[11:4], wid_queue[7:0]};
        4'b001?: wid_queue <= #0.1 wr_last ? {wid_queue[31:16], wdata_q0[11:4], wid_queue[15:8]} : {wid_queue[23:16], wdata_q0[11:4], wid_queue[15:0]};
        4'b01??: wid_queue <= #0.1 wr_last ? {wid_queue[31:24], wdata_q0[11:4], wid_queue[23:8]} : {wdata_q0[11:4], wid_queue[23:0]};
        4'b1???: wid_queue <= #0.1 wr_last ? {wdata_q0[11:4], wid_queue[23:0]} : wid_queue;
        default:;  // No change
      endcase
    end else if (wr_last)
      wid_queue <= #0.1 {8'h0, wid_queue[31:8]};
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wrd_len <= #0.1 5'h0;
  else begin
    if (pop_wdq) begin
      case (wdata_q0[13:12])
        2'b00  : wrd_len <= #0.1 wdata_q0[3] ? 5'h2 : 5'h1;
        2'b01  : wrd_len[3:0] <= #0.1 {2'h0, wdata_q0[3:2]} + 1'b1;
        2'b10  : wrd_len[3:0] <= #0.1 {1'b0, wdata_q0[3:1]} + 1'b1;
        default: wrd_len <= #0.1 wdata_q0[3:0] + 1'b1;
      endcase
    end else if (wmem_rd)
      wrd_len <= #0.1 wrd_len[3:0] - 1'b1;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wlen_cnt <= #0.1 5'h0;
  else begin
    if (pop_wdq)
      wlen_cnt <= #0.1 {1'b0, wdata_q0[3:0]};
    else if (axim_wvalid&axim_wready)
      wlen_cnt <= #0.1 wlen_cnt[3:0] - 1'b1;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    axim_wlast <= #0.1 1'b0;
  else begin
    if (pop_wdq)
      axim_wlast <= #0.1 (wdata_q0[3:0]==4'h0) ? 1'b1 : 1'b0;
    else if (axim_wvalid&axim_wready&(wlen_cnt[3:0]==4'h1))
      axim_wlast <= #0.1 1'b1;
    else if (axim_wvalid&axim_wready&(wlen_cnt[3:0]==4'h0))
      axim_wlast <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wdata_buf0 <= #0.1 72'h0;
  else begin
    if (wmem_rd) begin
      case (wsize_d)
        2'b00: begin
          case (wadr_sel[2:0])
            3'b111 : wdata_buf0 <= #0.1 {wdata_tmp0[64],    wdata_tmp0[71:65], wdata_tmp0[7:0],  wdata_tmp0[63:8]};
            3'b110 : wdata_buf0 <= #0.1 {wdata_tmp0[65:64], wdata_tmp0[71:66], wdata_tmp0[15:0], wdata_tmp0[63:16]};
            3'b101 : wdata_buf0 <= #0.1 {wdata_tmp0[66:64], wdata_tmp0[71:67], wdata_tmp0[23:0], wdata_tmp0[63:24]};
            3'b100 : wdata_buf0 <= #0.1 {wdata_tmp0[67:64], wdata_tmp0[71:68], wdata_tmp0[31:0], wdata_tmp0[63:32]};
            3'b011 : wdata_buf0 <= #0.1 {wdata_tmp0[68:64], wdata_tmp0[71:69], wdata_tmp0[39:0], wdata_tmp0[63:40]};
            3'b010 : wdata_buf0 <= #0.1 {wdata_tmp0[69:64], wdata_tmp0[71:70], wdata_tmp0[47:0], wdata_tmp0[63:48]};
            3'b001 : wdata_buf0 <= #0.1 {wdata_tmp0[70:64], wdata_tmp0[71],    wdata_tmp0[55:0], wdata_tmp0[63:56]};
            default: wdata_buf0 <= #0.1 wdata_tmp0;
          endcase
        end
        2'b01: begin
          case (wadr_sel[2:1])
            2'b11  : wdata_buf0 <= #0.1 {wdata_tmp0[65:64], wdata_tmp0[71:66], wdata_tmp0[15:0], wdata_tmp0[63:16]};
            2'b10  : wdata_buf0 <= #0.1 {wdata_tmp0[67:64], wdata_tmp0[71:68], wdata_tmp0[31:0], wdata_tmp0[63:32]};
            2'b01  : wdata_buf0 <= #0.1 {wdata_tmp0[69:64], wdata_tmp0[71:70], wdata_tmp0[47:0], wdata_tmp0[63:48]};
            default: wdata_buf0 <= #0.1 wdata_tmp0;
          endcase
        end
        2'b10: begin
          if (wadr_sel[2])
            wdata_buf0 <= #0.1 {wdata_tmp0[67:64], wdata_tmp0[71:68], wdata_tmp0[31:0], wdata_tmp0[63:32]};
          else
            wdata_buf0 <= #0.1 wdata_tmp0;
        end
        default: wdata_buf0 <= #0.1 wdata_tmp0;
      endcase
    end
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wdata_vld <= #0.1 8'h0;
  else begin
    if (wmem_rd) begin
      case (wsize_d)
        2'b00: begin
          case (wadr_sel[2:0])
            3'b111 : wdata_vld <= #0.1 {1'b1, 7'h0};
            3'b110 : wdata_vld <= #0.1 {1'b0, 1'b1, 6'h0};
            3'b101 : wdata_vld <= #0.1 {2'h0, 1'b1, 5'h0};
            3'b100 : wdata_vld <= #0.1 {3'h0, 1'b1, 4'h0};
            3'b011 : wdata_vld <= #0.1 {4'h0, 1'b1, 3'h0};
            3'b010 : wdata_vld <= #0.1 {5'h0, 1'b1, 2'h0};
            3'b001 : wdata_vld <= #0.1 {6'h0, 1'b1, 1'b0};
            default: wdata_vld <= #0.1 {7'h0, 1'b1};
          endcase
        end
        2'b01: begin
          case (wadr_sel[2:1])
            2'b11  : wdata_vld <= #0.1 {2'b11, 6'h0};
            2'b10  : wdata_vld <= #0.1 {2'b00, 2'b11, 4'h0};
            2'b01  : wdata_vld <= #0.1 {4'h0,  2'b11, 2'b00};
            default: wdata_vld <= #0.1 {6'h0,  2'b11};
          endcase
        end
        2'b10: begin
          if (wadr_sel[2])
            wdata_vld <= #0.1 {4'b1111, 4'h0};
          else
            wdata_vld <= #0.1 {4'h0, 4'b1111};
        end
        default: wdata_vld <= #0.1 8'b1111_1111;
      endcase
    end else if (axim_wvalid&axim_wready&~axim_wlast) begin
      case (wsize_d1)
        2'b00: wdata_vld <= #0.1 {wdata_vld[6:0], wdata_vld[7]};
        2'b01: wdata_vld <= #0.1 {wdata_vld[5:0], wdata_vld[7:6]};
        2'b10: wdata_vld <= #0.1 {wdata_vld[3:0], wdata_vld[7:4]};
        default:;   // no change
      endcase
    end
  end
end

assign push_wrq = axim_bvalid & axim_bready;
assign pop_wrq  = wrq_vld[0] & ~(cpu_tx_req&~tx_cpu_ack);
always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wrq_vld <= #0.1 8'h0;
  else begin
    case ({push_wrq, pop_wrq})
      2'b01  : wrq_vld <= #0.1 {1'b0, wrq_vld[7:1]};
      2'b10  : wrq_vld <= #0.1 {wrq_vld[6:0], 1'b1};
      default:; //
    endcase
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn) begin
    wrq_buf0 <= #0.1 10'h0;
    wrq_buf1 <= #0.1 10'h0;
    wrq_buf2 <= #0.1 10'h0;
    wrq_buf3 <= #0.1 10'h0;
    wrq_buf4 <= #0.1 10'h0;
    wrq_buf5 <= #0.1 10'h0;
    wrq_buf6 <= #0.1 10'h0;
    wrq_buf7 <= #0.1 10'h0;
  end else begin
    if (push_wrq) begin
      casez (wrq_vld)
        8'b0000_0000: wrq_buf0 <= #0.1 {axim_bresp, axim_bid};
        8'b0000_0001: begin
          if (pop_wrq)
            wrq_buf0 <= #0.1 {axim_bresp, axim_bid};
          else
            wrq_buf1 <= #0.1 {axim_bresp, axim_bid};
        end
        8'b0000_001?: begin
          if (pop_wrq) begin
            wrq_buf0 <= #0.1 wrq_buf1;
            wrq_buf1 <= #0.1 {axim_bresp, axim_bid};
          end else
            wrq_buf2 <= #0.1 {axim_bresp, axim_bid};
        end
        8'b0000_01??: begin
          if (pop_wrq) begin
            wrq_buf0 <= #0.1 wrq_buf1;
            wrq_buf1 <= #0.1 wrq_buf2;
            wrq_buf2 <= #0.1 {axim_bresp, axim_bid};
          end else
            wrq_buf3 <= #0.1 {axim_bresp, axim_bid};
        end
        8'b0000_1???: begin
          if (pop_wrq) begin
            wrq_buf0 <= #0.1 wrq_buf1;
            wrq_buf1 <= #0.1 wrq_buf2;
            wrq_buf2 <= #0.1 wrq_buf3;
            wrq_buf3 <= #0.1 {axim_bresp, axim_bid};
          end else
            wrq_buf4 <= #0.1 {axim_bresp, axim_bid};
        end
        8'b0001_????: begin
          if (pop_wrq) begin
            wrq_buf0 <= #0.1 wrq_buf1;
            wrq_buf1 <= #0.1 wrq_buf2;
            wrq_buf2 <= #0.1 wrq_buf3;
            wrq_buf3 <= #0.1 wrq_buf4;
            wrq_buf4 <= #0.1 {axim_bresp, axim_bid};
          end else
            wrq_buf5 <= #0.1 {axim_bresp, axim_bid};
        end
        8'b001?_????: begin
          if (pop_wrq) begin
            wrq_buf0 <= #0.1 wrq_buf1;
            wrq_buf1 <= #0.1 wrq_buf2;
            wrq_buf2 <= #0.1 wrq_buf3;
            wrq_buf3 <= #0.1 wrq_buf4;
            wrq_buf4 <= #0.1 wrq_buf5;
            wrq_buf5 <= #0.1 {axim_bresp, axim_bid};
          end else
            wrq_buf6 <= #0.1 {axim_bresp, axim_bid};
        end
        8'b01??_????: begin
          if (pop_wrq) begin
            wrq_buf0 <= #0.1 wrq_buf1;
            wrq_buf1 <= #0.1 wrq_buf2;
            wrq_buf2 <= #0.1 wrq_buf3;
            wrq_buf3 <= #0.1 wrq_buf4;
            wrq_buf4 <= #0.1 wrq_buf5;
            wrq_buf5 <= #0.1 wrq_buf6;
            wrq_buf6 <= #0.1 {axim_bresp, axim_bid};
          end else
            wrq_buf7 <= #0.1 {axim_bresp, axim_bid};
        end
        8'b1???_????: begin
          if (pop_wrq) begin
            wrq_buf0 <= #0.1 wrq_buf1;
            wrq_buf1 <= #0.1 wrq_buf2;
            wrq_buf2 <= #0.1 wrq_buf3;
            wrq_buf3 <= #0.1 wrq_buf4;
            wrq_buf4 <= #0.1 wrq_buf5;
            wrq_buf5 <= #0.1 wrq_buf6;
            wrq_buf6 <= #0.1 wrq_buf7;
            wrq_buf7 <= #0.1 {axim_bresp, axim_bid};
          end
        end
        default:;   //
      endcase
    end else if (pop_wrq) begin
      wrq_buf0 <= #0.1 wrq_buf1;
      wrq_buf1 <= #0.1 wrq_buf2;
      wrq_buf2 <= #0.1 wrq_buf3;
      wrq_buf3 <= #0.1 wrq_buf4;
      wrq_buf4 <= #0.1 wrq_buf5;
      wrq_buf5 <= #0.1 wrq_buf6;
      wrq_buf6 <= #0.1 wrq_buf7;
    end
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rdata_cnt0 <= #0.1 8'h0;
  else begin
    if (sft_ack0)
      rdata_cnt0 <= #0.1 8'h0;
    else if (axim_rvalid&axim_rready&(axim_rid==rd_tqbuf0[7:0])&rd_tqvld[0]) begin
      if (axim_rlast)
        rdata_cnt0 <= #0.1 rd_tqvld[1] ? rdata_cnt1 : 8'h0;
      else begin
        case (rd_tqbuf0[9:8])
          2'b00  : rdata_cnt0 <= #0.1 rdata_cnt0[6:0] + 1'b1;
          2'b01  : rdata_cnt0 <= #0.1 rdata_cnt0[6:0] + 2'h2;
          2'b10  : rdata_cnt0 <= #0.1 rdata_cnt0[6:0] + 3'h4;
          default: rdata_cnt0 <= #0.1 rdata_cnt0[6:0] + 4'h8;
        endcase
      end
    end
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn) begin
    rdata_buf0 <= #0.1 64'h0;
  end else begin
    if (axim_rvalid&axim_rready&(axim_rid==rd_tqbuf0[7:0])&rd_tqvld[0])
      rdata_buf0 <= #0.1 func_rdata((rdata_sel[0] ? rdata_buf1 : rdata_buf0), axim_rdata, rdata_cnt0[2:0], rd_tqbuf0[12:10], rd_tqbuf0[9:8]);
    else if (rdata_sel[0])
      rdata_buf0 <= #0.1 rdata_buf1;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rdata_cnt1 <= #0.1 8'h0;
  else begin
    if (sft_ack0)
      rdata_cnt1 <= #0.1 8'h0;
    else if (pop_rtq&(axim_rid==rd_tqbuf0[7:0]))
      rdata_cnt1 <= #0.1 rd_tqvld[2] ? rdata_cnt2 : 8'h0;
    else if (axim_rvalid&axim_rready&(axim_rid==rd_tqbuf1[7:0])&rd_tqvld[1]&(rd_tqbuf1[7:0]!=rd_tqbuf0[7:0])) begin
      if (axim_rlast)
        rdata_cnt1 <= #0.1 rd_tqvld[2] ? rdata_cnt2 : 8'h0;
      else begin
        case (rd_tqbuf1[9:8])
          2'b00  : rdata_cnt1 <= #0.1 rdata_cnt1[6:0] + 1'b1;
          2'b01  : rdata_cnt1 <= #0.1 rdata_cnt1[6:0] + 2'h2;
          2'b10  : rdata_cnt1 <= #0.1 rdata_cnt1[6:0] + 3'h4;
          default: rdata_cnt1 <= #0.1 rdata_cnt1[6:0] + 4'h8;
        endcase
      end
    end
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn) begin
    rdata_buf1 <= #0.1 64'h0;
  end else begin
    if (axim_rvalid&axim_rready&(axim_rid==rd_tqbuf1[7:0])&rd_tqvld[1])
      rdata_buf1 <= #0.1 func_rdata(((|rdata_sel[1:0]) ? rdata_buf2 : rdata_buf1), axim_rdata, rdata_cnt1[2:0], rd_tqbuf1[12:10], rd_tqbuf1[9:8]);
    else if (|rdata_sel[1:0])
      rdata_buf1 <= #0.1 rdata_buf2;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rdata_cnt2 <= #0.1 8'h0;
  else begin
    if (sft_ack0)
      rdata_cnt2 <= #0.1 8'h0;
    else if (pop_rtq&((axim_rid==rd_tqbuf0[7:0])|(axim_rid==rd_tqbuf1[7:0])))
      rdata_cnt2 <= #0.1 rd_tqvld[3] ? rdata_cnt3 : 8'h0;
    else if (axim_rvalid&axim_rready&(axim_rid==rd_tqbuf2[7:0])&rd_tqvld[2]&(rd_tqbuf2[7:0]!=rd_tqbuf1[7:0])&(rd_tqbuf2[7:0]!=rd_tqbuf0[7:0])) begin
      if (axim_rlast)
        rdata_cnt2 <= #0.1 rd_tqvld[3] ? rdata_cnt3 : 8'h0;
      else begin
        case (rd_tqbuf2[9:8])
          2'b00  : rdata_cnt2 <= #0.1 rdata_cnt2[6:0] + 1'b1;
          2'b01  : rdata_cnt2 <= #0.1 rdata_cnt2[6:0] + 2'h2;
          2'b10  : rdata_cnt2 <= #0.1 rdata_cnt2[6:0] + 3'h4;
          default: rdata_cnt2 <= #0.1 rdata_cnt2[6:0] + 4'h8;
        endcase
      end
    end
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn) begin
    rdata_buf2 <= #0.1 64'h0;
  end else begin
    if (axim_rvalid&axim_rready&(axim_rid==rd_tqbuf2[7:0])&rd_tqvld[2])
      rdata_buf2 <= #0.1 func_rdata(((|rdata_sel[2:0]) ? rdata_buf3 : rdata_buf2), axim_rdata, rdata_cnt2[2:0], rd_tqbuf2[12:10], rd_tqbuf2[9:8]);
    else if (|rdata_sel[2:0])
      rdata_buf2 <= #0.1 rdata_buf3;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rdata_cnt3 <= #0.1 8'h0;
  else begin
    if (sft_ack0)
      rdata_cnt3 <= #0.1 8'h0;
    else if (pop_rtq&((axim_rid==rd_tqbuf0[7:0])|(axim_rid==rd_tqbuf1[7:0])|(axim_rid==rd_tqbuf2[7:0]))&rd_tqvld[3])
      rdata_cnt3 <= #0.1 rd_tqvld[4] ? rdata_cnt4 : 8'h0;
    else if (axim_rvalid&axim_rready&(axim_rid==rd_tqbuf3[7:0])&rd_tqvld[3]&(rd_tqbuf3[7:0]!=rd_tqbuf2[7:0])&(rd_tqbuf3[7:0]!=rd_tqbuf1[7:0])&(rd_tqbuf3[7:0]!=rd_tqbuf0[7:0])) begin
      if (axim_rlast)
        rdata_cnt3 <= #0.1 rd_tqvld[4] ? rdata_cnt4 : 8'h0;
      else begin
        case (rd_tqbuf3[9:8])
          2'b00  : rdata_cnt3 <= #0.1 rdata_cnt3[6:0] + 1'b1;
          2'b01  : rdata_cnt3 <= #0.1 rdata_cnt3[6:0] + 2'h2;
          2'b10  : rdata_cnt3 <= #0.1 rdata_cnt3[6:0] + 3'h4;
          default: rdata_cnt3 <= #0.1 rdata_cnt3[6:0] + 4'h8;
        endcase
      end
    end
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn) begin
    rdata_buf3 <= #0.1 64'h0;
  end else begin
    if (axim_rvalid&axim_rready&(axim_rid==rd_tqbuf3[7:0])&rd_tqvld[3])
      rdata_buf3 <= #0.1 func_rdata(((|rdata_sel[3:0]) ? rdata_buf4 : rdata_buf3), axim_rdata, rdata_cnt3[2:0], rd_tqbuf3[12:10], rd_tqbuf3[9:8]);
    else if (|rdata_sel[3:0])
      rdata_buf3 <= #0.1 rdata_buf4;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rdata_cnt4 <= #0.1 8'h0;
  else begin
    if (sft_ack0)
      rdata_cnt4 <= #0.1 8'h0;
    else if (pop_rtq&((axim_rid==rd_tqbuf0[7:0])|(axim_rid==rd_tqbuf1[7:0])|(axim_rid==rd_tqbuf2[7:0])|(axim_rid==rd_tqbuf3[7:0]))&rd_tqvld[4])
      rdata_cnt4 <= #0.1 rd_tqvld[5] ? rdata_cnt5 : 8'h0;
    else if (axim_rvalid&axim_rready&(axim_rid==rd_tqbuf4[7:0])&rd_tqvld[4]&(rd_tqbuf4[7:0]!=rd_tqbuf3[7:0])
      &(rd_tqbuf4[7:0]!=rd_tqbuf2[7:0])&(rd_tqbuf4[7:0]!=rd_tqbuf1[7:0])&(rd_tqbuf4[7:0]!=rd_tqbuf0[7:0])) begin
      if (axim_rlast)
        rdata_cnt4 <= #0.1 rd_tqvld[5] ? rdata_cnt5 : 8'h0;
      else begin
        case (rd_tqbuf4[9:8])
          2'b00  : rdata_cnt4 <= #0.1 rdata_cnt4[6:0] + 1'b1;
          2'b01  : rdata_cnt4 <= #0.1 rdata_cnt4[6:0] + 2'h2;
          2'b10  : rdata_cnt4 <= #0.1 rdata_cnt4[6:0] + 3'h4;
          default: rdata_cnt4 <= #0.1 rdata_cnt4[6:0] + 4'h8;
        endcase
      end
    end
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn) begin
    rdata_buf4 <= #0.1 64'h0;
  end else begin
    if (axim_rvalid&axim_rready&(axim_rid==rd_tqbuf4[7:0])&rd_tqvld[4])
      rdata_buf4 <= #0.1 func_rdata(((|rdata_sel[4:0]) ? rdata_buf5 : rdata_buf4), axim_rdata, rdata_cnt4[2:0], rd_tqbuf4[12:10], rd_tqbuf4[9:8]);
    else if (|rdata_sel[4:0])
      rdata_buf4 <= #0.1 rdata_buf5;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rdata_cnt5 <= #0.1 8'h0;
  else begin
    if (sft_ack0)
      rdata_cnt5 <= #0.1 8'h0;
    else if (pop_rtq&((axim_rid==rd_tqbuf0[7:0])|(axim_rid==rd_tqbuf1[7:0])|(axim_rid==rd_tqbuf2[7:0])
      |(axim_rid==rd_tqbuf3[7:0])|(axim_rid==rd_tqbuf4[7:0]))&rd_tqvld[5])
      rdata_cnt5 <= #0.1 rd_tqvld[6] ? rdata_cnt6 : 8'h0;
    else if (axim_rvalid&axim_rready&(axim_rid==rd_tqbuf5[7:0])&rd_tqvld[5]&(rd_tqbuf5[7:0]!=rd_tqbuf3[7:0])&(rd_tqbuf5[7:0]!=rd_tqbuf4[7:0])
      &(rd_tqbuf5[7:0]!=rd_tqbuf2[7:0])&(rd_tqbuf5[7:0]!=rd_tqbuf1[7:0])&(rd_tqbuf5[7:0]!=rd_tqbuf0[7:0])) begin
      if (axim_rlast)
        rdata_cnt5 <= #0.1 rd_tqvld[6] ? rdata_cnt6 : 8'h0;
      else begin
        case (rd_tqbuf5[9:8])
          2'b00  : rdata_cnt5 <= #0.1 rdata_cnt5[6:0] + 1'b1;
          2'b01  : rdata_cnt5 <= #0.1 rdata_cnt5[6:0] + 2'h2;
          2'b10  : rdata_cnt5 <= #0.1 rdata_cnt5[6:0] + 3'h4;
          default: rdata_cnt5 <= #0.1 rdata_cnt5[6:0] + 4'h8;
        endcase
      end
    end
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn) begin
    rdata_buf5 <= #0.1 64'h0;
  end else begin
    if (axim_rvalid&axim_rready&(axim_rid==rd_tqbuf5[7:0])&rd_tqvld[5])
      rdata_buf5 <= #0.1 func_rdata(((|rdata_sel[5:0]) ? rdata_buf6 : rdata_buf5), axim_rdata, rdata_cnt5[2:0], rd_tqbuf5[12:10], rd_tqbuf5[9:8]);
    else if (|rdata_sel[5:0])
      rdata_buf5 <= #0.1 rdata_buf6;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rdata_cnt6 <= #0.1 8'h0;
  else begin
    if (sft_ack0)
      rdata_cnt6 <= #0.1 8'h0;
    else if (pop_rtq&((axim_rid==rd_tqbuf0[7:0])|(axim_rid==rd_tqbuf1[7:0])|(axim_rid==rd_tqbuf2[7:0])
      |(axim_rid==rd_tqbuf3[7:0])|(axim_rid==rd_tqbuf4[7:0])|(axim_rid==rd_tqbuf5[7:0]))&rd_tqvld[6])
      rdata_cnt6 <= #0.1 rd_tqvld[7] ? rdata_cnt7 : 8'h0;
    else if (axim_rvalid&axim_rready&(axim_rid==rd_tqbuf6[7:0])&rd_tqvld[6]&(rd_tqbuf6[7:0]!=rd_tqbuf3[7:0])&(rd_tqbuf6[7:0]!=rd_tqbuf4[7:0])
      &(rd_tqbuf6[7:0]!=rd_tqbuf5[7:0])&(rd_tqbuf6[7:0]!=rd_tqbuf2[7:0])&(rd_tqbuf6[7:0]!=rd_tqbuf1[7:0])&(rd_tqbuf6[7:0]!=rd_tqbuf0[7:0])) begin
      if (axim_rlast)
        rdata_cnt6 <= #0.1 rd_tqvld[7] ? rdata_cnt7 : 8'h0;
      else begin
        case (rd_tqbuf6[9:8])
          2'b00  : rdata_cnt6 <= #0.1 rdata_cnt6[6:0] + 1'b1;
          2'b01  : rdata_cnt6 <= #0.1 rdata_cnt6[6:0] + 2'h2;
          2'b10  : rdata_cnt6 <= #0.1 rdata_cnt6[6:0] + 3'h4;
          default: rdata_cnt6 <= #0.1 rdata_cnt6[6:0] + 4'h8;
        endcase
      end
    end
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn) begin
    rdata_buf6 <= #0.1 64'h0;
  end else begin
    if (axim_rvalid&axim_rready&(axim_rid==rd_tqbuf6[7:0])&rd_tqvld[6])
      rdata_buf6 <= #0.1 func_rdata(((|rdata_sel[6:0]) ? rdata_buf7 : rdata_buf6), axim_rdata, rdata_cnt6[2:0], rd_tqbuf6[12:10], rd_tqbuf6[9:8]);
    else if (|rdata_sel[6:0])
      rdata_buf6 <= #0.1 rdata_buf7;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rdata_cnt7 <= #0.1 8'h0;
  else begin
    if (sft_ack0)
      rdata_cnt7 <= #0.1 8'h0;
    else if (pop_rtq&((axim_rid==rd_tqbuf0[7:0])|(axim_rid==rd_tqbuf1[7:0])|(axim_rid==rd_tqbuf2[7:0])|(axim_rid==rd_tqbuf6[7:0])
      |(axim_rid==rd_tqbuf3[7:0])|(axim_rid==rd_tqbuf4[7:0])|(axim_rid==rd_tqbuf5[7:0]))&rd_tqvld[7])
      //rdata_cnt6 <= `DLY rd_tqvld[7] ? rdata_cnt7 : 8'h0;
      rdata_cnt7 <= #0.1 8'h0;
    else if (axim_rvalid&axim_rready&(axim_rid==rd_tqbuf7[7:0])&rd_tqvld[7]&(rd_tqbuf7[7:0]!=rd_tqbuf3[7:0])
      &(rd_tqbuf7[7:0]!=rd_tqbuf4[7:0])&(rd_tqbuf7[7:0]!=rd_tqbuf6[7:0])&(rd_tqbuf7[7:0]!=rd_tqbuf5[7:0])
      &(rd_tqbuf7[7:0]!=rd_tqbuf2[7:0])&(rd_tqbuf7[7:0]!=rd_tqbuf1[7:0])&(rd_tqbuf7[7:0]!=rd_tqbuf0[7:0])) begin
      if (axim_rlast)
        //rdata_cnt7 <= `DLY rd_tqvld[7] ? rdata_cnt7 : 8'h0;
        rdata_cnt7 <= #0.1 8'h0;
      else begin
        case (rd_tqbuf7[9:8])
          2'b00  : rdata_cnt7 <= #0.1 rdata_cnt7[6:0] + 1'b1;
          2'b01  : rdata_cnt7 <= #0.1 rdata_cnt7[6:0] + 2'h2;
          2'b10  : rdata_cnt7 <= #0.1 rdata_cnt7[6:0] + 3'h4;
          default: rdata_cnt7 <= #0.1 rdata_cnt7[6:0] + 4'h8;
        endcase
      end
    end
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn) begin
    rdata_buf7 <= #0.1 64'h0;
  end else begin
    if (axim_rvalid&axim_rready&(axim_rid==rd_tqbuf7[7:0])&rd_tqvld[7])
      rdata_buf7 <= #0.1 func_rdata(rdata_buf7, axim_rdata, rdata_cnt7[2:0], rd_tqbuf7[12:10], rd_tqbuf7[9:8]);
    //else if (|rdata_sel[7:0])
    //  rdata_buf6 <= `DLY rdata_buf7;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rmem_busy <= #0.1 8'h0;
  else begin
    if (sft_rst)
      rmem_busy <= #0.1 8'h0;
    else begin
      case ({(push_rdq&~trans_abort), pop_txdq})
        2'b10  : rmem_busy[rdata_len[9:7]] <= #0.1 1'b1;
        2'b01  : rmem_busy[txdq_buf[9:7]] <= #0.1 1'b0;
        2'b11  : begin
          rmem_busy[rdata_len[9:7]] <= #0.1 1'b1;
          rmem_busy[txdq_buf[9:7]]  <= #0.1 1'b0;
        end
        default:;
      endcase
    end
  end
end

always @ (*) begin
  if ((axim_rid==rd_tqbuf0[7:0])&rd_tqvld[0])
    axim_rready = ~rmem_busy[rd_tqbuf0[15:13]];
  else if ((axim_rid==rd_tqbuf1[7:0])&rd_tqvld[1])
    axim_rready = ~rmem_busy[rd_tqbuf1[15:13]];
  else if ((axim_rid==rd_tqbuf2[7:0])&rd_tqvld[2])
    axim_rready = ~rmem_busy[rd_tqbuf2[15:13]];
  else if ((axim_rid==rd_tqbuf3[7:0])&rd_tqvld[3])
    axim_rready = ~rmem_busy[rd_tqbuf3[15:13]];
  else if ((axim_rid==rd_tqbuf4[7:0])&rd_tqvld[4])
    axim_rready = ~rmem_busy[rd_tqbuf4[15:13]];
  else if ((axim_rid==rd_tqbuf5[7:0])&rd_tqvld[5])
    axim_rready = ~rmem_busy[rd_tqbuf5[15:13]];
  else if ((axim_rid==rd_tqbuf6[7:0])&rd_tqvld[7])
    axim_rready = ~rmem_busy[rd_tqbuf6[15:13]];
  else/// if ((axim_rid==rd_tqbuf7[7:0])&rd_tqvld[7])
    axim_rready = ~rmem_busy[rd_tqbuf7[15:13]];
end
//******************************************************************************
// Write SRAM control and instance

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wmem_rd_d <= #0.1 3'h0;
  else begin
    if (sft_rst|trans_abort)
      wmem_rd_d <= #0.1 3'h0;
    else
      wmem_rd_d <= #0.1 {wmem_rd_d[1:0], wsram_rd};
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wmem_cen <= #0.1 1'b1;
  else begin
    if ((wsram_wr|wsram_rd)&~(sft_rst|trans_abort))
      wmem_cen <= #0.1 1'b0;
    else
      wmem_cen <= #0.1 1'b1;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wmem_wen <= #0.1 1'b1;
  else begin
    if (wsram_wr)
      wmem_wen <= #0.1 1'b0;
    else
      wmem_wen <= #0.1 1'b1;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wmem_wdata <= #0.1 72'h0;
  else begin
    if (wsram_wr)
      wmem_wdata <= #0.1 cpu_wdata;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wmem_waddr <= #0.1 6'h0;
  else begin
    if (wsram_wr)
      wmem_waddr <= #0.1 wsram_wptr[5:0];
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wmem_raddr <= #0.1 6'h0;
  else begin
    if (wsram_rd)
      wmem_raddr <= #0.1 wsram_rptr[5:0];
  end
end

sim_Bisted_S2P64X72 u_wdata_buf_0 (
  .Q           (wmem_temp),
  .SQ          (wmem_rdata),
  .BistFail    (bist_fail[0]),
  .BistFinish  (bist_finish[0]),

  .CLK         (sysclk),
  .CLKX2       (mem_clk2x),
  .RCEN        (wmem_cen),
  .RA          (wmem_raddr),
  .WEN         (wmem_wen),
  .WA          (wmem_waddr),
  .D           (wmem_wdata),
  .RESET_B     (sysrstn),
  .NVIC_RST_B  (bist_rstn),
  .BistMode    (bist_mode),
  .SCAN_ENABLE (scan_enable),
  .TEST_MODE   (test_mode)
);
//******************************************************************************
// Read SRAM control and instance
assign rmem_wdata = ({64{rmem_wsel[0]}} & rdata_buf0) | ({64{rmem_wsel[1]}} & rdata_buf1)
                  | ({64{rmem_wsel[2]}} & rdata_buf2) | ({64{rmem_wsel[3]}} & rdata_buf3)
                  | ({64{rmem_wsel[4]}} & rdata_buf4) | ({64{rmem_wsel[5]}} & rdata_buf5)
                  | ({64{rmem_wsel[6]}} & rdata_buf6) | ({64{rmem_wsel[7]}} & rdata_buf7);
assign rmem_cen   = tx_cpu_ren & rmem_wen;

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rmem_wen <= #0.1 1'b1;
  else begin
    if (rmem_wr)
      rmem_wen <= #0.1 1'b0;
    else
      rmem_wen <= #0.1 1'b1;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rmem_waddr <= #0.1 7'h0;
  else begin
    if (axim_rvalid&axim_rready) begin
      if ((axim_rlast&(axim_rid==rd_tqbuf0[7:0])) | rmem_wr0)
        rmem_waddr <= #0.1 {rd_tqbuf0[15:13], rdata_cnt0[6:3]};
      else if ((axim_rlast&(axim_rid==rd_tqbuf1[7:0])) | rmem_wr1)
        rmem_waddr <= #0.1 {rd_tqbuf1[15:13], rdata_cnt1[6:3]};
      else if ((axim_rlast&(axim_rid==rd_tqbuf2[7:0])) | rmem_wr2)
        rmem_waddr <= #0.1 {rd_tqbuf2[15:13], rdata_cnt2[6:3]};
      else if ((axim_rlast&(axim_rid==rd_tqbuf3[7:0])) | rmem_wr3)
        rmem_waddr <= #0.1 {rd_tqbuf3[15:13], rdata_cnt3[6:3]};
      else if ((axim_rlast&(axim_rid==rd_tqbuf4[7:0])) | rmem_wr4)
        rmem_waddr <= #0.1 {rd_tqbuf4[15:13], rdata_cnt4[6:3]};
      else if ((axim_rlast&(axim_rid==rd_tqbuf5[7:0])) | rmem_wr5)
        rmem_waddr <= #0.1 {rd_tqbuf5[15:13], rdata_cnt5[6:3]};
      else if ((axim_rlast&(axim_rid==rd_tqbuf6[7:0])) | rmem_wr6)
        rmem_waddr <= #0.1 {rd_tqbuf6[15:13], rdata_cnt6[6:3]};
      else if ((axim_rlast&(axim_rid==rd_tqbuf7[7:0])) | rmem_wr7)
        rmem_waddr <= #0.1 {rd_tqbuf7[15:13], rdata_cnt7[6:3]};
    end
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rmem_raddr <= #0.1 8'h0;
  else begin
    if (load_adr)
      rmem_raddr <= #0.1 {1'b0, txdq_buf[9:7], 4'h0};
    else if (pop_txdq&txdq_vld[1])
      rmem_raddr <= #0.1 {1'b0, txdq_buf[19:17], 4'h0};
    else if (~tx_cpu_ren)
      rmem_raddr <= #0.1 rmem_raddr[6:0] + 1'b1;
  end
end

sim_Bisted_S2P128X64 u_rdata_buf_0 (
  .Q           (rmem_temp),
  .SQ          (rmem_rdata),
  .BistFail    (bist_fail[1]),
  .BistFinish  (bist_finish[1]),

  .CLK         (sysclk),
  .CLKX2       (mem_clk2x),
  .RCEN        (rmem_cen),
  .RA          (rmem_raddr[6:0]),
  .WEN         (rmem_wen),
  .WA          (rmem_waddr),
  .D           (rmem_wdata),
  .RESET_B     (sysrstn),
  .NVIC_RST_B  (bist_rstn),
  .BistMode    (bist_mode),
  .SCAN_ENABLE (scan_enable),
  .TEST_MODE   (test_mode)
);

//******************************************************************************
// Function for read data select based on size, start address and data count
function [63:0] func_rdata;
  input [63:0] rdata_org;   // original read data
  input [63:0] rdata_bus;   // read data from bus
  input [2:0]  rdata_cnt;   // read data counter
  input [2:0]  rdata_adr;   // read data start address
  input [1:0]  rsize;       // read data size

  reg  [3:0] rdata_sel;
  begin
    rdata_sel = rdata_cnt + rdata_adr;
    case (rsize)
      2'b00: begin
        case (rdata_cnt[2:0])
          3'b000: begin
            func_rdata[63:8] = rdata_org[63:8];
            case (rdata_sel[2:0])
              3'b000 : func_rdata[7:0] = rdata_bus[7:0];
              3'b001 : func_rdata[7:0] = rdata_bus[15:8];
              3'b010 : func_rdata[7:0] = rdata_bus[23:16];
              3'b011 : func_rdata[7:0] = rdata_bus[31:24];
              3'b100 : func_rdata[7:0] = rdata_bus[39:32];
              3'b101 : func_rdata[7:0] = rdata_bus[47:40];
              3'b110 : func_rdata[7:0] = rdata_bus[55:48];
              default: func_rdata[7:0] = rdata_bus[63:56];
            endcase
          end
          3'b001: begin
            func_rdata[63:16] = rdata_org[63:16];
            func_rdata[7:0]   = rdata_org[7:0];
            case (rdata_sel[2:0])
              3'b000 : func_rdata[15:8] = rdata_bus[7:0];
              3'b001 : func_rdata[15:8] = rdata_bus[15:8];
              3'b010 : func_rdata[15:8] = rdata_bus[23:16];
              3'b011 : func_rdata[15:8] = rdata_bus[31:24];
              3'b100 : func_rdata[15:8] = rdata_bus[39:32];
              3'b101 : func_rdata[15:8] = rdata_bus[47:40];
              3'b110 : func_rdata[15:8] = rdata_bus[55:48];
              default: func_rdata[15:8] = rdata_bus[63:56];
            endcase
          end
          3'b010: begin
            func_rdata[63:24] = rdata_org[63:24];
            func_rdata[15:0]  = rdata_org[15:0];
            case (rdata_sel[2:0])
              3'b000 : func_rdata[23:16] = rdata_bus[7:0];
              3'b001 : func_rdata[23:16] = rdata_bus[15:8];
              3'b010 : func_rdata[23:16] = rdata_bus[23:16];
              3'b011 : func_rdata[23:16] = rdata_bus[31:24];
              3'b100 : func_rdata[23:16] = rdata_bus[39:32];
              3'b101 : func_rdata[23:16] = rdata_bus[47:40];
              3'b110 : func_rdata[23:16] = rdata_bus[55:48];
              default: func_rdata[23:16] = rdata_bus[63:56];
            endcase
          end
          3'b011: begin
            func_rdata[63:32] = rdata_org[63:32];
            func_rdata[23:0]  = rdata_org[23:0];
            case (rdata_sel[2:0])
              3'b000 : func_rdata[31:24] = rdata_bus[7:0];
              3'b001 : func_rdata[31:24] = rdata_bus[15:8];
              3'b010 : func_rdata[31:24] = rdata_bus[23:16];
              3'b011 : func_rdata[31:24] = rdata_bus[31:24];
              3'b100 : func_rdata[31:24] = rdata_bus[39:32];
              3'b101 : func_rdata[31:24] = rdata_bus[47:40];
              3'b110 : func_rdata[31:24] = rdata_bus[55:48];
              default: func_rdata[31:24] = rdata_bus[63:56];
            endcase
          end
          3'b100: begin
            func_rdata[63:40] = rdata_org[63:40];
            func_rdata[31:0]  = rdata_org[31:0];
            case (rdata_sel[2:0])
              3'b000 : func_rdata[39:32] = rdata_bus[7:0];
              3'b001 : func_rdata[39:32] = rdata_bus[15:8];
              3'b010 : func_rdata[39:32] = rdata_bus[23:16];
              3'b011 : func_rdata[39:32] = rdata_bus[31:24];
              3'b100 : func_rdata[39:32] = rdata_bus[39:32];
              3'b101 : func_rdata[39:32] = rdata_bus[47:40];
              3'b110 : func_rdata[39:32] = rdata_bus[55:48];
              default: func_rdata[39:32] = rdata_bus[63:56];
            endcase
          end
          3'b101: begin
            func_rdata[63:48] = rdata_org[63:48];
            func_rdata[39:0]  = rdata_org[39:0];
            case (rdata_sel[2:0])
              3'b000 : func_rdata[47:40] = rdata_bus[7:0];
              3'b001 : func_rdata[47:40] = rdata_bus[15:8];
              3'b010 : func_rdata[47:40] = rdata_bus[23:16];
              3'b011 : func_rdata[47:40] = rdata_bus[31:24];
              3'b100 : func_rdata[47:40] = rdata_bus[39:32];
              3'b101 : func_rdata[47:40] = rdata_bus[47:40];
              3'b110 : func_rdata[47:40] = rdata_bus[55:48];
              default: func_rdata[47:40] = rdata_bus[63:56];
            endcase
          end
          3'b110: begin
            func_rdata[63:56] = rdata_org[63:56];
            func_rdata[47:0]  = rdata_org[47:0];
            case (rdata_sel[2:0])
              3'b000 : func_rdata[55:48] = rdata_bus[7:0];
              3'b001 : func_rdata[55:48] = rdata_bus[15:8];
              3'b010 : func_rdata[55:48] = rdata_bus[23:16];
              3'b011 : func_rdata[55:48] = rdata_bus[31:24];
              3'b100 : func_rdata[55:48] = rdata_bus[39:32];
              3'b101 : func_rdata[55:48] = rdata_bus[47:40];
              3'b110 : func_rdata[55:48] = rdata_bus[55:48];
              default: func_rdata[55:48] = rdata_bus[63:56];
            endcase
          end
          default: begin    // 3'b111;
            func_rdata[55:0] = rdata_org[55:0];
            case (rdata_sel[2:0])
              3'b000 : func_rdata[63:56] = rdata_bus[7:0];
              3'b001 : func_rdata[63:56] = rdata_bus[15:8];
              3'b010 : func_rdata[63:56] = rdata_bus[23:16];
              3'b011 : func_rdata[63:56] = rdata_bus[31:24];
              3'b100 : func_rdata[63:56] = rdata_bus[39:32];
              3'b101 : func_rdata[63:56] = rdata_bus[47:40];
              3'b110 : func_rdata[63:56] = rdata_bus[55:48];
              default: func_rdata[63:56] = rdata_bus[63:56];
            endcase
          end
        endcase
      end
      2'b01: begin
        case ({rdata_cnt[2:1], rdata_sel[2:1]})
          4'b0000: func_rdata = {rdata_org[63:16], rdata_bus[15:0]                  };
          4'b0001: func_rdata = {rdata_org[63:16], rdata_bus[31:16]                 };
          4'b0010: func_rdata = {rdata_org[63:16], rdata_bus[47:32]                 };
          4'b0011: func_rdata = {rdata_org[63:16], rdata_bus[63:48]                 };
          4'b0100: func_rdata = {rdata_org[63:32], rdata_bus[15:0] , rdata_org[15:0]};
          4'b0101: func_rdata = {rdata_org[63:32], rdata_bus[31:16], rdata_org[15:0]};
          4'b0110: func_rdata = {rdata_org[63:32], rdata_bus[47:32], rdata_org[15:0]};
          4'b0111: func_rdata = {rdata_org[63:32], rdata_bus[63:48], rdata_org[15:0]};
          4'b1000: func_rdata = {rdata_org[63:48], rdata_bus[15:0] , rdata_org[31:0]};
          4'b1001: func_rdata = {rdata_org[63:48], rdata_bus[31:16], rdata_org[31:0]};
          4'b1010: func_rdata = {rdata_org[63:48], rdata_bus[47:32], rdata_org[31:0]};
          4'b1011: func_rdata = {rdata_org[63:48], rdata_bus[63:48], rdata_org[31:0]};
          4'b1100: func_rdata = {                  rdata_bus[15:0] , rdata_org[47:0]};
          4'b1101: func_rdata = {                  rdata_bus[31:16], rdata_org[47:0]};
          4'b1110: func_rdata = {                  rdata_bus[47:32], rdata_org[47:0]};
          default: func_rdata = {                  rdata_bus[63:48], rdata_org[47:0]};
        endcase
      end
      2'b10: begin
        case ({rdata_cnt[2], rdata_sel[2]})
          2'b00  : func_rdata = {rdata_org[63:32], rdata_bus[31:0]};
          2'b01  : func_rdata = {rdata_org[63:32], rdata_bus[63:32]};
          2'b10  : func_rdata = {rdata_bus[31:0],  rdata_org[31:0]};
          default: func_rdata = {rdata_bus[63:32], rdata_org[31:0]};
        endcase
      end
      default: func_rdata = rdata_bus;
    endcase
  end
endfunction
endmodule
//==============================================================================
//
//    This confidential and proprietary hardware may be used only as
//  authorized by a licensing agreement from
//                    SunMedia Technology Co., LTD.
//
//  In the event of publication, the following notice is applicable:
//
//            COPYRIGHT 2017, SunMedia Technology Co., LTD.
//                        ALL RIGHTS RESERVED
//
//  The entire notice above must be reproduced on all authorized copies.
//
//==============================================================================
//
//  File        : f_bio_cpus_ctrl.v
//  Author      : kun.zhang
//  Date        : 20/Nov/2017
//  Version     : 1.1
//  Abstract    : This module is the CPU mode control block for BIO control. It
//                takes command from AXI bus and transfer it to tx_pkt for IO
//                bus transfers. Including 2 32X64 S2P memory for data storage.
//                This module is for Bchip to Achip CPU access
//
//  Modification History:
//  Date          By            Version         Change Description
//------------------------------------------------------------------------------
//  20/Mar/2017   kun.zhang      1.0            Original
//  20/Nov/2017   kun.zhang      1.1            Changed to 64bit AXI bus for
//                                              Bchip access
//
//
//==============================================================================



module f_bio_cpus_ctrl #(parameter IDW = 9) (
  input  wire        sysclk,    // clock
  input  wire        sysrstn,   // reset
  input  wire        sft_rst,   // Soft reset
  input  wire        sft_set,   // Soft set
  output reg         sft_ack3,  // Soft reset ack from CPU slave mode

  input  wire        bist_rstn, // NVIC_RST_B
  input  wire        bist_mode,
  input  wire        test_mode,
  input  wire        scan_enable,
  output wire [1:0]  bist_fail,
  output wire [1:0]  bist_finish,
  input  wire        mem_clk2x,

  input  wire        stest_en,     // Self-test mode enable
  input  wire        stest_trig,   // Self-test trigger

  input  wire        rx_cpu_req,    // Receiver to CPU request for read data
  input  wire [17:0] rx_cpu_info,   // Receiver to CPU request information
  input  wire        cpu_rvld,      // CPU read data valid
  input  wire [63:0] cpu_rdata,     // CPU read data
  output wire        cpu_rrdy,      // CPU read ready, has enough buffer for RX data.
  input  wire        rx_cpu_req1,   // Receiver to CPU request for write response
  input  wire [9:0]  rx_cpu_info1,  // Receiver to CPU write response information
  output wire        cpu_rx_acp1,   // CPU accept write response request

  output reg         cpu_tx_req,    // CPU to transmiter request
  output reg  [66:0] cpu_tx_info,   // CPU to transmiter request information
  input  wire        tx_cpu_ack,    // Transmiter to CPU request acknowlage
  input  wire        tx_cpu_ren,    // Transmiter to CPU read enable
  output wire [63:0] cpu_data,      // CPU write data
  output reg  [3:0]  cpu_tlast,     // CPU last data in a burst and valid byte
  output reg  [131:0] cpu_wbe,       // CPU data byte enable
  output wire        cpu_clast,     // CPU data command last

  output wire [3:0]  arb_probe,     //

  // AXI slave port
  input  wire [IDW-1:0] axis_awid,
  input  wire [31:0] axis_awaddr,
  input  wire [3:0]  axis_awlen,
  input  wire [2:0]  axis_awsize,
  input  wire [1:0]  axis_awburst,
  input  wire [1:0]  axis_awlock,
  input  wire [3:0]  axis_awcache,
  input  wire [2:0]  axis_awprot,
  input  wire        axis_awvalid,
  output reg         axis_awready,

  input  wire [IDW-1:0] axis_wid,
  input  wire [63:0] axis_wdata,
  input  wire [7:0]  axis_wstrb,
  input  wire        axis_wlast,
  input  wire        axis_wvalid,
  output wire        axis_wready,

  output reg  [IDW-1:0] axis_bid,
  output reg  [1:0]  axis_bresp,
  output reg         axis_bvalid,
  input  wire        axis_bready,

  input  wire [IDW-1:0] axis_arid,
  input  wire [31:0] axis_araddr,
  input  wire [3:0]  axis_arlen,
  input  wire [2:0]  axis_arsize,
  input  wire [1:0]  axis_arburst,
  input  wire [1:0]  axis_arlock,
  input  wire [3:0]  axis_arcache,
  input  wire [2:0]  axis_arprot,
  input  wire        axis_arvalid,
  output reg         axis_arready,

  output reg  [IDW-1:0] axis_rid,
  output reg  [63:0] axis_rdata,
  output reg  [1:0]  axis_rresp,
  output reg         axis_rlast,
  output reg         axis_rvalid,
  input  wire        axis_rready
);

parameter RD_IDLE = 2'b00;
parameter RD_BUSY = 2'b10;
parameter WR_IDLE = 2'b01;
parameter WR_BUSY = 2'b11;
//******************************************************************************
reg  [1:0]  cpu_arb_cs;     // CPU arbiter current state
reg  [1:0]  cpu_arb_ns;     // CPU arbiter next state
wire        set_treq;       // Status to set new cpu_tx_req
reg         srst_r;         // Latched sft_rst
wire        srst_w;         // Soft reset
reg         wr_abort;       // Write abort the transfers for soft reset
reg         rd_abort;       // Read abort the transfers for soft reset
//reg         rd_dlast;       // Read last data after abort
wire        wr_abort_w;     // Write abort mix with sft_rst;
wire        rd_abort_w;     // Read abort mix with sft_rst;
wire        clr_wabort;     // Status to clear wr_abort
wire        clr_rabort;     // Status to clear rd_abort

reg         wr_tx_req;      // CPU write TX request, level
reg  [65:0] wr_tx_info;     // CPU write TX information
wire        tx_wr_ack;      // CPU write TX acknowlage
reg  [6:0]  wr_dlen;        // Write data length for bytes
wire [7:0]  wr_len;         // Write length in bytes
wire [63:0] wr_data;        // CPU write data
wire        pop_wrcq;       // Pop information from write command queue
wire [58:0] wr_cqinfo;      // Write command queue information
reg  [3:0]  wr_cqvld;       // Write command queue valid
reg  [58:0] wr_cqbuf0;      // Write command queue buffer0
reg  [58:0] wr_cqbuf1;      // Write command queue buffer1
reg  [58:0] wr_cqbuf2;      // Write command queue buffer2
reg  [58:0] wr_cqbuf3;      // Write command queue buffer3
wire        push_wdq;       // Push information to write data queue
wire        pop_wrdq;       // Pop information from write data quque
reg  [3:0]  wr_dqvld;       // Write data queue valid
reg  [4:0]  wr_dqvld1;      // Write data queue valid for wbe
wire        pop_wrsq;       // Pop information from write size queue
wire [4:0]  wr_sqinfo;      // Write size queue information
reg  [3:0]  wr_sqvld;       // Write size queue valid
reg  [19:0] wr_sqbuf;       // Write size queue buffer
reg  [1:0]  wr_size;        // Write size for data
reg  [3:0]  wr_adr_sel;     // Write address select
reg  [3:0]  wr_cnt;         // Write counter for 32/64bit data shift
reg  [4:0]  wbe_cnt;        // Write byte-enable counter
reg  [127:0] wbe_buf;        // Write byte-enable shift buffer for 32/64bit data
reg  [131:0] wbe_info;       // Write byte-enable for data queue
reg  [1:0]  wbe_sel;        // Write byte-enable selected for address
reg  [131:0] wr_dqbuf0;      // Write data queue buffer
reg  [131:0] wr_dqbuf1;      // Write data queue buffer
reg  [131:0] wr_dqbuf2;      // Write data queue buffer
reg  [131:0] wr_dqbuf3;      // Write data queue buffer
reg  [131:0] wr_dqbuf4;      // Write data queue buffer
wire        pop_txdq;       // Pop information from Transfer data queue
reg  [3:0]  txdq_vld;       // Transfer data queue valid
reg  [27:0] txdq_buf;       // Transfer data queue buffer
reg  [3:0]  tx_dlast;       // Transfer data last
wire        pop_wrbq;       // Pop information from write response queue
wire        push_wrbq;      // status to push write response queue
reg  [7:0]  wr_bqvld;       // Write response queue valid
reg  [8:0]  wr_bqbuf0;      // Write response queue entry0
reg  [8:0]  wr_bqbuf1;      // Write response queue entry1
reg  [8:0]  wr_bqbuf2;      // Write response queue entry2
reg  [8:0]  wr_bqbuf3;      // Write response queue entry3
reg  [8:0]  wr_bqbuf4;      // Write response queue entry4
reg  [8:0]  wr_bqbuf5;      // Write response queue entry5
reg  [8:0]  wr_bqbuf6;      // Write response queue entry6
reg  [8:0]  wr_bqbuf7;      // Write response queue entry7
reg  [3:0]  wr_bqvld1;      // Write response queue valid1
reg  [10:0] wr_bq1buf0;     // Write response queue1 entry0
reg  [10:0] wr_bq1buf1;     // Write response queue1 entry1
reg  [10:0] wr_bq1buf2;     // Write response queue1 entry2
reg  [10:0] wr_bq1buf3;     // Write response queue1 entry3
reg  [10:0] wr_bqinfo;      // Write response queue information

reg         rd_tx_req;     // CPU read TX request, level
reg  [57:0] rd_tx_info;    // CPU read TX information
wire        tx_rd_ack;     // CPU read TX acknowlage
wire        pop_rdcq;      // Pop information form read command queue
wire [58:0] rd_cqinfo;     // Read command queue information
reg  [3:0]  rd_cqvld;      // Read command queue valid
reg  [58:0] rd_cqbuf0;     // Read command queue buffer0
reg  [58:0] rd_cqbuf1;     // Read command queue buffer1
reg  [58:0] rd_cqbuf2;     // Read command queue buffer2
reg  [58:0] rd_cqbuf3;     // Read command queue buffer3
wire        pop_rdtq;      // Pop information from read transfer queue
wire [17:0] rd_tqinfo;     // Read TX queue information
reg  [7:0]  rd_tqvld;      // Read TX queue valid
reg  [17:0] rd_tqbuf0;     // Read TX queue buffer0
reg  [17:0] rd_tqbuf1;     // Read TX queue buffer1
reg  [17:0] rd_tqbuf2;     // Read TX queue buffer2
reg  [17:0] rd_tqbuf3;     // Read TX queue buffer3
reg  [17:0] rd_tqbuf4;     // Read TX queue buffer4
reg  [17:0] rd_tqbuf5;     // Read TX queue buffer5
reg  [17:0] rd_tqbuf6;     // Read TX queue buffer6
reg  [17:0] rd_tqbuf7;     // Read TX queue buffer7
wire [8:0]  rx_dcnt;       // RX data counter in words
wire        rx_dlast;      // RX last data
reg  [23:0] rd_dqinfo;     // Read data queue information
wire        pop_rdq;       // Pop information from read data queue
reg         rmem_rd_en;    // Read memory read enable
reg  [4:0]  rd_dqvld;      // Read data queue valid
reg  [23:0] rd_dqbuf0;     // Read data queue buffer0
reg  [23:0] rd_dqbuf1;     // Read data queue buffer1
reg  [23:0] rd_dqbuf2;     // Read data queue buffer2
reg  [23:0] rd_dqbuf3;     // Read data queue buffer3
reg  [23:0] rd_dqbuf4;     // Read data queue buffer4
reg  [4:0]  rd_len;        // Read data length
reg  [1:0]  rd_size;       // Read data size.
reg  [3:0]  rd_bcnt;       // Read data byte counter
reg  [2:0]  rd_adr_sel;    // Read address select
reg  [4:0]  rd_dcnt;       // Read data counter for 64/32bit shift

wire         wr_2w_vld;     // Write 2Word data valid
reg         axis_wready_s;  // Wready source
reg  [15:0] wdata_sel;     // Write memory data with address select for half-word access
reg  [7:0]  wdata_sel1;    // Write memory data with address select for byte access
reg  [63:0] wmem_wdata_s;  // Write memory write data source
wire        wsram_full;     // Write memory full
wire        wsram_wr;      // Write SRAM write
reg  [7:0]  wsram_wptr;    // Write SRAM write pointer
reg  [7:0]  wsram_rptr;    // Write SRAM read pointer
wire        wsram_empty;   // Write SRAM empty
wire [63:0] wmem_rdata;    // Write SRAM read data, from SQ
wire [63:0] wmem_temp;     // Write SRAM read data temp, from Q
wire        wmem_cen;      // Write SRAM chip enable
reg  [7:0]  wmem_raddr;    // Write SRAM read address
reg         wmem_wen;      // Write SRAM write enable
reg  [5:0]  wmem_waddr;    // Write SRAM write address

wire        rmem_wr;       // Read memory write
wire        rmem_rd;       // Read memory read
wire        rmem_rd1;      // Read memory read after abort
wire [63:0] rmem_wdata_s;  // Read memory write data source
wire        rmem_full;     // Read memory full
wire        rmem_empty;    // Read memory empty
wire        rpre_wr0;      // Read memory pre-write0
wire        rpre_wr1;      // Read memory pre-write1
wire        rpre_wr2;      // Read memory pre-write2
wire        rpre_wr3;      // Read memory pre-write3
wire        rpre_wr4;      // Read memory pre-write4
wire        rpre_wr;       // Read memory pre-write
reg  [7:0]  rmem_dcnt0;    // Read memory data counter0 for pre-read
reg  [2:0]  rmem_dcnt1;    // Read memory data counter1 for pre-read
reg  [2:0]  rmem_dcnt10;   // Read memory data counter1 temp0 for pre-read
reg  [2:0]  rmem_dcnt11;   // Read memory data counter1 temp1 for pre-read
reg  [2:0]  rmem_dcnt12;   // Read memory data counter1 temp2 for pre-read
wire        rsram_wr;      // Read SRAM write
wire        rsram_rd;      // Read SRAM read
reg  [7:0]  rsram_wptr;    // Read SRAM write pointer
reg  [7:0]  rsram_rptr;    // Read SRAM read pointer
wire        rsram_empty;   // Read SRAM empty
reg  [2:0]  rmem_rd_d;     // Read SRAM read delayed for data latch
reg  [63:0] rmem_tmp0;     // Read memory temp register
reg  [63:0] rmem_tmp1;     // Read memory temp register
reg  [63:0] rmem_tmp2;     // Read memory temp register
reg  [63:0] rmem_tmp3;     // Read memory temp register
wire [63:0] rmem_rdata;    // Read SRAM read data, from SQ
wire [63:0] rmem_temp;     // Read SRAM read data temp, from Q
reg         rmem_cen;      // Read SRAM chip enable
reg  [5:0]  rmem_raddr;    // Read SRAM read address
reg         rmem_wen;      // Read SRAM write enable
reg  [5:0]  rmem_waddr;    // Read SRAM write address
reg  [63:0] rmem_wdata;    // Read SRAM write data

//reg  [31:0] stest_addr;    // Self-test register address
//reg         cpu_rrdy_t;    // Self-test mode cpu read ready
//reg  [1:0]  stest_rsel;    // Self-test read select. 11: Read address.
                           // 00: Read register lower, 01: Read register higher
//reg         rd_reg_en;     // Read register enable
//reg         wr_reg_en;     // Write register enable
//reg  [31:0] stest_data;    // Self-test data
//wire [63:0] stest_wdata;   // Self-test write data

reg         temp0;  // tmp reg for txbuf sub
//==============================================================================
assign srst_w     = srst_r   | sft_rst;
assign wr_abort_w = wr_abort | sft_rst;
assign rd_abort_w = rd_abort | sft_rst;
assign clr_wabort = wr_abort&~wr_bqvld[0]&~wr_bqvld1[0]&~wr_cqvld[0]&~axis_awvalid;
assign clr_rabort = rd_abort&~rd_tqvld[0]&~rd_dqvld[0]&~rd_cqvld[0]&(rd_dcnt[3:0]==4'h0)
                  & (~axis_rvalid|(axis_rvalid&axis_rready))&~axis_arvalid;
assign set_treq  = (cpu_arb_ns!=cpu_arb_cs) & cpu_arb_ns[1] & ~srst_w;
assign cpu_data  = wr_data;
assign tx_rd_ack = (cpu_arb_cs!=RD_BUSY)&(cpu_arb_ns==RD_BUSY);
assign tx_wr_ack = (cpu_arb_cs!=WR_BUSY)&(cpu_arb_ns==WR_BUSY);

assign arb_probe = {tx_rd_ack, rd_tx_req, tx_wr_ack, wr_tx_req};

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    srst_r <= #0.1 1'b0;
  else begin
    if (sft_rst)
      srst_r <= #0.1 1'b1;
    else if (~wr_abort&~rd_abort)
      srst_r <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wr_abort <= #0.1 1'b0;
  else begin
    if (sft_rst)
      wr_abort <= #0.1 1'b1;
    else if (clr_wabort)
      wr_abort <= #0.1 1'b0;
  end
end

//always @ (posedge sysclk or negedge sysrstn) begin
//  if (~sysrstn)
//    rd_dlast <= `DLY 1'b0;
//  else begin
//    if (rd_abort&~rd_dlast&~rd_tqvld[0]&~rd_dqvld[0]&~rd_cqvld[0])
//      rd_dlast <= `DLY 1'b1;
//    else if (axis_rvalid&axis_rready&axis_rlast)
//      rd_dlast <= `DLY 1'b0;
//  end
//end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rd_abort <= #0.1 1'b0;
  else begin
    if (sft_rst)
      rd_abort <= #0.1 1'b1;
    else if (clr_rabort)
      rd_abort <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    sft_ack3 <= #0.1 1'b0;
  else begin
    if (srst_r&~wr_abort&~rd_abort)
      sft_ack3 <= #0.1 1'b1;
    else
      sft_ack3 <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    cpu_tx_req <= #0.1 1'b0;
  else begin
    if (set_treq)
      cpu_tx_req <= #0.1 1'b1;
    else if (tx_cpu_ack|sft_rst)
      cpu_tx_req <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    cpu_tx_info <= #0.1 67'h0;
  else begin
    if (set_treq) begin
      if (cpu_arb_ns[0])
        cpu_tx_info <= #0.1 {1'b1, wr_tx_info[65:0]};
      else
        cpu_tx_info <= #0.1 {1'b0, 8'h0, rd_tx_info[57:0]};
    end
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    cpu_arb_cs <= #0.1 WR_IDLE;
  else begin
    cpu_arb_cs <= #0.1 cpu_arb_ns;
  end
end

always @ (*) begin
  cpu_arb_ns = cpu_arb_cs;
  case (cpu_arb_cs)
    RD_IDLE: begin
      if (wr_tx_req&~sft_rst)
        cpu_arb_ns = WR_BUSY;
      else if (rd_tx_req&~sft_rst)
        cpu_arb_ns = RD_BUSY;
    end
    RD_BUSY: begin
      if (tx_cpu_ack&wr_tx_req&~sft_rst)
        cpu_arb_ns = WR_BUSY;
      else if (tx_cpu_ack|sft_rst)
        cpu_arb_ns = RD_IDLE;
    end
    WR_IDLE: begin
      if (rd_tx_req&~sft_rst)
        cpu_arb_ns = RD_BUSY;
      else if (wr_tx_req&~sft_rst)
        cpu_arb_ns = WR_BUSY;
    end
    WR_BUSY: begin
      if (tx_cpu_ack&rd_tx_req&~sft_rst)
        cpu_arb_ns = RD_BUSY;
      else if (tx_cpu_ack|sft_rst)
        cpu_arb_ns = WR_IDLE;
    end
    default: cpu_arb_ns = WR_IDLE;
  endcase
end

//******************************************************************************
assign pop_wrcq  = wr_cqvld[0]&wr_dqvld[0]&~wr_tx_req&(~wr_bqvld[7]|(wr_bqvld[7]&push_wrbq));
assign push_wdq  = axis_wvalid&axis_wready&axis_wlast;
assign pop_wrdq  = tx_cpu_ack & cpu_tx_info[66];
assign push_wrbq = (rx_cpu_req1|(wr_abort&wr_bqvld[0])) & cpu_rx_acp1;
assign wr_cqinfo = {axis_awid[8], axis_awsize, axis_awprot, axis_awlock, axis_awburst, axis_awlen[3:0],
                    axis_awcache, axis_awid[7:0], axis_awaddr[31:0]};
//assign wr_data   = stest_en ? stest_wdata : wmem_rdata;
assign wr_data   = wmem_rdata;
assign cpu_clast = pop_txdq;

assign wsram_full  = (wsram_wptr[6]^wmem_raddr[6])&(wsram_wptr[5:0]==wmem_raddr[5:0]);
assign axis_wready = axis_wready_s & ~wsram_full;

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    axis_awready <= #0.1 1'b1;
  else begin
    if ((axis_awvalid&axis_awready&wr_cqvld[2]&~pop_wrcq)|stest_en|clr_wabort)
      axis_awready <= #0.1 1'b0;
    else if ((wr_cqvld[3]&pop_wrcq)|sft_set)
      axis_awready <= #0.1 1'b1;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wr_cqvld <= #0.1 4'h0;
  else begin
    case ({(axis_awvalid&axis_awready), pop_wrcq})
      2'b01  : wr_cqvld <= #0.1 {1'b0, wr_cqvld[3:1]};
      2'b10  : wr_cqvld <= #0.1 {wr_cqvld[2:0], 1'b1};
      default:;
    endcase
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn) begin
    wr_cqbuf0 <= #0.1 59'h0;
    wr_cqbuf1 <= #0.1 59'h0;
    wr_cqbuf2 <= #0.1 59'h0;
    wr_cqbuf3 <= #0.1 59'h0;
  end else begin
    if (axis_awvalid&axis_awready) begin
      casez (wr_cqvld)
        4'b0000: wr_cqbuf0 <= #0.1 wr_cqinfo;
        4'b0001: begin
          if (pop_wrcq)
            wr_cqbuf0 <= #0.1 wr_cqinfo;
          else
            wr_cqbuf1 <= #0.1 wr_cqinfo;
        end
        4'b001?: begin
          if (pop_wrcq) begin
            wr_cqbuf0 <= #0.1 wr_cqbuf1;
            wr_cqbuf1 <= #0.1 wr_cqinfo;
          end else
            wr_cqbuf2 <= #0.1 wr_cqinfo;
        end
        4'b01??: begin
          if (pop_wrcq) begin
            wr_cqbuf0 <= #0.1 wr_cqbuf1;
            wr_cqbuf1 <= #0.1 wr_cqbuf2;
            wr_cqbuf2 <= #0.1 wr_cqinfo;
          end else
            wr_cqbuf3 <= #0.1 wr_cqinfo;
        end
        4'b1???: begin
          if (pop_wrcq) begin
            wr_cqbuf0 <= #0.1 wr_cqbuf1;
            wr_cqbuf1 <= #0.1 wr_cqbuf2;
            wr_cqbuf2 <= #0.1 wr_cqbuf3;
            wr_cqbuf3 <= #0.1 wr_cqinfo;
          end
        end
        default:;
      endcase
    end else if (pop_wrcq) begin
      wr_cqbuf0 <= #0.1 wr_cqbuf1;
      wr_cqbuf1 <= #0.1 wr_cqbuf2;
      wr_cqbuf2 <= #0.1 wr_cqbuf3;
    end
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wr_tx_req <= #0.1 1'b0;
  else begin
    //if ((pop_wrcq|wr_reg_en)&~wr_abort_w)
    if (pop_wrcq&~wr_abort_w)
      wr_tx_req <= #0.1 1'b1;
    else if (tx_wr_ack|sft_rst)
      wr_tx_req <= #0.1 1'b0;
  end
end

assign wr_len = wr_dlen[6:0] + (wr_dlen[6:3] + 4'hb); // 9 + 1(byte) + 1(byte_en)
always @ (*) begin
  case (wr_cqbuf0[57:55])
    3'b011 : wr_dlen = {wr_cqbuf0[47:44], 3'b111};
    3'b010 : wr_dlen = {1'b0,  wr_cqbuf0[47:44], 2'b11};
    3'b001 : wr_dlen = {2'b00, wr_cqbuf0[47:44], 1'b1};
    default: wr_dlen = {3'b00, wr_cqbuf0[47:44]};
  endcase
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wr_tx_info <= #0.1 60'h0;
  else begin
    if (pop_wrcq)
      wr_tx_info <= #0.1 {wr_len[7:0], wr_cqbuf0[57:0]};
    //else if (wr_reg_en)
    //  wr_tx_info <= `DLY {8'd8, 4'hA, 6'h0, 1'b1, 3'b010, 4'h0, 2'h0, 6'h2A, stest_addr};
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wr_dqvld <= #0.1 4'h0;
  else begin
    case ({push_wdq, pop_wrcq})
      2'b01  : wr_dqvld <= #0.1 {1'b0, wr_dqvld[3:1]};
      2'b10  : wr_dqvld <= #0.1 {wr_dqvld[2:0], 1'b1};
      default:;
    endcase
  end
end

assign pop_wrsq  = wr_sqvld[0]&~axis_wready_s&~wr_dqvld1[3];
assign wr_sqinfo = {axis_awsize[1:0], axis_awaddr[2:0]};
always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wr_sqvld <= #0.1 4'h0;
  else begin
    case ({(axis_awvalid&axis_awready), pop_wrsq})
      2'b01  : wr_sqvld <= #0.1 {1'b0, wr_sqvld[3:1]};
      2'b10  : wr_sqvld <= #0.1 {wr_sqvld[2:0], 1'b1};
      default:;
    endcase
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wr_sqbuf <= #0.1 20'h0;
  else begin
    if (axis_awvalid&axis_awready) begin
      casez (wr_sqvld)
        4'b0000: wr_sqbuf[4:0] <= #0.1 wr_sqinfo;
        4'b0001: wr_sqbuf <= #0.1 pop_wrsq ? {wr_sqbuf[19:5],  wr_sqinfo} : {wr_sqbuf[19:10], wr_sqinfo, wr_sqbuf[4:0]};
        4'b001?: wr_sqbuf <= #0.1 pop_wrsq ? {wr_sqbuf[19:10], wr_sqinfo, wr_sqbuf[9:5]}  : {wr_sqbuf[19:15], wr_sqinfo, wr_sqbuf[9:0]};
        4'b01??: wr_sqbuf <= #0.1 pop_wrsq ? {wr_sqbuf[19:15], wr_sqinfo, wr_sqbuf[14:5]} : {wr_sqinfo, wr_sqbuf[14:0]};
        4'b1???: wr_sqbuf <= #0.1 pop_wrsq ? {wr_sqinfo, wr_sqbuf[19:5]} : wr_sqbuf;
        default:;   // no change
      endcase
    end else if (pop_wrsq)
      wr_sqbuf <= #0.1 {5'h0, wr_sqbuf[19:5]};
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wr_size <= #0.1 2'h0;
  else begin
    if (pop_wrsq)
      wr_size <= #0.1 wr_sqbuf[4:3];
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wr_adr_sel <= #0.1 4'h0;
  else begin
    if (pop_wrsq)
      wr_adr_sel <= #0.1 {1'b0, wr_sqbuf[2:0]};
    else if (axis_wvalid&axis_wready) begin
      case (wr_size[1:0])
        2'b00  : wr_adr_sel <= #0.1 wr_adr_sel[2:0] + 1'b1;
        2'b01  : wr_adr_sel <= #0.1 wr_adr_sel[2:0] + 2'h2;
        2'b10  : wr_adr_sel <= #0.1 wr_adr_sel[2:0] + 3'h4;
        default:;   // no-change
      endcase
    end
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    axis_wready_s <= #0.1 1'b0;
  else begin
    if (pop_wrsq)
      axis_wready_s <= #0.1 1'b1;
    else if (push_wdq)
      axis_wready_s <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wr_cnt <= #0.1 4'h0;
  else begin
    if (axis_wvalid&axis_wready&axis_wlast)
      wr_cnt <= #0.1 4'h0;
    else if (axis_wvalid&axis_wready&(wr_size[1:0]!=2'b11))
      wr_cnt <= #0.1 wr_cnt[2:0] + 1'b1;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wbe_cnt <= #0.1 5'h0;
  else begin
    if (axis_wvalid&axis_wready&wr_2w_vld) begin
      if (axis_wlast)
        wbe_cnt <= #0.1 5'h0;
      else
        wbe_cnt <= #0.1 wbe_cnt[3:0] + 1'b1;
    end
  end
end

always @ (*) begin
  case (wr_adr_sel[2:1])
    2'h3   : wbe_sel = axis_wstrb[7:6];
    2'h2   : wbe_sel = axis_wstrb[5:4];
    2'h1   : wbe_sel = axis_wstrb[3:2];
    default: wbe_sel = axis_wstrb[1:0];
  endcase
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wbe_buf <= #0.1 128'h0;
  else begin
    if (axis_wvalid&axis_wready) begin
      case (wr_size[1:0])
        2'b11: begin
          case (wbe_cnt[3:0])
            4'h0   : wbe_buf[7:0]    <= #0.1 axis_wstrb[7:0];
            4'h1   : wbe_buf[15:8]   <= #0.1 axis_wstrb[7:0];
            4'h2   : wbe_buf[23:16]  <= #0.1 axis_wstrb[7:0];
            4'h3   : wbe_buf[31:24]  <= #0.1 axis_wstrb[7:0];
            4'h4   : wbe_buf[39:32]  <= #0.1 axis_wstrb[7:0];
            4'h5   : wbe_buf[47:40]  <= #0.1 axis_wstrb[7:0];
            4'h6   : wbe_buf[55:48]  <= #0.1 axis_wstrb[7:0];
            4'h7   : wbe_buf[63:56]  <= #0.1 axis_wstrb[7:0];
            4'h8   : wbe_buf[71:64]  <= #0.1 axis_wstrb[7:0];
            4'h9   : wbe_buf[79:72]  <= #0.1 axis_wstrb[7:0];
            4'hA   : wbe_buf[87:80]  <= #0.1 axis_wstrb[7:0];
            4'hB   : wbe_buf[95:88]  <= #0.1 axis_wstrb[7:0];
            4'hC   : wbe_buf[103:96] <= #0.1 axis_wstrb[7:0];
            4'hD   : wbe_buf[111:104] <= #0.1 axis_wstrb[7:0];
            4'hE   : wbe_buf[119:112] <= #0.1 axis_wstrb[7:0];
            default:;   // no change
          endcase
        end
        2'b10: begin
          case ({wbe_cnt[3:0], wr_cnt[0]})
            5'b0000_0: wbe_buf[3:0]   <= #0.1 wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0];
            5'b0000_1: wbe_buf[7:4]   <= #0.1 wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0];
            5'b0001_0: wbe_buf[11:8]  <= #0.1 wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0];
            5'b0001_1: wbe_buf[15:12] <= #0.1 wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0];
            5'b0010_0: wbe_buf[19:16] <= #0.1 wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0];
            5'b0010_1: wbe_buf[23:20] <= #0.1 wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0];
            5'b0011_0: wbe_buf[27:24] <= #0.1 wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0];
            5'b0011_1: wbe_buf[31:28] <= #0.1 wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0];
            5'b0100_0: wbe_buf[35:32] <= #0.1 wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0];
            5'b0100_1: wbe_buf[39:36] <= #0.1 wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0];
            5'b0101_0: wbe_buf[43:40] <= #0.1 wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0];
            5'b0101_1: wbe_buf[47:44] <= #0.1 wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0];
            5'b0110_0: wbe_buf[51:48] <= #0.1 wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0];
            5'b0110_1: wbe_buf[55:52] <= #0.1 wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0];
            5'b0111_0: wbe_buf[59:56] <= #0.1 wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0];
            //5'b1000_0: wbe_buf[63:60] <= `DLY wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0];
            //5'b1000_1: wbe_buf[67:64] <= `DLY wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0];
            //5'b1001_0: wbe_buf[71:68] <= `DLY wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0];
            //5'b1001_1: wbe_buf[75:72] <= `DLY wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0];
            //5'b1010_0: wbe_buf[79:76] <= `DLY wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0];
            //5'b1010_1: wbe_buf[83:80] <= `DLY wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0];
            //5'b1011_0: wbe_buf[87:84] <= `DLY wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0];
            //5'b1011_1: wbe_buf[91:88] <= `DLY wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0];
            //5'b1100_0: wbe_buf[35:92] <= `DLY wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0];
            //5'b1100_1: wbe_buf[99:96] <= `DLY wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0];
            //5'b1101_0: wbe_buf[103:100] <= `DLY wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0];
            //5'b1101_1: wbe_buf[107:104] <= `DLY wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0];
            //5'b1110_0: wbe_buf[111:108] <= `DLY wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0];
            //5'b1110_1: wbe_buf[115:112] <= `DLY wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0];
            //5'b1111_0: wbe_buf[119:116] <= `DLY wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0];
            default : ; // no change
          endcase
        end
        2'b01: begin
          case ({wbe_cnt[3:0], wr_cnt[1:0]})
            6'b0000_00: wbe_buf[1:0]   <= #0.1 wbe_sel;
            6'b0000_01: wbe_buf[3:2]   <= #0.1 wbe_sel;
            6'b0000_10: wbe_buf[5:4]   <= #0.1 wbe_sel;
            6'b0000_11: wbe_buf[7:6]   <= #0.1 wbe_sel;
            6'b0001_00: wbe_buf[9:8]   <= #0.1 wbe_sel;
            6'b0001_01: wbe_buf[11:10] <= #0.1 wbe_sel;
            6'b0001_10: wbe_buf[13:12] <= #0.1 wbe_sel;
            6'b0001_11: wbe_buf[15:14] <= #0.1 wbe_sel;
            6'b0010_00: wbe_buf[17:16] <= #0.1 wbe_sel;
            6'b0010_01: wbe_buf[19:18] <= #0.1 wbe_sel;
            6'b0010_10: wbe_buf[21:20] <= #0.1 wbe_sel;
            6'b0010_11: wbe_buf[23:22] <= #0.1 wbe_sel;
            6'b0011_00: wbe_buf[25:24] <= #0.1 wbe_sel;
            6'b0011_01: wbe_buf[27:26] <= #0.1 wbe_sel;
            6'b0011_10: wbe_buf[29:28] <= #0.1 wbe_sel;
            6'b0011_11: wbe_buf[31:30] <= #0.1 wbe_sel;
            //6'b0100_00: wbe_buf[33:32] <= `DLY wbe_sel;
            //6'b0100_01: wbe_buf[35:34] <= `DLY wbe_sel;
            //6'b0100_10: wbe_buf[37:36] <= `DLY wbe_sel;
            //6'b0100_11: wbe_buf[39:38] <= `DLY wbe_sel;
            //6'b0101_00: wbe_buf[41:40] <= `DLY wbe_sel;
            //6'b0101_01: wbe_buf[43:42] <= `DLY wbe_sel;
            //6'b0101_10: wbe_buf[45:44] <= `DLY wbe_sel;
            //6'b0101_11: wbe_buf[47:46] <= `DLY wbe_sel;
            //6'b0110_00: wbe_buf[49:48] <= `DLY wbe_sel;
            //6'b0110_01: wbe_buf[51:50] <= `DLY wbe_sel;
            //6'b0110_10: wbe_buf[53:52] <= `DLY wbe_sel;
            //6'b0110_11: wbe_buf[55:54] <= `DLY wbe_sel;
            //6'b0111_00: wbe_buf[57:56] <= `DLY wbe_sel;
            //6'b0111_01: wbe_buf[59:58] <= `DLY wbe_sel;
            //6'b0111_10: wbe_buf[61:60] <= `DLY wbe_sel;
            //6'b1000_00: wbe_buf[63:62] <= `DLY wbe_sel;
            //6'b1000_01: wbe_buf[65:64] <= `DLY wbe_sel;
            //6'b1000_10: wbe_buf[67:66] <= `DLY wbe_sel;
            //6'b1000_11: wbe_buf[69:68] <= `DLY wbe_sel;
            //6'b1001_00: wbe_buf[71:70] <= `DLY wbe_sel;
            //6'b1001_01: wbe_buf[73:72] <= `DLY wbe_sel;
            //6'b1001_10: wbe_buf[75:74] <= `DLY wbe_sel;
            //6'b1001_11: wbe_buf[77:76] <= `DLY wbe_sel;
            //6'b1010_00: wbe_buf[79:78] <= `DLY wbe_sel;
            //6'b1010_01: wbe_buf[81:80] <= `DLY wbe_sel;
            //6'b1010_10: wbe_buf[83:82] <= `DLY wbe_sel;
            //6'b1010_11: wbe_buf[85:84] <= `DLY wbe_sel;
            //6'b1011_00: wbe_buf[87:86] <= `DLY wbe_sel;
            //6'b1011_01: wbe_buf[89:88] <= `DLY wbe_sel;
            //6'b1011_10: wbe_buf[91:90] <= `DLY wbe_sel;
            //6'b1011_11: wbe_buf[93:92] <= `DLY wbe_sel;
            //6'b1100_00: wbe_buf[95:94] <= `DLY wbe_sel;
            //6'b1100_01: wbe_buf[97:96] <= `DLY wbe_sel;
            //6'b1100_10: wbe_buf[99:98] <= `DLY wbe_sel;
            //6'b1100_11: wbe_buf[101:100] <= `DLY wbe_sel;
            //6'b1101_00: wbe_buf[103:102] <= `DLY wbe_sel;
            //6'b1101_01: wbe_buf[105:104] <= `DLY wbe_sel;
            //6'b1101_10: wbe_buf[107:106] <= `DLY wbe_sel;
            //6'b1101_11: wbe_buf[109:108] <= `DLY wbe_sel;
            //6'b1110_00: wbe_buf[111:110] <= `DLY wbe_sel;
            //6'b1110_01: wbe_buf[113:112] <= `DLY wbe_sel;
            //6'b1110_10: wbe_buf[115:114] <= `DLY wbe_sel;
            //6'b1110_11: wbe_buf[117:116] <= `DLY wbe_sel;
            //6'b1111_00: wbe_buf[119:118] <= `DLY wbe_sel;
            //6'b1111_01: wbe_buf[121:120] <= `DLY wbe_sel;
            //6'b1111_10: wbe_buf[123:122] <= `DLY wbe_sel;
            default  : ;
          endcase
        end
        default: begin  // 2'b00
          wbe_buf[{wbe_cnt[0], wr_cnt[2:0]}] <= #0.1 axis_wstrb[wr_adr_sel[2:0]];
        end
      endcase
    end
  end
end

always @ (*) begin
  wbe_info[131:128] = wbe_cnt[3:0];
  case (wr_size[1:0])
    2'b11: begin
      case (wbe_cnt[3:0])
        4'h0   : wbe_info[127:0] = {120'h0, axis_wstrb[7:0]};
        4'h1   : wbe_info[127:0] = {112'h0, axis_wstrb[7:0], wbe_buf[7:0]};
        4'h2   : wbe_info[127:0] = {104'h0, axis_wstrb[7:0], wbe_buf[15:0]};
        4'h3   : wbe_info[127:0] = {96'h0,  axis_wstrb[7:0], wbe_buf[23:0]};
        4'h4   : wbe_info[127:0] = {88'h0,  axis_wstrb[7:0], wbe_buf[31:0]};
        4'h5   : wbe_info[127:0] = {80'h0,  axis_wstrb[7:0], wbe_buf[39:0]};
        4'h6   : wbe_info[127:0] = {72'h0,  axis_wstrb[7:0], wbe_buf[47:0]};
        4'h7   : wbe_info[127:0] = {64'h0,  axis_wstrb[7:0], wbe_buf[55:0]};
        4'h8   : wbe_info[127:0] = {56'h0,  axis_wstrb[7:0], wbe_buf[63:0]};
        4'h9   : wbe_info[127:0] = {48'h0,  axis_wstrb[7:0], wbe_buf[71:0]};
        4'hA   : wbe_info[127:0] = {40'h0,  axis_wstrb[7:0], wbe_buf[79:0]};
        4'hB   : wbe_info[127:0] = {32'h0,  axis_wstrb[7:0], wbe_buf[87:0]};
        4'hC   : wbe_info[127:0] = {24'h0,  axis_wstrb[7:0], wbe_buf[95:0]};
        4'hD   : wbe_info[127:0] = {16'h0,  axis_wstrb[7:0], wbe_buf[103:0]};
        4'hE   : wbe_info[127:0] = {8'h0,   axis_wstrb[7:0], wbe_buf[111:0]};
        default: wbe_info[127:0] = {        axis_wstrb[7:0], wbe_buf[119:0]};
      endcase
    end
    2'b10: begin
      case ({wbe_cnt[3:0], wr_cnt[0]})
        5'b0000_0: wbe_info[127:0] = {124'h0, (wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0])};
        5'b0000_1: wbe_info[127:0] = {120'h0, (wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0]), wbe_buf[3:0]};
        5'b0001_0: wbe_info[127:0] = {116'h0, (wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0]), wbe_buf[7:0]};
        5'b0001_1: wbe_info[127:0] = {112'h0, (wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0]), wbe_buf[11:0]};
        5'b0010_0: wbe_info[127:0] = {108'h0, (wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0]), wbe_buf[15:0]};
        5'b0010_1: wbe_info[127:0] = {104'h0, (wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0]), wbe_buf[19:0]};
        5'b0011_0: wbe_info[127:0] = {100'h0, (wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0]), wbe_buf[23:0]};
        5'b0011_1: wbe_info[127:0] = {96'h0,  (wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0]), wbe_buf[27:0]};
        5'b0100_0: wbe_info[127:0] = {92'h0,  (wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0]), wbe_buf[31:0]};
        5'b0100_1: wbe_info[127:0] = {88'h0,  (wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0]), wbe_buf[35:0]};
        5'b0101_0: wbe_info[127:0] = {84'h0,  (wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0]), wbe_buf[39:0]};
        5'b0101_1: wbe_info[127:0] = {80'h0,  (wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0]), wbe_buf[43:0]};
        5'b0110_0: wbe_info[127:0] = {76'h0,  (wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0]), wbe_buf[47:0]};
        5'b0110_1: wbe_info[127:0] = {72'h0,  (wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0]), wbe_buf[51:0]};
        5'b0111_0: wbe_info[127:0] = {68'h0,  (wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0]), wbe_buf[55:0]};
        default : wbe_info[127:0] = {64'h0,  (wr_adr_sel[2] ? axis_wstrb[7:4] : axis_wstrb[3:0]), wbe_buf[59:0]};
      endcase
    end
    2'b01: begin
      case ({wbe_cnt[3:0], wr_cnt[1:0]})
        6'b0000_00: wbe_info[127:0] = {126'h0, wbe_sel};
        6'b0000_01: wbe_info[127:0] = {124'h0, wbe_sel, wbe_buf[1:0]};
        6'b0000_10: wbe_info[127:0] = {122'h0, wbe_sel, wbe_buf[3:0]};
        6'b0000_11: wbe_info[127:0] = {120'h0, wbe_sel, wbe_buf[5:0]};
        6'b0001_00: wbe_info[127:0] = {118'h0, wbe_sel, wbe_buf[7:0]};
        6'b0001_01: wbe_info[127:0] = {116'h0, wbe_sel, wbe_buf[9:0]};
        6'b0001_10: wbe_info[127:0] = {114'h0, wbe_sel, wbe_buf[11:0]};
        6'b0001_11: wbe_info[127:0] = {112'h0, wbe_sel, wbe_buf[13:0]};
        6'b0010_00: wbe_info[127:0] = {110'h0, wbe_sel, wbe_buf[15:0]};
        6'b0010_01: wbe_info[127:0] = {108'h0, wbe_sel, wbe_buf[17:0]};
        6'b0010_10: wbe_info[127:0] = {106'h0, wbe_sel, wbe_buf[19:0]};
        6'b0010_11: wbe_info[127:0] = {104'h0, wbe_sel, wbe_buf[21:0]};
        6'b0011_00: wbe_info[127:0] = {102'h0, wbe_sel, wbe_buf[23:0]};
        6'b0011_01: wbe_info[127:0] = {100'h0, wbe_sel, wbe_buf[25:0]};
        6'b0011_10: wbe_info[127:0] = {98'h0,  wbe_sel, wbe_buf[27:0]};
        //5'b011_11: wbe_info[127:0] = {32'h0, wbe_sel, wbe_buf[29:0]};
        //5'b100_00: wbe_info[127:0] = {30'h0, wbe_sel, wbe_buf[31:0]};
        //5'b100_01: wbe_info[127:0] = {28'h0, wbe_sel, wbe_buf[33:0]};
        //5'b100_10: wbe_info[127:0] = {26'h0, wbe_sel, wbe_buf[35:0]};
        //5'b100_11: wbe_info[127:0] = {24'h0, wbe_sel, wbe_buf[37:0]};
        //5'b101_00: wbe_info[127:0] = {22'h0, wbe_sel, wbe_buf[39:0]};
        //5'b101_01: wbe_info[127:0] = {20'h0, wbe_sel, wbe_buf[41:0]};
        //5'b101_10: wbe_info[127:0] = {18'h0, wbe_sel, wbe_buf[43:0]};
        //5'b101_11: wbe_info[127:0] = {16'h0, wbe_sel, wbe_buf[45:0]};
        //5'b110_00: wbe_info[127:0] = {14'h0, wbe_sel, wbe_buf[47:0]};
        //5'b110_01: wbe_info[127:0] = {12'h0, wbe_sel, wbe_buf[49:0]};
        //5'b110_10: wbe_info[127:0] = {10'h0, wbe_sel, wbe_buf[51:0]};
        //5'b110_11: wbe_info[127:0] = {8'h0,  wbe_sel, wbe_buf[53:0]};
        //5'b111_00: wbe_info[127:0] = {6'h0,  wbe_sel, wbe_buf[55:0]};
        //5'b111_01: wbe_info[127:0] = {4'h0,  wbe_sel, wbe_buf[57:0]};
        //5'b111_10: wbe_info[127:0] = {2'h0,  wbe_sel, wbe_buf[59:0]};
        default  : wbe_info[127:0] = {96'h0, wbe_sel, wbe_buf[29:0]};
        //default  : wbe_info[127:0] = {       wbe_sel, wbe_buf[61:0]};
      endcase
    end
    default: begin
      case ({wbe_cnt[3:0], wr_cnt[2:0]})
        7'h00  : wbe_info[127:0] = {127'h0, axis_wstrb[wr_adr_sel[2:0]]};
        7'h01  : wbe_info[127:0] = {126'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[0]};
        7'h02  : wbe_info[127:0] = {125'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[1:0]};
        7'h03  : wbe_info[127:0] = {124'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[2:0]};
        7'h04  : wbe_info[127:0] = {123'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[3:0]};
        7'h05  : wbe_info[127:0] = {122'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[4:0]};
        7'h06  : wbe_info[127:0] = {121'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[5:0]};
        7'h07  : wbe_info[127:0] = {120'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[6:0]};
        7'h08  : wbe_info[127:0] = {119'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[7:0]};
        7'h09  : wbe_info[127:0] = {118'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[8:0]};
        7'h0A  : wbe_info[127:0] = {117'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[9:0]};
        7'h0B  : wbe_info[127:0] = {116'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[10:0]};
        7'h0C  : wbe_info[127:0] = {115'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[11:0]};
        7'h0D  : wbe_info[127:0] = {114'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[12:0]};
        7'h0E  : wbe_info[127:0] = {113'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[13:0]};
        default: wbe_info[127:0] = {112'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[14:0]};
        //6'h10  : wbe_info[127:0] = {47'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[15:0]};
        //6'h11  : wbe_info[127:0] = {46'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[16:0]};
        //6'h12  : wbe_info[127:0] = {45'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[17:0]};
        //6'h13  : wbe_info[127:0] = {44'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[18:0]};
        //6'h14  : wbe_info[127:0] = {43'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[19:0]};
        //6'h15  : wbe_info[127:0] = {42'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[20:0]};
        //6'h16  : wbe_info[127:0] = {41'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[21:0]};
        //6'h17  : wbe_info[127:0] = {40'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[22:0]};
        //6'h18  : wbe_info[127:0] = {39'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[23:0]};
        //6'h19  : wbe_info[127:0] = {38'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[24:0]};
        //6'h1A  : wbe_info[127:0] = {37'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[25:0]};
        //6'h1B  : wbe_info[127:0] = {36'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[26:0]};
        //6'h1C  : wbe_info[127:0] = {35'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[27:0]};
        //6'h1D  : wbe_info[127:0] = {34'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[28:0]};
        //6'h1E  : wbe_info[127:0] = {33'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[29:0]};
        //6'h1F  : wbe_info[127:0] = {32'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[30:0]};
        //6'h20  : wbe_info[127:0] = {31'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[31:0]};
        //6'h21  : wbe_info[127:0] = {30'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[32:0]};
        //6'h22  : wbe_info[127:0] = {29'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[33:0]};
        //6'h23  : wbe_info[127:0] = {28'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[34:0]};
        //6'h24  : wbe_info[127:0] = {27'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[35:0]};
        //6'h25  : wbe_info[127:0] = {26'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[36:0]};
        //6'h26  : wbe_info[127:0] = {25'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[37:0]};
        //6'h27  : wbe_info[127:0] = {24'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[38:0]};
        //6'h28  : wbe_info[127:0] = {23'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[39:0]};
        //6'h29  : wbe_info[127:0] = {22'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[40:0]};
        //6'h2A  : wbe_info[127:0] = {21'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[41:0]};
        //6'h2B  : wbe_info[127:0] = {20'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[42:0]};
        //6'h2C  : wbe_info[127:0] = {19'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[43:0]};
        //6'h2D  : wbe_info[127:0] = {18'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[44:0]};
        //6'h2E  : wbe_info[127:0] = {17'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[45:0]};
        //6'h2F  : wbe_info[127:0] = {16'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[46:0]};
        //6'h30  : wbe_info[127:0] = {15'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[47:0]};
        //6'h31  : wbe_info[127:0] = {14'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[48:0]};
        //6'h32  : wbe_info[127:0] = {13'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[49:0]};
        //6'h33  : wbe_info[127:0] = {12'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[50:0]};
        //6'h34  : wbe_info[127:0] = {11'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[51:0]};
        //6'h35  : wbe_info[127:0] = {10'h0, axis_wstrb[wr_adr_sel[2:0]], wbe_buf[52:0]};
        //6'h36  : wbe_info[127:0] = {9'h0,  axis_wstrb[wr_adr_sel[2:0]], wbe_buf[53:0]};
        //6'h37  : wbe_info[127:0] = {8'h0,  axis_wstrb[wr_adr_sel[2:0]], wbe_buf[54:0]};
        //6'h38  : wbe_info[127:0] = {7'h0,  axis_wstrb[wr_adr_sel[2:0]], wbe_buf[55:0]};
        //6'h39  : wbe_info[127:0] = {6'h0,  axis_wstrb[wr_adr_sel[2:0]], wbe_buf[56:0]};
        //6'h3A  : wbe_info[127:0] = {5'h0,  axis_wstrb[wr_adr_sel[2:0]], wbe_buf[57:0]};
        //6'h3B  : wbe_info[127:0] = {4'h0,  axis_wstrb[wr_adr_sel[2:0]], wbe_buf[58:0]};
        //6'h3C  : wbe_info[127:0] = {3'h0,  axis_wstrb[wr_adr_sel[2:0]], wbe_buf[59:0]};
        //6'h3D  : wbe_info[127:0] = {2'h0,  axis_wstrb[wr_adr_sel[2:0]], wbe_buf[60:0]};
        //6'h3E  : wbe_info[127:0] = {1'b0,  axis_wstrb[wr_adr_sel[2:0]], wbe_buf[61:0]};
        //default: wbe_info[127:0] = {       axis_wstrb[wr_adr_sel[2:0]], wbe_buf[62:0]};
      endcase
    end
  endcase
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wr_dqvld1 <= #0.1 5'h0;
  else begin
    if (sft_ack3)
      wr_dqvld1 <= #0.1 5'h0;
    else begin
      case ({push_wdq, pop_wrdq})
        2'b01  : wr_dqvld1 <= #0.1 {1'b0, wr_dqvld1[4:1]};
        2'b10  : wr_dqvld1 <= #0.1 {wr_dqvld1[3:0], 1'b1};
        default:;
      endcase
    end
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn) begin
    wr_dqbuf0 <= #0.1 132'h0;
    wr_dqbuf1 <= #0.1 132'h0;
    wr_dqbuf2 <= #0.1 132'h0;
    wr_dqbuf3 <= #0.1 132'h0;
    wr_dqbuf4 <= #0.1 132'h0;
  end else begin
    if (push_wdq) begin
      casez (wr_dqvld1)
        5'b00000: wr_dqbuf0 <= #0.1 wbe_info;
        5'b00001: begin
          if (pop_wrdq)
            wr_dqbuf0 <= #0.1 wbe_info;
          else
            wr_dqbuf1 <= #0.1 wbe_info;
        end
        5'b0001?: begin
          if (pop_wrdq) begin
            wr_dqbuf0 <= #0.1 wr_dqbuf1;
            wr_dqbuf1 <= #0.1 wbe_info;
          end else
            wr_dqbuf2 <= #0.1 wbe_info;
        end
        5'b001??: begin
          if (pop_wrdq) begin
            wr_dqbuf0 <= #0.1 wr_dqbuf1;
            wr_dqbuf1 <= #0.1 wr_dqbuf2;
            wr_dqbuf2 <= #0.1 wbe_info;
          end else
            wr_dqbuf3 <= #0.1 wbe_info;
        end
        5'b01???: begin
          if (pop_wrdq) begin
            wr_dqbuf0 <= #0.1 wr_dqbuf1;
            wr_dqbuf1 <= #0.1 wr_dqbuf2;
            wr_dqbuf2 <= #0.1 wr_dqbuf3;
            wr_dqbuf3 <= #0.1 wbe_info;
          end else
            wr_dqbuf4 <= #0.1 wbe_info;
        end
        5'b1????: begin
          if (pop_wrdq) begin
            wr_dqbuf0 <= #0.1 wr_dqbuf1;
            wr_dqbuf1 <= #0.1 wr_dqbuf2;
            wr_dqbuf2 <= #0.1 wr_dqbuf3;
            wr_dqbuf3 <= #0.1 wr_dqbuf4;
            wr_dqbuf4 <= #0.1 wbe_info;
          end
        end
        default:;
      endcase
    end else if (pop_wrdq) begin
      wr_dqbuf0 <= #0.1 wr_dqbuf1;
      wr_dqbuf1 <= #0.1 wr_dqbuf2;
      wr_dqbuf2 <= #0.1 wr_dqbuf3;
      wr_dqbuf3 <= #0.1 wr_dqbuf4;
    end
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    cpu_wbe <= #0.1 132'h0;
  else begin
    if (pop_wrdq)
      cpu_wbe <= #0.1 wr_dqbuf0;
  end
end

assign pop_txdq = ~tx_cpu_ren & (txdq_buf[6:3]==4'h0) & txdq_vld[0];
always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    txdq_vld <= #0.1 4'h0;
  else begin
    if (sft_ack3)
      txdq_vld <= #0.1 4'h0;
    else begin
      case ({pop_wrcq, pop_txdq})
        2'b01  : txdq_vld <= #0.1 {1'b0, txdq_vld[3:1]};
        2'b10  : txdq_vld <= #0.1 {txdq_vld[2:0], 1'b1};
        default:; //
      endcase
    end
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    {temp0, txdq_buf} <= #0.1 29'h0;
  else begin
    if (pop_wrcq) begin
      casez (txdq_vld)
        4'b0000: txdq_buf[6:0] <= #0.1 wr_dlen[6:0];
        4'b0001: begin
          if (pop_txdq)
            txdq_buf[6:0] <= #0.1 wr_dlen[6:0];
          else if (~tx_cpu_ren) begin
            {temp0, txdq_buf[6:3]} <= #0.1 txdq_buf[6:3] - 1'b1;
            txdq_buf[13:7] <= #0.1 wr_dlen[6:0];
          end else
            txdq_buf[13:7] <= #0.1 wr_dlen[6:0];
        end
        4'b001?: begin
          if (pop_txdq)
            txdq_buf[13:0] <= #0.1 {wr_dlen[6:0], txdq_buf[13:7]};
          else if (~tx_cpu_ren) begin
            {temp0, txdq_buf[6:3]} <= #0.1 txdq_buf[6:3] - 1'b1;
            txdq_buf[20:14] <= #0.1 wr_dlen[6:0];
          end else
            txdq_buf[20:14] <= #0.1 wr_dlen[6:0];
        end
        4'b01??: begin
          if (pop_txdq)
            txdq_buf[20:0] <= #0.1 {wr_dlen[6:0], txdq_buf[20:7]};
          else if (~tx_cpu_ren) begin
            {temp0, txdq_buf[6:3]} <= #0.1 txdq_buf[6:3] - 1'b1;
            txdq_buf[27:21] <= #0.1 wr_dlen[6:0];
          end else
            txdq_buf[27:21] <= #0.1 wr_dlen[6:0];
        end
        4'b1???: begin
          if (pop_txdq)
            txdq_buf <= #0.1 {wr_dlen[6:0], txdq_buf[27:7]};
        end
        default:;   //
      endcase
    end else if (pop_txdq)
      txdq_buf[20:0] <= #0.1 txdq_buf[27:7];
    else if (~tx_cpu_ren) begin
      {temp0, txdq_buf[6:3]} <= #0.1 txdq_buf[6:3] - 1'b1;
    end
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    tx_dlast <= #0.1 4'h0;
  else begin
    if (pop_txdq)
      tx_dlast <= #0.1 {1'b1, txdq_buf[2:0]};
    else
      tx_dlast[3] <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    cpu_tlast <= #0.1 4'h0;
  else begin
    cpu_tlast <= #0.1 tx_dlast;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wr_bqvld <= #0.1 8'h0;
  else begin
    case ({pop_wrcq, push_wrbq})
      2'b01  : wr_bqvld <= #0.1 {1'b0, wr_bqvld[7:1]};
      2'b10  : wr_bqvld <= #0.1 {wr_bqvld[6:0], 1'b1};
      default:;
    endcase
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn) begin
    wr_bqbuf0 <= #0.1 9'h0;
    wr_bqbuf1 <= #0.1 9'h0;
    wr_bqbuf2 <= #0.1 9'h0;
    wr_bqbuf3 <= #0.1 9'h0;
    wr_bqbuf4 <= #0.1 9'h0;
    wr_bqbuf5 <= #0.1 9'h0;
    wr_bqbuf6 <= #0.1 9'h0;
    wr_bqbuf7 <= #0.1 9'h0;
  end else begin
    if (pop_wrcq) begin
      casez (wr_bqvld)
        8'b0000_0000: wr_bqbuf0 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
        8'b0000_0001: begin
          if (push_wrbq)
            wr_bqbuf0 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
          else
            wr_bqbuf1 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
        end
        8'b0000_001?: begin
          if (push_wrbq&((rx_cpu_info1[7:0]==wr_bqbuf0[7:0])|wr_abort)) begin
            wr_bqbuf0 <= #0.1 wr_bqbuf1;
            wr_bqbuf1 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
          end else if (push_wrbq)
            wr_bqbuf1 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
          else
            wr_bqbuf2 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
        end
        8'b0000_01??: begin
          if (push_wrbq&((rx_cpu_info1[7:0]==wr_bqbuf0[7:0])|wr_abort)) begin
            wr_bqbuf0 <= #0.1 wr_bqbuf1;
            wr_bqbuf1 <= #0.1 wr_bqbuf2;
            wr_bqbuf2 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
          end else if (push_wrbq&(rx_cpu_info1[7:0]==wr_bqbuf1[7:0])) begin
            wr_bqbuf1 <= #0.1 wr_bqbuf2;
            wr_bqbuf2 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
          end else if (push_wrbq)
            wr_bqbuf2 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
          else
            wr_bqbuf3 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
        end
        8'b0000_1???: begin
          if (push_wrbq&((rx_cpu_info1[7:0]==wr_bqbuf0[7:0])|wr_abort)) begin
            wr_bqbuf0 <= #0.1 wr_bqbuf1;
            wr_bqbuf1 <= #0.1 wr_bqbuf2;
            wr_bqbuf2 <= #0.1 wr_bqbuf3;
            wr_bqbuf3 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
          end else if (push_wrbq&(rx_cpu_info1[7:0]==wr_bqbuf1[7:0])) begin
            wr_bqbuf1 <= #0.1 wr_bqbuf2;
            wr_bqbuf2 <= #0.1 wr_bqbuf3;
            wr_bqbuf3 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
          end else if (push_wrbq&(rx_cpu_info1[7:0]==wr_bqbuf2[7:0])) begin
            wr_bqbuf2 <= #0.1 wr_bqbuf3;
            wr_bqbuf3 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
          end else if (push_wrbq)
            wr_bqbuf3 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
          else
            wr_bqbuf4 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
        end
        8'b0001_????: begin
          if (push_wrbq&((rx_cpu_info1[7:0]==wr_bqbuf0[7:0])|wr_abort)) begin
            wr_bqbuf0 <= #0.1 wr_bqbuf1;
            wr_bqbuf1 <= #0.1 wr_bqbuf2;
            wr_bqbuf2 <= #0.1 wr_bqbuf3;
            wr_bqbuf3 <= #0.1 wr_bqbuf4;
            wr_bqbuf4 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
          end else if (push_wrbq&(rx_cpu_info1[7:0]==wr_bqbuf1[7:0])) begin
            wr_bqbuf1 <= #0.1 wr_bqbuf2;
            wr_bqbuf2 <= #0.1 wr_bqbuf3;
            wr_bqbuf3 <= #0.1 wr_bqbuf4;
            wr_bqbuf4 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
          end else if (push_wrbq&(rx_cpu_info1[7:0]==wr_bqbuf2[7:0])) begin
            wr_bqbuf2 <= #0.1 wr_bqbuf3;
            wr_bqbuf3 <= #0.1 wr_bqbuf4;
            wr_bqbuf4 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
          end else if (push_wrbq&(rx_cpu_info1[7:0]==wr_bqbuf3[7:0])) begin
            wr_bqbuf3 <= #0.1 wr_bqbuf4;
            wr_bqbuf4 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
          end else if (push_wrbq)
            wr_bqbuf4 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
          else
            wr_bqbuf5 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
        end
        8'b001?_????: begin
          if (push_wrbq&((rx_cpu_info1[7:0]==wr_bqbuf0[7:0])|wr_abort)) begin
            wr_bqbuf0 <= #0.1 wr_bqbuf1;
            wr_bqbuf1 <= #0.1 wr_bqbuf2;
            wr_bqbuf2 <= #0.1 wr_bqbuf3;
            wr_bqbuf3 <= #0.1 wr_bqbuf4;
            wr_bqbuf4 <= #0.1 wr_bqbuf5;
            wr_bqbuf5 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
          end else if (push_wrbq&(rx_cpu_info1[7:0]==wr_bqbuf1[7:0])) begin
            wr_bqbuf1 <= #0.1 wr_bqbuf2;
            wr_bqbuf2 <= #0.1 wr_bqbuf3;
            wr_bqbuf3 <= #0.1 wr_bqbuf4;
            wr_bqbuf4 <= #0.1 wr_bqbuf5;
            wr_bqbuf5 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
          end else if (push_wrbq&(rx_cpu_info1[7:0]==wr_bqbuf2[7:0])) begin
            wr_bqbuf2 <= #0.1 wr_bqbuf3;
            wr_bqbuf3 <= #0.1 wr_bqbuf4;
            wr_bqbuf4 <= #0.1 wr_bqbuf5;
            wr_bqbuf5 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
          end else if (push_wrbq&(rx_cpu_info1[7:0]==wr_bqbuf3[7:0])) begin
            wr_bqbuf3 <= #0.1 wr_bqbuf4;
            wr_bqbuf4 <= #0.1 wr_bqbuf5;
            wr_bqbuf5 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
          end else if (push_wrbq&(rx_cpu_info1[7:0]==wr_bqbuf4[7:0])) begin
            wr_bqbuf4 <= #0.1 wr_bqbuf5;
            wr_bqbuf5 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
          end else if (push_wrbq)
            wr_bqbuf5 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
          else
            wr_bqbuf6 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
        end
        8'b01??_????: begin
          if (push_wrbq&((rx_cpu_info1[7:0]==wr_bqbuf0[7:0])|wr_abort)) begin
            wr_bqbuf0 <= #0.1 wr_bqbuf1;
            wr_bqbuf1 <= #0.1 wr_bqbuf2;
            wr_bqbuf2 <= #0.1 wr_bqbuf3;
            wr_bqbuf3 <= #0.1 wr_bqbuf4;
            wr_bqbuf4 <= #0.1 wr_bqbuf5;
            wr_bqbuf5 <= #0.1 wr_bqbuf6;
            wr_bqbuf6 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
          end else if (push_wrbq&(rx_cpu_info1[7:0]==wr_bqbuf1[7:0])) begin
            wr_bqbuf1 <= #0.1 wr_bqbuf2;
            wr_bqbuf2 <= #0.1 wr_bqbuf3;
            wr_bqbuf3 <= #0.1 wr_bqbuf4;
            wr_bqbuf4 <= #0.1 wr_bqbuf5;
            wr_bqbuf5 <= #0.1 wr_bqbuf6;
            wr_bqbuf6 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
          end else if (push_wrbq&(rx_cpu_info1[7:0]==wr_bqbuf2[7:0])) begin
            wr_bqbuf2 <= #0.1 wr_bqbuf3;
            wr_bqbuf3 <= #0.1 wr_bqbuf4;
            wr_bqbuf4 <= #0.1 wr_bqbuf5;
            wr_bqbuf5 <= #0.1 wr_bqbuf6;
            wr_bqbuf6 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
          end else if (push_wrbq&(rx_cpu_info1[7:0]==wr_bqbuf3[7:0])) begin
            wr_bqbuf3 <= #0.1 wr_bqbuf4;
            wr_bqbuf4 <= #0.1 wr_bqbuf5;
            wr_bqbuf5 <= #0.1 wr_bqbuf6;
            wr_bqbuf6 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
          end else if (push_wrbq&(rx_cpu_info1[7:0]==wr_bqbuf4[7:0])) begin
            wr_bqbuf4 <= #0.1 wr_bqbuf5;
            wr_bqbuf5 <= #0.1 wr_bqbuf6;
            wr_bqbuf6 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
          end else if (push_wrbq&(rx_cpu_info1[7:0]==wr_bqbuf5[7:0])) begin
            wr_bqbuf5 <= #0.1 wr_bqbuf6;
            wr_bqbuf6 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
          end else if (push_wrbq)
            wr_bqbuf6 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
          else
            wr_bqbuf7 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
        end
        8'b1???_????: begin
          if (push_wrbq&((rx_cpu_info1[7:0]==wr_bqbuf0[7:0])|wr_abort)) begin
            wr_bqbuf0 <= #0.1 wr_bqbuf1;
            wr_bqbuf1 <= #0.1 wr_bqbuf2;
            wr_bqbuf2 <= #0.1 wr_bqbuf3;
            wr_bqbuf3 <= #0.1 wr_bqbuf4;
            wr_bqbuf4 <= #0.1 wr_bqbuf5;
            wr_bqbuf5 <= #0.1 wr_bqbuf6;
            wr_bqbuf6 <= #0.1 wr_bqbuf7;
            wr_bqbuf7 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
          end else if (push_wrbq&(rx_cpu_info1[7:0]==wr_bqbuf1[7:0])) begin
            wr_bqbuf1 <= #0.1 wr_bqbuf2;
            wr_bqbuf2 <= #0.1 wr_bqbuf3;
            wr_bqbuf3 <= #0.1 wr_bqbuf4;
            wr_bqbuf4 <= #0.1 wr_bqbuf5;
            wr_bqbuf5 <= #0.1 wr_bqbuf6;
            wr_bqbuf6 <= #0.1 wr_bqbuf7;
            wr_bqbuf7 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
          end else if (push_wrbq&(rx_cpu_info1[7:0]==wr_bqbuf2[7:0])) begin
            wr_bqbuf2 <= #0.1 wr_bqbuf3;
            wr_bqbuf3 <= #0.1 wr_bqbuf4;
            wr_bqbuf4 <= #0.1 wr_bqbuf5;
            wr_bqbuf5 <= #0.1 wr_bqbuf6;
            wr_bqbuf6 <= #0.1 wr_bqbuf7;
            wr_bqbuf7 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
          end else if (push_wrbq&(rx_cpu_info1[7:0]==wr_bqbuf3[7:0])) begin
            wr_bqbuf3 <= #0.1 wr_bqbuf4;
            wr_bqbuf4 <= #0.1 wr_bqbuf5;
            wr_bqbuf5 <= #0.1 wr_bqbuf6;
            wr_bqbuf6 <= #0.1 wr_bqbuf7;
            wr_bqbuf7 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
          end else if (push_wrbq&(rx_cpu_info1[7:0]==wr_bqbuf4[7:0])) begin
            wr_bqbuf4 <= #0.1 wr_bqbuf5;
            wr_bqbuf5 <= #0.1 wr_bqbuf6;
            wr_bqbuf6 <= #0.1 wr_bqbuf7;
            wr_bqbuf7 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
          end else if (push_wrbq&(rx_cpu_info1[7:0]==wr_bqbuf5[7:0])) begin
            wr_bqbuf5 <= #0.1 wr_bqbuf6;
            wr_bqbuf6 <= #0.1 wr_bqbuf7;
            wr_bqbuf7 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
          end else if (push_wrbq&(rx_cpu_info1[7:0]==wr_bqbuf6[7:0])) begin
            wr_bqbuf6 <= #0.1 wr_bqbuf7;
            wr_bqbuf7 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
          end else if (push_wrbq)
            wr_bqbuf7 <= #0.1 {wr_cqbuf0[58], wr_cqbuf0[39:32]};
        end
        default:;
      endcase
    end else if (push_wrbq) begin
      if (wr_bqvld[0]&((rx_cpu_info1[7:0]==wr_bqbuf0[7:0])|wr_abort)) begin
        wr_bqbuf0 <= #0.1 wr_bqbuf1;
        wr_bqbuf1 <= #0.1 wr_bqbuf2;
        wr_bqbuf2 <= #0.1 wr_bqbuf3;
        wr_bqbuf3 <= #0.1 wr_bqbuf4;
        wr_bqbuf4 <= #0.1 wr_bqbuf5;
        wr_bqbuf5 <= #0.1 wr_bqbuf6;
        wr_bqbuf6 <= #0.1 wr_bqbuf7;
      end else if (wr_bqvld[1]&(rx_cpu_info1[7:0]==wr_bqbuf1[7:0])) begin
        wr_bqbuf1 <= #0.1 wr_bqbuf2;
        wr_bqbuf2 <= #0.1 wr_bqbuf3;
        wr_bqbuf3 <= #0.1 wr_bqbuf4;
        wr_bqbuf4 <= #0.1 wr_bqbuf5;
        wr_bqbuf5 <= #0.1 wr_bqbuf6;
        wr_bqbuf6 <= #0.1 wr_bqbuf7;
      end else if (wr_bqvld[2]&(rx_cpu_info1[7:0]==wr_bqbuf2[7:0])) begin
        wr_bqbuf2 <= #0.1 wr_bqbuf3;
        wr_bqbuf3 <= #0.1 wr_bqbuf4;
        wr_bqbuf4 <= #0.1 wr_bqbuf5;
        wr_bqbuf5 <= #0.1 wr_bqbuf6;
        wr_bqbuf6 <= #0.1 wr_bqbuf7;
      end else if (wr_bqvld[3]&(rx_cpu_info1[7:0]==wr_bqbuf3[7:0])) begin
        wr_bqbuf3 <= #0.1 wr_bqbuf4;
        wr_bqbuf4 <= #0.1 wr_bqbuf5;
        wr_bqbuf5 <= #0.1 wr_bqbuf6;
        wr_bqbuf6 <= #0.1 wr_bqbuf7;
      end else if (wr_bqvld[4]&(rx_cpu_info1[7:0]==wr_bqbuf4[7:0])) begin
        wr_bqbuf4 <= #0.1 wr_bqbuf5;
        wr_bqbuf5 <= #0.1 wr_bqbuf6;
        wr_bqbuf6 <= #0.1 wr_bqbuf7;
      end else if (wr_bqvld[5]&(rx_cpu_info1[7:0]==wr_bqbuf5[7:0])) begin
        wr_bqbuf5 <= #0.1 wr_bqbuf6;
        wr_bqbuf6 <= #0.1 wr_bqbuf7;
      end else if (wr_bqvld[6]&(rx_cpu_info1[7:0]==wr_bqbuf6[7:0])) begin
        wr_bqbuf6 <= #0.1 wr_bqbuf7;
      end
    end
  end
end

assign cpu_rx_acp1 = ~wr_bqvld1[3];
assign pop_wrbq    = wr_bqvld1[0] & ~axis_bvalid;
always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wr_bqvld1 <= #0.1 4'h0;
  else begin
    case ({push_wrbq, pop_wrbq})
      2'b01  : wr_bqvld1 <= #0.1 {1'b0, wr_bqvld1[3:1]};
      2'b10  : wr_bqvld1 <= #0.1 {wr_bqvld1[2:0], 1'b1};
      default:;
    endcase
  end
end

always @ (*) begin
  wr_bqinfo[10:9] = rx_cpu_info1[9:8];
  if ((rx_cpu_info1[7:0]==wr_bqbuf0[7:0])|wr_abort)
    wr_bqinfo[8:0] = wr_bqbuf0[8:0];
  else if (rx_cpu_info1[7:0]==wr_bqbuf1[7:0])
    wr_bqinfo[8:0] = wr_bqbuf1[8:0];
  else if (rx_cpu_info1[7:0]==wr_bqbuf2[7:0])
    wr_bqinfo[8:0] = wr_bqbuf2[8:0];
  else if (rx_cpu_info1[7:0]==wr_bqbuf3[7:0])
    wr_bqinfo[8:0] = wr_bqbuf3[8:0];
  else if (rx_cpu_info1[7:0]==wr_bqbuf4[7:0])
    wr_bqinfo[8:0] = wr_bqbuf4[8:0];
  else if (rx_cpu_info1[7:0]==wr_bqbuf5[7:0])
    wr_bqinfo[8:0] = wr_bqbuf5[8:0];
  else if (rx_cpu_info1[7:0]==wr_bqbuf6[7:0])
    wr_bqinfo[8:0] = wr_bqbuf6[8:0];
  else// if (rx_cpu_info1[7:0]==wr_bqbuf7[7:0])
    wr_bqinfo[8:0] = wr_bqbuf7[8:0];
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn) begin
    wr_bq1buf0 <= #0.1 11'h0;
    wr_bq1buf1 <= #0.1 11'h0;
    wr_bq1buf2 <= #0.1 11'h0;
    wr_bq1buf3 <= #0.1 11'h0;
  end else begin
    if (push_wrbq) begin
      casez (wr_bqvld1)
        4'b0000: wr_bq1buf0 <= #0.1 wr_bqinfo;
        4'b0001: begin
          if (pop_wrbq)
            wr_bq1buf0 <= #0.1 wr_bqinfo;
          else
            wr_bq1buf1 <= #0.1 wr_bqinfo;
        end
        4'b001?: begin
          if (pop_wrbq) begin
            wr_bq1buf0 <= #0.1 wr_bq1buf1;
            wr_bq1buf1 <= #0.1 wr_bqinfo;
          end else
            wr_bq1buf2 <= #0.1 wr_bqinfo;
        end
        4'b01??: begin
          if (pop_wrbq) begin
            wr_bq1buf0 <= #0.1 wr_bq1buf1;
            wr_bq1buf1 <= #0.1 wr_bq1buf2;
            wr_bq1buf2 <= #0.1 wr_bqinfo;
          end else
            wr_bq1buf3 <= #0.1 wr_bqinfo;
        end
        4'b1???: begin
          if (pop_wrbq) begin
            wr_bq1buf0 <= #0.1 wr_bq1buf1;
            wr_bq1buf1 <= #0.1 wr_bq1buf2;
            wr_bq1buf2 <= #0.1 wr_bq1buf3;
            wr_bq1buf3 <= #0.1 wr_bqinfo;
          end
        end
        default:;
      endcase
    end else if (pop_wrbq) begin
      wr_bq1buf0 <= #0.1 wr_bq1buf1;
      wr_bq1buf1 <= #0.1 wr_bq1buf2;
      wr_bq1buf2 <= #0.1 wr_bq1buf3;
    end
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    axis_bvalid <= #0.1 1'b0;
  else begin
    if (pop_wrbq)
      axis_bvalid <= #0.1 1'b1;
    else if (axis_bvalid&axis_bready)
      axis_bvalid <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    axis_bid <= #0.1 9'h0;
  else begin
    if (pop_wrbq)
      axis_bid <= #0.1 wr_bq1buf0[8:0];
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    axis_bresp <= #0.1 2'h0;
  else begin
    if (pop_wrbq)
      axis_bresp <= #0.1 wr_bq1buf0[10:9];
  end
end
//******************************************************************************
assign pop_rdcq  = rd_cqvld[0]&~rd_tx_req&(~rd_tqvld[7]|(rd_tqvld[7]&rx_cpu_req));
assign rd_cqinfo = {axis_arid[8], axis_arsize, axis_arprot, axis_arlock, axis_arburst,
                    axis_arlen, axis_arcache, axis_arid[7:0], axis_araddr[31:0]};

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    axis_arready <= #0.1 1'b1;
  else begin
    if ((axis_arvalid&axis_arready&rd_cqvld[2]&~pop_rdcq)|stest_en|clr_rabort)
      axis_arready <= #0.1 1'b0;
    else if ((rd_cqvld[3]&pop_rdcq)|sft_set)
      axis_arready <= #0.1 1'b1;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rd_cqvld <= #0.1 4'h0;
  else begin
    case ({(axis_arvalid&axis_arready), pop_rdcq})
      2'b01  : rd_cqvld <= #0.1 {1'b0, rd_cqvld[3:1]};
      2'b10  : rd_cqvld <= #0.1 {rd_cqvld[2:0], 1'b1};
      default:; // no change
    endcase
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn) begin
    rd_cqbuf0 <= #0.1 59'h0;
    rd_cqbuf1 <= #0.1 59'h0;
    rd_cqbuf2 <= #0.1 59'h0;
    rd_cqbuf3 <= #0.1 59'h0;
  end else begin
    if (axis_arvalid&axis_arready) begin
      casez (rd_cqvld)
        4'b0000: rd_cqbuf0 <= #0.1 rd_cqinfo;
        4'b0001: begin
          if (pop_rdcq)
            rd_cqbuf0 <= #0.1 rd_cqinfo;
          else
            rd_cqbuf1 <= #0.1 rd_cqinfo;
        end
        4'b001?: begin
          if (pop_rdcq) begin
            rd_cqbuf0 <= #0.1 rd_cqbuf1;
            rd_cqbuf1 <= #0.1 rd_cqinfo;
          end else
            rd_cqbuf2 <= #0.1 rd_cqinfo;
        end
        4'b01??: begin
          if (pop_rdcq) begin
            rd_cqbuf0 <= #0.1 rd_cqbuf1;
            rd_cqbuf1 <= #0.1 rd_cqbuf2;
            rd_cqbuf2 <= #0.1 rd_cqinfo;
          end else
            rd_cqbuf3 <= #0.1 rd_cqinfo;
        end
        4'b1???: begin
          if (pop_rdcq) begin
            rd_cqbuf0 <= #0.1 rd_cqbuf1;
            rd_cqbuf1 <= #0.1 rd_cqbuf2;
            rd_cqbuf2 <= #0.1 rd_cqbuf3;
            rd_cqbuf3 <= #0.1 rd_cqinfo;
          end
        end
        default:;
      endcase
    end else if (pop_rdcq) begin
      rd_cqbuf0 <= #0.1 rd_cqbuf1;
      rd_cqbuf1 <= #0.1 rd_cqbuf2;
      rd_cqbuf2 <= #0.1 rd_cqbuf3;
    end
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rd_tx_req <= #0.1 1'b0;
  else begin
    //if ((pop_rdcq|stest_trig|rd_reg_en)&~rd_abort_w)
    if (pop_rdcq&~rd_abort_w)
      rd_tx_req <= #0.1 1'b1;
    else if (tx_rd_ack|sft_rst)
      rd_tx_req <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rd_tx_info <= #0.1 58'h0;
  else begin
    if (pop_rdcq)
      rd_tx_info <= #0.1 rd_cqbuf0[57:0];
    //else if (stest_trig)
    //  rd_tx_info <= `DLY {8'h4, 4'h5, 1'b0, 3'b010, 4'h0, 6'h15, 32'h5555_5555};
    //else if (rd_reg_en)
    //  rd_tx_info <= `DLY {8'h4, 4'hA, 1'b0, 3'b010, 4'h0, 6'h2A, stest_addr};
  end
end

assign pop_rdtq  = rx_cpu_req | (rd_abort&rd_tqvld[0]&~rd_dqvld[4]);
assign rd_tqinfo = {rd_cqbuf0[47:44], rd_cqbuf0[2:0], rd_cqbuf0[56:55], rd_cqbuf0[58], rd_cqbuf0[39:32]};
always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rd_tqvld <= #0.1 8'h0;
  else begin
    case ({pop_rdcq, pop_rdtq})
      2'b01  : rd_tqvld <= #0.1 {1'b0, rd_tqvld[7:1]};
      2'b10  : rd_tqvld <= #0.1 {rd_tqvld[6:0], 1'b1};
      default:; // no change
    endcase
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn) begin
    rd_tqbuf0 <= #0.1 18'h0;
    rd_tqbuf1 <= #0.1 18'h0;
    rd_tqbuf2 <= #0.1 18'h0;
    rd_tqbuf3 <= #0.1 18'h0;
    rd_tqbuf4 <= #0.1 18'h0;
    rd_tqbuf5 <= #0.1 18'h0;
    rd_tqbuf6 <= #0.1 18'h0;
    rd_tqbuf7 <= #0.1 18'h0;
  end else begin
    if (pop_rdcq) begin
      casez (rd_tqvld)
        8'b0000_0000: rd_tqbuf0 <= #0.1 rd_tqinfo;
        8'b0000_0001: begin
          if (pop_rdtq)
            rd_tqbuf0 <= #0.1 rd_tqinfo;
          else
            rd_tqbuf1 <= #0.1 rd_tqinfo;
        end
        8'b0000_001?: begin
          if (pop_rdtq&((rd_tqbuf0[7:0]==rx_cpu_info[15:8])|rd_abort)) begin
            rd_tqbuf0 <= #0.1 rd_tqbuf1;
            rd_tqbuf1 <= #0.1 rd_tqinfo;
          end else if (rx_cpu_req)
            rd_tqbuf1 <= #0.1 rd_tqinfo;
          else
            rd_tqbuf2 <= #0.1 rd_tqinfo;
        end
        8'b0000_01??: begin
          if (pop_rdtq&((rd_tqbuf0[7:0]==rx_cpu_info[15:8])|rd_abort)) begin
            rd_tqbuf0 <= #0.1 rd_tqbuf1;
            rd_tqbuf1 <= #0.1 rd_tqbuf2;
            rd_tqbuf2 <= #0.1 rd_tqinfo;
          end else if (rx_cpu_req&(rd_tqbuf1[7:0]==rx_cpu_info[15:8])) begin
            rd_tqbuf1 <= #0.1 rd_tqbuf2;
            rd_tqbuf2 <= #0.1 rd_tqinfo;
          end else if (rx_cpu_req)
            rd_tqbuf2 <= #0.1 rd_tqinfo;
          else
            rd_tqbuf3 <= #0.1 rd_tqinfo;
        end
        8'b0000_1???: begin
          if (pop_rdtq) begin
            if ((rd_tqbuf0[7:0]==rx_cpu_info[15:8])|rd_abort) begin
              rd_tqbuf0 <= #0.1 rd_tqbuf1;
              rd_tqbuf1 <= #0.1 rd_tqbuf2;
              rd_tqbuf2 <= #0.1 rd_tqbuf3;
              rd_tqbuf3 <= #0.1 rd_tqinfo;
            end else if (rd_tqbuf1[7:0]==rx_cpu_info[15:8]) begin
              rd_tqbuf1 <= #0.1 rd_tqbuf2;
              rd_tqbuf2 <= #0.1 rd_tqbuf3;
              rd_tqbuf3 <= #0.1 rd_tqinfo;
            end else if (rd_tqbuf2[7:0]==rx_cpu_info[15:8]) begin
              rd_tqbuf2 <= #0.1 rd_tqbuf3;
              rd_tqbuf3 <= #0.1 rd_tqinfo;
            end else
              rd_tqbuf3 <= #0.1 rd_tqinfo;
          end else
            rd_tqbuf4 <= #0.1 rd_tqinfo;
        end
        8'b0001_????: begin
          if (pop_rdtq) begin
            if ((rd_tqbuf0[7:0]==rx_cpu_info[15:8])|rd_abort) begin
              rd_tqbuf0 <= #0.1 rd_tqbuf1;
              rd_tqbuf1 <= #0.1 rd_tqbuf2;
              rd_tqbuf2 <= #0.1 rd_tqbuf3;
              rd_tqbuf3 <= #0.1 rd_tqbuf4;
              rd_tqbuf4 <= #0.1 rd_tqinfo;
            end else if (rd_tqbuf1[7:0]==rx_cpu_info[15:8]) begin
              rd_tqbuf1 <= #0.1 rd_tqbuf2;
              rd_tqbuf2 <= #0.1 rd_tqbuf3;
              rd_tqbuf3 <= #0.1 rd_tqbuf4;
              rd_tqbuf4 <= #0.1 rd_tqinfo;
            end else if (rd_tqbuf2[7:0]==rx_cpu_info[15:8]) begin
              rd_tqbuf2 <= #0.1 rd_tqbuf3;
              rd_tqbuf3 <= #0.1 rd_tqbuf4;
              rd_tqbuf4 <= #0.1 rd_tqinfo;
            end else if (rd_tqbuf3[7:0]==rx_cpu_info[15:8]) begin
              rd_tqbuf3 <= #0.1 rd_tqbuf4;
              rd_tqbuf4 <= #0.1 rd_tqinfo;
            end else
              rd_tqbuf4 <= #0.1 rd_tqinfo;
          end else
            rd_tqbuf5 <= #0.1 rd_tqinfo;
        end
        8'b001?_????: begin
          if (pop_rdtq) begin
            if ((rd_tqbuf0[7:0]==rx_cpu_info[15:8])|rd_abort) begin
              rd_tqbuf0 <= #0.1 rd_tqbuf1;
              rd_tqbuf1 <= #0.1 rd_tqbuf2;
              rd_tqbuf2 <= #0.1 rd_tqbuf3;
              rd_tqbuf3 <= #0.1 rd_tqbuf4;
              rd_tqbuf4 <= #0.1 rd_tqbuf5;
              rd_tqbuf5 <= #0.1 rd_tqinfo;
            end else if (rd_tqbuf1[7:0]==rx_cpu_info[15:8]) begin
              rd_tqbuf1 <= #0.1 rd_tqbuf2;
              rd_tqbuf2 <= #0.1 rd_tqbuf3;
              rd_tqbuf3 <= #0.1 rd_tqbuf4;
              rd_tqbuf4 <= #0.1 rd_tqbuf5;
              rd_tqbuf5 <= #0.1 rd_tqinfo;
            end else if (rd_tqbuf2[7:0]==rx_cpu_info[15:8]) begin
              rd_tqbuf2 <= #0.1 rd_tqbuf3;
              rd_tqbuf3 <= #0.1 rd_tqbuf4;
              rd_tqbuf4 <= #0.1 rd_tqbuf5;
              rd_tqbuf5 <= #0.1 rd_tqinfo;
            end else if (rd_tqbuf3[7:0]==rx_cpu_info[15:8]) begin
              rd_tqbuf3 <= #0.1 rd_tqbuf4;
              rd_tqbuf4 <= #0.1 rd_tqbuf5;
              rd_tqbuf5 <= #0.1 rd_tqinfo;
            end else if (rd_tqbuf4[7:0]==rx_cpu_info[15:8]) begin
              rd_tqbuf4 <= #0.1 rd_tqbuf5;
              rd_tqbuf5 <= #0.1 rd_tqinfo;
            end else
              rd_tqbuf5 <= #0.1 rd_tqinfo;
          end else
            rd_tqbuf6 <= #0.1 rd_tqinfo;
        end
        8'b01??_????: begin
          if (pop_rdtq) begin
            if ((rd_tqbuf0[7:0]==rx_cpu_info[15:8])|rd_abort) begin
              rd_tqbuf0 <= #0.1 rd_tqbuf1;
              rd_tqbuf1 <= #0.1 rd_tqbuf2;
              rd_tqbuf2 <= #0.1 rd_tqbuf3;
              rd_tqbuf3 <= #0.1 rd_tqbuf4;
              rd_tqbuf4 <= #0.1 rd_tqbuf5;
              rd_tqbuf5 <= #0.1 rd_tqbuf6;
              rd_tqbuf6 <= #0.1 rd_tqinfo;
            end else if (rd_tqbuf1[7:0]==rx_cpu_info[15:8]) begin
              rd_tqbuf1 <= #0.1 rd_tqbuf2;
              rd_tqbuf2 <= #0.1 rd_tqbuf3;
              rd_tqbuf3 <= #0.1 rd_tqbuf4;
              rd_tqbuf4 <= #0.1 rd_tqbuf5;
              rd_tqbuf5 <= #0.1 rd_tqbuf6;
              rd_tqbuf6 <= #0.1 rd_tqinfo;
            end else if (rd_tqbuf2[7:0]==rx_cpu_info[15:8]) begin
              rd_tqbuf2 <= #0.1 rd_tqbuf3;
              rd_tqbuf3 <= #0.1 rd_tqbuf4;
              rd_tqbuf4 <= #0.1 rd_tqbuf5;
              rd_tqbuf5 <= #0.1 rd_tqbuf6;
              rd_tqbuf6 <= #0.1 rd_tqinfo;
            end else if (rd_tqbuf3[7:0]==rx_cpu_info[15:8]) begin
              rd_tqbuf3 <= #0.1 rd_tqbuf4;
              rd_tqbuf4 <= #0.1 rd_tqbuf5;
              rd_tqbuf5 <= #0.1 rd_tqbuf6;
              rd_tqbuf6 <= #0.1 rd_tqinfo;
            end else if (rd_tqbuf4[7:0]==rx_cpu_info[15:8]) begin
              rd_tqbuf4 <= #0.1 rd_tqbuf5;
              rd_tqbuf5 <= #0.1 rd_tqbuf6;
              rd_tqbuf6 <= #0.1 rd_tqinfo;
            end else if (rd_tqbuf5[7:0]==rx_cpu_info[15:8]) begin
              rd_tqbuf5 <= #0.1 rd_tqbuf6;
              rd_tqbuf6 <= #0.1 rd_tqinfo;
            end else
              rd_tqbuf6 <= #0.1 rd_tqinfo;
          end else
            rd_tqbuf7 <= #0.1 rd_tqinfo;
        end
        8'b1???_????: begin
          if (pop_rdtq) begin
            if ((rd_tqbuf0[7:0]==rx_cpu_info[15:8])|rd_abort) begin
              rd_tqbuf0 <= #0.1 rd_tqbuf1;
              rd_tqbuf1 <= #0.1 rd_tqbuf2;
              rd_tqbuf2 <= #0.1 rd_tqbuf3;
              rd_tqbuf3 <= #0.1 rd_tqbuf4;
              rd_tqbuf4 <= #0.1 rd_tqbuf5;
              rd_tqbuf5 <= #0.1 rd_tqbuf6;
              rd_tqbuf6 <= #0.1 rd_tqbuf7;
              rd_tqbuf7 <= #0.1 rd_tqinfo;
            end else if (rd_tqbuf1[7:0]==rx_cpu_info[15:8]) begin
              rd_tqbuf1 <= #0.1 rd_tqbuf2;
              rd_tqbuf2 <= #0.1 rd_tqbuf3;
              rd_tqbuf3 <= #0.1 rd_tqbuf4;
              rd_tqbuf4 <= #0.1 rd_tqbuf5;
              rd_tqbuf5 <= #0.1 rd_tqbuf6;
              rd_tqbuf6 <= #0.1 rd_tqbuf7;
              rd_tqbuf7 <= #0.1 rd_tqinfo;
            end else if (rd_tqbuf2[7:0]==rx_cpu_info[15:8]) begin
              rd_tqbuf2 <= #0.1 rd_tqbuf3;
              rd_tqbuf3 <= #0.1 rd_tqbuf4;
              rd_tqbuf4 <= #0.1 rd_tqbuf5;
              rd_tqbuf5 <= #0.1 rd_tqbuf6;
              rd_tqbuf6 <= #0.1 rd_tqbuf7;
              rd_tqbuf7 <= #0.1 rd_tqinfo;
            end else if (rd_tqbuf3[7:0]==rx_cpu_info[15:8]) begin
              rd_tqbuf3 <= #0.1 rd_tqbuf4;
              rd_tqbuf4 <= #0.1 rd_tqbuf5;
              rd_tqbuf5 <= #0.1 rd_tqbuf6;
              rd_tqbuf6 <= #0.1 rd_tqbuf7;
              rd_tqbuf7 <= #0.1 rd_tqinfo;
            end else if (rd_tqbuf4[7:0]==rx_cpu_info[15:8]) begin
              rd_tqbuf4 <= #0.1 rd_tqbuf5;
              rd_tqbuf5 <= #0.1 rd_tqbuf6;
              rd_tqbuf6 <= #0.1 rd_tqbuf7;
              rd_tqbuf7 <= #0.1 rd_tqinfo;
            end else if (rd_tqbuf5[7:0]==rx_cpu_info[15:8]) begin
              rd_tqbuf5 <= #0.1 rd_tqbuf6;
              rd_tqbuf6 <= #0.1 rd_tqbuf7;
              rd_tqbuf7 <= #0.1 rd_tqinfo;
            end else if (rd_tqbuf6[7:0]==rx_cpu_info[15:8]) begin
              rd_tqbuf6 <= #0.1 rd_tqbuf7;
              rd_tqbuf7 <= #0.1 rd_tqinfo;
            end else
              rd_tqbuf7 <= #0.1 rd_tqinfo;
          end
        end
        default:;
      endcase
    end else if (pop_rdtq) begin
      if (rd_tqvld[0]&((rd_tqbuf0[7:0]==rx_cpu_info[15:8])|rd_abort)) begin
        rd_tqbuf0 <= #0.1 rd_tqbuf1;
        rd_tqbuf1 <= #0.1 rd_tqbuf2;
        rd_tqbuf2 <= #0.1 rd_tqbuf3;
        rd_tqbuf3 <= #0.1 rd_tqbuf4;
        rd_tqbuf4 <= #0.1 rd_tqbuf5;
        rd_tqbuf5 <= #0.1 rd_tqbuf6;
        rd_tqbuf6 <= #0.1 rd_tqbuf7;
      end else if (rd_tqvld[1]&(rd_tqbuf1[7:0]==rx_cpu_info[15:8])) begin
        rd_tqbuf1 <= #0.1 rd_tqbuf2;
        rd_tqbuf2 <= #0.1 rd_tqbuf3;
        rd_tqbuf3 <= #0.1 rd_tqbuf4;
        rd_tqbuf4 <= #0.1 rd_tqbuf5;
        rd_tqbuf5 <= #0.1 rd_tqbuf6;
        rd_tqbuf6 <= #0.1 rd_tqbuf7;
      end else if (rd_tqvld[2]&(rd_tqbuf2[7:0]==rx_cpu_info[15:8])) begin
        rd_tqbuf2 <= #0.1 rd_tqbuf3;
        rd_tqbuf3 <= #0.1 rd_tqbuf4;
        rd_tqbuf4 <= #0.1 rd_tqbuf5;
        rd_tqbuf5 <= #0.1 rd_tqbuf6;
        rd_tqbuf6 <= #0.1 rd_tqbuf7;
      end else if (rd_tqvld[3]&(rd_tqbuf3[7:0]==rx_cpu_info[15:8])) begin
        rd_tqbuf3 <= #0.1 rd_tqbuf4;
        rd_tqbuf4 <= #0.1 rd_tqbuf5;
        rd_tqbuf5 <= #0.1 rd_tqbuf6;
        rd_tqbuf6 <= #0.1 rd_tqbuf7;
      end else if (rd_tqvld[4]&(rd_tqbuf4[7:0]==rx_cpu_info[15:8])) begin
        rd_tqbuf4 <= #0.1 rd_tqbuf5;
        rd_tqbuf5 <= #0.1 rd_tqbuf6;
        rd_tqbuf6 <= #0.1 rd_tqbuf7;
      end else if (rd_tqvld[5]&(rd_tqbuf5[7:0]==rx_cpu_info[15:8])) begin
        rd_tqbuf5 <= #0.1 rd_tqbuf6;
        rd_tqbuf6 <= #0.1 rd_tqbuf7;
      end else if (rd_tqvld[6]&(rd_tqbuf6[7:0]==rx_cpu_info[15:8])) begin
        rd_tqbuf6 <= #0.1 rd_tqbuf7;
      end
    end
  end
end

//assign rx_dcnt = rx_cpu_info[7:0] - 3'h4;   // 1 for length, 3 for command information
always @ (*) begin
  rd_dqinfo[23:22] = rx_cpu_info[17:16];
  if ((rd_tqbuf0[7:0]==rx_cpu_info[15:8])|rd_abort) begin
    rd_dqinfo[21:14] = func_dcnt(rd_tqbuf0[10:9], rd_tqbuf0[17:14]);
    rd_dqinfo[13:0] = rd_tqbuf0[13:0];
  end else if (rd_tqbuf1[7:0]==rx_cpu_info[15:8]) begin
    rd_dqinfo[21:14] = func_dcnt(rd_tqbuf1[10:9], rd_tqbuf1[17:14]);
    rd_dqinfo[13:0] = rd_tqbuf1[13:0];
  end else if (rd_tqbuf2[7:0]==rx_cpu_info[15:8]) begin
    rd_dqinfo[21:14] = func_dcnt(rd_tqbuf2[10:9], rd_tqbuf2[17:14]);
    rd_dqinfo[13:0] = rd_tqbuf2[13:0];
  end else if (rd_tqbuf3[7:0]==rx_cpu_info[15:8]) begin
    rd_dqinfo[21:14] = func_dcnt(rd_tqbuf3[10:9], rd_tqbuf3[17:14]);
    rd_dqinfo[13:0] = rd_tqbuf3[13:0];
  end else if (rd_tqbuf4[7:0]==rx_cpu_info[15:8]) begin
    rd_dqinfo[21:14] = func_dcnt(rd_tqbuf4[10:9], rd_tqbuf4[17:14]);
    rd_dqinfo[13:0] = rd_tqbuf4[13:0];
  end else if (rd_tqbuf5[7:0]==rx_cpu_info[15:8]) begin
    rd_dqinfo[21:14] = func_dcnt(rd_tqbuf5[10:9], rd_tqbuf5[17:14]);
    rd_dqinfo[13:0] = rd_tqbuf5[13:0];
  end else if (rd_tqbuf6[7:0]==rx_cpu_info[15:8]) begin
    rd_dqinfo[21:14] = func_dcnt(rd_tqbuf6[10:9], rd_tqbuf6[17:14]);
    rd_dqinfo[13:0] = rd_tqbuf6[13:0];
  end else begin
    rd_dqinfo[21:14] = func_dcnt(rd_tqbuf7[10:9], rd_tqbuf7[17:14]);
    rd_dqinfo[13:0] = rd_tqbuf7[13:0];
  end
end

assign pop_rdq  = rd_dqvld[0]&~rmem_rd_en&(~axis_rvalid|(axis_rvalid&axis_rready&axis_rlast));
always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rd_dqvld <= #0.1 5'h0;
  else begin
    case ({pop_rdtq, pop_rdq})
      2'b01  : rd_dqvld <= #0.1 {1'b0, rd_dqvld[4:1]};
      2'b10  : rd_dqvld <= #0.1 {rd_dqvld[3:0], 1'b1};
    endcase
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn) begin
    rd_dqbuf0 <= #0.1 17'h0;
    rd_dqbuf1 <= #0.1 17'h0;
    rd_dqbuf2 <= #0.1 17'h0;
    rd_dqbuf3 <= #0.1 17'h0;
    rd_dqbuf4 <= #0.1 17'h0;
  end else begin
    if (pop_rdtq) begin
      casez (rd_dqvld)
        5'b00000: rd_dqbuf0 <= #0.1 rd_dqinfo;
        5'b00001: begin
          if (pop_rdq)
            rd_dqbuf0 <= #0.1 rd_dqinfo;
          else
            rd_dqbuf1 <= #0.1 rd_dqinfo;
        end
        5'b0001?: begin
          if (pop_rdq) begin
            rd_dqbuf0 <= #0.1 rd_dqbuf1;
            rd_dqbuf1 <= #0.1 rd_dqinfo;
          end else
            rd_dqbuf2 <= #0.1 rd_dqinfo;
        end
        5'b001??: begin
          if (pop_rdq) begin
            rd_dqbuf0 <= #0.1 rd_dqbuf1;
            rd_dqbuf1 <= #0.1 rd_dqbuf2;
            rd_dqbuf2 <= #0.1 rd_dqinfo;
          end else
            rd_dqbuf3 <= #0.1 rd_dqinfo;
        end
        5'b01???: begin
          if (pop_rdq) begin
            rd_dqbuf0 <= #0.1 rd_dqbuf1;
            rd_dqbuf1 <= #0.1 rd_dqbuf2;
            rd_dqbuf2 <= #0.1 rd_dqbuf3;
            rd_dqbuf3 <= #0.1 rd_dqinfo;
          end else
            rd_dqbuf4 <= #0.1 rd_dqinfo;
        end
        5'b1????: begin
          if (pop_rdq) begin
            rd_dqbuf0 <= #0.1 rd_dqbuf1;
            rd_dqbuf1 <= #0.1 rd_dqbuf2;
            rd_dqbuf2 <= #0.1 rd_dqbuf3;
            rd_dqbuf3 <= #0.1 rd_dqbuf4;
            rd_dqbuf4 <= #0.1 rd_dqinfo;
          end
        end
        default:;   // no change
      endcase
    end else if (pop_rdq) begin
      rd_dqbuf0 <= #0.1 rd_dqbuf1;
      rd_dqbuf1 <= #0.1 rd_dqbuf2;
      rd_dqbuf2 <= #0.1 rd_dqbuf3;
      rd_dqbuf3 <= #0.1 rd_dqbuf4;
    end
  end
end

//assign cpu_rrdy = stest_en ? cpu_rrdy_t : (~rmem_full & ~rd_dqvld[3]);
assign cpu_rrdy = (~rmem_full & ~rd_dqvld[3]);

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rd_len <= #0.1 5'h0;
  else begin
    if (pop_rdq)
      rd_len <= #0.1 {1'b0, rd_dqbuf0[20:17]};
    else if (rmem_rd|rmem_rd1)
      rd_len <= #0.1 rd_len[3:0] - 1'b1;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rmem_rd_en <= #0.1 1'b0;
  else begin
    if (pop_rdq)
      rmem_rd_en <= #0.1 1'b1;
    else if ((rmem_rd|rmem_rd1)&(rd_len[3:0]==4'h0))
      rmem_rd_en <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rd_size <= #0.1 2'h0;
  else begin
    if (pop_rdq)
      rd_size <= #0.1 rd_dqbuf0[10:9];
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rd_bcnt <= #0.1 4'h0;
  else begin
    if (rmem_rd|rmem_rd1) begin
      case (rd_size)
        2'b00  : rd_bcnt <= #0.1 4'h7;
        2'b01  : rd_bcnt <= #0.1 4'h3;
        2'b10  : rd_bcnt <= #0.1 4'h1;
        default: rd_bcnt <= #0.1 4'h0;
      endcase
    end else if (axis_rvalid&axis_rready&axis_rlast)
      rd_bcnt <= #0.1 4'h0;
    else if (axis_rvalid&axis_rready&(rd_bcnt[2:0]!=3'h0))
      rd_bcnt <= #0.1 rd_bcnt[2:0] - 1'b1;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rd_adr_sel <= #0.1 3'h0;
  else begin
    if (pop_rdq)
      rd_adr_sel <= #0.1 rd_dqbuf0[13:11];
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rd_dcnt <= #0.1 5'h0;
  else begin
    if (pop_rdq)
      case (rd_dqbuf0[10:9])
        2'b00  : rd_dcnt <= #0.1 {1'b0, rd_dqbuf0[17:14]};
        2'b01  : rd_dcnt <= #0.1 {1'h0, rd_dqbuf0[18:15]};
        2'b10  : rd_dcnt <= #0.1 {1'h0, rd_dqbuf0[19:16]};
        default: rd_dcnt <= #0.1 {1'b0, rd_dqbuf0[20:17]};
      endcase
    else if (axis_rvalid&axis_rready&~axis_rlast)
      rd_dcnt <= #0.1 rd_dcnt[3:0] - 1'b1;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    axis_rvalid <= #0.1 1'b0;
  else begin
    if (rmem_rd|rmem_rd1)
      axis_rvalid <= #0.1 1'b1;
    else if (axis_rvalid&axis_rready&(axis_rlast|(rd_bcnt[2:0]==3'h0)))
      axis_rvalid <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    axis_rid <= #0.1 9'h0;
  else begin
    if (pop_rdq)
      axis_rid <= #0.1 rd_dqbuf0[8:0];
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    axis_rresp <= #0.1 2'h0;
  else begin
    if (pop_rdq)
      axis_rresp <= #0.1 rd_dqbuf0[23:22];
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    axis_rdata <= #0.1 64'h0;
  else begin
    if (rmem_rd1)
      axis_rdata <= #0.1 64'h0;
    else if (rmem_rd) begin
      case (rd_size)
        2'b00: begin
          case (rd_adr_sel[2:0])
            3'b111 : axis_rdata <= #0.1 {rmem_tmp0[7:0],  rmem_tmp0[63:8]};
            3'b110 : axis_rdata <= #0.1 {rmem_tmp0[15:0], rmem_tmp0[63:16]};
            3'b101 : axis_rdata <= #0.1 {rmem_tmp0[23:0], rmem_tmp0[63:24]};
            3'b100 : axis_rdata <= #0.1 {rmem_tmp0[31:0], rmem_tmp0[63:32]};
            3'b011 : axis_rdata <= #0.1 {rmem_tmp0[39:0], rmem_tmp0[63:40]};
            3'b010 : axis_rdata <= #0.1 {rmem_tmp0[47:0], rmem_tmp0[63:48]};
            3'b001 : axis_rdata <= #0.1 {rmem_tmp0[55:0], rmem_tmp0[63:56]};
            default: axis_rdata <= #0.1 rmem_tmp0;
          endcase
        end
        2'b01: begin
          case (rd_adr_sel[2:1])
            2'b11  : axis_rdata <= #0.1 {rmem_tmp0[15:0], rmem_tmp0[63:16]};
            2'b10  : axis_rdata <= #0.1 {rmem_tmp0[31:0], rmem_tmp0[63:32]};
            2'b01  : axis_rdata <= #0.1 {rmem_tmp0[47:0], rmem_tmp0[63:48]};
            default: axis_rdata <= #0.1 rmem_tmp0;
          endcase
        end
        2'b10: begin
          if (rd_adr_sel[2])
            axis_rdata <= #0.1 {rmem_tmp0[31:0], rmem_tmp0[63:32]};
          else
            axis_rdata <= #0.1 rmem_tmp0;
        end
        default: axis_rdata <= #0.1 rmem_tmp0;
      endcase
    end
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    axis_rlast <= #0.1 1'b0;
  else begin
    if (pop_rdq) begin
      case (rd_dqbuf0[10:9])
        2'b00  : axis_rlast <= #0.1 (rd_dqbuf0[17:14]==4'h0) ? 1'b1 : 1'b0;
        2'b01  : axis_rlast <= #0.1 (rd_dqbuf0[18:15]==4'h0) ? 1'b1 : 1'b0;
        2'b10  : axis_rlast <= #0.1 (rd_dqbuf0[19:16]==4'h0) ? 1'b1 : 1'b0;
        default: axis_rlast <= #0.1 (rd_dqbuf0[20:17]==4'h0) ? 1'b1 : 1'b0;
      endcase
    end else if (axis_rvalid&axis_rready&(rd_dcnt[3:0]==4'h1))
      axis_rlast <= #0.1 1'b1;
    else if (axis_rvalid&axis_rready&axis_rlast)
      axis_rlast <= #0.1 1'b0;
  end
end
//******************************************************************************
// Write SRAM control and instance
assign wr_2w_vld   = axis_wlast|(wr_size[1:0]==2'b11)|((wr_size==2'b10)&wr_cnt[0])
                   | ((wr_size==2'b01)&(wr_cnt[1:0]==2'b11))
                   | ((wr_size==2'b00)&(wr_cnt[2:0]==3'b111));
assign wsram_wr    = axis_wvalid&axis_wready&wr_2w_vld;

always @ (*) begin
  case (wr_adr_sel[2:1])
    2'h3   : wdata_sel = axis_wdata[63:48];
    2'h2   : wdata_sel = axis_wdata[47:32];
    2'h1   : wdata_sel = axis_wdata[31:16];
    default: wdata_sel = axis_wdata[15:0];
  endcase
end

always @ (*) begin
  case (wr_adr_sel[2:0])
    3'b000 : wdata_sel1 = axis_wdata[7:0];
    3'b001 : wdata_sel1 = axis_wdata[15:8];
    3'b010 : wdata_sel1 = axis_wdata[23:16];
    3'b011 : wdata_sel1 = axis_wdata[31:24];
    3'b100 : wdata_sel1 = axis_wdata[39:32];
    3'b101 : wdata_sel1 = axis_wdata[47:40];
    3'b110 : wdata_sel1 = axis_wdata[55:48];
    default: wdata_sel1 = axis_wdata[63:56];
  endcase
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wmem_wdata_s <= #0.1 64'h0;
  else begin
    if (axis_wvalid&axis_wready) begin
      case (wr_size)
        2'b00: begin
          case (wr_cnt[2:0])
            3'b000 : wmem_wdata_s[7:0]   <= #0.1 wdata_sel1;
            3'b001 : wmem_wdata_s[15:8]  <= #0.1 wdata_sel1;
            3'b010 : wmem_wdata_s[23:16] <= #0.1 wdata_sel1;
            3'b011 : wmem_wdata_s[31:24] <= #0.1 wdata_sel1;
            3'b100 : wmem_wdata_s[39:32] <= #0.1 wdata_sel1;
            3'b101 : wmem_wdata_s[47:40] <= #0.1 wdata_sel1;
            3'b110 : wmem_wdata_s[55:48] <= #0.1 wdata_sel1;
            default: wmem_wdata_s[63:56] <= #0.1 wdata_sel1;
          endcase
        end
        2'b01: begin
          case (wr_cnt[1:0])
            2'b00  : wmem_wdata_s[15:0]  <= #0.1 wdata_sel;
            2'b01  : wmem_wdata_s[31:16] <= #0.1 wdata_sel;
            2'b10  : wmem_wdata_s[47:32] <= #0.1 wdata_sel;
            default: wmem_wdata_s[63:48] <= #0.1 wdata_sel;
          endcase
        end
        2'b10: begin
          case ({wr_cnt[0], wr_adr_sel[2]})
            2'b00  : wmem_wdata_s[31:0]  <= #0.1 axis_wdata[31:0];
            2'b01  : wmem_wdata_s[31:0]  <= #0.1 axis_wdata[63:32];
            2'b10  : wmem_wdata_s[63:32] <= #0.1 axis_wdata[31:0];
            default: wmem_wdata_s[63:32] <= #0.1 axis_wdata[63:32];
          endcase
        end
        default: wmem_wdata_s <= #0.1 axis_wdata;
      endcase
    end
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wsram_wptr <= #0.1 8'h0;
  else begin
    if (sft_ack3)
      wsram_wptr <= #0.1 8'h0;
    else if (wsram_wr)
      wsram_wptr <= #0.1 wsram_wptr[6:0] + 1'b1;
  end
end

assign wmem_cen = wmem_wen & tx_cpu_ren;

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wmem_wen <= #0.1 1'b1;
  else begin
    if (axis_wvalid&axis_wready&wr_2w_vld)
      wmem_wen <= #0.1 1'b0;
    else
      wmem_wen <= #0.1 1'b1;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wmem_raddr <= #0.1 8'h0;
  else begin
    if (sft_ack3)
      wmem_raddr <= #0.1 8'h0;
    else if (~tx_cpu_ren)
      wmem_raddr <= #0.1 wmem_raddr[6:0] + 1'b1;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    wmem_waddr <= #0.1 6'h0;
  else begin
    if (wsram_wr)
      wmem_waddr <= #0.1 wsram_wptr[5:0];
  end
end

sim_Bisted_S2P64X64 u_wdata_buf_0 (
  .Q               (wmem_temp),
  .SQ              (wmem_rdata),
  .BistFail        (bist_fail[0]),
  .BistFinish      (bist_finish[0]),

  .CLK             (sysclk),
  .CLKX2           (mem_clk2x),
  .RCEN            (wmem_cen),
  .RA              (wmem_raddr[5:0]),
  .WEN             (wmem_wen),
  .WA              (wmem_waddr),
  .D               (wmem_wdata_s),
  .RESET_B         (sysrstn),
  .NVIC_RST_B      (bist_rstn),
  .SCAN_ENABLE     (scan_enable),
  .BistMode        (bist_mode),
  .TEST_MODE       (test_mode)
);
//******************************************************************************
// Read SRAM control and instance
assign rmem_wr      = cpu_rvld&cpu_rrdy&~stest_en;
assign rmem_wdata_s = cpu_rdata;
assign rmem_rd     = rmem_rd_en&~rmem_empty&~(|rd_bcnt[2:0])&~(axis_rvalid&~axis_rready);
assign rmem_rd1    = rmem_rd_en&rmem_empty&rd_abort&~(|rd_bcnt[2:0])&~(axis_rvalid&~axis_rready);
assign rsram_wr    = rmem_wr & (|rmem_dcnt0[6:2]) & ~((rmem_dcnt0[6:0]==6'h4)&rmem_rd) & ~rmem_full;
assign rsram_rd    = rmem_rd & ~rsram_empty;
assign rsram_empty = (rsram_wptr[6:0]==rsram_rptr[6:0]);
assign rmem_full   = (rsram_wptr[6]^rsram_rptr[6])&(rsram_wptr[5:0]==rsram_rptr[5:0]);
assign rmem_empty  = (rmem_dcnt0[6:0]==7'h0);

assign rpre_wr0 = rmem_wr & (rmem_dcnt0[6:0]==7'h0);
assign rpre_wr1 = rmem_wr & (rmem_dcnt0[6:0]==7'h1);
assign rpre_wr2 = rmem_wr & (rmem_dcnt0[6:0]==7'h2);
assign rpre_wr3 = rmem_wr & (rmem_dcnt0[6:0]==7'h3);
assign rpre_wr4 = rmem_wr & (rmem_dcnt0[6:0]==7'h4);

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rmem_dcnt0 <= #0.1 8'h0;
  else begin
    case ({rmem_wr, rmem_rd})
      2'b01  : rmem_dcnt0 <= #0.1 rmem_dcnt0[6:0] - 1'b1;
      2'b10  : rmem_dcnt0 <= #0.1 rmem_dcnt0[6:0] + 1'b1;
      default:;
    endcase
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rsram_wptr <= #0.1 8'h0;
  else begin
    if (rsram_wr)
      rsram_wptr <= #0.1 rsram_wptr[6:0] + 1'b1;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rsram_rptr <= #0.1 8'h0;
  else begin
    if (rsram_rd)
      rsram_rptr <= #0.1 rsram_rptr[6:0] + 1'b1;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn) begin
    rmem_dcnt1  <= #0.1 3'h0;
    rmem_dcnt12 <= #0.1 3'h0;
    rmem_dcnt11 <= #0.1 3'h0;
  end else begin
    if (rmem_rd&~rmem_rd_d[2]) begin
      if (rmem_dcnt12[1:0]!=2'h0)
        rmem_dcnt1 <= #0.1 rmem_dcnt12[1:0] - 1'b1;

      if (rmem_dcnt11[1:0]!=2'h0)
        rmem_dcnt12 <= #0.1 rmem_dcnt11[1:0] - 1'b1;

      if (rmem_dcnt10[1:0]!=2'h0)
        rmem_dcnt11 <= #0.1 rmem_dcnt10[1:0] - 1'b1;
    end else if (rmem_rd_d[2]&~rmem_rd) begin
      rmem_dcnt1  <= #0.1 rmem_dcnt12[1:0] + 1'b1;
      rmem_dcnt12 <= #0.1 rmem_dcnt11[1:0] + 1'b1;
      rmem_dcnt11 <= #0.1 rmem_dcnt10[1:0] + 1'b1;
    end else begin
      rmem_dcnt1  <= #0.1 {1'b0, rmem_dcnt12[1:0]};
      rmem_dcnt12 <= #0.1 {1'b0, rmem_dcnt11[1:0]};
      rmem_dcnt11 <= #0.1 {1'b0, rmem_dcnt10[1:0]};
    end
  end
end

assign rpre_wr = rpre_wr1|rpre_wr2|rpre_wr3|(rpre_wr4&rmem_rd);
always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rmem_dcnt10 <= #0.1 3'h0;
  else begin
    case ({rmem_rd_d[2], rpre_wr, rmem_rd})
      3'b001 : if (rmem_dcnt10[1:0]!=2'h0) rmem_dcnt10 <= #0.1 rmem_dcnt10[1:0] - 1'b1;
      3'b010 : if (rmem_dcnt10[1:0]!=2'h3) rmem_dcnt10 <= #0.1 rmem_dcnt10[1:0] + 1'b1;
      3'b100 : if (rmem_dcnt10[1:0]!=2'h3) rmem_dcnt10 <= #0.1 rmem_dcnt10[1:0] + 1'b1;
      3'b110 : if (rmem_dcnt10[1:0]!=2'h3) rmem_dcnt10 <= #0.1 rmem_dcnt10[1:0] + 2'h2;
      3'b111 : if (rmem_dcnt10[1:0]!=2'h3) rmem_dcnt10 <= #0.1 rmem_dcnt10[1:0] + 1'b1;
    endcase
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rmem_tmp0 <= #0.1 64'h0;
  else begin
    if (rpre_wr0|(rpre_wr1&rmem_rd))
      rmem_tmp0 <= #0.1 rmem_wdata_s;
    else if (rmem_rd_d[2]&rmem_rd&(rmem_dcnt1[1:0]==2'h0))
      rmem_tmp0 <= #0.1 rmem_rdata;
    else if (rmem_rd)
      rmem_tmp0 <= #0.1 rmem_tmp1;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rmem_tmp1 <= #0.1 64'h0;
  else begin
    if (rpre_wr1|(rpre_wr2&rmem_rd))
      rmem_tmp1 <= #0.1 rmem_wdata_s;
    else if (rmem_rd_d[2]&((rmem_rd&(rmem_dcnt1[1:0]==2'h1))|(~rmem_rd&(rmem_dcnt1[1:0]==2'h0))))
      rmem_tmp1 <= #0.1 rmem_rdata;
    else if (rmem_rd)
      rmem_tmp1 <= #0.1 rmem_tmp2;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rmem_tmp2 <= #0.1 64'h0;
  else begin
    if (rpre_wr2|(rpre_wr3&rmem_rd))
      rmem_tmp2 <= #0.1 rmem_wdata_s;
    else if (rmem_rd_d[2]&((rmem_rd&(rmem_dcnt1[1:0]==2'h2))|(~rmem_rd&(rmem_dcnt1[1:0]==2'h1))))
      rmem_tmp2 <= #0.1 rmem_rdata;
    else if (rmem_rd)
      rmem_tmp2 <= #0.1 rmem_tmp3;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rmem_tmp3 <= #0.1 64'h0;
  else begin
    if (rpre_wr3|(rpre_wr4&rmem_rd))
      rmem_tmp3 <= #0.1 rmem_wdata_s;
    else if (rmem_rd_d[2]&((rmem_rd&(rmem_dcnt1[1:0]==2'h3))|(~rmem_rd&(rmem_dcnt1[1:0]==2'h2))))
      rmem_tmp3 <= #0.1 rmem_rdata;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rmem_rd_d <= #0.1 3'h0;
  else begin
    rmem_rd_d <= #0.1 {rmem_rd_d[1:0], rsram_rd};
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rmem_wdata <= #0.1 64'h0;
  else begin
    if (rsram_wr)
      rmem_wdata <= #0.1 rmem_wdata_s;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rmem_cen <= #0.1 1'b1;
  else begin
    if (rsram_wr | rsram_rd)
      rmem_cen <= #0.1 1'b0;
    else
      rmem_cen <= #0.1 1'b1;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rmem_wen <= #0.1 1'b1;
  else begin
    if (rsram_wr)
      rmem_wen <= #0.1 1'b0;
    else
      rmem_wen <= #0.1 1'b1;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rmem_raddr <= #0.1 6'h0;
  else begin
    if (rsram_rd)
      rmem_raddr <= #0.1 rsram_rptr[5:0];
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    rmem_waddr <= #0.1 6'h0;
  else begin
    if (rsram_wr)
      rmem_waddr <= #0.1 rsram_wptr[5:0];
  end
end

sim_Bisted_S2P64X64 u_rdata_buf_0 (
  .Q               (rmem_temp),
  .SQ              (rmem_rdata),
  .BistFail        (bist_fail[1]),
  .BistFinish      (bist_finish[1]),

  .CLK             (sysclk),
  .CLKX2           (mem_clk2x),
  .RCEN            (rmem_cen),
  .RA              (rmem_raddr),
  .WEN             (rmem_wen),
  .WA              (rmem_waddr),
  .D               (rmem_wdata),
  .RESET_B         (sysrstn),
  .NVIC_RST_B      (bist_rstn),
  .SCAN_ENABLE     (scan_enable),
  .BistMode        (bist_mode),
  .TEST_MODE       (test_mode)
);
//******************************************************************************
//assign stest_wdata = {stest_data[7:0], stest_data[15:8], stest_data[23:16], stest_data[31:24], 32'hF};

//always @ (posedge sysclk or negedge sysrstn) begin
//  if (~sysrstn)
//    stest_rsel <= `DLY 2'h0;
//  else begin
//    if (stest_en&rx_cpu_req&(rx_cpu_info[13:8]==6'h15))
//      stest_rsel <= `DLY 2'b11;
//    else if (stest_en&rx_cpu_req&(rx_cpu_info[13:8]==6'h2A))
//      stest_rsel <= `DLY 2'b01;
//  end
//end
//
//always @ (posedge sysclk or negedge sysrstn) begin
//  if (~sysrstn)
//    cpu_rrdy_t <= `DLY 1'b0;
//  else begin
//    if (stest_en&rx_cpu_req)
//      cpu_rrdy_t <= `DLY 1'b1;
//    else if (cpu_rvld&cpu_rrdy_t&stest_rsel[0])
//      cpu_rrdy_t <= `DLY 1'b0;
//  end
//end
//
//always @ (posedge sysclk or negedge sysrstn) begin
//  if (~sysrstn)
//    stest_addr <= `DLY 32'h0;
//  else begin
//    if (cpu_rvld&cpu_rrdy_t&stest_rsel[1])
//      stest_addr <= `DLY cpu_rdata[31:0];
//  end
//end
//
//always @ (posedge sysclk or negedge sysrstn) begin
//  if (~sysrstn)
//    rd_reg_en <= `DLY 1'b0;
//  else begin
//    if (cpu_rvld&cpu_rrdy_t&stest_rsel[1])
//      rd_reg_en <= `DLY 1'b1;
//    else
//      rd_reg_en <= `DLY 1'b0;
//  end
//end
//
//always @ (posedge sysclk or negedge sysrstn) begin
//  if (~sysrstn)
//    stest_data <= `DLY 32'h0;
//  else begin
//    if (cpu_rvld&cpu_rrdy_t&~stest_rsel[1])
//      stest_data <= `DLY cpu_rdata[31:0];
//  end
//end
//
//always @ (posedge sysclk or negedge sysrstn) begin
//  if (~sysrstn)
//    wr_reg_en <= `DLY 1'b0;
//  else begin
//    if (cpu_rvld&cpu_rrdy_t&(stest_rsel[1:0]==2'b01))
//      wr_reg_en <= `DLY 1'b1;
//    else
//      wr_reg_en <= `DLY 1'b0;
//  end
//end

//******************************************************************************
// Function for AXI data byte count calculation
function [7:0] func_dcnt;
  input [1:0] size;
  input [3:0] len;
  begin
    case (size)
      2'b11  : func_dcnt = {1'b0, len[3:0], 3'b111};
      2'b10  : func_dcnt = {2'h0, len[3:0], 2'b11};
      2'b01  : func_dcnt = {3'h0, len[3:0], 1'b1};
      default: func_dcnt = {4'h0, len[3:0]};
    endcase
  end
endfunction
endmodule
//==============================================================================
//
//    This confidential and proprietary hardware may be used only as
//  authorized by a licensing agreement from
//                    SunMedia Technology Co., LTD.
//
//  In the event of publication, the following notice is applicable:
//
//            COPYRIGHT 2017, SunMedia Technology Co., LTD.
//                        ALL RIGHTS RESERVED
//
//  The entire notice above must be reproduced on all authorized copies.
//
//==============================================================================
//
//  File        : f_bio_dma_ctrl.v
//  Author      : kun.zhang
//  Date        : 27/Feb/2017
//  Version     : 1.0
//  Abstract    : This is the DMA controller top block. Including some simple
//                mux for all channels
//
//  Modification History:
//  Date          By            Version         Change Description
//------------------------------------------------------------------------------
//  27/Feb/2017   kun.zhang      1.0            Original
//
//
//==============================================================================



module f_bio_dma_ctrl (
  input  wire        sysclk,    // clock
  input  wire        sysrstn,   // reset
  input  wire        sft_rst,   // Soft reset
  output wire        sft_ack1,  // Soft reset ack for DMA write
  output wire        sft_ack2,  // Soft reset ack for DMA read

  input  wire        bist_rstn, // NVIC_RST_B
  input  wire        bist_mode,
  input  wire        test_mode,
  input  wire        scan_enable,
  output wire [5:0]  bist_fail,
  output wire [5:0]  bist_finish,

  input  wire        dma_wvld,  // DMA write data valid
  input  wire [2:0]  dma_ch,    // DMA write channel number
  input  wire [63:0] dma_wdata, // DMA write data
  output wire        dma_wrdy,  // DMA write read, has enough buffer for data

  output wire        dma_req,   // DMA mode transfer request, pulse
  output wire [15:0] dma_info,  // DMA mode transfer reqeust information
  input  wire        dma_ack,   // DMA mode transfer acknowlage
  output wire        dma_dvld,  // DMA mode data valid
  output wire [63:0] dma_data,  // DMA mode data
  output wire        dma_last,  // DMA mode last data in a burst
  input  wire        dma_drdy,  // DMA mode daa ready

  input  wire        en_16b,    // Enable 16bit data bus
  output wire        ch0_run,   // Channel0 runing states
  input  wire        ch0_trig,  // Channel0 trigger
  input  wire        ch0_stop,  // Channel0 Stop pulse
  input  wire        ch0_dir,   // Channel0 Direction
  input  wire [15:0] ch0_len,   // Channel0 DMA length
  input  wire [31:0] ch0_addr,  // Channel0 start address
  output wire        ch1_run,   // Channel1 runing states
  input  wire        ch1_trig,  // Channel1 trigger
  input  wire        ch1_stop,  // Channel1 Stop pulse
  input  wire        ch1_dir,   // Channel1 Direction
  input  wire [15:0] ch1_len,   // Channel1 DMA length
  input  wire [31:0] ch1_addr,  // Channel1 start address
  output wire        ch2_run,   // Channel2 runing states
  input  wire        ch2_trig,  // Channel2 trigger
  input  wire        ch2_stop,  // Channel2 Stop pulse
  input  wire        ch2_dir,   // Channel2 Direction
  input  wire [15:0] ch2_len,   // Channel2 DMA length
  input  wire [31:0] ch2_addr,  // Channel2 start address
  output wire        ch3_run,   // Channel3 runing states
  input  wire        ch3_trig,  // Channel3 trigger
  input  wire        ch3_stop,  // Channel3 Stop pulse
  input  wire        ch3_dir,   // Channel3 Direction
  input  wire [15:0] ch3_len,   // Channel3 DMA length
  input  wire [31:0] ch3_addr,  // Channel3 start address
  output wire        ch4_run,   // Channel4 runing states
  input  wire        ch4_trig,  // Channel4 trigger
  input  wire        ch4_stop,  // Channel4 Stop pulse
  input  wire        ch4_dir,   // Channel4 Direction
  input  wire [15:0] ch4_len,   // Channel4 DMA length
  input  wire [31:0] ch4_addr,  // Channel4 start address
  output wire        ch5_run,   // Channel5 runing states
  input  wire        ch5_trig,  // Channel5 trigger
  input  wire        ch5_stop,  // Channel5 Stop pulse
  input  wire        ch5_dir,   // Channel5 Direction
  input  wire [15:0] ch5_len,   // Channel5 DMA length
  input  wire [31:0] ch5_addr,  // Channel5 start address


    input  wire [1:0]   ch0_dst_sel,    // Channel0 destination select
    input  wire [1:0]   ch1_dst_sel,    // Channel1 destination select
    input  wire [1:0]   ch2_dst_sel,    // Channel2 destination select
    input  wire [1:0]   ch3_dst_sel,    // Channel3 destination select
    input  wire [1:0]   ch4_dst_sel,    // Channel4 destination select
    input  wire [1:0]   ch5_dst_sel,    // Channel5 destination select

    input  wire         ch0_discnt,     // Channel0 disable length counter
    input  wire         ch1_discnt,     // Channel1 disable length counter
    input  wire         ch2_discnt,     // Channel2 disable length counter
    input  wire         ch3_discnt,     // Channel3 disable length counter
    input  wire         ch4_discnt,     // Channel4 disable length counter
    input  wire         ch5_discnt,     // Channel5 disable length counter

    input  wire [5:0]   rx_sdone,       // RX stop done from rx_pkt
    input  wire         tx_done,        // TX transfer done from cdc
    input  wire [2:0]   tx_dch,         // TX transfer done channel number
    output wire         rx_stop_req,    // RX stop request to rx_ctrl
    output wire [2:0]   rx_sch,         // RX stop request channel number
    input  wire         lvds_pop,       // LVDS TX pop data
    output wire [31:0]  lvds_rdata,     // LVDS TX read data
    output wire         lvds_empty,     // LVDS TX data empty
    input  wire         lvds_push,      // LVDS RX push data
    input  wire [31:0]  lvds_wdata,     // LVDS RX write data
    output wire         lvds_full,      // LVDS RX data full
    input  wire         ddfch_rreq,     // DDFCH read request
    output wire [31:0]  ddfch_rdata,    // DDFCH read data
    output wire         ddfch_rvalid,   // DDFCH read data valid


  output wire [15:0]  axim_probe,

  // AXI Write Address phase signals
  output wire [3:0]   axim_awid,
  output wire [31:0]  axim_awaddr,
  output wire [3:0]   axim_awlen,
  output wire [2:0]   axim_awsize,
  output wire [1:0]   axim_awburst,
  output wire [1:0]   axim_awlock,
  output wire [3:0]   axim_awcache,
  output wire [2:0]   axim_awprot,
  output wire         axim_awvalid,
  input  wire         axim_awready,
  // AXI Write Data phase signals
  output wire [3:0]   axim_wid,
  output wire [127:0] axim_wdata,
  output wire [15:0]  axim_wstrb,
  output wire         axim_wlast,
  output wire         axim_wvalid,
  input  wire         axim_wready,
  // AXI Write Response phase signals
  input  wire [3:0]   axim_bid,
  input  wire [1:0]   axim_bresp,
  input  wire         axim_bvalid,
  output wire         axim_bready,

  // AXI Read Address phase signals
  output wire [3:0]   axim_arid,
  output wire [31:0]  axim_araddr,
  output wire [3:0]   axim_arlen,
  output wire [2:0]   axim_arsize,
  output wire [1:0]   axim_arburst,
  output wire [1:0]   axim_arlock,
  output wire [3:0]   axim_arcache,
  output wire [2:0]   axim_arprot,
  output wire         axim_arvalid,
  input  wire         axim_arready,
  // AXI Read Data phase signals
  input  wire [3:0]   axim_rid,
  input  wire [127:0] axim_rdata,
  input  wire [1:0]   axim_rresp,
  input  wire         axim_rlast,
  input  wire         axim_rvalid,
  output wire         axim_rready
);

assign sft_ack1 = 1'h1;
assign sft_ack2 = 1'h1;
assign bist_fail = 6'h0;
assign bist_finish = 6'h0;
assign dma_wrdy = 1'h0;
assign dma_req = 1'h0;
assign dma_info = 1'h0;
assign dma_dvld = 1'h0;
assign dma_data = 1'h0;
assign dma_last = 1'h0;
assign ch0_run = 1'h0;
assign ch1_run = 1'h0;
assign ch2_run = 1'h0;
assign ch3_run = 1'h0;
assign ch4_run = 1'h0;
assign ch5_run = 1'h0;
assign rx_stop_req = 1'h0;
assign rx_sch = 3'h0;
assign lvds_rdata = 32'h0;
assign lvds_empty = 1'h0;
assign lvds_full = 1'h0;
assign ddfch_rdata = 32'h0;
assign ddfch_rvalid = 1'h0;
assign axim_probe = 16'h0;
assign axim_awid = 4'h0;
assign axim_awaddr = 32'h0;
assign axim_awlen = 4'h0;
assign axim_awsize = 3'h0;
assign axim_awburst = 2'h0;
assign axim_awlock = 2'h0;
assign axim_awcache = 4'h0;
assign axim_awprot = 3'h0;
assign axim_awvalid = 1'h0;
assign axim_wid = 4'h0;
assign axim_wdata = 128'h0;
assign axim_wstrb = 16'h0;
assign axim_wlast = 1'h0;
assign axim_wvalid =1 'h0;
assign axim_bready = 1'h0;
assign axim_arid = 4'h0;
assign axim_araddr = 32'h0;
assign axim_arlen = 4'h0;
assign axim_arsize = 3'h0;
assign axim_arburst = 2'h0;
assign axim_arlock = 2'h0;
assign axim_arcache = 4'h0;
assign axim_arprot = 3'h0;
assign axim_arvalid = 1'h0;
assign axim_rready = 1'b0;

endmodule
//==============================================================================
//
//    This confidential and proprietary hardware may be used only as
//  authorized by a licensing agreement from
//                    SunMedia Technology Co., LTD.
//
//  In the event of publication, the following notice is applicable:
//
//            COPYRIGHT 2017, SunMedia Technology Co., LTD.
//                        ALL RIGHTS RESERVED
//
//  The entire notice above must be reproduced on all authorized copies.
//
//==============================================================================
//
//  File        : f_bio_stest_ctrl.v
//  Author      : kun.zhang
//  Date        : 13/Mar/2017
//  Version     : 1.0
//  Abstract    : This is the self-test control block for BIO controller.
//                Including the flow control FSM and timeout check.
//
//  Modification History:
//  Date          By            Version         Change Description
//------------------------------------------------------------------------------
//  13/Mar/2017   kun.zhang      1.0            Original
//
//
//==============================================================================



module f_bio_stest_ctrl (
  input  wire        sysclk,    // clock
  input  wire        sysrstn,   // reset
  input  wire        sft_rst,   // Soft reset

  input  wire        stest_trig,    // Self-test start trigger
  input  wire        pulse_1us,     // 1us boundary pulse from timer
  output wire        stest_run,     // Self-test running
  input  wire        btchk_sreq,    // Bus tunning request from soft-ware

  output wire        ckchk_req,     // Clock check request
  input  wire        ckchk_ack,     // Clock check acknowlage
  output wire        stest_req,     // Self-test start request
  input  wire        stest_ack,     // Receives Self-test start
  output wire        btchk_req,     // Request to send BT start
  input  wire        btchk_ack,     // Bus tunning acknowlage, receives BT start
  input  wire        btchk_dack,    // Receives BT data
  output wire        btchk_req1,    // Request to send BT end
  input  wire        btchk_ack1,    // Bus tunning acknowlage, receives BT end
  input  wire        rx_fail,       // RX status, indicates tunning or read address error
  output wire        btchk_done,    // Bus-tunning done
  output wire        btchk_fail,    // Bus tunning fail
  output wire        stest_done,    // Self-test done
  output wire        stest_fail,    // Self-test fail
  output wire        stest_tfail,   // Self-test timeout fail
  output wire [2:0]  stest_pst      // Self-test previous state after fail/timeout
);

assign stest_run = 1'b0;
assign ckchk_req = 1'b0;
assign stest_req = 1'b0;
assign btchk_req = 1'b0;
assign btchk_req1 = 1'b0;
assign btchk_done = 1'b0;
assign btchk_fail = 1'b0;
assign stest_done = 1'b0;
assign stest_fail = 1'b0;
assign stest_tfail = 1'b0;
assign stest_pst = 3'h0;

endmodule
module f_bio_arst_gen (
  input  wire   clk,
  input  wire   rsts,
  input  wire   rstd_m,
  input  wire   test_mode,
  output wire   rstd
);

reg [15:0] rst_smp;
wire       rstd_w;

always @ (posedge clk or negedge rsts) begin
  if (~rsts)
    rst_smp <= #0.1 16'h0;
  else begin
    rst_smp <= #0.1 {rst_smp[14:0], 1'b1};
  end
end

assign rstd_w = test_mode ? rsts : (rst_smp[15]&rstd_m);

f_aim_reset_sync u_rst_sync_0 (
  .RST_B            (rsts),
  .TEST_MODE        (test_mode),
  .RESAMPLE_CLK     (clk),
  .SRC_RST_B        (rstd_w),
  .RESAMPLE_RST_B   (rstd)
);

endmodule
//==============================================================================
//
//    This confidential and proprietary hardware may be used only as
//  authorized by a licensing agreement from
//                    SunMedia Technology Co., LTD.
//
//  In the event of publication, the following notice is applicable:
//
//            COPYRIGHT 2016, SunMedia Technology Co., LTD.
//                        ALL RIGHTS RESERVED
//
//  The entire notice above must be reproduced on all authorized copies.
//
//==============================================================================
//
//  File        : f_bio_stest_timer.v
//  Author      : kun.zhang
//  Date        : 07/Nov/2016
//  Version     : 1.0
//  Abstract    : This module is the IO bus self-test mode timer, used to check
//                bus commulation timeout conditions by generate a 1us pulse
//                signal to system domain. The counter will been cleared by
//                a rising edge of stest_en.
//
//  Modification History:
//  Date          By            Version         Change Description
//------------------------------------------------------------------------------
//  07/Nov/2016   kun.zhang      1.0            Original
//
//
//==============================================================================



module f_bio_stest_timer (
  input  wire   ref_clk,    // 27MHz clock
  input  wire   ref_rstn,   // reset
  input  wire   sysclk,
  input  wire   sysrstn,
  input  wire   stest_en,   // Self-test enable
  input  wire   stest_run,  // Self-test running for timer enable
  output wire   stest_trig, // Selt-test trigger
  output wire   pulse_1us   // pulse signal that indicates 1us boundary
);

assign stest_trig = 1'b0;
assign pulse_1us = 1'b0;

endmodule

//==============================================================================
//
//    This confidential and proprietary hardware may be used only as
//  authorized by a licensing agreement from
//                    SunMedia Technology Co., LTD.
//
//  In the event of publication, the following notice is applicable:
//
//            COPYRIGHT 2017, SunMedia Technology Co., LTD.
//                        ALL RIGHTS RESERVED
//
//  The entire notice above must be reproduced on all authorized copies.
//
//==============================================================================
//
//  File        : f_bio_rst_ctrl.v
//  Author      : kun.zhang
//  Date        : 13/Apr/2017
//  Version     : 1.0
//  Abstract    : This is the reset control module for BIO controller when reset
//                achip
//
//  Modification History:
//  Date          By            Version         Change Description
//------------------------------------------------------------------------------
//  13/Apr/2017   kun.zhang      1.0            Original
//
//
//==============================================================================



module f_bio_rst_ctrl (
  input  wire       clk_ref,    // Reference clock to A-chip
  input  wire       a_reset,    // Reset to A-chip, low active
  input  wire       test_mode,  // test mode enable
  input  wire       sysclk,     // System domain clock
  input  wire       sysrstn,    // System domain reset from global reset gen
  input  wire       tx_clk,     // TX domain clock
  input  wire       tx_rstn,    // TX domain reset from global reset gen
  input  wire       rx_clk,     // RX domain clock
  input  wire       rx_rstn,    // RX domain reset from global reset
  output reg        a_reset_m,  // A chip reset mask
  output reg        sft_rst,    // System domain soft reset
  output reg        sft_set,    // System domain soft set (clear of soft reset)
  input  wire       sft_ack0,   // Soft reset from CPU mode
  input  wire       sft_ack1,   // Soft reset from DMA mode write
  input  wire       sft_ack2,   // Soft reset from DMA mode read
  input  wire       sft_ack3,   // Soft reset from CPU slave mode
  output wire       cdc_rstn,   // CDC domain reset for system domain CDC logics
  output wire       txs_rstn,   // TX domain reset combined with A-chip reset
  output wire       rxs_rstn    // RX domain reset combined with A-chip reset
);

wire cdc_rstn_src;  // CDC domain reset source
wire txs_rstn_src;  // TX domain reset source
wire rxs_rstn_src;  // RX domain reset source

wire a_reset_w; // A-reset after oversample with system clock
reg  a_reset_d; // a-reset_w delayed 1T for pulse generate

reg  sft_rst_st0;   // Soft reset status0
reg  sft_rst_st1;   // Soft reset status1
reg  sft_rst_st2;   // Soft reset status2
reg  sft_rst_st3;   // Soft reset status3

assign cdc_rstn_src = test_mode ? sysrstn : (sysrstn&a_reset);
assign txs_rstn_src = test_mode ? tx_rstn : (tx_rstn&a_reset);
assign rxs_rstn_src = test_mode ? rx_rstn : (rx_rstn&a_reset);

f_aim_reset_sync u_rst_sync_0 (
  .RST_B            (sysrstn),
  .TEST_MODE        (test_mode),
  .RESAMPLE_CLK     (sysclk),
  .SRC_RST_B        (cdc_rstn_src),
  .RESAMPLE_RST_B   (cdc_rstn)
);

f_aim_reset_sync u_rst_sync_1 (
  .RST_B            (tx_rstn),
  .TEST_MODE        (test_mode),
  .RESAMPLE_CLK     (tx_clk),
  .SRC_RST_B        (txs_rstn_src),
  .RESAMPLE_RST_B   (txs_rstn)
);

f_aim_reset_sync u_rst_sync_2 (
  .RST_B            (rx_rstn),
  .TEST_MODE        (test_mode),
  .RESAMPLE_CLK     (rx_clk),
  .SRC_RST_B        (rxs_rstn_src),
  .RESAMPLE_RST_B   (rxs_rstn)
);

f_aim_rego_sync u_rst_sync_3 (
  .inp         (a_reset),
  .outp        (a_reset_w),
  .clk         (sysclk),
  .rstb        (sysrstn)
);

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    a_reset_d <= #0.1 1'b0;
  else
    a_reset_d <= #0.1 a_reset_w;
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    sft_rst <= #0.1 1'b0;
  else begin
    if (a_reset_d & ~a_reset_w)
      sft_rst <= #0.1 1'b1;
    else
      sft_rst <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    sft_set <= #0.1 1'b0;
  else begin
    if (~a_reset_d & a_reset_w)
      sft_set <= #0.1 1'b1;
    else
      sft_set <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    sft_rst_st0 <= #0.1 1'b0;
  else begin
    if (sft_rst)
      sft_rst_st0 <= #0.1 1'b1;
    else if (sft_ack0)
      sft_rst_st0 <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    sft_rst_st1 <= #0.1 1'b0;
  else begin
    if (sft_rst)
      sft_rst_st1 <= #0.1 1'b1;
    else if (sft_ack1)
      sft_rst_st1 <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    sft_rst_st2 <= #0.1 1'b0;
  else begin
    if (sft_rst)
      sft_rst_st2 <= #0.1 1'b1;
    else if (sft_ack2)
      sft_rst_st2 <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    sft_rst_st3 <= #0.1 1'b0;
  else begin
    if (sft_rst)
      sft_rst_st3 <= #0.1 1'b1;
    else if (sft_ack3)
      sft_rst_st3 <= #0.1 1'b0;
  end
end

always @ (posedge sysclk or negedge sysrstn) begin
  if (~sysrstn)
    a_reset_m <= #0.1 1'b1;
  else begin
    if (sft_rst)
      a_reset_m <= #0.1 1'b0;
    else if (~a_reset_m&~sft_rst_st0&~sft_rst_st1&~sft_rst_st2&~sft_rst_st3)
      a_reset_m <= #0.1 1'b1;
  end
end
endmodule



module f_IOPAD_TOP
(
		// output
		BIO_RXD,
		BIO_RXVLD,
		BIO_TXRDY,
		I_RXCK,
		I_RXD,
		I_RXRDY,
		I_RXVLD,
		I_TXCK,
		I_TXD,
		I_TXRDY,
		I_TXVLD,
		PI_CLKIORX,
		// input
		BIO_DDR_EN,
		BIO_EN16B,
		BIO_RXRDY,
		BIO_TXD,
		BIO_TXVLD,
		COMPRESSION_MODE,
		CTS_IGNORE,
		C_RXCK,
		C_RXD,
		C_RXRDY,
		C_RXVLD,
		C_TXCK,
		C_TXD,
		C_TXRDY,
		C_TXVLD,
		FREE_IOCTL_CLKRX,
		HCLK_PAD_OUT,
		HPAD_OEN,
		HPAD_OUT,
		IORX_RST_B,
		IOTX_RST_B,
		MO_IORX_CK_COMP,
		MO_IORX_CK_COMP_CKINV,
		MO_IORX_CLKI_DLY,
		MO_IORX_CLKI_INV,
		MO_IORX_CLKI_POL,
		MO_IORX_CLKO_DLY,
		MO_IORX_CLKO_INV,
		MO_IORX_CLKO_POL,
		MO_IOTX_CK_COMP,
		MO_IOTX_CK_COMP_CKINV,
		MO_IOTX_CLKI_DLY,
		MO_IOTX_CLKI_INV,
		MO_IOTX_CLKI_POL,
		MO_IOTX_CLKO_DLY,
		MO_IOTX_CLKO_INV,
		MO_IOTX_CLKO_POL,
		PO_CLKIOTX,
		RGMII_DATA_SCAN_CLK,
		SFT_CFG_BIO_SEL,
		SI_HPAD_EN,
		SI_VPAD_EN,
		SO_HPAD_EN,
		SO_VPAD_EN,
		TEST_MODE,
		VCLK_PAD_OUT,
		VPAD_OEN,
		VPAD_OUT
);
output	[31:0]	BIO_RXD;
output  [1:0]   BIO_RXVLD;
output		BIO_TXRDY;
output		I_RXCK;
output	[15:0]	I_RXD;
output		I_RXRDY;
output		I_RXVLD;
output		I_TXCK;
output	[15:0]	I_TXD;
output		I_TXRDY;
output		I_TXVLD;
output		PI_CLKIORX;
input		BIO_DDR_EN;
input		BIO_EN16B;
input		BIO_RXRDY;
input	[31:0]	BIO_TXD;
input   [1:0]   BIO_TXVLD;
input		COMPRESSION_MODE;
input		CTS_IGNORE;
input		C_RXCK;
input	[15:0]	C_RXD;
input		C_RXRDY;
input		C_RXVLD;
input		C_TXCK;
input	[15:0]	C_TXD;
input		C_TXRDY;
input		C_TXVLD;
input		FREE_IOCTL_CLKRX;
input		HCLK_PAD_OUT;
input	[17:0]	HPAD_OEN;
input	[17:0]	HPAD_OUT;
input		IORX_RST_B;
input		IOTX_RST_B;
input		MO_IORX_CK_COMP;
input		MO_IORX_CK_COMP_CKINV;
input	[3:0]	MO_IORX_CLKI_DLY;
input		MO_IORX_CLKI_INV;
input		MO_IORX_CLKI_POL;
input	[3:0]	MO_IORX_CLKO_DLY;
input		MO_IORX_CLKO_INV;
input		MO_IORX_CLKO_POL;
input		MO_IOTX_CK_COMP;
input		MO_IOTX_CK_COMP_CKINV;
input	[3:0]	MO_IOTX_CLKI_DLY;
input		MO_IOTX_CLKI_INV;
input		MO_IOTX_CLKI_POL;
input	[3:0]	MO_IOTX_CLKO_DLY;
input		MO_IOTX_CLKO_INV;
input		MO_IOTX_CLKO_POL;
input		PO_CLKIOTX;
input		RGMII_DATA_SCAN_CLK;
input		SFT_CFG_BIO_SEL;
input	[17:0]	SI_HPAD_EN;
input	[17:0]	SI_VPAD_EN;
input	[17:0]	SO_HPAD_EN;
input	[17:0]	SO_VPAD_EN;
input		TEST_MODE;
input		VCLK_PAD_OUT;
input	[17:0]	VPAD_OEN;
input	[17:0]	VPAD_OUT;
//-------------------------------------------
//      ---f_IOPAD_V_CTRL---
//-------------------------------------------
wire		BIO_DDR_EN;
wire		BIO_EN16B;
wire	[15:0]	BIO_RXD_V;
wire		BIO_RXRDY;
wire	[31:0]	BIO_TXD;
wire    [1:0]   BIO_TXVLD;
wire		C_TXCK;
wire	[15:0]	C_TXD;
wire		C_TXRDY;
wire		C_TXVLD;
wire		FREE_IOCTL_CLKRX;
wire		IORX_RST_B;
wire		IOTX_RST_B;
wire		I_TXCK;
wire	[15:0]	I_TXD;
wire		I_TXRDY;
wire		I_TXVLD;
wire		MO_IOTX_CK_COMP;
wire		MO_IOTX_CK_COMP_CKINV;
wire	[3:0]	MO_IOTX_CLKI_DLY;
wire		MO_IOTX_CLKI_INV;
wire		MO_IOTX_CLKI_POL;
wire	[3:0]	MO_IOTX_CLKO_DLY;
wire		MO_IOTX_CLKO_INV;
wire		MO_IOTX_CLKO_POL;
wire		PO_CLKIOTX;
wire		RGMII_DATA_SCAN_CLK;
wire		RG_TX_CK_COMP;
wire		RG_TX_CK_COMP_CKINV;
wire		RG_VCLKI_DIS;
wire	[3:0]	RG_VCLKI_DLY;
wire		RG_VCLKI_INV;
wire		RG_VCLKI_POL;
wire		RG_VCLKI_SRC;
wire	[3:0]	RG_VCLKO_DLY;
wire		RG_VCLKO_INV;
wire		RG_VCLKO_POL;
wire		RG_VCLKO_SRC;
wire		RG_VCLK_RGMII_MODE_EN;
wire	[17:0]	RG_VPAD_DDR_EN;
wire	[17:0]	RG_VPAD_EDGEA;
wire	[17:0]	RG_VPAD_EDGEB;
wire	[17:0]	RG_VPAD_IN_DIS;
wire	[17:0]	RG_VPAD_RGMII_MODE_EN;
wire	[17:0]	RG_VPAD_XOR_EN;
wire		SFT_CFG_BIO_SEL;
wire		TEST_MODE;
wire		VCLK0;
wire		VCLK1;
wire		VCLKI_OUT;
wire		VCLK_IN;
wire		VCLK_PAD_C;
wire		VCLK_PAD_I;
wire		VCLK_SDO;
wire		VCLK_SRC;
wire		VPAD0_RST_B;
wire		VPAD1_RST_B;
wire	[17:0]	VPAD_C;
wire	[17:0]	VPAD_I;
wire	[17:0]	VPAD_O_RESET_VALUE;
wire	[17:0]	VPAD_RXD_N;
wire	[17:0]	VPAD_RXD_P;
wire	[17:0]	VPAD_TXD_N;
wire	[17:0]	VPAD_TXD_P;
//-------------------------------------------
//      ---f_IOPAD_V_ALL---
//-------------------------------------------
wire		COMPRESSION_MODE;
wire		CTS_IGNORE;
wire	[17:0]	SI_VPAD_EN;
wire	[17:0]	SO_VPAD_EN;
wire		VCLK_PAD_OUT;
wire	[17:0]	VPAD_OEN;
wire	[17:0]	VPAD_OUT;
//-------------------------------------------
//      ---f_IOPAD_H_CTRL---
//-------------------------------------------
wire	[31:0]	BIO_RXD;
wire    [1:0]   BIO_RXVLD;
wire		BIO_TXRDY;
wire		C_RXCK;
wire	[15:0]	C_RXD;
wire		C_RXRDY;
wire		C_RXVLD;
wire		HCLK;
wire		HCLKI_OUT;
wire		HCLK_IN;
wire		HCLK_PAD_C;
wire		HCLK_PAD_I;
wire		HCLK_SDO;
wire		HCLK_SRC;
wire	[17:0]	HPAD_C;
wire	[17:0]	HPAD_I;
wire	[17:0]	HPAD_O_RESET_VALUE;
wire		HPAD_RST_B;
wire	[17:0]	HPAD_RXD_N;
wire	[17:0]	HPAD_RXD_P;
wire	[17:0]	HPAD_TXD_N;
wire	[17:0]	HPAD_TXD_P;
wire		I_RXCK;
wire	[15:0]	I_RXD;
wire		I_RXRDY;
wire		I_RXVLD;
wire		MO_IORX_CK_COMP;
wire		MO_IORX_CK_COMP_CKINV;
wire	[3:0]	MO_IORX_CLKI_DLY;
wire		MO_IORX_CLKI_INV;
wire		MO_IORX_CLKI_POL;
wire	[3:0]	MO_IORX_CLKO_DLY;
wire		MO_IORX_CLKO_INV;
wire		MO_IORX_CLKO_POL;
wire		PI_CLKIORX;
wire		RG_HCLKI_DIS;
wire	[3:0]	RG_HCLKI_DLY;
wire		RG_HCLKI_INV;
wire		RG_HCLKI_POL;
wire		RG_HCLKI_SRC;
wire	[3:0]	RG_HCLKO_DLY;
wire		RG_HCLKO_INV;
wire		RG_HCLKO_POL;
wire		RG_HCLKO_SRC;
wire		RG_HCLK_RGMII_MODE_EN;
wire	[17:0]	RG_HPAD_DDR_EN;
wire	[17:0]	RG_HPAD_EDGEA;
wire	[17:0]	RG_HPAD_EDGEB;
wire	[17:0]	RG_HPAD_IN_DIS;
wire	[17:0]	RG_HPAD_RGMII_MODE_EN;
wire	[17:0]	RG_HPAD_XOR_EN;
wire		RG_RX_CK_COMP;
wire		RG_RX_CK_COMP_CKINV;
//-------------------------------------------
//      ---f_IOPAD_H_ALL---
//-------------------------------------------
wire		HCLK_PAD_OUT;
wire	[17:0]	HPAD_OEN;
wire	[17:0]	HPAD_OUT;
wire	[17:0]	SI_HPAD_EN;
wire	[17:0]	SO_HPAD_EN;

f_IOPAD_V_CTRL IOPAD_V_CTRL0
(
	// inouts,
	// outputs,
	.BIO_RXD_V                       (BIO_RXD_V),
	.I_TXCK                          (I_TXCK),
	.I_TXD                           (I_TXD),
	.I_TXRDY                         (I_TXRDY),
	.I_TXVLD                         (I_TXVLD),
	.RG_TX_CK_COMP                   (RG_TX_CK_COMP),
	.RG_TX_CK_COMP_CKINV             (RG_TX_CK_COMP_CKINV),
	.RG_VCLKI_DIS                    (RG_VCLKI_DIS),
	.RG_VCLKI_DLY                    (RG_VCLKI_DLY),
	.RG_VCLKI_INV                    (RG_VCLKI_INV),
	.RG_VCLKI_POL                    (RG_VCLKI_POL),
	.RG_VCLKI_SRC                    (RG_VCLKI_SRC),
	.RG_VCLKO_DLY                    (RG_VCLKO_DLY),
	.RG_VCLKO_INV                    (RG_VCLKO_INV),
	.RG_VCLKO_POL                    (RG_VCLKO_POL),
	.RG_VCLKO_SRC                    (RG_VCLKO_SRC),
	.RG_VCLK_RGMII_MODE_EN           (RG_VCLK_RGMII_MODE_EN),
	.RG_VPAD_DDR_EN                  (RG_VPAD_DDR_EN),
	.RG_VPAD_EDGEA                   (RG_VPAD_EDGEA),
	.RG_VPAD_EDGEB                   (RG_VPAD_EDGEB),
	.RG_VPAD_IN_DIS                  (RG_VPAD_IN_DIS),
	.RG_VPAD_RGMII_MODE_EN           (RG_VPAD_RGMII_MODE_EN),
	.RG_VPAD_XOR_EN                  (RG_VPAD_XOR_EN),
	.VCLK0                           (VCLK0),
	.VCLK1                           (VCLK1),
	.VCLK_IN                         (VCLK_IN),
	.VCLK_PAD_C                      (VCLK_PAD_C),
	.VCLK_SRC                        (VCLK_SRC),
	.VPAD0_RST_B                     (VPAD0_RST_B),
	.VPAD1_RST_B                     (VPAD1_RST_B),
	.VPAD_C                          (VPAD_C),
	.VPAD_O_RESET_VALUE              (VPAD_O_RESET_VALUE),
	.VPAD_TXD_N                      (VPAD_TXD_N),
	.VPAD_TXD_P                      (VPAD_TXD_P),
	// inputs,
	.BIO_DDR_EN                      (BIO_DDR_EN),
	.BIO_EN16B                       (BIO_EN16B),
	.BIO_RXRDY                       (BIO_RXRDY),
	.BIO_TXD                         (BIO_TXD),
	.BIO_TXVLD                       (BIO_TXVLD),
	.C_TXCK                          (C_TXCK),
	.C_TXD                           (C_TXD),
	.C_TXRDY                         (C_TXRDY),
	.C_TXVLD                         (C_TXVLD),
	.FREE_IOCTL_CLKRX                (FREE_IOCTL_CLKRX),
	.IORX_RST_B                      (IORX_RST_B),
	.IOTX_RST_B                      (IOTX_RST_B),
	.MO_IOTX_CK_COMP                 (MO_IOTX_CK_COMP),
	.MO_IOTX_CK_COMP_CKINV           (MO_IOTX_CK_COMP_CKINV),
	.MO_IOTX_CLKI_DLY                (MO_IOTX_CLKI_DLY),
	.MO_IOTX_CLKI_INV                (MO_IOTX_CLKI_INV),
	.MO_IOTX_CLKI_POL                (MO_IOTX_CLKI_POL),
	.MO_IOTX_CLKO_DLY                (MO_IOTX_CLKO_DLY),
	.MO_IOTX_CLKO_INV                (MO_IOTX_CLKO_INV),
	.MO_IOTX_CLKO_POL                (MO_IOTX_CLKO_POL),
	.PO_CLKIOTX                      (PO_CLKIOTX),
	.RGMII_DATA_SCAN_CLK             (RGMII_DATA_SCAN_CLK),
	.SFT_CFG_BIO_SEL                 (SFT_CFG_BIO_SEL),
	.TEST_MODE                       (TEST_MODE),
	.VCLKI_OUT                       (VCLKI_OUT),
	.VCLK_PAD_I                      (VCLK_PAD_I),
	.VCLK_SDO                        (VCLK_SDO),
	.VPAD_I                          (VPAD_I),
	.VPAD_RXD_N                      (VPAD_RXD_N),
	.VPAD_RXD_P                      (VPAD_RXD_P)
);

f_IOPAD_V_ALL IOPAD_V_ALL0
(
	// inouts,
	// outputs,
	.VCLKI_OUT                       (VCLKI_OUT),
	.VCLK_PAD_I                      (VCLK_PAD_I),
	.VCLK_SDO                        (VCLK_SDO),
	.VPAD_I                          (VPAD_I),
	.VPAD_RXD_N                      (VPAD_RXD_N),
	.VPAD_RXD_P                      (VPAD_RXD_P),
	// inputs,
	.COMPRESSION_MODE                (COMPRESSION_MODE),
	.CTS_IGNORE                      (CTS_IGNORE),
	.RG_TX_CK_COMP                   (RG_TX_CK_COMP),
	.RG_TX_CK_COMP_CKINV             (RG_TX_CK_COMP_CKINV),
	.RG_VCLKI_DIS                    (RG_VCLKI_DIS),
	.RG_VCLKI_DLY                    (RG_VCLKI_DLY),
	.RG_VCLKI_INV                    (RG_VCLKI_INV),
	.RG_VCLKI_POL                    (RG_VCLKI_POL),
	.RG_VCLKI_SRC                    (RG_VCLKI_SRC),
	.RG_VCLKO_DLY                    (RG_VCLKO_DLY),
	.RG_VCLKO_INV                    (RG_VCLKO_INV),
	.RG_VCLKO_POL                    (RG_VCLKO_POL),
	.RG_VCLKO_SRC                    (RG_VCLKO_SRC),
	.RG_VCLK_RGMII_MODE_EN           (RG_VCLK_RGMII_MODE_EN),
	.RG_VPAD_DDR_EN                  (RG_VPAD_DDR_EN),
	.RG_VPAD_EDGEA                   (RG_VPAD_EDGEA),
	.RG_VPAD_EDGEB                   (RG_VPAD_EDGEB),
	.RG_VPAD_IN_DIS                  (RG_VPAD_IN_DIS),
	.RG_VPAD_RGMII_MODE_EN           (RG_VPAD_RGMII_MODE_EN),
	.RG_VPAD_XOR_EN                  (RG_VPAD_XOR_EN),
	.SI_VPAD_EN                      (SI_VPAD_EN),
	.SO_VPAD_EN                      (SO_VPAD_EN),
	.TEST_MODE                       (TEST_MODE),
	.VCLK0                           (VCLK0),
	.VCLK1                           (VCLK1),
	.VCLK_IN                         (VCLK_IN),
	.VCLK_PAD_C                      (VCLK_PAD_C),
	.VCLK_PAD_OUT                    (VCLK_PAD_OUT),
	.VCLK_SRC                        (VCLK_SRC),
	.VPAD0_RST_B                     (VPAD0_RST_B),
	.VPAD1_RST_B                     (VPAD1_RST_B),
	.VPAD_C                          (VPAD_C),
	.VPAD_OEN                        (VPAD_OEN),
	.VPAD_OUT                        (VPAD_OUT),
	.VPAD_O_RESET_VALUE              (VPAD_O_RESET_VALUE),
	.VPAD_TXD_N                      (VPAD_TXD_N),
	.VPAD_TXD_P                      (VPAD_TXD_P)
);

f_IOPAD_H_CTRL IOPAD_H_CTRL0
(
	// inouts,
	// outputs,
	.BIO_RXD                         (BIO_RXD),
	.BIO_RXVLD                       (BIO_RXVLD),
	.BIO_TXRDY                       (BIO_TXRDY),
	.HCLK                            (HCLK),
	.HCLK_IN                         (HCLK_IN),
	.HCLK_PAD_C                      (HCLK_PAD_C),
	.HCLK_SRC                        (HCLK_SRC),
	.HPAD_C                          (HPAD_C),
	.HPAD_O_RESET_VALUE              (HPAD_O_RESET_VALUE),
	.HPAD_RST_B                      (HPAD_RST_B),
	.HPAD_TXD_N                      (HPAD_TXD_N),
	.HPAD_TXD_P                      (HPAD_TXD_P),
	.I_RXCK                          (I_RXCK),
	.I_RXD                           (I_RXD),
	.I_RXRDY                         (I_RXRDY),
	.I_RXVLD                         (I_RXVLD),
	.PI_CLKIORX                      (PI_CLKIORX),
	.RG_HCLKI_DIS                    (RG_HCLKI_DIS),
	.RG_HCLKI_DLY                    (RG_HCLKI_DLY),
	.RG_HCLKI_INV                    (RG_HCLKI_INV),
	.RG_HCLKI_POL                    (RG_HCLKI_POL),
	.RG_HCLKI_SRC                    (RG_HCLKI_SRC),
	.RG_HCLKO_DLY                    (RG_HCLKO_DLY),
	.RG_HCLKO_INV                    (RG_HCLKO_INV),
	.RG_HCLKO_POL                    (RG_HCLKO_POL),
	.RG_HCLKO_SRC                    (RG_HCLKO_SRC),
	.RG_HCLK_RGMII_MODE_EN           (RG_HCLK_RGMII_MODE_EN),
	.RG_HPAD_DDR_EN                  (RG_HPAD_DDR_EN),
	.RG_HPAD_EDGEA                   (RG_HPAD_EDGEA),
	.RG_HPAD_EDGEB                   (RG_HPAD_EDGEB),
	.RG_HPAD_IN_DIS                  (RG_HPAD_IN_DIS),
	.RG_HPAD_RGMII_MODE_EN           (RG_HPAD_RGMII_MODE_EN),
	.RG_HPAD_XOR_EN                  (RG_HPAD_XOR_EN),
	.RG_RX_CK_COMP                   (RG_RX_CK_COMP),
	.RG_RX_CK_COMP_CKINV             (RG_RX_CK_COMP_CKINV),
	// inputs,
	.BIO_DDR_EN                      (BIO_DDR_EN),
	.BIO_EN16B                       (BIO_EN16B),
	.BIO_RXD_V                       (BIO_RXD_V),
	.C_RXCK                          (C_RXCK),
	.C_RXD                           (C_RXD),
	.C_RXRDY                         (C_RXRDY),
	.C_RXVLD                         (C_RXVLD),
	.FREE_IOCTL_CLKRX                (FREE_IOCTL_CLKRX),
	.HCLKI_OUT                       (HCLKI_OUT),
	.HCLK_PAD_I                      (HCLK_PAD_I),
	.HCLK_SDO                        (HCLK_SDO),
	.HPAD_I                          (HPAD_I),
	.HPAD_RXD_N                      (HPAD_RXD_N),
	.HPAD_RXD_P                      (HPAD_RXD_P),
	.IORX_RST_B                      (IORX_RST_B),
	.MO_IORX_CK_COMP                 (MO_IORX_CK_COMP),
	.MO_IORX_CK_COMP_CKINV           (MO_IORX_CK_COMP_CKINV),
	.MO_IORX_CLKI_DLY                (MO_IORX_CLKI_DLY),
	.MO_IORX_CLKI_INV                (MO_IORX_CLKI_INV),
	.MO_IORX_CLKI_POL                (MO_IORX_CLKI_POL),
	.MO_IORX_CLKO_DLY                (MO_IORX_CLKO_DLY),
	.MO_IORX_CLKO_INV                (MO_IORX_CLKO_INV),
	.MO_IORX_CLKO_POL                (MO_IORX_CLKO_POL),
	.RGMII_DATA_SCAN_CLK             (RGMII_DATA_SCAN_CLK),
	.SFT_CFG_BIO_SEL                 (SFT_CFG_BIO_SEL),
	.TEST_MODE                       (TEST_MODE)
);

f_IOPAD_H_ALL IOPAD_H_ALL0
(
	// inouts,
	// outputs,
	.HCLKI_OUT                       (HCLKI_OUT),
	.HCLK_PAD_I                      (HCLK_PAD_I),
	.HCLK_SDO                        (HCLK_SDO),
	.HPAD_I                          (HPAD_I),
	.HPAD_RXD_N                      (HPAD_RXD_N),
	.HPAD_RXD_P                      (HPAD_RXD_P),
	// inputs,
	.COMPRESSION_MODE                (COMPRESSION_MODE),
	.CTS_IGNORE                      (CTS_IGNORE),
	.HCLK                            (HCLK),
	.HCLK_IN                         (HCLK_IN),
	.HCLK_PAD_C                      (HCLK_PAD_C),
	.HCLK_PAD_OUT                    (HCLK_PAD_OUT),
	.HCLK_SRC                        (HCLK_SRC),
	.HPAD_C                          (HPAD_C),
	.HPAD_OEN                        (HPAD_OEN),
	.HPAD_OUT                        (HPAD_OUT),
	.HPAD_O_RESET_VALUE              (HPAD_O_RESET_VALUE),
	.HPAD_RST_B                      (HPAD_RST_B),
	.HPAD_TXD_N                      (HPAD_TXD_N),
	.HPAD_TXD_P                      (HPAD_TXD_P),
	.RG_HCLKI_DIS                    (RG_HCLKI_DIS),
	.RG_HCLKI_DLY                    (RG_HCLKI_DLY),
	.RG_HCLKI_INV                    (RG_HCLKI_INV),
	.RG_HCLKI_POL                    (RG_HCLKI_POL),
	.RG_HCLKI_SRC                    (RG_HCLKI_SRC),
	.RG_HCLKO_DLY                    (RG_HCLKO_DLY),
	.RG_HCLKO_INV                    (RG_HCLKO_INV),
	.RG_HCLKO_POL                    (RG_HCLKO_POL),
	.RG_HCLKO_SRC                    (RG_HCLKO_SRC),
	.RG_HCLK_RGMII_MODE_EN           (RG_HCLK_RGMII_MODE_EN),
	.RG_HPAD_DDR_EN                  (RG_HPAD_DDR_EN),
	.RG_HPAD_EDGEA                   (RG_HPAD_EDGEA),
	.RG_HPAD_EDGEB                   (RG_HPAD_EDGEB),
	.RG_HPAD_IN_DIS                  (RG_HPAD_IN_DIS),
	.RG_HPAD_RGMII_MODE_EN           (RG_HPAD_RGMII_MODE_EN),
	.RG_HPAD_XOR_EN                  (RG_HPAD_XOR_EN),
	.RG_RX_CK_COMP                   (RG_RX_CK_COMP),
	.RG_RX_CK_COMP_CKINV             (RG_RX_CK_COMP_CKINV),
	.SI_HPAD_EN                      (SI_HPAD_EN),
	.SO_HPAD_EN                      (SO_HPAD_EN),
	.TEST_MODE                       (TEST_MODE)
);

endmodule

module f_IOPAD_V_CTRL(
	/*autoarg*/
//*******
// Inputs
//*******
    PO_CLKIOTX, IOTX_RST_B, IORX_RST_B, FREE_IOCTL_CLKRX,
    MO_IOTX_CLKO_INV, MO_IOTX_CLKO_DLY, MO_IOTX_CLKO_POL,
    MO_IOTX_CLKI_INV, MO_IOTX_CLKI_DLY, MO_IOTX_CLKI_POL,
    MO_IOTX_CK_COMP_CKINV, MO_IOTX_CK_COMP, SFT_CFG_BIO_SEL,
    BIO_EN16B, BIO_DDR_EN, BIO_TXD, BIO_TXVLD, BIO_RXRDY, VCLK_SDO,
    VCLKI_OUT, VPAD_RXD_P, VPAD_RXD_N, VPAD_I, C_TXD, C_TXRDY,
    C_TXVLD, VCLK_PAD_I, C_TXCK, TEST_MODE, RGMII_DATA_SCAN_CLK,
//********
// Outputs
//********
    BIO_RXD_V, VCLK_IN, VCLK_SRC, VCLK0, VCLK1, VPAD0_RST_B,
    VPAD1_RST_B, RG_VCLKO_INV, RG_VCLKO_DLY, RG_VCLKO_SRC,
    RG_VCLKO_POL, RG_VCLK_RGMII_MODE_EN, RG_VCLKI_SRC, RG_VCLKI_DIS,
    RG_VCLKI_INV, RG_VCLKI_DLY, RG_VCLKI_POL, RG_TX_CK_COMP_CKINV,
    RG_TX_CK_COMP, RG_VPAD_XOR_EN, RG_VPAD_RGMII_MODE_EN,
    RG_VPAD_DDR_EN, RG_VPAD_EDGEA, RG_VPAD_EDGEB, RG_VPAD_IN_DIS,
    VPAD_O_RESET_VALUE, VPAD_TXD_P, VPAD_TXD_N, I_TXD, I_TXRDY,
    I_TXVLD, VPAD_C, I_TXCK, VCLK_PAD_C
    );
//=============================================================================
//Interface with chip internal module
//=============================================================================
//clock and reset from CLKGEN/RSTGEN
input	PO_CLKIOTX;
input	IOTX_RST_B;
input	IORX_RST_B;
input	FREE_IOCTL_CLKRX;
//register configuration for txclk pad from MOON
input	MO_IOTX_CLKO_INV;
input	[3:0]	MO_IOTX_CLKO_DLY;
input	MO_IOTX_CLKO_POL;
input	MO_IOTX_CLKI_INV;
input	[3:0]	MO_IOTX_CLKI_DLY;
input	MO_IOTX_CLKI_POL;
//clock invert or not in compensate circuit, default 0(not invert)
input	MO_IOTX_CK_COMP_CKINV;
//using softpad clock or compensate clock, default 0(using compensate clock)
input	MO_IOTX_CK_COMP;
//high active to enable "RGMII_MODE" of softpad
input	SFT_CFG_BIO_SEL;
//high active to enable 16bit mode
input	BIO_EN16B;
//high active to enable DDR mode
input	BIO_DDR_EN;
//=============================================================================
//Interface with BIO_CTRL
//=============================================================================
input	[31:0]	BIO_TXD;
input   [1:0]   BIO_TXVLD;
input		BIO_RXRDY;
output	[15:0]	BIO_RXD_V;
//=============================================================================
//Interface with module f_IOPAD_V_ALL
//=============================================================================
//clock and reset interface with module f_IOPAD_V_ALL
output		VCLK_IN;
output		VCLK_SRC;
output		VCLK0;
output		VCLK1;
output	VPAD0_RST_B;
output	VPAD1_RST_B;

input	VCLK_SDO;
input	VCLKI_OUT;

//clock pad configuration
output	RG_VCLKO_INV;
output	[3:0]	RG_VCLKO_DLY;
output	RG_VCLKO_SRC;
output	RG_VCLKO_POL;
output	RG_VCLK_RGMII_MODE_EN;
output	RG_VCLKI_SRC;
output	RG_VCLKI_DIS;
output	RG_VCLKI_INV;
output	[3:0]	RG_VCLKI_DLY;
output	RG_VCLKI_POL;
//clock invert or not in compensate circuit, default 0(not invert)
output	RG_TX_CK_COMP_CKINV;
//using softpad clock or compensate clock, default 0(using compensate clock)
output	RG_TX_CK_COMP;


//data pad configuration
output	[17:0]	RG_VPAD_XOR_EN;
output	[17:0]	RG_VPAD_RGMII_MODE_EN;
output	[17:0]	RG_VPAD_DDR_EN;
output	[17:0]	RG_VPAD_EDGEA;
output	[17:0]	RG_VPAD_EDGEB;
output	[17:0]	RG_VPAD_IN_DIS;
//data pad input and output data
output	[17:0]	VPAD_O_RESET_VALUE;
output	[17:0]	VPAD_TXD_P;
output	[17:0]	VPAD_TXD_N;

input	[17:0]	VPAD_RXD_P;
input	[17:0]	VPAD_RXD_N;

//pad sequence
input	[17:0]	VPAD_I;
output	[15:0]	I_TXD;
output		I_TXRDY;
output		I_TXVLD;

input	[15:0]	C_TXD;
input		C_TXRDY;
input		C_TXVLD;
output	[17:0]	VPAD_C;

input	VCLK_PAD_I;
output	I_TXCK;
input	C_TXCK;
output	VCLK_PAD_C;
//=============================================================================
//Interface with module f_IOPAD_H_ALL
//=============================================================================
//input	HCLKI_OUT;

//scan related
input	TEST_MODE;
input	RGMII_DATA_SCAN_CLK;

//clock connection
wire	VCLK_IN=1'h0;
wire	VCLK_SRC=PO_CLKIOTX;
wire	VCLK0=PO_CLKIOTX;
f_CKMUX_CELL	U_VCLK1_SRCMUX(
	.S0(BIO_EN16B|TEST_MODE),
	.A(FREE_IOCTL_CLKRX),
	.B(PO_CLKIOTX),
	.Y(VCLK1)
);
wire	VPAD0_RST_B=IOTX_RST_B;
wire	VPAD1_RST_B=BIO_EN16B?IOTX_RST_B:IORX_RST_B;

//clock pad control rename
wire	RG_VCLKO_INV=MO_IOTX_CLKO_INV;
wire	[3:0]	RG_VCLKO_DLY=MO_IOTX_CLKO_DLY;
wire	RG_VCLKO_POL=MO_IOTX_CLKO_POL;
wire	RG_VCLK_RGMII_MODE_EN=SFT_CFG_BIO_SEL;
wire	RG_VCLKI_INV=MO_IOTX_CLKI_INV;
wire	[3:0]	RG_VCLKI_DLY=MO_IOTX_CLKI_DLY;
wire	RG_VCLKI_POL=MO_IOTX_CLKI_POL;
wire	RG_TX_CK_COMP_CKINV=MO_IOTX_CK_COMP_CKINV;
wire	RG_TX_CK_COMP=MO_IOTX_CK_COMP|(~SFT_CFG_BIO_SEL);
wire	RG_VCLKO_SRC=1'h1;
wire	RG_VCLKI_SRC=1'h0;
wire	RG_VCLKI_DIS=1'h1;
//data pad configuration
wire	[17:0]	RG_VPAD_XOR_EN=18'h0;
wire	[17:0]	RG_VPAD_RGMII_MODE_EN={18{SFT_CFG_BIO_SEL}};
wire	[17:0]	RG_VPAD_DDR_EN={18{BIO_DDR_EN}};
wire	[17:0]	RG_VPAD_EDGEA={
	{8{BIO_EN16B&BIO_DDR_EN}},			//TXD[15:8] or RXD[7:0]
	BIO_DDR_EN,		//TXVLD
	1'h0,			//RXRDY
	{8{BIO_DDR_EN}}		//TXD[7:0]
	};

wire	[17:0]	RG_VPAD_EDGEB={
	{8{~BIO_EN16B}},			//TXD[15:8] or RXD[7:0]
	1'h0,			//TXVLD
	1'h0,			//RXRDY
	8'h0		//TXD[7:0]
	};

wire	[17:0]	RG_VPAD_IN_DIS={
	{8{BIO_EN16B}},			//TXD[15:8] or RXD[7:0]
	1'h1,			//TXVLD
	1'h1,			//RXRDY
	8'h1		//TXD[7:0]
	};
//data pad input/output data
wire	[17:0]	VPAD_O_RESET_VALUE=18'h0;
wire	[17:0]	VPAD_TXD_P={
	BIO_TXD[15:8],
	BIO_TXVLD[0],
	BIO_RXRDY,
	BIO_TXD[7:0]
	};
wire	[17:0]	VPAD_TXD_N={
	BIO_TXD[31:24],
	BIO_TXVLD[1],
	BIO_RXRDY,
	BIO_TXD[23:16]
	};
wire	[15:0]	BIO_RXD_V={VPAD_RXD_N[17:10],VPAD_RXD_P[17:10]};
//pad sequence
wire	[15:0]	I_TXD={
	VPAD_I[17:10],
	VPAD_I[7:0]
	};
wire	I_TXRDY=VPAD_I[8];
wire	I_TXVLD=VPAD_I[9];
wire	[17:0]	VPAD_C={
	C_TXD[15:8],
	C_TXVLD,
	C_TXRDY,
	C_TXD[7:0]
	};
wire	VCLK_PAD_C=C_TXCK;
wire	I_TXCK=VCLK_PAD_I;
endmodule
module f_IOPAD_V_ALL(
	/*autoarg*/
//*******
// Inputs
//*******
    VCLK_IN, VCLK_SRC, VCLK0, VCLK1, VPAD0_RST_B, VPAD1_RST_B,
    VPAD_O_RESET_VALUE, VPAD_OUT, VPAD_OEN, VPAD_C, VPAD_TXD_P,
    VPAD_TXD_N, RG_VPAD_XOR_EN, RG_VPAD_RGMII_MODE_EN, RG_VPAD_DDR_EN,
    RG_VPAD_EDGEA, RG_VPAD_EDGEB, RG_VPAD_IN_DIS, VCLK_PAD_OUT,
    VCLK_PAD_C, RG_VCLKO_INV, RG_VCLKO_DLY, RG_VCLKO_SRC,
    RG_VCLKO_POL, RG_VCLK_RGMII_MODE_EN, RG_VCLKI_SRC, RG_VCLKI_DIS,
    RG_VCLKI_INV, RG_VCLKI_DLY, RG_VCLKI_POL, RG_TX_CK_COMP_CKINV,
    RG_TX_CK_COMP, TEST_MODE, COMPRESSION_MODE, SO_VPAD_EN,
    SI_VPAD_EN, CTS_IGNORE,
//********
// Outputs
//********
    VCLK_SDO, VCLKI_OUT, VCLK_PAD_I, VPAD_I, VPAD_RXD_P, VPAD_RXD_N
    );

//clock and reset
input	VCLK_IN;
input	VCLK_SRC;
//VCLK0: clock for PAD0~PAD9
input	VCLK0;
//VCLK1: clock for PAD10~PAD17
input	VCLK1;
input	VPAD0_RST_B;
input	VPAD1_RST_B;
output	VCLK_SDO;
output	VCLKI_OUT;

//data/control
input	[17:0]	VPAD_O_RESET_VALUE;
input	[17:0]	VPAD_OUT;
input	[17:0]	VPAD_OEN;
input	[17:0]	VPAD_C;
input	[17:0]	VPAD_TXD_P;
input	[17:0]	VPAD_TXD_N;
input	[17:0]	RG_VPAD_XOR_EN;
input	[17:0]	RG_VPAD_RGMII_MODE_EN;
input	[17:0]	RG_VPAD_DDR_EN;
input	[17:0]	RG_VPAD_EDGEA;
input	[17:0]	RG_VPAD_EDGEB;
input	[17:0]	RG_VPAD_IN_DIS;

input	VCLK_PAD_OUT;
input	VCLK_PAD_C;
input	RG_VCLKO_INV;
input	[3:0]	RG_VCLKO_DLY;
input	RG_VCLKO_SRC;
input	RG_VCLKO_POL;
input	RG_VCLK_RGMII_MODE_EN;
input	RG_VCLKI_SRC;
input	RG_VCLKI_DIS;
input	RG_VCLKI_INV;
input	[3:0]	RG_VCLKI_DLY;
input	RG_VCLKI_POL;
//clock invert or not in compensate circuit, default 0(not invert)
input	RG_TX_CK_COMP_CKINV;
//using softpad clock or compensate clock, default 0(using compensate clock)
input	RG_TX_CK_COMP;

output	VCLK_PAD_I;
output	[17:0]	VPAD_I;
output	[17:0]	VPAD_RXD_P;
output	[17:0]	VPAD_RXD_N;
//scan related
input	TEST_MODE;
//not macro, do not need manual chain
//input	SCAN_EN;
input	COMPRESSION_MODE;
input	[17:0]	SO_VPAD_EN;
input	[17:0]	SI_VPAD_EN;
//delete manual chain
//input	SCAN_IN_V;
//output	SCAN_OUT_V;
//=============================================================================
//Others
//=============================================================================
input	CTS_IGNORE;

/*autowire*/
// Beginning of automatic wires (for undeclared instantiated-module outputs)
wire    [17:0]  VPAD_SCAN_OUT;          // From U_DATAPAD0 of f_PAD_RGMII_DATA.v, ...
// End of automatics

//wire	[17:0]	VPAD_SCAN_IN={VPAD_SCAN_OUT[16:0],SCAN_IN_V};
//wire		SCAN_OUT_V=VPAD_SCAN_OUT[17];
/*
f_PAD_RGMII_DATA AUTO_TEMPLATE(
                   .RST_B		(VPAD0_RST_B),
                   .GMII_CLK		(VCLK0),
                   .O_RESET_VALUE	(VPAD_O_RESET_VALUE[@]),
                   .PAD_OUT		(VPAD_OUT[@]),
                   .PAD_OEN		(VPAD_OEN[@]),
		   .PAD_C		(VPAD_C[@]),
                   .GMII_TXD_P		(VPAD_TXD_P[@]),
                   .GMII_TXD_N		(VPAD_TXD_N[@]),
                   .RG_XOR_EN		(RG_VPAD_XOR_EN[@]),
                   .RG_RGMII_MODE_EN	(RG_VPAD_RGMII_MODE_EN[@]),
                   .RG_DDR_EN		(RG_VPAD_DDR_EN[@]),
                   .RG_EDGEA		(RG_VPAD_EDGEA[@]),
                   .RG_EDGEB		(RG_VPAD_EDGEB[@]),
                   .RG_PAD_IN_DIS	(RG_VPAD_IN_DIS[@]),
                   .COMPRESSION_MODE	(COMPRESSION_MODE),
                   .TEST_MODE		(TEST_MODE),
                   .SCAN_EN		(1'b0),
                   .SCAN_IN		(1'b0),
                   .SO_PAD_EN		(SO_VPAD_EN[@]),
                   .SI_PAD_EN		(SI_VPAD_EN[@]),
		   .PAD_I		(VPAD_I[@]),
                   .GMII_RXD_P		(VPAD_RXD_P[@]),
                   .GMII_RXD_N		(VPAD_RXD_N[@]),
                   .SCAN_OUT		(VPAD_SCAN_OUT[@]));
*/
f_PAD_RGMII_DATA U_DATAPAD0(
	/*autoinst*/
  // Inputs
    .RST_B  ( VPAD0_RST_B ),                                     // Templated
    .GMII_CLK  ( VCLK0 ),                                        // Templated
    .O_RESET_VALUE  ( VPAD_O_RESET_VALUE[0] ),                   // Templated
    .PAD_OUT  ( VPAD_OUT[0] ),                                   // Templated
    .PAD_OEN  ( VPAD_OEN[0] ),                                   // Templated
    .PAD_C  ( VPAD_C[0] ),                                       // Templated
    .GMII_TXD_P  ( VPAD_TXD_P[0] ),                              // Templated
    .GMII_TXD_N  ( VPAD_TXD_N[0] ),                              // Templated
    .RG_XOR_EN  ( RG_VPAD_XOR_EN[0] ),                           // Templated
    .RG_RGMII_MODE_EN  ( RG_VPAD_RGMII_MODE_EN[0] ),             // Templated
    .RG_DDR_EN  ( RG_VPAD_DDR_EN[0] ),                           // Templated
    .RG_EDGEA  ( RG_VPAD_EDGEA[0] ),                             // Templated
    .RG_EDGEB  ( RG_VPAD_EDGEB[0] ),                             // Templated
    .RG_PAD_IN_DIS  ( RG_VPAD_IN_DIS[0] ),                       // Templated
    .TEST_MODE  ( TEST_MODE ),                                   // Templated
    .SCAN_EN  ( 1'b0 ),                                          // Templated
    .SCAN_IN  ( 1'b0 ),                                          // Templated
    .SO_PAD_EN  ( SO_VPAD_EN[0] ),                               // Templated
    .SI_PAD_EN  ( SI_VPAD_EN[0] ),                               // Templated
    .COMPRESSION_MODE  ( COMPRESSION_MODE ),                     // Templated
  // Outputs
    .PAD_I  ( VPAD_I[0] ),                                       // Templated
    .GMII_RXD_P  ( VPAD_RXD_P[0] ),                              // Templated
    .GMII_RXD_N  ( VPAD_RXD_N[0] ),                              // Templated
    .SCAN_OUT  ( VPAD_SCAN_OUT[0] ));                             // Templated
f_PAD_RGMII_DATA U_DATAPAD1(
	/*autoinst*/
  // Inputs
    .RST_B  ( VPAD0_RST_B ),                                     // Templated
    .GMII_CLK  ( VCLK0 ),                                        // Templated
    .O_RESET_VALUE  ( VPAD_O_RESET_VALUE[1] ),                   // Templated
    .PAD_OUT  ( VPAD_OUT[1] ),                                   // Templated
    .PAD_OEN  ( VPAD_OEN[1] ),                                   // Templated
    .PAD_C  ( VPAD_C[1] ),                                       // Templated
    .GMII_TXD_P  ( VPAD_TXD_P[1] ),                              // Templated
    .GMII_TXD_N  ( VPAD_TXD_N[1] ),                              // Templated
    .RG_XOR_EN  ( RG_VPAD_XOR_EN[1] ),                           // Templated
    .RG_RGMII_MODE_EN  ( RG_VPAD_RGMII_MODE_EN[1] ),             // Templated
    .RG_DDR_EN  ( RG_VPAD_DDR_EN[1] ),                           // Templated
    .RG_EDGEA  ( RG_VPAD_EDGEA[1] ),                             // Templated
    .RG_EDGEB  ( RG_VPAD_EDGEB[1] ),                             // Templated
    .RG_PAD_IN_DIS  ( RG_VPAD_IN_DIS[1] ),                       // Templated
    .TEST_MODE  ( TEST_MODE ),                                   // Templated
    .SCAN_EN  ( 1'b0 ),                                          // Templated
    .SCAN_IN  ( 1'b0 ),                                          // Templated
    .SO_PAD_EN  ( SO_VPAD_EN[1] ),                               // Templated
    .SI_PAD_EN  ( SI_VPAD_EN[1] ),                               // Templated
    .COMPRESSION_MODE  ( COMPRESSION_MODE ),                     // Templated
  // Outputs
    .PAD_I  ( VPAD_I[1] ),                                       // Templated
    .GMII_RXD_P  ( VPAD_RXD_P[1] ),                              // Templated
    .GMII_RXD_N  ( VPAD_RXD_N[1] ),                              // Templated
    .SCAN_OUT  ( VPAD_SCAN_OUT[1] ));                             // Templated
f_PAD_RGMII_DATA U_DATAPAD2(
	/*autoinst*/
  // Inputs
    .RST_B  ( VPAD0_RST_B ),                                     // Templated
    .GMII_CLK  ( VCLK0 ),                                        // Templated
    .O_RESET_VALUE  ( VPAD_O_RESET_VALUE[2] ),                   // Templated
    .PAD_OUT  ( VPAD_OUT[2] ),                                   // Templated
    .PAD_OEN  ( VPAD_OEN[2] ),                                   // Templated
    .PAD_C  ( VPAD_C[2] ),                                       // Templated
    .GMII_TXD_P  ( VPAD_TXD_P[2] ),                              // Templated
    .GMII_TXD_N  ( VPAD_TXD_N[2] ),                              // Templated
    .RG_XOR_EN  ( RG_VPAD_XOR_EN[2] ),                           // Templated
    .RG_RGMII_MODE_EN  ( RG_VPAD_RGMII_MODE_EN[2] ),             // Templated
    .RG_DDR_EN  ( RG_VPAD_DDR_EN[2] ),                           // Templated
    .RG_EDGEA  ( RG_VPAD_EDGEA[2] ),                             // Templated
    .RG_EDGEB  ( RG_VPAD_EDGEB[2] ),                             // Templated
    .RG_PAD_IN_DIS  ( RG_VPAD_IN_DIS[2] ),                       // Templated
    .TEST_MODE  ( TEST_MODE ),                                   // Templated
    .SCAN_EN  ( 1'b0 ),                                          // Templated
    .SCAN_IN  ( 1'b0 ),                                          // Templated
    .SO_PAD_EN  ( SO_VPAD_EN[2] ),                               // Templated
    .SI_PAD_EN  ( SI_VPAD_EN[2] ),                               // Templated
    .COMPRESSION_MODE  ( COMPRESSION_MODE ),                     // Templated
  // Outputs
    .PAD_I  ( VPAD_I[2] ),                                       // Templated
    .GMII_RXD_P  ( VPAD_RXD_P[2] ),                              // Templated
    .GMII_RXD_N  ( VPAD_RXD_N[2] ),                              // Templated
    .SCAN_OUT  ( VPAD_SCAN_OUT[2] ));                             // Templated
f_PAD_RGMII_DATA U_DATAPAD3(
	/*autoinst*/
  // Inputs
    .RST_B  ( VPAD0_RST_B ),                                     // Templated
    .GMII_CLK  ( VCLK0 ),                                        // Templated
    .O_RESET_VALUE  ( VPAD_O_RESET_VALUE[3] ),                   // Templated
    .PAD_OUT  ( VPAD_OUT[3] ),                                   // Templated
    .PAD_OEN  ( VPAD_OEN[3] ),                                   // Templated
    .PAD_C  ( VPAD_C[3] ),                                       // Templated
    .GMII_TXD_P  ( VPAD_TXD_P[3] ),                              // Templated
    .GMII_TXD_N  ( VPAD_TXD_N[3] ),                              // Templated
    .RG_XOR_EN  ( RG_VPAD_XOR_EN[3] ),                           // Templated
    .RG_RGMII_MODE_EN  ( RG_VPAD_RGMII_MODE_EN[3] ),             // Templated
    .RG_DDR_EN  ( RG_VPAD_DDR_EN[3] ),                           // Templated
    .RG_EDGEA  ( RG_VPAD_EDGEA[3] ),                             // Templated
    .RG_EDGEB  ( RG_VPAD_EDGEB[3] ),                             // Templated
    .RG_PAD_IN_DIS  ( RG_VPAD_IN_DIS[3] ),                       // Templated
    .TEST_MODE  ( TEST_MODE ),                                   // Templated
    .SCAN_EN  ( 1'b0 ),                                          // Templated
    .SCAN_IN  ( 1'b0 ),                                          // Templated
    .SO_PAD_EN  ( SO_VPAD_EN[3] ),                               // Templated
    .SI_PAD_EN  ( SI_VPAD_EN[3] ),                               // Templated
    .COMPRESSION_MODE  ( COMPRESSION_MODE ),                     // Templated
  // Outputs
    .PAD_I  ( VPAD_I[3] ),                                       // Templated
    .GMII_RXD_P  ( VPAD_RXD_P[3] ),                              // Templated
    .GMII_RXD_N  ( VPAD_RXD_N[3] ),                              // Templated
    .SCAN_OUT  ( VPAD_SCAN_OUT[3] ));                             // Templated
f_PAD_RGMII_DATA U_DATAPAD4(
	/*autoinst*/
  // Inputs
    .RST_B  ( VPAD0_RST_B ),                                     // Templated
    .GMII_CLK  ( VCLK0 ),                                        // Templated
    .O_RESET_VALUE  ( VPAD_O_RESET_VALUE[4] ),                   // Templated
    .PAD_OUT  ( VPAD_OUT[4] ),                                   // Templated
    .PAD_OEN  ( VPAD_OEN[4] ),                                   // Templated
    .PAD_C  ( VPAD_C[4] ),                                       // Templated
    .GMII_TXD_P  ( VPAD_TXD_P[4] ),                              // Templated
    .GMII_TXD_N  ( VPAD_TXD_N[4] ),                              // Templated
    .RG_XOR_EN  ( RG_VPAD_XOR_EN[4] ),                           // Templated
    .RG_RGMII_MODE_EN  ( RG_VPAD_RGMII_MODE_EN[4] ),             // Templated
    .RG_DDR_EN  ( RG_VPAD_DDR_EN[4] ),                           // Templated
    .RG_EDGEA  ( RG_VPAD_EDGEA[4] ),                             // Templated
    .RG_EDGEB  ( RG_VPAD_EDGEB[4] ),                             // Templated
    .RG_PAD_IN_DIS  ( RG_VPAD_IN_DIS[4] ),                       // Templated
    .TEST_MODE  ( TEST_MODE ),                                   // Templated
    .SCAN_EN  ( 1'b0 ),                                          // Templated
    .SCAN_IN  ( 1'b0 ),                                          // Templated
    .SO_PAD_EN  ( SO_VPAD_EN[4] ),                               // Templated
    .SI_PAD_EN  ( SI_VPAD_EN[4] ),                               // Templated
    .COMPRESSION_MODE  ( COMPRESSION_MODE ),                     // Templated
  // Outputs
    .PAD_I  ( VPAD_I[4] ),                                       // Templated
    .GMII_RXD_P  ( VPAD_RXD_P[4] ),                              // Templated
    .GMII_RXD_N  ( VPAD_RXD_N[4] ),                              // Templated
    .SCAN_OUT  ( VPAD_SCAN_OUT[4] ));                             // Templated
f_PAD_RGMII_DATA U_DATAPAD5(
	/*autoinst*/
  // Inputs
    .RST_B  ( VPAD0_RST_B ),                                     // Templated
    .GMII_CLK  ( VCLK0 ),                                        // Templated
    .O_RESET_VALUE  ( VPAD_O_RESET_VALUE[5] ),                   // Templated
    .PAD_OUT  ( VPAD_OUT[5] ),                                   // Templated
    .PAD_OEN  ( VPAD_OEN[5] ),                                   // Templated
    .PAD_C  ( VPAD_C[5] ),                                       // Templated
    .GMII_TXD_P  ( VPAD_TXD_P[5] ),                              // Templated
    .GMII_TXD_N  ( VPAD_TXD_N[5] ),                              // Templated
    .RG_XOR_EN  ( RG_VPAD_XOR_EN[5] ),                           // Templated
    .RG_RGMII_MODE_EN  ( RG_VPAD_RGMII_MODE_EN[5] ),             // Templated
    .RG_DDR_EN  ( RG_VPAD_DDR_EN[5] ),                           // Templated
    .RG_EDGEA  ( RG_VPAD_EDGEA[5] ),                             // Templated
    .RG_EDGEB  ( RG_VPAD_EDGEB[5] ),                             // Templated
    .RG_PAD_IN_DIS  ( RG_VPAD_IN_DIS[5] ),                       // Templated
    .TEST_MODE  ( TEST_MODE ),                                   // Templated
    .SCAN_EN  ( 1'b0 ),                                          // Templated
    .SCAN_IN  ( 1'b0 ),                                          // Templated
    .SO_PAD_EN  ( SO_VPAD_EN[5] ),                               // Templated
    .SI_PAD_EN  ( SI_VPAD_EN[5] ),                               // Templated
    .COMPRESSION_MODE  ( COMPRESSION_MODE ),                     // Templated
  // Outputs
    .PAD_I  ( VPAD_I[5] ),                                       // Templated
    .GMII_RXD_P  ( VPAD_RXD_P[5] ),                              // Templated
    .GMII_RXD_N  ( VPAD_RXD_N[5] ),                              // Templated
    .SCAN_OUT  ( VPAD_SCAN_OUT[5] ));                             // Templated
f_PAD_RGMII_DATA U_DATAPAD6(
	/*autoinst*/
  // Inputs
    .RST_B  ( VPAD0_RST_B ),                                     // Templated
    .GMII_CLK  ( VCLK0 ),                                        // Templated
    .O_RESET_VALUE  ( VPAD_O_RESET_VALUE[6] ),                   // Templated
    .PAD_OUT  ( VPAD_OUT[6] ),                                   // Templated
    .PAD_OEN  ( VPAD_OEN[6] ),                                   // Templated
    .PAD_C  ( VPAD_C[6] ),                                       // Templated
    .GMII_TXD_P  ( VPAD_TXD_P[6] ),                              // Templated
    .GMII_TXD_N  ( VPAD_TXD_N[6] ),                              // Templated
    .RG_XOR_EN  ( RG_VPAD_XOR_EN[6] ),                           // Templated
    .RG_RGMII_MODE_EN  ( RG_VPAD_RGMII_MODE_EN[6] ),             // Templated
    .RG_DDR_EN  ( RG_VPAD_DDR_EN[6] ),                           // Templated
    .RG_EDGEA  ( RG_VPAD_EDGEA[6] ),                             // Templated
    .RG_EDGEB  ( RG_VPAD_EDGEB[6] ),                             // Templated
    .RG_PAD_IN_DIS  ( RG_VPAD_IN_DIS[6] ),                       // Templated
    .TEST_MODE  ( TEST_MODE ),                                   // Templated
    .SCAN_EN  ( 1'b0 ),                                          // Templated
    .SCAN_IN  ( 1'b0 ),                                          // Templated
    .SO_PAD_EN  ( SO_VPAD_EN[6] ),                               // Templated
    .SI_PAD_EN  ( SI_VPAD_EN[6] ),                               // Templated
    .COMPRESSION_MODE  ( COMPRESSION_MODE ),                     // Templated
  // Outputs
    .PAD_I  ( VPAD_I[6] ),                                       // Templated
    .GMII_RXD_P  ( VPAD_RXD_P[6] ),                              // Templated
    .GMII_RXD_N  ( VPAD_RXD_N[6] ),                              // Templated
    .SCAN_OUT  ( VPAD_SCAN_OUT[6] ));                             // Templated
f_PAD_RGMII_DATA U_DATAPAD7(
	/*autoinst*/
  // Inputs
    .RST_B  ( VPAD0_RST_B ),                                     // Templated
    .GMII_CLK  ( VCLK0 ),                                        // Templated
    .O_RESET_VALUE  ( VPAD_O_RESET_VALUE[7] ),                   // Templated
    .PAD_OUT  ( VPAD_OUT[7] ),                                   // Templated
    .PAD_OEN  ( VPAD_OEN[7] ),                                   // Templated
    .PAD_C  ( VPAD_C[7] ),                                       // Templated
    .GMII_TXD_P  ( VPAD_TXD_P[7] ),                              // Templated
    .GMII_TXD_N  ( VPAD_TXD_N[7] ),                              // Templated
    .RG_XOR_EN  ( RG_VPAD_XOR_EN[7] ),                           // Templated
    .RG_RGMII_MODE_EN  ( RG_VPAD_RGMII_MODE_EN[7] ),             // Templated
    .RG_DDR_EN  ( RG_VPAD_DDR_EN[7] ),                           // Templated
    .RG_EDGEA  ( RG_VPAD_EDGEA[7] ),                             // Templated
    .RG_EDGEB  ( RG_VPAD_EDGEB[7] ),                             // Templated
    .RG_PAD_IN_DIS  ( RG_VPAD_IN_DIS[7] ),                       // Templated
    .TEST_MODE  ( TEST_MODE ),                                   // Templated
    .SCAN_EN  ( 1'b0 ),                                          // Templated
    .SCAN_IN  ( 1'b0 ),                                          // Templated
    .SO_PAD_EN  ( SO_VPAD_EN[7] ),                               // Templated
    .SI_PAD_EN  ( SI_VPAD_EN[7] ),                               // Templated
    .COMPRESSION_MODE  ( COMPRESSION_MODE ),                     // Templated
  // Outputs
    .PAD_I  ( VPAD_I[7] ),                                       // Templated
    .GMII_RXD_P  ( VPAD_RXD_P[7] ),                              // Templated
    .GMII_RXD_N  ( VPAD_RXD_N[7] ),                              // Templated
    .SCAN_OUT  ( VPAD_SCAN_OUT[7] ));                             // Templated
f_PAD_RGMII_DATA U_DATAPAD8(
	/*autoinst*/
  // Inputs
    .RST_B  ( VPAD0_RST_B ),                                     // Templated
    .GMII_CLK  ( VCLK0 ),                                        // Templated
    .O_RESET_VALUE  ( VPAD_O_RESET_VALUE[8] ),                   // Templated
    .PAD_OUT  ( VPAD_OUT[8] ),                                   // Templated
    .PAD_OEN  ( VPAD_OEN[8] ),                                   // Templated
    .PAD_C  ( VPAD_C[8] ),                                       // Templated
    .GMII_TXD_P  ( VPAD_TXD_P[8] ),                              // Templated
    .GMII_TXD_N  ( VPAD_TXD_N[8] ),                              // Templated
    .RG_XOR_EN  ( RG_VPAD_XOR_EN[8] ),                           // Templated
    .RG_RGMII_MODE_EN  ( RG_VPAD_RGMII_MODE_EN[8] ),             // Templated
    .RG_DDR_EN  ( RG_VPAD_DDR_EN[8] ),                           // Templated
    .RG_EDGEA  ( RG_VPAD_EDGEA[8] ),                             // Templated
    .RG_EDGEB  ( RG_VPAD_EDGEB[8] ),                             // Templated
    .RG_PAD_IN_DIS  ( RG_VPAD_IN_DIS[8] ),                       // Templated
    .TEST_MODE  ( TEST_MODE ),                                   // Templated
    .SCAN_EN  ( 1'b0 ),                                          // Templated
    .SCAN_IN  ( 1'b0 ),                                          // Templated
    .SO_PAD_EN  ( SO_VPAD_EN[8] ),                               // Templated
    .SI_PAD_EN  ( SI_VPAD_EN[8] ),                               // Templated
    .COMPRESSION_MODE  ( COMPRESSION_MODE ),                     // Templated
  // Outputs
    .PAD_I  ( VPAD_I[8] ),                                       // Templated
    .GMII_RXD_P  ( VPAD_RXD_P[8] ),                              // Templated
    .GMII_RXD_N  ( VPAD_RXD_N[8] ),                              // Templated
    .SCAN_OUT  ( VPAD_SCAN_OUT[8] ));                             // Templated
f_PAD_RGMII_DATA U_DATAPAD9(
	/*autoinst*/
  // Inputs
    .RST_B  ( VPAD0_RST_B ),                                     // Templated
    .GMII_CLK  ( VCLK0 ),                                        // Templated
    .O_RESET_VALUE  ( VPAD_O_RESET_VALUE[9] ),                   // Templated
    .PAD_OUT  ( VPAD_OUT[9] ),                                   // Templated
    .PAD_OEN  ( VPAD_OEN[9] ),                                   // Templated
    .PAD_C  ( VPAD_C[9] ),                                       // Templated
    .GMII_TXD_P  ( VPAD_TXD_P[9] ),                              // Templated
    .GMII_TXD_N  ( VPAD_TXD_N[9] ),                              // Templated
    .RG_XOR_EN  ( RG_VPAD_XOR_EN[9] ),                           // Templated
    .RG_RGMII_MODE_EN  ( RG_VPAD_RGMII_MODE_EN[9] ),             // Templated
    .RG_DDR_EN  ( RG_VPAD_DDR_EN[9] ),                           // Templated
    .RG_EDGEA  ( RG_VPAD_EDGEA[9] ),                             // Templated
    .RG_EDGEB  ( RG_VPAD_EDGEB[9] ),                             // Templated
    .RG_PAD_IN_DIS  ( RG_VPAD_IN_DIS[9] ),                       // Templated
    .TEST_MODE  ( TEST_MODE ),                                   // Templated
    .SCAN_EN  ( 1'b0 ),                                          // Templated
    .SCAN_IN  ( 1'b0 ),                                          // Templated
    .SO_PAD_EN  ( SO_VPAD_EN[9] ),                               // Templated
    .SI_PAD_EN  ( SI_VPAD_EN[9] ),                               // Templated
    .COMPRESSION_MODE  ( COMPRESSION_MODE ),                     // Templated
  // Outputs
    .PAD_I  ( VPAD_I[9] ),                                       // Templated
    .GMII_RXD_P  ( VPAD_RXD_P[9] ),                              // Templated
    .GMII_RXD_N  ( VPAD_RXD_N[9] ),                              // Templated
    .SCAN_OUT  ( VPAD_SCAN_OUT[9] ));                             // Templated
/*
f_PAD_RGMII_DATA AUTO_TEMPLATE(
                   .RST_B		(VPAD1_RST_B),
                   .GMII_CLK		(VCLK1),
                   .O_RESET_VALUE	(VPAD_O_RESET_VALUE[@]),
                   .PAD_OUT		(VPAD_OUT[@]),
                   .PAD_OEN		(VPAD_OEN[@]),
		   .PAD_C		(VPAD_C[@]),
                   .GMII_TXD_P		(VPAD_TXD_P[@]),
                   .GMII_TXD_N		(VPAD_TXD_N[@]),
                   .RG_XOR_EN		(RG_VPAD_XOR_EN[@]),
                   .RG_RGMII_MODE_EN	(RG_VPAD_RGMII_MODE_EN[@]),
                   .RG_DDR_EN		(RG_VPAD_DDR_EN[@]),
                   .RG_EDGEA		(RG_VPAD_EDGEA[@]),
                   .RG_EDGEB		(RG_VPAD_EDGEB[@]),
                   .RG_PAD_IN_DIS	(RG_VPAD_IN_DIS[@]),
                   .COMPRESSION_MODE	(COMPRESSION_MODE),
                   .TEST_MODE		(TEST_MODE),
                   .SCAN_EN		(1'b0),
                   .SCAN_IN		(1'b0),
                   .SO_PAD_EN		(SO_VPAD_EN[@]),
                   .SI_PAD_EN		(SI_VPAD_EN[@]),
		   .PAD_I		(VPAD_I[@]),
                   .GMII_RXD_P		(VPAD_RXD_P[@]),
                   .GMII_RXD_N		(VPAD_RXD_N[@]),
                   .SCAN_OUT		(VPAD_SCAN_OUT[@]));
*/
f_PAD_RGMII_DATA U_DATAPAD10(
	/*autoinst*/
  // Inputs
    .RST_B  ( VPAD1_RST_B ),                                     // Templated
    .GMII_CLK  ( VCLK1 ),                                        // Templated
    .O_RESET_VALUE  ( VPAD_O_RESET_VALUE[10] ),                  // Templated
    .PAD_OUT  ( VPAD_OUT[10] ),                                  // Templated
    .PAD_OEN  ( VPAD_OEN[10] ),                                  // Templated
    .PAD_C  ( VPAD_C[10] ),                                      // Templated
    .GMII_TXD_P  ( VPAD_TXD_P[10] ),                             // Templated
    .GMII_TXD_N  ( VPAD_TXD_N[10] ),                             // Templated
    .RG_XOR_EN  ( RG_VPAD_XOR_EN[10] ),                          // Templated
    .RG_RGMII_MODE_EN  ( RG_VPAD_RGMII_MODE_EN[10] ),            // Templated
    .RG_DDR_EN  ( RG_VPAD_DDR_EN[10] ),                          // Templated
    .RG_EDGEA  ( RG_VPAD_EDGEA[10] ),                            // Templated
    .RG_EDGEB  ( RG_VPAD_EDGEB[10] ),                            // Templated
    .RG_PAD_IN_DIS  ( RG_VPAD_IN_DIS[10] ),                      // Templated
    .TEST_MODE  ( TEST_MODE ),                                   // Templated
    .SCAN_EN  ( 1'b0 ),                                          // Templated
    .SCAN_IN  ( 1'b0 ),                                          // Templated
    .SO_PAD_EN  ( SO_VPAD_EN[10] ),                              // Templated
    .SI_PAD_EN  ( SI_VPAD_EN[10] ),                              // Templated
    .COMPRESSION_MODE  ( COMPRESSION_MODE ),                     // Templated
  // Outputs
    .PAD_I  ( VPAD_I[10] ),                                      // Templated
    .GMII_RXD_P  ( VPAD_RXD_P[10] ),                             // Templated
    .GMII_RXD_N  ( VPAD_RXD_N[10] ),                             // Templated
    .SCAN_OUT  ( VPAD_SCAN_OUT[10] ));                            // Templated
f_PAD_RGMII_DATA U_DATAPAD11(
	/*autoinst*/
  // Inputs
    .RST_B  ( VPAD1_RST_B ),                                     // Templated
    .GMII_CLK  ( VCLK1 ),                                        // Templated
    .O_RESET_VALUE  ( VPAD_O_RESET_VALUE[11] ),                  // Templated
    .PAD_OUT  ( VPAD_OUT[11] ),                                  // Templated
    .PAD_OEN  ( VPAD_OEN[11] ),                                  // Templated
    .PAD_C  ( VPAD_C[11] ),                                      // Templated
    .GMII_TXD_P  ( VPAD_TXD_P[11] ),                             // Templated
    .GMII_TXD_N  ( VPAD_TXD_N[11] ),                             // Templated
    .RG_XOR_EN  ( RG_VPAD_XOR_EN[11] ),                          // Templated
    .RG_RGMII_MODE_EN  ( RG_VPAD_RGMII_MODE_EN[11] ),            // Templated
    .RG_DDR_EN  ( RG_VPAD_DDR_EN[11] ),                          // Templated
    .RG_EDGEA  ( RG_VPAD_EDGEA[11] ),                            // Templated
    .RG_EDGEB  ( RG_VPAD_EDGEB[11] ),                            // Templated
    .RG_PAD_IN_DIS  ( RG_VPAD_IN_DIS[11] ),                      // Templated
    .TEST_MODE  ( TEST_MODE ),                                   // Templated
    .SCAN_EN  ( 1'b0 ),                                          // Templated
    .SCAN_IN  ( 1'b0 ),                                          // Templated
    .SO_PAD_EN  ( SO_VPAD_EN[11] ),                              // Templated
    .SI_PAD_EN  ( SI_VPAD_EN[11] ),                              // Templated
    .COMPRESSION_MODE  ( COMPRESSION_MODE ),                     // Templated
  // Outputs
    .PAD_I  ( VPAD_I[11] ),                                      // Templated
    .GMII_RXD_P  ( VPAD_RXD_P[11] ),                             // Templated
    .GMII_RXD_N  ( VPAD_RXD_N[11] ),                             // Templated
    .SCAN_OUT  ( VPAD_SCAN_OUT[11] ));                            // Templated
f_PAD_RGMII_DATA U_DATAPAD12(
	/*autoinst*/
  // Inputs
    .RST_B  ( VPAD1_RST_B ),                                     // Templated
    .GMII_CLK  ( VCLK1 ),                                        // Templated
    .O_RESET_VALUE  ( VPAD_O_RESET_VALUE[12] ),                  // Templated
    .PAD_OUT  ( VPAD_OUT[12] ),                                  // Templated
    .PAD_OEN  ( VPAD_OEN[12] ),                                  // Templated
    .PAD_C  ( VPAD_C[12] ),                                      // Templated
    .GMII_TXD_P  ( VPAD_TXD_P[12] ),                             // Templated
    .GMII_TXD_N  ( VPAD_TXD_N[12] ),                             // Templated
    .RG_XOR_EN  ( RG_VPAD_XOR_EN[12] ),                          // Templated
    .RG_RGMII_MODE_EN  ( RG_VPAD_RGMII_MODE_EN[12] ),            // Templated
    .RG_DDR_EN  ( RG_VPAD_DDR_EN[12] ),                          // Templated
    .RG_EDGEA  ( RG_VPAD_EDGEA[12] ),                            // Templated
    .RG_EDGEB  ( RG_VPAD_EDGEB[12] ),                            // Templated
    .RG_PAD_IN_DIS  ( RG_VPAD_IN_DIS[12] ),                      // Templated
    .TEST_MODE  ( TEST_MODE ),                                   // Templated
    .SCAN_EN  ( 1'b0 ),                                          // Templated
    .SCAN_IN  ( 1'b0 ),                                          // Templated
    .SO_PAD_EN  ( SO_VPAD_EN[12] ),                              // Templated
    .SI_PAD_EN  ( SI_VPAD_EN[12] ),                              // Templated
    .COMPRESSION_MODE  ( COMPRESSION_MODE ),                     // Templated
  // Outputs
    .PAD_I  ( VPAD_I[12] ),                                      // Templated
    .GMII_RXD_P  ( VPAD_RXD_P[12] ),                             // Templated
    .GMII_RXD_N  ( VPAD_RXD_N[12] ),                             // Templated
    .SCAN_OUT  ( VPAD_SCAN_OUT[12] ));                            // Templated
f_PAD_RGMII_DATA U_DATAPAD13(
	/*autoinst*/
  // Inputs
    .RST_B  ( VPAD1_RST_B ),                                     // Templated
    .GMII_CLK  ( VCLK1 ),                                        // Templated
    .O_RESET_VALUE  ( VPAD_O_RESET_VALUE[13] ),                  // Templated
    .PAD_OUT  ( VPAD_OUT[13] ),                                  // Templated
    .PAD_OEN  ( VPAD_OEN[13] ),                                  // Templated
    .PAD_C  ( VPAD_C[13] ),                                      // Templated
    .GMII_TXD_P  ( VPAD_TXD_P[13] ),                             // Templated
    .GMII_TXD_N  ( VPAD_TXD_N[13] ),                             // Templated
    .RG_XOR_EN  ( RG_VPAD_XOR_EN[13] ),                          // Templated
    .RG_RGMII_MODE_EN  ( RG_VPAD_RGMII_MODE_EN[13] ),            // Templated
    .RG_DDR_EN  ( RG_VPAD_DDR_EN[13] ),                          // Templated
    .RG_EDGEA  ( RG_VPAD_EDGEA[13] ),                            // Templated
    .RG_EDGEB  ( RG_VPAD_EDGEB[13] ),                            // Templated
    .RG_PAD_IN_DIS  ( RG_VPAD_IN_DIS[13] ),                      // Templated
    .TEST_MODE  ( TEST_MODE ),                                   // Templated
    .SCAN_EN  ( 1'b0 ),                                          // Templated
    .SCAN_IN  ( 1'b0 ),                                          // Templated
    .SO_PAD_EN  ( SO_VPAD_EN[13] ),                              // Templated
    .SI_PAD_EN  ( SI_VPAD_EN[13] ),                              // Templated
    .COMPRESSION_MODE  ( COMPRESSION_MODE ),                     // Templated
  // Outputs
    .PAD_I  ( VPAD_I[13] ),                                      // Templated
    .GMII_RXD_P  ( VPAD_RXD_P[13] ),                             // Templated
    .GMII_RXD_N  ( VPAD_RXD_N[13] ),                             // Templated
    .SCAN_OUT  ( VPAD_SCAN_OUT[13] ));                            // Templated
f_PAD_RGMII_DATA U_DATAPAD14(
	/*autoinst*/
  // Inputs
    .RST_B  ( VPAD1_RST_B ),                                     // Templated
    .GMII_CLK  ( VCLK1 ),                                        // Templated
    .O_RESET_VALUE  ( VPAD_O_RESET_VALUE[14] ),                  // Templated
    .PAD_OUT  ( VPAD_OUT[14] ),                                  // Templated
    .PAD_OEN  ( VPAD_OEN[14] ),                                  // Templated
    .PAD_C  ( VPAD_C[14] ),                                      // Templated
    .GMII_TXD_P  ( VPAD_TXD_P[14] ),                             // Templated
    .GMII_TXD_N  ( VPAD_TXD_N[14] ),                             // Templated
    .RG_XOR_EN  ( RG_VPAD_XOR_EN[14] ),                          // Templated
    .RG_RGMII_MODE_EN  ( RG_VPAD_RGMII_MODE_EN[14] ),            // Templated
    .RG_DDR_EN  ( RG_VPAD_DDR_EN[14] ),                          // Templated
    .RG_EDGEA  ( RG_VPAD_EDGEA[14] ),                            // Templated
    .RG_EDGEB  ( RG_VPAD_EDGEB[14] ),                            // Templated
    .RG_PAD_IN_DIS  ( RG_VPAD_IN_DIS[14] ),                      // Templated
    .TEST_MODE  ( TEST_MODE ),                                   // Templated
    .SCAN_EN  ( 1'b0 ),                                          // Templated
    .SCAN_IN  ( 1'b0 ),                                          // Templated
    .SO_PAD_EN  ( SO_VPAD_EN[14] ),                              // Templated
    .SI_PAD_EN  ( SI_VPAD_EN[14] ),                              // Templated
    .COMPRESSION_MODE  ( COMPRESSION_MODE ),                     // Templated
  // Outputs
    .PAD_I  ( VPAD_I[14] ),                                      // Templated
    .GMII_RXD_P  ( VPAD_RXD_P[14] ),                             // Templated
    .GMII_RXD_N  ( VPAD_RXD_N[14] ),                             // Templated
    .SCAN_OUT  ( VPAD_SCAN_OUT[14] ));                            // Templated
f_PAD_RGMII_DATA U_DATAPAD15(
	/*autoinst*/
  // Inputs
    .RST_B  ( VPAD1_RST_B ),                                     // Templated
    .GMII_CLK  ( VCLK1 ),                                        // Templated
    .O_RESET_VALUE  ( VPAD_O_RESET_VALUE[15] ),                  // Templated
    .PAD_OUT  ( VPAD_OUT[15] ),                                  // Templated
    .PAD_OEN  ( VPAD_OEN[15] ),                                  // Templated
    .PAD_C  ( VPAD_C[15] ),                                      // Templated
    .GMII_TXD_P  ( VPAD_TXD_P[15] ),                             // Templated
    .GMII_TXD_N  ( VPAD_TXD_N[15] ),                             // Templated
    .RG_XOR_EN  ( RG_VPAD_XOR_EN[15] ),                          // Templated
    .RG_RGMII_MODE_EN  ( RG_VPAD_RGMII_MODE_EN[15] ),            // Templated
    .RG_DDR_EN  ( RG_VPAD_DDR_EN[15] ),                          // Templated
    .RG_EDGEA  ( RG_VPAD_EDGEA[15] ),                            // Templated
    .RG_EDGEB  ( RG_VPAD_EDGEB[15] ),                            // Templated
    .RG_PAD_IN_DIS  ( RG_VPAD_IN_DIS[15] ),                      // Templated
    .TEST_MODE  ( TEST_MODE ),                                   // Templated
    .SCAN_EN  ( 1'b0 ),                                          // Templated
    .SCAN_IN  ( 1'b0 ),                                          // Templated
    .SO_PAD_EN  ( SO_VPAD_EN[15] ),                              // Templated
    .SI_PAD_EN  ( SI_VPAD_EN[15] ),                              // Templated
    .COMPRESSION_MODE  ( COMPRESSION_MODE ),                     // Templated
  // Outputs
    .PAD_I  ( VPAD_I[15] ),                                      // Templated
    .GMII_RXD_P  ( VPAD_RXD_P[15] ),                             // Templated
    .GMII_RXD_N  ( VPAD_RXD_N[15] ),                             // Templated
    .SCAN_OUT  ( VPAD_SCAN_OUT[15] ));                            // Templated
f_PAD_RGMII_DATA U_DATAPAD16(
	/*autoinst*/
  // Inputs
    .RST_B  ( VPAD1_RST_B ),                                     // Templated
    .GMII_CLK  ( VCLK1 ),                                        // Templated
    .O_RESET_VALUE  ( VPAD_O_RESET_VALUE[16] ),                  // Templated
    .PAD_OUT  ( VPAD_OUT[16] ),                                  // Templated
    .PAD_OEN  ( VPAD_OEN[16] ),                                  // Templated
    .PAD_C  ( VPAD_C[16] ),                                      // Templated
    .GMII_TXD_P  ( VPAD_TXD_P[16] ),                             // Templated
    .GMII_TXD_N  ( VPAD_TXD_N[16] ),                             // Templated
    .RG_XOR_EN  ( RG_VPAD_XOR_EN[16] ),                          // Templated
    .RG_RGMII_MODE_EN  ( RG_VPAD_RGMII_MODE_EN[16] ),            // Templated
    .RG_DDR_EN  ( RG_VPAD_DDR_EN[16] ),                          // Templated
    .RG_EDGEA  ( RG_VPAD_EDGEA[16] ),                            // Templated
    .RG_EDGEB  ( RG_VPAD_EDGEB[16] ),                            // Templated
    .RG_PAD_IN_DIS  ( RG_VPAD_IN_DIS[16] ),                      // Templated
    .TEST_MODE  ( TEST_MODE ),                                   // Templated
    .SCAN_EN  ( 1'b0 ),                                          // Templated
    .SCAN_IN  ( 1'b0 ),                                          // Templated
    .SO_PAD_EN  ( SO_VPAD_EN[16] ),                              // Templated
    .SI_PAD_EN  ( SI_VPAD_EN[16] ),                              // Templated
    .COMPRESSION_MODE  ( COMPRESSION_MODE ),                     // Templated
  // Outputs
    .PAD_I  ( VPAD_I[16] ),                                      // Templated
    .GMII_RXD_P  ( VPAD_RXD_P[16] ),                             // Templated
    .GMII_RXD_N  ( VPAD_RXD_N[16] ),                             // Templated
    .SCAN_OUT  ( VPAD_SCAN_OUT[16] ));                            // Templated
f_PAD_RGMII_DATA U_DATAPAD17(
	/*autoinst*/
  // Inputs
    .RST_B  ( VPAD1_RST_B ),                                     // Templated
    .GMII_CLK  ( VCLK1 ),                                        // Templated
    .O_RESET_VALUE  ( VPAD_O_RESET_VALUE[17] ),                  // Templated
    .PAD_OUT  ( VPAD_OUT[17] ),                                  // Templated
    .PAD_OEN  ( VPAD_OEN[17] ),                                  // Templated
    .PAD_C  ( VPAD_C[17] ),                                      // Templated
    .GMII_TXD_P  ( VPAD_TXD_P[17] ),                             // Templated
    .GMII_TXD_N  ( VPAD_TXD_N[17] ),                             // Templated
    .RG_XOR_EN  ( RG_VPAD_XOR_EN[17] ),                          // Templated
    .RG_RGMII_MODE_EN  ( RG_VPAD_RGMII_MODE_EN[17] ),            // Templated
    .RG_DDR_EN  ( RG_VPAD_DDR_EN[17] ),                          // Templated
    .RG_EDGEA  ( RG_VPAD_EDGEA[17] ),                            // Templated
    .RG_EDGEB  ( RG_VPAD_EDGEB[17] ),                            // Templated
    .RG_PAD_IN_DIS  ( RG_VPAD_IN_DIS[17] ),                      // Templated
    .TEST_MODE  ( TEST_MODE ),                                   // Templated
    .SCAN_EN  ( 1'b0 ),                                          // Templated
    .SCAN_IN  ( 1'b0 ),                                          // Templated
    .SO_PAD_EN  ( SO_VPAD_EN[17] ),                              // Templated
    .SI_PAD_EN  ( SI_VPAD_EN[17] ),                              // Templated
    .COMPRESSION_MODE  ( COMPRESSION_MODE ),                     // Templated
  // Outputs
    .PAD_I  ( VPAD_I[17] ),                                      // Templated
    .GMII_RXD_P  ( VPAD_RXD_P[17] ),                             // Templated
    .GMII_RXD_N  ( VPAD_RXD_N[17] ),                             // Templated
    .SCAN_OUT  ( VPAD_SCAN_OUT[17] ));                            // Templated

f_PAD_RGMII_CLKTX_COMP U_VCLK(
                 .CTS_IGNORE	(CTS_IGNORE),
                 .CLK_IN	(VCLK_IN),
                 .CLK_SRC	(VCLK_SRC),
                 .PAD_OUT	(VCLK_PAD_OUT),
		 .PAD_C		(VCLK_PAD_C),
                 .RG_CLKO_INV		(RG_VCLKO_INV),
                 .RG_CLKO_DLY		(RG_VCLKO_DLY),
                 .RG_CLKO_SRC		(RG_VCLKO_SRC),
                 .RG_CLKO_POL		(RG_VCLKO_POL),
                 .RG_RGMII_MODE_EN	(RG_VCLK_RGMII_MODE_EN),
                 .RG_CLKI_SRC		(RG_VCLKI_SRC),
                 .RG_CLKI_DIS		(RG_VCLKI_DIS),
                 .RG_CLKI_INV		(RG_VCLKI_INV),
                 .RG_CLKI_DLY		(RG_VCLKI_DLY),
                 .RG_CLKI_POL		(RG_VCLKI_POL),
		 .RG_CK_COMP_CKINV	(RG_TX_CK_COMP_CKINV),
		 .RG_CK_COMP		(RG_TX_CK_COMP),
		 .PAD_I			(VCLK_PAD_I),
                 .CLK_SDO		(VCLK_SDO),
                 .CLKI_OUT		(VCLKI_OUT));

// Local Variables:
// verilog-library-flags:("-y ../../softpad_macro/rtl/")
// End:
endmodule
module f_IOPAD_H_CTRL(
	/*autoarg*/
//*******
// Inputs
//*******
    IORX_RST_B, FREE_IOCTL_CLKRX, MO_IORX_CLKO_INV, MO_IORX_CLKO_DLY,
    MO_IORX_CLKO_POL, MO_IORX_CLKI_INV, MO_IORX_CLKI_DLY,
    MO_IORX_CLKI_POL, MO_IORX_CK_COMP_CKINV, MO_IORX_CK_COMP,
    SFT_CFG_BIO_SEL, BIO_EN16B, BIO_DDR_EN, HCLK_SDO, HCLKI_OUT,
    HPAD_RXD_P, HPAD_RXD_N, HPAD_I, C_RXD, C_RXRDY, C_RXVLD,
    HCLK_PAD_I, C_RXCK, BIO_RXD_V, TEST_MODE, RGMII_DATA_SCAN_CLK,
//********
// Outputs
//********
    PI_CLKIORX, BIO_RXVLD, BIO_TXRDY, BIO_RXD, HCLK_IN, HCLK_SRC,
    HCLK, HPAD_RST_B, RG_HCLKO_INV, RG_HCLKO_DLY, RG_HCLKO_SRC,
    RG_HCLKO_POL, RG_HCLK_RGMII_MODE_EN, RG_HCLKI_SRC, RG_HCLKI_DIS,
    RG_HCLKI_INV, RG_HCLKI_DLY, RG_HCLKI_POL, RG_RX_CK_COMP_CKINV,
    RG_RX_CK_COMP, RG_HPAD_XOR_EN, RG_HPAD_RGMII_MODE_EN,
    RG_HPAD_DDR_EN, RG_HPAD_EDGEA, RG_HPAD_EDGEB, RG_HPAD_IN_DIS,
    HPAD_O_RESET_VALUE, HPAD_TXD_P, HPAD_TXD_N, I_RXD, I_RXRDY,
    I_RXVLD, HPAD_C, I_RXCK, HCLK_PAD_C
    );
//=============================================================================
//Interface with chip internal module
//=============================================================================
//clock and reset from/to CLKGEN/RSTGEN
output	PI_CLKIORX;
input	IORX_RST_B;
input	FREE_IOCTL_CLKRX;
//register configuration for txclk pad from MOON
input	MO_IORX_CLKO_INV;
input	[3:0]	MO_IORX_CLKO_DLY;
input	MO_IORX_CLKO_POL;
input	MO_IORX_CLKI_INV;
input	[3:0]	MO_IORX_CLKI_DLY;
input	MO_IORX_CLKI_POL;
//clock invert or not in compensate circuit, default 0(not invert)
input	MO_IORX_CK_COMP_CKINV;
//using softpad clock or compensate clock, default 0(using compensate clock)
input	MO_IORX_CK_COMP;
//high active to enable "RGMII_MODE" of softpad
input	SFT_CFG_BIO_SEL;
//high active to enable 16bit mode
input	BIO_EN16B;
//high active to enable DDR mode
input	BIO_DDR_EN;
//=============================================================================
//Interface with BIO_CTRL
//=============================================================================
output  [1:0]   BIO_RXVLD;
output		BIO_TXRDY;
output	[31:0]	BIO_RXD;
//=============================================================================
//Interface with module f_IOPAD_H_ALL
//=============================================================================
//clock and reset interface with module f_IOPAD_H_ALL
output		HCLK_IN;
output		HCLK_SRC;
output		HCLK;
output	HPAD_RST_B;

input	HCLK_SDO;
input	HCLKI_OUT;

//clock pad configuration
output	RG_HCLKO_INV;
output	[3:0]	RG_HCLKO_DLY;
output	RG_HCLKO_SRC;
output	RG_HCLKO_POL;
output	RG_HCLK_RGMII_MODE_EN;
output	RG_HCLKI_SRC;
output	RG_HCLKI_DIS;
output	RG_HCLKI_INV;
output	[3:0]	RG_HCLKI_DLY;
output	RG_HCLKI_POL;
//clock invert or not in compensate circuit, default 0(not invert)
output	RG_RX_CK_COMP_CKINV;
//using softpad clock or compensate clock, default 0(using compensate clock)
output	RG_RX_CK_COMP;

//data pad configuration
output	[17:0]	RG_HPAD_XOR_EN;
output	[17:0]	RG_HPAD_RGMII_MODE_EN;
output	[17:0]	RG_HPAD_DDR_EN;
output	[17:0]	RG_HPAD_EDGEA;
output	[17:0]	RG_HPAD_EDGEB;
output	[17:0]	RG_HPAD_IN_DIS;
//data pad input and output data
output	[17:0]	HPAD_O_RESET_VALUE;
output	[17:0]	HPAD_TXD_P;
output	[17:0]	HPAD_TXD_N;

input	[17:0]	HPAD_RXD_P;
input	[17:0]	HPAD_RXD_N;

//pad sequence
input	[17:0]	HPAD_I;
output	[15:0]	I_RXD;
output		I_RXRDY;
output		I_RXVLD;

input	[15:0]	C_RXD;
input		C_RXRDY;
input		C_RXVLD;
output	[17:0]	HPAD_C;

input	HCLK_PAD_I;
output	I_RXCK;
input	C_RXCK;
output	HCLK_PAD_C;
//=============================================================================
//Interface with module f_IOPAD_V_CTRL
//=============================================================================
input	[15:0]	BIO_RXD_V;

//scan related
input	TEST_MODE;
input	RGMII_DATA_SCAN_CLK;

//clock connection
wire	HCLK_IN=1'h0;
wire	HCLK_SRC=1'h0;
wire	HCLK=FREE_IOCTL_CLKRX;
wire	HPAD_RST_B=IORX_RST_B;
wire	PI_CLKIORX=HCLKI_OUT;

//clock pad control rename
wire	RG_HCLK_RGMII_MODE_EN=SFT_CFG_BIO_SEL;
wire	RG_HCLKI_INV=MO_IORX_CLKI_INV;
wire	[3:0]	RG_HCLKI_DLY=MO_IORX_CLKI_DLY;
wire	RG_HCLKI_POL=MO_IORX_CLKI_POL;
wire	RG_RX_CK_COMP_CKINV=MO_IORX_CK_COMP_CKINV;
wire	RG_RX_CK_COMP=MO_IORX_CK_COMP|(~SFT_CFG_BIO_SEL);
wire	RG_HCLKO_SRC=1'h1;
wire	RG_HCLKI_SRC=1'h0;
wire	RG_HCLKI_DIS=1'h0;
wire	RG_HCLKO_INV=1'h0;
wire	[3:0]	RG_HCLKO_DLY=4'h0;
wire	RG_HCLKO_POL=1'h0;

//data pad configuration
wire	[17:0]	RG_HPAD_XOR_EN=18'h0;
wire	[17:0]	RG_HPAD_RGMII_MODE_EN={18{SFT_CFG_BIO_SEL}};
wire	[17:0]	RG_HPAD_DDR_EN={18{BIO_DDR_EN}};
wire	[17:0]	RG_HPAD_EDGEA=18'h0;
wire	[17:0]	RG_HPAD_EDGEB=18'h3ffff;

wire	[17:0]	RG_HPAD_IN_DIS={18{~SFT_CFG_BIO_SEL}};
//data pad input/output data
wire	[17:0]	HPAD_O_RESET_VALUE=18'h0;
wire	[17:0]	HPAD_TXD_P=18'h0;
wire	[17:0]	HPAD_TXD_N=18'h0;
wire	[31:0]	BIO_RXD=BIO_EN16B?{HPAD_RXD_N[15:0],HPAD_RXD_P[15:0]}:{8'h0,BIO_RXD_V[15:8],8'h0,BIO_RXD_V[7:0]};
wire	[1:0]   BIO_RXVLD={HPAD_RXD_N[16], HPAD_RXD_P[16]};
wire	BIO_TXRDY=HPAD_RXD_P[17];
//pad sequence
wire	[15:0]	I_RXD=HPAD_I[15:0];
wire	I_RXVLD=HPAD_I[16];
wire	I_RXRDY=HPAD_I[17];
wire	[17:0]	HPAD_C={
	C_RXRDY,
	C_RXVLD,
	C_RXD[15:8],
	C_RXD[7:0]
	};
wire	HCLK_PAD_C=C_RXCK;
wire	I_RXCK=HCLK_PAD_I;
endmodule
module f_IOPAD_H_ALL(
	/*autoarg*/
//*******
// Inputs
//*******
    HCLK_IN, HCLK_SRC, HCLK, HPAD_RST_B, HPAD_O_RESET_VALUE, HPAD_OUT,
    HPAD_OEN, HPAD_C, HPAD_TXD_P, HPAD_TXD_N, RG_HPAD_XOR_EN,
    RG_HPAD_RGMII_MODE_EN, RG_HPAD_DDR_EN, RG_HPAD_EDGEA,
    RG_HPAD_EDGEB, RG_HPAD_IN_DIS, HCLK_PAD_OUT, HCLK_PAD_C,
    RG_HCLKO_INV, RG_HCLKO_DLY, RG_HCLKO_SRC, RG_HCLKO_POL,
    RG_HCLK_RGMII_MODE_EN, RG_HCLKI_SRC, RG_HCLKI_DIS, RG_HCLKI_INV,
    RG_HCLKI_DLY, RG_HCLKI_POL, RG_RX_CK_COMP_CKINV, RG_RX_CK_COMP,
    TEST_MODE, COMPRESSION_MODE, SO_HPAD_EN, SI_HPAD_EN, CTS_IGNORE,
//********
// Outputs
//********
    HCLK_SDO, HCLKI_OUT, HCLK_PAD_I, HPAD_I, HPAD_RXD_P, HPAD_RXD_N
    );

//clock and reset
input	HCLK_IN;
input	HCLK_SRC;
input	HCLK;
input	HPAD_RST_B;
output	HCLK_SDO;
output	HCLKI_OUT;

//data/control
input	[17:0]	HPAD_O_RESET_VALUE;
input	[17:0]	HPAD_OUT;
input	[17:0]	HPAD_OEN;
input	[17:0]	HPAD_C;
input	[17:0]	HPAD_TXD_P;
input	[17:0]	HPAD_TXD_N;
input	[17:0]	RG_HPAD_XOR_EN;
input	[17:0]	RG_HPAD_RGMII_MODE_EN;
input	[17:0]	RG_HPAD_DDR_EN;
input	[17:0]	RG_HPAD_EDGEA;
input	[17:0]	RG_HPAD_EDGEB;
input	[17:0]	RG_HPAD_IN_DIS;

input	HCLK_PAD_OUT;
input	HCLK_PAD_C;
input	RG_HCLKO_INV;
input	[3:0]	RG_HCLKO_DLY;
input	RG_HCLKO_SRC;
input	RG_HCLKO_POL;
input	RG_HCLK_RGMII_MODE_EN;
input	RG_HCLKI_SRC;
input	RG_HCLKI_DIS;
input	RG_HCLKI_INV;
input	[3:0]	RG_HCLKI_DLY;
input	RG_HCLKI_POL;
//clock invert or not in compensate circuit, default 0(not invert)
input	RG_RX_CK_COMP_CKINV;
//using softpad clock or compensate clock, default 0(using compensate clock)
input	RG_RX_CK_COMP;

output	HCLK_PAD_I;
output	[17:0]	HPAD_I;
output	[17:0]	HPAD_RXD_P;
output	[17:0]	HPAD_RXD_N;
//scan related
input	TEST_MODE;
//not macro, do not need manual chain
//input	SCAN_EN;
input	COMPRESSION_MODE;
input	[17:0]	SO_HPAD_EN;
input	[17:0]	SI_HPAD_EN;
//delete manual chain
//input	SCAN_IN_H;
//output	SCAN_OUT_H;
//=============================================================================
//Others
//=============================================================================
input	CTS_IGNORE;

/*autowire*/
// Beginning of automatic wires (for undeclared instantiated-module outputs)
wire    [17:0]  HPAD_SCAN_OUT;          // From U_DATAPAD0 of f_PAD_RGMII_DATA.v, ...
// End of automatics

//wire	[17:0]	HPAD_SCAN_IN={HPAD_SCAN_OUT[16:0],SCAN_IN_H};
//wire		SCAN_OUT_H=HPAD_SCAN_OUT[17];
/*
f_PAD_RGMII_DATA AUTO_TEMPLATE(
                   .RST_B		(HPAD_RST_B),
                   .GMII_CLK		(HCLK),
                   .O_RESET_VALUE	(HPAD_O_RESET_VALUE[@]),
                   .PAD_OUT		(HPAD_OUT[@]),
                   .PAD_OEN		(HPAD_OEN[@]),
		   .PAD_C		(HPAD_C[@]),
                   .GMII_TXD_P		(HPAD_TXD_P[@]),
                   .GMII_TXD_N		(HPAD_TXD_N[@]),
                   .RG_XOR_EN		(RG_HPAD_XOR_EN[@]),
                   .RG_RGMII_MODE_EN	(RG_HPAD_RGMII_MODE_EN[@]),
                   .RG_DDR_EN		(RG_HPAD_DDR_EN[@]),
                   .RG_EDGEA		(RG_HPAD_EDGEA[@]),
                   .RG_EDGEB		(RG_HPAD_EDGEB[@]),
                   .RG_PAD_IN_DIS	(RG_HPAD_IN_DIS[@]),
                   .COMPRESSION_MODE	(COMPRESSION_MODE),
                   .TEST_MODE		(TEST_MODE),
                   .SCAN_EN		(1'b0),
                   .SCAN_IN		(1'b0),
                   .SO_PAD_EN		(SO_HPAD_EN[@]),
                   .SI_PAD_EN		(SI_HPAD_EN[@]),
		   .PAD_I		(HPAD_I[@]),
                   .GMII_RXD_P		(HPAD_RXD_P[@]),
                   .GMII_RXD_N		(HPAD_RXD_N[@]),
                   .SCAN_OUT		(HPAD_SCAN_OUT[@]));
*/
f_PAD_RGMII_DATA U_DATAPAD0(
	/*autoinst*/
  // Inputs
    .RST_B  ( HPAD_RST_B ),                                      // Templated
    .GMII_CLK  ( HCLK ),                                         // Templated
    .O_RESET_VALUE  ( HPAD_O_RESET_VALUE[0] ),                   // Templated
    .PAD_OUT  ( HPAD_OUT[0] ),                                   // Templated
    .PAD_OEN  ( HPAD_OEN[0] ),                                   // Templated
    .PAD_C  ( HPAD_C[0] ),                                       // Templated
    .GMII_TXD_P  ( HPAD_TXD_P[0] ),                              // Templated
    .GMII_TXD_N  ( HPAD_TXD_N[0] ),                              // Templated
    .RG_XOR_EN  ( RG_HPAD_XOR_EN[0] ),                           // Templated
    .RG_RGMII_MODE_EN  ( RG_HPAD_RGMII_MODE_EN[0] ),             // Templated
    .RG_DDR_EN  ( RG_HPAD_DDR_EN[0] ),                           // Templated
    .RG_EDGEA  ( RG_HPAD_EDGEA[0] ),                             // Templated
    .RG_EDGEB  ( RG_HPAD_EDGEB[0] ),                             // Templated
    .RG_PAD_IN_DIS  ( RG_HPAD_IN_DIS[0] ),                       // Templated
    .TEST_MODE  ( TEST_MODE ),                                   // Templated
    .SCAN_EN  ( 1'b0 ),                                          // Templated
    .SCAN_IN  ( 1'b0 ),                                          // Templated
    .SO_PAD_EN  ( SO_HPAD_EN[0] ),                               // Templated
    .SI_PAD_EN  ( SI_HPAD_EN[0] ),                               // Templated
    .COMPRESSION_MODE  ( COMPRESSION_MODE ),                     // Templated
  // Outputs
    .PAD_I  ( HPAD_I[0] ),                                       // Templated
    .GMII_RXD_P  ( HPAD_RXD_P[0] ),                              // Templated
    .GMII_RXD_N  ( HPAD_RXD_N[0] ),                              // Templated
    .SCAN_OUT  ( HPAD_SCAN_OUT[0] ));                             // Templated
f_PAD_RGMII_DATA U_DATAPAD1(
	/*autoinst*/
  // Inputs
    .RST_B  ( HPAD_RST_B ),                                      // Templated
    .GMII_CLK  ( HCLK ),                                         // Templated
    .O_RESET_VALUE  ( HPAD_O_RESET_VALUE[1] ),                   // Templated
    .PAD_OUT  ( HPAD_OUT[1] ),                                   // Templated
    .PAD_OEN  ( HPAD_OEN[1] ),                                   // Templated
    .PAD_C  ( HPAD_C[1] ),                                       // Templated
    .GMII_TXD_P  ( HPAD_TXD_P[1] ),                              // Templated
    .GMII_TXD_N  ( HPAD_TXD_N[1] ),                              // Templated
    .RG_XOR_EN  ( RG_HPAD_XOR_EN[1] ),                           // Templated
    .RG_RGMII_MODE_EN  ( RG_HPAD_RGMII_MODE_EN[1] ),             // Templated
    .RG_DDR_EN  ( RG_HPAD_DDR_EN[1] ),                           // Templated
    .RG_EDGEA  ( RG_HPAD_EDGEA[1] ),                             // Templated
    .RG_EDGEB  ( RG_HPAD_EDGEB[1] ),                             // Templated
    .RG_PAD_IN_DIS  ( RG_HPAD_IN_DIS[1] ),                       // Templated
    .TEST_MODE  ( TEST_MODE ),                                   // Templated
    .SCAN_EN  ( 1'b0 ),                                          // Templated
    .SCAN_IN  ( 1'b0 ),                                          // Templated
    .SO_PAD_EN  ( SO_HPAD_EN[1] ),                               // Templated
    .SI_PAD_EN  ( SI_HPAD_EN[1] ),                               // Templated
    .COMPRESSION_MODE  ( COMPRESSION_MODE ),                     // Templated
  // Outputs
    .PAD_I  ( HPAD_I[1] ),                                       // Templated
    .GMII_RXD_P  ( HPAD_RXD_P[1] ),                              // Templated
    .GMII_RXD_N  ( HPAD_RXD_N[1] ),                              // Templated
    .SCAN_OUT  ( HPAD_SCAN_OUT[1] ));                             // Templated
f_PAD_RGMII_DATA U_DATAPAD2(
	/*autoinst*/
  // Inputs
    .RST_B  ( HPAD_RST_B ),                                      // Templated
    .GMII_CLK  ( HCLK ),                                         // Templated
    .O_RESET_VALUE  ( HPAD_O_RESET_VALUE[2] ),                   // Templated
    .PAD_OUT  ( HPAD_OUT[2] ),                                   // Templated
    .PAD_OEN  ( HPAD_OEN[2] ),                                   // Templated
    .PAD_C  ( HPAD_C[2] ),                                       // Templated
    .GMII_TXD_P  ( HPAD_TXD_P[2] ),                              // Templated
    .GMII_TXD_N  ( HPAD_TXD_N[2] ),                              // Templated
    .RG_XOR_EN  ( RG_HPAD_XOR_EN[2] ),                           // Templated
    .RG_RGMII_MODE_EN  ( RG_HPAD_RGMII_MODE_EN[2] ),             // Templated
    .RG_DDR_EN  ( RG_HPAD_DDR_EN[2] ),                           // Templated
    .RG_EDGEA  ( RG_HPAD_EDGEA[2] ),                             // Templated
    .RG_EDGEB  ( RG_HPAD_EDGEB[2] ),                             // Templated
    .RG_PAD_IN_DIS  ( RG_HPAD_IN_DIS[2] ),                       // Templated
    .TEST_MODE  ( TEST_MODE ),                                   // Templated
    .SCAN_EN  ( 1'b0 ),                                          // Templated
    .SCAN_IN  ( 1'b0 ),                                          // Templated
    .SO_PAD_EN  ( SO_HPAD_EN[2] ),                               // Templated
    .SI_PAD_EN  ( SI_HPAD_EN[2] ),                               // Templated
    .COMPRESSION_MODE  ( COMPRESSION_MODE ),                     // Templated
  // Outputs
    .PAD_I  ( HPAD_I[2] ),                                       // Templated
    .GMII_RXD_P  ( HPAD_RXD_P[2] ),                              // Templated
    .GMII_RXD_N  ( HPAD_RXD_N[2] ),                              // Templated
    .SCAN_OUT  ( HPAD_SCAN_OUT[2] ));                             // Templated
f_PAD_RGMII_DATA U_DATAPAD3(
	/*autoinst*/
  // Inputs
    .RST_B  ( HPAD_RST_B ),                                      // Templated
    .GMII_CLK  ( HCLK ),                                         // Templated
    .O_RESET_VALUE  ( HPAD_O_RESET_VALUE[3] ),                   // Templated
    .PAD_OUT  ( HPAD_OUT[3] ),                                   // Templated
    .PAD_OEN  ( HPAD_OEN[3] ),                                   // Templated
    .PAD_C  ( HPAD_C[3] ),                                       // Templated
    .GMII_TXD_P  ( HPAD_TXD_P[3] ),                              // Templated
    .GMII_TXD_N  ( HPAD_TXD_N[3] ),                              // Templated
    .RG_XOR_EN  ( RG_HPAD_XOR_EN[3] ),                           // Templated
    .RG_RGMII_MODE_EN  ( RG_HPAD_RGMII_MODE_EN[3] ),             // Templated
    .RG_DDR_EN  ( RG_HPAD_DDR_EN[3] ),                           // Templated
    .RG_EDGEA  ( RG_HPAD_EDGEA[3] ),                             // Templated
    .RG_EDGEB  ( RG_HPAD_EDGEB[3] ),                             // Templated
    .RG_PAD_IN_DIS  ( RG_HPAD_IN_DIS[3] ),                       // Templated
    .TEST_MODE  ( TEST_MODE ),                                   // Templated
    .SCAN_EN  ( 1'b0 ),                                          // Templated
    .SCAN_IN  ( 1'b0 ),                                          // Templated
    .SO_PAD_EN  ( SO_HPAD_EN[3] ),                               // Templated
    .SI_PAD_EN  ( SI_HPAD_EN[3] ),                               // Templated
    .COMPRESSION_MODE  ( COMPRESSION_MODE ),                     // Templated
  // Outputs
    .PAD_I  ( HPAD_I[3] ),                                       // Templated
    .GMII_RXD_P  ( HPAD_RXD_P[3] ),                              // Templated
    .GMII_RXD_N  ( HPAD_RXD_N[3] ),                              // Templated
    .SCAN_OUT  ( HPAD_SCAN_OUT[3] ));                             // Templated
f_PAD_RGMII_DATA U_DATAPAD4(
	/*autoinst*/
  // Inputs
    .RST_B  ( HPAD_RST_B ),                                      // Templated
    .GMII_CLK  ( HCLK ),                                         // Templated
    .O_RESET_VALUE  ( HPAD_O_RESET_VALUE[4] ),                   // Templated
    .PAD_OUT  ( HPAD_OUT[4] ),                                   // Templated
    .PAD_OEN  ( HPAD_OEN[4] ),                                   // Templated
    .PAD_C  ( HPAD_C[4] ),                                       // Templated
    .GMII_TXD_P  ( HPAD_TXD_P[4] ),                              // Templated
    .GMII_TXD_N  ( HPAD_TXD_N[4] ),                              // Templated
    .RG_XOR_EN  ( RG_HPAD_XOR_EN[4] ),                           // Templated
    .RG_RGMII_MODE_EN  ( RG_HPAD_RGMII_MODE_EN[4] ),             // Templated
    .RG_DDR_EN  ( RG_HPAD_DDR_EN[4] ),                           // Templated
    .RG_EDGEA  ( RG_HPAD_EDGEA[4] ),                             // Templated
    .RG_EDGEB  ( RG_HPAD_EDGEB[4] ),                             // Templated
    .RG_PAD_IN_DIS  ( RG_HPAD_IN_DIS[4] ),                       // Templated
    .TEST_MODE  ( TEST_MODE ),                                   // Templated
    .SCAN_EN  ( 1'b0 ),                                          // Templated
    .SCAN_IN  ( 1'b0 ),                                          // Templated
    .SO_PAD_EN  ( SO_HPAD_EN[4] ),                               // Templated
    .SI_PAD_EN  ( SI_HPAD_EN[4] ),                               // Templated
    .COMPRESSION_MODE  ( COMPRESSION_MODE ),                     // Templated
  // Outputs
    .PAD_I  ( HPAD_I[4] ),                                       // Templated
    .GMII_RXD_P  ( HPAD_RXD_P[4] ),                              // Templated
    .GMII_RXD_N  ( HPAD_RXD_N[4] ),                              // Templated
    .SCAN_OUT  ( HPAD_SCAN_OUT[4] ));                             // Templated
f_PAD_RGMII_DATA U_DATAPAD5(
	/*autoinst*/
  // Inputs
    .RST_B  ( HPAD_RST_B ),                                      // Templated
    .GMII_CLK  ( HCLK ),                                         // Templated
    .O_RESET_VALUE  ( HPAD_O_RESET_VALUE[5] ),                   // Templated
    .PAD_OUT  ( HPAD_OUT[5] ),                                   // Templated
    .PAD_OEN  ( HPAD_OEN[5] ),                                   // Templated
    .PAD_C  ( HPAD_C[5] ),                                       // Templated
    .GMII_TXD_P  ( HPAD_TXD_P[5] ),                              // Templated
    .GMII_TXD_N  ( HPAD_TXD_N[5] ),                              // Templated
    .RG_XOR_EN  ( RG_HPAD_XOR_EN[5] ),                           // Templated
    .RG_RGMII_MODE_EN  ( RG_HPAD_RGMII_MODE_EN[5] ),             // Templated
    .RG_DDR_EN  ( RG_HPAD_DDR_EN[5] ),                           // Templated
    .RG_EDGEA  ( RG_HPAD_EDGEA[5] ),                             // Templated
    .RG_EDGEB  ( RG_HPAD_EDGEB[5] ),                             // Templated
    .RG_PAD_IN_DIS  ( RG_HPAD_IN_DIS[5] ),                       // Templated
    .TEST_MODE  ( TEST_MODE ),                                   // Templated
    .SCAN_EN  ( 1'b0 ),                                          // Templated
    .SCAN_IN  ( 1'b0 ),                                          // Templated
    .SO_PAD_EN  ( SO_HPAD_EN[5] ),                               // Templated
    .SI_PAD_EN  ( SI_HPAD_EN[5] ),                               // Templated
    .COMPRESSION_MODE  ( COMPRESSION_MODE ),                     // Templated
  // Outputs
    .PAD_I  ( HPAD_I[5] ),                                       // Templated
    .GMII_RXD_P  ( HPAD_RXD_P[5] ),                              // Templated
    .GMII_RXD_N  ( HPAD_RXD_N[5] ),                              // Templated
    .SCAN_OUT  ( HPAD_SCAN_OUT[5] ));                             // Templated
f_PAD_RGMII_DATA U_DATAPAD6(
	/*autoinst*/
  // Inputs
    .RST_B  ( HPAD_RST_B ),                                      // Templated
    .GMII_CLK  ( HCLK ),                                         // Templated
    .O_RESET_VALUE  ( HPAD_O_RESET_VALUE[6] ),                   // Templated
    .PAD_OUT  ( HPAD_OUT[6] ),                                   // Templated
    .PAD_OEN  ( HPAD_OEN[6] ),                                   // Templated
    .PAD_C  ( HPAD_C[6] ),                                       // Templated
    .GMII_TXD_P  ( HPAD_TXD_P[6] ),                              // Templated
    .GMII_TXD_N  ( HPAD_TXD_N[6] ),                              // Templated
    .RG_XOR_EN  ( RG_HPAD_XOR_EN[6] ),                           // Templated
    .RG_RGMII_MODE_EN  ( RG_HPAD_RGMII_MODE_EN[6] ),             // Templated
    .RG_DDR_EN  ( RG_HPAD_DDR_EN[6] ),                           // Templated
    .RG_EDGEA  ( RG_HPAD_EDGEA[6] ),                             // Templated
    .RG_EDGEB  ( RG_HPAD_EDGEB[6] ),                             // Templated
    .RG_PAD_IN_DIS  ( RG_HPAD_IN_DIS[6] ),                       // Templated
    .TEST_MODE  ( TEST_MODE ),                                   // Templated
    .SCAN_EN  ( 1'b0 ),                                          // Templated
    .SCAN_IN  ( 1'b0 ),                                          // Templated
    .SO_PAD_EN  ( SO_HPAD_EN[6] ),                               // Templated
    .SI_PAD_EN  ( SI_HPAD_EN[6] ),                               // Templated
    .COMPRESSION_MODE  ( COMPRESSION_MODE ),                     // Templated
  // Outputs
    .PAD_I  ( HPAD_I[6] ),                                       // Templated
    .GMII_RXD_P  ( HPAD_RXD_P[6] ),                              // Templated
    .GMII_RXD_N  ( HPAD_RXD_N[6] ),                              // Templated
    .SCAN_OUT  ( HPAD_SCAN_OUT[6] ));                             // Templated
f_PAD_RGMII_DATA U_DATAPAD7(
	/*autoinst*/
  // Inputs
    .RST_B  ( HPAD_RST_B ),                                      // Templated
    .GMII_CLK  ( HCLK ),                                         // Templated
    .O_RESET_VALUE  ( HPAD_O_RESET_VALUE[7] ),                   // Templated
    .PAD_OUT  ( HPAD_OUT[7] ),                                   // Templated
    .PAD_OEN  ( HPAD_OEN[7] ),                                   // Templated
    .PAD_C  ( HPAD_C[7] ),                                       // Templated
    .GMII_TXD_P  ( HPAD_TXD_P[7] ),                              // Templated
    .GMII_TXD_N  ( HPAD_TXD_N[7] ),                              // Templated
    .RG_XOR_EN  ( RG_HPAD_XOR_EN[7] ),                           // Templated
    .RG_RGMII_MODE_EN  ( RG_HPAD_RGMII_MODE_EN[7] ),             // Templated
    .RG_DDR_EN  ( RG_HPAD_DDR_EN[7] ),                           // Templated
    .RG_EDGEA  ( RG_HPAD_EDGEA[7] ),                             // Templated
    .RG_EDGEB  ( RG_HPAD_EDGEB[7] ),                             // Templated
    .RG_PAD_IN_DIS  ( RG_HPAD_IN_DIS[7] ),                       // Templated
    .TEST_MODE  ( TEST_MODE ),                                   // Templated
    .SCAN_EN  ( 1'b0 ),                                          // Templated
    .SCAN_IN  ( 1'b0 ),                                          // Templated
    .SO_PAD_EN  ( SO_HPAD_EN[7] ),                               // Templated
    .SI_PAD_EN  ( SI_HPAD_EN[7] ),                               // Templated
    .COMPRESSION_MODE  ( COMPRESSION_MODE ),                     // Templated
  // Outputs
    .PAD_I  ( HPAD_I[7] ),                                       // Templated
    .GMII_RXD_P  ( HPAD_RXD_P[7] ),                              // Templated
    .GMII_RXD_N  ( HPAD_RXD_N[7] ),                              // Templated
    .SCAN_OUT  ( HPAD_SCAN_OUT[7] ));                             // Templated
f_PAD_RGMII_DATA U_DATAPAD8(
	/*autoinst*/
  // Inputs
    .RST_B  ( HPAD_RST_B ),                                      // Templated
    .GMII_CLK  ( HCLK ),                                         // Templated
    .O_RESET_VALUE  ( HPAD_O_RESET_VALUE[8] ),                   // Templated
    .PAD_OUT  ( HPAD_OUT[8] ),                                   // Templated
    .PAD_OEN  ( HPAD_OEN[8] ),                                   // Templated
    .PAD_C  ( HPAD_C[8] ),                                       // Templated
    .GMII_TXD_P  ( HPAD_TXD_P[8] ),                              // Templated
    .GMII_TXD_N  ( HPAD_TXD_N[8] ),                              // Templated
    .RG_XOR_EN  ( RG_HPAD_XOR_EN[8] ),                           // Templated
    .RG_RGMII_MODE_EN  ( RG_HPAD_RGMII_MODE_EN[8] ),             // Templated
    .RG_DDR_EN  ( RG_HPAD_DDR_EN[8] ),                           // Templated
    .RG_EDGEA  ( RG_HPAD_EDGEA[8] ),                             // Templated
    .RG_EDGEB  ( RG_HPAD_EDGEB[8] ),                             // Templated
    .RG_PAD_IN_DIS  ( RG_HPAD_IN_DIS[8] ),                       // Templated
    .TEST_MODE  ( TEST_MODE ),                                   // Templated
    .SCAN_EN  ( 1'b0 ),                                          // Templated
    .SCAN_IN  ( 1'b0 ),                                          // Templated
    .SO_PAD_EN  ( SO_HPAD_EN[8] ),                               // Templated
    .SI_PAD_EN  ( SI_HPAD_EN[8] ),                               // Templated
    .COMPRESSION_MODE  ( COMPRESSION_MODE ),                     // Templated
  // Outputs
    .PAD_I  ( HPAD_I[8] ),                                       // Templated
    .GMII_RXD_P  ( HPAD_RXD_P[8] ),                              // Templated
    .GMII_RXD_N  ( HPAD_RXD_N[8] ),                              // Templated
    .SCAN_OUT  ( HPAD_SCAN_OUT[8] ));                             // Templated
f_PAD_RGMII_DATA U_DATAPAD9(
	/*autoinst*/
  // Inputs
    .RST_B  ( HPAD_RST_B ),                                      // Templated
    .GMII_CLK  ( HCLK ),                                         // Templated
    .O_RESET_VALUE  ( HPAD_O_RESET_VALUE[9] ),                   // Templated
    .PAD_OUT  ( HPAD_OUT[9] ),                                   // Templated
    .PAD_OEN  ( HPAD_OEN[9] ),                                   // Templated
    .PAD_C  ( HPAD_C[9] ),                                       // Templated
    .GMII_TXD_P  ( HPAD_TXD_P[9] ),                              // Templated
    .GMII_TXD_N  ( HPAD_TXD_N[9] ),                              // Templated
    .RG_XOR_EN  ( RG_HPAD_XOR_EN[9] ),                           // Templated
    .RG_RGMII_MODE_EN  ( RG_HPAD_RGMII_MODE_EN[9] ),             // Templated
    .RG_DDR_EN  ( RG_HPAD_DDR_EN[9] ),                           // Templated
    .RG_EDGEA  ( RG_HPAD_EDGEA[9] ),                             // Templated
    .RG_EDGEB  ( RG_HPAD_EDGEB[9] ),                             // Templated
    .RG_PAD_IN_DIS  ( RG_HPAD_IN_DIS[9] ),                       // Templated
    .TEST_MODE  ( TEST_MODE ),                                   // Templated
    .SCAN_EN  ( 1'b0 ),                                          // Templated
    .SCAN_IN  ( 1'b0 ),                                          // Templated
    .SO_PAD_EN  ( SO_HPAD_EN[9] ),                               // Templated
    .SI_PAD_EN  ( SI_HPAD_EN[9] ),                               // Templated
    .COMPRESSION_MODE  ( COMPRESSION_MODE ),                     // Templated
  // Outputs
    .PAD_I  ( HPAD_I[9] ),                                       // Templated
    .GMII_RXD_P  ( HPAD_RXD_P[9] ),                              // Templated
    .GMII_RXD_N  ( HPAD_RXD_N[9] ),                              // Templated
    .SCAN_OUT  ( HPAD_SCAN_OUT[9] ));                             // Templated
f_PAD_RGMII_DATA U_DATAPAD10(
	/*autoinst*/
  // Inputs
    .RST_B  ( HPAD_RST_B ),                                      // Templated
    .GMII_CLK  ( HCLK ),                                         // Templated
    .O_RESET_VALUE  ( HPAD_O_RESET_VALUE[10] ),                  // Templated
    .PAD_OUT  ( HPAD_OUT[10] ),                                  // Templated
    .PAD_OEN  ( HPAD_OEN[10] ),                                  // Templated
    .PAD_C  ( HPAD_C[10] ),                                      // Templated
    .GMII_TXD_P  ( HPAD_TXD_P[10] ),                             // Templated
    .GMII_TXD_N  ( HPAD_TXD_N[10] ),                             // Templated
    .RG_XOR_EN  ( RG_HPAD_XOR_EN[10] ),                          // Templated
    .RG_RGMII_MODE_EN  ( RG_HPAD_RGMII_MODE_EN[10] ),            // Templated
    .RG_DDR_EN  ( RG_HPAD_DDR_EN[10] ),                          // Templated
    .RG_EDGEA  ( RG_HPAD_EDGEA[10] ),                            // Templated
    .RG_EDGEB  ( RG_HPAD_EDGEB[10] ),                            // Templated
    .RG_PAD_IN_DIS  ( RG_HPAD_IN_DIS[10] ),                      // Templated
    .TEST_MODE  ( TEST_MODE ),                                   // Templated
    .SCAN_EN  ( 1'b0 ),                                          // Templated
    .SCAN_IN  ( 1'b0 ),                                          // Templated
    .SO_PAD_EN  ( SO_HPAD_EN[10] ),                              // Templated
    .SI_PAD_EN  ( SI_HPAD_EN[10] ),                              // Templated
    .COMPRESSION_MODE  ( COMPRESSION_MODE ),                     // Templated
  // Outputs
    .PAD_I  ( HPAD_I[10] ),                                      // Templated
    .GMII_RXD_P  ( HPAD_RXD_P[10] ),                             // Templated
    .GMII_RXD_N  ( HPAD_RXD_N[10] ),                             // Templated
    .SCAN_OUT  ( HPAD_SCAN_OUT[10] ));                            // Templated
f_PAD_RGMII_DATA U_DATAPAD11(
	/*autoinst*/
  // Inputs
    .RST_B  ( HPAD_RST_B ),                                      // Templated
    .GMII_CLK  ( HCLK ),                                         // Templated
    .O_RESET_VALUE  ( HPAD_O_RESET_VALUE[11] ),                  // Templated
    .PAD_OUT  ( HPAD_OUT[11] ),                                  // Templated
    .PAD_OEN  ( HPAD_OEN[11] ),                                  // Templated
    .PAD_C  ( HPAD_C[11] ),                                      // Templated
    .GMII_TXD_P  ( HPAD_TXD_P[11] ),                             // Templated
    .GMII_TXD_N  ( HPAD_TXD_N[11] ),                             // Templated
    .RG_XOR_EN  ( RG_HPAD_XOR_EN[11] ),                          // Templated
    .RG_RGMII_MODE_EN  ( RG_HPAD_RGMII_MODE_EN[11] ),            // Templated
    .RG_DDR_EN  ( RG_HPAD_DDR_EN[11] ),                          // Templated
    .RG_EDGEA  ( RG_HPAD_EDGEA[11] ),                            // Templated
    .RG_EDGEB  ( RG_HPAD_EDGEB[11] ),                            // Templated
    .RG_PAD_IN_DIS  ( RG_HPAD_IN_DIS[11] ),                      // Templated
    .TEST_MODE  ( TEST_MODE ),                                   // Templated
    .SCAN_EN  ( 1'b0 ),                                          // Templated
    .SCAN_IN  ( 1'b0 ),                                          // Templated
    .SO_PAD_EN  ( SO_HPAD_EN[11] ),                              // Templated
    .SI_PAD_EN  ( SI_HPAD_EN[11] ),                              // Templated
    .COMPRESSION_MODE  ( COMPRESSION_MODE ),                     // Templated
  // Outputs
    .PAD_I  ( HPAD_I[11] ),                                      // Templated
    .GMII_RXD_P  ( HPAD_RXD_P[11] ),                             // Templated
    .GMII_RXD_N  ( HPAD_RXD_N[11] ),                             // Templated
    .SCAN_OUT  ( HPAD_SCAN_OUT[11] ));                            // Templated
f_PAD_RGMII_DATA U_DATAPAD12(
	/*autoinst*/
  // Inputs
    .RST_B  ( HPAD_RST_B ),                                      // Templated
    .GMII_CLK  ( HCLK ),                                         // Templated
    .O_RESET_VALUE  ( HPAD_O_RESET_VALUE[12] ),                  // Templated
    .PAD_OUT  ( HPAD_OUT[12] ),                                  // Templated
    .PAD_OEN  ( HPAD_OEN[12] ),                                  // Templated
    .PAD_C  ( HPAD_C[12] ),                                      // Templated
    .GMII_TXD_P  ( HPAD_TXD_P[12] ),                             // Templated
    .GMII_TXD_N  ( HPAD_TXD_N[12] ),                             // Templated
    .RG_XOR_EN  ( RG_HPAD_XOR_EN[12] ),                          // Templated
    .RG_RGMII_MODE_EN  ( RG_HPAD_RGMII_MODE_EN[12] ),            // Templated
    .RG_DDR_EN  ( RG_HPAD_DDR_EN[12] ),                          // Templated
    .RG_EDGEA  ( RG_HPAD_EDGEA[12] ),                            // Templated
    .RG_EDGEB  ( RG_HPAD_EDGEB[12] ),                            // Templated
    .RG_PAD_IN_DIS  ( RG_HPAD_IN_DIS[12] ),                      // Templated
    .TEST_MODE  ( TEST_MODE ),                                   // Templated
    .SCAN_EN  ( 1'b0 ),                                          // Templated
    .SCAN_IN  ( 1'b0 ),                                          // Templated
    .SO_PAD_EN  ( SO_HPAD_EN[12] ),                              // Templated
    .SI_PAD_EN  ( SI_HPAD_EN[12] ),                              // Templated
    .COMPRESSION_MODE  ( COMPRESSION_MODE ),                     // Templated
  // Outputs
    .PAD_I  ( HPAD_I[12] ),                                      // Templated
    .GMII_RXD_P  ( HPAD_RXD_P[12] ),                             // Templated
    .GMII_RXD_N  ( HPAD_RXD_N[12] ),                             // Templated
    .SCAN_OUT  ( HPAD_SCAN_OUT[12] ));                            // Templated
f_PAD_RGMII_DATA U_DATAPAD13(
	/*autoinst*/
  // Inputs
    .RST_B  ( HPAD_RST_B ),                                      // Templated
    .GMII_CLK  ( HCLK ),                                         // Templated
    .O_RESET_VALUE  ( HPAD_O_RESET_VALUE[13] ),                  // Templated
    .PAD_OUT  ( HPAD_OUT[13] ),                                  // Templated
    .PAD_OEN  ( HPAD_OEN[13] ),                                  // Templated
    .PAD_C  ( HPAD_C[13] ),                                      // Templated
    .GMII_TXD_P  ( HPAD_TXD_P[13] ),                             // Templated
    .GMII_TXD_N  ( HPAD_TXD_N[13] ),                             // Templated
    .RG_XOR_EN  ( RG_HPAD_XOR_EN[13] ),                          // Templated
    .RG_RGMII_MODE_EN  ( RG_HPAD_RGMII_MODE_EN[13] ),            // Templated
    .RG_DDR_EN  ( RG_HPAD_DDR_EN[13] ),                          // Templated
    .RG_EDGEA  ( RG_HPAD_EDGEA[13] ),                            // Templated
    .RG_EDGEB  ( RG_HPAD_EDGEB[13] ),                            // Templated
    .RG_PAD_IN_DIS  ( RG_HPAD_IN_DIS[13] ),                      // Templated
    .TEST_MODE  ( TEST_MODE ),                                   // Templated
    .SCAN_EN  ( 1'b0 ),                                          // Templated
    .SCAN_IN  ( 1'b0 ),                                          // Templated
    .SO_PAD_EN  ( SO_HPAD_EN[13] ),                              // Templated
    .SI_PAD_EN  ( SI_HPAD_EN[13] ),                              // Templated
    .COMPRESSION_MODE  ( COMPRESSION_MODE ),                     // Templated
  // Outputs
    .PAD_I  ( HPAD_I[13] ),                                      // Templated
    .GMII_RXD_P  ( HPAD_RXD_P[13] ),                             // Templated
    .GMII_RXD_N  ( HPAD_RXD_N[13] ),                             // Templated
    .SCAN_OUT  ( HPAD_SCAN_OUT[13] ));                            // Templated
f_PAD_RGMII_DATA U_DATAPAD14(
	/*autoinst*/
  // Inputs
    .RST_B  ( HPAD_RST_B ),                                      // Templated
    .GMII_CLK  ( HCLK ),                                         // Templated
    .O_RESET_VALUE  ( HPAD_O_RESET_VALUE[14] ),                  // Templated
    .PAD_OUT  ( HPAD_OUT[14] ),                                  // Templated
    .PAD_OEN  ( HPAD_OEN[14] ),                                  // Templated
    .PAD_C  ( HPAD_C[14] ),                                      // Templated
    .GMII_TXD_P  ( HPAD_TXD_P[14] ),                             // Templated
    .GMII_TXD_N  ( HPAD_TXD_N[14] ),                             // Templated
    .RG_XOR_EN  ( RG_HPAD_XOR_EN[14] ),                          // Templated
    .RG_RGMII_MODE_EN  ( RG_HPAD_RGMII_MODE_EN[14] ),            // Templated
    .RG_DDR_EN  ( RG_HPAD_DDR_EN[14] ),                          // Templated
    .RG_EDGEA  ( RG_HPAD_EDGEA[14] ),                            // Templated
    .RG_EDGEB  ( RG_HPAD_EDGEB[14] ),                            // Templated
    .RG_PAD_IN_DIS  ( RG_HPAD_IN_DIS[14] ),                      // Templated
    .TEST_MODE  ( TEST_MODE ),                                   // Templated
    .SCAN_EN  ( 1'b0 ),                                          // Templated
    .SCAN_IN  ( 1'b0 ),                                          // Templated
    .SO_PAD_EN  ( SO_HPAD_EN[14] ),                              // Templated
    .SI_PAD_EN  ( SI_HPAD_EN[14] ),                              // Templated
    .COMPRESSION_MODE  ( COMPRESSION_MODE ),                     // Templated
  // Outputs
    .PAD_I  ( HPAD_I[14] ),                                      // Templated
    .GMII_RXD_P  ( HPAD_RXD_P[14] ),                             // Templated
    .GMII_RXD_N  ( HPAD_RXD_N[14] ),                             // Templated
    .SCAN_OUT  ( HPAD_SCAN_OUT[14] ));                            // Templated
f_PAD_RGMII_DATA U_DATAPAD15(
	/*autoinst*/
  // Inputs
    .RST_B  ( HPAD_RST_B ),                                      // Templated
    .GMII_CLK  ( HCLK ),                                         // Templated
    .O_RESET_VALUE  ( HPAD_O_RESET_VALUE[15] ),                  // Templated
    .PAD_OUT  ( HPAD_OUT[15] ),                                  // Templated
    .PAD_OEN  ( HPAD_OEN[15] ),                                  // Templated
    .PAD_C  ( HPAD_C[15] ),                                      // Templated
    .GMII_TXD_P  ( HPAD_TXD_P[15] ),                             // Templated
    .GMII_TXD_N  ( HPAD_TXD_N[15] ),                             // Templated
    .RG_XOR_EN  ( RG_HPAD_XOR_EN[15] ),                          // Templated
    .RG_RGMII_MODE_EN  ( RG_HPAD_RGMII_MODE_EN[15] ),            // Templated
    .RG_DDR_EN  ( RG_HPAD_DDR_EN[15] ),                          // Templated
    .RG_EDGEA  ( RG_HPAD_EDGEA[15] ),                            // Templated
    .RG_EDGEB  ( RG_HPAD_EDGEB[15] ),                            // Templated
    .RG_PAD_IN_DIS  ( RG_HPAD_IN_DIS[15] ),                      // Templated
    .TEST_MODE  ( TEST_MODE ),                                   // Templated
    .SCAN_EN  ( 1'b0 ),                                          // Templated
    .SCAN_IN  ( 1'b0 ),                                          // Templated
    .SO_PAD_EN  ( SO_HPAD_EN[15] ),                              // Templated
    .SI_PAD_EN  ( SI_HPAD_EN[15] ),                              // Templated
    .COMPRESSION_MODE  ( COMPRESSION_MODE ),                     // Templated
  // Outputs
    .PAD_I  ( HPAD_I[15] ),                                      // Templated
    .GMII_RXD_P  ( HPAD_RXD_P[15] ),                             // Templated
    .GMII_RXD_N  ( HPAD_RXD_N[15] ),                             // Templated
    .SCAN_OUT  ( HPAD_SCAN_OUT[15] ));                            // Templated
f_PAD_RGMII_DATA U_DATAPAD16(
	/*autoinst*/
  // Inputs
    .RST_B  ( HPAD_RST_B ),                                      // Templated
    .GMII_CLK  ( HCLK ),                                         // Templated
    .O_RESET_VALUE  ( HPAD_O_RESET_VALUE[16] ),                  // Templated
    .PAD_OUT  ( HPAD_OUT[16] ),                                  // Templated
    .PAD_OEN  ( HPAD_OEN[16] ),                                  // Templated
    .PAD_C  ( HPAD_C[16] ),                                      // Templated
    .GMII_TXD_P  ( HPAD_TXD_P[16] ),                             // Templated
    .GMII_TXD_N  ( HPAD_TXD_N[16] ),                             // Templated
    .RG_XOR_EN  ( RG_HPAD_XOR_EN[16] ),                          // Templated
    .RG_RGMII_MODE_EN  ( RG_HPAD_RGMII_MODE_EN[16] ),            // Templated
    .RG_DDR_EN  ( RG_HPAD_DDR_EN[16] ),                          // Templated
    .RG_EDGEA  ( RG_HPAD_EDGEA[16] ),                            // Templated
    .RG_EDGEB  ( RG_HPAD_EDGEB[16] ),                            // Templated
    .RG_PAD_IN_DIS  ( RG_HPAD_IN_DIS[16] ),                      // Templated
    .TEST_MODE  ( TEST_MODE ),                                   // Templated
    .SCAN_EN  ( 1'b0 ),                                          // Templated
    .SCAN_IN  ( 1'b0 ),                                          // Templated
    .SO_PAD_EN  ( SO_HPAD_EN[16] ),                              // Templated
    .SI_PAD_EN  ( SI_HPAD_EN[16] ),                              // Templated
    .COMPRESSION_MODE  ( COMPRESSION_MODE ),                     // Templated
  // Outputs
    .PAD_I  ( HPAD_I[16] ),                                      // Templated
    .GMII_RXD_P  ( HPAD_RXD_P[16] ),                             // Templated
    .GMII_RXD_N  ( HPAD_RXD_N[16] ),                             // Templated
    .SCAN_OUT  ( HPAD_SCAN_OUT[16] ));                            // Templated
f_PAD_RGMII_DATA U_DATAPAD17(
	/*autoinst*/
  // Inputs
    .RST_B  ( HPAD_RST_B ),                                      // Templated
    .GMII_CLK  ( HCLK ),                                         // Templated
    .O_RESET_VALUE  ( HPAD_O_RESET_VALUE[17] ),                  // Templated
    .PAD_OUT  ( HPAD_OUT[17] ),                                  // Templated
    .PAD_OEN  ( HPAD_OEN[17] ),                                  // Templated
    .PAD_C  ( HPAD_C[17] ),                                      // Templated
    .GMII_TXD_P  ( HPAD_TXD_P[17] ),                             // Templated
    .GMII_TXD_N  ( HPAD_TXD_N[17] ),                             // Templated
    .RG_XOR_EN  ( RG_HPAD_XOR_EN[17] ),                          // Templated
    .RG_RGMII_MODE_EN  ( RG_HPAD_RGMII_MODE_EN[17] ),            // Templated
    .RG_DDR_EN  ( RG_HPAD_DDR_EN[17] ),                          // Templated
    .RG_EDGEA  ( RG_HPAD_EDGEA[17] ),                            // Templated
    .RG_EDGEB  ( RG_HPAD_EDGEB[17] ),                            // Templated
    .RG_PAD_IN_DIS  ( RG_HPAD_IN_DIS[17] ),                      // Templated
    .TEST_MODE  ( TEST_MODE ),                                   // Templated
    .SCAN_EN  ( 1'b0 ),                                          // Templated
    .SCAN_IN  ( 1'b0 ),                                          // Templated
    .SO_PAD_EN  ( SO_HPAD_EN[17] ),                              // Templated
    .SI_PAD_EN  ( SI_HPAD_EN[17] ),                              // Templated
    .COMPRESSION_MODE  ( COMPRESSION_MODE ),                     // Templated
  // Outputs
    .PAD_I  ( HPAD_I[17] ),                                      // Templated
    .GMII_RXD_P  ( HPAD_RXD_P[17] ),                             // Templated
    .GMII_RXD_N  ( HPAD_RXD_N[17] ),                             // Templated
    .SCAN_OUT  ( HPAD_SCAN_OUT[17] ));                            // Templated

f_PAD_RGMII_CLKRX_COMP U_HCLK(
		 .CTS_IGNORE	(CTS_IGNORE),
                 .CLK_IN	(HCLK_IN),
                 .CLK_SRC	(HCLK_SRC),
                 .PAD_OUT	(HCLK_PAD_OUT),
		 .PAD_C		(HCLK_PAD_C),
                 .RG_CLKO_INV		(RG_HCLKO_INV),
                 .RG_CLKO_DLY		(RG_HCLKO_DLY),
                 .RG_CLKO_SRC		(RG_HCLKO_SRC),
                 .RG_CLKO_POL		(RG_HCLKO_POL),
                 .RG_RGMII_MODE_EN	(RG_HCLK_RGMII_MODE_EN),
                 .RG_CLKI_SRC		(RG_HCLKI_SRC),
                 .RG_CLKI_DIS		(RG_HCLKI_DIS),
                 .RG_CLKI_INV		(RG_HCLKI_INV),
                 .RG_CLKI_DLY		(RG_HCLKI_DLY),
                 .RG_CLKI_POL		(RG_HCLKI_POL),
		 .RG_CK_COMP_CKINV	(RG_RX_CK_COMP_CKINV),
		 .RG_CK_COMP		(RG_RX_CK_COMP),
		 .PAD_I			(HCLK_PAD_I),
                 .CLK_SDO		(HCLK_SDO),
                 .CLKI_OUT		(HCLKI_OUT));

// Local Variables:
// verilog-library-flags:("-y ../../softpad_macro/rtl/")
// End:
endmodule
module f_PAD_RGMII_CLKTX_COMP(
	/*autoarg*/
//*******
// Inputs
//*******
    CLK_IN, CLK_SRC, PAD_OUT, RG_CLKO_INV, RG_CLKO_DLY, RG_CLKO_SRC,
    RG_CLKO_POL, RG_RGMII_MODE_EN, RG_CLKI_SRC, RG_CLKI_DIS,
    RG_CLKI_INV, RG_CLKI_DLY, RG_CLKI_POL, PAD_C, RG_CK_COMP_CKINV,
    RG_CK_COMP, CTS_IGNORE,
//********
// Outputs
//********
    CLK_SDO, CLKI_OUT, PAD_I
    );
//=============================================================================
//RGMII_CLK softpad i/o
//=============================================================================
input       CLK_IN;
input       CLK_SRC;
input       PAD_OUT;
input       RG_CLKO_INV;
input [3:0] RG_CLKO_DLY;
input       RG_CLKO_SRC;
input       RG_CLKO_POL;
input       RG_RGMII_MODE_EN;
input       RG_CLKI_SRC;
input       RG_CLKI_DIS;
input       RG_CLKI_INV;
input [3:0] RG_CLKI_DLY;
input       RG_CLKI_POL;
output CLK_SDO;
output CLKI_OUT;
input	PAD_C;
output	PAD_I;
//=============================================================================
//PAD_CLK_COMP i/o
//=============================================================================
//clock invert or not in compensate circuit, default 0(not invert)
input	RG_CK_COMP_CKINV;
//using softpad clock or compensate clock, default 0(using compensate clock)
input	RG_CK_COMP;

//=============================================================================
//Others
//=============================================================================
input	CTS_IGNORE;

f_CTS_IGNORE_MUX U_CLKTX_SPAD_IGNORE(.CKI(CLK_SRC),.IGNORE_EN(CTS_IGNORE),.CLKO(CLK_SRC_SPAD));
f_CTS_IGNORE_MUX U_CLKTX_COMP_IGNORE(.CKI(CLK_SRC),.IGNORE_EN(CTS_IGNORE),.CLKO(CLK_SRC_COMP));

/*autowire*/

f_PAD_RGMII_CLK U_PAD_RGMII_CLK(
	.PAD_I(SPAD_I),
        .CLK_SRC  ( CLK_SRC_SPAD ),
	/*autoinst*/
  // Inputs
    .CLK_IN  ( CLK_IN ),
    .PAD_OUT  ( PAD_OUT ),
    .RG_CLKO_INV  ( RG_CLKO_INV ),
    .RG_CLKO_DLY  ( RG_CLKO_DLY[3:0] ),
    .RG_CLKO_SRC  ( RG_CLKO_SRC ),
    .RG_CLKO_POL  ( RG_CLKO_POL ),
    .RG_RGMII_MODE_EN  ( RG_RGMII_MODE_EN ),
    .RG_CLKI_SRC  ( RG_CLKI_SRC ),
    .RG_CLKI_DIS  ( RG_CLKI_DIS ),
    .RG_CLKI_INV  ( RG_CLKI_INV ),
    .RG_CLKI_DLY  ( RG_CLKI_DLY[3:0] ),
    .RG_CLKI_POL  ( RG_CLKI_POL ),
    .PAD_C  ( PAD_C ),
  // Outputs
    .CLK_SDO  ( CLK_SDO ),
    .CLKI_OUT  ( CLKI_OUT ));

//clock compensate module design updated to match data path
//PAD_CLK_COMP U_CLK_COMP(
f_PAD_CLK_COMP_BIO_R2P U_CLK_COMP(
	.CLK_IN_SRC(CLK_SRC_COMP),
	.CLK_IN_SPAD(SPAD_I),
	.CLK_OUT(PAD_I),
	/*autoinst*/
  // Inputs
    .RG_CK_COMP_CKINV  ( RG_CK_COMP_CKINV ),
    .RG_CK_COMP  ( RG_CK_COMP ));

endmodule
module f_PAD_RGMII_CLKRX_COMP(
	/*autoarg*/
//*******
// Inputs
//*******
    CLK_IN, CLK_SRC, PAD_OUT, RG_CLKO_INV, RG_CLKO_DLY, RG_CLKO_SRC,
    RG_CLKO_POL, RG_RGMII_MODE_EN, RG_CLKI_SRC, RG_CLKI_DIS,
    RG_CLKI_INV, RG_CLKI_DLY, RG_CLKI_POL, PAD_C, RG_CK_COMP_CKINV,
    RG_CK_COMP, CTS_IGNORE,
//********
// Outputs
//********
    CLK_SDO, CLKI_OUT, PAD_I
    );
//=============================================================================
//RGMII_CLK softpad i/o
//=============================================================================
input       CLK_IN;
input       CLK_SRC;
input       PAD_OUT;
input       RG_CLKO_INV;
input [3:0] RG_CLKO_DLY;
input       RG_CLKO_SRC;
input       RG_CLKO_POL;
input       RG_RGMII_MODE_EN;
input       RG_CLKI_SRC;
input       RG_CLKI_DIS;
input       RG_CLKI_INV;
input [3:0] RG_CLKI_DLY;
input       RG_CLKI_POL;
output CLK_SDO;
output CLKI_OUT;
input	PAD_C;
output	PAD_I;
//=============================================================================
//PAD_CLK_COMP i/o
//=============================================================================
//clock invert or not in compensate circuit, default 0(not invert)
input	RG_CK_COMP_CKINV;
//using softpad clock or compensate clock, default 0(using compensate clock)
input	RG_CK_COMP;

//=============================================================================
//Others
//=============================================================================
input	CTS_IGNORE;

f_CTS_IGNORE_MUX U_CLKRX_SPAD_IGNORE(.CKI(PAD_C),.IGNORE_EN(CTS_IGNORE),.CLKO(CLK_SRC_SPAD));
f_CTS_IGNORE_MUX U_CLKRX_COMP_IGNORE(.CKI(PAD_C),.IGNORE_EN(CTS_IGNORE),.CLKO(CLK_SRC_COMP));

f_PAD_RGMII_CLK U_PAD_RGMII_CLK(
	.CLKI_OUT(SPAD_CLKI_OUT),
        .PAD_C  ( CLK_SRC_SPAD),
	/*autoinst*/
  // Inputs
    .CLK_IN  ( CLK_IN ),
    .CLK_SRC  ( CLK_SRC ),
    .PAD_OUT  ( PAD_OUT ),
    .RG_CLKO_INV  ( RG_CLKO_INV ),
    .RG_CLKO_DLY  ( RG_CLKO_DLY[3:0] ),
    .RG_CLKO_SRC  ( RG_CLKO_SRC ),
    .RG_CLKO_POL  ( RG_CLKO_POL ),
    .RG_RGMII_MODE_EN  ( RG_RGMII_MODE_EN ),
    .RG_CLKI_SRC  ( RG_CLKI_SRC ),
    .RG_CLKI_DIS  ( RG_CLKI_DIS ),
    .RG_CLKI_INV  ( RG_CLKI_INV ),
    .RG_CLKI_DLY  ( RG_CLKI_DLY[3:0] ),
    .RG_CLKI_POL  ( RG_CLKI_POL ),
  // Outputs
    .CLK_SDO  ( CLK_SDO ),
    .PAD_I  ( PAD_I ));

//clock compensate module design updated to match data path
//PAD_CLK_COMP U_CLK_COMP(
f_PAD_CLK_COMP_BIO_P2R U_CLK_COMP(
	.CLK_IN_SRC(CLK_SRC_COMP),
	.CLK_IN_SPAD(SPAD_CLKI_OUT),
	.CLK_OUT(CLKI_OUT),
	/*autoinst*/
  // Inputs
    .RG_CK_COMP_CKINV  ( RG_CK_COMP_CKINV ),
    .RG_CK_COMP  ( RG_CK_COMP ));

endmodule
//'timescale 1ns/1ps

//20170310 by lixiaoyong
//move PAD out of this module for project IAI136/IAB137
module f_PAD_RGMII_DATA ( // input
                   RST_B,
                   GMII_CLK,
                   O_RESET_VALUE,
                   PAD_OUT,
                   PAD_OEN,
		   PAD_C,
                   GMII_TXD_P,
                   GMII_TXD_N,
                   RG_XOR_EN,
                   RG_RGMII_MODE_EN,
                   RG_DDR_EN,
                   //RG_DS,
                   //RG_SR,
                   RG_EDGEA,
                   RG_EDGEB,
                   RG_PAD_IN_DIS,
                   COMPRESSION_MODE,
                   TEST_MODE,
                   SCAN_EN,
                   SCAN_IN,
                   SO_PAD_EN,
                   SI_PAD_EN,
                   //// inout
                   //PAD,
                   // output
                   //PAD_IN,
		   PAD_I,
                   GMII_RXD_P,
                   GMII_RXD_N,
                   SCAN_OUT);

// input declaration
input       RST_B;
input       GMII_CLK;
input       O_RESET_VALUE;
//input       GPIO_O;
input       PAD_OUT;
//input       GPIO_OE;
input       PAD_OEN;
input		PAD_C;
//input       GMII_TXD_A;
//input       GMII_TXD_B;
input       GMII_TXD_P;
input       GMII_TXD_N;
input       RG_XOR_EN;
input       RG_RGMII_MODE_EN;
input       RG_DDR_EN;
//input [1:0] RG_DS;
//input       RG_SR;
input       RG_EDGEA;
input       RG_EDGEB;
input       RG_PAD_IN_DIS;
input       TEST_MODE;
input       SCAN_EN;
input       SCAN_IN;
input       SO_PAD_EN;
input       SI_PAD_EN;
input       COMPRESSION_MODE;

//// inout declaration
//inout       PAD;
//wire PAD;

// output declaration
//output PAD_IN;
output	PAD_I;
output GMII_RXD_P;
output GMII_RXD_N;
output SCAN_OUT;
wire GMII_RXD_P;
wire GMII_RXD_N;

// reg
reg rgst_1p;
reg rgst_1n;
reg rxdp;
reg rxdn;

// wire
//wire ddr;
wire PAD_C;


//wire ddr_MX = RG_DDR_EN ? ddr : rxdp;

wire ddr_MX;
wire PAD_I_path_mode = RG_RGMII_MODE_EN ? ddr_MX : PAD_OUT;

wire SCAN_IN_MX = COMPRESSION_MODE ? SCAN_IN : rxdn;
wire PAD_I = SO_PAD_EN ? SCAN_IN_MX : PAD_I_path_mode;

//wire GPIO_OE_MX = (SO_PAD_EN | (GPIO_OE & ~SI_PAD_EN));
//wire PAD_OEN = ~GPIO_OE_MX;

wire GPIO_OE_MX = (SO_PAD_EN | (~PAD_OEN & ~SI_PAD_EN));
wire PAD_OEN_ALL = ~GPIO_OE_MX;

//wire TIE1;
//TIEHI_CELL U_TIE1 (.Y(TIE1));
//PBCU8R U_DATA_PAD( .I(PAD_I),
//								.REN(TIE1),
//								.IE(TIE1),
//                               .OEN(PAD_OEN_ALL),
//                               .PAD(PAD),
//                               .C(PAD_C)
//);
//,
//                               .REN(TIE1),
//                               .SMT(TIE1),
//                               .SR(RG_SR),
//                               .P1(1'b0),
//                               .P2(1'b0),
//                               .E1(RG_DS[0]),
//                               .E2(RG_DS[1]));
//

wire PAD_IN = PAD_C;

//mannual chain can be compressed by DFT compiler
//wire SCAN_OUT = (TEST_MODE & COMPRESSION_MODE & ~SO_PAD_EN) ? PAD_C : rxdn;
wire SCAN_OUT = rxdn;


wire DATA_FROM_PAD = RG_PAD_IN_DIS ? O_RESET_VALUE : PAD_C;
wire TxRx_MX_A = PAD_OEN ? DATA_FROM_PAD: GMII_TXD_P;
wire TxRx_MX_B = PAD_OEN ? DATA_FROM_PAD: GMII_TXD_N;

// register 1p/1n
always @(posedge GMII_CLK or negedge RST_B)
begin
  if (!RST_B)
    rgst_1p <= #0.1 O_RESET_VALUE;
  else if (SCAN_EN)
    rgst_1p <= #0.1 SCAN_IN;
  else
    //rgst_1p <= #`UD PAD_C;
    rgst_1p <= #0.1 TxRx_MX_A;
end

wire GMII_1n_CLK;
wire GMII_1n_CLK_POL = (~TEST_MODE) & RG_EDGEB;
//XOR_CELL U_1NPOL(.A(GMII_CLK), .B(GMII_1n_CLK_POL), .Y(GMII_1n_CLK));
f_CKXOR_CELL U_1NPOL(.A1(GMII_CLK), .A2(GMII_1n_CLK_POL), .Z(GMII_1n_CLK));

always @(posedge GMII_1n_CLK or negedge RST_B)
begin
  if (!RST_B)
    rgst_1n <= #0.1 O_RESET_VALUE;
  else if (SCAN_EN)
    rgst_1n <= #0.1 rgst_1p;
  else
    //rgst_1n <= #`UD PAD_C;
    rgst_1n <= #0.1 TxRx_MX_B;
end

//wire TxRx_MX_A = GPIO_OE ? GMII_TXD_P : rgst_1p;
//wire TxRx_MX_B = GPIO_OE ? GMII_TXD_N : rgst_1n;

wire decode = rgst_1p ^ rgst_1n;
wire XOR_MX = RG_XOR_EN ? decode : rgst_1n;

wire rxdp_in = rgst_1p;
wire rxdn_in = XOR_MX;

wire GMII_2p_CLK_POL = (~TEST_MODE & RG_EDGEA) ? 1'b1 : 1'b0;
wire GMII_2p_CLK;
//XOR_CELL U_2PPOL(.A(GMII_CLK), .B(GMII_2p_CLK_POL), .Y(GMII_2p_CLK));
f_CKXOR_CELL U_2PPOL(.A1(GMII_CLK), .A2(GMII_2p_CLK_POL), .Z(GMII_2p_CLK));

// register rxdp/n
always @(posedge GMII_2p_CLK or negedge RST_B)
begin
  if (!RST_B)
    rxdp <= #0.1 O_RESET_VALUE;
  else if (SCAN_EN)
    rxdp <= #0.1 rgst_1n;
  else
    rxdp <= #0.1 rxdp_in;
end

wire GMII_2n_CLK;
//wire GMII_2n_CLK_POL = (~TEST_MODE & RG_EDGEB) ? 1'b1 : 1'b0;
//XOR2X4A9TR U_2NPOL(.A(GMII_CLK), .B(GMII_2n_CLK_POL), .Y(GMII_2n_CLK));
assign	GMII_2n_CLK = GMII_CLK;

always @(posedge GMII_2n_CLK or negedge RST_B)
begin
  if (!RST_B)
    rxdn <= #0.1 O_RESET_VALUE;
  else if (SCAN_EN)
    rxdn <= #0.1 rxdp;
  else
    rxdn <= #0.1 rxdn_in;
end

// Rx output
assign GMII_RXD_P = rxdp;
assign GMII_RXD_N = rxdn;

// double-data-rate
//f_CLK_MUX_CELL U_MUX(.A  (rxdn_dly),
//                .B  (rxdp_dly),
//                .S0 (GMII_CLK),
//                .Y  (ddr));

// modify for low power,  f_CLK_MUX_CELL will be not switch when ddr disable
// 2011-09-22  lc.zhan
//wire DATA_SEL = (~RG_DDR_EN) | GMII_CLK;
//lixiaoyong: cut off the timing path from GMII_CLK to PAD/I in scan mode
wire DATA_SEL = (~RG_DDR_EN) | GMII_CLK | TEST_MODE;

f_CLK_MUX_CELL U_MUX(
		.A  (rxdn),
                .B  (rxdp),
                .S0 (DATA_SEL),
                .Y  (ddr_MX)
		);

endmodule

//'timescale 1ns/1ps

//20170310 by lixiaoyong
//move PAD out of this module for project IAI136/IAB137
//fix the delay chain logic as a gate level module
module f_PAD_RGMII_CLK( // input
                 CLK_IN,
                 CLK_SRC,
                 PAD_OUT,
                 //PAD_OEN,
		 PAD_C,
                 RG_CLKO_INV,
                 RG_CLKO_DLY,
                 RG_CLKO_SRC,
                 RG_CLKO_POL,
                 //RG_DS,
                 RG_RGMII_MODE_EN,
                 RG_CLKI_SRC,
                 RG_CLKI_DIS,
                 RG_CLKI_INV,
                 RG_CLKI_DLY,
                 RG_CLKI_POL,
                 //RG_SR,
                 //// inout
                 //PAD,
                 // output
		 PAD_I,
                 CLK_SDO,
                 //PAD_IN,
                 CLKI_OUT);

// input declaration
input       CLK_IN;
input       CLK_SRC;
//input       GPIO_O;
input       PAD_OUT;
//input       GPIO_OE;
//input       PAD_OEN;
input       RG_CLKO_INV;
input [3:0] RG_CLKO_DLY;
input       RG_CLKO_SRC;
input       RG_CLKO_POL;
input       RG_RGMII_MODE_EN;
input       RG_CLKI_SRC;
input       RG_CLKI_DIS;
input       RG_CLKI_INV;
input [3:0] RG_CLKI_DLY;
input       RG_CLKI_POL;
//input [1:0] RG_DS;
//input       RG_SR;

//// inout declaration
//inout PAD;

// output declaration
output CLK_SDO;
//output PAD_IN;
output CLKI_OUT;

input	PAD_C;
output	PAD_I;

// reg
//reg CLKO_dly;
//reg CLKI_dly;

// wire
wire CLKO_dly_1_1;
wire CLKO_dly_1_2;
wire CLKO_dly_2_1;
wire CLKO_dly_2_2;
wire CLKO_dly_3_1;
wire CLKO_dly_3_2;
wire CLKO_dly_4_1;
wire CLKO_dly_4_2;
wire CLKO_dly_5_1;
wire CLKO_dly_5_2;
wire CLKO_dly_6_1;
wire CLKO_dly_6_2;
wire CLKO_dly_7_1;
wire CLKO_dly_7_2;
wire CLKO_dly_8_1;
wire CLKO_dly_8_2;
wire CLKO_dly_9_1;
wire CLKO_dly_9_2;
wire CLKO_dly_10_1;
wire CLKO_dly_10_2;
wire CLKO_dly_11_1;
wire CLKO_dly_11_2;
wire CLKO_dly_12_1;
wire CLKO_dly_12_2;
wire CLKO_dly_13_1;
wire CLKO_dly_13_2;
wire CLKO_dly_14_1;
wire CLKO_dly_14_2;
wire CLKO_dly_15_1;
wire CLKO_dly_15_2;
wire PAD_I;
wire CLKI_dly_1_1;
wire CLKI_dly_1_2;
wire CLKI_dly_2_1;
wire CLKI_dly_2_2;
wire CLKI_dly_3_1;
wire CLKI_dly_3_2;
wire CLKI_dly_4_1;
wire CLKI_dly_4_2;
wire CLKI_dly_5_1;
wire CLKI_dly_5_2;
wire CLKI_dly_6_1;
wire CLKI_dly_6_2;
wire CLKI_dly_7_1;
wire CLKI_dly_7_2;
wire CLKI_dly_8_1;
wire CLKI_dly_8_2;
wire CLKI_dly_9_1;
wire CLKI_dly_9_2;
wire CLKI_dly_10_1;
wire CLKI_dly_10_2;
wire CLKI_dly_11_1;
wire CLKI_dly_11_2;
wire CLKI_dly_12_1;
wire CLKI_dly_12_2;
wire CLKI_dly_13_1;
wire CLKI_dly_13_2;
wire CLKI_dly_14_1;
wire CLKI_dly_14_2;
wire CLKI_dly_15_1;
wire CLKI_dly_15_2;



//wire CLKO_inv = RG_CLKO_INV ? ~CLK_SRC : CLK_SRC;
f_CKMUX_CELL U_CLKO_SRC_MUX0(.S0(RG_CLKO_INV),.A(CLK_SRC),.B(~CLK_SRC),.Y(CLKO_inv));
wire    CLKO_dly_1_0;
//XOR_CELL    U_XOR_CELL_POL0(.A(CLKO_inv), .B(RG_CLKO_POL), .Y(CLKO_dly_1_0));
f_CKXOR_CELL    U_XOR_CELL_POL0(.A1(CLKO_inv), .A2(RG_CLKO_POL), .Z(CLKO_dly_1_0));

f_SPAD_DLY_CHAIN	U_CLKO_DLY_CHAIN0(
	.CLKIN	(CLKO_dly_1_0),
	.DLY_SEL	(RG_CLKO_DLY),
	.CLKOUT		(CLKO_dly)
);

//always @(*)
//begin
//  case (RG_CLKO_DLY)
//    4'b0000 : CLKO_dly = CLKO_inv;
//    4'b0001 : CLKO_dly = CLKO_dly_1_2;
//    4'b0010 : CLKO_dly = CLKO_dly_2_2;
//    4'b0011 : CLKO_dly = CLKO_dly_3_2;
//    4'b0100 : CLKO_dly = CLKO_dly_4_2;
//    4'b0101 : CLKO_dly = CLKO_dly_5_2;
//    4'b0110 : CLKO_dly = CLKO_dly_6_2;
//    4'b0111 : CLKO_dly = CLKO_dly_7_2;
//    4'b1000 : CLKO_dly = CLKO_dly_8_2;
//    4'b1001 : CLKO_dly = CLKO_dly_9_2;
//    4'b1010 : CLKO_dly = CLKO_dly_10_2;
//    4'b1011 : CLKO_dly = CLKO_dly_11_2;
//    4'b1100 : CLKO_dly = CLKO_dly_12_2;
//    4'b1101 : CLKO_dly = CLKO_dly_13_2;
//    4'b1110 : CLKO_dly = CLKO_dly_14_2;
//    //4'b1111 : CLKO_dly = CLKO_dly_15_2;
//    default : CLKO_dly = CLKO_dly_15_2;
//  endcase
//end

wire    CLKO_POL;
//XOR_CELL    U_XOR_CELL_POL1(.A(CLKO_dly), .B(RG_CLKO_POL), .Y(CLKO_POL));
f_CKXOR_CELL    U_XOR_CELL_POL1(.A1(CLKO_dly), .A2(RG_CLKO_POL), .Z(CLKO_POL));
//wire CLKO_src = RG_CLKO_SRC  ? CLKO_POL : CLK_IN;
f_CKMUX_CELL U_CLKO_SRC_MUX1(.S0(RG_CLKO_SRC),.A(CLK_IN),.B(CLKO_POL),.Y(CLKO_src));

//wire CLK_BUF_in = RG_RGMII_MODE_EN ? CLKO_src : GPIO_O;
wire CLK_BUF_in = RG_RGMII_MODE_EN ? CLKO_src : PAD_OUT;

f_CLK_BUF_CELL  U_PAD_I_buf(.A(CLK_BUF_in), .Y(PAD_I));

f_CLK_BUF_CELL  U_CLK_SDO_buf(.A(CLK_IN), .Y(CLK_SDO));

//wire PAD_OEN = ~GPIO_OE;

//PBCU12R U_CLK_PAD			( .I(PAD_I),
//								.REN(TIE1),
//								.IE(TIE1),
//                              .OEN(PAD_OEN),
//                              .PAD(PAD),
//                              .C(PAD_IN)
//);

//wire CLKI_src = RG_CLKI_SRC ? CLK_SRC : PAD_IN;
wire CLKI_src = RG_CLKI_SRC ? CLK_SRC : PAD_C;

wire CLKI_dis = CLKI_src | RG_CLKI_DIS;

//wire CLKI_inv = RG_CLKI_INV ? ~CLKI_dis : CLKI_dis;
//
////wire CLKI_pol_1 = CLKI_inv ^ RG_CLKI_POL;
//wire CLKI_pol_1;
//XOR2X4A9TR U_POL1(.A(CLKI_inv), .B(RG_CLKI_POL), .Y(CLKI_pol_1));

// move the RG_CLKI_INV from CLK path
// 2011-10-15  lc.zhan
wire	CLKI_POL_1ST = RG_CLKI_INV ^ RG_CLKI_POL;

wire CLKI_pol_1;
//XOR_CELL U_POL1(.A(CLKI_dis), .B(CLKI_POL_1ST), .Y(CLKI_pol_1));
f_CKXOR_CELL U_POL1(.A1(CLKI_dis), .A2(CLKI_POL_1ST), .Z(CLKI_pol_1));


f_SPAD_DLY_CHAIN	U_CLKI_DLY_CHAIN0(
	.CLKIN	(CLKI_pol_1),
	.DLY_SEL	(RG_CLKI_DLY),
	.CLKOUT		(CLKI_dly)
);

//always @(*)
//begin
//  case (RG_CLKI_DLY)
//    4'b0000 : CLKI_dly = CLKI_pol_1;
//    4'b0001 : CLKI_dly = CLKI_dly_1_2;
//    4'b0010 : CLKI_dly = CLKI_dly_2_2;
//    4'b0011 : CLKI_dly = CLKI_dly_3_2;
//    4'b0100 : CLKI_dly = CLKI_dly_4_2;
//    4'b0101 : CLKI_dly = CLKI_dly_5_2;
//    4'b0110 : CLKI_dly = CLKI_dly_6_2;
//    4'b0111 : CLKI_dly = CLKI_dly_7_2;
//    4'b1000 : CLKI_dly = CLKI_dly_8_2;
//    4'b1001 : CLKI_dly = CLKI_dly_9_2;
//    4'b1010 : CLKI_dly = CLKI_dly_10_2;
//    4'b1011 : CLKI_dly = CLKI_dly_11_2;
//    4'b1100 : CLKI_dly = CLKI_dly_12_2;
//    4'b1101 : CLKI_dly = CLKI_dly_13_2;
//    4'b1110 : CLKI_dly = CLKI_dly_14_2;
//    //4'b1111 : CLKI_dly = CLKI_dly_15_2;
//    default : CLKI_dly = CLKI_dly_15_2;
//  endcase
//end

//wire CLKI_pol_2 = CLKI_dly ^ RG_CLKI_POL;
wire CLKI_pol_2;
//XOR_CELL U_POL2(.A(CLKI_dly), .B(RG_CLKI_POL), .Y(CLKI_pol_2));
f_CKXOR_CELL U_POL2(.A1(CLKI_dly), .A2(RG_CLKI_POL), .Z(CLKI_pol_2));

f_CLK_BUF_CELL  U_CLKI_OUT_buf(.A(CLKI_pol_2), .Y(CLKI_OUT));


endmodule


 // SPAD_DLY_CHAIN_DEFINED

module f_SPAD_DLY_CHAIN(
	CLKIN,
	DLY_SEL,
	CLKOUT
);
input	CLKIN;
input	[3:0]	DLY_SEL;
output	CLKOUT;
// delay chain
f_CLK_DLY005_CELL U_CLK_DLY_1 (.A (CLKIN),   .Y (CLK_dly_1));
f_CLK_DLY005_CELL U_CLK_DLY_2 (.A (CLK_dly_1),  .Y (CLK_dly_2));
f_CLK_DLY005_CELL U_CLK_DLY_3 (.A (CLK_dly_2),  .Y (CLK_dly_3));
f_CLK_DLY005_CELL U_CLK_DLY_4 (.A (CLK_dly_3),  .Y (CLK_dly_4));
f_CLK_DLY005_CELL U_CLK_DLY_5 (.A (CLK_dly_4),  .Y (CLK_dly_5));
f_CLK_DLY005_CELL U_CLK_DLY_6 (.A (CLK_dly_5),  .Y (CLK_dly_6));
f_CLK_DLY005_CELL U_CLK_DLY_7 (.A (CLK_dly_6),  .Y (CLK_dly_7));
f_CLK_DLY005_CELL U_CLK_DLY_8 (.A (CLK_dly_7),  .Y (CLK_dly_8));
f_CLK_DLY005_CELL U_CLK_DLY_9 (.A (CLK_dly_8),  .Y (CLK_dly_9));
f_CLK_DLY005_CELL U_CLK_DLY_10(.A (CLK_dly_9),  .Y (CLK_dly_10));
f_CLK_DLY005_CELL U_CLK_DLY_11(.A (CLK_dly_10), .Y (CLK_dly_11));
f_CLK_DLY005_CELL U_CLK_DLY_12(.A (CLK_dly_11), .Y (CLK_dly_12));
f_CLK_DLY005_CELL U_CLK_DLY_13(.A (CLK_dly_12), .Y (CLK_dly_13));
f_CLK_DLY005_CELL U_CLK_DLY_14(.A (CLK_dly_13), .Y (CLK_dly_14));
f_CLK_DLY005_CELL U_CLK_DLY_15(.A (CLK_dly_14), .Y (CLK_dly_15));

//delay select
f_CKMUX_CELL U_CLK_DLY_MUXL0_0(.S0(DLY_SEL[0]),.A(CLKIN),.B(CLK_dly_1),.Y(CLK_dly_L0_0));
f_CKMUX_CELL U_CLK_DLY_MUXL0_1(.S0(DLY_SEL[0]),.A(CLK_dly_2),.B(CLK_dly_3),.Y(CLK_dly_L0_1));
f_CKMUX_CELL U_CLK_DLY_MUXL0_2(.S0(DLY_SEL[0]),.A(CLK_dly_4),.B(CLK_dly_5),.Y(CLK_dly_L0_2));
f_CKMUX_CELL U_CLK_DLY_MUXL0_3(.S0(DLY_SEL[0]),.A(CLK_dly_6),.B(CLK_dly_7),.Y(CLK_dly_L0_3));
f_CKMUX_CELL U_CLK_DLY_MUXL0_4(.S0(DLY_SEL[0]),.A(CLK_dly_8),.B(CLK_dly_9),.Y(CLK_dly_L0_4));
f_CKMUX_CELL U_CLK_DLY_MUXL0_5(.S0(DLY_SEL[0]),.A(CLK_dly_10),.B(CLK_dly_11),.Y(CLK_dly_L0_5));
f_CKMUX_CELL U_CLK_DLY_MUXL0_6(.S0(DLY_SEL[0]),.A(CLK_dly_12),.B(CLK_dly_13),.Y(CLK_dly_L0_6));
f_CKMUX_CELL U_CLK_DLY_MUXL0_7(.S0(DLY_SEL[0]),.A(CLK_dly_14),.B(CLK_dly_15),.Y(CLK_dly_L0_7));

f_CKMUX_CELL U_CLK_DLY_MUXL1_0(.S0(DLY_SEL[1]),.A(CLK_dly_L0_0),.B(CLK_dly_L0_1),.Y(CLK_dly_L1_0));
f_CKMUX_CELL U_CLK_DLY_MUXL1_1(.S0(DLY_SEL[1]),.A(CLK_dly_L0_2),.B(CLK_dly_L0_3),.Y(CLK_dly_L1_1));
f_CKMUX_CELL U_CLK_DLY_MUXL1_2(.S0(DLY_SEL[1]),.A(CLK_dly_L0_4),.B(CLK_dly_L0_5),.Y(CLK_dly_L1_2));
f_CKMUX_CELL U_CLK_DLY_MUXL1_3(.S0(DLY_SEL[1]),.A(CLK_dly_L0_6),.B(CLK_dly_L0_7),.Y(CLK_dly_L1_3));

f_CKMUX_CELL U_CLK_DLY_MUXL2_0(.S0(DLY_SEL[2]),.A(CLK_dly_L1_0),.B(CLK_dly_L1_1),.Y(CLK_dly_L2_0));
f_CKMUX_CELL U_CLK_DLY_MUXL2_1(.S0(DLY_SEL[2]),.A(CLK_dly_L1_2),.B(CLK_dly_L1_3),.Y(CLK_dly_L2_1));

f_CKMUX_CELL U_CLK_DLY_MUXL3(.S0(DLY_SEL[3]),.A(CLK_dly_L2_0),.B(CLK_dly_L2_1),.Y(CLKOUT));
endmodule
 // SPAD_DLY_CHAIN_DEFINED

module f_PAD_CLK_COMP_BIO_P2R(
	CLK_IN_SRC,
	CLK_IN_SPAD,
	RG_CK_COMP_CKINV,
	RG_CK_COMP,
	CLK_OUT
);
//the original clock input
input	CLK_IN_SRC;
//clock input from RGMII_CLK softpad
input	CLK_IN_SPAD;
//clock invert or not in compensate circuit, default 0(not invert)
input	RG_CK_COMP_CKINV;
//using softpad clock or compensate clock, default 0(using compensate clock)
input	RG_CK_COMP;
//clock output
output	CLK_OUT;

//  Startpoint: BIO_RXD_2 (input port clocked by IOCTL_RX_CLK)
//  Endpoint: CHIPF0/PARF_WRAPPER0/BIO_CTL_RN0/u_bio_top_0/u_macro_wrap_0/u_sftpad_0/IOPAD_H_ALL0/U_DATAPAD2/rgst_1n_reg
//               (rising edge-triggered flip-flop clocked by IOCTL_RX_CLK')
//  Path Group: BIO_P2R
//  Path Type: max
//  Max Data Paths Derating Factor  : 1.0000
//  Min Clock Paths Derating Factor : 0.9500
//  Max Clock Paths Derating Factor : 1.0000
//
//  Point                                                   Incr       Path
//  ------------------------------------------------------------------------------
//  clock IOCTL_RX_CLK (rise edge)                        0.0000     0.0000
//  clock network delay (propagated)                      0.0000     0.0000
//  input external delay                                  0.4000     0.4000 f
//  BIO_RXD_2 (inout)                                     0.0000     0.4000 f
//  CHIPF0/PARF_WRAPPER0/BIO_CTL_RN0/u_bio_top_0/u_macro_wrap_0/u_pad_sth_0/RXD[2] (BSIOSTH_IAB137)
//                                                        0.0000     0.4000 f
//  CHIPF0/PARF_WRAPPER0/BIO_CTL_RN0/u_bio_top_0/u_macro_wrap_0/u_pad_sth_0/C_RXD[2] (BSIOSTH_IAB137)
//                                                        0.8325 &   1.2325 f
//  CHIPF0/PARF_WRAPPER0/BIO_CTL_RN0/u_bio_top_0/u_macro_wrap_0/hm_boundary_clk_buf_31_0/CLK (CKBD12)
//                                                       -0.0000 &   1.2325 f
//  CHIPF0/PARF_WRAPPER0/BIO_CTL_RN0/u_bio_top_0/u_macro_wrap_0/hm_boundary_clk_buf_31_0/C (CKBD12)
//                                                        0.1506 &   1.3830 f
//  CHIPF0/PARF_WRAPPER0/BIO_CTL_RN0/u_bio_top_0/u_macro_wrap_0/u_sftpad_0/IOPAD_H_ALL0/U_DATAPAD2/icc_postcts_func_1/A2 (AN2XLVTD1)
//                                                        0.0244 &   1.4075 f
//  CHIPF0/PARF_WRAPPER0/BIO_CTL_RN0/u_bio_top_0/u_macro_wrap_0/u_sftpad_0/IOPAD_H_ALL0/U_DATAPAD2/icc_postcts_func_1/Z (AN2XLVTD1)
//                                                        0.1351 &   1.5426 f
//  CHIPF0/PARF_WRAPPER0/BIO_CTL_RN0/u_bio_top_0/u_macro_wrap_0/u_sftpad_0/IOPAD_H_ALL0/U_DATAPAD2/rgst_1n_reg/D (SDFCNQHVTD1)
//                                                        0.0000 &   1.5426 f
//  data arrival time                                                1.5426
//
//  clock IOCTL_RX_CLK' (rise edge)                       1.1000     1.1000
//  clock network delay (propagated)                      0.9866     2.0866
//  clock reconvergence pessimism                         0.0000     2.0866
//  inter-clock uncertainty                              -0.1500     1.9366
//  CHIPF0/PARF_WRAPPER0/BIO_CTL_RN0/u_bio_top_0/u_macro_wrap_0/u_sftpad_0/IOPAD_H_ALL0/U_DATAPAD2/rgst_1n_reg/CP (SDFCNQHVTD1)
//                                                                   1.9366 r
//  library setup time                                   -0.1915     1.7451
//  data required time                                               1.7451
//  ------------------------------------------------------------------------------
//  data required time                                               1.7451
//  data arrival time                                               -1.5426
//  ------------------------------------------------------------------------------
//  slack (MET)                                                      0.2025
//
//
//1
//nogu-modified start Reference Path Delay 2017-05-24//
f_CLK_BUF_CELL  U_CLKIN_BUF(.A(CLK_IN_SRC), .Y(CLK_IN_BUF));
//AN2XLVTD1 U_AND_CELL_COMP (.A1(1'b1), .A2(CLK_IN_SRC), .Z(CLK_IN_BUF));
//nogu-modified end Reference Path Delay 2017-05-24//

f_CLK_INV_CELL	U_CLKIN_INV(.A(CLK_IN_BUF), .Y(CLK_IN_INV));
f_CKMUX_CELL U_CLKIN_MUX(.S0(RG_CK_COMP_CKINV),.A(CLK_IN_BUF),.B(CLK_IN_INV),.Y(CLK_OUT_SRC));
f_CKMUX_CELL U_CLKOUT_MUX(.S0(RG_CK_COMP),.A(CLK_OUT_SRC),.B(CLK_IN_SPAD),.Y(CLK_OUT));
endmodule

module f_PAD_CLK_COMP_BIO_R2P(
	CLK_IN_SRC,
	CLK_IN_SPAD,
	RG_CK_COMP_CKINV,
	RG_CK_COMP,
	CLK_OUT
);
//the original clock input
input	CLK_IN_SRC;
//clock input from RGMII_CLK softpad
input	CLK_IN_SPAD;
//clock invert or not in compensate circuit, default 0(not invert)
input	RG_CK_COMP_CKINV;
//using softpad clock or compensate clock, default 0(using compensate clock)
input	RG_CK_COMP;
//clock output
output	CLK_OUT;

//  Startpoint: CHIPF0/PARF_WRAPPER0/BIO_CTL_RN0/u_bio_top_0/u_macro_wrap_0/u_sftpad_0/IOPAD_V_ALL0/U_DATAPAD1/rxdp_reg
//               (rising edge-triggered flip-flop clocked by IOCTL_TX_CLK')
//  Endpoint: BIO_TXD_1 (output port clocked by IOCTL_TX_CLK)
//  Path Group: BIO_R2P
//  Path Type: max
//  Max Data Paths Derating Factor  : 1.0000
//  Min Clock Paths Derating Factor : 0.9500
//  Max Clock Paths Derating Factor : 1.0000
//
//  Point                                                   Incr       Path
//  ------------------------------------------------------------------------------
//  clock IOCTL_TX_CLK' (rise edge)                       1.1000     1.1000
//  clock network delay (propagated)                      1.0672     2.1672
//  CHIPF0/PARF_WRAPPER0/BIO_CTL_RN0/u_bio_top_0/u_macro_wrap_0/u_sftpad_0/IOPAD_V_ALL0/U_DATAPAD1/rxdp_reg/CP (SDFCNQLVTD4)
//                                                        0.0000     2.1672 r
//  CHIPF0/PARF_WRAPPER0/BIO_CTL_RN0/u_bio_top_0/u_macro_wrap_0/u_sftpad_0/IOPAD_V_ALL0/U_DATAPAD1/rxdp_reg/Q (SDFCNQLVTD4)
//                                                        0.2433 &   2.4105 r
//  CHIPF0/PARF_WRAPPER0/BIO_CTL_RN0/u_bio_top_0/u_macro_wrap_0/u_sftpad_0/IOPAD_V_ALL0/U_DATAPAD1/U_MUX/U_MUX_CELL/I1 (MUX2LVTD1)
//                                                        0.0001 &   2.4106 r
//  CHIPF0/PARF_WRAPPER0/BIO_CTL_RN0/u_bio_top_0/u_macro_wrap_0/u_sftpad_0/IOPAD_V_ALL0/U_DATAPAD1/U_MUX/U_MUX_CELL/Z (MUX2LVTD1)
//                                                        0.1226 &   2.5331 r
//  CHIPF0/PARF_WRAPPER0/BIO_CTL_RN0/u_bio_top_0/u_macro_wrap_0/u_sftpad_0/IOPAD_V_ALL0/U_DATAPAD1/dc_tpdsr9/I1 (MUX2LVTD4)
//                                                        0.0001 &   2.5332 r
//  CHIPF0/PARF_WRAPPER0/BIO_CTL_RN0/u_bio_top_0/u_macro_wrap_0/u_sftpad_0/IOPAD_V_ALL0/U_DATAPAD1/dc_tpdsr9/Z (MUX2LVTD4)
//                                                        0.1220 &   2.6552 r
//  CHIPF0/PARF_WRAPPER0/BIO_CTL_RN0/u_bio_top_0/u_macro_wrap_0/hm_boundary_clk_buf_153_0/CLK (CKBD12)
//                                                        0.0001 &   2.6553 r
//  CHIPF0/PARF_WRAPPER0/BIO_CTL_RN0/u_bio_top_0/u_macro_wrap_0/hm_boundary_clk_buf_153_0/C (CKBD12)
//                                                        0.1051 &   2.7605 r
//  CHIPF0/PARF_WRAPPER0/BIO_CTL_RN0/u_bio_top_0/u_macro_wrap_0/u_pad_est_0/I_TXD[1] (BSIOEST_IAB137)
//                                                       -0.0000 &   2.7605 r
//  CHIPF0/PARF_WRAPPER0/BIO_CTL_RN0/u_bio_top_0/u_macro_wrap_0/u_pad_est_0/TXD[1] (BSIOEST_IAB137)
//                                                        0.2824     3.0429 r
//  BIO_TXD_1 (inout)                                     0.0000     3.0429 r
//  data arrival time                                                3.0429
//
//  clock IOCTL_TX_CLK (rise edge)                        2.2000     2.2000
//  clock network delay (propagated)                      0.0000     2.2000
//  clock reconvergence pessimism                         0.0000     2.2000
//  inter-clock uncertainty                              -0.1500     2.0500
//  output external delay                                -0.4000     1.6500
//  data required time                                               1.6500
//  ------------------------------------------------------------------------------
//  data required time                                               1.6500
//  data arrival time                                               -3.0429
//  ------------------------------------------------------------------------------
//  slack (VIOLATED)                                                -1.3929
//
//
//1



//nogu-modified start Reference Path Delay 2017-05-24//
f_CLK_BUF_CELL  U_CLKIN_BUF(.A(CLK_IN_SRC), .Y(CLK_IN_BUF));
//wire CLK_IN_SRC_MUX;
//MUX2LVTD1 U_MUX_CELL_COMP0         (.I0(1'b0), .I1(CLK_IN_SRC),     .S(1'b1), .Z(CLK_IN_SRC_MUX));
//MUX2LVTD4 U_MUX_CELL_COMP1         (.I0(1'b0), .I1(CLK_IN_SRC_MUX), .S(1'b1), .Z(CLK_IN_BUF));
//nogu-modified end Reference Path Delay 2017-05-24//

f_CLK_INV_CELL	U_CLKIN_INV(.A(CLK_IN_BUF), .Y(CLK_IN_INV));
f_CKMUX_CELL U_CLKIN_MUX(.S0(RG_CK_COMP_CKINV),.A(CLK_IN_BUF),.B(CLK_IN_INV),.Y(CLK_OUT_SRC));
f_CKMUX_CELL U_CLKOUT_MUX(.S0(RG_CK_COMP),.A(CLK_OUT_SRC),.B(CLK_IN_SPAD),.Y(CLK_OUT));
endmodule
//==============================================================================
//
//    This confidential and proprietary hardware may be used only as
//  authorized by a licensing agreement from
//                    SunMedia Technology Co., LTD.
//
//  In the event of publication, the following notice is applicable:
//
//            COPYRIGHT 2016, SunMedia Technology Co., LTD.
//                        ALL RIGHTS RESERVED
//
//  The entire notice above must be reproduced on all authorized copies.
//
//==============================================================================
//
//  File        : f_bio_axi_rslice.v
//  Author      : kun.zhang
//  Date        : 21/Jan/2016
//  Version     : 1.0
//  Abstract    : AXI channel reverse (backward) register slice block. This
//                module will add registers in AXI channel ready path. The
//                parameter DIH (Data Index High) is equal to (Data_Width-1)
//
//  Modification History:
//  Date          By            Version         Change Description
//------------------------------------------------------------------------------
//  21/Jan/2016   kun.zhang      1.0            Original
//
//
//==============================================================================



module f_bio_axi_rslice #(parameter DIH = 1) (
  input  wire         clk,      // clock
  input  wire         rstn,     // reset
  input  wire         valid_s,  // channel valid of source
  input  wire [DIH:0] data_s,   // channel data of source
  output wire         ready_s,  // channel ready of source
  output wire         valid_d,  // channel valid of destination
  output wire [DIH:0] data_d,   // channel data of destination
  input  wire         ready_d   // channel ready of destination
);

localparam DW = DIH + 1;

wire         data_en;   // Data enabled to transfer to data buffer
reg          dbuf_full; // Data buffer is full
reg  [DIH:0] data_buf;  // Data buffer entry

assign data_en = (valid_s & ~dbuf_full) & ~ready_d;
assign data_d  = dbuf_full ? data_buf : data_s;
assign valid_d = (valid_s | dbuf_full);
assign ready_s = ~dbuf_full;

always @ (posedge clk or negedge rstn) begin
  if (~rstn)
    dbuf_full <= #0.1 1'b0;
  else begin
    if (data_en | ready_d)
      dbuf_full <= #0.1 data_en;
  end
end

always @ (posedge clk or negedge rstn) begin
  if (~rstn)
    data_buf <= #0.1 {DW{1'b0}};
  else begin
    if (data_en)
      data_buf <= #0.1 data_s;
  end
end
endmodule

//==============================================================================
//
//    This confidential and proprietary hardware may be used only as
//  authorized by a licensing agreement from
//                    SunMedia Technology Co., LTD.
//
//  In the event of publication, the following notice is applicable:
//
//            COPYRIGHT 2017, SunMedia Technology Co., LTD.
//                        ALL RIGHTS RESERVED
//
//  The entire notice above must be reproduced on all authorized copies.
//
//==============================================================================
//
//  File        : f_fbio_top.v
//  Author      : kun.zhang
//  Date        : 02/Mar/2018
//  Version     : 1.2
//  Abstract    : This is the top module of BIO controller.
//
//  Modification History:
//  Date          By            Version         Change Description
//------------------------------------------------------------------------------
//  13/Mar/2017   kun.zhang      1.0            Original
//  06/Dec/2017   kun.zhang      1.1            Add AXI slave1 interface for B2A
//                                              CPU access
//  02/Mar/2018   kun.zhang      1.2            Modified for FPGA based BIO
//
//
//==============================================================================


module f_fbio_top (
  // IO Pads
  input  wire [37:0]  io_pad_i,     // Input from PINMX
  output wire [37:0]  io_pad_oen,   // Output enable to PINMX
  output wire [37:0]  io_pad_o,     // Output to PINMX
  output wire         fpga_rstn,    // Reset output to FPGA

  //
  input  wire         achip_clk,    // A-chip reference clock from B-chip clk_gen
  input  wire         achip_rst,    // A-chip reset from B-chip rst_gen
  output wire         ioclk_src,    // IO clock source from PAD, (RX clock)
  input  wire         com_mode,     // Compression mode
  input  wire         cts_ignore,   // CTS_IGNORE for clock
  input  wire         scan_clk,     // SCAN clock input to Soft PAD

  // global signal from B-chip to A-chip
  input  wire         atest_en,      // A-chip test mode enable
  input  wire         stest_mode,    // Self-test mode
  output wire         stest_fail,    // Self-test Fail
  output wire         stest_tfail,   // Self-test timeout fail
  output wire         stest_done,    // Self-test done
  output wire [15:0]  bio_probe,     // Probe data out
  output wire [3:0]   bio_probe1,    // Probe clock out

  input  wire         tx_clk,   // TX domain clock
  input  wire         tx_rstn,  // TX domain reset
  input  wire         rx_clk,   // RX domain clock
  input  wire         rx_rstn,  // RX domain reset
  input  wire         sysclk,   // System domain clock
  input  wire         sysrstn,  // System domain reset
  input  wire         adr_remap,    // Address remap

  input  wire         bist_rstn, // NVIC_RST_B
  input  wire         bist_mode,
  input  wire         test_mode,
  input  wire         scan_enable,
  output wire [12:0]  bist_fail,
  output wire [12:0]  bist_finish,
  input  wire         mem_clk2x,

  // AXI slave interface -->
  input  wire [3:0]   axis0_awid,
  input  wire [31:0]  axis0_awaddr,
  input  wire [3:0]   axis0_awlen,
  input  wire [2:0]   axis0_awsize,
  input  wire [1:0]   axis0_awburst,
  input  wire [1:0]   axis0_awlock,
  input  wire [3:0]   axis0_awcache,
  input  wire [2:0]   axis0_awprot,
  input  wire         axis0_awvalid,
  output wire         axis0_awready,

  input  wire [3:0]   axis0_wid,
  input  wire [31:0]  axis0_wdata,
  input  wire [3:0]   axis0_wstrb,
  input  wire         axis0_wlast,
  input  wire         axis0_wvalid,
  output wire         axis0_wready,

  output wire [3:0]   axis0_bid,
  output wire [1:0]   axis0_bresp,
  output wire         axis0_bvalid,
  input  wire         axis0_bready,

  input  wire [3:0]   axis0_arid,
  input  wire [31:0]  axis0_araddr,
  input  wire [3:0]   axis0_arlen,
  input  wire [2:0]   axis0_arsize,
  input  wire [1:0]   axis0_arburst,
  input  wire [1:0]   axis0_arlock,
  input  wire [3:0]   axis0_arcache,
  input  wire [2:0]   axis0_arprot,
  input  wire         axis0_arvalid,
  output wire         axis0_arready,

  output wire [3:0]   axis0_rid,
  output wire [31:0]  axis0_rdata,
  output wire [1:0]   axis0_rresp,
  output wire         axis0_rlast,
  output wire         axis0_rvalid,
  input  wire         axis0_rready,
  // AXI slave port for B2A CPU access
  input  wire [8:0]   axis1_awid,
  input  wire [31:0]  axis1_awaddr,
  input  wire [3:0]   axis1_awlen,
  input  wire [2:0]   axis1_awsize,
  input  wire [1:0]   axis1_awburst,
  input  wire [1:0]   axis1_awlock,
  input  wire [3:0]   axis1_awcache,
  input  wire [2:0]   axis1_awprot,
  input  wire         axis1_awvalid,
  output wire         axis1_awready,

  input  wire [8:0]   axis1_wid,
  input  wire [63:0]  axis1_wdata,
  input  wire [7:0]   axis1_wstrb,
  input  wire         axis1_wlast,
  input  wire         axis1_wvalid,
  output wire         axis1_wready,

  output wire [8:0]   axis1_bid,
  output wire [1:0]   axis1_bresp,
  output wire         axis1_bvalid,
  input  wire         axis1_bready,

  input  wire [8:0]   axis1_arid,
  input  wire [31:0]  axis1_araddr,
  input  wire [3:0]   axis1_arlen,
  input  wire [2:0]   axis1_arsize,
  input  wire [1:0]   axis1_arburst,
  input  wire [1:0]   axis1_arlock,
  input  wire [3:0]   axis1_arcache,
  input  wire [2:0]   axis1_arprot,
  input  wire         axis1_arvalid,
  output wire         axis1_arready,

  output wire [8:0]   axis1_rid,
  output wire [63:0]  axis1_rdata,
  output wire [1:0]   axis1_rresp,
  output wire         axis1_rlast,
  output wire         axis1_rvalid,
  input  wire         axis1_rready,
  // <-- AXI slave interface
  // AXI master0 interface -->
  // AXI Write Address phase signals
  output wire [3:0]   axim0_awid,
  output wire [31:0]  axim0_awaddr,
  output wire [3:0]   axim0_awlen,
  output wire [2:0]   axim0_awsize,
  output wire [1:0]   axim0_awburst,
  output wire [1:0]   axim0_awlock,
  output wire [3:0]   axim0_awcache,
  output wire [2:0]   axim0_awprot,
  output wire         axim0_awvalid,
  input  wire         axim0_awready,
  // AXI Write Data phase signals
  output wire [3:0]   axim0_wid,
  output wire [127:0] axim0_wdata,
  output wire [15:0]  axim0_wstrb,
  output wire         axim0_wlast,
  output wire         axim0_wvalid,
  input  wire         axim0_wready,
  // AXI Write Response phase signals
  input  wire [3:0]   axim0_bid,
  input  wire [1:0]   axim0_bresp,
  input  wire         axim0_bvalid,
  output wire         axim0_bready,

  // AXI Read Address phase signals
  output wire [3:0]   axim0_arid,
  output wire [31:0]  axim0_araddr,
  output wire [3:0]   axim0_arlen,
  output wire [2:0]   axim0_arsize,
  output wire [1:0]   axim0_arburst,
  output wire [1:0]   axim0_arlock,
  output wire [3:0]   axim0_arcache,
  output wire [2:0]   axim0_arprot,
  output wire         axim0_arvalid,
  input  wire         axim0_arready,
  // AXI Read Data phase signals
  input  wire [3:0]   axim0_rid,
  input  wire [127:0] axim0_rdata,
  input  wire [1:0]   axim0_rresp,
  input  wire         axim0_rlast,
  input  wire         axim0_rvalid,
  output wire         axim0_rready,
  // <-- AXI master0 interface
  // AXI master1 interface -->
  // AXI Write Address phase signals
  output wire [7:0]   axim1_awid,
  output wire [31:0]  axim1_awaddr,
  output wire [3:0]   axim1_awlen,
  output wire [2:0]   axim1_awsize,
  output wire [1:0]   axim1_awburst,
  output wire [1:0]   axim1_awlock,
  output wire [3:0]   axim1_awcache,
  output wire [2:0]   axim1_awprot,
  output wire         axim1_awvalid,
  input  wire         axim1_awready,
  // AXI Write Data phase signals
  output wire [7:0]   axim1_wid,
  output wire [63:0]  axim1_wdata,
  output wire [7:0]   axim1_wstrb,
  output wire         axim1_wlast,
  output wire         axim1_wvalid,
  input  wire         axim1_wready,
  // AXI Write Response phase signals
  input  wire [7:0]   axim1_bid,
  input  wire [1:0]   axim1_bresp,
  input  wire         axim1_bvalid,
  output wire         axim1_bready,

  // AXI Read Address phase signals
  output wire [7:0]   axim1_arid,
  output wire [31:0]  axim1_araddr,
  output wire [3:0]   axim1_arlen,
  output wire [2:0]   axim1_arsize,
  output wire [1:0]   axim1_arburst,
  output wire [1:0]   axim1_arlock,
  output wire [3:0]   axim1_arcache,
  output wire [2:0]   axim1_arprot,
  output wire         axim1_arvalid,
  input  wire         axim1_arready,
  // AXI Read Data phase signals
  input  wire [7:0]   axim1_rid,
  input  wire [63:0]  axim1_rdata,
  input  wire [1:0]   axim1_rresp,
  input  wire         axim1_rlast,
  input  wire         axim1_rvalid,
  output wire         axim1_rready
  // <-- AXI master1 interface
);

parameter BIO_SADR = 32'h0; // Self-test Data register address

wire [31:0]  tx_data;   // Transfer data to soft-pad, if SDR mode only bit 15:0 is valid
wire [1:0]   tx_vld;    // Transfer valid
wire         tx_rdy;    // Transfer ready from rx domain
wire [31:0]  rx_data;   // Receiver data from soft-pad, if SDR mode only bit 15:0 is valid
wire [1:0]   rx_vld;    // Reciever valid
wire         rx_rdy;    // Receiver ready to tx domain

wire         ddr_en;        // DDR mode enable
wire         en_16b;        // 16bit mode enable
wire         stest_trig;    // Self test trigger in system domain
wire         pulse_1us;     // Pulse 1us indicator
wire [2:0]   stest_pst;     // Self test previous state
wire         stest_en;      // Self test enable from test mux
wire         stest_sreq;    // Self test software request
wire         stest_run;     // Self test running for timer enable

wire [46:0]  sft_ds_en;    // PAD DS enable
wire [46:0]  sft_ie_en;    // PAD input enable
wire         sft_pwd;      // Software config power analog down
wire         test_ie;      // Test mode force input enable
wire         pi_clkrx;     // Clock RX from Soft pad
wire         spad_en;      // Soft PAD enable
wire [3:0]   rx_clki_dly;  // RX clock input delay select
wire         rx_clki_inv;  // RX clock input inverter select
wire         rx_clki_pol;  // RX clock input pol select
wire [3:0]   rx_clko_dly;  // RX clock output delay select
wire         rx_clko_inv;  // RX clock output inverter select
wire         rx_clko_pol;  // RX clock output pol select
wire [3:0]   tx_clki_dly;  // TX clock input delay select
wire         tx_clki_inv;  // TX clock input inverter select
wire         tx_clki_pol;  // TX clock input pol select
wire [3:0]   tx_clko_dly;  // TX clock output delay select
wire         tx_clko_inv;  // TX clock output inverter select
wire         tx_clko_pol;  // TX clock output pol select
wire         rx_ck_comp;   // RX clock compress mode enable
wire         rx_ck_cinv;   // RX clock inverter in compress mode
wire         tx_ck_comp;   // TX clock compress mode enable
wire         tx_ck_cinv;   // TX clock inverter in compress mode

wire         sft_rst;      // Soft reset to system domain control logics
wire         sft_set;      // The clear of reset in system domain
wire         sft_ack0;     // Soft reset ack from cpu mode
wire         sft_ack1;     // Soft reset ack for DMA write
wire         sft_ack2;     // Soft reset ack for DMA read
wire         a_reset_m;    // Achip reset mask
wire         cdc_rstn;     // CDC domain system reset
wire         txs_rstn;     // TX domain reset
wire         rxs_rstn;     // RX domain reset


wire         lvds_pop;
wire [31:0]  lvds_rdata;
wire         lvds_empty;
wire         lvds_push;
wire [31:0]  lvds_wdata;
wire         lvds_full;







wire         ddfch_rreq;
wire [31:0]  ddfch_rdata;
wire         ddfch_rvalid;


wire [31:0] st_reg_adr = BIO_SADR | 32'h50;

wire [7:0]  pb_sel;
reg  [15:0] probe;
wire [15:0] axis_probe;
wire [15:0] axim_probe0;
wire [31:0] axim_probe1;
wire [15:0] tx_probe;
wire [11:0] rx_probe;
wire [9:0]  arb_probe;

assign bio_probe1 = {tx_clk, rx_clk, achip_clk, ioclk_src};
assign bio_probe = probe;

always @ (*) begin
  case (pb_sel)
    8'h0   : probe = {tx_vld, tx_rdy, io_pad_i[16], io_pad_i[17], rx_vld, rx_rdy, io_pad_i[36], io_pad_i[37],
                      stest_pst[2:0], stest_done, stest_tfail, stest_fail};
    8'h1   : probe = {4'h0, rx_probe};
    8'h2   : probe = tx_probe;
    8'h3   : probe = axis_probe;
    8'h4   : probe = axim_probe0;
    8'h5   : probe = axim_probe1[15:0];
    8'h6   : probe = axim_probe1[31:16];
    8'h7   : probe = {6'h0, arb_probe};
    default: probe = 16'h0;
  endcase
end

assign stest_en = 1'b0;

assign lvds_pop   = 1'b0;
assign lvds_push  = 1'b0;
assign lvds_wdata = 32'h0;





assign ddfch_rreq = 1'b0;


f_bio_core u_core_0 (
  .tx_clk           (tx_clk),
  .tx_rstn          (txs_rstn),
  .rx_clk           (rx_clk),
  .rx_rstn          (rxs_rstn),
  .sysclk           (sysclk),
  .sysrstn          (sysrstn),
  .cdc_rstn         (cdc_rstn),
  .sft_rst          (sft_rst),
  .sft_set          (sft_set),
  .sft_ack0         (sft_ack0),
  .sft_ack1         (sft_ack1),
  .sft_ack2         (sft_ack2),
  .sft_ack3         (sft_ack3),
  .adr_remap        (adr_remap),
  .st_reg_adr       (st_reg_adr),

  .bist_rstn        (bist_rstn),
  .bist_mode        (bist_mode),
  .test_mode        (test_mode),
  .scan_enable      (scan_enable),
  .bist_fail        (bist_fail),
  .bist_finish      (bist_finish),
  .mem_clk2x        (mem_clk2x),

  .axis0_awid       (axis0_awid),
  .axis0_awaddr     (axis0_awaddr),
  .axis0_awlen      (axis0_awlen),
  .axis0_awsize     (axis0_awsize),
  .axis0_awburst    (axis0_awburst),
  .axis0_awlock     (axis0_awlock),
  .axis0_awcache    (axis0_awcache),
  .axis0_awprot     (axis0_awprot),
  .axis0_awvalid    (axis0_awvalid),
  .axis0_awready    (axis0_awready),

  .axis0_wid        (axis0_wid),
  .axis0_wdata      (axis0_wdata),
  .axis0_wstrb      (axis0_wstrb),
  .axis0_wlast      (axis0_wlast),
  .axis0_wvalid     (axis0_wvalid),
  .axis0_wready     (axis0_wready),

  .axis0_bid        (axis0_bid),
  .axis0_bresp      (axis0_bresp),
  .axis0_bvalid     (axis0_bvalid),
  .axis0_bready     (axis0_bready),

  .axis0_arid       (axis0_arid),
  .axis0_araddr     (axis0_araddr),
  .axis0_arlen      (axis0_arlen),
  .axis0_arsize     (axis0_arsize),
  .axis0_arburst    (axis0_arburst),
  .axis0_arlock     (axis0_arlock),
  .axis0_arcache    (axis0_arcache),
  .axis0_arprot     (axis0_arprot),
  .axis0_arvalid    (axis0_arvalid),
  .axis0_arready    (axis0_arready),

  .axis0_rid        (axis0_rid),
  .axis0_rdata      (axis0_rdata),
  .axis0_rresp      (axis0_rresp),
  .axis0_rlast      (axis0_rlast),
  .axis0_rvalid     (axis0_rvalid),
  .axis0_rready     (axis0_rready),

  // AXI slave interface for B2A CPU access
  .axis1_awid       (axis1_awid),
  .axis1_awaddr     (axis1_awaddr),
  .axis1_awlen      (axis1_awlen),
  .axis1_awsize     (axis1_awsize),
  .axis1_awburst    (axis1_awburst),
  .axis1_awlock     (axis1_awlock),
  .axis1_awcache    (axis1_awcache),
  .axis1_awprot     (axis1_awprot),
  .axis1_awvalid    (axis1_awvalid),
  .axis1_awready    (axis1_awready),

  .axis1_wid        (axis1_wid),
  .axis1_wdata      (axis1_wdata),
  .axis1_wstrb      (axis1_wstrb),
  .axis1_wlast      (axis1_wlast),
  .axis1_wvalid     (axis1_wvalid),
  .axis1_wready     (axis1_wready),

  .axis1_bid        (axis1_bid),
  .axis1_bresp      (axis1_bresp),
  .axis1_bvalid     (axis1_bvalid),
  .axis1_bready     (axis1_bready),

  .axis1_arid       (axis1_arid),
  .axis1_araddr     (axis1_araddr),
  .axis1_arlen      (axis1_arlen),
  .axis1_arsize     (axis1_arsize),
  .axis1_arburst    (axis1_arburst),
  .axis1_arlock     (axis1_arlock),
  .axis1_arcache    (axis1_arcache),
  .axis1_arprot     (axis1_arprot),
  .axis1_arvalid    (axis1_arvalid),
  .axis1_arready    (axis1_arready),

  .axis1_rid        (axis1_rid),
  .axis1_rdata      (axis1_rdata),
  .axis1_rresp      (axis1_rresp),
  .axis1_rlast      (axis1_rlast),
  .axis1_rvalid     (axis1_rvalid),
  .axis1_rready     (axis1_rready),

  // AXI Write Address phase signals
  .axim0_awid       (axim0_awid),
  .axim0_awaddr     (axim0_awaddr),
  .axim0_awlen      (axim0_awlen),
  .axim0_awsize     (axim0_awsize),
  .axim0_awburst    (axim0_awburst),
  .axim0_awlock     (axim0_awlock),
  .axim0_awcache    (axim0_awcache),
  .axim0_awprot     (axim0_awprot),
  .axim0_awvalid    (axim0_awvalid),
  .axim0_awready    (axim0_awready),
  // AXI Write Data phase signals
  .axim0_wid        (axim0_wid),
  .axim0_wdata      (axim0_wdata),
  .axim0_wstrb      (axim0_wstrb),
  .axim0_wlast      (axim0_wlast),
  .axim0_wvalid     (axim0_wvalid),
  .axim0_wready     (axim0_wready),
  // AXI Write Response phase signals
  .axim0_bid        (axim0_bid),
  .axim0_bresp      (axim0_bresp),
  .axim0_bvalid     (axim0_bvalid),
  .axim0_bready     (axim0_bready),

  // AXI Read Address phase signals
  .axim0_arid       (axim0_arid),
  .axim0_araddr     (axim0_araddr),
  .axim0_arlen      (axim0_arlen),
  .axim0_arsize     (axim0_arsize),
  .axim0_arburst    (axim0_arburst),
  .axim0_arlock     (axim0_arlock),
  .axim0_arcache    (axim0_arcache),
  .axim0_arprot     (axim0_arprot),
  .axim0_arvalid    (axim0_arvalid),
  .axim0_arready    (axim0_arready),
  // AXI Read Data phase signals
  .axim0_rid        (axim0_rid),
  .axim0_rdata      (axim0_rdata),
  .axim0_rresp      (axim0_rresp),
  .axim0_rlast      (axim0_rlast),
  .axim0_rvalid     (axim0_rvalid),
  .axim0_rready     (axim0_rready),

  // AXI Write Address phase signals
  .axim1_awid       (axim1_awid),
  .axim1_awaddr     (axim1_awaddr),
  .axim1_awlen      (axim1_awlen),
  .axim1_awsize     (axim1_awsize),
  .axim1_awburst    (axim1_awburst),
  .axim1_awlock     (axim1_awlock),
  .axim1_awcache    (axim1_awcache),
  .axim1_awprot     (axim1_awprot),
  .axim1_awvalid    (axim1_awvalid),
  .axim1_awready    (axim1_awready),
  // AXI Write Data Phase signals
  .axim1_wid        (axim1_wid),
  .axim1_wdata      (axim1_wdata),
  .axim1_wstrb      (axim1_wstrb),
  .axim1_wlast      (axim1_wlast),
  .axim1_wvalid     (axim1_wvalid),
  .axim1_wready     (axim1_wready),
  // AXI Write Response phase signals
  .axim1_bid        (axim1_bid),
  .axim1_bresp      (axim1_bresp),
  .axim1_bvalid     (axim1_bvalid),
  .axim1_bready     (axim1_bready),

  // AXI Read Address phase signals
  .axim1_arid       (axim1_arid),
  .axim1_araddr     (axim1_araddr),
  .axim1_arlen      (axim1_arlen),
  .axim1_arsize     (axim1_arsize),
  .axim1_arburst    (axim1_arburst),
  .axim1_arlock     (axim1_arlock),
  .axim1_arcache    (axim1_arcache),
  .axim1_arprot     (axim1_arprot),
  .axim1_arvalid    (axim1_arvalid),
  .axim1_arready    (axim1_arready),
  // AXI Read Data phase signals
  .axim1_rid        (axim1_rid),
  .axim1_rdata      (axim1_rdata),
  .axim1_rresp      (axim1_rresp),
  .axim1_rlast      (axim1_rlast),
  .axim1_rvalid     (axim1_rvalid),
  .axim1_rready     (axim1_rready),


















    .lvds_pop       (lvds_pop),
    .lvds_rdata     (lvds_rdata),
    .lvds_empty     (lvds_empty),
    .lvds_push      (lvds_push),
    .lvds_wdata     (lvds_wdata),
    .lvds_full      (lvds_full),







    .ddfch_rreq     (ddfch_rreq),
    .ddfch_rdata    (ddfch_rdata),
    .ddfch_rvalid   (ddfch_rvalid),


  .stest_trig       (stest_trig),
  .pulse_1us        (pulse_1us),
  .stest_sreq       (stest_sreq),
  .stest_done       (stest_done),
  .stest_fail       (stest_fail),
  .stest_tfail      (stest_tfail),
  .stest_pst        (stest_pst),
  .stest_en         (stest_en),
  .stest_run        (stest_run),

  .pb_sel           (pb_sel),
  .axis_probe       (axis_probe),
  .axim0_probe      (axim_probe0),
  .axim1_probe      (axim_probe1),
  .tx_probe         (tx_probe),
  .rx_probe         (rx_probe),
  .arb_probe        (arb_probe),

  .ddr_en           (ddr_en),
  .en_16b           (en_16b),
  .sft_ds_en        (sft_ds_en),
  .sft_ie_en        (sft_ie_en),
  .sft_pwd          (sft_pwd),
  .rx_clki_dly      (rx_clki_dly),
  .rx_clki_inv      (rx_clki_inv),
  .rx_clki_pol      (rx_clki_pol),
  .rx_clko_dly      (rx_clko_dly),
  .rx_clko_inv      (rx_clko_inv),
  .rx_clko_pol      (rx_clko_pol),
  .tx_clki_dly      (tx_clki_dly),
  .tx_clki_inv      (tx_clki_inv),
  .tx_clki_pol      (tx_clki_pol),
  .tx_clko_dly      (tx_clko_dly),
  .tx_clko_inv      (tx_clko_inv),
  .tx_clko_pol      (tx_clko_pol),
  .rx_ck_comp       (rx_ck_comp),
  .rx_ck_cinv       (rx_ck_cinv),
  .tx_ck_comp       (tx_ck_comp),
  .tx_ck_cinv       (tx_ck_cinv),

  .tx_data          (tx_data),
  .tx_vld           (tx_vld),
  .tx_rdy           (tx_rdy),
  .rx_data          (rx_data),
  .rx_vld           (rx_vld),
  .rx_rdy           (rx_rdy)
);

f_fbio_wrap u_macro_wrap_0 (
  // IO Pads
  .io_pad_i     (io_pad_i),
  .io_pad_oen   (io_pad_oen),
  .pad_o        (io_pad_o),

  .test_mode    (test_mode),
  .pi_clkrx     (ioclk_src),
  .tx_clk       (tx_clk),
  .tx_rstn      (txs_rstn),
  .rx_clk       (rx_clk),
  .rx_rstn      (rxs_rstn),
  .ddr_en       (ddr_en),
  .en_16b       (en_16b),
  .com_mode     (com_mode),
  .cts_ignore   (cts_ignore),
  .scan_clk     (scan_clk),
  .spad_en      (1'b1),
  .rx_clki_dly  (rx_clki_dly),
  .rx_clki_inv  (rx_clki_inv),
  .rx_clki_pol  (rx_clki_pol),
  .rx_clko_dly  (rx_clko_dly),
  .rx_clko_inv  (rx_clko_inv),
  .rx_clko_pol  (rx_clko_pol),
  .tx_clki_dly  (tx_clki_dly),
  .tx_clki_inv  (tx_clki_inv),
  .tx_clki_pol  (tx_clki_pol),
  .tx_clko_dly  (tx_clko_dly),
  .tx_clko_inv  (tx_clko_inv),
  .tx_clko_pol  (tx_clko_pol),
  .rx_ck_comp   (rx_ck_comp),
  .rx_ck_cinv   (rx_ck_cinv),
  .tx_ck_comp   (tx_ck_comp),
  .tx_ck_cinv   (tx_ck_cinv),

  .tx_data      (tx_data),
  .tx_vld       (tx_vld),
  .tx_rdy       (tx_rdy),
  .rx_data      (rx_data),
  .rx_vld       (rx_vld),
  .rx_rdy       (rx_rdy)
);

f_bio_stest_timer u_stest_timer_0 (
  .ref_clk      (achip_clk),
  .ref_rstn     (achip_rst),
  .sysclk       (sysclk),
  .sysrstn      (cdc_rstn),
  .stest_en     (stest_en),
  .stest_run    (stest_run),
  .stest_trig   (stest_trig),
  .pulse_1us    (pulse_1us)
);

f_bio_rst_ctrl u_rst_gen_0 (
  .clk_ref      (achip_clk),
  .a_reset      (achip_rst),
  .test_mode    (test_mode),
  .sysclk       (sysclk),
  .sysrstn      (sysrstn),
  .tx_clk       (tx_clk),
  .tx_rstn      (tx_rstn),
  .rx_clk       (rx_clk),
  .rx_rstn      (rx_rstn),
  .a_reset_m    (a_reset_m),
  .sft_rst      (sft_rst),
  .sft_set      (sft_set),
  .sft_ack0     (sft_ack0),
  .sft_ack1     (sft_ack1),
  .sft_ack2     (sft_ack2),
  .sft_ack3     (sft_ack3),
  .cdc_rstn     (cdc_rstn),
  .txs_rstn     (txs_rstn),
  .rxs_rstn     (rxs_rstn)
);

f_bio_arst_gen u_arst_0 (
  .clk          (achip_clk),
  .rsts         (achip_rst),
  .rstd_m       (a_reset_m),
  .test_mode    (test_mode),
  .rstd         (fpga_rstn)
);

endmodule
//==============================================================================
//
//    This confidential and proprietary hardware may be used only as
//  authorized by a licensing agreement from
//                    SunMedia Technology Co., LTD.
//
//  In the event of publication, the following notice is applicable:
//
//            COPYRIGHT 2018, SunMedia Technology Co., LTD.
//                        ALL RIGHTS RESERVED
//
//  The entire notice above must be reproduced on all authorized copies.
//
//==============================================================================
//
//  File        : f_fbio_wrap.v
//  Author      : kun.zhang
//  Date        : 02/Mar/2018
//  Version     : 1.0
//  Abstract    : This is the soft pad wrapper for FPGA connection BIO
//
//  Modification History:
//  Date          By            Version         Change Description
//------------------------------------------------------------------------------
//  02/Mar/2018   kun.zhang      1.0            Original
//
//
//==============================================================================



module f_fbio_wrap (
  input  wire [37:0]  io_pad_i,     // Input from PINMX
  output wire [37:0]  io_pad_oen,      // Output enable to PINMX
  output wire [37:0]  pad_o,        // Output to PINMX
  // Global control signal
  input  wire         test_mode,    // B-chip Test mode select
  output wire         pi_clkrx,     // Clock RX from Soft pad
  input  wire         tx_clk,       // TX domain clock
  input  wire         tx_rstn,      // TX doamin reset
  input  wire         rx_clk,       // RX domain clock
  input  wire         rx_rstn,      // RX domain reset
  input  wire         ddr_en,       // DDR mode enable
  input  wire         en_16b,       // 16Bit IO bus enable
  input  wire         com_mode,     // Compression mode
  input  wire         cts_ignore,   // CTS_IGNORE for clock
  input  wire         scan_clk,     // SCAN clock input
  input  wire         spad_en,      // Soft PAD enable
  input  wire [3:0]   rx_clki_dly,  // RX clock input delay select
  input  wire         rx_clki_inv,  // RX clock input inverter select
  input  wire         rx_clki_pol,  // RX clock input pol select
  input  wire [3:0]   rx_clko_dly,  // RX clock output delay select
  input  wire         rx_clko_inv,  // RX clock output inverter select
  input  wire         rx_clko_pol,  // RX clock output pol select
  input  wire [3:0]   tx_clki_dly,  // TX clock input delay select
  input  wire         tx_clki_inv,  // TX clock input inverter select
  input  wire         tx_clki_pol,  // TX clock input pol select
  input  wire [3:0]   tx_clko_dly,  // TX clock output delay select
  input  wire         tx_clko_inv,  // TX clock output inverter select
  input  wire         tx_clko_pol,  // TX clock output pol select
  input  wire         rx_ck_comp,   // RX clock compress mode enable
  input  wire         rx_ck_cinv,   // RX clock inverter in compress mode
  input  wire         tx_ck_comp,   // TX clock compress mode enable
  input  wire         tx_ck_cinv,   // TX clock inverter in compress mode
  // Connection to core
  input  wire [31:0]  tx_data,   // Transfer data to soft-pad, if SDR mode only bit 15:0 is valid
  input  wire [1:0]   tx_vld,    // Transfer valid
  output wire         tx_rdy,    // Transfer ready from rx domain
  output wire [31:0]  rx_data,   // Receiver data from soft-pad, if SDR mode only bit 15:0 is valid
  output wire [1:0]   rx_vld,    // Reciever valid
  input  wire         rx_rdy     // Receiver ready to tx domain
);

wire        i_rxck;     // RX clock I to PAD
wire [15:0] i_rxd;      // RX data I to PAD
wire        i_rxrdy;    // RX ready I to PAD
wire        i_rxvld;    // RX valid I to PAD
wire        i_txck;     // TX clock I to PAD
wire [15:0] i_txd;      // TX data I to PAD
wire        i_txrdy;    // TX ready I to PAD
wire        i_txvld;    // TX valid I to PAD

wire [17:0] vpad_oen;
wire [17:0] vpad_o;
wire [37:0] io_pad_o;

assign io_pad_o   = 38'h0;

assign io_pad_oen = {{19{1'b1}}, 3'h0, {8{~en_16b}}, 8'h0};
assign vpad_oen = {io_pad_oen[15:8], io_pad_oen[16], io_pad_oen[17], io_pad_oen[7:0]};
assign vpad_o   = {io_pad_o[15:8], io_pad_o[16], io_pad_o[17], io_pad_o[7:0]};

assign pad_o[37]    = i_rxrdy;
assign pad_o[36]    = i_rxvld;
assign pad_o[35:20] = i_rxd;
assign pad_o[19]    = i_rxck;
assign pad_o[18]    = i_txck;
assign pad_o[17]    = i_txrdy;
assign pad_o[16]    = i_txvld;
assign pad_o[15:0]  = i_txd;

f_IOPAD_TOP u_sftpad_0 (
  // output
  .BIO_RXD          (rx_data),
  .BIO_RXVLD        (rx_vld),
  .BIO_TXRDY        (tx_rdy),
  .I_RXCK           (i_rxck),
  .I_RXD            (i_rxd),
  .I_RXRDY          (i_rxrdy),
  .I_RXVLD          (i_rxvld),
  .I_TXCK           (i_txck),
  .I_TXD            (i_txd),
  .I_TXRDY          (i_txrdy),
  .I_TXVLD          (i_txvld),
  .PI_CLKIORX       (pi_clkrx),
  // input
  .BIO_DDR_EN       (ddr_en),
  .BIO_EN16B        (en_16b),
  .BIO_RXRDY        (rx_rdy),
  .BIO_TXD          (tx_data),
  .BIO_TXVLD        (tx_vld),
  .COMPRESSION_MODE (com_mode),
  .CTS_IGNORE       (cts_ignore),
  .C_RXCK           (io_pad_i[19]),
  .C_RXD            (io_pad_i[35:20]),
  .C_RXRDY          (io_pad_i[37]),
  .C_RXVLD          (io_pad_i[36]),
  .C_TXCK           (io_pad_i[18]),
  .C_TXD            (io_pad_i[15:0]),
  .C_TXRDY          (io_pad_i[17]),
  .C_TXVLD          (io_pad_i[16]),
  .FREE_IOCTL_CLKRX (rx_clk),
  .HCLK_PAD_OUT     (io_pad_o[19]),
  .HPAD_OEN         (io_pad_oen[37:20]),
  .HPAD_OUT         (io_pad_o[37:20]),
  .IORX_RST_B       (rx_rstn),
  .IOTX_RST_B       (tx_rstn),
  .MO_IORX_CLKI_DLY (rx_clki_dly),
  .MO_IORX_CLKI_INV (rx_clki_inv),
  .MO_IORX_CLKI_POL (rx_clki_pol),
  .MO_IORX_CLKO_DLY (rx_clko_dly),
  .MO_IORX_CLKO_INV (rx_clko_inv),
  .MO_IORX_CLKO_POL (rx_clko_pol),
  .MO_IOTX_CLKI_DLY (tx_clki_dly),
  .MO_IOTX_CLKI_INV (tx_clki_inv),
  .MO_IOTX_CLKI_POL (tx_clki_pol),
  .MO_IOTX_CLKO_DLY (tx_clko_dly),
  .MO_IOTX_CLKO_INV (tx_clko_inv),
  .MO_IOTX_CLKO_POL (tx_clko_pol),
  .MO_IORX_CK_COMP    (rx_ck_comp),
  .MO_IORX_CK_COMP_CKINV  (rx_ck_cinv),
  .MO_IOTX_CK_COMP    (tx_ck_comp),
  .MO_IOTX_CK_COMP_CKINV  (tx_ck_cinv),
  .PO_CLKIOTX       (tx_clk),
  .RGMII_DATA_SCAN_CLK (scan_clk),
  .SFT_CFG_BIO_SEL  (spad_en),
  .SI_HPAD_EN       (18'h0),
  .SI_VPAD_EN       (18'h0),
  .SO_HPAD_EN       (18'h0),
  .SO_VPAD_EN       (18'h0),
  .TEST_MODE        (test_mode),
  .VCLK_PAD_OUT     (io_pad_o[18]),
  .VPAD_OEN         (vpad_oen[17:0]),
  .VPAD_OUT         (vpad_o[17:0])
);
endmodule

module f_CKMUX_CELL(S0, A, B, Y);
input S0,A,B;
output Y;


        wire        Y             =  S0 ? B : A;
endmodule

module f_CTS_IGNORE_MUX (CKI , IGNORE_EN , CLKO );
input CKI ;
input IGNORE_EN ;
output CLKO ;

	    reg MUX_B;
	    wire IGNORE_QN = !MUX_B;
            always @(IGNORE_EN or IGNORE_QN)
            if (IGNORE_EN)
                MUX_B = IGNORE_QN;
	    wire CLKO = IGNORE_EN ? MUX_B : CKI;
endmodule

module f_CLK_BUF_CELL (
  input  wire A,
  output wire Y
);

assign Y = A;

endmodule

module f_CLK_INV_CELL (
  input  wire A,
  output wire Y
);

assign Y = ~A;

endmodule

module f_CLK_DLY005_CELL (
  input  wire A,
  output wire Y
);

assign Y = A;

endmodule

module f_CLK_MUX_CELL (
  input A,
  input B,
  input S0,
  output Y
);

assign Y = S0 ? B : A;

endmodule

module f_CKXOR_CELL (
  input A1,
  input A2,
  output Z
);
assign Z = A1 ^ A2;
endmodule

module f_aim_data_rdy_sync #(parameter WIDTH=8) (
	output 	wire	ready_s, //ready to receive next data
	input	[WIDTH-1:0]	indata_s,
	input		send_s,
	input		clks, rstb_clks,
	output	wire	[WIDTH-1:0]	data_d,
	output	wire	data_avail_d, //data_d valid
	input		clkd, rstb_clkd);

`ifdef SVA_ON
property Chk_send_1T_pulse;
	@(posedge clks) disable iff(!rstb_clks)
		$rose(send_s) |-> ##1 $fell(send_s);
endproperty

Checker_send_1T_pulse: assert property(Chk_send_1T_pulse) else
	$fatal("send_s should be exactly 1T pulse!");

property Chk_send_when_ready;
	@(posedge clks) disable iff(!rstb_clks)
		$rose(send_s) |-> ready_s;
endproperty

Checker_send_when_ready: assert property(Chk_send_when_ready) else
	$fatal("send_s can be asserted only when read_s is high!");

`endif

	wire	[WIDTH-1:0]	data_s; //internal data bus
	wire	ack_d; 	//acknowledge enable signal
	wire	en_s; 	//control enable signal
	wire	q2_en_d;	//control - sync_output
	wire	q2_ack_s;	//feedback - sync output

	f_aim_rego_sync sync_s(.inp(ack_d), .outp(q2_ack_s),
				.rstb(rstb_clks), .clk(clks));
	f_aim_rego_sync sync_d(.inp(en_s), .outp(q2_en_d),
				.rstb(rstb_clkd), .clk(clkd));
	f_aim_mcps_send #(WIDTH) send0(.data_s(data_s), .en_s(en_s), .ready_s(ready_s),
			.indata_s(indata_s), .send_s(send_s),
			.q2_ack_s(q2_ack_s), .clks(clks),
			.rstb_clks(rstb_clks));
	f_aim_mcpd_recv_simple #(WIDTH) recv0(.data_d(data_d), .ack_d(ack_d),
			.data_s(data_s), .data_avail_d(data_avail_d),
			.q2_en_d(q2_en_d), .clkd(clkd), .rstb_clkd(rstb_clkd));
endmodule


//
// f_aim_dflop
//
// D-type flip-flop
//
module  f_aim_dflop
(
    d,
    q,
    rstb,
    clk
);

input   clk;
input   rstb;
input   d;
output  q;
reg     q;

always @(posedge clk or negedge rstb)
if (!rstb)
    q <= #0.5 0;
else
    q <= #0.5 d;

endmodule

//
// f_aim_dflops
//
// D-type flip-flop(s)
//
module  f_aim_dflops
(
    en,
    d,
    q,
    rstb,
    clk
);

parameter   WIDTH=8;

input                   clk;
input                   rstb;
input                   en;
input   [WIDTH-1:0]     d;
output  [WIDTH-1:0]     q;
reg     [WIDTH-1:0]     q;

always @(posedge clk or negedge rstb)
if (!rstb)
    q <= #0.5 0;
else if (en)
    q <= #0.5 d;

endmodule

module f_aim_mcpd_recv_simple #(parameter WIDTH=8) (
	output 	wire [WIDTH-1:0] data_d,
	output	wire		ack_d,	//acknowledge signal
	input	[WIDTH-1:0]		data_s,	//unsynchronized data_s
	output	wire		data_avail_d,	//one pulse for data available
	input			q2_en_d, //synchronized enable input
	input			clkd, rstb_clkd);

	wire preload_d;	//load pulse from pulse generator

	//Pulse generator
	f_aim_plsgen plsgen0(.pulse(preload_d), .q(ack_d), .d(q2_en_d),
				.clk(clkd), .rstb(rstb_clkd));

	f_aim_dflop dff_avail(.d(preload_d), .q(data_avail_d),
				.clk(clkd), .rstb(rstb_clkd));
	f_aim_dflops #(WIDTH) dffs_data(.en(preload_d), .d(data_s), .q(data_d),
				.clk(clkd), .rstb(rstb_clkd));

endmodule
module f_aim_mcps_send #(parameter WIDTH=8) (
	output 	wire [WIDTH-1:0] data_s,
	output 	wire		en_s, ready_s,
	input	[WIDTH-1:0]	indata_s,
	input			send_s,
	input			q2_ack_s,
	input			clks, rstb_clks);

	wire ack_s;	//acknowledge pulse from pulse generator

	//Pulse generator
	f_aim_plsgen plsgen0(.pulse(ack_s), .q(), .d(q2_ack_s),
				.clk(clks), .rstb(rstb_clks));
	//data ready/acknowledge FSM
	f_aim_sends_fsm send_fsm0(.ready_s(ready_s), .send_s(send_s),
				.ack_s(ack_s), .clks(clks),
				.rstb_clks(rstb_clks));
	//send next data word
	wire nexts_data = ready_s & send_s;

	//toggle-flop controlled by nexts_data
	f_aim_dflops #(1) dffs_en(.en(nexts_data), .d(~en_s), .q(en_s),
				.clk(clks), .rstb(rstb_clks));
	f_aim_dflops #(WIDTH) dffs_data(.en(nexts_data), .d(indata_s),
				.q(data_s), .clk(clks), .rstb(rstb_clks));

endmodule
//Pulse Generator
module f_aim_plsgen (
	output wire pulse, q,
	input d,
	input clk, rstb);

	f_aim_dflop dff0(.d(d), .q(q), .rstb(rstb), .clk(clk));

	assign pulse = q^d;
endmodule
module f_aim_pulse_sync
(
   inp,
   outp,

   clks,
   clkd,
   rstb_clks,
   rstb_clkd
);

input   inp;
output  outp;
input   clks;
input   clkd;
input   rstb_clkd;
input   rstb_clks;

`ifdef SVA_ON
property Chk_inp_1T_pulse;
	@(posedge clks) disable iff(!rstb_clks)
		$rose(inp) |-> ##1 $fell(inp);
endproperty

Checker_inp_1T_pulse: assert property(Chk_inp_1T_pulse) else
	$fatal("inp should be exactly 1T pulse!");

`endif

wire        cdc;                // cdc - clock-domain-crossing
wire        A, A_d;

f_aim_tflop           tflop0( .t(inp),   .q(cdc),  .clk(clks), .rstb(rstb_clks));  // toggling flip-flop
f_aim_rego_sync    sync0( .inp(cdc), .outp(A),  .clk(clkd), .rstb(rstb_clkd));  // cross-clock-domain here
f_aim_dflop           dflop0( .d(A),    .q(A_d),  .clk(clkd), .rstb(rstb_clkd));

assign      outp = A^A_d;

endmodule
//
//  f_aim_rego_sync
//  in - - out
//
module  f_aim_rego_sync
(
    inp,         // asynchornous input
    outp,        // sampled output
    rstb,
    clk
);

input   inp;
output  outp;
input   rstb;
input   clk;

wire    cdc     = inp;       // cdc - clock-domain crossing
wire    cdc_d1;             // #1 sample
wire    cdc_d2;             // #2 sample
wire    outp     = cdc_d2;

f_aim_dflop   dflop0(.d(cdc),     .q(cdc_d1),    .clk(clk), .rstb(rstb));
f_aim_dflop   dflop1(.d(cdc_d1),  .q(cdc_d2),    .clk(clk), .rstb(rstb));

endmodule


module f_aim_reset_sync (
        RST_B,
        TEST_MODE,
        RESAMPLE_CLK,
        SRC_RST_B,

        RESAMPLE_RST_B

);

input   RST_B;
input   TEST_MODE;
input   RESAMPLE_CLK;
input   SRC_RST_B;

output  RESAMPLE_RST_B;

wire	RESAMPLE_RST_B_SRC;
wire	RESAMPLE_RST_B_SRC_RS;

wire RESAMPLE_RST_B = TEST_MODE ? RST_B : RESAMPLE_RST_B_SRC_RS;

f_aim_dflop ff0(.d(1'b1), .q(RESAMPLE_RST_B_SRC), 
	.rstb(SRC_RST_B), .clk(RESAMPLE_CLK));
f_aim_dflop ff1(.d(RESAMPLE_RST_B_SRC), .q(RESAMPLE_RST_B_SRC_RS), 
	.rstb(SRC_RST_B), .clk(RESAMPLE_CLK));

endmodule

module f_aim_sends_fsm (
	output 	wire	ready_s, 	//ready to send next data
	input 		send_s,		//send adata
	input		ack_s,		//acknowledge receipt of data_s
	input		clks, rstb_clks);

	reg state, next;

	always @(posedge clks or negedge rstb_clks)
		if(!rstb_clks)	state <= #0.5 1'b1;
		else		state <= #0.5 next;

	always @* begin
		case (state)
			1 : //ready state
				if(send_s)	next = 1'b0;
				else		next = 1'b1;
			0 : //busy state
				if(ack_s)	next = 1'b1;
				else		next = 1'b0;
		endcase
	end

	assign ready_s = state;
endmodule
//
// f_aim_tflop
//
// T-type flip-flop
//
module  f_aim_tflop
(
    t,
    q,
    rstb,
    clk
);

input   clk;
input   rstb;
input   t;
output  q;
reg     q;

always @(posedge clk or negedge rstb)
if (!rstb)
    q <= #0.5 0;
else if (t)
    q <= #0.5 ~q;

endmodule

